# SciMLBase

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/SciMLBase/stable)

[![codecov](https://codecov.io/gh/SciML/SciMLBase.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/SciMLBase.jl)
[![Build Status](https://github.com/SciML/SciMLBase.jl/workflows/CI/badge.svg)](https://github.com/SciML/SciMLBase.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

SciMLBase.jl is the core interface definition of the SciML ecosystem. It is a
low dependency library made to be depended on by the downstream libraries to
supply the common interface and allow for interexchange of mathematical problems.

## v2.0 Breaking Changes

The breaking changes in v2.0 are:

  - `IntegralProblem` has moved to an interface with `IntegralFunction` and `BatchedIntegralFunction` which requires specifying `prototype`s for the values to be modified
    instead of `nout` and `batch`. https://github.com/SciML/SciMLBase.jl/pull/497
  - `ODEProblem` was made temporarily into a `mutable struct` to allow for EnzymeRules support. Using the mutation throws a warning that this is only experimental and should not be relied on.
    https://github.com/SciML/SciMLBase.jl/pull/501
  - `BVProblem` now has a new interface for `TwoPointBVProblem` which splits the bc terms for the two sides, forcing a true two-point BVProblem to allow for further specializations and to allow
    for wrapping Fortran solvers in the interface. https://github.com/SciML/SciMLBase.jl/pull/477
  - `SDEProblem` constructor was changed to remove an anti-pattern which required passing the diffusion function `g` twice, i.e. `SDEProblem(SDEFunction(f,g),g, ...)`.
    Now this is simply `SDEProblem(SDEFunction(f,g),...)`. https://github.com/SciML/SciMLBase.jl/pull/489

"""
IMPORTANT:

These types are used by the following packages, please notify with an issue if you need to
modify these structures:
- `SciML/MethodOfLines.jl`
"""

"""
$(TYPEDEF)

Solution to a PDE, solved from an ODEProblem generated by a discretizer.

## Fields

  - `u`: the solution to the PDE, as a dictionary of symbols to Arrays of values. The
    Arrays are of the same shape as the domain of the PDE. Time is always the first axis.
  - `original_sol`: The original ODESolution that was used to generate this solution.
  - `t`: the time points corresponding to the saved values of the ODE solution.
  - `ivdomain`: The full list of domains for the independent variables. May be a grid for a
    discrete solution, or a vector/tuple of tuples for a continuous solution.
  - `ivs`: The list of independent variables for the solution.
  - `dvs`: The list of dependent variables for the solution.
  - `disc_data`: Metadata about the discretization process and type.
  - `prob`: The ODEProblem that was used to generate this solution.
  - `alg`: The algorithm used to solve the ODEProblem.
  - `interp`: Interpolations for the solution.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully, whether it terminated early due to a user-defined callback, or whether it
    exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
  - `stats`: statistics of the solver, such as the number of function evaluations required.
"""
struct PDETimeSeriesSolution{
        T, N, uType, Disc, Sol, DType, tType, domType, ivType, dvType,
        P, A,
        IType, S,
    } <: AbstractPDETimeSeriesSolution{T, N, uType, Disc}
    u::uType
    original_sol::Sol
    errors::DType
    t::tType
    ivdomain::domType
    ivs::ivType
    dvs::dvType
    disc_data::Disc
    prob::P
    alg::A
    interp::IType
    dense::Bool
    tslocation::Int
    retcode::ReturnCode.T
    stats::S
end

"""
Dispatch for the following function should be implemented in each discretizer package, for their relevant metadata type `D`.
"""
function (sol::PDETimeSeriesSolution{T, N, S, D})(args...; kwargs...) where {T, N, S, D}
    error(ArgumentError("Call for PDETimeSeriesSolution not implemented for solution metadata type $D, please post an issue on the relevant discretizer package's github page."))
end

"""
$(TYPEDEF)

Solution to a PDE, solved from an NonlinearProblem generated by a discretizer.

## Fields

  - `u`: the solution to the PDE, as a dictionary of symbols to Arrays of values. The
    Arrays are of the same shape as the domain of the PDE. Time is always the first axis.
  - `original_sol`: The original NonlinearSolution that was used to generate this solution.
  - `ivdomain`: The full list of domains for the independent variables. May be a grid for a
    discrete solution, or a vector/tuple of tuples for a continuous solution.
  - `ivs`: The list of independent variables for the solution.
  - `dvs`: The list of dependent variables for the solution.
  - `disc_data`: Metadata about the discretization process and type.
  - `prob`: The NonlinearProblem that was used to generate this solution.
  - `alg`: The algorithm used to solve the NonlinearProblem.
  - `interp`: Interpolations for the solution.
  - `retcode`: The return code from the solver. Used to determine whether the solver solved
    successfully (`sol.retcode === ReturnCode.Success`), whether it terminated due to a user-defined
    callback (`sol.retcode === ReturnCode.Terminated`), or whether it exited due to an error. For more
    details, see the return code section of the ODEProblem.jl documentation.
"""
struct PDENoTimeSolution{
        T, N, uType, Disc, Sol, domType, ivType, dvType, P, A,
        IType, S,
    } <: AbstractPDENoTimeSolution{T, N, uType, Disc}
    u::uType
    original_sol::Sol
    ivdomain::domType
    ivs::ivType
    dvs::dvType
    disc_data::Disc
    prob::P
    alg::A
    interp::IType
    retcode::ReturnCode.T
    stats::S
end

const PDESolution{
    T, N, S, D,
} = Union{
    PDETimeSeriesSolution{T, N, S, D},
    PDENoTimeSolution{T, N, S, D},
}

"""
Dispatch for the following function should be implemented in each discretizer package, for their relevant metadata type `D`.
"""
function (sol::PDENoTimeSolution{T, N, S, D})(args...; kwargs...) where {T, N, S, D}
    error(ArgumentError("Call for PDENoTimeSolution not implemented for solution metadata type $D, please post an issue on the relevant discretizer package's github page."))
end

"""
Intercept PDE wrapping. Please implement a method for the PDESolution types in your discretizer.
"""
function SciMLBase.wrap_sol(
        sol,
        metadata::AbstractDiscretizationMetadata{hasTime}
    ) where {
        hasTime,
    }
    if hasTime isa Val{true}
        return PDETimeSeriesSolution(sol, metadata)
    else
        return PDENoTimeSolution(sol, metadata)
    end
end

function Base.show(io::IO, m::MIME"text/plain", A::PDETimeSeriesSolution)
    println(io, string("retcode: ", A.retcode))
    println(io, string("Interpolation: "), typeof(A.interp))
    print(io, "t: ")
    show(io, m, A.t)
    print(io, "ivs: ")
    show(io, m, A.ivs)
    print(io, "domain:")
    show(io, m, A.ivdomain)
    println(io)
    print(io, "u: ")
    return show(io, m, A.u)
end

function Base.show(io::IO, m::MIME"text/plain", A::PDENoTimeSolution)
    println(io, string("retcode: ", A.retcode))
    println(io, string("Interpolation: "), typeof(A.interp))
    print(io, "ivs: ")
    show(io, m, A.ivs)
    print(io, "domain:")
    show(io, m, A.ivdomain)
    println(io)
    print(io, "u: ")
    return show(io, m, A.u)
end

using OrdinaryDiffEq, Test

A = [
    1 2
    3 4
]
prob = ODEProblem((u, p, t) -> A * u, ones(2, 2), (0.0, 1.0))
function prob_func(prob, i, repeat)
    return remake(prob, u0 = i * prob.u0)
end
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim = solve(ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 10, saveat = 0.01)
@test sim isa EnsembleSolution
@test size(sim[1, :, :, :]) == (2, 101, 10)
@test size(sim[:, 1, :, :]) == (2, 101, 10)
@test size(sim[:, :, 1, :]) == (2, 2, 10)
@test size(sim[:, :, :, 1]) == (2, 2, 101)
@test Array(sim)[1, :, :, :] == Array(sim[1, :, :, :])
@test Array(sim)[:, 1, :, :] == Array(sim[:, 1, :, :])
@test Array(sim)[:, :, 1, :] == Array(sim[:, :, 1, :])
@test Array(sim)[:, :, :, 1] == Array(sim[:, :, :, 1])

using Test, SciMLBase, SciMLBase.EnsembleAnalysis

EA = SciMLBase.EnsembleAnalysis

# tests for https://github.com/SciML/DifferentialEquations.jl/issues/731
# make sure integer inputs work
@test all(EA.componentwise_mean([[1, 1], [2, 2], [3, 3]]) .≈ [2.0, 2.0])
m, v = EA.componentwise_meanvar([[1, 1], [2, 2], [3, 3]])
@test all(m .≈ 2.0)
@test all(v .≈ 1.0)
mx, my, C = EA.componentwise_meancov([[1, 1], [2, 2], [3, 3]], [[3, 3], [2, 2], [1, 1]])
@test all(mx .≈ 2.0)
@test all(my .≈ 2.0)
@test all(C .≈ -1.0)
mx, my,
    C = EA.componentwise_weighted_meancov(
    [[1, 1], [2, 2], [3, 3]],
    [[3, 3], [2, 2], [1, 1]],
    [[1, 1], [2, 2], [1, 1]]
)
@test all(mx .≈ 2.0)
@test all(my .≈ 2.0)
@test all(C .≈ -0.8)

using ModelingToolkit, JumpProcesses, LinearAlgebra, NonlinearSolve, Optimization,
    OptimizationOptimJL, OrdinaryDiffEq, RecursiveArrayTools, SciMLBase,
    SteadyStateDiffEq, StochasticDiffEq, DelayDiffEq, SymbolicIndexingInterface,
    DiffEqCallbacks, StochasticDelayDiffEq, Test, Plots
import Symbolics
import SymbolicUtils as SU
using ModelingToolkit: t_nounits as t, D_nounits as D

# Sets rnd number.
using StableRNGs
rng = StableRNG(12345)
seed = rand(rng, 1:100)

### Basic Tests ###

# Prepares a model systems.
begin
    # Prepare system components.
    @parameters kp kd k1 k2
    @variables begin
        X(t), [bounds = (-10.0, 10.0)]
        Y(t), [bounds = (-10.0, 10.0)]
        XY(t)
    end
    alg_eqs = [
        0 ~ kp - kd * X - k1 * X + k2 * Y
        0 ~ 1 + k1 * X - k2 * Y - Y
    ]
    diff_eqs = [
        D(X) ~ kp - kd * X - k1 * X + k2 * Y
        D(Y) ~ 1 + k1 * X - k2 * Y - Y
    ]
    noise_eqs = [
        sqrt(kp + X),
        sqrt(k1 + Y),
    ]
    jumps = [
        ConstantRateJump(kp, [X ~ Pre(X) + 1]),
        ConstantRateJump(kd * X, [X ~ Pre(X) - 1]),
        ConstantRateJump(k1 * X, [X ~ Pre(X) - 1, Y ~ Pre(Y) + 1]),
        ConstantRateJump(k2 * Y, [X ~ Pre(X) + 1, Y ~ Pre(Y) - 1]),
        ConstantRateJump(1, [Y ~ Pre(Y) + 1]),
        ConstantRateJump(Y, [Y ~ Pre(Y) - 1]),
    ]
    obs = [XY ~ X + Y]
    loss = kd * (k1 - X)^2 + k2 * (kp * Y - X^2)^2

    # Create systems (without structural_simplify, since that might modify systems to affect intended tests).
    osys = complete(System(diff_eqs, t; observed = obs, name = :osys))
    ssys = complete(
        System(
            diff_eqs, t, [X, Y], [kp, kd, k1, k2]; noise_eqs, observed = obs, name = :ssys
        )
    )
    jsys = complete(
        JumpSystem(
            jumps, t, [X, Y], [kp, kd, k1, k2]; observed = obs, name = :jsys
        )
    )
    nsys = complete(System(alg_eqs; observed = obs, name = :nsys))
    optsys = complete(
        OptimizationSystem(
            loss, [X, Y], [kp, kd, k1, k2]; observed = obs, name = :optsys
        )
    )
end

# Prepares problems, integrators, and solutions.
begin
    # Sets problem inputs (to be used for all problem creations).
    u0_vals = [X => 4.0, Y => 5.0]
    tspan = (0.0, 10.0)
    p_vals = [kp => 1.0, kd => 0.1, k1 => 0.25, k2 => 0.5]

    # Creates problems.
    oprob = ODEProblem(osys, [u0_vals; p_vals], tspan)
    sprob = SDEProblem(ssys, [u0_vals; p_vals], tspan)
    jprob = JumpProblem(jsys, [u0_vals; p_vals], tspan; aggregator = Direct(), rng)
    nprob = NonlinearProblem(nsys, [u0_vals; p_vals])
    hcprob = NonlinearProblem(HomotopyNonlinearFunction(nprob.f), nprob.u0, nprob.p)
    ssprob = SteadyStateProblem(osys, [u0_vals; p_vals])
    optprob = OptimizationProblem(optsys, [u0_vals; p_vals], grad = true, hess = true)
    problems = [oprob, sprob, jprob, nprob, hcprob, ssprob, optprob]
    systems = [osys, ssys, jsys, nsys, nsys, osys, optsys]

    # Creates an `EnsembleProblem` for each problem.
    eoprob = EnsembleProblem(oprob)
    esprob = EnsembleProblem(sprob)
    ejprob = EnsembleProblem(jprob)
    enprob = EnsembleProblem(nprob)
    essprob = EnsembleProblem(ssprob)
    eoptprob = EnsembleProblem(optprob)
    eproblems = [eoprob, esprob, ejprob, enprob, essprob, optprob]
    esystems = [osys, ssys, jsys, nsys, osys, optsys]

    # Creates integrators.
    oint = init(oprob, Tsit5(); save_everystep = false)
    sint = init(sprob, ImplicitEM(); save_everystep = false)
    jint = init(jprob, SSAStepper())
    nint = init(nprob, NewtonRaphson(); save_everystep = false)
    ssint = init(ssprob, DynamicSS(Tsit5()); save_everystep = false)
    integrators = [oint, sint, jint, nint]
    integsystems = [osys, ssys, jsys, nsys]

    # Creates solutions.
    osol = solve(oprob, Tsit5())
    ssol = solve(sprob, ImplicitEM(); seed)
    jsol = solve(jprob, SSAStepper(); seed)
    nsol = solve(nprob, NewtonRaphson())
    sssol = solve(ssprob, DynamicSS(Tsit5()))
    optsol = solve(optprob, GradientDescent())
    sols = [osol, ssol, jsol, nsol, sssol, optsol]
end

non_timeseries_objects = [problems; eproblems; integrators; [nsol]; [sssol]; [optsol]]
non_timeseries_systems = [systems; esystems; integsystems; nsys; osys; optsys]
timeseries_objects = [osol, ssol, jsol]
timeseries_systems = [osys, ssys, jsys]

@testset "Non-timeseries indexing $(SciMLBase.parameterless_type(valp))" for (valp, indp) in
    zip(
        deepcopy(non_timeseries_objects), non_timeseries_systems
    )
    u = state_values(valp)
    uidxs = variable_index.((indp,), [X, Y])
    @testset "State indexing" begin
        for (sym, val, newval) in [
                (X, u[uidxs[1]], 4.0)
                (indp.X, u[uidxs[1]], 4.0)
                (:X, u[uidxs[1]], 4.0)
                (uidxs[1], u[uidxs[1]], 4.0)
                ([X, Y], u[uidxs], 4ones(2))
                ([indp.X, indp.Y], u[uidxs], 4ones(2))
                ([:X, :Y], u[uidxs], 4ones(2))
                (uidxs, u[uidxs], 4ones(2))
                ((X, Y), Tuple(u[uidxs]), (4.0, 4.0))
                ((indp.X, indp.Y), Tuple(u[uidxs]), (4.0, 4.0))
                ((:X, :Y), Tuple(u[uidxs]), (4.0, 4.0))
                (Tuple(uidxs), Tuple(u[uidxs]), (4.0, 4.0))
            ]
            get = getsym(indp, sym)
            set! = setsym(indp, sym)
            @inferred get(valp)
            @test get(valp) == val
            @test valp[sym] == val

            if !(valp isa SciMLBase.AbstractNoTimeSolution)
                @inferred set!(valp, newval)
                @test get(valp) == newval
                set!(valp, val)
                @test get(valp) == val

                if !(valp isa JumpProblem) || !(sym isa Union{Tuple, AbstractArray})
                    valp[sym] = newval
                    @test valp[sym] == newval
                    valp[sym] = val
                    @test valp[sym] == val
                end
            end
        end
    end

    @testset "Observed" begin
        # Observed functions don't infer
        for (sym, val) in [
                (XY, sum(u))
                (indp.XY, sum(u))
                (:XY, sum(u))
                ([X, indp.Y, :XY, X * Y], [u[uidxs]..., sum(u), prod(u)])
                ((X, indp.Y, :XY, X * Y), (u[uidxs]..., sum(u), prod(u)))
                (X * Y, prod(u))
            ]
            get = getsym(indp, sym)
            @test get(valp) == val
        end
    end

    getter = getsym(indp, [])
    @test getter(valp) == []

    p = getindex.((Dict(p_vals),), [kp, kd, k1, k2])
    newp = p .* 10
    pidxs = parameter_index.((indp,), [kp, kd, k1, k2])
    @testset "Parameter indexing" begin
        for (sym, oldval, newval) in [
                (kp, p[1], newp[1])
                (indp.kp, p[1], newp[1])
                (:kp, p[1], newp[1])
                (pidxs[1], p[1], newp[1])
                ([kp, kd], p[1:2], newp[1:2])
                ([indp.kp, indp.kd], p[1:2], newp[1:2])
                ([:kp, :kd], p[1:2], newp[1:2])
                (pidxs[1:2], p[1:2], newp[1:2])
                ((kp, kd), Tuple(p[1:2]), Tuple(newp[1:2]))
                ((indp.kp, indp.kd), Tuple(p[1:2]), Tuple(newp[1:2]))
                ((:kp, :kd), Tuple(p[1:2]), Tuple(newp[1:2]))
                (Tuple(pidxs[1:2]), Tuple(p[1:2]), Tuple(newp[1:2]))
            ]
            get = getp(indp, sym)
            set! = setp(indp, sym)

            @inferred get(valp)
            @test get(valp) == valp.ps[sym]
            @test get(valp) == oldval

            if !(valp isa SciMLBase.AbstractNoTimeSolution)
                @inferred set!(valp, newval)
                @test get(valp) == newval
                set!(valp, oldval)
                @test get(valp) == oldval

                valp.ps[sym] = newval
                @test get(valp) == newval
                valp.ps[sym] = oldval
                @test get(valp) == oldval
            end
        end
        getter = getp(indp, [])
        @test getter(valp) == []
    end
end

@testset "Timeseries indexing $(SciMLBase.parameterless_type(valp))" for (valp, indp) in
    zip(
        timeseries_objects, timeseries_systems
    )
    u = state_values(valp)
    uidxs = variable_index.((indp,), [X, Y])
    xvals = getindex.(valp.u, uidxs[1])
    yvals = getindex.(valp.u, uidxs[2])
    xyvals = xvals .+ yvals
    tvals = valp.t
    @testset "State indexing and observed" begin
        for (sym, val, check_inference, check_getindex) in [
                (X, xvals, true, true)
                (indp.X, xvals, true, true)
                (:X, xvals, true, true)
                (uidxs[1], xvals, true, false)
                (
                    [X, Y], vcat.(xvals, yvals),
                    true, true,
                )
                (
                    [indp.X, indp.Y],
                    vcat.(xvals, yvals),
                    true, true,
                )
                (
                    [:X, :Y],
                    vcat.(xvals, yvals),
                    true, true,
                )
                (
                    uidxs, vcat.(xvals, yvals),
                    true, false,
                )
                (
                    (Y, X),
                    tuple.(yvals, xvals),
                    true, true,
                )
                (
                    (indp.Y, indp.X),
                    tuple.(yvals, xvals),
                    true, true,
                )
                (
                    (:Y, :X),
                    tuple.(yvals, xvals),
                    true, true,
                )
                (
                    Tuple(reverse(uidxs)),
                    tuple.(yvals, xvals),
                    true, false,
                )
                (t, tvals, true, true)
                (:t, tvals, true, true)
                (
                    [X, t], vcat.(xvals, tvals),
                    false, true,
                )
                (
                    (Y, t),
                    tuple.(yvals, tvals),
                    true, true,
                )
                (
                    [],
                    [
                        []
                            for _ in 1:length(tvals)
                    ],
                    false,
                    false,
                )
                (XY, xyvals, true, true)
                (indp.XY, xyvals, true, true)
                (:XY, xyvals, true, true)
                (
                    [X, indp.Y, :XY, X * Y],
                    vcat.(
                        xvals, yvals, xyvals,
                        xvals .* yvals
                    ),
                    false,
                    true,
                )
                (
                    (X, indp.Y, :XY, X * Y),
                    tuple.(
                        xvals, yvals, xyvals,
                        xvals .* yvals
                    ),
                    false,
                    true,
                )
                (
                    X * Y, xvals .* yvals,
                    false, true,
                )
            ]
            get = getsym(indp, sym)
            if check_inference
                @inferred get(valp)
            end
            @test get(valp) == val
            if check_getindex
                @test valp[sym] == val
            end
            # TODO: Test more subindexes when they're supported
            for i in [rand(eachindex(val)), CartesianIndex(1)]
                if check_inference
                    @inferred get(valp, i)
                end
                @test get(valp, i) == val[i]
                if check_getindex
                    @test valp[sym, i] == val[i]
                end
            end
        end
    end

    p = getindex.((Dict(p_vals),), [kp, kd, k1, k2])
    pidxs = parameter_index.((indp,), [kp, kd, k1, k2])

    @testset "Parameter indexing" begin
        for (sym, oldval) in [
                (kp, p[1])
                (indp.kp, p[1])
                (:kp, p[1])
                (pidxs[1], p[1])
                ([kp, kd], p[1:2])
                ([indp.kp, indp.kd], p[1:2])
                ([:kp, :kd], p[1:2])
                (pidxs[1:2], p[1:2])
                ((kp, kd), Tuple(p[1:2]))
                ((indp.kp, indp.kd), Tuple(p[1:2]))
                ((:kp, :kd), Tuple(p[1:2]))
                (Tuple(pidxs[1:2]), Tuple(p[1:2]))
            ]
            get = getp(indp, sym)

            @inferred get(valp)
            @test get(valp) == valp.ps[sym]
            @test get(valp) == oldval
        end
        getter = getp(indp, [])
        @test getter(valp) == []
    end

    @testset "Interpolation" begin
        sol = valp
        interpolated_sol = sol(0.0:1.0:10.0)
        @test interpolated_sol[XY] isa Vector
        @test interpolated_sol[XY, :] isa Vector
        @test interpolated_sol[XY, 2] isa Float64
        @test length(interpolated_sol[XY, 1:5]) == 5
        @test interpolated_sol[XY] ≈ interpolated_sol[X] .+ interpolated_sol[Y]
        @test collect(interpolated_sol[t]) isa Vector
        @test collect(interpolated_sol[t, :]) isa Vector
        @test interpolated_sol[t, 2] isa Float64
        @test length(interpolated_sol[t, 1:5]) == 5

        sol3 = sol(0.0:1.0:10.0, idxs = [X, Y])
        @test sol3.u isa Vector
        @test first(sol3.u) isa Vector
        @test length(sol3.u) == 11
        @test length(sol3.t) == 11
        @test collect(sol3[t]) ≈ sol3.t
        @test collect(sol3[t, 1:5]) ≈ sol3.t[1:5]
        @test sol(0.0:1.0:10.0, idxs = [Y, 1]) isa RecursiveArrayTools.DiffEqArray

        sol4 = sol(0.1, idxs = [X, Y])
        @test sol4 isa Vector
        @test length(sol4) == 2
        @test first(sol4) isa Real
        @test sol(0.1, idxs = [Y, 1]) isa Vector{<:Real}

        sol5 = sol(0.0:1.0:10.0, idxs = X)
        @test sol5.u isa Vector
        @test first(sol5.u) isa Real
        @test length(sol5.u) == 11
        @test length(sol5.t) == 11
        @test collect(sol5[t]) ≈ sol3.t
        @test collect(sol5[t, 1:5]) ≈ sol3.t[1:5]
        @test_throws Any sol(0.0:1.0:10.0, idxs = 1.2)

        sol6 = sol(0.1, idxs = X)
        @test sol6 isa Real
        @test_throws Any sol(0.1, idxs = 1.2)
    end
end

@testset "ODE with array symbolics" begin
    sts = @variables x(t)[1:3] = [1, 2, 3.0] y(t) = 1.0
    ps = @parameters p[1:3] = [1, 2, 3]
    eqs = [
        collect(D.(x) .~ x)
        D(y) ~ norm(x) * y - x[1]
    ]
    @named sys = System(eqs, t, [sts...;], ps)
    sys = complete(sys)
    prob = ODEProblem(sys, [], (0, 1.0))
    sol = solve(prob, Tsit5())
    # interpolation of array variables
    @test sol(1.0, idxs = x) == [sol(1.0, idxs = x[i]) for i in 1:3]

    x_idx = variable_index.((sys,), [x[1], x[2], x[3]])
    y_idx = variable_index(sys, y)
    x_val = getindex.(sol.u, (x_idx,))
    y_val = getindex.(sol.u, y_idx)
    obs_val = getindex.(x_val, 1) .+ y_val

    @testset "Solution indexing ($sym)" for (sym, val, check_inference) in [
            # don't check inference for weird cases of nested arrays/tuples
            (x, x_val, true),
            (sys.x, x_val, true),
            (:x, x_val, true),
            (x_idx, x_val, true),
            (x[1] + sys.y, obs_val, true),
            ([x[1], x[2]], getindex.(x_val, ([1, 2],)), true),
            ([sys.x[1], sys.x[2]], getindex.(x_val, ([1, 2],)), true),
            # Type-annotation is required, otherwise this is a `Vector{Num}` and treated
            # like a symbolic expression
            (Any[x[1], x_idx[2]], getindex.(x_val, ([1, 2],)), false),
            ([x, x[1] + y], [[i, j] for (i, j) in zip(x_val, obs_val)], false),
            ([sys.x, x[1] + y], [[i, j] for (i, j) in zip(x_val, obs_val)], false),
            ([:x, x[1] + y], [[i, j] for (i, j) in zip(x_val, obs_val)], false),
            ([x, y], [[i, j] for (i, j) in zip(x_val, y_val)], false),
            ([sys.x, sys.y], [[i, j] for (i, j) in zip(x_val, y_val)], false),
            ([:x, :y], [[i, j] for (i, j) in zip(x_val, y_val)], false),
            ([x_idx, y_idx], [[i, j] for (i, j) in zip(x_val, y_val)], false),
            ([x, y_idx], [[i, j] for (i, j) in zip(x_val, y_val)], false),
            ([x, x], [[i, i] for i in x_val], true),
            ([sys.x, sys.x], [[i, i] for i in x_val], true),
            ([:x, :x], [[i, i] for i in x_val], true),
            ([x, x_idx], [[i, i] for i in x_val], false),
            ((x, y), [(i, j) for (i, j) in zip(x_val, y_val)], true),
            ((sys.x, sys.y), [(i, j) for (i, j) in zip(x_val, y_val)], true),
            ((:x, :y), [(i, j) for (i, j) in zip(x_val, y_val)], true),
            ((x, y_idx), [(i, j) for (i, j) in zip(x_val, y_val)], true),
            ((x, x), [(i, i) for i in x_val], true),
            ((sys.x, sys.x), [(i, i) for i in x_val], true),
            ((:x, :x), [(i, i) for i in x_val], true),
            ((x, x_idx), [(i, i) for i in x_val], true),
            ((x, x[1] + y), [(i, j) for (i, j) in zip(x_val, obs_val)], true),
            ((sys.x, x[1] + y), [(i, j) for (i, j) in zip(x_val, obs_val)], true),
            ((:x, x[1] + y), [(i, j) for (i, j) in zip(x_val, obs_val)], true),
            (
                (x, (x[1] + y, y)),
                [(i, (k, j)) for (i, j, k) in zip(x_val, y_val, obs_val)], false,
            ),
            (
                [x, [x[1] + y, y]],
                [[i, [k, j]] for (i, j, k) in zip(x_val, y_val, obs_val)], false,
            ),
            (
                (x, [x[1] + y, y], (x[1] + y, y_idx)),
                [(i, [k, j], (k, j)) for (i, j, k) in zip(x_val, y_val, obs_val)], false,
            ),
            (
                [x, [x[1] + y, y], (x[1] + y, y_idx)],
                [[i, [k, j], (k, j)] for (i, j, k) in zip(x_val, y_val, obs_val)], false,
            ),
        ]
        if check_inference
            @inferred getsym(prob, sym)(sol)
        end
        @test getsym(prob, sym)(sol) == val
    end

    x_newval = [3.0, 6.0, 9.0]
    y_newval = 4.0
    x_probval = prob[x]
    y_probval = prob[y]

    @testset "Problem indexing ($sym)" for (sym, oldval, newval, check_inference) in [
            (x, x_probval, x_newval, true),
            (sys.x, x_probval, x_newval, true),
            (:x, x_probval, x_newval, true),
            (x_idx, x_probval, x_newval, true),
            ((x, y), (x_probval, y_probval), (x_newval, y_newval), true),
            ((sys.x, sys.y), (x_probval, y_probval), (x_newval, y_newval), true),
            ((:x, :y), (x_probval, y_probval), (x_newval, y_newval), true),
            ((x_idx, y_idx), (x_probval, y_probval), (x_newval, y_newval), true),
            ([x, y], [x_probval, y_probval], [x_newval, y_newval], false),
            ([sys.x, sys.y], [x_probval, y_probval], [x_newval, y_newval], false),
            ([:x, :y], [x_probval, y_probval], [x_newval, y_newval], false),
            ([x_idx, y_idx], [x_probval, y_probval], [x_newval, y_newval], false),
            ((x, y_idx), (x_probval, y_probval), (x_newval, y_newval), true),
            (Any[x, y_idx], [x_probval, y_probval], [x_newval, y_newval], false),
            ((x_idx, y), (x_probval, y_probval), (x_newval, y_newval), true),
            (Any[x_idx, y], [x_probval, y_probval], [x_newval, y_newval], false),
            (
                Any[x[1:2], Any[y_idx, x[3]]], [x_probval[1:2], [y_probval, x_probval[3]]],
                [x_newval[1:2], [y_newval, x_newval[3]]], false,
            ),
            (
                Any[x[1:2], (y_idx, x[3])], [x_probval[1:2], (y_probval, x_probval[3])],
                [x_newval[1:2], (y_newval, x_newval[3])], false,
            ),
            (
                (x[1:2], Any[y_idx, x[3]]), (x_probval[1:2], [y_probval, x_probval[3]]),
                (x_newval[1:2], [y_newval, x_newval[3]]), false,
            ),
            (
                (x[1:2], (y_idx, x[3])), (x_probval[1:2], (y_probval, x_probval[3])),
                (x_newval[1:2], (y_newval, x_newval[3])), false,
            ),
        ]
        getter = getsym(prob, sym)
        setter! = setsym(prob, sym)
        if check_inference
            @inferred getter(prob)
        end
        @test getter(prob) == oldval
        if check_inference
            @inferred setter!(prob, newval)
        else
            setter!(prob, newval)
        end
        @test getter(prob) == newval
        setter!(prob, oldval)
        @test getter(prob) == oldval
    end

    @testset "Parameter indexing" begin
        pval = [1.0, 2.0, 3.0]
        pval_new = [4.0, 5.0, 6.0]

        # don't check inference for nested tuples/arrays
        for (sym, oldval, newval, check_inference) in [
                (p[1], pval[1], pval_new[1], true),
                (p, pval, pval_new, true),
                (sys.p, pval, pval_new, true),
                (:p, pval, pval_new, true),
                ((p[1], p[2]), Tuple(pval[1:2]), Tuple(pval_new[1:2]), true),
                ([p[1], p[2]], pval[1:2], pval_new[1:2], true),
                ((p[1], p[2:3]), (pval[1], pval[2:3]), (pval_new[1], pval_new[2:3]), true),
                ([p[1], p[2:3]], [pval[1], pval[2:3]], [pval_new[1], pval_new[2:3]], false),
                (
                    (p[1], (p[2],), [p[3]]), (pval[1], (pval[2],), [pval[3]]),
                    (pval_new[1], (pval_new[2],), [pval_new[3]]), false,
                ),
                (
                    [p[1], (p[2],), [p[3]]], [pval[1], (pval[2],), [pval[3]]],
                    [pval_new[1], (pval_new[2],), [pval_new[3]]], false,
                ),
            ]
            getter = getp(prob, sym)
            setter! = setp(prob, sym)
            if check_inference
                @inferred getter(prob)
            end
            @test getter(prob) == oldval
            if check_inference
                @inferred setter!(prob, newval)
            else
                setter!(prob, newval)
            end
            @test getter(prob) == newval
            setter!(prob, oldval)
            @test getter(prob) == oldval
        end
    end
end

# Issue https://github.com/SciML/ModelingToolkit.jl/issues/2697
@testset "Interpolation of derivative of observed variables" begin
    @variables x(t) y(t) z(t) w(t)[1:2]
    @named sys = System(
        [D(x) ~ 1, y ~ x^2, z ~ 2y^2 + 3x, w[1] ~ x + y + z, w[2] ~ z * x * y], t
    )
    sys = mtkcompile(sys)
    prob = ODEProblem(sys, [x => 0.0], (0.0, 1.0))
    sol = solve(prob, Tsit5())
    @test_throws ErrorException sol(1.0, Val{1}, idxs = y)
    @test_throws ErrorException sol(1.0, Val{1}, idxs = [y, z])
    @test_throws ErrorException sol(1.0, Val{1}, idxs = w)
    @test_throws ErrorException sol(1.0, Val{1}, idxs = [w, w])
    @test_throws ErrorException sol(1.0, Val{1}, idxs = [w, y])
end

@testset "Discrete save indexing" begin
    struct NumSymbolCache{S}
        sc::S
    end
    SymbolicIndexingInterface.symbolic_container(s::NumSymbolCache) = s.sc
    function SymbolicIndexingInterface.is_observed(s::NumSymbolCache, x)
        return symbolic_type(x) != NotSymbolic() && !is_variable(s, x) &&
            !is_parameter(s, x) && !is_independent_variable(s, x)
    end
    function SymbolicIndexingInterface.observed(s::NumSymbolCache, x)
        res = ModelingToolkit.build_function(
            x,
            sort(variable_symbols(s); by = Base.Fix1(variable_index, s)),
            sort(parameter_symbols(s), by = Base.Fix1(parameter_index, s)),
            independent_variable_symbols(s)[]; expression = Val(false)
        )
        if res isa Tuple
            return let oopfn = res[1], iipfn = res[2]
                fn(out, u, p, t) = iipfn(out, u, p, t)
                fn(u, p, t) = oopfn(u, p, t)
                fn
            end
        else
            return res
        end
    end
    function SymbolicIndexingInterface.parameter_observed(s::NumSymbolCache, x)
        if x isa Symbol
            allsyms = all_symbols(s)
            x = allsyms[findfirst(y -> hasname(y) && x == getname(y), allsyms)]
        elseif x isa AbstractArray
            allsyms = all_symbols(s)
            newx = []
            for i in eachindex(x)
                if x[i] isa Symbol
                    push!(
                        newx,
                        allsyms[findfirst(y -> hasname(y) && x[i] == getname(y), allsyms)]
                    )
                else
                    push!(newx, x[i])
                end
            end
            x = newx
        end
        res = ModelingToolkit.build_function(
            x,
            sort(parameter_symbols(s), by = Base.Fix1(parameter_index, s)),
            independent_variable_symbols(s)[]; expression = Val(false)
        )
        if res isa Tuple
            return let oopfn = res[1], iipfn = res[2]
                fn(out, p, t) = iipfn(out, p, t)
                fn(p, t) = oopfn(p, t)
                fn
            end
        else
            return res
        end
    end
    function SymbolicIndexingInterface.get_all_timeseries_indexes(s::NumSymbolCache, x)
        if symbolic_type(x) == NotSymbolic()
            x = ModelingToolkit.unwrap.(x)
        else
            x = ModelingToolkit.unwrap(x)
        end
        if x isa Symbol
            allsyms = all_symbols(s)
            x = allsyms[findfirst(y -> hasname(y) && x == getname(y), allsyms)]
        elseif x isa AbstractArray
            allsyms = all_symbols(s)
            newx = []
            for i in eachindex(x)
                if x[i] isa Symbol
                    push!(
                        newx,
                        allsyms[findfirst(y -> hasname(y) && x[i] == getname(y), allsyms)]
                    )
                else
                    push!(newx, x[i])
                end
            end
            x = newx
        end
        vars = Set{Symbolics.SymbolicT}()
        SU.search_variables!(vars, x)
        return mapreduce(union, vars; init = Set()) do sym
            if is_variable(s, sym)
                Set([ContinuousTimeseries()])
            elseif is_parameter(s, sym) && is_timeseries_parameter(s, sym)
                Set([timeseries_parameter_index(s, sym).timeseries_idx])
            else
                Set()
            end
        end
    end
    function SymbolicIndexingInterface.with_updated_parameter_timeseries_values(
            ::NumSymbolCache, p::Vector{Float64}, args...
        )
        for (idx, buf) in args
            if idx == 1
                p[1:2] .= buf
            else
                p[3:4] .= buf
            end
        end

        return p
    end
    function SciMLBase.create_parameter_timeseries_collection(s::NumSymbolCache, ps, tspan)
        trem = rem(tspan[1], 0.1, RoundDown)
        if trem > 0
            trem = 0.1 - trem
        end
        dea1 = DiffEqArray(Vector{Float64}[], (tspan[1] + trem):0.1:tspan[2])
        dea2 = DiffEqArray(Vector{Float64}[], Float64[])
        return ParameterTimeseriesCollection((dea1, dea2), deepcopy(ps))
    end
    function SciMLBase.get_saveable_values(::NumSymbolCache, p::Vector{Float64}, tsidx)
        if tsidx == 1
            return p[1:2]
        else
            return p[3:4]
        end
    end

    @variables x(t) ud1(t) ud2(t) xd1(t) xd2(t)
    @parameters kp
    sc = SymbolCache(
        [x],
        Dict(ud1 => 1, xd1 => 2, ud2 => 3, xd2 => 4, kp => 5),
        t;
        timeseries_parameters = Dict(
            ud1 => ParameterTimeseriesIndex(1, 1), xd1 => ParameterTimeseriesIndex(1, 2),
            ud2 => ParameterTimeseriesIndex(2, 1), xd2 => ParameterTimeseriesIndex(2, 2)
        )
    )
    sys = NumSymbolCache(sc)

    function f!(du, u, p, t)
        du .= u .* t .+ p[5] * sum(u)
    end
    fn = ODEFunction(f!; sys = sys)
    prob = ODEProblem(fn, [1.0], (0.0, 1.0), [1.0, 2.0, 3.0, 4.0, 5.0])
    cb1 = PeriodicCallback(
        0.1; initial_affect = true, final_affect = true,
        save_positions = (false, false)
    ) do integ
        integ.p[1:2] .+= exp(-integ.t)
        SciMLBase.save_discretes!(integ, 1)
    end
    function affect2!(integ)
        integ.p[3:4] .+= only(integ.u)
        SciMLBase.save_discretes!(integ, 2)
    end
    cb2 = DiscreteCallback(
        (args...) -> true, affect2!, save_positions = (false, false),
        initialize = (c, u, t, integ) -> affect2!(integ)
    )
    sol = solve(deepcopy(prob), Tsit5(); callback = CallbackSet(cb1, cb2))

    ud1val = getindex.(sol.discretes.collection[1].u, 1)
    xd1val = getindex.(sol.discretes.collection[1].u, 2)
    ud2val = getindex.(sol.discretes.collection[2].u, 1)
    xd2val = getindex.(sol.discretes.collection[2].u, 2)

    for (sym, timeseries_index, val, buffer, isobs, check_inference) in [
            (
                ud1,
                1,
                ud1val,
                zeros(length(ud1val)),
                false,
                true,
            )
            (
                [ud1, xd1],
                1,
                vcat.(
                    ud1val,
                    xd1val
                ),
                map(
                    _ -> zeros(2),
                    ud1val
                ),
                false,
                true,
            )
            (
                (ud2, xd2),
                2,
                tuple.(
                    ud2val,
                    xd2val
                ),
                map(
                    _ -> zeros(2),
                    ud2val
                ),
                false,
                true,
            )
            (
                ud2 + xd2,
                2,
                ud2val .+
                    xd2val,
                zeros(length(ud2val)),
                true,
                true,
            )
            (
                [
                    ud2 + xd2,
                    ud2 * xd2,
                ],
                2,
                vcat.(
                    ud2val .+
                        xd2val,
                    ud2val .*
                        xd2val
                ),
                map(
                    _ -> zeros(2),
                    ud2val
                ),
                true,
                true,
            )
            (
                (
                    ud1 + xd1,
                    ud1 * xd1,
                ),
                1,
                tuple.(
                    ud1val .+
                        xd1val,
                    ud1val .*
                        xd1val
                ),
                map(
                    _ -> zeros(2),
                    ud1val
                ),
                true,
                true,
            )
        ]
        getter = getp(sys, sym)
        if check_inference
            @inferred getter(sol)
            @inferred getter(deepcopy(buffer), sol)
            if !isobs
                @inferred getter(parameter_values(sol))
                if !(eltype(val) <: Number)
                    @inferred getter(deepcopy(buffer[1]), parameter_values(sol))
                end
            end
        end

        @test getter(sol) == val
        if eltype(val) <: Number
            target = val
        else
            target = collect.(val)
        end
        tmp = deepcopy(buffer)
        getter(tmp, sol)
        @test tmp == target

        if !isobs
            @test getter(parameter_values(sol)) == val[end]
            if !(eltype(val) <: Number)
                target = collect(val[end])
                tmp = deepcopy(buffer)[end]
                getter(tmp, parameter_values(sol))
                @test tmp == target
            end
        end

        for subidx in [
                1, CartesianIndex(2), :, rand(Bool, length(val)), rand(eachindex(val), 4), 2:5,
            ]
            if check_inference
                @inferred getter(sol, subidx)
                if !isa(val[subidx], Number)
                    @inferred getter(deepcopy(buffer[subidx]), sol, subidx)
                end
            end
            @test getter(sol, subidx) == val[subidx]
            tmp = deepcopy(buffer[subidx])
            if val[subidx] isa Number
                continue
            end
            target = val[subidx]
            if eltype(target) <: Number
                target = collect(target)
            else
                target = collect.(target)
            end
            getter(tmp, sol, subidx)
            @test tmp == target
        end
    end

    for sym in [
            [ud1, xd1, ud2],
            (ud2, xd1, xd2),
            ud1 + ud2,
            [ud1 + ud2, ud1 * xd1],
            (ud1 + ud2, ud1 * xd1),
        ]
        getter = getp(sys, sym)
        @test_throws Exception getter(sol)
        @test_throws Exception getter([], sol)
        for subidx in [1, CartesianIndex(1), :, rand(Bool, 4), rand(1:4, 3), 1:2]
            @test_throws Exception getter(sol, subidx)
            @test_throws Exception getter([], sol, subidx)
        end
    end

    kpval = sol.prob.p[5]
    xval = getindex.(sol.u)

    for (sym, val_is_timeseries, val, check_inference) in [
            (kp, false, kpval, true),
            ([kp, kp], false, [kpval, kpval], true),
            ((kp, kp), false, (kpval, kpval), true),
            (ud2, true, ud2val, true),
            ([ud2, kp], true, vcat.(ud2val, kpval), false),
            ((ud1, kp), true, tuple.(ud1val, kpval), false),
            ([kp, x], true, vcat.(kpval, xval), false),
            ((kp, x), true, tuple.(kpval, xval), false),
            (2ud2, true, 2 .* ud2val, true),
            ([kp, 2ud1], true, vcat.(kpval, 2 .* ud1val), false),
            ((kp, 2ud1), true, tuple.(kpval, 2 .* ud1val), false),
        ]
        getter = getsym(sys, sym)
        if check_inference
            @inferred getter(sol)
        end
        @test getter(sol) == val
        reference = val_is_timeseries ? val : xval
        for subidx in [
                1, CartesianIndex(2), :, rand(Bool, length(reference)),
                rand(eachindex(reference), 4), 2:6,
            ]
            if check_inference
                @inferred getter(sol, subidx)
            end
            target = if val_is_timeseries
                val[subidx]
            else
                val
            end
            @test getter(sol, subidx) == target
        end
    end

    _xval = xval[1]
    _ud1val = ud1val[1]
    _ud2val = ud2val[1]
    _xd1val = xd1val[1]
    _xd2val = xd2val[1]
    integ = init(prob, Tsit5(); callback = CallbackSet(cb1, cb2))
    for (sym, val, check_inference) in [
            ([x, ud1], [_xval, _ud1val], false),
            ((x, ud1), (_xval, _ud1val), true),
            (x + ud2, _xval + _ud2val, true),
            ([2x, 3xd1], [2_xval, 3_xd1val], true),
            ((2x, 3xd2), (2_xval, 3_xd2val), true),
        ]
        getter = getsym(sys, sym)
        @test_throws Exception getter(sol)
        for subidx in [1, CartesianIndex(1), :, rand(Bool, 4), rand(1:4, 3), 1:2]
            @test_throws Exception getter(sol, subidx)
        end

        if check_inference
            @inferred getter(integ)
        end
        @test getter(integ) == val
    end

    xinterp = sol(0.1:0.1:0.3, idxs = x).u
    xinterp2 = sol(sol.discretes.collection[2].t[2:4], idxs = x).u
    ud1interp = ud1val[2:4]
    ud2interp = ud2val[2:4]

    c1 = SciMLBase.Clock(0.1)
    c2 = SciMLBase.SolverStepClock()
    for (sym, t, val) in [
            (x, c1[2], xinterp[1]),
            (x, c1[2:4], xinterp),
            ([x, ud1], c1[2], [xinterp[1], ud1interp[1]]),
            ([x, ud1], c1[2:4], vcat.(xinterp, ud1interp)),
            (x, c2[2], xinterp2[1]),
            (x, c2[2:4], xinterp2),
            ([x, ud2], c2[2], [xinterp2[1], ud2interp[1]]),
            ([x, ud2], c2[2:4], vcat.(xinterp2, ud2interp)),
        ]
        res = sol(t, idxs = sym)
        if res isa DiffEqArray
            res = res.u
        end
        @test res == val
    end

    @testset "Plotting" begin
        plotfn(t, u) = (t, 2u)
        all_idxs = [ud1, 2ud1, ud2, (plotfn, 0, ud1), (plotfn, t, ud1)]
        sym_idxs = [:ud1, :ud2, (plotfn, 0, :ud1), (plotfn, 0, :ud1)]

        for idx in Iterators.flatten((all_idxs, sym_idxs))
            @test_nowarn plot(sol; idxs = idx)
            @test_nowarn plot(sol; idxs = [idx])
        end
        for idx in Iterators.flatten(
                (
                    Iterators.product(all_idxs, all_idxs), Iterators.product(sym_idxs, sym_idxs),
                )
            )
            @test_nowarn plot(sol; idxs = collect(idx))
            if !(
                    idx[1] isa Tuple || idx[2] isa Tuple ||
                        length(get_all_timeseries_indexes(sol, collect(idx))) > 1
                )
                @test_nowarn plot(sol; idxs = idx)
            end
        end
    end

    @testset "`initialize_save_discretes`" begin
        fn = ODEFunction(f!; sys = sys)
        prob = ODEProblem(fn, [1.0], (0.0, 1.0), [1.0, 2.0, 3.0, 4.0, 5.0])
        cb1 = PeriodicCallback(
            0.1; initial_affect = true, final_affect = true,
            save_positions = (false, false)
        ) do integ
            integ.p[1:2] .+= exp(-integ.t)
            SciMLBase.save_discretes!(integ, 1)
        end
        function affect2!(integ)
            integ.p[3:4] .+= only(integ.u)
        end

        @testset "`DiscreteCallback`" begin
            cb2 = DiscreteCallback(
                (args...) -> true, affect2!, save_positions = (true, true),
                initialize_save_discretes = false, saved_clock_partitions = (2,)
            )
            sol = solve(deepcopy(prob), Tsit5(); callback = CallbackSet(cb1, cb2))

            @test sol.discretes.collection[2].t[1] > 0.0
        end

        @testset "`ContinuousCallback`" begin
            cb2 = ContinuousCallback(
                (u, t, i) -> cos(4pi * t), affect2!, save_positions = (true, true),
                initialize_save_discretes = false, saved_clock_partitions = (2,)
            )
            sol = solve(deepcopy(prob), Tsit5(); callback = CallbackSet(cb1, cb2))

            @test sol.discretes.collection[2].t[1] > 0.0
        end

        @testset "`VectorContinuousCallback`" begin
            cb2 = VectorContinuousCallback(
                (out, u, t, integ) -> (out[1] = cos(4pi * t)), (integ, i) -> affect2!(integ), 2;
                save_positions = (true, true),
                initialize_save_discretes = false, saved_clock_partitions = [(2,)]
            )
            sol = solve(deepcopy(prob), Tsit5(); callback = CallbackSet(cb1, cb2))

            @test sol.discretes.collection[2].t[1] > 0.0
        end
    end
end

# Issue https://github.com/SciML/ModelingToolkit.jl/issues/3004
@testset "Continuous interpolation before discrete save" begin
    @variables x(t)
    @discretes c(t)
    devt = ModelingToolkit.SymbolicDiscreteCallback(1.0, [c ~ Pre(c) + 1]; discrete_parameters = [c], iv = t)
    @mtkcompile sys = System(
        D(x) ~ c * cos(x), t, [x, c], []; discrete_events = [devt]
    )
    prob = ODEProblem(sys, [x => 0.0, c => 1.0], (0.0, 2pi))
    sol = solve(prob, Tsit5())
    @test_nowarn sol(-0.1; idxs = sys.x)
    @test_nowarn sol(-0.1; idxs = [sys.x, 2sys.x])
    @test_throws ErrorException sol(-0.1; idxs = sys.c)
    @test_throws ErrorException sol(-0.1; idxs = [sys.x, sys.x + sys.c])
end

@testset "DDEs" begin
    function oscillator(; name, k = 1.0, τ = 0.01)
        @parameters k = k τ = τ
        @variables x(..) = 0.1 + t y(t) = 0.1 + t jcn(t) delx(t)
        eqs = [
            D(x(t)) ~ y,
            D(y) ~ -k * x(t - τ) + jcn,
            delx ~ x(t - τ),
        ]
        return System(eqs, t; name = name)
    end
    systems = @named begin
        osc1 = oscillator(k = 1.0, τ = 0.01)
        osc2 = oscillator(k = 2.0, τ = 0.04)
    end
    eqs = [
        osc1.jcn ~ osc2.delx,
        osc2.jcn ~ osc1.delx,
    ]
    @named coupledOsc = System(eqs, t)
    @named coupledOsc = compose(coupledOsc, systems)
    sys = mtkcompile(coupledOsc)
    prob = DDEProblem(sys, [], (0.0, 10.0); constant_lags = [sys.osc1.τ, sys.osc2.τ])
    sym = sys.osc1.delx
    delay = sys.osc1.τ
    original = sys.osc1.x
    @test prob[sym] ≈ prob[original] .+ (prob.tspan[1] - prob.ps[delay])
    integ = init(prob, MethodOfSteps(Tsit5()))
    step!(integ, 10.0, true)
    @test integ[sym] ≈ SciMLBase.get_sol(integ)(integ.t - integ.ps[delay]; idxs = original)
    sol = solve(prob, MethodOfSteps(Tsit5()))
    @test sol[sym] ≈ sol(sol.t .- sol.ps[delay]; idxs = original)
end

@testset "SDDEs" begin
    function oscillator(; name, k = 1.0, τ = 0.01)
        @parameters k = k τ = τ
        @brownians a
        @variables x(..) = 0.1 + t y(t) = 0.1 + t jcn(t) delx(t)
        eqs = [
            D(x(t)) ~ y + a,
            D(y) ~ -k * x(t - τ) + jcn,
            delx ~ x(t - τ),
        ]
        return System(eqs, t; name = name)
    end
    systems = @named begin
        osc1 = oscillator(k = 1.0, τ = 0.01)
        osc2 = oscillator(k = 2.0, τ = 0.04)
    end
    eqs = [
        osc1.jcn ~ osc2.delx,
        osc2.jcn ~ osc1.delx,
    ]
    @named coupledOsc = System(eqs, t)
    @named coupledOsc = compose(coupledOsc, systems)
    sys = mtkcompile(coupledOsc)
    prob = SDDEProblem(sys, [], (0.0, 10.0); constant_lags = [sys.osc1.τ, sys.osc2.τ])
    sym = sys.osc1.delx
    delay = sys.osc1.τ
    original = sys.osc1.x
    @test prob[sym] ≈ prob[original] .+ (prob.tspan[1] - prob.ps[delay])
    sol = solve(prob, ImplicitEM())
    @test sol[sym] ≈ sol(sol.t .- sol.ps[delay]; idxs = original)
end

@testset "RODESolutions save discretes" begin
    @discretes k(t)
    @variables A(t)
    function affect2!(m, o, ctx, integ)
        return (; k = m.k + 1.0)
    end
    db = 1.0 => ModelingToolkit.ImperativeAffect(affect2!; modified = (; k))

    @named ssys = System(D(A) ~ k * A, t, [A, k], []; noise_eqs = [0.0], discrete_events = db)
    ssys = complete(ssys)
    prob = SDEProblem(ssys, [A => 1.0, k => 1.0], (0.0, 4.0))
    sol = solve(prob, RI5())
    @test sol[k] isa AbstractVector
    @test sol[k] == [1.0, 2.0, 3.0, 4.0]
end

"""
    isautodifferentiable(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm is compatible with
direct automatic differentiation, i.e. can have algorithms like
ForwardDiff or ReverseDiff attempt to differentiate directly
through the solver.

Defaults to false as only pure-Julia algorithms can have this be true.
"""
isautodifferentiable(alg::AbstractSciMLAlgorithm) = false

"""
    forwarddiffs_model(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm uses ForwardDiff.jl
on the model function is called with ForwardDiff.jl

Defaults to false as only pure-Julia algorithms can have this be true.
"""
forwarddiffs_model(alg::AbstractSciMLAlgorithm) = false

"""
    forwarddiffs_model_time(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm uses ForwardDiff.jl
on the model `f(u,p,t)` function is called with ForwardDiff.jl on the `t` argument.

Defaults to false as only a few pure-Julia algorithms (Rosenbrock methods)
have this as true
"""
forwarddiffs_model_time(alg::AbstractSciMLAlgorithm) = false

"""
    forwarddiff_chunksize(alg::AbstractSciMLAlgorithm)

Trait declaration for the ForwardDiff chunk size used by the algorithm
when calling the model function with ForwardDiff.Dual numbers.

Returns a `Val{N}()`: `Val(0)` means unspecified (the framework will choose
a default, typically 1 for FunctionWrapper compatibility). `Val(N)` for any
positive integer `N` means the algorithm will use chunk size `N`.

This is used by DiffEqBase to compile FunctionWrapper variants with matching
Dual number chunk sizes, avoiding `NoFunctionWrapperFoundError`.

Defaults to `Val(0)` (unspecified).
"""
forwarddiff_chunksize(alg::AbstractSciMLAlgorithm) = Val(0)

"""
    allows_arbitrary_number_types(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm is compatible with
direct automatic differentiation, i.e. can have algorithms like
ForwardDiff or ReverseDiff attempt to differentiate directly
through the solver.

Defaults to false as only pure-Julia algorithms can have this be true.
"""
allows_arbitrary_number_types(alg::AbstractSciMLAlgorithm) = false

"""
    allowscomplex(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm is compatible with
having complex numbers as the state variables.

Defaults to false.
"""
allowscomplex(alg::AbstractSciMLAlgorithm) = false

"""
    isadaptive(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm uses adaptivity,
i.e. has a non-quasi-static compute graph.

Defaults to true.
"""
isadaptive(alg::AbstractDEAlgorithm) = true
# Default to assuming adaptive, safer error("Adaptivity algorithm trait not set.")

"""
    isdiscrete(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm allows for
discrete state values, such as integers.

Defaults to false.
"""
isdiscrete(alg::AbstractDEAlgorithm) = false

"""
    has_lazy_interpolation(alg::AbstractDEAlgorithm)

Trait declaration for whether an algorithm computes the solution interpolation lazily.

Defaults to false.
"""
has_lazy_interpolation(alg::AbstractDEAlgorithm) = false
"""
    allowsbounds(opt)

Trait declaration for whether an solver allows for
box constraints passed with `lb` and `ub` in problems.

Defaults to false.
"""
allowsbounds(opt) = false

"""
    requiresbounds(opt)

Trait declaration for whether an solver requires
box constraints passed with `lb` and `ub` in
problems.

Defaults to false.
"""
requiresbounds(opt) = false

"""
    allowsconstraints(opt)

Trait declaration for whether an optimizer allows
non-linear constraints specified in `cons` in
`OptimizationFunction`.

Defaults to false.
"""
allowsconstraints(opt) = false

"""
    requiresconstraints(opt)

Trait declaration for whether an optimizer
requires non-linear constraints specified in
`cons` in `OptimizationFunction`.

Defaults to false.
"""
requiresconstraints(opt) = false

"""
    requiresgradient(opt)

Trait declaration for whether an optimizer
requires gradient in `instantiate_function`.

Defaults to false.
"""
requiresgradient(opt) = false

"""
    allowsfg(opt)

Trait declaration for whether an optimizer
allows combined function and gradient evaluation
in `instantiate_function`.

Defaults to false.
"""
allowsfg(opt) = false

"""
    requireshessian(opt)

Trait declaration for whether an optimizer
requires hessian in `instantiate_function`.

Defaults to false.
"""
requireshessian(opt) = false

"""
    allowsfgh(opt)

Trait declaration for whether an optimizer
allows combined function, gradient, and hessian
evaluation in `instantiate_function`.

Defaults to false.
"""
allowsfgh(opt) = false

"""
    requiresconsjac(opt)

Trait declaration for whether an optimizer
requires `cons_j` in `instantiate_function`, that is,
does the optimizer require a constraints' Jacobian.

Defaults to false.
"""
requiresconsjac(opt) = false

"""
    allowsconsjvp(opt)

Trait declaration for whether an optimizer
allows  constraint's jacobian vector product
in `instantiate_function`.

Defaults to false.
"""
allowsconsjvp(opt) = false

"""
    allowsconsvjp(opt)

Trait declaration for whether an optimizer
allows  constraint's vector jacobian product
in `instantiate_function`.

Defaults to false.
"""
allowsconsvjp(opt) = false

"""
    requiresconshess(opt)

Trait declaration for whether an optimizer
requires cons_h in `instantiate_function`, that is,
does the optimizer require constraints' hessian.

Defaults to false.
"""
requiresconshess(opt) = false

"""
    requireslagh(opt)

Trait declaration for whether an optimizer
requires lag_h in `instantiate_function`, that is,
does the optimizer require lagrangian hessian.

Defaults to false.
"""
requireslagh(opt) = false

"""
    allowscallback(opt)

Trait declaration for whether an optimizer
supports passing a `callback` to `solve`
for an `OptimizationProblem`.

Defaults to true.
"""
allowscallback(opt) = true

"""
    alg_order(alg)

The theoretic convergence order of the algorithm. If the method is adaptive order, this is treated
as the maximum order of the algorithm.
"""
function alg_order(alg::AbstractODEAlgorithm)
    error("Order is not defined for this algorithm")
end

"""
    allows_non_wiener_noise(alg::AbstractSDEAlgorithm)

Trait declaration for whether an algorithm allows for non-wiener noise.
In general, this is false for any high order (that uses levy areas) or adaptive method.

Defaults to false.
"""
allows_non_wiener_noise(alg::AbstractSDEAlgorithm) = false

"""
    requires_additive_noise(alg::AbstractSDEAlgorithm)

Trait declaration for whether an algorithm requires additive noise, i.e. the noise
function is not a function of `u`.

Defaults to false
"""
requires_additive_noise(alg::AbstractSDEAlgorithm) = false

EnumX.@enumx AlgorithmInterpretation Ito Stratonovich

"""
    alg_interpretation(alg)

Integral interpolation for the SDE solver algorithm. SDEs solutions depend on the chosen definition of the stochastic integral. In the Ito calculus,
the left-hand rule is taken, while Stratonovich calculus uses the right-hand rule. Unlike in standard Riemannian integration, these integral rules do
not converge to the same answer. In the context of a stochastic differential equation, the underlying solution (and its mean, variance, etc.) is dependent
on the integral rule that is chosen. This trait describes which interpretation the solver algorithm subscribes to, and thus whether the solution should
be interpreted as the solution to the SDE under the Ito or Stratonovich interpretation.

For more information, see <https://oatml.cs.ox.ac.uk/blog/2022/03/22/ito-strat.html> as a good high-level explanation.

!!! note

    The expected solution statistics are dependent on this output. Solutions from solvers with different
    interpretations are expected to have different answers on almost all SDEs without additive noise.
"""
function alg_interpretation(alg::AbstractSciMLAlgorithm)
    error("Algorithm interpretation is not defined for this algorithm. It can be either `AlgorithmInterpretation.Ito` or `AlgorithmInterpretation.Stratonovich`")
end

"""
    $(TYPEDSIGNATURES)

Trait declaration for whether an algorithm supports specifying `tstops` as a function `tstops(p, tspan)` to be called after
initialization.

Defaults to false.
"""
allows_late_binding_tstops(alg::AbstractODEAlgorithm) = false

"""
    $(TYPEDSIGNATURES)

Trait declaration for whether the optimization algorithm supports the `init` interface.

Deprecated as this is not an optimization-specific idea and should use the traits for general caching.
"""
supports_opt_cache_interface(alg) = false

"""
    $(TYPEDSIGNATURES)

Trait for specifying whether the passed algorithm supports `init`. Any `init`ed object can `solve!`.
"""
has_init(a) = false

"""
    $(TYPEDSIGNATURES)

Trait for specifying whether the passed algorithm supports `step!`, specifying a more direct control over the internal solver process.
See https://docs.sciml.ai/SciMLBase/stable/interfaces/Init_Solve/#init-and-the-Iterator-Interface for more details.
"""
has_step(a) = false

"""
    supports_solve_rng(prob, alg) -> Bool

Whether `solve(prob, alg; rng=...)` is supported for this problem/algorithm path.

Pass `alg = nothing` to query support for the default solver-selection path
(i.e., `solve(prob; rng=...)`).
"""
supports_solve_rng(::AbstractSciMLProblem, alg) = false

module SciMLBaseReverseDiffExt

using SciMLBase
using ReverseDiff

function SciMLBase.anyeltypedual(
        ::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        V, D, N, VA, DA, T <: ReverseDiff.TrackedArray{V, D, N, VA, DA},
    }
    return SciMLBase.anyeltypedual(V, Val{counter})
end

SciMLBase.value(x::Type{ReverseDiff.TrackedReal{V, D, O}}) where {V, D, O} = V
function SciMLBase.value(
        x::Type{
            ReverseDiff.TrackedArray{V, D, N, VA, DA},
        }
    ) where {
        V, D,
        N, VA,
        DA,
    }
    return Array{V, N}
end
SciMLBase.value(x::ReverseDiff.TrackedReal) = x.value
SciMLBase.value(x::ReverseDiff.TrackedArray) = x.value

SciMLBase.unitfulvalue(x::Type{ReverseDiff.TrackedReal{V, D, O}}) where {V, D, O} = V
function SciMLBase.unitfulvalue(
        x::Type{
            ReverseDiff.TrackedArray{V, D, N, VA, DA},
        }
    ) where {
        V, D,
        N, VA,
        DA,
    }
    return Array{V, N}
end
SciMLBase.unitfulvalue(x::ReverseDiff.TrackedReal) = x.value
SciMLBase.unitfulvalue(x::ReverseDiff.TrackedArray) = x.value

# Force TrackedArray from TrackedReal when reshaping W\b
SciMLBase._reshape(v::AbstractVector{<:ReverseDiff.TrackedReal}, siz) = reduce(vcat, v)

SciMLBase.promote_u0(u0::ReverseDiff.TrackedArray, p::ReverseDiff.TrackedArray, t0) = u0
function SciMLBase.promote_u0(
        u0::AbstractArray{<:ReverseDiff.TrackedReal},
        p::ReverseDiff.TrackedArray, t0
    )
    return u0
end
function SciMLBase.promote_u0(
        u0::ReverseDiff.TrackedArray,
        p::AbstractArray{<:ReverseDiff.TrackedReal}, t0
    )
    return u0
end
function SciMLBase.promote_u0(
        u0::AbstractArray{<:ReverseDiff.TrackedReal},
        p::AbstractArray{<:ReverseDiff.TrackedReal}, t0
    )
    return u0
end
SciMLBase.promote_u0(u0, p::ReverseDiff.TrackedArray, t0) = ReverseDiff.track(u0)
function SciMLBase.promote_u0(
        u0, p::ReverseDiff.TrackedArray{T}, t0
    ) where {T <: ReverseDiff.ForwardDiff.Dual}
    return ReverseDiff.track(T.(u0))
end
SciMLBase.promote_u0(u0, p::AbstractArray{<:ReverseDiff.TrackedReal}, t0) = eltype(p).(u0)

end

using ModelingToolkit, OrdinaryDiffEq
using ModelingToolkit: t_nounits as t, D_nounits as D
import SymbolicIndexingInterface as SII
import SciMLStructures as SS
using ModelingToolkitStandardLibrary
import ModelingToolkitStandardLibrary as MSL
using SciMLSensitivity
using Test

# DifferentiationInterface with version-dependent backends
using DifferentiationInterface
using ADTypes
using ForwardDiff: ForwardDiff
using Mooncake: Mooncake
if VERSION < v"1.12"
    using Zygote: Zygote
    using Enzyme: Enzyme
end

# Define available reverse-mode backends based on Julia version
# Note: Mooncake does not support SymbolicIndexingInterface AD yet
# See: https://github.com/SciML/SciMLBase.jl/issues/1207
const ZYGOTE_BACKENDS = VERSION < v"1.12" ? [AutoZygote()] : []
const MOONCAKE_BACKENDS = [AutoMooncake()]

function backend_name(backend::ADTypes.AbstractADType)
    return string(typeof(backend).name.name)
end

@parameters σ ρ β
@variables x(t) y(t) z(t) w(t)

eqs = [
    D(D(x)) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
    w ~ x + y + z + 2 * β,
]

@mtkcompile sys = System(eqs, t)

u0 = [
    D(x) => 2.0,
    x => 1.0,
    y => 0.0,
    z => 0.0,
]

p = [
    σ => 28.0,
    ρ => 10.0,
    β => 8 / 3,
]

tspan = (0.0, 100.0)
prob = ODEProblem(sys, [u0; p], tspan)
sol = solve(prob, Tsit5())

@testset "AutoDiff Observable Functions" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            gs = DifferentiationInterface.gradient(sol -> sum(sol[sys.w]), backend, sol)
            du_ = [1.0, 1.0, 1.0, 0.0]
            du = [du_ for _ in sol[[D(x), x, y, z]]]
            @test du == gs.u

            # Observable in a vector
            # Zygote returns incorrect gradient on Julia 1.10 (elements swapped)
            # See https://github.com/SciML/SciMLBase.jl/issues/1233
            gs2 = DifferentiationInterface.gradient(
                sol -> sum(sum.(sol[[sys.w, sys.x]])), backend, sol
            )
            du_ = [1.0, 1.0, 2.0, 0.0]
            du = [du_ for _ in sol[[D(x), x, y, z]]]
            @test_broken du == gs2.u
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    # https://github.com/SciML/SciMLBase.jl/issues/1207
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                gs = DifferentiationInterface.gradient(
                    sol -> sum(sol[sys.w]), backend, sol
                )
                du_ = [1.0, 1.0, 1.0, 0.0]
                du = [du_ for _ in sol[[D(x), x, y, z]]]
                du == gs.u
            end
        end
    end
end

@testset "AD Observable Functions for Initialization" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            iprob = prob.f.initialization_data.initializeprob
            isol = solve(iprob)
            gs = DifferentiationInterface.gradient(isol -> isol[w], backend, isol)

            @test gs isa NamedTuple
            @test isempty(setdiff(fieldnames(typeof(gs)), fieldnames(typeof(isol))))

            # Compare gradient for parameters match from observed function
            # to ensure parameter gradients are passed through the observed function
            f = SII.observed(iprob.f.sys, w)
            gu0 = DifferentiationInterface.gradient(
                u0 -> f(u0, SII.parameter_values(iprob)), backend, SII.state_values(iprob)
            )
            gp = DifferentiationInterface.gradient(
                p -> f(SII.state_values(iprob), p), backend, SII.parameter_values(iprob)
            )

            @test gs.prob.p == gp
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                iprob = prob.f.initialization_data.initializeprob
                isol = solve(iprob)
                gs = DifferentiationInterface.gradient(isol -> isol[w], backend, isol)
                gs isa NamedTuple
            end
        end
    end
end

# DAE

function create_model(; C₁ = 3.0e-5, C₂ = 1.0e-6)
    @named resistor1 = MSL.Electrical.Resistor(R = 5.0)
    @named resistor2 = MSL.Electrical.Resistor(R = 2.0)
    @named capacitor1 = MSL.Electrical.Capacitor(C = C₁)
    @named capacitor2 = MSL.Electrical.Capacitor(C = C₂)
    @named source = MSL.Electrical.Voltage()
    @named input_signal = MSL.Blocks.Sine(frequency = 100.0)
    @named ground = MSL.Electrical.Ground()
    @named ampermeter = MSL.Electrical.CurrentSensor()

    eqs = [
        connect(input_signal.output, source.V)
        connect(source.p, capacitor1.n, capacitor2.n)
        connect(source.n, resistor1.p, resistor2.p, ground.g)
        connect(resistor1.n, capacitor1.p, ampermeter.n)
        connect(resistor2.n, capacitor2.p, ampermeter.p)
    ]

    return @named circuit_model = System(
        eqs, t,
        systems = [
            resistor1, resistor2, capacitor1, capacitor2,
            source, input_signal, ground, ampermeter,
        ], initial_conditions = [resistor1.n.v => 0.0]
    )
end

@testset "DAE Observable function AD" begin
    model = create_model()
    sys = mtkcompile(model)

    prob = ODEProblem(sys, [], (0.0, 1.0))
    sol = solve(prob, Rodas4())

    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            gs = DifferentiationInterface.gradient(
                sol -> sum(sol[sys.ampermeter.i]), backend, sol
            )
            du_ = [0.2, 1.0]
            du = [du_ for _ in sol.u]
            @test gs.u == du
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                gs = DifferentiationInterface.gradient(
                    sol -> sum(sol[sys.ampermeter.i]), backend, sol
                )
                du_ = [0.2, 1.0]
                du = [du_ for _ in sol.u]
                gs.u == du
            end
        end
    end

    @testset "DAE Initialization Observable function AD" begin
        for backend in ZYGOTE_BACKENDS
            @testset "$(backend_name(backend))" begin
                iprob = prob.f.initialization_data.initializeprob
                isol = solve(iprob)
                tunables, repack, _ = SS.canonicalize(
                    SS.Tunable(), SII.parameter_values(iprob)
                )
                gs = DifferentiationInterface.gradient(
                    isol -> isol[sys.ampermeter.i], backend, isol
                )
                gt = gs.prob.p.tunable
                @test length(findall(!iszero, gt)) == 1
            end
        end
        # Mooncake does not support SymbolicIndexingInterface AD yet
        for backend in MOONCAKE_BACKENDS
            @testset "$(backend_name(backend)) (broken)" begin
                @test_broken begin
                    iprob = prob.f.initialization_data.initializeprob
                    isol = solve(iprob)
                    gs = DifferentiationInterface.gradient(
                        isol -> isol[sys.ampermeter.i], backend, isol
                    )
                    gt = gs.prob.p.tunable
                    length(findall(!iszero, gt)) == 1
                end
            end
        end
    end
end

@testset "Adjoints with DAE" begin
    model = create_model()
    sys = mtkcompile(model)
    prob = ODEProblem(sys, [], (0.0, 1.0))
    tunables, _, _ = SS.canonicalize(SS.Tunable(), prob.p)

    # Zygote DAE adjoints currently broken due to ChainRules issue with
    # ModelingToolkitBase.PConstructorApplicator ("Tuple field type cannot be Union{}")
    # See https://github.com/SciML/SciMLBase.jl/issues/1233
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            @test_broken begin
                function loss_wrt_tunables(new_tunables)
                    new_p = SS.replace(SS.Tunable(), prob.p, new_tunables)
                    new_prob = remake(prob, p = new_p)
                    sol = solve(new_prob, Rodas4())
                    return sum(sol[sys.ampermeter.i])
                end

                gs_p_new = DifferentiationInterface.gradient(
                    loss_wrt_tunables, backend, tunables
                )

                !isnothing(gs_p_new) && length(gs_p_new) == length(tunables)
            end
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                function loss_wrt_tunables_mooncake(new_tunables)
                    new_p = SS.replace(SS.Tunable(), prob.p, new_tunables)
                    new_prob = remake(prob, p = new_p)
                    sol = solve(new_prob, Rodas4())
                    return sum(sol[sys.ampermeter.i])
                end
                gs_p_new = DifferentiationInterface.gradient(
                    loss_wrt_tunables_mooncake, backend, tunables
                )
                !isnothing(gs_p_new)
            end
        end
    end
end

using Test, SciMLBase, SymbolicIndexingInterface, Accessors, StaticArrays

function simplependulum!(du, u, p, t)
    θ = u[1]
    dθ = u[2]
    du[1] = dθ
    return du[2] = -9.81 * sin(θ)
end
function bc!(residual, u, p, t)
    residual[1] = u[1][1] + pi / 2
    return residual[2] = u[end][1] - pi / 2
end
prob_bvp = BVProblem(simplependulum!, bc!, [pi / 2, pi / 2], (0, 1.0))
@test prob_bvp.tspan === (0.0, 1.0)

@testset "`constructorof` tests" begin
    probs = []

    function lorenz!(du, u, p, t)
        du[1] = p[1] * (u[2] - u[1])
        du[2] = u[1] * (p[2] - u[3]) - u[2]
        du[3] = u[1] * u[2] - p[3] * u[3]
    end
    u0 = [1.0; 2.0; 3.0]
    du0 = similar(u0)
    p = [10.0, 20.0, 30.0]
    tspan = (0.0, 100.0)
    lorenz!(du0, u0, p, tspan[1])
    sys = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)
    fn = ODEFunction(lorenz!; sys)
    push!(probs, ODEProblem(fn, u0, tspan, p))

    function daelorenz!(resid, du, u, p, t)
        lorenz!(resid, u, p, t)
        resid .-= du
    end
    fn = DAEFunction(daelorenz!; sys)
    push!(probs, DAEProblem(fn, du0, u0, tspan, p))

    function ddelorenz!(du, u, h, p, t)
        du[1] = p[1] * (u[2] - u[1])
        du[2] = u[1] * (p[2] - u[3]) - u[2]
        du[3] = u[1] * u[2] - p[3] * u[3]
    end

    function history(p, t)
        return u0 .- t
    end

    fn = DDEFunction(ddelorenz!; sys)
    push!(probs, DDEProblem(fn, u0, history, tspan, p))

    function noise!(du, u, p, t)
        du .= 0.1u
    end
    fn = SDEFunction(lorenz!, noise!; sys)
    push!(probs, SDEProblem(fn, u0, tspan, p))

    fn = SDDEFunction(ddelorenz!, noise!; sys)
    push!(probs, SDDEProblem(fn, noise!, u0, history, tspan, p))

    function nllorenz!(du, u, p)
        lorenz!(du, u, p, 0.0)
    end

    fn = NonlinearFunction(nllorenz!; sys)
    push!(probs, NonlinearProblem(fn, u0, p))
    push!(probs, NonlinearLeastSquaresProblem(fn, u0, p))

    @testset "$(SciMLBase.parameterless_type(typeof(prob)))" for prob in probs
        newprob = @reset prob.u0 = u0 .+ 1
        @test typeof(newprob) == typeof(prob)
    end
end

# test for tspan promotion in DiscreteProblem
let
    p = (0.1 / 1000, 0.01)
    u₀ = [1.0]
    tspan = (0.0, 1.0)
    dprob = DiscreteProblem(u₀, tspan, p)
    @test dprob.tspan === (0.0, 1.0)

    dprob2 = DiscreteProblem(u₀, 1.0, p)
    @test dprob.tspan === (0.0, 1.0)

    dprob3 = DiscreteProblem(u₀, [0.0, 1.0], p)
    @test dprob.tspan === (0.0, 1.0)

    dprob4 = DiscreteProblem{true}(nothing, nothing, p)
    dprob4b = DiscreteProblem{true}(nothing, nothing)
    dprob5 = DiscreteProblem{true}(SciMLBase.DISCRETE_INPLACE_DEFAULT, u₀, tspan, p)
    dprob6 = DiscreteProblem{true}(SciMLBase.DISCRETE_INPLACE_DEFAULT, u₀, tspan)
    dprob7 = DiscreteProblem{true}((du, u, p, t) -> du[1] = 0, u₀, tspan)
    @test dprob7.u0 === u₀
    @test dprob7.tspan === tspan
    dprob8 = DiscreteProblem{true}(nothing, u₀, tspan)
    @test dprob8.u0 === u₀
    @test dprob8.tspan === tspan
end

@testset "SCCNonlinearProblem with static arrays" begin
    function f1(u, p)
        y = u[1]
        x = p[1]
        return SA[1 - y^2 - x^2]
    end

    function f2(u, p)
        yt = u[1]
        x, xt, y = p
        return SA[-2y * yt - 2x * xt]
    end

    function f3(u, p)
        lam = u[1]
        x, xt, y, yt = p
        return SA[-2xt^2 - 2yt^2 - 2y * (-1 + y * lam) - 2x^2 * lam]
    end

    explicit1 = Returns(nothing)
    function explicit2(p, sols)
        p[3] = sols[1].u[1]
    end
    function explicit3(p, sols)
        p[4] = sols[2].u[1]
    end

    p = [1.0, 0.0, NaN, NaN]
    prob1 = NonlinearProblem(f1, SA[1.0], p)
    prob2 = NonlinearProblem(f2, SA[0.0], p)
    prob3 = NonlinearProblem(f3, SA[1.0], p)
    sccprob = SCCNonlinearProblem(
        (prob1, prob2, prob3), (explicit1, explicit2, explicit3), p, true
    )

    @test !SciMLBase.isinplace(sccprob)
    @test sccprob isa SCCNonlinearProblem{SVector{3, Float64}}
    @test state_values(sccprob) isa SVector{3, Float64}
    @test sccprob.p === prob1.p === prob2.p === prob3.p

    sccprob2 = @inferred remake(sccprob; u0 = SA[2.0, 1.0, 2.0])
    @test !SciMLBase.isinplace(sccprob2)
    @test sccprob2 isa SCCNonlinearProblem{SVector{3, Float64}}
    @test state_values(sccprob2) isa SVector{3, Float64}
end

using ModelingToolkit, OrdinaryDiffEq, SymbolicIndexingInterface, Test
using ModelingToolkit: t_nounits as t, D_nounits as D

# DifferentiationInterface with version-dependent backends
using DifferentiationInterface
using ADTypes
using ForwardDiff: ForwardDiff
using Mooncake: Mooncake
if VERSION < v"1.12"
    using Zygote: Zygote
    using Enzyme: Enzyme
end

# Define available reverse-mode backends based on Julia version
# Note: Mooncake does not support SymbolicIndexingInterface AD yet
# See: https://github.com/SciML/SciMLBase.jl/issues/1207
const ZYGOTE_BACKENDS = VERSION < v"1.12" ? [AutoZygote()] : []
const MOONCAKE_BACKENDS = [AutoMooncake()]

function backend_name(backend::ADTypes.AbstractADType)
    return string(typeof(backend).name.name)
end

@parameters σ ρ β
@variables x(t) y(t) z(t)

eqs = [
    D(x) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
]

@named lorenz1 = System(eqs, t)
@named lorenz2 = System(eqs, t)

@parameters γ
@variables a(t) α(t)
connections = [
    0 ~ lorenz1.x + lorenz2.y + a * γ,
    α ~ 2lorenz1.x + a * γ,
]
@mtkcompile sys = System(connections, t, [a, α], [γ], systems = [lorenz1, lorenz2])

u0 = [
    lorenz1.x => 1.0,
    lorenz1.y => 0.0,
    lorenz1.z => 0.0,
    lorenz2.x => 0.0,
    lorenz2.y => 1.0,
    lorenz2.z => 0.0,
]

p = [
    lorenz1.σ => 10.0,
    lorenz1.ρ => 28.0,
    lorenz1.β => 8 / 3,
    lorenz2.σ => 10.0,
    lorenz2.ρ => 28.0,
    lorenz2.β => 8 / 3,
    γ => 2.0,
]

tspan = (0.0, 100.0)
prob = ODEProblem(sys, [u0; p], tspan)
sol = solve(prob, Rodas4())

@testset "Symbolic indexing gradients" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            gs_sym = DifferentiationInterface.gradient(
                sol -> sum(sol[lorenz1.x]), backend, sol
            )
            idx_sym = SymbolicIndexingInterface.variable_index(sys, lorenz1.x)
            true_grad_sym = zeros(length(ModelingToolkit.unknowns(sys)))
            true_grad_sym[idx_sym] = 1.0

            @test all(map(x -> x == true_grad_sym, gs_sym))
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    # https://github.com/SciML/SciMLBase.jl/issues/1207
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                gs_sym = DifferentiationInterface.gradient(
                    sol -> sum(sol[lorenz1.x]), backend, sol
                )
                idx_sym = SymbolicIndexingInterface.variable_index(sys, lorenz1.x)
                true_grad_sym = zeros(length(ModelingToolkit.unknowns(sys)))
                true_grad_sym[idx_sym] = 1.0
                all(map(x -> x == true_grad_sym, gs_sym))
            end
        end
    end
end

@testset "Vector symbolic indexing gradients" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            gs_vec = DifferentiationInterface.gradient(
                sol -> sum(sum.(sol[[lorenz1.x, lorenz2.x]])), backend, sol
            )
            idx_vecsym = SymbolicIndexingInterface.variable_index.(
                Ref(sys), [lorenz1.x, lorenz2.x]
            )
            true_grad_vecsym = zeros(length(ModelingToolkit.unknowns(sys)))
            true_grad_vecsym[idx_vecsym] .= 1.0

            @test all(map(x -> x == true_grad_vecsym, gs_vec.u))
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                gs_vec = DifferentiationInterface.gradient(
                    sol -> sum(sum.(sol[[lorenz1.x, lorenz2.x]])), backend, sol
                )
                idx_vecsym = SymbolicIndexingInterface.variable_index.(
                    Ref(sys), [lorenz1.x, lorenz2.x]
                )
                true_grad_vecsym = zeros(length(ModelingToolkit.unknowns(sys)))
                true_grad_vecsym[idx_vecsym] .= 1.0
                all(map(x -> x == true_grad_vecsym, gs_vec.u))
            end
        end
    end
end

@testset "Tuple symbolic indexing gradients" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            gs_tup = DifferentiationInterface.gradient(
                sol -> sum(sum.(collect.(sol[(lorenz1.x, lorenz2.x)]))), backend, sol
            )
            idx_tupsym = SymbolicIndexingInterface.variable_index.(
                Ref(sys), [lorenz1.x, lorenz2.x]
            )
            true_grad_tupsym = zeros(length(ModelingToolkit.unknowns(sys)))
            true_grad_tupsym[idx_tupsym] .= 1.0

            @test all(map(x -> x == true_grad_tupsym, gs_tup.u))
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                gs_tup = DifferentiationInterface.gradient(
                    sol -> sum(sum.(collect.(sol[(lorenz1.x, lorenz2.x)]))), backend, sol
                )
                idx_tupsym = SymbolicIndexingInterface.variable_index.(
                    Ref(sys), [lorenz1.x, lorenz2.x]
                )
                true_grad_tupsym = zeros(length(ModelingToolkit.unknowns(sys)))
                true_grad_tupsym[idx_tupsym] .= 1.0
                all(map(x -> x == true_grad_tupsym, gs_tup.u))
            end
        end
    end
end

@testset "Time series symbolic indexing gradients" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            gs_ts = DifferentiationInterface.gradient(
                sol -> sum(sum.(sol[[lorenz1.x, lorenz2.x], :])), backend, sol
            )
            idx_vecsym = SymbolicIndexingInterface.variable_index.(
                Ref(sys), [lorenz1.x, lorenz2.x]
            )
            true_grad_vecsym = zeros(length(ModelingToolkit.unknowns(sys)))
            true_grad_vecsym[idx_vecsym] .= 1.0

            @test all(map(x -> x == true_grad_vecsym, gs_ts.u))
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                gs_ts = DifferentiationInterface.gradient(
                    sol -> sum(sum.(sol[[lorenz1.x, lorenz2.x], :])), backend, sol
                )
                idx_vecsym = SymbolicIndexingInterface.variable_index.(
                    Ref(sys), [lorenz1.x, lorenz2.x]
                )
                true_grad_vecsym = zeros(length(ModelingToolkit.unknowns(sys)))
                true_grad_vecsym[idx_vecsym] .= 1.0
                all(map(x -> x == true_grad_vecsym, gs_ts.u))
            end
        end
    end
end

# BatchedInterface AD
@variables x(t) = 1.0 y(t) = 1.0 z(t) = 1.0 w(t) = 1.0
@named sys1 = System([D(x) ~ x + y, D(y) ~ y * z, D(z) ~ z * t * x], t)
sys1 = complete(sys1)
prob1 = ODEProblem(sys1, [], (0.0, 10.0))
@named sys2 = System([D(x) ~ x + w, D(y) ~ w * t, D(w) ~ x + y + w], t)
sys2 = complete(sys2)
prob2 = ODEProblem(sys2, [], (0.0, 10.0))

bi = BatchedInterface((sys1, [x, y, z]), (sys2, [x, y, w]))
getter = getsym(bi)

@testset "BatchedInterface AD" begin
    for backend in ZYGOTE_BACKENDS
        @testset "$(backend_name(backend))" begin
            # Compute gradient with respect to prob1
            p1grad = DifferentiationInterface.gradient(
                prob1 -> sum(getter(prob1, prob2)), backend, prob1
            )
            # Compute gradient with respect to prob2
            p2grad = DifferentiationInterface.gradient(
                prob2 -> sum(getter(prob1, prob2)), backend, prob2
            )

            @test p1grad.u0 ≈ ones(3)
            testp2grad = zeros(3)
            testp2grad[variable_index(prob2, w)] = 1.0
            @test p2grad.u0 ≈ testp2grad
        end
    end
    # Mooncake does not support SymbolicIndexingInterface AD yet
    for backend in MOONCAKE_BACKENDS
        @testset "$(backend_name(backend)) (broken)" begin
            @test_broken begin
                p1grad = DifferentiationInterface.gradient(
                    prob1 -> sum(getter(prob1, prob2)), backend, prob1
                )
                p2grad = DifferentiationInterface.gradient(
                    prob2 -> sum(getter(prob1, prob2)), backend, prob2
                )
                p1grad.u0 ≈ ones(3)
            end
        end
    end
end

using Sundials
function lorenz!(du, u, p, t)
    du[1] = 10.0(u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz!, u0, tspan)

sol = solve(prob, CVODE_Adams())
sol(90:1:100, idxs = 1).u isa Array{Float64}

using SciMLBase, PartialFunctions, Test

partial_add = @$ +(_, _)
partial_add2 = @$ +(_, 2)
partial_add3 = @$ +(3, _)

@test only(SciMLBase.numargs(partial_add)) == 2
@test only(SciMLBase.numargs(partial_add2)) == 1
@test only(SciMLBase.numargs(partial_add3)) == 1

f1(args...) = args

@test only(SciMLBase.numargs(@$ f1(_, _, _))) == 3
@test only(SciMLBase.numargs(@$ f1(_, _, _, _, 4))) == 4
@test only(SciMLBase.numargs(@$ f1(_, _, _, _, _))) == 5

using BoundaryValueDiffEq, Random

function ode!(du, u, p, t)
    du[1] = u[2]
    return du[2] = -p[1] * u[1]
end

function bc!(residual, u, p, t)
    residual[1] = u[1][1] - 1.0
    return residual[2] = u[end][1]
end

function prob_func(prob, i, repeat)
    return remake(prob, p = [rand()])
end

initial_guess = [0.0, 1.0]
tspan = (0.0, pi / 2)
p = [rand()]
bvp = BVProblem(ode!, bc!, initial_guess, tspan, p)
ensemble_prob = EnsembleProblem(bvp, prob_func = prob_func)
sim = solve(ensemble_prob, MIRK4(), trajectories = 10, dt = 0.1)

"""
$(TYPEDEF)

Stores the optimization run's statistics that is returned
in the `stats` field of the `OptimizationResult`.

## Fields

  - `iterations`: number of iterations
  - `time`: time taken to run the solver
  - `fevals`: number of function evaluations
  - `gevals`: number of gradient evaluations
  - `hevals`: number of hessian evaluations

Default values for all the field are set to 0 and hence even when
you might expect non-zero values due to unavilability of the information
from the solver it would be 0.
"""
struct OptimizationStats
    iterations::Int
    time::Float64
    fevals::Int
    gevals::Int
    hevals::Int
end

function OptimizationStats(; iterations = 0, time = 0.0, fevals = 0, gevals = 0, hevals = 0)
    return OptimizationStats(iterations, time, fevals, gevals, hevals)
end

function Base.show(io::IO, ::MIME"text/plain", s::OptimizationStats)
    println(io, summary(s))
    @printf io "%-50s %-d\n" "Number of iterations:" s.iterations
    @printf io "%-50s %-f\n" "Time in seconds:" s.time
    @printf io "%-50s %-d\n" "Number of function evaluations:" s.fevals
    @printf io "%-50s %-d\n" "Number of gradient evaluations:" s.gevals
    return @printf io "%-50s %-d" "Number of hessian evaluations:" s.hevals
end

function Base.merge(s1::OptimizationStats, s2::OptimizationStats)
    return OptimizationStats(
        s1.iterations + s2.iterations, s1.time + s2.time, s1.fevals + s2.fevals,
        s1.gevals + s2.gevals, s1.hevals + s2.hevals
    )
end

"""
$(TYPEDEF)

Representation of the solution to a non-linear optimization defined by an OptimizationProblem.

## Fields

  - `u`: the representation of the optimization's solution.
  - `alg`: the algorithm type used by the solver.
  - `objective`: Objective value of the solution
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully or whether it exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
  - `original`: if the solver is wrapped from a external solver, e.g.
    Optim.jl, then this is the original return from said solver library.
  - `stats`: statistics of the solver, such as the number of function evaluations required.

## Internal Fields

  - `cache::AbstractOptimizationCache`: the optimization cache that was solved.

## Interface

`OptimizationSolution` is a `SciMLBase.AbstractNoTimeSolution`. For more information on the SciML
solution interfaces, check out the
[SciML Solution Interface documentation page](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/)
"""
struct OptimizationSolution{T, N, uType, C <: AbstractOptimizationCache, A, OV, O, ST} <:
    AbstractOptimizationSolution{T, N}
    u::uType # minimizer
    cache::C # optimization cache
    alg::A # algorithm
    objective::OV
    retcode::ReturnCode.T
    original::O # original output of the optimizer
    stats::ST
end

function build_solution(
        cache::AbstractOptimizationCache,
        alg, u, objective;
        retcode = ReturnCode.Default,
        original = nothing,
        stats = nothing,
        kwargs...
    )
    T = eltype(eltype(u))
    N = ndims(u)

    #Backwords compatibility, remove ASAP
    retcode = symbol_to_ReturnCode(retcode)

    return OptimizationSolution{
        T, N, typeof(u), typeof(cache), typeof(alg),
        typeof(objective), typeof(original), typeof(stats),
    }(
        u, cache,
        alg, objective, retcode, original, stats
    )
end

"""
$(TYPEDEF)

Representation the default cache for an optimization problem defined by an `OptimizationProblem`.
"""
mutable struct DefaultOptimizationCache{F <: OptimizationFunction, P} <:
    AbstractOptimizationCache
    f::F
    p::P
end

# for compatibility
function build_solution(
        prob::AbstractOptimizationProblem,
        alg, u, objective;
        retcode = ReturnCode.Default,
        original = nothing,
        kwargs...
    )
    T = eltype(eltype(u))
    N = ndims(u)

    Base.depwarn(
        "`build_solution(prob::AbstractOptimizationProblem, args...; kwargs...)` is deprecated." *
            " Consider implementing an `AbstractOptimizationCache` instead.",
        "build_solution(prob::AbstractOptimizationProblem, args...; kwargs...)"
    )

    cache = DefaultOptimizationCache(prob.f, prob.p)

    #Backwords compatibility, remove ASAP
    retcode = symbol_to_ReturnCode(retcode)

    return OptimizationSolution{
        T, N, typeof(u), typeof(cache), typeof(alg),
        typeof(objective), typeof(original),
    }(
        u, cache, alg, objective,
        retcode,
        original
    )
end

function Base.getproperty(cache::SciMLBase.AbstractOptimizationCache, x::Symbol)
    if x in (:u0, :p) && has_reinit(cache)
        return getfield(cache.reinit_cache, x)
    end
    return getfield(cache, x)
end

function has_reinit(cache::SciMLBase.AbstractOptimizationCache)
    return hasfield(typeof(cache), :reinit_cache)
end
function reinit!(
        cache::SciMLBase.AbstractOptimizationCache; p = missing,
        u0 = missing, interpret_symbolicmap = true
    )
    if p === missing && u0 === missing
        p, u0 = cache.p, cache.u0
    else # at least one of them has a value
        if p === missing
            p = cache.p
        end
        if u0 === missing
            u0 = cache.u0
        end
        isu0symbolic = eltype(u0) <: Pair && !isempty(u0)
        ispsymbolic = eltype(p) <: Pair && !isempty(p) && interpret_symbolicmap
        if isu0symbolic && !has_sys(cache.f)
            throw(
                ArgumentError(
                    "This cache does not support symbolic maps with" *
                        " remake, i.e. it does not have a symbolic origin. Please use `remke`" *
                        "with the `u0` keyword argument as a vector of values, paying attention to" *
                        "parameter order."
                )
            )
        end
        if ispsymbolic && !has_sys(cache.f)
            throw(
                ArgumentError(
                    "This cache does not support symbolic maps with " *
                        "`remake`, i.e. it does not have a symbolic origin. Please use `remake`" *
                        "with the `p` keyword argument as a vector of values (paying attention to" *
                        "parameter order) or pass `interpret_symbolicmap = false` as a keyword argument"
                )
            )
        end
        if isu0symbolic && ispsymbolic
            p, u0 = process_p_u0_symbolic(cache, p, u0)
        elseif isu0symbolic
            _, u0 = process_p_u0_symbolic(cache, cache.p, u0)
        elseif ispsymbolic
            p, _ = process_p_u0_symbolic(cache, p, cache.u0)
        end
    end

    cache.reinit_cache.p = p
    cache.reinit_cache.u0 = u0

    return cache
end

function SymbolicIndexingInterface.parameter_values(x::AbstractOptimizationCache)
    return if has_reinit(x)
        x.reinit_cache.p
    else
        x.p
    end
end
SymbolicIndexingInterface.symbolic_container(x::AbstractOptimizationCache) = x.f

get_p(sol::OptimizationSolution) = sol.cache.p
get_observed(sol::OptimizationSolution) = sol.cache.f.observed
get_syms(sol::OptimizationSolution) = variable_symbols(sol.cache.f)
get_paramsyms(sol::OptimizationSolution) = parameter_symbols(sol.cache.f)
has_observed(sol::OptimizationSolution) = get_observed(sol) !== nothing
has_syms(sol::OptimizationSolution) = !isempty(variable_symbols(sol.cache.f))
has_paramsyms(sol::OptimizationSolution) = !isempty(parameter_symbols(sol.cache.f))

function Base.show(io::IO, A::AbstractOptimizationSolution)
    println(io, string("retcode: ", A.retcode))
    print(io, "u: ")
    show(io, A.u)
    println(io)
    print(io, "Final objective value:     $(A.objective)\n")
    return
end

function SymbolicIndexingInterface.parameter_values(x::AbstractOptimizationSolution)
    return parameter_values(x.cache)
end
SymbolicIndexingInterface.symbolic_container(x::AbstractOptimizationSolution) = x.cache

Base.@propagate_inbounds function Base.getproperty(
        x::AbstractOptimizationSolution,
        s::Symbol
    )
    if s === :minimizer
        Base.depwarn(
            "`sol.minimizer` is deprecated. Use `sol.u` instead.",
            "sol.minimizer"
        )
        return getfield(x, :u)
    elseif s === :x
        return getfield(x, :u)
    elseif s === :minimum
        Base.depwarn(
            "`sol.minimum` is deprecated. Use `sol.objective` instead.",
            "sol.minimum"
        )
        return getfield(x, :objective)
    elseif s === :prob
        Base.depwarn(
            "`sol.prob` is deprecated. Use getters like `get_p` or `get_syms` on `sol` instead.",
            "sol.prob"
        )
        return getfield(x, :cache)
    elseif s === :ps
        return ParameterIndexingProxy(x)
    end
    return getfield(x, s)
end

function Base.summary(io::IO, A::AbstractOptimizationSolution)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(A)),
        no_color, " with uType ",
        type_color, eltype(A.u),
        no_color
    )
end

"""
    is_diagonal_noise(prob::AbstractSciMLProblem)
"""
is_diagonal_noise(prob::AbstractSciMLProblem) = false
function is_diagonal_noise(
        prob::AbstractRODEProblem{
            uType,
            tType,
            iip,
            Nothing,
        }
    ) where {
        uType,
        tType,
        iip,
    }
    return true
end
function is_diagonal_noise(
        prob::AbstractSDDEProblem{
            uType,
            tType,
            lType,
            iip,
            Nothing,
        }
    ) where {
        uType,
        tType,
        lType,
        iip,
    }
    return true
end

"""
    isinplace(prob::AbstractSciMLProblem)

Determine whether the function of the given problem operates in place or not.
"""
function isinplace(prob::AbstractSciMLProblem) end
isinplace(prob::AbstractLinearProblem{bType, iip}) where {bType, iip} = iip
isinplace(prob::AbstractNonlinearProblem{uType, iip}) where {uType, iip} = iip
isinplace(prob::AbstractIntegralProblem{iip}) where {iip} = iip
isinplace(prob::AbstractODEProblem{uType, tType, iip}) where {uType, tType, iip} = iip
function isinplace(
        prob::AbstractRODEProblem{
            uType,
            tType,
            iip,
            ND,
        }
    ) where {
        uType, tType,
        iip, ND,
    }
    return iip
end
function isinplace(
        prob::AbstractDDEProblem{
            uType,
            tType,
            lType,
            iip,
        }
    ) where {
        uType, tType,
        lType, iip,
    }
    return iip
end
function isinplace(
        prob::AbstractDAEProblem{
            uType,
            duType,
            tType,
            iip,
        }
    ) where {
        uType,
        duType,
        tType, iip,
    }
    return iip
end
isinplace(prob::AbstractNoiseProblem) = isinplace(prob.noise)
isinplace(::SplitFunction{iip}) where {iip} = iip
function isinplace(
        prob::AbstractSDDEProblem{
            uType,
            tType,
            lType,
            iip,
            ND,
        }
    ) where {
        uType,
        tType,
        lType,
        iip, ND,
    }
    return iip
end

module SciMLBaseEnzymeExt

using SciMLBase: AbstractSensitivityAlgorithm
import Enzyme: EnzymeRules

# Enzyme rules for SciMLBase abstract types
#
# Sensitivity algorithms define HOW to compute derivatives, not WHAT to differentiate.
# They should be treated as inactive (constant) during Enzyme differentiation to prevent
# errors when they are stored in problem structures that Enzyme differentiates through.
#
# This fixes issues like SciMLSensitivity.jl#1225 where passing `sensealg` to ODEProblem
# constructor would fail with Enzyme.

# All sensitivity algorithm types should be inactive for Enzyme differentiation
EnzymeRules.inactive_type(::Type{<:AbstractSensitivityAlgorithm}) = true

end

using OrdinaryDiffEq
using Test

f(u, p, t) = 1.01 * u
u0 = 1 / 2
tspan = (0.0, 1.0)
prob = ODEProblem(f, u0, tspan)
function prob_func(prob, i, repeat)
    return remake(prob, u0 = rand() * prob.u0)
end
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim = solve(ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 10)
@test sim.stats.nf == mapreduce(x -> x.stats.nf, +, sim.u)

module SciMLBaseZygoteExt

using Zygote
using Zygote: @adjoint, pullback
import Zygote: literal_getproperty
import ChainRulesCore
using SciMLBase
using SciMLBase: ODESolution, remake, ODEFunction,
    getobserved, build_solution, EnsembleSolution,
    NonlinearSolution, AbstractTimeseriesSolution
using SymbolicIndexingInterface: symbolic_type, NotSymbolic, variable_index, is_observed,
    observed, parameter_values, state_values, current_time
using RecursiveArrayTools
import SciMLStructures

@adjoint function SciMLBase.remake(prob::ODEFunction; kw...)
    y = remake(prob; kw...)
    function odefunction_remake_back(Δ)
        (Δ,)
    end
    y, odefunction_remake_back
end

# This method resolves the ambiguity with the pullback defined in
# RecursiveArrayToolsZygoteExt
# https://github.com/SciML/RecursiveArrayTools.jl/blob/d06ecb856f43bc5e37cbaf50e5f63c578bf3f1bd/ext/RecursiveArrayToolsZygoteExt.jl#L67
@adjoint function Base.getindex(VA::ODESolution, i::Int, j::Int)
    function ODESolution_getindex_pullback(Δ)
        du = [
            m == j ? [i == k ? Δ : zero(VA.u[1][1]) for k in 1:length(VA.u[1])] :
                zero(VA.u[1]) for m in 1:length(VA.u)
        ]
        dp = zero(VA.prob.p)
        dprob = remake(VA.prob, p = dp)
        du, dprob
        T = eltype(eltype(VA.u))
        if dprob.u0 === nothing
            N = 2
        elseif dprob isa SciMLBase.BVProblem && !hasmethod(size, Tuple{typeof(dprob.u0)})
            __u0 = hasmethod(dprob.u0, Tuple{typeof(dprob.p), typeof(first(dprob.tspan))}) ?
                dprob.u0(dprob.p, first(dprob.tspan)) : dprob.u0(first(dprob.tspan))
            N = length((size(__u0)..., length(du)))
        else
            N = length((size(dprob.u0)..., length(du)))
        end
        Δ′ = ODESolution{T, N}(
            du, nothing, nothing,
            VA.t, VA.k, VA.discretes, dprob, VA.alg, VA.interp, VA.dense, 0, VA.stats,
            VA.alg_choice, VA.retcode
        )
        (Δ′, nothing, nothing)
    end
    VA[i, j], ODESolution_getindex_pullback
end

@adjoint function Base.getindex(VA::ODESolution, sym, j::Integer)
    res, pullback = ChainRulesCore.rrule(Zygote.ZygoteRuleConfig(), getindex, VA, sym, j)
    return res, Base.tail ∘ pullback
end

@adjoint function EnsembleSolution(sim, time, converged, stats)
    out = EnsembleSolution(sim, time, converged, stats)
    function EnsembleSolution_adjoint(p̄::AbstractArray{T, N}) where {T, N}
        arrarr = [
            [
                    p̄[ntuple(x -> Colon(), Val(N - 2))..., j, i]
                    for j in 1:size(p̄)[end - 1]
                ] for i in 1:size(p̄)[end]
        ]
        (EnsembleSolution(arrarr, 0.0, true, stats), nothing, nothing, nothing)
    end
    function EnsembleSolution_adjoint(p̄::AbstractArray{<:AbstractArray, 1})
        (EnsembleSolution(p̄, 0.0, true, stats), nothing, nothing, nothing)
    end
    function EnsembleSolution_adjoint(p̄::RecursiveArrayTools.AbstractVectorOfArray)
        (EnsembleSolution(p̄, 0.0, true, stats), nothing, nothing, nothing)
    end
    function EnsembleSolution_adjoint(p̄::EnsembleSolution)
        (p̄, nothing, nothing, nothing)
    end
    function EnsembleSolution_adjoint(p̄::NamedTuple)
        (p̄.u, nothing, nothing, nothing)
    end
    out, EnsembleSolution_adjoint
end

@adjoint function Base.getindex(VA::ODESolution, i::Int)
    function ODESolution_getindex_pullback(Δ)
        Δ′ = [
            (i == j ? Δ : Zygote.FillArrays.Fill(zero(eltype(x)), size(x)))
                for (x, j) in zip(VA.u, 1:length(VA))
        ]
        (Δ′, nothing)
    end
    VA[:, i], ODESolution_getindex_pullback
end

@adjoint function Base.getindex(VA::ODESolution, sym)
    function ODESolution_getindex_pullback(Δ)
        i = symbolic_type(sym) != NotSymbolic() ? variable_index(VA, sym) : sym
        if is_observed(VA, sym)
            f = observed(VA, sym)
            p = parameter_values(VA)
            u = state_values(VA)
            t = current_time(VA)
            y, back = Zygote.pullback(u, p) do u, p
                f.(u, Ref(p), t)
            end
            gs = back(Δ)
            (u = gs[1], prob = (p = gs[2],)), nothing
        elseif i === nothing
            throw(error("Zygote AD of purely-symbolic slicing for observed quantities is not yet supported. Work around this by using `A[sym,i]` to access each element sequentially in the function being differentiated."))
        else
            VA = recursivecopy(VA)
            recursivefill!(VA, zero(eltype(VA)))
            v = view(VA, i, ntuple(_ -> :, ndims(VA) - 1)...)
            copyto!(v, Δ)
            (VA, nothing)
        end
    end
    VA[sym], ODESolution_getindex_pullback
end

function obs_grads(VA, sym, obs_idx, Δ)
    y, back = Zygote.pullback(VA) do sol
        getindex.(Ref(sol), sym[obs_idx])
    end
    Δreduced = reduce(hcat, Δ)
    Δobs = eachrow(Δreduced[obs_idx, :])
    return back(Δobs)
end

function obs_grads2(VA::SciMLBase.NonlinearSolution, sym, obs_idx, Δ)
    y, back = Zygote.pullback(VA) do sol
        getindex.(Ref(sol), sym[obs_idx])
    end
    Δobs = Δ[obs_idx, :]
    return back(Δobs)
end

function obs_grads(VA, sym, ::Nothing, Δ)
    return Zygote.nt_nothing(VA)
end

function not_obs_grads(VA::ODESolution{T}, sym, not_obss_idx, i, Δ) where {T}
    Δ′ = map(enumerate(VA.u)) do (t_idx, us)
        map(enumerate(us)) do (u_idx, u)
            if u_idx in i
                idx = findfirst(isequal(u_idx), i)
                Δ[t_idx][idx]
            else
                zero(T)
            end
        end
    end

    return Δ′
end

@adjoint function Base.getindex(
        VA::ODESolution{T}, sym::Union{Tuple, AbstractVector}
    ) where {T}
    function ODESolution_getindex_pullback(Δ)
        sym = sym isa Tuple ? collect(sym) : sym
        i = map(x -> symbolic_type(x) != NotSymbolic() ? variable_index(VA, x) : x, sym)

        obs_idx = findall(s -> is_observed(VA, s), sym)
        not_obs_idx = setdiff(1:length(sym), obs_idx)

        gs_obs = obs_grads(VA, sym, isempty(obs_idx) ? nothing : obs_idx, Δ)
        gs_not_obs = not_obs_grads(VA, sym, not_obs_idx, i, Δ)

        a = Zygote.accum(gs_obs[1], (u = gs_not_obs,))

        (a, nothing)
    end
    VA[sym], ODESolution_getindex_pullback
end

@adjoint function Base.getindex(VA::SciMLBase.AbstractNonlinearSolution, sym)
    function NonlinearSolution_getindex_pullback(Δ)
        i = symbolic_type(sym) != NotSymbolic() ? variable_index(VA, sym) : sym
        if is_observed(VA, sym)
            f = observed(VA, sym)
            p = parameter_values(VA)
            u = state_values(VA)
            _, back = Zygote.pullback(u, p) do u, p
                f.f_oop(u, p)
            end
            gs = back(Δ)
            ((u = gs[1], prob = (p = gs[2],)), nothing)
        elseif i === nothing
            throw(error("Zygote AD of purely-symbolic slicing for observed quantities is not yet supported. Work around this by using `A[sym,i]` to access each element sequentially in the function being differentiated."))
        elseif i isa Int && VA.u isa Number
            (Δ, nothing)
        else
            VA = recursivecopy(VA)
            recursivefill!(VA, zero(eltype(VA)))
            v = view(VA, i, ntuple(_ -> :, ndims(VA) - 1)...)
            copyto!(v, Δ)
            (VA, nothing)
        end
    end
    VA[sym], NonlinearSolution_getindex_pullback
end

@adjoint function ODESolution{
        T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15,
    }(
        u,
        args...
    ) where {
        T1, T2, T3, T4, T5, T6, T7, T8,
        T9, T10, T11, T12, T13, T14, T15,
    }
    function ODESolutionAdjoint(ȳ)
        (ȳ, ntuple(_ -> nothing, length(args))...)
    end

    ODESolution{T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15}(
            u, args...
        ),
        ODESolutionAdjoint
end

@adjoint function SDEProblem{uType, tType, isinplace, P, NP, F, G, K, ND}(
        u,
        args...
    ) where
    {uType, tType, isinplace, P, NP, F, G, K, ND}
    function SDEProblemAdjoint(ȳ)
        (ȳ, ntuple(_ -> nothing, length(args))...)
    end

    SDEProblem{uType, tType, isinplace, P, NP, F, G, K, ND}(u, args...), SDEProblemAdjoint
end

@adjoint function NonlinearSolution{T, N, uType, R, P, A, O, uType2}(
        u,
        args...
    ) where {
        T,
        N,
        uType,
        R,
        P,
        A,
        O,
        uType2,
    }
    function NonlinearSolutionAdjoint(ȳ)
        (ȳ, ntuple(_ -> nothing, length(args))...)
    end
    NonlinearSolution{T, N, uType, R, P, A, O, uType2}(u, args...), NonlinearSolutionAdjoint
end

@adjoint function literal_getproperty(sol::SciMLBase.LinearSolution, ::Val{:u})
    function solu_adjoint(Δ)
        zerou = zero(sol.u)
        _Δ = @. ifelse(Δ === nothing, zerou, Δ)
        (SciMLBase.build_linear_solution(sol.alg, _Δ, sol.resid, sol.cache),)
    end
    sol.u, solu_adjoint
end

@adjoint function Base.getindex(sol::SciMLBase.LinearSolution, i::Integer)
    function LinearSolution_getindex_pullback(Δ)
        du = zero(sol.u)
        du[i] = Δ
        (SciMLBase.build_linear_solution(sol.alg, du, sol.resid, sol.cache), nothing)
    end
    sol[i], LinearSolution_getindex_pullback
end

@adjoint function literal_getproperty(
        sol::SciMLBase.OptimizationSolution,
        ::Val{:u}
    )
    function solu_adjoint(Δ)
        zerou = zero(sol.u)
        _Δ = @. ifelse(Δ === nothing, zerou, Δ)
        (build_solution(sol.cache, sol.alg, _Δ, sol.objective),)
    end
    sol.u, solu_adjoint
end

function ∇tmap(cx, f, args...)
    ys_and_backs = SciMLBase.tmap((args...) -> Zygote._pullback(cx, f, args...), args...)
    return if isempty(ys_and_backs)
        ys_and_backs, _ -> (NoTangent(), NoTangent())
    else
        ys, backs = Zygote.unzip(ys_and_backs)
        function ∇tmap_internal(Δ)
            Δf_and_args_zipped = SciMLBase.tmap((f, δ) -> f(δ), backs, Δ)
            Δf_and_args = Zygote.unzip(Δf_and_args_zipped)
            Δf = reduce(Zygote.accum, Δf_and_args[1])
            return (Δf, Δf_and_args[2:end]...)
        end
        ys, ∇tmap_internal
    end
end

function ∇responsible_map(cx, f, args...)
    ys_and_backs = SciMLBase.responsible_map(
        (args...) -> Zygote._pullback(cx, f, args...),
        args...
    )
    return if isempty(ys_and_backs)
        ys_and_backs, _ -> (NoTangent(), NoTangent())
    else
        ys, backs = Zygote.unzip(ys_and_backs)
        ys,
            function ∇responsible_map_internal(Δ)
                # Apply pullbacks in reverse order. Needed for correctness if `f` is stateful.
                Δf_and_args_zipped = SciMLBase.responsible_map(
                    (f, δ) -> f(δ),
                    Zygote._tryreverse(
                        SciMLBase.responsible_map,
                        backs, Δ
                    )...
                )
                Δf_and_args = Zygote.unzip(
                    Zygote._tryreverse(
                        SciMLBase.responsible_map,
                        Δf_and_args_zipped
                    )
                )
                Δf = reduce(Zygote.accum, Δf_and_args[1])
                return (Δf, Δf_and_args[2:end]...)
        end
    end
end

@adjoint function SciMLBase.tmap(f, args::Union{AbstractArray, Tuple}...)
    ∇tmap(__context__, f, args...)
end

@adjoint function SciMLBase.responsible_map(
        f,
        args::Union{
            AbstractArray, Tuple,
        }...
    )
    ∇responsible_map(__context__, f, args...)
end

end

@doc doc"""

Defines a random ordinary differential equation (RODE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/rode_types/>

## Mathematical Specification of a RODE Problem

To define a RODE Problem, you simply need to give the function ``f`` and the initial
condition ``u_0`` which define an ODE:

```math
\frac{du}{dt} = f(u,p,t,W(t))
```

where `W(t)` is a random process. `f` should be specified as `f(u,p,t,W)`
(or in-place as `f(du,u,p,t,W)`), and `u₀` should be an AbstractArray (or number)
whose geometry matches the desired geometry of `u`. Note that we are not limited
to numbers or vectors for `u₀`; one is allowed to provide `u₀` as arbitrary matrices
/ higher dimension tensors as well.

### Constructors

- `RODEProblem(f::RODEFunction,u0,tspan,p=NullParameters();noise=WHITE_NOISE,rand_prototype=nothing,callback=nothing)`
- `RODEProblem{isinplace,specialize}(f,u0,tspan,p=NullParameters();noise=WHITE_NOISE,rand_prototype=nothing,callback=nothing,mass_matrix=I)` :
  Defines the RODE with the specified functions. The default noise is `WHITE_NOISE`.
  `isinplace` optionally sets whether the function is inplace or not. This is
  determined automatically, but not inferred. `specialize` optionally controls
  the specialization level. See the [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
  for more details. The default is `AutoSpecialize`.

For more details on the in-place and specialization controls, see the ODEFunction documentation.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the
[DiffEqFunctions](@ref performance_overloads)
page.

### Fields

* `f`: The drift function in the SDE.
* `u0`: The initial condition.
* `tspan`: The timespan for the problem.
* `p`: The optional parameters for the problem. Defaults to `NullParameters`.
* `noise`: The noise process applied to the noise upon generation. Defaults to
  Gaussian white noise. For information on defining different noise processes,
  see [the noise process documentation page](@ref noise_process)
* `rand_prototype`: A prototype type instance for the noise vector. It defaults
  to `nothing`, which means the problem should be interpreted as having a noise
  vector whose size matches `u0`.
* `kwargs`: The keyword arguments passed onto the solves.
"""
mutable struct RODEProblem{uType, tType, isinplace, P, NP, F, K, ND} <:
    AbstractRODEProblem{uType, tType, isinplace, ND}
    f::F
    u0::uType
    tspan::tType
    p::P
    noise::NP
    kwargs::K
    rand_prototype::ND
    seed::UInt64
    @add_kwonly function RODEProblem{iip}(
            f::RODEFunction{iip}, u0, tspan,
            p = NullParameters();
            rand_prototype = nothing,
            noise = nothing, seed = UInt64(0),
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan),
            isinplace(f), typeof(p),
            typeof(noise), typeof(f), typeof(kwargs),
            typeof(rand_prototype),
        }(
            f, _u0, _tspan, p, noise, kwargs,
            rand_prototype, seed
        )
    end
    function RODEProblem{iip}(f, u0, tspan, p = NullParameters(); kwargs...) where {iip}
        return RODEProblem(RODEFunction{iip}(f), u0, tspan, p; kwargs...)
    end
end

function RODEProblem(f::RODEFunction, u0, tspan, p = NullParameters(); kwargs...)
    return RODEProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end

function RODEProblem(f, u0, tspan, p = NullParameters(); kwargs...)
    return RODEProblem(RODEFunction(f), u0, tspan, p; kwargs...)
end

@doc doc"""
    RODEAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = false, alias_du0 = false, alias_tstops = false, alias = nothing)

Holds information on what variables to alias
when solving an RODEProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false .
* `alias_du0::Union{Bool, Nothing}`: alias the du0 array for DAEs. Defaults to false.
* `alias_tstops::Union{Bool, Nothing}`: alias the tstops array
* `alias_noise::Union{Bool,Nothing}`: alias the noise process
* `alias_jumps::Union{Bool, Nothing}`: alias jump process if wrapped in a JumpProcess
* `alias::Union{Bool, Nothing}`: sets all fields of the `RODEAliasSpecifier` to `alias`

"""
struct RODEAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_du0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}
    alias_noise::Union{Bool, Nothing}
    alias_jumps::Union{Bool, Nothing}

    function RODEAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias_noise = nothing,
            alias_jumps = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false, false, false)
        elseif isnothing(alias)
            new(
                alias_p, alias_f, alias_u0, alias_du0,
                alias_tstops, alias_noise, alias_jumps
            )
        end
    end
end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "Home" => "index.md",
    "Interfaces" => Any[
        "interfaces/Array_and_Number.md",
        "interfaces/Problems.md",
        "interfaces/SciMLFunctions.md",
        "interfaces/Algorithms.md",
        "interfaces/Solutions.md",
        "interfaces/Init_Solve.md",
        "interfaces/Ensembles.md",
        "interfaces/Common_Keywords.md",
        "interfaces/Differentiation.md",
        "interfaces/PDE.md",
    ],
    "Fundamentals" => Any["fundamentals/FAQ.md"],
]

using DifferentialEquations, PythonCall, CondaPkg

CondaPkg.add_pip("diffeqpy")

@testset "Use of DifferentialEquations through PythonCall with user code written in Python" begin
    pyexec(
        """
        from juliacall import Main
        Main.seval("using DifferentialEquations")
        de = Main.seval("DifferentialEquations")

        def f(u,p,t):
            return -u

        u0 = 0.5
        tspan = (0., 1.)
        prob = de.ODEProblem(f, u0, tspan)
        sol = de.solve(prob)
        """, @__MODULE__
    )
    @test pyconvert(Any, pyeval("sol", @__MODULE__)) isa ODESolution

    pyexec(
        """
        def f(u,p,t):
            x, y, z = u
            sigma, rho, beta = p
            return [sigma * (y - x), x * (rho - z) - y, x * y - beta * z]

        u0 = [1.0,0.0,0.0]
        tspan = (0., 100.)
        p = [10.0,28.0,8/3]
        prob = de.ODEProblem(f, u0, tspan, p)
        sol = de.solve(prob,saveat=0.01)
        """, @__MODULE__
    )
    @test pyconvert(Any, pyeval("sol", @__MODULE__)) isa ODESolution

    # Test that the types and shapes of sol.t and de.transpose(de.stack(sol.u)) are
    # compatible with matplotlib, but don't actually plot anything.
    pyexec(
        """
        u2 = de.transpose(de.stack(sol.u))
        ok = sol.t.shape == (10001,) and \
        u2.shape == (10001, 3) and \
        sol.t[0] == 0 and \
        sol.t[-1] == 100 and \
        type(u2[4123, 2]) == float
        """, @__MODULE__
    )
    @test pyconvert(Any, pyeval("ok", @__MODULE__))

    @pyexec """
    jul_f = Main.seval(""\"
    function f(du,u,p,t)
        x, y, z = u
        sigma, rho, beta = p
        du[1] = sigma * (y - x)
        du[2] = x * (rho - z) - y
        du[3] = x * y - beta * z
    end""\")
    u0 = [1.0,0.0,0.0]
    tspan = (0., 100.)
    p = [10.0,28.0,2.66]
    prob = de.ODEProblem(jul_f, u0, tspan, p)
    sol = de.solve(prob)
    """
    @test pyconvert(Any, pyeval("sol", @__MODULE__)) isa ODESolution

    pyexec(
        """
        def f(u,p,t):
            return 1.01*u

        def g(u,p,t):
            return 0.87*u

        u0 = 0.5
        tspan = (0.0,1.0)
        prob = de.SDEProblem(f,g,u0,tspan)
        sol = de.solve(prob,reltol=1e-3,abstol=1e-3)
        """, @__MODULE__
    )

    # Issue SciML/diffeqpy#136 (conditions must be prepared)
    pyexec(
        """
        from diffeqpy import ode

        def simple_system_b(du, u, p, t):
            du[0] = -1*p[0]*u[0]

        def condition(u, t, integrator):
            return t == 0.5

        def affect_b(integrator):
            integrator.u[0] += 10

        cb = ode.DiscreteCallback(
            condition, affect_b
        )

        prob = ode.ODEProblem(simple_system_b, [1.], (0.,10.), [0.2])
        sol = ode.solve(prob, ode.Tsit5(), callback=cb, tstops=0.5)
        """, @__MODULE__
    )
end

@testset "promotion" begin
    _u0 = pyconvert(
        Any, pyeval("""de.SciMLBase.prepare_initial_state([1.0, 0, 0])""", @__MODULE__)
    )
    @test _u0 isa Vector{Float64}
end

function getsyms(sol::AbstractSciMLSolution)
    syms = variable_symbols(sol)
    if isempty(syms)
        syms = keys(sol.u[1])
    end
    return syms
end

function getsyms(prob::AbstractSciMLProblem)
    return variable_symbols(prob.f)
end

function getsyms(sol::AbstractOptimizationSolution)
    syms = variable_symbols(sol)
    if isempty(syms)
        syms = keys(sol.u[1])
    end
    return syms
end

function getindepsym(prob::AbstractSciMLProblem)
    syms = independent_variable_symbols(prob.f)
    if isempty(syms)
        return nothing
    else
        return syms[1]
    end
end

getindepsym(sol::AbstractSciMLSolution) = getindepsym(sol.prob)

function getparamsyms(prob::AbstractSciMLProblem)
    psyms = parameter_symbols(prob.f)
    if isempty(psyms)
        return nothing
    end
    return psyms
end

getparamsyms(sol) = getparamsyms(sol.prob)

function getparamsyms(sol::AbstractOptimizationSolution)
    psyms = parameter_symbols(sol)
    if isempty(psyms)
        return nothing
    end
    return psyms
end

# Only for compatibility!
function getindepsym_defaultt(sol)
    return something(getindepsym(sol), :t)
end

function getobserved(prob::AbstractSciMLProblem)
    if has_observed(prob.f)
        return prob.f.observed
    else
        return DEFAULT_OBSERVED
    end
end

getobserved(sol) = getobserved(sol.prob)

function getobserved(sol::AbstractOptimizationSolution)
    if has_observed(sol)
        return get_observed(sol)
    else
        return DEFAULT_OBSERVED
    end
end

@doc doc"""

Defines an integral problem.
Documentation Page: <https://docs.sciml.ai/Integrals/stable/>

## Mathematical Specification of an Integral Problem

Integral problems are multi-dimensional integrals defined as:

```math
\int_{lb}^{ub} f(u,p) du
```

where `p` are parameters. `u` is a `Number` or `AbstractVector`
whose geometry matches the space being integrated.
This space is bounded by the lower bound `lb` and upper bound `ub`,
which are `Number`s or `AbstractVector`s with the same geometry as `u`.

## Problem Type

### Constructors

```julia
IntegralProblem(f::AbstractIntegralFunction,domain,p=NullParameters(); kwargs...)
IntegralProblem(f::AbstractIntegralFunction,lb,ub,p=NullParameters(); kwargs...)
IntegralProblem(f,domain,p=NullParameters(); nout=nothing, batch=nothing, kwargs...)
IntegralProblem(f,lb,ub,p=NullParameters(); nout=nothing, batch=nothing, kwargs...)
```

- `f`: the integrand, callable function `y = f(u,p)` for out-of-place (default) or an
  `IntegralFunction` or `BatchIntegralFunction` for inplace and batching optimizations.
- domain: an object representing an integration domain, i.e. the tuple `(lb, ub)`.
- `lb`: DEPRECATED: Either a number or vector of lower bounds.
- `ub`: DEPRECATED: Either a number or vector of upper bounds.
- `p`: The parameters associated with the problem.
- `nout`: DEPRECATED (see `IntegralFunction`): length of the vector output of the integrand
  (by default the integrand is assumed to be scalar)
- `batch`: DEPRECATED (see `BatchIntegralFunction`): number of points the integrand can
  evaluate simultaneously (by default there is no batching)
- `kwargs`: Keyword arguments copied to the solvers.

Additionally, we can supply iip like `IntegralProblem{iip}(...)` as `true` or `false`
to declare at compile time whether the integrator function is in-place.

### Fields

The fields match the names of the constructor arguments.
"""
struct IntegralProblem{isinplace, P, F, T, K} <: AbstractIntegralProblem{isinplace}
    f::F
    domain::T
    p::P
    kwargs::K
    @add_kwonly function IntegralProblem{iip}(
            f::AbstractIntegralFunction{iip}, domain,
            p = NullParameters(); nout = nothing, batch = nothing,
            kwargs...
        ) where {iip}
        warn_paramtype(p)
        new{iip, typeof(p), typeof(f), typeof(domain), typeof(kwargs)}(
            f,
            domain, p, kwargs
        )
    end
end

function IntegralProblem(
        f::AbstractIntegralFunction,
        domain,
        p = NullParameters();
        kwargs...
    )
    return IntegralProblem{isinplace(f)}(f, domain, p; kwargs...)
end

@deprecate IntegralProblem{iip}(
    f::AbstractIntegralFunction,
    lb::Union{Number, AbstractVector{<:Number}},
    ub::Union{Number, AbstractVector{<:Number}},
    p = NullParameters(); kwargs...
) where {iip} IntegralProblem{iip}(
    f, (lb, ub), p; kwargs...
)

function IntegralProblem(f, args...; kwargs...)
    return IntegralProblem{isinplace(f, 3)}(f, args...; kwargs...)
end
function IntegralProblem{iip}(
        f, args...; nout = nothing, batch = nothing, kwargs...
    ) where {iip}
    if nout !== nothing || batch !== nothing
        @warn "`nout` and `batch` keywords are deprecated in favor of inplace `IntegralFunction`s or `BatchIntegralFunction`s. Instead of using `nout` to define sizes, the new interface requires giving an `integrand_prototype` which is a vector of the form to write to. For example, define an `IntegralFunction` where `integrand_prototype = zero(nout)` (or appropriate vector type), or for batched `integrand_prototype = zero(nout, nbatch)`. See the updated Integrals.jl documentation for details."
    end

    g = if iip
        if batch === nothing
            output_prototype = nout === nothing ? Array{Float64, 0}(undef) :
                Vector{Float64}(undef, nout)
            IntegralFunction(f, output_prototype)
        else
            output_prototype = nout === nothing ? Float64[] :
                Matrix{Float64}(undef, nout, 0)
            BatchIntegralFunction(f, output_prototype, max_batch = batch)
        end
    else
        if batch === nothing
            IntegralFunction(f)
        else
            BatchIntegralFunction(f, max_batch = batch)
        end
    end
    return IntegralProblem(g, args...; kwargs...)
end

function Base.getproperty(prob::IntegralProblem, name::Symbol)
    if name === :lb
        domain = getfield(prob, :domain)
        lb, ub = domain
        return lb
    elseif name === :ub
        domain = getfield(prob, :domain)
        lb, ub = domain
        return ub
    elseif name === :ps
        return ParameterIndexingProxy(prob)
    end
    return Base.getfield(prob, name)
end

struct QuadratureProblem end
@deprecate QuadratureProblem(args...; kwargs...) IntegralProblem(args...; kwargs...)

@doc doc"""

Defines a integral problem over pre-sampled data.
Documentation Page: <https://docs.sciml.ai/Integrals/stable/>

## Mathematical Specification of a data Integral Problem

Sampled integral problems are defined as:

```math
\sum_i w_i y_i
```
where `y_i` are sampled values of the integrand, and `w_i` are weights
assigned by a quadrature rule, which depend on sampling points `x`.

## Problem Type

### Constructors

```julia
SampledIntegralProblem(y::AbstractArray, x::AbstractVector; dim=ndims(y), kwargs...)
```
- `y`: The sampled integrand, must be a subtype of `AbstractArray`.
  It is assumed that the values of `y` along dimension `dim`
  correspond to the integrand evaluated at sampling points `x`
- `x`: Sampling points, must be a subtype of `AbstractVector`.
- `dim`: Dimension along which to integrate. Defaults to the last dimension of `y`.
- `kwargs`: Keyword arguments copied to the solvers.

### Fields

The fields match the names of the constructor arguments.
"""
struct SampledIntegralProblem{Y, X, K} <: AbstractIntegralProblem{false}
    y::Y
    x::X
    dim::Int
    kwargs::K
    @add_kwonly function SampledIntegralProblem(
            y::AbstractArray, x::AbstractVector;
            dim = ndims(y),
            kwargs...
        )
        @assert dim <= ndims(y) "The integration dimension `dim` is larger than the number of dimensions of the integrand `y`"
        @assert length(x) == size(y, dim) "The integrand `y` must have the same length as the sampling points `x` along the integrated dimension."
        @assert axes(x, 1) == axes(y, dim) "The integrand `y` must obey the same indexing as the sampling points `x` along the integrated dimension."
        new{typeof(y), typeof(x), typeof(kwargs)}(y, x, dim, kwargs)
    end
end

@doc doc"""
    IntegralAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias = nothing)

Holds information on what variables to alias
when solving an IntegralProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias::Union{Bool, Nothing}`: sets all fields of the `IntegralAliasSpecifier` to `alias`

"""
struct IntegralAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}

    function IntegralAliasSpecifier(alias_p = nothing, alias_f = nothing, alias = nothing)
        return if alias == true
            new(true, true)
        elseif alias == false
            new(false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f)
        end
    end
end

const NONCONCRETE_ELTYPE_MESSAGE = """
Non-concrete element type inside of an `Array` detected.
Arrays with non-concrete element types, such as
`Array{Union{Float32,Float64}}`, are not supported by the
differential equation solvers. Anyways, this is bad for
performance so you don't want to be doing this!

If this was a mistake, promote the element types to be
all the same. If this was intentional, for example,
using Unitful.jl with different unit values, then use
an array type which has fast broadcast support for
heterogeneous values such as the `ArrayPartition`
from RecursiveArrayTools.jl. For example:

```julia
using RecursiveArrayTools
x = ArrayPartition([1.0,2.0],[1f0,2f0])
y = ArrayPartition([3.0,4.0],[3f0,4f0])
x .+ y # fast, stable, and usable as u0 into DiffEq!
```

Element type:
"""

struct NonConcreteEltypeError <: Exception
    eltype::Any
end

function Base.showerror(io::IO, e::NonConcreteEltypeError)
    print(io, NONCONCRETE_ELTYPE_MESSAGE)
    return print(io, e.eltype)
end

# Functions used in solve dispatches

eltypedual(x) = false
promote_u0(::Nothing, p, t0) = nothing
isdualtype(::Type{T}) where {T} = false

has_kwargs(_prob::AbstractSciMLProblem) = has_kwargs(typeof(_prob))
Base.@pure __has_kwargs(::Type{T}) where {T} = :kwargs ∈ fieldnames(T)
has_kwargs(::Type{T}) where {T} = __has_kwargs(T)

@inline function extract_alg(solve_args, solve_kwargs, prob_kwargs)
    return if isempty(solve_args) || isnothing(first(solve_args))
        if haskey(solve_kwargs, :alg)
            solve_kwargs[:alg]
        elseif haskey(prob_kwargs, :alg)
            prob_kwargs[:alg]
        else
            nothing
        end
    elseif first(solve_args) isa SciMLBase.AbstractSciMLAlgorithm &&
            !(first(solve_args) isa SciMLBase.EnsembleAlgorithm)
        first(solve_args)
    else
        nothing
    end
end

handle_distribution_u0(_u0) = _u0

eval_u0(u0::Function) = true
eval_u0(u0) = false

function get_concrete_p(prob, kwargs)
    return if haskey(kwargs, :p)
        p = kwargs[:p]
    else
        p = prob.p
    end
end

function get_concrete_u0(prob::BVProblem, isadapt, t0, kwargs)
    if haskey(kwargs, :u0)
        u0 = kwargs[:u0]
    else
        u0 = prob.u0
    end

    isadapt && eltype(u0) <: Integer && (u0 = float.(u0))

    _u0 = handle_distribution_u0(u0)

    if isinplace(prob) && (_u0 isa Number || _u0 isa SArray)
        throw(IncompatibleInitialConditionError())
    end

    if _u0 isa Tuple
        throw(TupleStateError())
    end

    return _u0
end

function checkkwargs(kwargshandle; kwargs...)
    return if any(x -> x ∉ allowedkeywords, keys(kwargs))
        if kwargshandle == KeywordArgError
            throw(CommonKwargError(kwargs))
        elseif kwargshandle == KeywordArgWarn
            @warn KWARGWARN_MESSAGE
            unrecognized = setdiff(keys(kwargs), allowedkeywords)
            print("Unrecognized keyword arguments: ")
            printstyled(unrecognized; bold = true, color = :red)
            print("\n\n")
        else
            @assert kwargshandle == KeywordArgSilent
        end
    end
end

function checkkwargs(kwargshandle, allowed; kwargs...)
    return if any(x -> x ∉ allowed, keys(kwargs))
        if kwargshandle == KeywordArgError
            throw(CommonKwargError(kwargs))
        elseif kwargshandle == KeywordArgWarn
            @warn KWARGWARN_MESSAGE
            unrecognized = setdiff(keys(kwargs), allowed)
            print("Unrecognized keyword arguments: ")
            printstyled(unrecognized; bold = true, color = :red)
            print("\n\n")
        else
            @assert kwargshandle == KeywordArgSilent
        end
    end
end
"""
    $(TYPEDSIGNATURES)

Given the index provider `indp` used to construct the problem `prob` being solved, return
an updated `prob` to be used for solving. All implementations should accept arbitrary
keyword arguments.

Should be called before the problem is solved, after performing type-promotion on the
problem. If the returned problem is not `===` the provided `prob`, it is assumed to
contain the `u0` and `p` passed as keyword arguments.

# Keyword Arguments

- `u0`, `p`: Override values for `state_values(prob)` and `parameter_values(prob)` which
  should be used instead of the ones in `prob`.
"""
function get_updated_symbolic_problem(indp, prob; kw...)
    return prob
end

function isconcreteu0(prob, t0, kwargs)
    return !eval_u0(prob.u0) && prob.u0 !== nothing && !isdistribution(prob.u0)
end

function isconcretedu0(prob, t0, kwargs)
    return !eval_u0(prob.u0) && prob.du0 !== nothing && !isdistribution(prob.du0)
end

function get_concrete_u0(prob, isadapt, t0, kwargs)
    if eval_u0(prob.u0)
        u0 = prob.u0(prob.p, t0)
    elseif haskey(kwargs, :u0)
        u0 = kwargs[:u0]
    else
        u0 = prob.u0
    end

    isadapt && eltype(u0) <: Integer && (u0 = float.(u0))

    _u0 = handle_distribution_u0(u0)

    if isinplace(prob) && (_u0 isa Number || _u0 isa SArray)
        throw(IncompatibleInitialConditionError())
    end

    nu0 = length(something(_u0, ()))
    if isdefined(prob.f, :mass_matrix) && prob.f.mass_matrix !== nothing &&
            prob.f.mass_matrix isa AbstractArray &&
            size(prob.f.mass_matrix, 1) !== nu0
        throw(IncompatibleMassMatrixError(size(prob.f.mass_matrix, 1), nu0))
    end

    if _u0 isa Tuple
        throw(TupleStateError())
    end

    return _u0
end

function get_concrete_du0(prob, isadapt, t0, kwargs)
    if eval_u0(prob.du0)
        du0 = prob.du0(prob.p, t0)
    elseif haskey(kwargs, :du0)
        du0 = kwargs[:du0]
    else
        du0 = prob.du0
    end

    isadapt && eltype(du0) <: Integer && (du0 = float.(du0))

    _du0 = handle_distribution_u0(du0)

    if isinplace(prob) && (_du0 isa Number || _du0 isa SArray)
        throw(IncompatibleInitialConditionError())
    end

    return _du0
end

function promote_u0(u0, p, t0)
    if SciMLStructures.isscimlstructure(p)
        _p = SciMLStructures.canonicalize(SciMLStructures.Tunable(), p)[1]
        if !isequal(_p, p)
            return promote_u0(u0, _p, t0)
        end
    end
    Tu = eltype(u0)
    if isdualtype(Tu)
        return u0
    end
    Tp = anyeltypedual(p, Val{0})
    if Tp == Any
        Tp = Tu
    end
    Tt = anyeltypedual(t0, Val{0})
    if Tt == Any
        Tt = Tu
    end
    Tcommon = promote_type(Tu, Tp, Tt)
    return if isdualtype(Tcommon)
        Tcommon.(u0)
    else
        u0
    end
end

function promote_u0(u0::AbstractArray{<:Complex}, p, t0)
    if SciMLStructures.isscimlstructure(p)
        _p = SciMLStructures.canonicalize(SciMLStructures.Tunable(), p)[1]
        if !isequal(_p, p)
            return promote_u0(u0, _p, t0)
        end
    end
    Tu = real(eltype(u0))
    if isdualtype(Tu)
        return u0
    end
    Tp = anyeltypedual(p, Val{0})
    if Tp == Any
        Tp = Tu
    end
    Tt = anyeltypedual(t0, Val{0})
    if Tt == Any
        Tt = Tu
    end
    Tcommon = promote_type(eltype(u0), Tp, Tt)
    return if isdualtype(real(Tcommon))
        Tcommon.(u0)
    else
        u0
    end
end

anyeltypedual(x) = anyeltypedual(x, Val{0})
anyeltypedual(x, counter) = Any
anyeltypedual(x::FixedSizeDiffCache, counter = 0) = Any

value(x) = x
unitfulvalue(x) = x
isdistribution(u0) = false
sse(x::Number) = abs2(x)

struct DualEltypeChecker{T, T2}
    x::T
    counter::T2
end

@inline __sum(f::F, args...; init, kwargs...) where {F} = sum(f, args...; init, kwargs...)
@inline function __sum(
        f::F, a::StaticArraysCore.StaticArray...; init, kwargs...
    ) where {F}
    return mapreduce(f, +, a...; init, kwargs...)
end

totallength(x::Number) = 1
totallength(x::AbstractArray) = __sum(totallength, x; init = 0)

_reshape(v, siz) = reshape(v, siz)
_reshape(v::Number, siz) = v
_reshape(v::AbstractSciMLScalarOperator, siz) = v

set_mooncakeoriginator_if_mooncake(x::SciMLBase.ADOriginator) = x

# Copied from Static.jl https://github.com/SciML/Static.jl/blob/b50279cc9b33741fd60f382c789fbaef8622d964/src/Static.jl#L743
@generated function reduce_tup(f::F, inds::Tuple{Vararg{Any, N}}) where {F, N}
    q = Expr(:block, Expr(:meta, :inline, :propagate_inbounds))
    if N == 1
        push!(q.args, :(inds[1]))
        return q
    end
    syms = Vector{Symbol}(undef, N)
    i = 0
    for n in 1:N
        syms[n] = iₙ = Symbol(:i_, (i += 1))
        push!(q.args, Expr(:(=), iₙ, Expr(:ref, :inds, n)))
    end
    W = 1 << (8sizeof(N) - 2 - leading_zeros(N))
    while W > 0
        _N = length(syms)
        for _ in (2W):W:_N
            for w in 1:W
                new_sym = Symbol(:i_, (i += 1))
                push!(q.args, Expr(:(=), new_sym, Expr(:call, :f, syms[w], syms[w + W])))
                syms[w] = new_sym
            end
            deleteat!(syms, (1 + W):(2W))
        end
        W >>>= 1
    end
    return q
end

####
# Catch undefined AD overload cases

const ADJOINT_NOT_FOUND_MESSAGE = """
Compatibility with reverse-mode automatic differentiation requires SciMLSensitivity.jl.
Please install SciMLSensitivity.jl and do `using SciMLSensitivity`/`import SciMLSensitivity`
for this functionality. For more details, see <https://docs.sciml.ai/SciMLSensitivity/dev/>.
"""

struct AdjointNotFoundError <: Exception end

function Base.showerror(io::IO, e::AdjointNotFoundError)
    return print(io, ADJOINT_NOT_FOUND_MESSAGE)
end

function _concrete_solve_adjoint(args...; kwargs...)
    throw(AdjointNotFoundError())
end

const FORWARD_SENSITIVITY_NOT_FOUND_MESSAGE = """
Compatibility with forward-mode automatic differentiation requires SciMLSensitivity.jl.
Please install SciMLSensitivity.jl and do `using SciMLSensitivity`/`import SciMLSensitivity`
for this functionality. For more details, see <https://docs.sciml.ai/SciMLSensitivity/dev/>.
"""

struct ForwardSensitivityNotFoundError <: Exception end

function Base.showerror(io::IO, e::ForwardSensitivityNotFoundError)
    return print(io, FORWARD_SENSITIVITY_NOT_FOUND_MESSAGE)
end

function _concrete_solve_forward(args...; kwargs...)
    throw(ForwardSensitivityNotFoundError())
end

using OrdinaryDiffEq
import Unitful: @u_str

# w Unitful
rhsU(x, p, t) = p * x
pU = 0.5u"1/hr"
xU0 = 1.0u"g/L"
tspanU = (0.0u"hr", 5.0u"hr")
probU = ODEProblem(rhsU, xU0, tspanU, pU)
solU = solve(probU, Tsit5())
tU = range(tspanU[1], tspanU[2], length = 20)
xU = solU(tU)

module SciMLBaseDistributionsExt

using Distributions, SciMLBase

SciMLBase.handle_distribution_u0(_u0::Distributions.Sampleable) = rand(_u0)
SciMLBase.isdistribution(_u0::Distributions.Sampleable) = true

end

using Documenter, SciMLBase, ModelingToolkit

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

include("pages.jl")

makedocs(
    sitename = "SciMLBase.jl",
    authors = "Chris Rackauckas",
    modules = [SciMLBase, ModelingToolkit],
    clean = true, doctest = false, linkcheck = true,
    warnonly = [:docs_block, :missing_docs],
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/SciMLBase/stable"
    ),
    linkcheck_ignore = [
        "https://www.sciencedirect.com/science/article/abs/pii/S0045782523007156",
    ],
    pages = pages
)

deploydocs(
    repo = "github.com/SciML/SciMLBase.jl.git";
    push_preview = true
)

using Optimization, OptimizationOptimJL, ForwardDiff, Test

x0 = zeros(2)
rosenbrock(x, p = nothing) = (1 - x[1])^2 + 100 * (x[2] - x[1]^2)^2
l1 = rosenbrock(x0)

optf = OptimizationFunction(rosenbrock, Optimization.AutoForwardDiff())
prob = OptimizationProblem(optf, x0)
sol1 = Optimization.solve(prob, OptimizationOptimJL.BFGS(), maxiters = 5)

ensembleprob = Optimization.EnsembleProblem(
    prob, [x0, x0 .+ rand(2), x0 .+ rand(2), x0 .+ rand(2)]
)

sol = Optimization.solve(
    ensembleprob, OptimizationOptimJL.BFGS(),
    EnsembleThreads(), trajectories = 4, maxiters = 5
)
@test findmin(i -> sol.u[i].objective, 1:4)[1] <= sol1.objective

sol = Optimization.solve(
    ensembleprob, OptimizationOptimJL.BFGS(),
    EnsembleDistributed(), trajectories = 4, maxiters = 5
)
@test findmin(i -> sol.u[i].objective, 1:4)[1] <= sol1.objective

prob = OptimizationProblem(optf, x0, lb = [-0.5, -0.5], ub = [0.5, 0.5])
ensembleprob = Optimization.EnsembleProblem(
    prob, prob_func = (prob, i, repeat) -> remake(prob, u0 = rand(-0.5:0.001:0.5, 2))
)

sol = Optimization.solve(
    ensembleprob, OptimizationOptimJL.BFGS(),
    EnsembleThreads(), trajectories = 5, maxiters = 5
)
@test findmin(i -> sol.u[i].objective, 1:4)[1] <= sol1.objective

sol = Optimization.solve(
    ensembleprob, OptimizationOptimJL.BFGS(),
    EnsembleDistributed(), trajectories = 5, maxiters = 5
)
@test findmin(i -> sol.u[i].objective, 1:4)[1] <= sol1.objective

using NonlinearSolve

f(u, p) = u .* u .- p
u0 = [1.0, 1.0]
p = 2.0
prob = NonlinearProblem(f, u0, p)
ensembleprob = EnsembleProblem(prob, [u0, u0 .+ rand(2), u0 .+ rand(2), u0 .+ rand(2)])

sol = solve(ensembleprob, EnsembleThreads(), trajectories = 4, maxiters = 100)

sol = solve(ensembleprob, EnsembleDistributed(), trajectories = 4, maxiters = 100)

using SciMLBase, Test

function test_num_args()
    f(x) = 2x
    f(x, y) = 2xy

    numpar = SciMLBase.numargs(f) # Should be [1,2]
    g = (x, y) -> x^2
    numpar2 = SciMLBase.numargs(g) # [2]
    numpar3 = SciMLBase.numargs(sqrt ∘ g) # [2]
    @show numpar, minimum(numpar) == 1, maximum(numpar) == 2
    return minimum(numpar) == 1 && maximum(numpar) == 2 &&
        maximum(numpar2) == 2 &&
        only(numpar3) == 2
end

@test test_num_args()

# Test isinplace on UnionAll
# https://github.com/SciML/SciMLBase.jl/issues/529

struct Foo{T} end
f = Foo{1}()
(this::Foo{T})(args...) where {T} = 1
@test SciMLBase.isinplace(Foo{Int}(), 4)

@testset "isinplace for FunctionWrappersWrapper" begin
    using FunctionWrappersWrappers

    # IIP: all wrappers return Nothing
    iip_fww = FunctionWrappersWrapper(
        (du, u, p, t) -> (du .= u; nothing),
        (Tuple{Vector{Float64}, Vector{Float64}, Nothing, Float64},),
        (Nothing,)
    )
    @test @inferred SciMLBase.isinplace(iip_fww, 4) === true

    # OOP: wrapper returns non-Nothing
    oop_fww = FunctionWrappersWrapper(
        (u, p, t) -> u .* 2,
        (Tuple{Vector{Float64}, Nothing, Float64},),
        (Vector{Float64},)
    )
    @test @inferred SciMLBase.isinplace(oop_fww, 3) === false

    # Multi-variant IIP (like OrdinaryDiffEq uses with 4 dual variants)
    multi_iip = FunctionWrappersWrapper(
        (du, u, p, t) -> (du .= u; nothing),
        (
            Tuple{Vector{Float64}, Vector{Float64}, Nothing, Float64},
            Tuple{Vector{Float64}, Vector{Float64}, Nothing, Float64},
        ),
        (Nothing, Nothing)
    )
    @test @inferred SciMLBase.isinplace(multi_iip, 4) === true
end

@testset "widen_bounded_type_params" begin
    f = ODEFunction{true, SciMLBase.AutoSpecialize}((du, u, p, t) -> du .= u)
    @test typeof(f).parameters[end - 1] === Nothing  # ID is concrete
    @test typeof(f).parameters[end] === Nothing     # NLP is concrete

    widened = @inferred SciMLBase.widen_bounded_type_params(f)

    # Bounded params are widened to their upper bounds
    @test typeof(widened).parameters[end - 1] === Union{Nothing, SciMLBase.OverrideInitData}
    @test typeof(widened).parameters[end] === Union{Nothing, SciMLBase.ODENLStepData}

    # Unbounded params stay concrete
    @test SciMLBase.isinplace(widened) === true
    @test SciMLBase.specialization(widened) === SciMLBase.AutoSpecialize

    # All field values preserved
    for fname in fieldnames(typeof(f))
        @test getfield(f, fname) === getfield(widened, fname)
    end
end

@testset "isinplace accepts an out-of-place version with different numbers of parameters " begin
    f1(u) = 2 * u
    @test !isinplace(f1, 2)
    @test_throws SciMLBase.TooFewArgumentsError SciMLBase.isinplace(f1, 4)
    @test !isinplace(f1, 4; outofplace_param_number = 1)
end

## Problem argument tests

ftoomany(u, p, t, x, y) = 2u
u0 = 0.5
tspan = (0.0, 1.0)
@test_throws SciMLBase.TooManyArgumentsError ODEProblem(ftoomany, u0, tspan)

ftoofew(u, t) = 2u
@test_throws SciMLBase.TooFewArgumentsError ODEProblem(ftoofew, u0, tspan)

fmessedup(u, t) = 2u
fmessedup(u, p, t, x, y) = 2u
@test_throws SciMLBase.FunctionArgumentsError ODEProblem(fmessedup, u0, tspan)

# Test SciMLFunctions

foop(u, p, t) = u
fiip(du, u, p, t) = du .= u

ofboth(u, p, t) = u
ofboth(du, u, p, t) = du .= u

ODEFunction(ofboth)
@inferred ODEFunction{true}(ofboth)
@inferred ODEFunction{false}(ofboth)

jac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, jac = jac)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, jac = jac)
jac(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, jac = jac)
ODEFunction(foop, jac = jac)
jac(du, u, p, t) = [1.0]
ODEFunction(fiip, jac = jac)
ODEFunction(foop, jac = jac)

Wfact(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, Wfact = Wfact)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, Wfact = Wfact)
Wfact(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, Wfact = Wfact)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, Wfact = Wfact)
Wfact(u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, Wfact = Wfact)
ODEFunction(foop, Wfact = Wfact)
Wfact(du, u, p, gamma, t) = [1.0]
ODEFunction(fiip, Wfact = Wfact)
ODEFunction(foop, Wfact = Wfact)

Wfact_t(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, Wfact_t = Wfact_t)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, Wfact_t = Wfact_t)
Wfact_t(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, Wfact_t = Wfact_t)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, Wfact_t = Wfact_t)
Wfact_t(u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, Wfact_t = Wfact_t)
ODEFunction(foop, Wfact_t = Wfact_t)
Wfact_t(du, u, p, gamma, t) = [1.0]
ODEFunction(fiip, Wfact_t = Wfact_t)
ODEFunction(foop, Wfact_t = Wfact_t)

tgrad(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, tgrad = tgrad)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, tgrad = tgrad)
tgrad(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, tgrad = tgrad)
ODEFunction(foop, tgrad = tgrad)
tgrad(du, u, p, t) = [1.0]
ODEFunction(fiip, tgrad = tgrad)
ODEFunction(foop, tgrad = tgrad)

paramjac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, paramjac = paramjac)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, paramjac = paramjac)
paramjac(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, paramjac = paramjac)
ODEFunction(foop, paramjac = paramjac)
paramjac(du, u, p, t) = [1.0]
ODEFunction(fiip, paramjac = paramjac)
ODEFunction(foop, paramjac = paramjac)

jvp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, jvp = jvp)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, jvp = jvp)
jvp(u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, jvp = jvp)
ODEFunction(foop, jvp = jvp)
jvp(du, u, v, p, t) = [1.0]
ODEFunction(fiip, jvp = jvp)
ODEFunction(foop, jvp = jvp)

vjp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(fiip, vjp = vjp)
@test_throws SciMLBase.TooFewArgumentsError ODEFunction(foop, vjp = vjp)
vjp(u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError ODEFunction(fiip, vjp = vjp)
ODEFunction(foop, vjp = vjp)
vjp(du, u, v, p, t) = [1.0]
ODEFunction(fiip, vjp = vjp)
ODEFunction(foop, vjp = vjp)

# SDE

foop(u, p, t) = u
goop(u, p, t) = u

fiip(du, u, p, t) = du .= u
giip(du, u, p, t) = du .= u

SDEFunction(fiip, giip)
SDEFunction(foop, goop)
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(foop, giip)
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, goop)

sfboth(u, p, t) = u
sfboth(du, u, p, t) = du .= u
sgboth(u, p, t) = u
sgboth(du, u, p, t) = du .= u

SDEFunction(sfboth, sgboth)
SDEFunction{true}(sfboth, sgboth)
SDEFunction{false}(sfboth, sgboth)

sjac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, jac = sjac)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, jac = sjac)
sjac(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, giip, jac = sjac)
SDEFunction(foop, goop, jac = sjac)
sjac(du, u, p, t) = [1.0]
SDEFunction(fiip, giip, jac = sjac)
SDEFunction(foop, goop, jac = sjac)

sWfact(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, Wfact = sWfact)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, Wfact = sWfact)
sWfact(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, Wfact = sWfact)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, goop, Wfact = sWfact)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, Wfact = sWfact)
sWfact(u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, giip, Wfact = sWfact)
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, goop, Wfact = sWfact)
SDEFunction(foop, goop, Wfact = sWfact)
sWfact(du, u, p, gamma, t) = [1.0]
SDEFunction(fiip, giip, Wfact = sWfact)
SDEFunction(foop, goop, Wfact = sWfact)

sWfact_t(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, Wfact_t = sWfact_t)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, giip, Wfact_t = sWfact_t)
sWfact_t(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, Wfact_t = sWfact_t)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, giip, Wfact_t = sWfact_t)
sWfact_t(u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(
    fiip, giip,
    Wfact_t = sWfact_t
)
SDEFunction(foop, goop, Wfact_t = sWfact_t)
sWfact_t(du, u, p, gamma, t) = [1.0]
SDEFunction(fiip, giip, Wfact_t = sWfact_t)
SDEFunction(foop, goop, Wfact_t = sWfact_t)

stgrad(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, tgrad = stgrad)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, tgrad = stgrad)
stgrad(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, giip, tgrad = stgrad)
SDEFunction(foop, goop, tgrad = stgrad)
stgrad(du, u, p, t) = [1.0]
SDEFunction(fiip, giip, tgrad = stgrad)
SDEFunction(foop, goop, tgrad = stgrad)

sparamjac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, paramjac = sparamjac)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, paramjac = sparamjac)
sparamjac(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(
    fiip, giip,
    paramjac = sparamjac
)
SDEFunction(foop, goop, paramjac = sparamjac)
sparamjac(du, u, p, t) = [1.0]
SDEFunction(fiip, giip, paramjac = sparamjac)
SDEFunction(foop, goop, paramjac = sparamjac)

sjvp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, jvp = sjvp)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, jvp = sjvp)
sjvp(u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, giip, jvp = sjvp)
SDEFunction(foop, goop, jvp = sjvp)
sjvp(du, u, v, p, t) = [1.0]
SDEFunction(fiip, giip, jvp = sjvp)
SDEFunction(foop, goop, jvp = sjvp)

svjp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(fiip, giip, vjp = svjp)
@test_throws SciMLBase.TooFewArgumentsError SDEFunction(foop, goop, vjp = svjp)
svjp(u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError SDEFunction(fiip, giip, vjp = svjp)
SDEFunction(foop, goop, vjp = svjp)
svjp(du, u, v, p, t) = [1.0]
SDEFunction(fiip, giip, vjp = svjp)
SDEFunction(foop, goop, vjp = svjp)

# RODEFunction

froop(u, p, t, W) = W
friip(du, p, t, W) = (du .= W)

RODEFunction(froop)
RODEFunction(friip)

frboth(u, p, t, W) = W
frboth(du, u, p, t, W) = (du .= W)

@test_nowarn RODEFunction(frboth)
@test_nowarn RODEFunction{true}(frboth)
@test_nowarn RODEFunction{false}(frboth)

frode(u, p, t, W) = p * u
rode_analytic(u0, t, p, W) = u0 * exp(p * t)
function rode_analytic!(sol)
    empty!(sol.u_analytic)
    return append!(sol.u_analytic, sol.prob.u0 * exp.(sol.prob.p * sol.t))
end
@test_nowarn RODEFunction(frode)
@test_nowarn RODEFunction(frode, analytic = rode_analytic)
@test_nowarn RODEFunction(frode, analytic = rode_analytic!, analytic_full = true)
@test_throws MethodError RODEFunction(
    frode, analytic = rode_analytic!,
    analytic_full = nothing
)

# DAEFunction

dfoop(du, u, p, t) = du .+ u
dfiip(res, du, u, p, t) = res .= du .+ u

dfboth(du, u, p, t) = du .+ u
dfboth(res, du, u, p, t) = res .= du .+ u

DAEFunction(dfboth)
DAEFunction{true}(dfboth)
DAEFunction{false}(dfboth)

djac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jac = djac)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jac = djac)
djac(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jac = djac)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jac = djac)
djac(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jac = djac)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jac = djac)
djac(du, u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DAEFunction(dfiip, jac = djac)
DAEFunction(dfoop, jac = djac)
djac(res, du, u, p, gamma, t) = [1.0]
DAEFunction(dfiip, jac = djac)
DAEFunction(dfoop, jac = djac)

djvp(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jvp = djvp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jvp = djvp)
djvp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jvp = djvp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jvp = djvp)
djvp(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jvp = djvp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jvp = djvp)
djvp(du, u, v, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, jvp = djvp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, jvp = djvp)
djvp(du, u, v, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DAEFunction(dfiip, jvp = djvp)
DAEFunction(dfoop, jvp = djvp)
djvp(res, du, u, v, p, gamma, t) = [1.0]
DAEFunction(dfiip, jvp = djvp)
DAEFunction(dfoop, jvp = djvp)

dvjp(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, vjp = dvjp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, vjp = dvjp)
dvjp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, vjp = dvjp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, vjp = dvjp)
dvjp(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, vjp = dvjp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, vjp = dvjp)
dvjp(du, u, v, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfiip, vjp = dvjp)
@test_throws SciMLBase.TooFewArgumentsError DAEFunction(dfoop, vjp = dvjp)
dvjp(du, u, v, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DAEFunction(dfiip, vjp = dvjp)
DAEFunction(dfoop, vjp = dvjp)
dvjp(res, du, u, v, p, gamma, t) = [1.0]
DAEFunction(dfiip, vjp = dvjp)
DAEFunction(dfoop, vjp = dvjp)
DAEFunction{true, SciMLBase.NoSpecialize}(dfiip, observed = 1)

# DDEFunction

ddefoop(u, h, p, t) = u
ddefiip(du, u, h, p, t) = du .= u

ddeofboth(u, h, p, t) = u
ddeofboth(du, u, h, p, t) = du .= u

DDEFunction(ddeofboth)
DDEFunction{true}(ddeofboth)
DDEFunction{false}(ddeofboth)

ddejac(u, h, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, jac = ddejac)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, jac = ddejac)
ddejac(u, h, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(ddefiip, jac = ddejac)
DDEFunction(ddefoop, jac = ddejac)
ddejac(du, u, h, p, t) = [1.0]
DDEFunction(ddefiip, jac = ddejac)
DDEFunction(ddefoop, jac = ddejac)

ddeWfact(u, h, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, Wfact = ddeWfact)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, Wfact = ddeWfact)
ddeWfact(u, h, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, Wfact = ddeWfact)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, Wfact = ddeWfact)
ddeWfact(u, h, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(ddefiip, Wfact = ddeWfact)
DDEFunction(ddefoop, Wfact = ddeWfact)
ddeWfact(du, u, h, p, gamma, t) = [1.0]
DDEFunction(ddefiip, Wfact = ddeWfact)
DDEFunction(ddefoop, Wfact = ddeWfact)

ddeWfact_t(u, h, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, Wfact_t = ddeWfact_t)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, Wfact_t = ddeWfact_t)
ddeWfact_t(u, h, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, Wfact_t = ddeWfact_t)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, Wfact_t = ddeWfact_t)
ddeWfact_t(u, h, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(
    ddefiip,
    Wfact_t = ddeWfact_t
)
DDEFunction(ddefoop, Wfact_t = Wfact_t)
ddeWfact_t(du, u, h, p, gamma, t) = [1.0]
DDEFunction(ddefiip, Wfact_t = ddeWfact_t)
DDEFunction(ddefoop, Wfact_t = ddeWfact_t)

ddetgrad(u, h, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, tgrad = ddetgrad)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, tgrad = ddetgrad)
ddetgrad(u, h, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(ddefiip, tgrad = ddetgrad)
DDEFunction(ddefoop, tgrad = ddetgrad)
ddetgrad(du, u, h, p, t) = [1.0]
DDEFunction(ddefiip, tgrad = ddetgrad)
DDEFunction(ddefoop, tgrad = ddetgrad)

ddeparamjac(u, h, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, paramjac = ddeparamjac)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, paramjac = ddeparamjac)
ddeparamjac(u, h, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(
    ddefiip,
    paramjac = ddeparamjac
)
DDEFunction(ddefoop, paramjac = paramjac)
ddeparamjac(du, u, h, p, t) = [1.0]
DDEFunction(ddefiip, paramjac = ddeparamjac)
DDEFunction(ddefoop, paramjac = ddeparamjac)

ddejvp(u, h, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, jvp = ddejvp)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, jvp = ddejvp)
ddejvp(u, v, h, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(ddefiip, jvp = ddejvp)
DDEFunction(ddefoop, jvp = ddejvp)
ddejvp(du, u, v, h, p, t) = [1.0]
DDEFunction(ddefiip, jvp = ddejvp)
DDEFunction(ddefoop, jvp = ddejvp)

ddevjp(u, h, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefiip, vjp = ddevjp)
@test_throws SciMLBase.TooFewArgumentsError DDEFunction(ddefoop, vjp = ddevjp)
ddevjp(u, v, h, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DDEFunction(ddefiip, vjp = ddevjp)
DDEFunction(ddefoop, vjp = ddevjp)
ddevjp(du, u, v, h, p, t) = [1.0]
DDEFunction(ddefiip, vjp = ddevjp)
DDEFunction(ddefoop, vjp = ddevjp)

# NonlinearFunction

nfoop(u, p) = u
nfiip(du, u, p) = du .= u

nfboth(u, p) = u
nfboth(du, u, p) = du .= u

NonlinearFunction(nfboth)
@inferred NonlinearFunction{true}(nfboth)
@inferred NonlinearFunction{false}(nfboth)

njac(u) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfiip, jac = njac)
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfoop, jac = njac)
njac(u, p) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError NonlinearFunction(nfiip, jac = njac)
NonlinearFunction(nfoop, jac = njac)
njac(du, u, p) = [1.0]
NonlinearFunction(nfiip, jac = njac)
NonlinearFunction(nfoop, jac = njac)

njvp(u) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfiip, jvp = njvp)
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfoop, jvp = njvp)
njvp(u, p) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfiip, jvp = njvp)
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfoop, jvp = njvp)
njvp(u, v, p) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError NonlinearFunction(nfiip, jvp = njvp)
NonlinearFunction(nfoop, jvp = njvp)
njvp(du, u, v, p) = [1.0]
NonlinearFunction(nfiip, jvp = njvp)
NonlinearFunction(nfoop, jvp = njvp)

nvjp(u) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfiip, vjp = nvjp)
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfoop, vjp = nvjp)
nvjp(u, p) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfiip, vjp = nvjp)
@test_throws SciMLBase.TooFewArgumentsError NonlinearFunction(nfoop, vjp = nvjp)
nvjp(u, v, p) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError NonlinearFunction(nfiip, vjp = nvjp)
NonlinearFunction(nfoop, vjp = nvjp)
nvjp(du, u, v, p) = [1.0]
NonlinearFunction(nfiip, vjp = nvjp)
NonlinearFunction(nfoop, vjp = nvjp)

# Integrals
intfew(u) = 1.0
@test_throws SciMLBase.TooFewArgumentsError IntegralProblem(intfew, (0.0, 1.0))
@test_throws SciMLBase.TooFewArgumentsError IntegralFunction(intfew)
@test_throws SciMLBase.TooFewArgumentsError IntegralFunction(intfew, zeros(3))
@test_throws SciMLBase.TooFewArgumentsError BatchIntegralFunction(intfew)
@test_throws SciMLBase.TooFewArgumentsError BatchIntegralFunction(intfew, zeros(3))
intf(u, p) = 1.0
p = 2.0
intfiip(y, u, p) = y .= 1.0

for (f, kws, iip) in (
            (intf, (;), false),
            (IntegralFunction(intf), (;), false),
            (IntegralFunction(intf, 1.0), (;), false),
            (IntegralFunction(intfiip, zeros(3)), (;), true),
        ),
        domain in (((0.0, 1.0),), (([0.0], [1.0]),))

    IntegralProblem(f, domain...; kws...)
    IntegralProblem(f, domain..., p; kws...)
    IntegralProblem{iip}(f, domain...; kws...)
    IntegralProblem{iip}(f, domain..., p; kws...)
end

x = [1.0, 2.0]
y = rand(2, 2)
SampledIntegralProblem(y, x)
SampledIntegralProblem(y, x; dim = 2)

# Optimization

optf(u) = 1.0
@test_throws SciMLBase.TooFewArgumentsError OptimizationFunction(optf)
@test_throws SciMLBase.TooFewArgumentsError OptimizationProblem(optf, 1.0)
optf(u, p) = 1.0
OptimizationFunction(optf)
OptimizationProblem(optf, 1.0)

# Test OptimizationFunction{iip} respects explicit iip parameter
# This function would fail isinplace check due to method ambiguity
struct ProblematicOptFunction end
(::ProblematicOptFunction)(x, p) = sum(x .^ 2)
# But when iip is explicitly provided, it should work without calling isinplace
@test_nowarn OptimizationFunction{false}(ProblematicOptFunction())
@test_nowarn OptimizationFunction{true}(ProblematicOptFunction())

# BVPFunction

bfoop(u, p, t) = u
bfiip(du, u, p, t) = du .= u

bfboth(u, p, t) = u
bfboth(du, u, p, t) = du .= u

bcoop(u, p, t) = u
bciip(res, u, p, t) = res .= u

bcfboth(u, p, t) = u
bcfboth(du, u, p, t) = du .= u

BVPFunction(bfboth, bcfboth)
@inferred BVPFunction{true}(bfboth, bcfboth)
@inferred BVPFunction{false}(bfboth, bcfboth)

bjac(u, t) = [1.0]
bcjac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(
    bfiip,
    bciip,
    jac = bjac,
    bcjac = bcjac
)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(
    bfoop,
    bciip,
    jac = bjac,
    bcjac = bcjac
)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(
    bfiip,
    bcoop,
    jac = bjac,
    bcjac = bcjac
)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(
    bfoop,
    bcoop,
    jac = bjac,
    bcjac = bcjac
)
bjac(u, p, t) = [1.0]
bcjac(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfiip,
    bcoop,
    jac = bjac,
    bcjac = bcjac
)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfiip,
    bciip,
    jac = bjac,
    bcjac = bcjac
)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfoop,
    bciip,
    jac = bjac,
    bcjac = bcjac
)
BVPFunction(bfoop, bcoop, jac = bjac)
bjac(du, u, p, t) = [1.0]
bcjac(du, u, p, t) = [1.0]
BVPFunction(bfiip, bciip, jac = bjac, bcjac = bcjac)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfoop,
    bciip,
    jac = bjac,
    bcjac = bcjac
)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfiip,
    bcoop,
    jac = bjac,
    bcjac = bcjac
)
BVPFunction(bfoop, bcoop, jac = bjac, bcjac = bcjac)

bWfact(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, Wfact = bWfact)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, Wfact = bWfact)
bWfact(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, Wfact = bWfact)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, Wfact = bWfact)
bWfact(u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfiip, bciip, Wfact = bWfact)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, Wfact = bWfact)
bWfact(du, u, p, gamma, t) = [1.0]
BVPFunction(bfiip, bciip, Wfact = bWfact)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, Wfact = bWfact)

bWfact_t(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, Wfact_t = bWfact_t)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, Wfact_t = bWfact_t)
bWfact_t(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, Wfact_t = bWfact_t)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, Wfact_t = bWfact_t)
bWfact_t(u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfiip,
    bciip,
    Wfact_t = bWfact_t
)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfoop,
    bciip,
    Wfact_t = bWfact_t
)
bWfact_t(du, u, p, gamma, t) = [1.0]
BVPFunction(bfiip, bciip, Wfact_t = bWfact_t)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfoop,
    bciip,
    Wfact_t = bWfact_t
)

btgrad(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, tgrad = btgrad)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, tgrad = btgrad)
btgrad(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfiip, bciip, tgrad = btgrad)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, tgrad = btgrad)
btgrad(du, u, p, t) = [1.0]
BVPFunction(bfiip, bciip, tgrad = btgrad)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, tgrad = btgrad)

bparamjac(u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, paramjac = bparamjac)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, paramjac = bparamjac)
bparamjac(u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfiip,
    bciip,
    paramjac = bparamjac
)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfoop,
    bciip,
    paramjac = bparamjac
)
bparamjac(du, u, p, t) = [1.0]
BVPFunction(bfiip, bciip, paramjac = bparamjac)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfoop,
    bciip,
    paramjac = bparamjac
)

bjvp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, jvp = bjvp)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, jvp = bjvp)
bjvp(u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfiip, bciip, jvp = bjvp)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, jvp = bjvp)
bjvp(du, u, v, p, t) = [1.0]
BVPFunction(bfiip, bciip, jvp = bjvp)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, jvp = bjvp)

bvjp(u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfiip, bciip, vjp = bvjp)
@test_throws SciMLBase.TooFewArgumentsError BVPFunction(bfoop, bciip, vjp = bvjp)
bvjp(u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfiip, bciip, vjp = bvjp)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, vjp = bvjp)
bvjp(du, u, v, p, t) = [1.0]
BVPFunction(bfiip, bciip, vjp = bvjp)

@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfoop, bciip, vjp = bvjp)

BVPFunction(bfiip, bciip, cost = (x, p) -> 0.0)
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(bfiip, bciip, cost = x -> 0.0)
equality(u, p) = u
inequality(u, p) = u
@test_throws SciMLBase.NonconformingFunctionsError BVPFunction(
    bfiip, bciip, cost = (x, p) -> 0.0, equality = equality, inequality = inequality
)
equality(res, u, p) = (res .= u)
inequality(res, u, p) = (res .= u)
BVPFunction(
    bfiip, bciip, cost = (x, p) -> 0.0, equality = equality, inequality = inequality
)

# DynamicalBVPFunction

dbfoop(du, u, p, t) = u
dbfiip(ddu, du, u, p, t) = ddu .= du .- u

dbfboth(du, u, p, t) = u
dbfboth(ddu, du, u, p, t) = ddu .= du .- u

dbcoop(du, u, p, t) = u
dbciip(res, du, u, p, t) = res .= du .- u

dbcfboth(du, u, p, t) = u
dbcfboth(res, du, u, p, t) = res .= du .- u

DynamicalBVPFunction(dbfboth, dbcfboth)
@inferred DynamicalBVPFunction{true}(dbfboth, dbcfboth)
@inferred DynamicalBVPFunction{false}(dbfboth, dbcfboth)

dbjac(du, u, t) = [1.0]
dbcjac(du, u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip,
    dbciip,
    jac = dbjac,
    bcjac = dbcjac
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    jac = dbjac,
    bcjac = dbcjac
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip,
    dbcoop,
    jac = dbjac,
    bcjac = dbcjac
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop,
    dbcoop,
    jac = dbjac,
    bcjac = dbcjac
)
dbjac(du, u, p, t) = [1.0]
dbcjac(du, u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip,
    dbcoop,
    jac = dbjac,
    bcjac = dbcjac
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip,
    dbciip,
    jac = dbjac,
    bcjac = dbcjac
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    jac = dbjac,
    bcjac = dbcjac
)
DynamicalBVPFunction(dbfoop, dbcoop, jac = dbjac)
dbjac(ddu, du, u, p, t) = [1.0]
dbcjac(ddu, du, u, p, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, jac = dbjac, bcjac = dbcjac)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    jac = dbjac,
    bcjac = dbcjac
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip,
    dbcoop,
    jac = dbjac,
    bcjac = dbcjac
)
DynamicalBVPFunction(dbfoop, dbcoop, jac = dbjac, bcjac = dbcjac)

dbWfact(du, u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, Wfact = dbWfact
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, Wfact = dbWfact
)
dbWfact(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, Wfact = dbWfact
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, Wfact = dbWfact
)
dbWfact(du, u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip, dbciip, Wfact = dbWfact
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, Wfact = dbWfact
)
dbWfact(ddu, du, u, p, gamma, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, Wfact = dbWfact)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, Wfact = dbWfact
)

dbWfact_t(du, u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, Wfact_t = dbWfact_t
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, Wfact_t = dbWfact_t
)
dbWfact_t(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, Wfact_t = dbWfact_t
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, Wfact_t = dbWfact_t
)
dbWfact_t(du, u, p, gamma, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip,
    dbciip,
    Wfact_t = dbWfact_t
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    Wfact_t = dbWfact_t
)
dbWfact_t(ddu, du, u, p, gamma, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, Wfact_t = dbWfact_t)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    Wfact_t = dbWfact_t
)

dbtgrad(du, u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, tgrad = dbtgrad
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, tgrad = dbtgrad
)
dbtgrad(du, u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip, dbciip, tgrad = dbtgrad
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, tgrad = dbtgrad
)
dbtgrad(ddu, du, u, p, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, tgrad = dbtgrad)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, tgrad = dbtgrad
)

dbparamjac(du, u, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, paramjac = dbparamjac
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, paramjac = dbparamjac
)
dbparamjac(du, u, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip,
    dbciip,
    paramjac = dbparamjac
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    paramjac = dbparamjac
)
dbparamjac(ddu, du, u, p, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, paramjac = dbparamjac)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop,
    dbciip,
    paramjac = dbparamjac
)

dbjvp(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, jvp = dbjvp
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, jvp = dbjvp
)
dbjvp(du, u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip, dbciip, jvp = dbjvp
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, jvp = dbjvp
)
dbjvp(ddu, du, u, v, p, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, jvp = dbjvp)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, jvp = dbjvp
)

dbvjp(du, u, p, t) = [1.0]
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfiip, dbciip, vjp = dbvjp
)
@test_throws SciMLBase.TooFewArgumentsError DynamicalBVPFunction(
    dbfoop, dbciip, vjp = dbvjp
)
dbvjp(du, u, v, p, t) = [1.0]
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfiip, dbciip, vjp = dbvjp
)
@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, vjp = dbvjp
)
dbvjp(ddu, du, u, v, p, t) = [1.0]
DynamicalBVPFunction(dbfiip, dbciip, vjp = dbvjp)

@test_throws SciMLBase.NonconformingFunctionsError DynamicalBVPFunction(
    dbfoop, dbciip, vjp = dbvjp
)

# IntegralFunction

ioop(u, p) = p * u
iiip(y, u, p) = y .= u * p
i1(u) = u
itoo(y, u, p, a) = y .= u * p

IntegralFunction(ioop)
IntegralFunction(ioop, 0.0)
IntegralFunction(iiip, Float64[])

@test_throws SciMLBase.IntegrandMismatchFunctionError IntegralFunction(iiip)
@test_throws SciMLBase.TooFewArgumentsError IntegralFunction(i1)
@test_throws SciMLBase.TooManyArgumentsError IntegralFunction(itoo)
@test_throws SciMLBase.TooManyArgumentsError IntegralFunction(itoo, Float64[])

# BatchIntegralFunction

boop(u, p) = p .* u
biip(y, u, p) = y .= p .* u
bi1(u) = u
bitoo(y, u, p, a) = y .= p .* u

BatchIntegralFunction(boop)
BatchIntegralFunction(boop, max_batch = 20)
BatchIntegralFunction(boop, Float64[])
BatchIntegralFunction(boop, Float64[], max_batch = 20)
BatchIntegralFunction(biip, Float64[])
BatchIntegralFunction(biip, Float64[], max_batch = 20)

@test_throws SciMLBase.IntegrandMismatchFunctionError BatchIntegralFunction(biip)
@test_throws SciMLBase.TooFewArgumentsError BatchIntegralFunction(bi1)
@test_throws SciMLBase.TooManyArgumentsError BatchIntegralFunction(bitoo)
@test_throws SciMLBase.TooManyArgumentsError BatchIntegralFunction(bitoo, Float64[])

module SciMLBasePyCallExt

using PyCall: PyCall, PyObject, PyAny, pyfunctionret, pyimport, hasproperty
using SciMLBase: SciMLBase, solve

# SciML uses a function's arity (number of arguments) to determine if it operates in place.
# PyCall does not preserve arity, so we inspect Python functions to find their arity.
function SciMLBase.numargs(f::PyObject)
    inspect = pyimport("inspect")
    f2 = hasproperty(f, :py_func) ? f.py_func : f
    # if `f` is a bound method (i.e., `self.f`), `getfullargspec` includes
    # `self` in the `args` list. So, we subtract 1 in that case:
    return length(first(inspect.getfullargspec(f2))) - inspect.ismethod(f2)
end

# differential equation solutions can be converted to lists, this tells PyCall not
# to perform that conversion automatically when a solution is returned from `solve`
PyCall.PyObject(::typeof(solve)) = pyfunctionret(solve, Any, Vararg{PyAny})

end

module SciMLBaseMeasurementsExt

using Measurements
using SciMLBase: SciMLBase

function SciMLBase.promote_u0(
        u0::AbstractArray{<:Measurements.Measurement},
        p::AbstractArray{<:Measurements.Measurement}, t0
    )
    return u0
end
SciMLBase.promote_u0(u0, p::AbstractArray{<:Measurements.Measurement}, t0) = eltype(p).(u0)

SciMLBase.value(x::Type{Measurements.Measurement{T}}) where {T} = T
SciMLBase.value(x::Measurements.Measurement) = Measurements.value(x)

SciMLBase.unitfulvalue(x::Type{Measurements.Measurement{T}}) where {T} = T
SciMLBase.unitfulvalue(x::Measurements.Measurement) = Measurements.value(x)

end

using Pkg
using SafeTestsets
using Test

const GROUP = get(ENV, "GROUP", "All")
const is_APPVEYOR = (Sys.iswindows() && haskey(ENV, "APPVEYOR"))

function activate_downstream_env()
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

function activate_python_env()
    Pkg.activate("python")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

@time begin
    if GROUP == "QA"
        @time @safetestset "Aqua" begin
            include("aqua.jl")
        end
    end
    if GROUP == "Core" || GROUP == "All"
        @time @safetestset "Adapt structure" begin
            include("adapt.jl")
        end
        @time @safetestset "Display" begin
            include("display.jl")
        end
        @time @safetestset "Existence functions" begin
            include("existence_functions.jl")
        end
        @time @safetestset "Function Building Error Messages" begin
            include("function_building_error_messages.jl")
        end
        @time @safetestset "Integrator interface" begin
            include("integrator_tests.jl")
        end
        @time @safetestset "Ensemble functionality" begin
            include("ensemble_tests.jl")
        end
        @time @safetestset "Solution interface" begin
            include("solution_interface.jl")
        end
        @time @safetestset "DE function conversion" begin
            include("convert_tests.jl")
        end
        @time @safetestset "Performance warnings" begin
            include("performance_warnings.jl")
        end
        @time @safetestset "Error hints" begin
            include("error_hint_tests.jl")
        end
        @time @safetestset "Problem building tests" begin
            include("problem_building_test.jl")
        end
        @time @safetestset "Serialization tests" begin
            include("serialization_tests.jl")
        end
        @time @safetestset "Clocks" begin
            include("clock.jl")
        end
    end

    if !is_APPVEYOR &&
            (GROUP == "Core" || GROUP == "All" || GROUP == "SymbolicIndexingInterface")
        @time @safetestset "Remake" begin
            include("remake_tests.jl")
        end
    end

    if !is_APPVEYOR && GROUP == "Downstream"
        activate_downstream_env()
        @time @safetestset "Ensembles of Zero Length Solutions" begin
            include("downstream/ensemble_zero_length.jl")
        end
        @time @safetestset "Timing first batch when solving Ensembles" begin
            include("downstream/ensemble_first_batch.jl")
        end
        @time @safetestset "solving Ensembles with multiple problems" begin
            include("downstream/ensemble_multi_prob.jl")
        end
        @time @safetestset "Ensemble solution statistics" begin
            include("downstream/ensemble_stats.jl")
        end
        @time @safetestset "Ensemble Optimization and Nonlinear problems" begin
            include("downstream/ensemble_nondes.jl")
        end
        @time @safetestset "Ensemble with DifferentialEquations automatic algorithm selection" begin
            include("downstream/ensemble_diffeq.jl")
        end
        @time @safetestset "Solution Indexing" begin
            include("downstream/solution_interface.jl")
        end
        @time @safetestset "Unitful interpolations" begin
            include("downstream/unitful_interpolations.jl")
        end
        @time @safetestset "Integer idxs" begin
            include("downstream/integer_idxs.jl")
        end
        @time @safetestset "Autodiff Remake" begin
            include("downstream/remake_autodiff.jl")
        end
        @time @safetestset "Partial Functions" begin
            include("downstream/partial_functions.jl")
        end
        @time @safetestset "Autodiff Observable Functions" begin
            include("downstream/observables_autodiff.jl")
        end
        @time @safetestset "ODE Solution Stripping" begin
            include("downstream/ode_stripping.jl")
        end
        @time @safetestset "Tables interface with MTK" begin
            include("downstream/tables.jl")
        end
        @time @safetestset "Initialization" begin
            include("downstream/initialization.jl")
        end
        @time @safetestset "Table Traits" begin
            include("downstream/traits.jl")
        end
        @time @safetestset "SplitODEProblem cache" begin
            include("downstream/splitodeproblem_cache.jl")
        end
    end

    if !is_APPVEYOR && GROUP == "SymbolicIndexingInterface"
        if GROUP != "Downstream"
            activate_downstream_env()
        end
        @time @safetestset "Symbol and integer based indexing of interpolated solutions" begin
            include("downstream/comprehensive_indexing.jl")
        end
        @time @safetestset "Symbol and integer based indexing of integrators" begin
            include("downstream/integrator_indexing.jl")
        end
        @time @safetestset "Problem Indexing" begin
            include("downstream/problem_interface.jl")
        end
        @time @safetestset "Adjoints" begin
            include("downstream/adjoints.jl")
        end
        @time @safetestset "ModelingToolkit Remake" begin
            include("downstream/modelingtoolkit_remake.jl")
        end
    end

    if !is_APPVEYOR && GROUP == "Python"
        activate_python_env()
        @time @safetestset "PythonCall" begin
            include("python/pythoncall.jl")
        end
    end
end

"""
    SciML.ReturnCode

`SciML.ReturnCode` is the standard return code enum interface for the SciML interface.
Return codes are notes given by the solvers to indicate the state of the solution, for
example whether it successfully solved the equations, whether it failed to solve the
equations, and importantly, why it exited.

## Using `SciML.ReturnCode`

`SciML.ReturnCode` use the interface of [EnumX.jl](https://github.com/fredrikekre/EnumX.jl)
and thus inherits all of the behaviors of being an EnumX. This includes the Enum type itself
being referred to as `SciML.ReturnCode.T`, and each of the constituent enum states being
referred to via `getproperty`, i.e. `SciML.ReturnCode.Success`.

## Note About Success Checking

Previous iterations of the interface suggested using `sol.retcode == :Success`, however,
that is now not advised instead should be replaced with ` SciMLBase.successful_retcode(sol)`. The reason is that there are many different
codes that can be interpreted as successful, such as `ReturnCode.Terminated` which means
successfully used `terminate!(integrator)` to end an integration at a user-specified
condition. As such, `successful_retcode` is the most general way to query for if the solver
did not error.

## Properties

  - `successful_retcode(retcode::ReturnCode.T)`: Determines whether the output enum is
    considered a success state of the solver, i.e. the solver successfully solved the
    equations. `ReturnCode.Success` is the most basic form, simply declaring that it was
    successful, but many more informative success return codes exist as well.
"""
EnumX.@enumx ReturnCode begin
    """
        ReturnCode.Default

    The default state of the solver. If this return code is given, then the solving
    process is either still in process or the solver library has not been setup
    with the return code interface and thus the return code is undetermined.

    ## Common Reasons for Seeing this Return Code

      - A common reason for `Default` return codes is that a solver is a non-SciML solver
        which does not fully conform to the interface. Please open an issue if this is seen
        and it will be improved.
      - Another common reason for a `Default` return code is if the solver is probed
        internally before the solving process is done, such as through the callback interface.
        Return codes are set to `Default` to start and are changed to `Success` and other
        return codes upon finishing the solving process or hitting a numerical difficulty.

    ## Properties

      - `successful_retcode` = `false`
    """
    Default

    """
        ReturnCode.Success

    The success state of the solver. If this return code is given, then the solving
    process was successful, but no extra information about that success is given.

    ## Common Reasons for Seeing this Return Code

      - This is the most common return code and most solvers will give this return code if
        the solving process went as expected without any errors or detected numerical issues.

    ## Properties

      - `successful_retcode` = `true`
    """
    Success

    """
        ReturnCode.Terminated

    The successful termination state of the solver. If this return code is given,
    then the solving process was successful at terminating the solve, usually
    through a callback `affect!` via `terminate!(integrator)`.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is if a user calls a callback which
        uses `terminate!(integrator)` to halt the integration at a user-chosen stopping point.
      - Another common reason for this return code is due to implicit `terminate!` statements
        in some library callbacks. For example, `SteadyStateCallback` uses `terminate!`
        internally, so solutions which reach steady state will have a `ReturnCode.Terminated`
        state instead of a `ReturnCode.Success` state. Similarly, problems solved via
        SteadyStateDiffEq.jl will have this `ReturnCode.Terminated` state if a timestepping
        method is used to solve to steady state.

    ## Properties

      - `successful_retcode` = `true`
    """
    Terminated

    """
        ReturnCode.DtNaN

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful and exited early because the `dt` of the
    integration was determined to be `NaN` and thus the solver could not continue.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is because the automatic `dt`
        selection algorithm is used but the starting derivative has a `NaN` or `Inf`
        derivative term. Double check that the `f(u0,p,t0)` term is well-defined without
        `NaN` or `Inf` values.
      - Another common reason for this return code is because of a user set `dt` which is
        calculated to be a `NaN`. If `solve(prob,alg,dt=x)`, double check that `x` is not
        `NaN`.

    ## Properties

      - `successful_retcode` = `false`
    """
    DtNaN

    """
        ReturnCode.MaxIters

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful and exited early because the solver's
    iterations hit the `maxiters` either set by default or by the user in the
    `solve`/`init` command.

    ## Note about Nonlinear Optimization

    In nonlinear optimization, many solvers (such as `OptimizationOptimisers.Adam`) do not
    have an exit criteria other than `iters == maxiters`. In this case, the solvers will
    iterate until `maxiters` and exit with a `Success` return code, as that is a successful
    run of the solver and not considered to be an error state. Solves with early termination
    criteria, such as `Optim.BFGS` exiting when the gradient is sufficiently close to zero,
    will give `ReturnCode.MaxIters` on exits which require the maximum iteration.

    ## Common Reasons for Seeing this Return Code

      - This commonly occurs in ODE solving if a non-stiff method (e.g. `Tsit5`) is used in
        an algorithm choice for a stiff ODE. It is recommended that in such cases, one tries a
        stiff ODE solver.
      - This commonly occurs in optimization and nonlinear solvers if the tolerance on `solve`
        to too low and cannot be achieved due to floating point error or the condition number
        of the solver matrix. Double check that the chosen tolerance is numerically possible.

    ## Properties

      - `successful_retcode` = `false`
    """
    MaxIters

    """
        ReturnCode.MaxNumSub

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful and exited early because during the solver's
    adaptivity, mesh length exceeded the `max_num_subintervals` either set by default or specified
    by users in the solver.

    ## Common Reasons for Seeing this Return Code

      - This commonly occurs in BVP solving if the original mesh are too coarse or
        the tolerance are too stringent. It is recommended that in such cases, one tries to increase the default `max_num_subintervals`
        in solvers, or decrease the tolerance.

    ## Properties

      - `successful_retcode` = `false`
    """
    MaxNumSub

    """
        ReturnCode.DtLessThanMin

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful and exited early because the `dt` of the
    integration was made to be less than `dtmin`, i.e. `dt < dtmin`.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is because the integration
        is going unstable. As `f(u,p,t) -> infinity`, the time steps required by the solver
        to accurately handle the dynamics decreases. When it gets sufficiently small, `dtmin`,
        an exit is thrown as the solution is likely unstable. `dtmin` is also chosen to be
        around the value where floating point issues cause `t + dt == t`, and thus a `dt`
        of that size is impossible at floating point precision.
      - Another common reason for this return code is if domain constraints are set, such as
        by using `isoutofdomain`, but the domain constraint is incorrect. For example, if
        one is solving the ODE `f(u,p,t) = -u - 1`, one may think "but I want a solution with
        `u > 0` and thus I will set `isoutofdomain(u,p,t) = u < 0`. However, the true solution
        of this ODE is not positive, and thus what will occur is that the solver will try to
        decrease `dt` until it can give an accurate solution that is positive. As this is
        impossible, it will continue to shrink the `dt` until `dt < dtmin` and then exit with
        this return code.

    ## Properties

      - `successful_retcode` = `false`
    """
    DtLessThanMin

    """
        ReturnCode.Unstable

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful and exited early because the `unstable_check`
    function, as given by the `unstable_check` common keyword argument (or its default),
    give a `true` at the current state.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is because `u` contains a `NaN`
        or `Inf` value. The default `unstable_check` only checks for these values.

    ## Properties

      - `successful_retcode` = `false`
    """
    Unstable

    """
        ReturnCode.InitialFailure

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful because the initialization process failed.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is because the initialization
        process of a DAE solver failed to find consistent initial conditions, which can
        occur if the differentiation index of the DAE solver is too high. Most DAE solvers
        only allow for index-1 DAEs, and so an index-2 DAE will fail during this
        initialization. To solve this kind of problem, use `ModelingToolkit.jl` and its
        `structural_simplify` method to reduce the index of the DAE.
      - Another common reason for this return code is if the initial condition was not
        suitable for the numerical solve. For example, the initial point had a `NaN` or `Inf`.
        Or in optimization, this can occur if the initial point is outside of the bound
        constraints given by the user.

    ## Properties

      - `successful_retcode` = `false`
    """
    InitialFailure

    """
        ReturnCode.ConvergenceFailure

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful because internal nonlinear solver iterations
    failed to converge.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is because an inappropriate
        nonlinear solver was chosen. If fixed point iteration is used on a stiff problem,
        it will be faster by avoiding the Jacobian but it will make a stiff ODE solver not
        stable for stiff problems!
      - For nonlinear solvers, this can occur if certain threshold was exceeded. For example,
        in approximate jacobian solvers like Broyden, Klement, etc. if the number of jacobian
        resets exceeds the threshold, then this return code is given.

    ## Properties

      - `successful_retcode` = `false`
    """
    ConvergenceFailure

    """
        ReturnCode.Failure

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful but no extra information is given.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for seeing this return code is because the solver is a wrapped
        solver (i.e. a Fortran code) which does not provide any extra information about its
        exit state. If this is from a Julia-based solver, please open an issue.

    ## Properties

      - `successful_retcode` = `false`
    """
    Failure

    """
        ReturnCode.ExactSolutionLeft

    The success state of the solver. If this return code is given, then the solving
    process was successful, and the left solution was given.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for this return code is via a bracketing nonlinear solver,
        such as bisection, iterating to convergence is unable to give the exact `f(x)=0`
        solution due to floating point precision issues, and thus it gives the first floating
        point value to the left for `x`.

    ## Properties

      - `successful_retcode` = `true`
    """
    ExactSolutionLeft

    """
        ReturnCode.ExactSolutionRight

    The success state of the solver. If this return code is given, then the solving
    process was successful, and the right solution was given.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for this return code is via a bracketing nonlinear solver,
        such as bisection, iterating to convergence is unable to give the exact `f(x)=0`
        solution due to floating point precision issues, and thus it gives the first floating
        point value to the right for `x`.

    ## Properties

      - `successful_retcode` = `true`
    """
    ExactSolutionRight

    """
        ReturnCode.FloatingPointLimit

    The success state of the solver. If this return code is given, then the solving
    process was successful, and the closest floating point value to the solution was given.

    ## Common Reasons for Seeing this Return Code

      - The most common reason for this return code is via a nonlinear solver, such as Falsi,
        iterating to convergence is unable to give the exact `f(x)=0` solution due to floating
        point precision issues, and thus it gives the closest floating point value to the
        true solution for `x`.

    ## Properties

      - `successful_retcode` = `true`
    """
    FloatingPointLimit

    """
        ReturnCode.Infeasible

    The optimization problem was proven to be infeasible by the solver.

    ## Properties

      - `successful_retcode` = `false`
    """
    Infeasible

    """
        ReturnCode.MaxTime

    A failure exit state of the solver. If this return code is given, then the
    solving process was unsuccessful and exited early because the solver's
    timer hit `maxtime` either set by default or by the user in the
    `solve`/`init` command.

    ## Properties

      - `successful_retcode` = `false`
    """
    MaxTime

    """
        ReturnCode.InternalLineSearchFailed

    Internal Line Search used by the algorithm has failed.

    ## Properties

      - `successful_retcode` = `false`
    """
    InternalLineSearchFailed

    """
        ReturnCode.ShrinkThresholdExceeded

    The trust region radius was shrunk more times than the provided threshold.

    ## Properties

      - `successful_retcode` = `false`
    """
    ShrinkThresholdExceeded

    """
        ReturnCode.Stalled

    The solution has stalled. This is only returned by algorithms for which stalling is a
    failure mode, such as on a NonlinearProblem where the found solution is larger than
    the accepted tolerance.

    ## Properties

      - `successful_retcode` = `false`
    """
    Stalled

    """
    ReturnCode.StalledSuccess

    The solution process has stalled, but the stall is not considered a failure of the solver.
    For example, a nonlinear optimizer may have stalled, that is its steps went to zero, which
    is a valid local minima.

    ## Common Reasons for Seeing this Return Code

      - For nonlinear least squares optimizations, this is given for local minima which exceed
        the chosen tolerance, i.e. `f(x)=resid` where `||resid||>tol` so it's not considered
        ReturnCode.Success but it is still considered a successful return of the solver since
        it's a valid local minima (and there no minima which achieves the tolerance).

    ## Properties

      - `successful_retcode` = `true`
    """
    StalledSuccess

    """
        ReturnCode.InternalLinearSolveFailed

    The linear problem inside another problem (for example inside a NonlinearProblem)
    could not be solved.

    ## Common Reasons for Seeing this Return Code

      - If a rank-deficient matrix originated inside the nonlinear solve and the
        provided linear solver is incapable of handling those cases.

    ## Properties

      - `successful_retcode` = `false`
    """
    InternalLinearSolveFailed

    """
        ReturnCode.APosterioriSafetyFailure

    A failure exit state of the solver. If this return code is given, then the solver
    completed execution but an a posteriori error check detected that the computed
    solution is likely inaccurate due to numerical issues. This is distinct from
    `ReturnCode.Failure` which indicates the solver itself failed to complete.

    ## Common Reasons for Seeing this Return Code

      - A linear solver (e.g. LU factorization) succeeded but a post-solve residual check
        `‖A*x - b‖` found the residual to be unacceptably large, indicating numerical
        instability from a near-singular or ill-conditioned matrix.
      - This return code is used when `residualsafety = true` is set on an LU algorithm
        and the residual exceeds the safety threshold.

    ## Properties

      - `successful_retcode` = `false`
    """
    APosterioriSafetyFailure
end

const symtrue = Symbol("true")
const symfalse = Symbol("false")

function Base.convert(::Type{ReturnCode.T}, retcode::Symbol)
    @warn "Backwards compatibility support of the new return codes to Symbols will be deprecated with the Julia v1.9 release. Please see https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes for more information"

    return if retcode == :Default || retcode == :DEFAULT
        ReturnCode.Default
    elseif retcode == :Success || retcode == :EXACT_SOLUTION_LEFT ||
            retcode == :FLOATING_POINT_LIMIT || retcode == symtrue || retcode == :OPTIMAL ||
            retcode == :LOCALLY_SOLVED
        ReturnCode.Success
    elseif retcode == :Terminated
        ReturnCode.Terminated
    elseif retcode == :MaxIters || retcode == :MAXITERS_EXCEED
        ReturnCode.MaxIters
    elseif retcode == :MaxNumSub
        ReturnCode.MaxNumSub
    elseif retcode == :MaxTime || retcode == :TIME_LIMIT
        ReturnCode.MaxTime
    elseif retcode == :DtLessThanMin
        ReturnCode.DtLessThanMin
    elseif retcode == :Unstable
        ReturnCode.Unstable
    elseif retcode == :InitialFailure
        ReturnCode.InitialFailure
    elseif retcode == :ConvergenceFailure || retcode == :ITERATION_LIMIT
        ReturnCode.ConvergenceFailure
    elseif retcode == :Failure || retcode == symfalse
        ReturnCode.Failure
    elseif retcode == :Infeasible || retcode == :INFEASIBLE ||
            retcode == :DUAL_INFEASIBLE || retcode == :LOCALLY_INFEASIBLE ||
            retcode == :INFEASIBLE_OR_UNBOUNDED
        ReturnCode.Infeasible
    else
        ReturnCode.Failure
    end
end

# Deprecate ASAP, only to make the deprecation easier
symbol_to_ReturnCode(retcode::ReturnCode.T) = retcode
function symbol_to_ReturnCode(retcode::Symbol)
    return if retcode == :Default || retcode == :DEFAULT
        ReturnCode.Default
    elseif retcode == :Success || retcode == :EXACT_SOLUTION_LEFT ||
            retcode == :FLOATING_POINT_LIMIT || retcode == symtrue || retcode == :OPTIMAL ||
            retcode == :LOCALLY_SOLVED
        ReturnCode.Success
    elseif retcode == :Terminated
        ReturnCode.Terminated
    elseif retcode == :MaxIters || retcode == :MAXITERS_EXCEED
        ReturnCode.MaxIters
    elseif retcode == :MaxTime || retcode == :TIME_LIMIT
        ReturnCode.MaxTime
    elseif retcode == :DtLessThanMin
        ReturnCode.DtLessThanMin
    elseif retcode == :Unstable
        ReturnCode.Unstable
    elseif retcode == :InitialFailure
        ReturnCode.InitialFailure
    elseif retcode == :ConvergenceFailure || retcode == :ITERATION_LIMIT
        ReturnCode.ConvergenceFailure
    elseif retcode == :Failure || retcode == symfalse
        ReturnCode.Failure
    elseif retcode == :Infeasible || retcode == :INFEASIBLE ||
            retcode == :DUAL_INFEASIBLE || retcode == :LOCALLY_INFEASIBLE ||
            retcode == :INFEASIBLE_OR_UNBOUNDED
        ReturnCode.Infeasible
    else
        ReturnCode.Failure
    end
end

function Base.convert(::Type{ReturnCode.T}, bool::Bool)
    return bool ? ReturnCode.Success : ReturnCode.Failure
end

"""
    successful_retcode(retcode::ReturnCode.T)::Bool
    successful_retcode(sol::AbstractSciMLSolution)::Bool

Returns a boolean for whether a return code should be interpreted as a form of success.
"""
function successful_retcode end

function successful_retcode(retcode::ReturnCode.T)
    return retcode == ReturnCode.Success || retcode == ReturnCode.Terminated ||
        retcode == ReturnCode.ExactSolutionLeft ||
        retcode == ReturnCode.ExactSolutionRight ||
        retcode == ReturnCode.FloatingPointLimit ||
        retcode == ReturnCode.StalledSuccess
end
successful_retcode(sol::AbstractSciMLSolution) = successful_retcode(sol.retcode)

module SciMLBaseChainRulesCoreExt

using SciMLBase
using SciMLBase: getobserved
import ChainRulesCore
import ChainRulesCore: NoTangent, @non_differentiable, zero_tangent, rrule_via_ad
using SymbolicIndexingInterface
using RecursiveArrayTools: AbstractVectorOfArray

@non_differentiable SciMLBase.checkkwargs(kwargshandle)

# numargs and isinplace use `methods()` for runtime reflection and are not differentiable.
# Mooncake already has @zero_adjoint for numargs; this is the ChainRules/Zygote equivalent.
@non_differentiable SciMLBase.numargs(::Any)
@non_differentiable SciMLBase.isinplace(::Any, ::Any)
@non_differentiable SciMLBase.isinplace(::Any, ::Any, ::Any)
@non_differentiable SciMLBase.isinplace(::Any, ::Any, ::Any, ::Any)

function ChainRulesCore.rrule(
        config::ChainRulesCore.RuleConfig{
            >:ChainRulesCore.HasReverseMode,
        },
        ::typeof(getindex),
        VA::ODESolution,
        sym,
        j::Integer
    )
    function ODESolution_getindex_pullback(Δ)
        i = symbolic_type(sym) != NotSymbolic() ? variable_index(VA, sym) : sym
        du,
            dprob = if i === nothing
            getter = getobserved(VA)
            grz = rrule_via_ad(config, getter, sym, VA.u[j], VA.prob.p, VA.t[j])[2](Δ)
            du = [k == j ? grz[3] : zero(VA.u[1]) for k in 1:length(VA.u)]
            dp = grz[4] # pullback for p
            if dp == NoTangent()
                dp = zero_tangent(parameter_values(VA.prob))
            end
            dprob = remake(VA.prob, p = dp)
            du, dprob
        else
            du = [
                m == j ? [i == k ? Δ : zero(VA.u[1][1]) for k in 1:length(VA.u[1])] :
                    zero(VA.u[1]) for m in 1:length(VA.u)
            ]
            dp = zero_tangent(VA.prob.p)
            dprob = remake(VA.prob, p = dp)
            du, dprob
        end
        T = eltype(eltype(du))
        N = ndims(eltype(du)) + 1
        Δ′ = ODESolution{T, N}(
            du, nothing, nothing, VA.t, VA.k, nothing, dprob,
            VA.alg, VA.interp, VA.dense, 0, VA.stats, VA.alg_choice, VA.retcode
        )
        return (NoTangent(), Δ′, NoTangent(), NoTangent())
    end
    return VA[sym, j], ODESolution_getindex_pullback
end

function ChainRulesCore.rrule(::typeof(getindex), VA::ODESolution, sym)
    function ODESolution_getindex_pullback(Δ)
        i = symbolic_type(sym) != NotSymbolic() ? variable_index(VA, sym) : sym
        return if i === nothing
            throw(error("AD of purely-symbolic slicing for observed quantities is not yet supported. Work around this by using `A[sym,i]` to access each element sequentially in the function being differentiated."))
        else
            Δ′ = [
                [i == k ? Δ[j] : zero(x[1]) for k in 1:length(x)]
                    for (x, j) in zip(VA.u, 1:length(VA))
            ]
            (NoTangent(), Δ′, NoTangent())
        end
    end
    return VA[sym], ODESolution_getindex_pullback
end

# NOTE: Constructor rrules for ODEProblem were removed. ODEProblem is a mutable struct,
# and Zygote's mutable struct tangent cache is not reset between repeated pullback calls
# when a constructor rrule exists (the Jnew reset in Zygote src/lib/lib.jl is bypassed).
# This caused Zygote.jacobian and repeated pullback calls to accumulate gradients
# incorrectly. Without these rrules, Zygote traces through the constructor natively
# using __new__/__splatnew__ which has proper cache reset.

function ChainRulesCore.rrule(::Type{SDEProblem}, args...; kwargs...)
    function SDEProblemAdjoint(ȳ)
        return (NoTangent(), ȳ.f, ȳ.g, ȳ.u0, ȳ.tspan, ȳ.p, ȳ.kwargs, ȳ.problem_type)
    end

    return SDEProblem(args...; kwargs...), SDEProblemAdjoint
end

function ChainRulesCore.rrule(
        ::Type{
            <:ODESolution{
                T1, T2, T3, T4, T5, T6, T7, T8, T9, T10,
                T11, T12, T13, T14, T15, T16,
            },
        }, u,
        args...
    ) where {
        T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11,
        T12, T13, T14, T15, T16,
    }
    function ODESolutionAdjoint(ȳ)
        return (NoTangent(), ȳ, ntuple(_ -> NoTangent(), length(args))...)
    end

    return ODESolution{T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16}(
            u, args...
        ),
        ODESolutionAdjoint
end

function ChainRulesCore.rrule(
        ::Type{
            <:RODESolution{
                T1, T2, T3, T4, T5, T6, T7, T8, T9, T10,
                T11, T12, T13, T14,
            },
        }, u,
        args...
    ) where {
        T1, T2, T3, T4, T5, T6, T7, T8, T9, T10,
        T11, T12, T13, T14,
    }
    function RODESolutionAdjoint(ȳ)
        return (NoTangent(), ȳ, ntuple(_ -> NoTangent(), length(args))...)
    end

    return RODESolution{
            T1, T2, T3, T4, T5, T6, T7, T8, T9, T10,
            T11, T12, T13, T14,
        }(u, args...),
        RODESolutionAdjoint
end

# EnsembleSolution rrule with full support for various gradient types
# Matches the Zygote extension implementation for consistency
function ChainRulesCore.rrule(
        ::Type{EnsembleSolution}, sim, time, converged, stats = nothing
    )
    out = EnsembleSolution(sim, time, converged, stats)
    function EnsembleSolution_adjoint(p̄::AbstractArray{T, N}) where {T, N}
        arrarr = [
            [
                    p̄[ntuple(x -> Colon(), Val(N - 2))..., j, i]
                    for j in 1:size(p̄)[end - 1]
                ] for i in 1:size(p̄)[end]
        ]
        return (
            NoTangent(),
            EnsembleSolution(arrarr, 0.0, true, stats),
            NoTangent(),
            NoTangent(),
            NoTangent(),
        )
    end
    function EnsembleSolution_adjoint(p̄::AbstractArray{<:AbstractArray, 1})
        return (
            NoTangent(),
            EnsembleSolution(p̄, 0.0, true, stats),
            NoTangent(),
            NoTangent(),
            NoTangent(),
        )
    end
    function EnsembleSolution_adjoint(p̄::AbstractVectorOfArray)
        return (
            NoTangent(),
            EnsembleSolution(p̄, 0.0, true, stats),
            NoTangent(),
            NoTangent(),
            NoTangent(),
        )
    end
    function EnsembleSolution_adjoint(p̄::EnsembleSolution)
        return (NoTangent(), p̄, NoTangent(), NoTangent(), NoTangent())
    end
    function EnsembleSolution_adjoint(p̄::NamedTuple)
        return (NoTangent(), p̄.u, NoTangent(), NoTangent(), NoTangent())
    end
    return out, EnsembleSolution_adjoint
end

function ChainRulesCore.rrule(
        ::Type{SciMLBase.IntervalNonlinearProblem}, args...; kwargs...
    )
    function IntervalNonlinearProblemAdjoint(ȳ)
        return (NoTangent(), ȳ.f, ȳ.tspan, ȳ.p, ȳ.kwargs, ȳ.problem_type)
    end

    return SciMLBase.IntervalNonlinearProblem(args...; kwargs...), IntervalNonlinearProblemAdjoint
end

# This is a workaround for the fact `NonlinearProblem` is a mutable struct. In SciMLSensitivity, we call
# `back` explicitly while already in a reverse pass causing a nested gradient call. The mutable struct
# causes accumulation anytime `getfield/property` is called, accumulating multiple times. This tries to treat
# AbstractDEProblem as immutable for the purposes of reverse mode AD.
function ChainRulesCore.rrule(
        ::ChainRulesCore.RuleConfig{>:ChainRulesCore.HasReverseMode},
        ::typeof(Base.getproperty), x::NonlinearProblem, f::Symbol
    )
    val = getfield(x, f)
    function back(der)
        dx = if der === nothing
            ChainRulesCore.zero_tangent(x)
        else
            NamedTuple{(f,)}((der,))
        end
        return (
            ChainRulesCore.NoTangent(), ChainRulesCore.ProjectTo(x)(dx),
            ChainRulesCore.NoTangent(),
        )
    end
    return val, back
end

end

@generated function struct_as_namedtuple(st)
    A = (Expr(:(=), n, :(st.$n)) for n in setdiff(fieldnames(st), (:kwargs,)))
    return Expr(:tuple, A...)
end

Base.@pure function remaker_of(prob::T) where {T <: AbstractSciMLProblem}
    parameterless_type(T){isinplace(prob)}
end
Base.@pure remaker_of(alg::T) where {T} = parameterless_type(T)

# Define `remaker_of` for the types that does not (make sense to)
# implement `isinplace` trait:
for T in [
        NoiseProblem,
        SplitFunction,  # TODO: use isinplace path for type-stability
        TwoPointBVPFunction,    # EnsembleProblem,
    ]
    @eval remaker_of(::$T) = $T
end

"""
    remake(thing; <keyword arguments>)

Re-construct `thing` with new field values specified by the keyword
arguments.
"""
function remake(thing; kwargs...)
    return _remake_internal(thing; kwargs...)
end

function _remake_internal(thing; kwargs...)
    T = remaker_of(thing)
    named_thing = struct_as_namedtuple(thing)
    return if :kwargs ∈ fieldnames(typeof(thing))
        if :args ∈ fieldnames(typeof(thing))
            named_thing = Base.structdiff(named_thing, (; args = ()))
            if :args ∉ keys(kwargs)
                k = Base.structdiff(named_thing, (; args = ()))
                if :kwargs ∉ keys(kwargs)
                    T(; named_thing..., thing.kwargs..., kwargs...)
                else
                    T(; named_thing..., kwargs[:kwargs]...)
                end
            else
                kwargs2 = Base.structdiff((; kwargs...), (; args = ()))
                if :kwargs ∉ keys(kwargs)
                    T(kwargs[:args]...; named_thing..., thing.kwargs..., kwargs2...)
                else
                    T(kwargs[:args]...; named_thing..., kwargs2[:kwargs]...)
                end
            end
        else
            if :kwargs ∉ keys(kwargs)
                T(; named_thing..., thing.kwargs..., kwargs...)
            else
                T(; named_thing..., kwargs[:kwargs]...)
            end
        end
    else
        T(; named_thing..., kwargs...)
    end
end

function isrecompile(prob::ODEProblem{iip}) where {iip}
    return (prob.f isa ODEFunction) ? !isfunctionwrapper(prob.f.f) : true
end

"""
    remake(prob::AbstractSciMLProblem; u0 = missing, p = missing, interpret_symbolicmap = true, use_defaults = false)

Remake the given problem `prob`. If `u0` or `p` are given, they will be used instead
of the unknowns/parameters of the problem. Either of them can be a symbolic map if
the problem has an associated system. If `interpret_symbolicmap == false`, `p` will never
be interpreted as a symbolic map and used as-is for parameters. `use_defaults` allows
controlling whether the default values from the system will be used to calculate missing
values in the symbolic map passed to `u0` or `p`. It is only valid when either `u0` or
`p` have been explicitly provided as a symbolic map and the problem has an associated
system.
"""
function remake(
        prob::AbstractSciMLProblem; u0 = missing,
        p = missing, interpret_symbolicmap = true, use_defaults = false, kwargs...
    )
    u0, p = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)
    return _remake_internal(prob; kwargs..., u0, p)
end

function remake(
        prob::AbstractIntervalNonlinearProblem; p = missing,
        interpret_symbolicmap = true, use_defaults = false, kwargs...
    )
    _, p = updated_u0_p(prob, [], p; interpret_symbolicmap, use_defaults)
    return _remake_internal(prob; kwargs..., p)
end

function remake(prob::AbstractNoiseProblem; kwargs...)
    return _remake_internal(prob; kwargs...)
end

function remake(
        prob::AbstractIntegralProblem; p = missing, interpret_symbolicmap = true, use_defaults = false, kwargs...
    )
    _, p = updated_u0_p(prob, nothing, p; interpret_symbolicmap, use_defaults)
    return _remake_internal(prob; kwargs..., p)
end

"""
    $(TYPEDSIGNATURES)

Check if the type `T` of an `AbstractSciMLFunction` has any type-erased (abstract) type
parameters beyond `iip` and `specialize`. Returns `true` if any field type parameter (index
3 and beyond) is not a concrete type (`isconcretetype` returns false), indicating that type
erasure was applied (e.g. by `promote_f` for AutoSpecialize compilation caching).
"""
@generated function _has_type_erased_params(::Type{T}) where {T <: AbstractSciMLFunction}
    params = T.parameters
    for i in 3:length(params)
        p = params[i]
        if !isconcretetype(p)
            return true
        end
    end
    return false
end

"""
    $(TYPEDSIGNATURES)

Reconstruct `source` preserving the non-concrete (erased) type parameters from
`TargetType` while using `source`'s actual concrete types for all other parameters.

Used to preserve type erasure from `promote_f`/`unwrapped_f` for AutoSpecialize:
the keyword constructor in `remake` narrows abstract type parameters back to concrete
types, and this function restores the erased type parameters (e.g. `Union{Nothing,
OverrideInitData}` for initialization_data) while allowing concrete field types
(like the function `f`) to change freely.
"""
@generated function _reconstruct_as_type(
        ::Type{TargetType}, source::SourceType
    ) where {TargetType <: AbstractSciMLFunction, SourceType <: AbstractSciMLFunction}
    target_params = collect(TargetType.parameters)
    source_params = collect(SourceType.parameters)

    # For erased (non-concrete) type parameters at index >= 3, keep the target's
    # abstract type. For all other parameters, use the source's actual type.
    mixed_params = similar(target_params, Any)
    for i in eachindex(target_params)
        if i >= 3 && !isconcretetype(target_params[i])
            mixed_params[i] = target_params[i]
        else
            mixed_params[i] = source_params[i]
        end
    end

    MixedType = TargetType.name.wrapper{mixed_params...}
    nf = fieldcount(MixedType)
    field_exprs = [:(getfield(source, $i)) for i in 1:nf]
    return :($(MixedType)($(field_exprs...)))
end

"""
    $(TYPEDSIGNATURES)

Widen all bounded type parameters of an `AbstractSciMLFunction` to their upper bounds.

For example, an `ODEFunction` has `ID <: Union{Nothing, OverrideInitData}` and
`NLP <: Union{Nothing, ODENLStepData}`. This function replaces the concrete types of
those parameters with `Union{Nothing, OverrideInitData}` and `Union{Nothing, ODENLStepData}`
respectively, while leaving all unbounded (`<: Any`) type parameters concrete.

This ensures that all AutoSpecialize instances of a function type share the same type
regardless of model-specific details (e.g. initialization functions), preventing
recompilation of `promote_f` and solver code for each model.
"""
@generated function widen_bounded_type_params(f::F) where {F <: AbstractSciMLFunction}
    # Walk the UnionAll chain to collect TypeVars and their upper bounds
    wrapper = F.name.wrapper
    typevars = TypeVar[]
    body = wrapper
    while body isa UnionAll
        push!(typevars, body.var)
        body = body.body
    end

    params = collect(F.parameters)
    new_params = similar(params, Any)
    for i in eachindex(params)
        if i <= length(typevars) && typevars[i].ub !== Any
            new_params[i] = typevars[i].ub
        else
            new_params[i] = params[i]
        end
    end

    NewType = wrapper{new_params...}
    nf = fieldcount(NewType)
    field_exprs = [:(getfield(f, $i)) for i in 1:nf]
    return :($(NewType)($(field_exprs...)))
end

"""
    $(TYPEDSIGNATURES)

A utility function which merges two `NamedTuple`s `a` and `b`, assuming that the
keys of `a` are a subset of those of `b`. Values in `b` take priority over those
in `a`, except if they are `nothing`. Keys not present in `a` are assumed to have
a value of `nothing`.
"""
function _similar_namedtuple_merge_ignore_nothing(a::NamedTuple, b::NamedTuple)
    ks = fieldnames(typeof(b))
    return NamedTuple{ks}(
        ntuple(Val(length(ks))) do i
            something(get(b, ks[i], nothing), get(a, ks[i], nothing), Some(nothing))
        end
    )
end

"""
    remake(func::AbstractSciMLFunction; f = missing, g = missing, f2 = missing, kwargs...)

`remake` the given `func`. Return an `AbstractSciMLFunction` of the same kind, `isinplace` and
`specialization` as `func`. Retain the properties of `func`, except those that are overridden
by keyword arguments. For stochastic functions (e.g. `SDEFunction`) the `g` keyword argument
is used to override `func.g`. For split functions (e.g. `SplitFunction`) the `f2` keyword
argument is used to override `func.f2`, and `f` is used for `func.f1`. If
`f isa AbstractSciMLFunction` and `func` is not a split function, properties of `f` will
override those of `func` (but not ones provided via keyword arguments). Properties of `f` that
are `nothing` will fall back to those in `func` (unless provided via keyword arguments). If
`f` is a different type of `AbstractSciMLFunction` from `func`, the returned function will be
of the kind of `f` unless `func` is a split function. If `func` is a split function, `f` and
`f2` will be wrapped in the appropriate `AbstractSciMLFunction` type with the same `isinplace`
and `specialization` as `func`.
"""
function remake(
        func::AbstractSciMLFunction; f = missing, g = missing, f2 = missing, kwargs...
    )
    # retain iip and spec of original function
    iip = isinplace(func)
    spec = specialization(func)
    # retain properties of original function
    props = getproperties(func)
    forig = f

    if f === missing || is_split_function(func)
        # if no `f` is provided, create the same type of SciMLFunction
        T = parameterless_type(func)
        f = isdefined(func, :f) ? func.f : func.f1
    elseif f isa AbstractSciMLFunction
        iip = isinplace(f)
        spec = specialization(f)
        # if `f` is a SciMLFunction, create that type
        T = parameterless_type(f)
        # properties of `f` take priority over those in the existing `func`
        # ignore properties of `f` which are `nothing` but present in `func`
        props = _similar_namedtuple_merge_ignore_nothing(props, getproperties(f))
        f = isdefined(f, :f) ? f.f : f.f1
    else
        # if `f` is provided but not a SciMLFunction, create the same type
        T = parameterless_type(func)
    end

    # minor hack to avoid breaking MTK, since prior to ~9.57 in `remake_initialization_data`
    # it creates a `NonlinearFunction` inside a `NonlinearFunction`. Just recursively unwrap
    # in this case and forget about properties.
    while !is_split_function(T) && f isa AbstractSciMLFunction
        f = isdefined(f, :f) ? f.f : f.f1
    end

    props = @delete props.f
    props = @delete props.f1

    args = (f,)
    if is_split_function(T)
        # `f1` and `f2` are wrapped in another SciMLFunction, unless they're
        # already wrapped in the appropriate type or are an `AbstractSciMLOperator`
        if !(f isa Union{AbstractSciMLOperator, split_function_f_wrapper(T)})
            f = split_function_f_wrapper(T){iip, spec}(f)
        end
        if hasproperty(func, :f2)
            # For SplitFunction
            # we don't do the same thing as `g`, because for SDEs `g` is
            # stored in the problem as well, whereas for Split ODEs etc
            # f2 is a part of the function. Thus, if the user provides
            # a SciMLFunction for `f` which contains `f2` we use that.
            f2 = coalesce(f2, get(props, :f2, missing), func.f2)
            if !(f2 isa Union{AbstractSciMLOperator, split_function_f_wrapper(T)})
                f2 = split_function_f_wrapper(T){iip, spec}(f2)
            end

            props = @delete props.f2

            if !ismissing(forig) && hasproperty(forig, :_func_cache)
                props = @delete props._func_cache
                props = @insert props._func_cache = forig._func_cache
            end

            args = (args..., f2)
        end
    end
    if isdefined(func, :g)
        # For SDEs/SDDEs where `g` is not a keyword
        g = coalesce(g, func.g)
        props = @delete props.g
        args = (args..., g)
    end
    result = T{iip, spec}(args...; props..., kwargs...)
    # Preserve type erasure from AutoSpecialize's promote_f. The keyword constructor
    # above uses typeof(field) for each type parameter, which restores concrete types
    # and undoes the intentional type erasure. Re-apply the original abstract type
    # parameters to maintain compilation caching benefits.
    # The _has_type_erased_params check is @generated and resolves at compile time,
    # so this branch is eliminated entirely for the common non-erased case.
    #
    # Check both `func` (the original function being remade) and `forig` (the incoming
    # `f` keyword argument, if it was an AbstractSciMLFunction). When `get_concrete_problem`
    # calls `remake(prob; f=promoted_f)`, the promoted_f from `unwrapped_f` has type-erased
    # params but the original `prob.f` does not — so we must check `forig` too.
    if _has_type_erased_params(typeof(func))
        return _reconstruct_as_type(typeof(func), result)
    elseif forig isa AbstractSciMLFunction && _has_type_erased_params(typeof(forig))
        return _reconstruct_as_type(typeof(forig), result)
    end
    return result
end

"""
    remake(prob::ODEProblem; f = missing, u0 = missing, tspan = missing,
           p = missing, kwargs = missing, _kwargs...)

Remake the given `ODEProblem`.
If `u0` or `p` are given as symbolic maps `ModelingToolkit.jl` has to be loaded.
"""
function remake(
        prob::ODEProblem; f = missing,
        u0 = missing,
        tspan = missing,
        p = missing,
        kwargs = missing,
        interpret_symbolicmap = true,
        build_initializeprob = Val{true},
        use_defaults = false,
        lazy_initialization = nothing,
        _kwargs...
    )
    if tspan === missing
        tspan = prob.tspan
    end

    newu0, newp = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    iip = isinplace(prob)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, tspan[1], p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, tspan[1], p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    f = coalesce(f, prob.f)
    f = remake(prob.f; f, initialization_data)

    if specialization(f) === FunctionWrapperSpecialize
        ptspan = promote_tspan(tspan)
        if iip
            f = remake(
                f; f = wrapfun_iip(unwrapped_f(f.f), (newu0, newu0, newp, ptspan[1]))
            )
        else
            f = remake(
                f; f = wrapfun_oop(unwrapped_f(f.f), (newu0, newu0, newp, ptspan[1]))
            )
        end
    end

    prob = if kwargs === missing
        ODEProblem{iip}(
            f, newu0, tspan, newp, prob.problem_type; prob.kwargs...,
            _kwargs...
        )
    else
        ODEProblem{iip}(f, newu0, tspan, newp, prob.problem_type; kwargs...)
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

function SciMLBase.remake(
        prob::AbstractDynamicOptProblem; f = missing,
        u0 = missing,
        tspan = missing,
        p = missing,
        wrapped_model = missing,
        kwargs = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        lazy_initialization = nothing,
        _kwargs...
    )

    if tspan === missing
        tspan = prob.tspan
    end

    newu0, newp = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    f = coalesce(f, prob.f)
    wrapped_model = coalesce(wrapped_model, prob.wrapped_model)

    T = parameterless_type(typeof(prob))

    prob = if kwargs === missing
        T(f, newu0, tspan, newp, wrapped_model; prob.kwargs..., _kwargs...)
    else
        T(f, newu0, tspan, newp, wrapped_model; kwargs...)
    end

    u0, p = maybe_eager_initialize_problem(prob, nothing, lazy_initialization)

    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

"""
    remake_initializeprob(sys, scimlfn, u0, t0, p)

!!! warning
    This method is deprecated. Please see `remake_initialization_data`

Re-create the initialization problem present in the function `scimlfn`, using the
associated system `sys`, and the user-provided new values of `u0`, initial time `t0` and
`p`. By default, returns `nothing, nothing, nothing, nothing` if `scimlfn` does not have an
initialization problem, and
`scimlfn.initializeprob, scimlfn.update_initializeprob!, scimlfn.initializeprobmap, scimlfn.initializeprobpmap`
if it does.

Note that `u0` or `p` may be `missing` if the user does not provide a value for them.
"""
function remake_initializeprob(sys, scimlfn, u0, t0, p)
    if !has_initialization_data(scimlfn)
        return nothing, nothing, nothing, nothing
    end
    initdata = scimlfn.initialization_data
    return initdata.initializeprob, initdata.update_initializeprob!,
        initdata.initializeprobmap, initdata.initializeprobpmap
end

"""
    $(TYPEDSIGNATURES)

Wrapper around `remake_initialization_data` for backward compatibility when `newu0` and
`newp` were not arguments.
"""
function remake_initialization_data_compat_wrapper(sys, scimlfn, u0, t0, p, newu0, newp)
    return if hasmethod(
            remake_initialization_data,
            Tuple{typeof(sys), typeof(scimlfn), typeof(u0), typeof(t0), typeof(p)}
        )
        remake_initialization_data(sys, scimlfn, u0, t0, p)
    else
        remake_initialization_data(sys, scimlfn, u0, t0, p, newu0, newp)
    end
end

"""
    remake_initialization_data(sys, scimlfn, u0, t0, p, newu0, newp)

Re-create the initialization data present in the function `scimlfn`, using the
associated system `sys`, the user provided new values of `u0`, initial time `t0`,
user-provided `p`, new u0 vector `newu0` and new parameter object `newp`. By default,
this calls `remake_initializeprob` for backward compatibility and attempts to construct
an `OverrideInitData` from the result.

Note that `u0` or `p` may be `missing` if the user does not provide a value for them.
"""
function remake_initialization_data(sys, scimlfn, u0, t0, p, newu0, newp)
    return reconstruct_initialization_data(
        nothing, remake_initializeprob(sys, scimlfn, u0, t0, p)...
    )
end

"""
    remake(prob::BVProblem; f = missing, u0 = missing, tspan = missing,
           p = missing, kwargs = missing, problem_type = missing, _kwargs...)

Remake the given `BVProblem`.
"""
function remake(
        prob::BVProblem{uType, tType, iip, nlls}; f = missing, bc = missing,
        u0 = missing, tspan = missing, p = missing, kwargs = missing, problem_type = missing,
        interpret_symbolicmap = true, use_defaults = false, _kwargs...
    ) where {
        uType, tType, iip, nlls,
    }
    if tspan === missing
        tspan = prob.tspan
    end

    u0, p = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    if problem_type === missing
        problem_type = prob.problem_type
    end

    twopoint = problem_type isa TwoPointBVProblem

    if bc === missing
        bc = prob.f.bc
    end

    if f === missing
        _f = prob.f
    elseif f isa BVPFunction
        _f = f
        bc = f.bc
    elseif specialization(prob.f) === FunctionWrapperSpecialize
        ptspan = promote_tspan(tspan)
        if iip
            _f = BVPFunction{iip, FunctionWrapperSpecialize, twopoint}(
                wrapfun_iip(
                    f,
                    (u0, u0, p, ptspan[1])
                ), bc; prob.f.bcresid_prototype
            )
        else
            _f = BVPFunction{iip, FunctionWrapperSpecialize, twopoint}(
                wrapfun_oop(
                    f,
                    (u0, p, ptspan[1])
                ), bc; prob.f.bcresid_prototype
            )
        end
    else
        _f = BVPFunction{isinplace(prob), specialization(prob.f), twopoint}(
            f, bc;
            prob.f.bcresid_prototype
        )
    end

    return if kwargs === missing
        BVProblem{iip}(
            _f, bc, u0, tspan, p; problem_type, nlls = Val(nlls), prob.kwargs...,
            _kwargs...
        )
    else
        BVProblem{iip}(_f, bc, u0, tspan, p; problem_type, nlls = Val(nlls), kwargs...)
    end
end

"""
    remake(prob::SDEProblem; f = missing, g = missing, u0 = missing, tspan = missing,
           p = missing, noise = missing, noise_rate_prototype = missing,
           seed = missing, kwargs = missing, _kwargs...)

Remake the given `SDEProblem`.
"""
function remake(
        prob::SDEProblem;
        f = missing,
        g = missing,
        u0 = missing,
        tspan = missing,
        p = missing,
        noise = missing,
        noise_rate_prototype = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        seed = missing,
        kwargs = missing,
        lazy_initialization = nothing,
        build_initializeprob = Val{true},
        _kwargs...
    )
    if tspan === missing
        tspan = prob.tspan
    end

    newu0, newp = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, tspan[1], p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, tspan[1], p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    if noise === missing
        noise = prob.noise
    end

    if noise_rate_prototype === missing
        noise_rate_prototype = prob.noise_rate_prototype
    end

    if seed === missing
        seed = prob.seed
    end
    f = coalesce(f, prob.f)
    g = coalesce(g, prob.g)
    f = remake(prob.f; f, g, initialization_data)
    iip = isinplace(prob)

    prob = if kwargs === missing
        SDEProblem{iip}(
            f,
            newu0,
            tspan,
            newp;
            noise,
            noise_rate_prototype,
            seed,
            prob.kwargs...,
            _kwargs...
        )
    else
        SDEProblem{iip}(f, newu0, tspan, newp; noise, noise_rate_prototype, seed, kwargs...)
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

function remake(
        prob::DDEProblem; f = missing, h = missing, u0 = missing,
        tspan = missing, p = missing, constant_lags = missing,
        dependent_lags = missing, order_discontinuity_t0 = missing,
        neutral = missing, kwargs = missing, interpret_symbolicmap = true,
        use_defaults = false, lazy_initialization = nothing, build_initializeprob = Val{true},
        _kwargs...
    )
    if tspan === missing
        tspan = prob.tspan
    end

    newu0, newp = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, tspan[1], p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, tspan[1], p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    f = coalesce(f, prob.f)
    f = remake(prob.f; f, initialization_data)

    h = coalesce(h, prob.h)
    constant_lags = coalesce(constant_lags, prob.constant_lags)
    dependent_lags = coalesce(dependent_lags, prob.dependent_lags)
    order_discontinuity_t0 = coalesce(order_discontinuity_t0, prob.order_discontinuity_t0)
    neutral = coalesce(neutral, prob.neutral)

    iip = isinplace(prob)

    prob = if kwargs === missing
        DDEProblem{iip}(
            f,
            newu0,
            h,
            tspan,
            newp;
            constant_lags,
            dependent_lags,
            order_discontinuity_t0,
            neutral,
            prob.kwargs...,
            _kwargs...
        )
    else
        DDEProblem{iip}(
            f, newu0, h, tspan, newp; constant_lags, dependent_lags,
            order_discontinuity_t0, neutral, kwargs...
        )
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

function remake(
        prob::SDDEProblem;
        f = missing,
        g = missing,
        h = missing,
        u0 = missing,
        tspan = missing,
        p = missing,
        constant_lags = missing,
        dependent_lags = missing,
        order_discontinuity_t0 = missing,
        neutral = missing,
        noise = missing,
        noise_rate_prototype = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        seed = missing,
        kwargs = missing,
        lazy_initialization = nothing,
        build_initializeprob = Val{true},
        _kwargs...
    )
    if tspan === missing
        tspan = prob.tspan
    end

    newu0, newp = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, tspan[1], p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, tspan[1], p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    if noise === missing
        noise = prob.noise
    end

    if noise_rate_prototype === missing
        noise_rate_prototype = prob.noise_rate_prototype
    end

    if seed === missing
        seed = prob.seed
    end

    f = coalesce(f, prob.f)
    g = coalesce(g, prob.g)
    f = remake(prob.f; f, g, initialization_data)
    iip = isinplace(prob)

    h = coalesce(h, prob.h)
    constant_lags = coalesce(constant_lags, prob.constant_lags)
    dependent_lags = coalesce(dependent_lags, prob.dependent_lags)
    order_discontinuity_t0 = coalesce(order_discontinuity_t0, prob.order_discontinuity_t0)
    neutral = coalesce(neutral, prob.neutral)

    prob = if kwargs === missing
        SDDEProblem{iip}(
            f,
            g,
            newu0,
            h,
            tspan,
            newp;
            noise,
            noise_rate_prototype,
            seed,
            constant_lags,
            dependent_lags,
            order_discontinuity_t0,
            neutral,
            prob.kwargs...,
            _kwargs...
        )
    else
        SDDEProblem{iip}(
            f, g, newu0, tspan, newp; noise, noise_rate_prototype, seed, constant_lags,
            dependent_lags, order_discontinuity_t0, neutral, kwargs...
        )
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

"""
    remake(prob::DAEProblem; f = missing, du0 = missing, u0 = missing, tspan = missing,
           p = missing, differential_vars = missing, kwargs = missing, _kwargs...)

Remake the given `DAEProblem`.
If `u0` or `p` are given as symbolic maps `ModelingToolkit.jl` has to be loaded.
"""
function remake(
        prob::DAEProblem; f = missing,
        du0 = missing,
        u0 = missing,
        tspan = missing,
        p = missing,
        differential_vars = missing,
        kwargs = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        lazy_initialization = nothing,
        build_initializeprob = Val{true},
        _kwargs...
    )
    if tspan === missing
        tspan = prob.tspan
    end

    newu0, newp = updated_u0_p(prob, u0, p, tspan[1]; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, tspan[1], p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, tspan[1], p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    f = coalesce(f, prob.f)
    f = remake(prob.f; f, initialization_data)

    du0 = coalesce(du0, prob.du0)
    differential_vars = coalesce(differential_vars, prob.differential_vars)

    iip = isinplace(prob)

    prob = if kwargs === missing
        DAEProblem{iip}(f, du0, newu0, tspan, newp; differential_vars, prob.kwargs..., _kwargs...)
    else
        DAEProblem{iip}(f, du0, newu0, tspan, newp; differential_vars, kwargs...)
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

"""
    remake(prob::OptimizationProblem; f = missing, u0 = missing, p = missing,
        lb = missing, ub = missing, int = missing, lcons = missing, ucons = missing,
        sense = missing, kwargs = missing, _kwargs...)

Remake the given `OptimizationProblem`.
If `u0` or `p` are given as symbolic maps `ModelingToolkit.jl` has to be loaded.
"""
function remake(
        prob::OptimizationProblem;
        f = missing,
        u0 = missing,
        p = missing,
        lb = missing,
        ub = missing,
        int = missing,
        lcons = missing,
        ucons = missing,
        sense = missing,
        kwargs = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        _kwargs...
    )
    u0, p = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)
    if f === missing
        f = prob.f
    end
    if lb === missing
        lb = prob.lb
    end
    if ub === missing
        ub = prob.ub
    end
    if int === missing
        int = prob.int
    end
    if lcons === missing
        lcons = prob.lcons
    end
    if ucons === missing
        ucons = prob.ucons
    end
    if sense === missing
        sense = prob.sense
    end

    return if kwargs === missing
        OptimizationProblem{isinplace(prob)}(
            f = f, u0 = u0, p = p, lb = lb,
            ub = ub, int = int,
            lcons = lcons, ucons = ucons,
            sense = sense; prob.kwargs..., _kwargs...
        )
    else
        OptimizationProblem{isinplace(prob)}(
            f = f, u0 = u0, p = p, lb = lb,
            ub = ub, int = int,
            lcons = lcons, ucons = ucons,
            sense = sense; kwargs...
        )
    end
end

"""
    remake(prob::NonlinearProblem; f = missing, u0 = missing, p = missing,
        problem_type = missing, kwargs = missing, _kwargs...)

Remake the given `NonlinearProblem`.
If `u0` or `p` are given as symbolic maps `ModelingToolkit.jl` has to be loaded.
"""
function remake(
        prob::NonlinearProblem;
        f = missing,
        u0 = missing,
        p = missing,
        problem_type = missing,
        kwargs = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        lazy_initialization = nothing,
        build_initializeprob = Val{true},
        _kwargs...
    )
    newu0, newp = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, nothing, p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, nothing, p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    f = coalesce(f, prob.f)
    f = remake(prob.f; f, initialization_data)

    if problem_type === missing
        problem_type = prob.problem_type
    end

    prob = if kwargs === missing
        NonlinearProblem{isinplace(prob)}(
            f = f, u0 = newu0, p = newp,
            problem_type = problem_type; prob.kwargs...,
            _kwargs...
        )
    else
        NonlinearProblem{isinplace(prob)}(
            f = f, u0 = newu0, p = newp,
            problem_type = problem_type; kwargs...
        )
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

function remake(
        prob::SteadyStateProblem;
        f = missing,
        u0 = missing,
        p = missing,
        kwargs = missing,
        interpret_symbolicmap = true,
        use_defaults = false,
        lazy_initialization = nothing,
        build_initializeprob = Val{true},
        _kwargs...
    )
    newu0, newp = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, Inf, p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, Inf, p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    f = coalesce(f, prob.f)
    f = remake(prob.f; f, initialization_data)

    prob = if kwargs === missing
        SteadyStateProblem{isinplace(prob)}(
            f = f, u0 = newu0, p = newp; prob.kwargs...,
            _kwargs...
        )
    else
        SteadyStateProblem{isinplace(prob)}(f = f, u0 = newu0, p = newp; kwargs...)
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

"""
    remake(prob::NonlinearLeastSquaresProblem; f = missing, u0 = missing, p = missing,
        kwargs = missing, _kwargs...)

Remake the given `NonlinearLeastSquaresProblem`.
"""
function remake(
        prob::NonlinearLeastSquaresProblem; f = missing, u0 = missing, p = missing,
        interpret_symbolicmap = true, use_defaults = false, kwargs = missing,
        lazy_initialization = nothing, build_initializeprob = Val{true}, _kwargs...
    )
    newu0, newp = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)

    if build_initializeprob == Val{true} || build_initializeprob == true
        if f !== missing && has_initialization_data(f)
            initialization_data = remake_initialization_data(
                prob.f.sys, f, u0, nothing, p, newu0, newp
            )
        else
            initialization_data = remake_initialization_data(
                prob.f.sys, prob.f, u0, nothing, p, newu0, newp
            )
        end
    else
        initialization_data = nothing
    end

    f = coalesce(f, prob.f)
    f = remake(prob.f; f, initialization_data)

    prob = if kwargs === missing
        prob = NonlinearLeastSquaresProblem{isinplace(prob)}(;
            f, u0 = newu0, p = newp, prob.kwargs...,
            _kwargs...
        )
    else
        prob = NonlinearLeastSquaresProblem{isinplace(prob)}(;
            f, u0 = newu0, p = newp, kwargs...
        )
    end

    u0, p = maybe_eager_initialize_problem(prob, initialization_data, lazy_initialization)
    @reset prob.u0 = u0
    @reset prob.p = p

    return prob
end

function scc_update_subproblems(probs::Vector, newu0, newp, parameters_alias)
    offset = Ref(0)
    return map(probs) do subprob
        # N should be inferred if `prob` is type-stable and `subprob.u0 isa StaticArray`
        N = length(state_values(subprob))
        if ArrayInterface.ismutable(newu0)
            _u0 = newu0[(offset[] + 1):(offset[] + N)]
        else
            _u0 = StaticArraysCore.similar_type(
                newu0, StaticArraysCore.Size(N)
            )(newu0[(offset[] + 1):(offset[] + N)])
        end
        subprob = if parameters_alias === Val(true)
            remake(subprob; u0 = _u0, p = newp)
        else
            remake(subprob; u0 = _u0)
        end
        offset[] += length(state_values(subprob))
        return subprob
    end
end

@inline _scc_update_subproblems(newu0, newp, ::Val{P}, offset::Int) where {P} = ()
@inline function _scc_update_subproblems(
        newu0, newp, ::Val{parameters_alias}, offset::Int,
        subprob, probs...
    ) where {parameters_alias}
    u0 = state_values(subprob)
    if u0 !== nothing
        N = length(state_values(subprob))
        if ArrayInterface.ismutable(newu0)
            _u0 = newu0[(offset + 1):(offset + N)]
        else
            _u0 = StaticArraysCore.similar_type(
                newu0, StaticArraysCore.Size(N)
            )(newu0[(offset + 1):(offset + N)])
        end
        if parameters_alias
            subprob = remake(subprob; u0 = _u0, p = newp)
        else
            subprob = remake(subprob; u0 = _u0)
        end
        offset += N
    end

    return (
        subprob,
        _scc_update_subproblems(newu0, newp, Val{parameters_alias}(), offset, probs...)...,
    )
end

function scc_update_subproblems(probs::Tuple, newu0, newp, ::Val{P}) where {P}
    return _scc_update_subproblems(newu0, newp, Val{P}(), 0, probs...)
end

"""
    remake(prob::SCCNonlinearProblem; u0 = missing, p = missing, probs = missing,
        parameters_alias = prob.parameters_alias, sys = missing, explicitfuns! = missing)

Remake the given `SCCNonlinearProblem`. `u0` is the state vector for the entire problem,
which will be chunked appropriately and used to `remake` the individual subproblems. `p`
is the parameter object for `prob`. If `parameters_alias`, the same parameter object will be
used to `remake` the individual subproblems. Otherwise if `p !== missing`, this function will
error and require that `probs` be specified. `probs` is the collection of subproblems. Even if
`probs` is explicitly specified, the value of `u0` provided to `remake` will be used to
override the values in `probs`. `sys` is the index provider for the full system.
"""
function remake(
        prob::SCCNonlinearProblem; u0 = missing, p = missing, probs = missing,
        parameters_alias = prob.parameters_alias, f = missing, sys = missing,
        interpret_symbolicmap = true, use_defaults = false, explicitfuns! = missing
    )
    if parameters_alias isa Bool
        parameters_alias = Val(parameters_alias)
    end
    if p !== missing && parameters_alias === Val(false) && probs === missing
        throw(ArgumentError("`parameters_alias` is `false` for the given `SCCNonlinearProblem`. Please provide the subproblems using the keyword `probs` with the parameters updated appropriately in each."))
    end
    newu0, newp = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)
    if probs === missing
        probs = prob.probs
    end
    if explicitfuns! === missing
        explicitfuns! = prob.explictfuns!
    end
    if sys === missing
        sys = prob.f.sys
    end
    if u0 !== missing || p !== missing && parameters_alias === Val(true)
        probs = scc_update_subproblems(probs, newu0, newp, parameters_alias)
    end
    f = coalesce(f, prob.f)
    f = remake(f; sys)

    return SCCNonlinearProblem{
        typeof(probs), typeof(explicitfuns!), typeof(f), typeof(newp),
    }(
        probs, explicitfuns!, f, newp, parameters_alias
    )
end

function remake(
        prob::LinearProblem; u0 = missing, p = missing, A = missing, b = missing,
        f = missing, interpret_symbolicmap = true, use_defaults = false, kwargs = missing,
        _kwargs...
    )
    u0, p = updated_u0_p(prob, u0, p; interpret_symbolicmap, use_defaults)
    f = coalesce(f, prob.f)
    # We want to copy to avoid aliasing, but don't want to unnecessarily copy
    A = @coalesce(A, copy(prob.A))
    b = @coalesce(b, copy(prob.b))

    A, b = _get_new_A_b(f, p, A, b)

    if kwargs === missing
        return LinearProblem{isinplace(prob)}(A, b, p; u0, f, prob.kwargs..., _kwargs...)
    else
        return LinearProblem{isinplace(prob)}(A, b, p; u0, f, kwargs...)
    end
end

"""
    $(TYPEDSIGNATURES)

A helper function to call `get_new_A_b` if `f isa SymbolicLinearInterface`.
"""
_get_new_A_b(f, p, A, b; kw...) = A, b

function _get_new_A_b(f::SymbolicLinearInterface, p, A, b; kw...)
    return get_new_A_b(f.sys, f, p, A, b; kw...)
end

# public API
"""
    $(TYPEDSIGNATURES)

A function to return the updated `A` and `b` matrices for a `LinearProblem` after `remake`.
`root_indp` is the innermost index provider found by recursively, calling
`SymbolicIndexingInterface.symbolic_container`, provided for dispatch. Returns the new `A`
`b` matrices. Mutation of `A` and `b` is permitted.

All implementations must accept arbitrary keyword arguments in case they are added in the
future.
"""
get_new_A_b(root_indp, f, p, A, b; kw...) = A, b

function varmap_has_var(varmap, var)
    return haskey(varmap, var) || hasname(var) && haskey(varmap, getname(var))
end

function varmap_get(varmap, var, default = nothing)
    if haskey(varmap, var)
        return varmap[var]
    end
    if hasname(var)
        name = getname(var)
        if haskey(varmap, name)
            return varmap[name]
        end
    end
    return default
end

"""
    $(TYPEDSIGNATURES)

Check if `varmap::Dict{Any, Any}` contains cyclic values for any symbolic variables in
`syms`. Falls back on the basis of `symbolic_container(indp)`. Returns `false` by default.
"""
function detect_cycles(indp, varmap, syms)
    if hasmethod(symbolic_container, Tuple{typeof(indp)}) &&
            (sc = symbolic_container(indp)) != indp
        return detect_cycles(sc, varmap, syms)
    else
        return false
    end
end

anydict(d::Dict{Any, Any}) = d
anydict(d) = Dict{Any, Any}(d)
anydict() = Dict{Any, Any}()

function _updated_u0_p_internal(
        prob, ::Missing, ::Missing, t0; interpret_symbolicmap = true, use_defaults = false
    )
    return state_values(prob), parameter_values(prob)
end
function _updated_u0_p_internal(
        prob, ::Missing, p, t0; interpret_symbolicmap = true, use_defaults = false
    )
    u0 = state_values(prob)

    if p isa AbstractArray && isempty(p)
        return _updated_u0_p_internal(
            prob, u0, parameter_values(prob), t0; interpret_symbolicmap
        )
    end
    eltype(p) <: Pair && interpret_symbolicmap || return u0, p
    defs = default_values(prob)
    p = fill_p(prob, anydict(p); defs, use_defaults)
    return _updated_u0_p_symmap(prob, u0, Val(false), p, Val(true), t0)
end

function _updated_u0_p_internal(
        prob, u0, ::Missing, t0; interpret_symbolicmap = true, use_defaults = false
    )
    p = parameter_values(prob)

    eltype(u0) <: Pair || return u0, p
    defs = default_values(prob)
    u0 = fill_u0(prob, anydict(u0); defs, use_defaults)
    return _updated_u0_p_symmap(prob, u0, Val(true), p, Val(false), t0)
end

function _updated_u0_p_internal(
        prob, u0, p, t0; interpret_symbolicmap = true, use_defaults = false
    )
    isu0symbolic = eltype(u0) <: Pair
    ispsymbolic = eltype(p) <: Pair && interpret_symbolicmap

    if !isu0symbolic && !ispsymbolic
        return u0, p
    end
    defs = default_values(prob)
    if isu0symbolic
        u0 = fill_u0(prob, anydict(u0); defs, use_defaults)
    end
    if ispsymbolic
        p = fill_p(prob, anydict(p); defs, use_defaults)
    end
    return _updated_u0_p_symmap(prob, u0, Val(isu0symbolic), p, Val(ispsymbolic), t0)
end

function fill_u0(prob, u0; defs = nothing, use_defaults = false)
    return fill_vars(
        prob, u0; defs, use_defaults, allsyms = variable_symbols(prob),
        index_function = variable_index
    )
end

function fill_p(prob, p; defs = nothing, use_defaults = false)
    return fill_vars(
        prob, p; defs, use_defaults, allsyms = parameter_symbols(prob),
        index_function = parameter_index
    )
end

function fill_vars(
        prob, varmap; defs = nothing, use_defaults = false, allsyms, index_function
    )
    idx_to_vsym = anydict(index_function(prob, sym) => sym for sym in allsyms)
    sym_to_idx = anydict()
    idx_to_sym = anydict()
    idx_to_val = anydict()
    for (k, v) in varmap
        v === nothing && continue
        idx = index_function(prob, k)
        idx === nothing && continue
        # If `k` is an array symbolic, and `[:k => [1.0, 2.0]]` is provided
        if idx isa AbstractArray && symbolic_type(k) == ScalarSymbolic()
            k = [idx_to_vsym[i] for i in idx]
        elseif !(idx isa AbstractArray) || symbolic_type(k) != ArraySymbolic()
            idx = (idx,)
            k = (k,)
            v = (v,)
        end
        for (kk, vv, ii) in zip(k, v, idx)
            sym_to_idx[kk] = ii
            kk = idx_to_vsym[ii]
            sym_to_idx[kk] = ii
            idx_to_sym[ii] = kk
            idx_to_val[ii] = vv
        end
    end
    for sym in allsyms
        haskey(sym_to_idx, sym) && continue
        idx = index_function(prob, sym)
        haskey(idx_to_val, idx) && continue
        sym_to_idx[sym] = idx
        idx_to_sym[idx] = sym
        idx_to_val[idx] = if defs !== nothing &&
                (defval = varmap_get(defs, sym)) !== nothing &&
                (symbolic_type(defval) != NotSymbolic() || use_defaults)
            defval
        else
            getsym(prob, sym)(prob)
        end
    end
    newvals = anydict()
    for (idx, val) in idx_to_val
        newvals[idx_to_sym[idx]] = val
    end
    for (k, v) in varmap
        haskey(sym_to_idx, k) && continue
        v === nothing && continue
        newvals[k] = v
    end
    return newvals
end

struct CyclicDependencyError <: Exception
    varmap::Dict{Any, Any}
    vars::Any
end

function Base.showerror(io::IO, err::CyclicDependencyError)
    println(io, "Detected cyclic dependency in initial values:")
    for (k, v) in err.varmap
        println(io, k, " => ", v)
    end
    return println(io, "While trying to solve for variables: ", err.vars)
end

function _updated_u0_p_symmap(prob, u0, ::Val{true}, p, ::Val{false}, t0)
    isdep = any(symbolic_type(v) !== NotSymbolic() for (_, v) in u0)
    isdep || return remake_buffer(prob, state_values(prob), keys(u0), values(u0)), p

    if detect_cycles(prob, u0, variable_symbols(prob))
        throw(CyclicDependencyError(u0, variable_symbols(prob)))
    end
    for (k, v) in u0
        u0[k] = symbolic_type(v) === NotSymbolic() ? v : symbolic_evaluate(v, u0)
    end

    isdep = any(symbolic_type(v) !== NotSymbolic() for (_, v) in u0)
    isdep || return remake_buffer(prob, state_values(prob), keys(u0), values(u0)), p

    # FIXME: need to provide `u` since the observed function expects it.
    # This is sort of an implicit dependency on MTK. The values of `u` won't actually be
    # used, since any state symbols in the expression were substituted out earlier.
    temp_state = ProblemState(;
        u = state_values(prob), p = p, t = t0,
        h = is_markovian(prob) ? nothing : get_history_function(prob)
    )
    for (k, v) in u0
        u0[k] = symbolic_type(v) === NotSymbolic() ? v : getsym(prob, v)(temp_state)
    end
    return remake_buffer(prob, state_values(prob), keys(u0), values(u0)), p
end

function _updated_u0_p_symmap(prob, u0, ::Val{false}, p, ::Val{true}, t0)
    isdep = any(symbolic_type(v) !== NotSymbolic() for (_, v) in p)
    isdep || return u0, remake_buffer(prob, parameter_values(prob), keys(p), values(p))

    if detect_cycles(prob, p, parameter_symbols(prob))
        throw(CyclicDependencyError(p, parameter_symbols(prob)))
    end
    for (k, v) in p
        p[k] = symbolic_type(v) === NotSymbolic() ? v : symbolic_evaluate(v, p)
    end

    isdep = any(symbolic_type(v) !== NotSymbolic() for (_, v) in p)
    isdep || return u0, remake_buffer(prob, parameter_values(prob), keys(p), values(p))

    # FIXME: need to provide `p` since the observed function expects an `MTKParameters`
    # this is sort of an implicit dependency on MTK. The values of `p` won't actually be
    # used, since any parameter symbols in the expression were substituted out earlier.
    temp_state = ProblemState(;
        u = u0, p = parameter_values(prob), t = t0,
        h = is_markovian(prob) ? nothing : get_history_function(prob)
    )
    for (k, v) in p
        p[k] = symbolic_type(v) === NotSymbolic() ? v : getsym(prob, v)(temp_state)
    end
    return u0, remake_buffer(prob, parameter_values(prob), keys(p), values(p))
end

function _updated_u0_p_symmap(prob, u0, ::Val{true}, p, ::Val{true}, t0)
    isu0dep = any(symbolic_type(v) !== NotSymbolic() for (_, v) in u0)
    ispdep = any(symbolic_type(v) !== NotSymbolic() for (_, v) in p)

    if !isu0dep && !ispdep
        return remake_buffer(prob, state_values(prob), keys(u0), values(u0)),
            remake_buffer(prob, parameter_values(prob), keys(p), values(p))
    end

    varmap = merge(u0, p)
    allsyms = [variable_symbols(prob); parameter_symbols(prob)]
    if detect_cycles(prob, varmap, allsyms)
        throw(CyclicDependencyError(varmap, allsyms))
    end
    if is_time_dependent(prob)
        varmap[only(independent_variable_symbols(prob))] = t0
    end
    for (k, v) in u0
        v = symbolic_type(v) === NotSymbolic() ? v : symbolic_evaluate(v, varmap)
        # if `symbolic_evaluate` can't get us a concrete value,
        # use the old one from `prob`.
        if symbolic_type(v) != NotSymbolic()
            v = getu(prob, k)(prob)
        end
        u0[k] = v
    end
    for (k, v) in p
        v = symbolic_type(v) === NotSymbolic() ? v : symbolic_evaluate(v, varmap)
        if symbolic_type(v) != NotSymbolic()
            v = getu(prob, k)(prob)
        end
        p[k] = v
    end
    return remake_buffer(prob, state_values(prob), keys(u0), values(u0)),
        remake_buffer(prob, parameter_values(prob), keys(p), values(p))
end

function updated_u0_p(
        prob, u0, p, t0 = nothing; interpret_symbolicmap = true,
        use_defaults = false
    )
    if u0 === missing && p === missing
        return state_values(prob), parameter_values(prob)
    end
    if prob.f !== nothing && has_sys(prob.f) && prob.f.sys === nothing
        if interpret_symbolicmap && eltype(p) !== Union{} && eltype(p) <: Pair
            throw(
                ArgumentError(
                    "This problem does not support symbolic maps with " *
                        "`remake`, i.e. it does not have a symbolic origin. Please use `remake`" *
                        "with the `p` keyword argument as a vector of values (paying attention to" *
                        "parameter order) or pass `interpret_symbolicmap = false` as a keyword argument"
                )
            )
        end
        if eltype(u0) !== Union{} && eltype(u0) <: Pair
            throw(
                ArgumentError(
                    "This problem does not support symbolic maps with" *
                        " remake, i.e. it does not have a symbolic origin. Please use `remake`" *
                        "with the `u0` keyword argument as a vector of values, paying attention to the order."
                )
            )
        end
        return (u0 === missing ? state_values(prob) : u0),
            (p === missing ? parameter_values(prob) : p)
    end
    newu0,
        newp = _updated_u0_p_internal(
        prob, u0, p, t0; interpret_symbolicmap, use_defaults
    )
    return late_binding_update_u0_p(prob, u0, p, t0, newu0, newp)
end

"""
    $(TYPEDSIGNATURES)

A function to perform custom modifications to `newu0` and/or `newp` after they have been
constructed in `remake`. `root_indp` is the innermost index provider found by recursively
calling `SymbolicIndexingInterface.symbolic_container`, provided for dispatch. Returns
the updated `newu0` and `newp`.
"""
function late_binding_update_u0_p(prob, root_indp, u0, p, t0, newu0, newp)
    return newu0, newp
end

"""
    $(TYPEDSIGNATURES)

Calls `late_binding_update_u0_p(prob, root_indp, u0, p, t0, newu0, newp)` after finding
`root_indp`.
"""
function late_binding_update_u0_p(prob, u0, p, t0, newu0, newp)
    root_indp = get_root_indp(prob)
    return late_binding_update_u0_p(prob, root_indp, u0, p, t0, newu0, newp)
end

# overloaded in MTK to intercept symbolic remake
function process_p_u0_symbolic(prob, p, u0)
    return if prob isa Union{AbstractDEProblem, OptimizationProblem, NonlinearProblem}
        throw(ArgumentError("Please load `ModelingToolkit.jl` in order to support symbolic remake."))
    else
        throw(ArgumentError("Symbolic remake for $(typeof(prob)) is currently not supported, consider opening an issue."))
    end
end

function maybe_eager_initialize_problem(
        prob::AbstractSciMLProblem, initialization_data,
        lazy_initialization::Union{Nothing, Bool}
    )
    if lazy_initialization === nothing
        lazy_initialization = !is_trivial_initialization(initialization_data)
    end
    if initialization_data !== nothing && !lazy_initialization &&
            (!is_time_dependent(prob) || current_time(prob) !== nothing)
        u0, p,
            _ = get_initial_values(
            prob, prob, prob.f, OverrideInit(), Val(isinplace(prob))
        )
        if u0 !== nothing && eltype(u0) == Any && isempty(u0)
            u0 = nothing
        end
    else
        u0 = state_values(prob)
        p = parameter_values(prob)
    end
    return u0, p
end

function remake(thing::AbstractJumpProblem; kwargs...)
    return parameterless_type(thing)(remake(thing.prob; kwargs...))
end

function remake(thing::AbstractEnsembleProblem; kwargs...)
    T = parameterless_type(thing)
    en_kwargs = [k for k in kwargs if first(k) ∈ fieldnames(T)]
    return T(remake(thing.prob; setdiff(kwargs, en_kwargs)...); en_kwargs...)
end

using ModelingToolkit, NonlinearSolve, OrdinaryDiffEq, Sundials, SciMLBase, Test
using SymbolicIndexingInterface
using ModelingToolkit: t_nounits as t, D_nounits as D
using StochasticDiffEq, OrdinaryDiffEq, NonlinearSolve, SymbolicIndexingInterface,
    LinearAlgebra, Test
@testset "CheckInit" begin
    abstol = 1.0e-10
    @testset "Sundials + DAEProblem" begin
        function daerhs(du, u, p, t)
            return [du[1] - u[1] * t - p, u[1]^2 - u[2]^2]
        end
        function daerhs!(resid, du, u, p, t)
            resid[1] = du[1] - u[1] * t - p
            resid[2] = u[1]^2 - u[2]^2
        end

        oopfn = DAEFunction{false}(daerhs)
        iipfn = DAEFunction{true}(daerhs!)

        @testset "Inplace = $(SciMLBase.isinplace(f))" for f in [oopfn, iipfn]
            prob = DAEProblem(f, [1.0, 0.0], [1.0, 1.0], (0.0, 1.0), 1.0)
            integ = init(prob, Sundials.IDA())
            u0, _,
                success = SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(), Val(SciMLBase.isinplace(f)); abstol
            )
            @test success
            @test u0 == prob.u0

            integ.u[2] = 2.0
            @test_throws SciMLBase.CheckInitFailureError SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(), Val(SciMLBase.isinplace(f)); abstol
            )

            integ.u[2] = 1.0
            integ.du[1] = 2.0
            @test_throws SciMLBase.CheckInitFailureError SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(), Val(SciMLBase.isinplace(f)); abstol
            )
        end
    end
end

@testset "OverrideInit with MTK" begin
    abstol = 1.0e-10
    reltol = 1.0e-8

    @variables x(t) [guess = 1.0] y(t) [guess = 1.0]
    @parameters p = missing [guess = 1.0] q = missing [guess = 1.0]
    @mtkcompile sys = System(
        [D(x) ~ p * y + q * t, D(y) ~ 5x + q], t;
        initialization_eqs = [p^2 + q^2 ~ 3, x^3 + y^3 ~ 5]
    )
    prob = ODEProblem(
        sys, [x => 1.0, p => 1.0], (0.0, 1.0); initializealg = SciMLBase.NoInit()
    )

    @test prob.f.initialization_data isa SciMLBase.OverrideInitData
    integ = init(prob, Tsit5())
    u0, pobj,
        success = SciMLBase.get_initial_values(
        prob, integ, prob.f, SciMLBase.OverrideInit(), Val(true);
        nlsolve_alg = NewtonRaphson(), abstol, reltol
    )

    @test getu(sys, x)(u0) ≈ 1.0
    @test getu(sys, y)(u0) ≈ cbrt(4)
    @test getp(sys, p)(pobj) ≈ 1.0
    @test getp(sys, q)(pobj) ≈ sqrt(2)
end

@testset "Initialization info printed" begin
    @parameters g
    @variables x(t) y(t) [state_priority = 10] λ(t)
    eqs = [
        D(D(x)) ~ λ * x
        D(D(y)) ~ λ * y - g
        x^2 + y^2 ~ 1
    ]
    @mtkcompile pend = System(eqs, t)

    prob = ODEProblem(pend, [x => 1, y => 0, g => 1], (0.0, 1.5), guesses = [λ => 1])
    @test occursin("Initialization status: FULLY_DETERMINED", sprint(summary, prob))

    prob = ODEProblem(pend, [g => 1], (0.0, 1.5), guesses = [λ => 1, x => 1, y => 0])
    @test occursin("Initialization status: UNDERDETERMINED", sprint(summary, prob))

    prob = ODEProblem(pend, [x => 1, y => 0, λ => 2, g => 1], (0.0, 1.5))
    @test occursin("Initialization status: OVERDETERMINED", sprint(summary, prob))
end

@testset "CheckInit" begin
    @testset "ODEProblem" begin
        function rhs(u, p, t)
            return [u[1] * t, u[1]^2 - u[2]^2]
        end
        function rhs!(du, u, p, t)
            du[1] = u[1] * t
            du[2] = u[1]^2 - u[2]^2
        end

        oopfn = ODEFunction{false}(rhs, mass_matrix = [1 0; 0 0])
        iipfn = ODEFunction{true}(rhs!, mass_matrix = [1 0; 0 0])

        @testset "Inplace = $(SciMLBase.isinplace(f))" for f in [oopfn, iipfn]
            prob = ODEProblem(f, [1.0, 1.0], (0.0, 1.0))
            integ = init(prob)
            u0, _,
                success = SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )
            @test success
            @test u0 == prob.u0

            integ.u[2] = 2.0
            @test_throws SciMLBase.CheckInitFailureError SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )
        end

        @testset "With I mass matrix" begin
            function rhs(u, p, t)
                return u
            end
            prob = ODEProblem(ODEFunction(rhs; mass_matrix = I), ones(2), (0.0, 1.0))
            integ = init(prob)
            u0, _,
                success = SciMLBase.get_initial_values(
                prob, integ, prob.f, SciMLBase.CheckInit(),
                Val(false); abstol = 1.0e-10
            )
            @test success
            @test u0 == prob.u0
        end
    end

    @testset "DAEProblem" begin
        function daerhs(du, u, p, t)
            return [du[1] - u[1] * t - p, u[1]^2 - u[2]^2]
        end
        function daerhs!(resid, du, u, p, t)
            resid[1] = du[1] - u[1] * t - p
            resid[2] = u[1]^2 - u[2]^2
        end

        oopfn = DAEFunction{false}(daerhs)
        iipfn = DAEFunction{true}(daerhs!)

        @testset "Inplace = $(SciMLBase.isinplace(f))" for f in [oopfn, iipfn]
            prob = DAEProblem(f, [1.0, 0.0], [1.0, 1.0], (0.0, 1.0), 1.0)
            integ = init(prob, DImplicitEuler())
            u0, _,
                success = SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )
            @test success
            @test u0 == prob.u0

            integ.u[2] = 2.0
            @test_throws SciMLBase.CheckInitFailureError SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )

            integ.u[2] = 1.0
            integ.du[1] = 2.0
            @test_throws SciMLBase.CheckInitFailureError SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )
        end
    end

    @testset "SDEProblem" begin
        mm_A = [1 0 0; 0 1 0; 0 0 0]
        function sdef!(du, u, p, t)
            du[1] = u[1]
            du[2] = u[2]
            du[3] = u[1] + u[2] + u[3] - 1
        end
        function sdef(u, p, t)
            du = similar(u)
            sdef!(du, u, p, t)
            du
        end

        function g!(du, u, p, t)
            @. du = 0.1
        end
        function g(u, p, t)
            du = similar(u)
            g!(du, u, p, t)
            du
        end
        iipfn = SDEFunction{true}(sdef!, g!; mass_matrix = mm_A)
        oopfn = SDEFunction{false}(sdef, g; mass_matrix = mm_A)

        @testset "Inplace = $(SciMLBase.isinplace(f))" for f in [oopfn, iipfn]
            prob = SDEProblem(f, [1.0, 1.0, -1.0], (0.0, 1.0))
            integ = init(prob, ImplicitEM())
            u0, _,
                success = SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )
            @test success
            @test u0 == prob.u0

            integ.u[2] = 2.0
            @test_throws SciMLBase.CheckInitFailureError SciMLBase.get_initial_values(
                prob, integ, f, SciMLBase.CheckInit(),
                Val(SciMLBase.isinplace(f)); abstol = 1.0e-10
            )
        end
    end
end

@testset "OverrideInit" begin
    function rhs2(u, p, t)
        return [u[1] * t + p, u[1]^2 - u[2]^2]
    end

    @testset "No-op without `initialization_data`" begin
        prob = ODEProblem(rhs2, [1.0, 2.0], (0.0, 1.0), 1.0)
        @test SciMLBase.initialization_status(prob) === nothing
        integ = init(prob)
        integ.u[2] = 3.0
        u0, p,
            success = SciMLBase.get_initial_values(
            prob, integ, prob.f, SciMLBase.OverrideInit(), Val(false)
        )
        @test u0 ≈ [1.0, 3.0]
        @test success
    end

    # unknowns are u[2], p. Parameter is u[1]
    initprob = NonlinearProblem([1.0, 1.0], [1.0]) do x, _u1
        u2, p = x
        u1 = _u1[1]
        return [u1^2 - u2^2, p^2 - 2p + 1]
    end
    update_initializeprob! = function (iprob, integ)
        iprob.p[1] = integ.u[1]
    end
    initprobmap = function (nlsol)
        return [parameter_values(nlsol)[1], nlsol.u[1]]
    end
    initprobpmap = function (_, nlsol)
        return nlsol.u[2]
    end
    initialization_data = SciMLBase.OverrideInitData(
        initprob, update_initializeprob!, initprobmap, initprobpmap
    )
    fn = ODEFunction(rhs2; initialization_data)
    prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
    @test SciMLBase.initialization_status(prob) == SciMLBase.FULLY_DETERMINED
    integ = init(prob; initializealg = NoInit())

    @testset "Works without `nlsolve_alg`" begin
        abstol = 1.0e-10
        reltol = 1.0e-8
        SciMLBase.get_initial_values(
            prob, integ, fn, SciMLBase.OverrideInit(), Val(false); abstol, reltol
        )
    end

    abstol = 1.0e-10
    reltol = 1.0e-10
    @testset "Solves" begin
        @testset "with explicit alg" begin
            u0, p,
                success = SciMLBase.get_initial_values(
                prob, integ, fn, SciMLBase.OverrideInit(),
                Val(false); nlsolve_alg = NewtonRaphson(), abstol, reltol
            )

            @test u0 ≈ [2.0, 2.0]
            @test p ≈ 1.0
            @test success

            initprob.p[1] = 1.0
        end
        @testset "with alg in `OverrideInit`" begin
            u0, p,
                success = SciMLBase.get_initial_values(
                prob, integ, fn,
                SciMLBase.OverrideInit(; nlsolve = NewtonRaphson(), abstol, reltol),
                Val(false)
            )

            @test u0 ≈ [2.0, 2.0]
            @test p ≈ 1.0
            @test success

            initprob.p[1] = 1.0
        end
        @testset "with trivial problem and no alg" begin
            iprob = NonlinearProblem((u, p) -> 0.0, nothing, 1.0)
            iprobmap = (_) -> [1.0, 1.0]
            initdata = SciMLBase.OverrideInitData(iprob, nothing, iprobmap, nothing)
            _fn = ODEFunction(rhs2; initialization_data = initdata)
            _prob = ODEProblem(_fn, [2.0, 0.0], (0.0, 1.0), 1.0)
            _integ = init(_prob; initializealg = NoInit())

            u0, p,
                success = SciMLBase.get_initial_values(
                _prob, _integ, _fn, SciMLBase.OverrideInit(), Val(false); abstol, reltol
            )

            @test u0 ≈ [1.0, 1.0]
            @test p ≈ 1.0
            @test success
        end
        @testset "with kwargs provided to `get_initial_values`" begin
            u0, p,
                success = SciMLBase.get_initial_values(
                prob, integ, fn, SciMLBase.OverrideInit(),
                Val(false); nlsolve_alg = NewtonRaphson(), abstol, reltol, u0 = [-1.0, 1.0]
            )
            @test u0 ≈ [2.0, -2.0]
            @test p ≈ 1.0
            @test success
        end
    end

    @testset "Solves with non-integrator value provider" begin
        _integ = ProblemState(; u = integ.u, p = parameter_values(integ), t = integ.t)
        u0, p,
            success = SciMLBase.get_initial_values(
            prob, _integ, fn, SciMLBase.OverrideInit(),
            Val(false); nlsolve_alg = NewtonRaphson(), abstol, reltol
        )

        @test u0 ≈ [2.0, 2.0]
        @test p ≈ 1.0
        @test success

        initprob.p[1] = 1.0
    end

    @testset "Solves without `update_initializeprob!`" begin
        initdata = SciMLBase.@set initialization_data.update_initializeprob! = nothing
        fn = ODEFunction(rhs2; initialization_data = initdata)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        integ = init(prob; initializealg = NoInit())

        u0, p,
            success = SciMLBase.get_initial_values(
            prob, integ, fn, SciMLBase.OverrideInit(),
            Val(false); nlsolve_alg = NewtonRaphson(), abstol, reltol
        )
        @test u0 ≈ [1.0, 1.0]
        @test p ≈ 1.0
        @test success
    end

    @testset "Solves without `initializeprobmap`" begin
        initdata = SciMLBase.@set initialization_data.initializeprobmap = nothing
        fn = ODEFunction(rhs2; initialization_data = initdata)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        integ = init(prob; initializealg = NoInit())

        u0, p,
            success = SciMLBase.get_initial_values(
            prob, integ, fn, SciMLBase.OverrideInit(),
            Val(false); nlsolve_alg = NewtonRaphson(), abstol, reltol
        )

        @test u0 ≈ [2.0, 0.0]
        @test p ≈ 1.0
        @test success
    end

    @testset "Solves without `initializeprobpmap`" begin
        initdata = SciMLBase.@set initialization_data.initializeprobpmap = nothing
        fn = ODEFunction(rhs2; initialization_data = initdata)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        integ = init(prob; initializealg = NoInit())

        u0, p,
            success = SciMLBase.get_initial_values(
            prob, integ, fn, SciMLBase.OverrideInit(),
            Val(false); nlsolve_alg = NewtonRaphson(), abstol, reltol
        )

        @test u0 ≈ [2.0, 2.0]
        @test p ≈ 0.0
        @test success
    end

    @testset "Initialization status for `SCCNonlinearProblem`" begin
        initprob = SCCNonlinearProblem([initprob], [Returns(nothing)])
        initialization_data = SciMLBase.OverrideInitData(
            initprob, nothing, nothing, nothing
        )
        fn = ODEFunction(rhs2; initialization_data)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        @test SciMLBase.initialization_status(prob) == SciMLBase.FULLY_DETERMINED
    end

    @testset "Trivial initialization" begin
        initprob = NonlinearProblem(Returns(nothing), nothing, [1.0])
        update_initializeprob! = function (iprob, integ)
            # just to access the current time and use it as a number, so this errors
            # if run on a problem with `current_time(prob) === nothing`
            iprob.p[1] = current_time(integ) + 1
            iprob.p[1] = state_values(integ)[1]
        end
        initprobmap = function (nlsol)
            u1 = parameter_values(nlsol)[1]
            return [u1, u1]
        end
        initprobpmap = function (_, nlsol)
            return 0.0
        end
        initialization_data = SciMLBase.OverrideInitData(
            initprob, update_initializeprob!, initprobmap, initprobpmap
        )
        fn = ODEFunction(rhs2; initialization_data)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        @test SciMLBase.initialization_status(prob) == SciMLBase.FULLY_DETERMINED
        integ = init(prob; initializealg = NoInit())

        u0, p,
            success = SciMLBase.get_initial_values(
            prob, integ, fn, SciMLBase.OverrideInit(), Val(false)
        )
        @test u0 ≈ [2.0, 2.0]
        @test p ≈ 0.0
        @test success

        @testset "Doesn't run in `remake` if `tspan == (nothing, nothing)`" begin
            prob = ODEProblem(fn, [2.0, 0.0], (nothing, nothing), 0.0)
            @test_nowarn remake(prob)
        end
    end

    @testset "Initialization status for overdetermined case" begin
        initfn = NonlinearFunction(; resid_prototype = ones(3)) do u, p
            return [u[1] - 1.0, u[2] - 1.0, u[1] * u[2] - 1.0]
        end
        initprob = NonlinearLeastSquaresProblem(initfn, ones(2))
        initialization_data = SciMLBase.OverrideInitData(
            initprob, nothing, nothing, nothing
        )
        fn = ODEFunction(rhs2; initialization_data)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        @test SciMLBase.initialization_status(prob) == SciMLBase.OVERDETERMINED
    end

    @testset "Initialization status for underdetermined case" begin
        initfn = NonlinearFunction(; resid_prototype = ones(1)) do u, p
            return [u[1] - 1.0]
        end
        initprob = NonlinearLeastSquaresProblem(initfn, ones(2))
        initialization_data = SciMLBase.OverrideInitData(
            initprob, nothing, nothing, nothing
        )
        fn = ODEFunction(rhs2; initialization_data)
        prob = ODEProblem(fn, [2.0, 0.0], (0.0, 1.0), 0.0)
        @test SciMLBase.initialization_status(prob) == SciMLBase.UNDERDETERMINED
    end
end

@testset "NoInit" begin
    prob = ODEProblem(ones(2), (0.0, 1.0), ones(2)) do u, p, t
        return u
    end
    u, p,
        success = SciMLBase.get_initial_values(
        prob, prob, prob.f, SciMLBase.NoInit(), Val(true)
    )
    @test u == ones(2)
    @test p == ones(2)
    @test success
end

module SciMLBaseMakieExt

using SciMLBase
using SymbolicIndexingInterface
using Makie

import Makie.SpecApi as S

function ensure_plottrait(PT::Type, arg, desired_plottrait_type::Type)
    return if !(Makie.conversion_trait(PT, arg) isa desired_plottrait_type)
        error(
            """
            `Makie.convert_arguments` for the plot type $PT and its conversion trait $(Makie.conversion_trait(PT, arg)) was unsuccessful.

            There is a recipe for the given arguments and the `$desired_plottrait_type` trait, however.

            The signature that could not be converted was:
            ::$(string(typeof(arg)))

            Makie needs to convert all plot input arguments to types that can be consumed by the backends (typically Arrays with Float32 elements).
            You can define a method for `Makie.convert_arguments` (a type recipe) for these types or their supertypes to make this set of arguments convertible (See <https://docs.makie.org/stable/documentation/recipes/index.html>).

            Alternatively, you can define `Makie.convert_single_argument` for single arguments which have types that are unknown to Makie but which can be converted to known types and fed back to the conversion pipeline.
            """
        )
    end
end

# ## `AbstractTimeseriesSolution` recipe

# First, we define the standard plot type for timeseries solutions.
# This is a `Lines` plot, since timeseries solutions are typically
# plotted as lines.
# In the recipe, we use the Makie PlotSpec API to override
Makie.plottype(sol::SciMLBase.AbstractTimeseriesSolution) = Makie.Lines

function Makie.used_attributes(::Type{<:Plot}, sol::SciMLBase.AbstractTimeseriesSolution)
    return (:plot_analytic, :denseplot, :plotdensity, :plotat, :tspan, :tscale, :vars, :idxs, :scatter_discretes)
end

function Makie.convert_arguments(
        PT::Type{<:Plot},
        sol::SciMLBase.AbstractTimeseriesSolution;
        plot_analytic = false,
        denseplot = Makie.automatic,
        plotdensity = Makie.automatic,
        plotat = nothing,
        tspan = nothing,
        tscale = :identity,
        vars = nothing,
        idxs = nothing,
        scatter_discretes = true
    )

    # First, this recipe is specifically only for timeseries solutions.
    # This means that the recipe only applies to `PointBased` plot types.
    #
    # However, since we need to know the plot type (lines, scatter, scatterlines, etc)
    # which the user passed in, we have to take the plot type directly instead of using
    # the trait system!
    #
    # So, we first check if the plot type is PointBased, and if not, we throw the standard
    # Makie error message for convert_arguments - just at a different place.
    # TODO: this is a bit of a hack, but of course one can define specific dispatches elsewhere...
    ensure_plottrait(PT, sol, Makie.PointBased)

    if vars !== nothing
        Base.depwarn(
            "To maintain consistency with solution indexing, keyword argument vars will be removed in a future version. Please use keyword argument idxs instead.",
            :f; force = true
        )
        (idxs !== nothing) &&
            error("Simultaneously using keywords vars and idxs is not supported. Please only use idxs.")
        idxs = vars
    end

    # Extract indices (this is SOP)

    idxs = idxs === nothing ? SciMLBase.plottable_indices(sol.u[1]) : idxs

    if !(idxs isa Union{Tuple, AbstractArray})
        vars = SciMLBase.interpret_vars([idxs], sol)
    else
        vars = SciMLBase.interpret_vars(idxs, sol)
    end

    # Separate continuous and discrete variables
    disc_vars = Tuple[]
    cont_vars = Tuple[]
    for var in vars
        tsidxs = union(
            var[2] === 0 ? () : get_all_timeseries_indexes(sol, var[2]),
            get_all_timeseries_indexes(sol, var[3])
        )
        if ContinuousTimeseries() in tsidxs || isempty(tsidxs)
            push!(cont_vars, var)
        else
            push!(disc_vars, (var..., only(tsidxs)))
        end
    end
    idxs = identity.(cont_vars)
    vars = identity.(cont_vars)

    # Translate automatics inside the function, for ease of use + passthrough from higher
    # level recipes
    if denseplot isa Makie.Automatic
        denseplot = (
            sol.dense ||
                typeof(sol.prob) <: SciMLBase.AbstractDiscreteProblem
        ) &&
            !(typeof(sol) <: SciMLBase.AbstractRODESolution) &&
            !(
            hasfield(typeof(sol), :interp) &&
                typeof(sol.interp) <: SciMLBase.SensitivityInterpolation
        )
    end

    if plotdensity isa Makie.Automatic
        plotdensity = min(
            Int(1.0e5),
            sol.tslocation == 0 ?
                (
                    sol.prob isa SciMLBase.AbstractDiscreteProblem ?
                    max(1000, 100 * length(sol)) :
                    max(1000, 10 * length(sol))
                ) :
                1000 * sol.tslocation
        )
    end

    # Originally, in the Plots recipe, `tscale`
    # read the axis's `xscale` attribute, and passed that on.
    #
    # However, we can't lift attributes from the axis since
    # we don't have access to it here, so we allow the user
    # to pass in a `tscale` attribute directly.
    @assert tscale isa Symbol "`tscale` if passed in to `Makie.plot` must be a Symbol, got a $(typeof(tscale))"

    # We must convert from plot Type to symbol here, for plotspec use
    # since PlotSpecs are defined based on symbols
    plot_type_sym = Makie.plotsym(PT) # TODO this is still a bit hacky!

    makie_plotspecs = PlotSpec[]

    # Convert continuous variables to arrays and generate PlotSpecs
    if !isempty(cont_vars)
        plot_vecs,
            labels = SciMLBase.diffeq_to_arrays(
            sol, plot_analytic, denseplot,
            plotdensity, tspan, vars, tscale, plotat
        )

        if length(plot_vecs) == 2
            append!(
                makie_plotspecs, map(
                    (x, y, label) -> PlotSpec(plot_type_sym, Point2f.(x, y); label),
                    eachcol(plot_vecs[1]),
                    eachcol(plot_vecs[2]),
                    labels
                )
            )
        elseif length(plot_vecs) == 3
            append!(
                makie_plotspecs, map(
                    (x, y, z, label) -> PlotSpec(plot_type_sym, Point3f.(x, y, z); label),
                    eachcol(plot_vecs[1]),
                    eachcol(plot_vecs[2]),
                    eachcol(plot_vecs[3]),
                    labels
                )
            )
        end
    end

    # Plot discrete variables as step functions
    for (func, xvar, yvar, tsidx) in disc_vars
        partition = sol.discretes[tsidx]
        ts = current_time(partition)
        if tspan !== nothing
            tstart = searchsortedfirst(ts, tspan[1])
            tend = searchsortedlast(ts, tspan[2])
            if tstart == lastindex(ts) + 1 || tend == firstindex(ts) - 1
                continue
            end
        else
            tstart = firstindex(ts)
            tend = lastindex(ts)
        end
        ts = ts[tstart:tend]

        if symbolic_type(xvar) == NotSymbolic() && xvar == 0
            xvar = only(independent_variable_symbols(sol))
        end
        xvals = sol(ts; idxs = xvar).u
        yvals = getp(sol, yvar)(sol, tstart:tend)
        tmpvals = map(func, xvals, yvals)
        xvals = getindex.(tmpvals, 1)
        yvals = getindex.(tmpvals, 2)

        label = string(SciMLBase.hasname(yvar) ? SciMLBase.getname(yvar) : yvar)

        scatter_spec = Makie.SpecApi.Scatter(Point2f.(xvals, yvals); label)

        # For lines/scatterlines, build step-function coordinates
        step_x = vec([xvals[1:(end - 1)]'; xvals[2:end]'])
        step_y = repeat(yvals[1:(end - 1)], inner = 2)

        line_spec = Makie.SpecApi.Lines(Point2f.(step_x, step_y); label, linestyle = :dash)

        # If scatter, don't plot lines.  If lines, don't plot scatter unless asked for.  If scatterlines, plot both.
        if PT <: Makie.Scatter
            push!(makie_plotspecs, scatter_spec)
        elseif PT <: Makie.Lines
            push!(makie_plotspecs, line_spec)
            if scatter_discretes
                push!(makie_plotspecs, scatter_spec)
            end
        elseif PT <: Makie.ScatterLines
            push!(makie_plotspecs, scatter_spec)
            push!(makie_plotspecs, line_spec)
        else
            push!(makie_plotspecs, Makie.PlotSpec(plot_type_sym, Point2f.(xvals, yvals); label))
        end

    end

    return makie_plotspecs
end

# ## Integrator recipes

# This will be very similar to the timeseries solution recipe, but without some of the conveniences.

Makie.plottype(integrator::SciMLBase.DEIntegrator) = Makie.Lines

function Makie.used_attributes(::Type{<:Plot}, integrator::SciMLBase.DEIntegrator)
    return (:plot_analytic, :denseplot, :plotdensity, :vars, :idxs)
end

function Makie.convert_arguments(
        PT::Type{<:Makie.Plot},
        integrator::SciMLBase.DEIntegrator;
        plot_analytic = false,
        denseplot = Makie.automatic,
        plotdensity = 10,
        vars = nothing,
        idxs = nothing
    )
    ensure_plottrait(PT, integrator, Makie.PointBased)

    # Interpret keyword arguments
    if vars !== nothing
        Base.depwarn(
            "To maintain consistency with solution indexing, keyword argument vars will be removed in a future version. Please use keyword argument idxs instead.",
            :f; force = true
        )
        (idxs !== nothing) &&
            error("Simultaneously using keywords vars and idxs is not supported. Please only use idxs.")
        idxs = vars
    end

    if denseplot isa Makie.Automatic
        denseplot = (
            integrator.opts.calck ||
                integrator isa AbstractSDEIntegrator
        ) &&
            integrator.iter > 0
    end

    # Begin deconstructing the integrator

    int_vars = SciMLBase.interpret_vars(idxs, integrator.sol)

    if denseplot
        # Generate the points from the plot from dense function
        plott = collect(range(integrator.tprev, integrator.t; length = plotdensity))
        if plot_analytic
            plot_analytic_timeseries = [
                integrator.sol.prob.f.analytic(
                        integrator.sol.prob.u0,
                        integrator.sol.prob.p,
                        t
                    ) for t in plott
            ]
        end
    else
        plott = nothing
    end

    dims = length(int_vars[1])
    for var in int_vars
        @assert length(var) == dims
    end

    plot_vecs = []
    for i in 2:dims
        push!(plot_vecs, [])
    end

    labels = String[] # Array{String, 2}(1, length(int_vars)*(1+plot_analytic))
    strs = String[]
    varsyms = SciMLBase.variable_symbols(integrator)

    for x in int_vars
        for j in 2:dims
            if denseplot
                if (x[j] isa Integer && x[j] == 0) ||
                        isequal(x[j], SciMLBase.getindepsym_defaultt(integrator))
                    push!(plot_vecs[j - 1], plott)
                else
                    push!(plot_vecs[j - 1], Vector(integrator(plott; idxs = x[j])))
                end
            else # just get values
                if x[j] == 0
                    push!(plot_vecs[j - 1], integrator.t)
                elseif x[j] == 1 && !(integrator.u isa AbstractArray)
                    push!(plot_vecs[j - 1], integrator.u)
                else
                    push!(plot_vecs[j - 1], integrator.u[x[j]])
                end
            end

            if !isempty(varsyms) && x[j] isa Integer
                push!(strs, String(SciMLBase.getname(varsyms[x[j]])))
            elseif SciMLBase.hasname(x[j])
                push!(strs, String(SciMLBase.getname(x[j])))
            else
                push!(strs, "u[$(x[j])]")
            end
        end
        SciMLBase.add_labels!(labels, x, dims, integrator.sol, strs)
    end

    if plot_analytic
        for x in int_vars
            for j in 1:dims
                if denseplot
                    push!(
                        plot_vecs[j],
                        u_n(plot_timeseries, x[j], sol, plott, plot_timeseries)
                    )
                else # Just get values
                    if x[j] == 0
                        push!(plot_vecs[j], integrator.t)
                    elseif x[j] == 1 && !(integrator.u isa AbstractArray)
                        push!(
                            plot_vecs[j],
                            integrator.sol.prob.f(
                                Val{:analytic}, integrator.t,
                                integrator.sol[1]
                            )
                        )
                    else
                        push!(
                            plot_vecs[j],
                            integrator.sol.prob.f(
                                Val{:analytic}, integrator.t,
                                integrator.sol[1]
                            )[x[j]]
                        )
                    end
                end
            end
            SciMLBase.add_labels!(labels, x, dims, integrator.sol, strs)
        end
    end

    # @show plot_vecs

    plot_type_sym = Makie.plotsym(PT)

    return if denseplot
        [
            Makie.PlotSpec(
                    plot_type_sym,
                    Point2f.(plot_vecs[1][idx], plot_vecs[2][idx]);
                    label,
                    color = Makie.Cycled(idx)
                )
                for (idx, label) in zip(1:length(plot_vecs[1]), labels)
        ]
    else
        [
            S.Scatter([Point2f(plot_vecs[1][idx], plot_vecs[2][idx])]; label)
                for (idx, label) in zip(1:length(plot_vecs[1]), labels)
        ]
    end
end

# ## Ensemble recipes

# Again, we first define the "ideal" plot type for ensemble solutions.
Makie.plottype(sol::SciMLBase.AbstractEnsembleSolution) = Makie.Lines

# We also define the attributes that are used by the ensemble solution recipe:
function Makie.used_attributes(::Type{<:Plot}, sol::SciMLBase.AbstractEnsembleSolution)
    return (
        :trajectories,
        :plot_analytic,
        :denseplot,
        :plotdensity,
        :plotat,
        :tspan,
        :tscale,
        :vars,
        :idxs,
    )
end

function Makie.convert_arguments(
        PT::Type{<:Lines},
        sim::SciMLBase.AbstractEnsembleSolution;
        trajectories = eachindex(sim),
        plot_analytic = false,
        denseplot = Makie.automatic,
        plotdensity = Makie.automatic,
        plotat = nothing,
        tspan = nothing,
        tscale = :identity,
        vars = nothing,
        idxs = nothing
    )

    # First, we check if the plot type is PointBased, and if not, we throw the standard
    # Makie error message for convert_arguments - just at a different place.
    ensure_plottrait(PT, sim, Makie.PointBased)

    @assert length(trajectories) > 0 "No trajectories to plot"
    @assert length(sim.u) > 0 "No solutions to plot"

    plot_type_sym = Makie.plotsym(PT)

    mp = [
        PlotSpec(
                plot_type_sym,
                sim.u[i];
                plot_analytic,
                denseplot,
                plotdensity,
                plotat,
                tspan,
                tscale,
                idxs
            ) for i in trajectories
    ]

    # Main.Infiltrator.@infiltrate

    return mp
end

# ## EnsembleSummary recipes

# WARNING: EXPERIMENTAL!

Makie.plottype(sim::SciMLBase.EnsembleSummary) = Makie.Lines

function Makie.used_attributes(::Type{<:Lines}, sim::SciMLBase.EnsembleSummary)
    return (
        :trajectories,
        :error_style,
        :ci_type,
        :plot_analytic,
        :denseplot,
        :plotdensity,
        :plotat,
        :tspan,
        :tscale,
        :vars,
        :idxs,
    )
end

# TODO: should `error_style` be Makie plot types instead?  I.e. `Band`, `Errorbar`, etc
function Makie.convert_arguments(
        ::Type{<:Lines},
        sim::SciMLBase.EnsembleSummary;
        idxs = sim.u.u[1] isa AbstractArray ? eachindex(sim.u.u[1]) :
            1,
        error_style = :ribbon, ci_type = :quantile,
        kwargs...
    )
    if ci_type == :SEM
        if sim.u.u[1] isa AbstractArray
            u = SciMLBase.vecarr_to_vectors(sim.u)
        else
            u = [sim.u.u]
        end
        if sim.u.u[1] isa AbstractArray
            ci_low = SciMLBase.vecarr_to_vectors(
                VectorOfArray(
                    [
                        sqrt.(
                                sim.v.u[i] /
                                sim.num_monte
                            ) .*
                            1.96
                            for i in 1:length(sim.v)
                    ]
                )
            )
            ci_high = ci_low
        else
            ci_low = [
                [
                    sqrt(sim.v.u[i] / length(sim.num_monte)) .* 1.96
                        for i in 1:length(sim.v)
                ],
            ]
            ci_high = ci_low
        end
    elseif ci_type == :quantile
        if sim.med.u[1] isa AbstractArray
            u = SciMLBase.vecarr_to_vectors(sim.med)
        else
            u = [sim.med.u]
        end
        if sim.u.u[1] isa AbstractArray
            ci_low = u - SciMLBase.vecarr_to_vectors(sim.qlow)
            ci_high = SciMLBase.vecarr_to_vectors(sim.qhigh) - u
        else
            ci_low = [u[1] - sim.qlow.u]
            ci_high = [sim.qhigh.u - u[1]]
        end
    else
        error("ci_type choice not valid. Must be `:SEM` or `:quantile`")
    end

    makie_plotlist = Makie.PlotSpec[]

    for (count, idx) in enumerate(idxs)
        push!(
            makie_plotlist,
            S.Lines(sim.t, u[idx]; color = Makie.Cycled(count), label = "u[$idx]")
        )
        if error_style == :ribbon
            push!(
                makie_plotlist,
                S.Band(
                    sim.t,
                    u[idx] .- ci_low[idx],
                    u[idx] .+ ci_high[idx];
                    color = Makie.Cycled(count),
                    alpha = 0.1
                )
            )
        elseif error_style == :bars
            push!(
                makie_plotlist,
                S.Errorbars(sim.t, u[idx], ci_low[idx], ci_high[idx])
            )
        elseif error_style == :none
            nothing
        else
            error("error_style `$error_style` not recognized")
        end
    end

    return makie_plotlist
end

end

@doc doc"""

Defines an implicit ordinary differential equation (ODE) or
differential-algebraic equation (DAE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/dae_types/>

## Mathematical Specification of an DAE Problem

To define a DAE Problem, you simply need to give the function ``f`` and the initial
condition ``u_0`` which define an ODE:

```math
0 = f(du,u,p,t)
```

`f` should be specified as `f(du,u,p,t)` (or in-place as `f(resid,du,u,p,t)`).
Note that we are not limited to numbers or vectors for `u₀`; one is allowed to
provide `u₀` as arbitrary matrices / higher dimension tensors as well.

## Problem Type

### Constructors

- `DAEProblem(f::DAEFunction,du0,u0,tspan,p=NullParameters();kwargs...)`
- `DAEProblem{isinplace,specialize}(f,du0,u0,tspan,p=NullParameters();kwargs...)` :
  Defines the DAE with the specified functions. `isinplace` optionally sets whether
  the function is inplace or not. This is determined automatically, but not inferred.
  `specialize` optionally controls the specialization level. See the specialization
  levels section of the documentation for more details. The default is `AutoSpecialize`.

For more details on the in-place and specialization controls, see the ODEFunction
documentation.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the
[DiffEqFunctions](@ref performance_overloads)
page.

### Fields

* `f`: The function in the ODE.
* `du0`: The initial condition for the derivative.
* `u0`: The initial condition.
* `tspan`: The timespan for the problem.
* `differential_vars`: A logical array which declares which variables are the
  differential (non-algebraic) vars (i.e. `du'` is in the equations for this
  variable). Defaults to nothing. Some solvers may require this be set if an
  initial condition needs to be determined.
* `p`: The parameters for the problem. Defaults to `NullParameters`
* `kwargs`: The keyword arguments passed onto the solves.

## Example Problems

Examples problems can be found in [DiffEqProblemLibrary.jl](https://github.com/SciML/DiffEqProblemLibrary.jl).

To use a sample problem, such as `prob_dae_resrob`, you can do something like:

```julia
#] add DAEProblemLibrary
using DAEProblemLibrary
prob = DAEProblemLibrary.prob_dae_resrob
sol = solve(prob,IDA())
```
"""
struct DAEProblem{uType, duType, tType, isinplace, P, F, K, D} <:
    AbstractDAEProblem{uType, duType, tType, isinplace}
    f::F
    du0::duType
    u0::uType
    tspan::tType
    p::P
    kwargs::K
    differential_vars::D
    @add_kwonly function DAEProblem{iip}(
            f::AbstractDAEFunction{iip},
            du0, u0, tspan, p = NullParameters();
            differential_vars = nothing,
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _du0 = prepare_initial_state(du0)
        if !isnothing(_u0)
            # Defend against external solvers like Sundials breaking on non-uniform input dimensions.
            size(_du0) == size(_u0) ||
                throw(ArgumentError("Sizes of u0 and du0 must be the same."))
            if !isnothing(differential_vars)
                size(_u0) == size(differential_vars) ||
                    throw(ArgumentError("Sizes of u0 and differential_vars must be the same."))
            end
        end
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_du0), typeof(_tspan),
            isinplace(f), typeof(p),
            typeof(f), typeof(kwargs),
            typeof(differential_vars),
        }(
            f, _du0, _u0, _tspan, p,
            kwargs, differential_vars
        )
    end

    function DAEProblem{iip}(f, du0, u0, tspan, p = NullParameters(); kwargs...) where {iip}
        return DAEProblem(DAEFunction{iip}(f), du0, u0, tspan, p; kwargs...)
    end
end

function DAEProblem(f::AbstractDAEFunction, du0, u0, tspan, p = NullParameters(); kwargs...)
    return DAEProblem{isinplace(f)}(f, du0, u0, tspan, p; kwargs...)
end

function DAEProblem(f, du0, u0, tspan, p = NullParameters(); kwargs...)
    return DAEProblem(DAEFunction(f), du0, u0, tspan, p; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: DAEProblem}
    return function ctor(f, du0, u0, tspan, p, kw, dv)
        iip = isinplace(f)
        return DAEProblem{iip}(f, du0, u0, tspan, p; differential_vars = dv, kw...)
    end
end

@doc doc"""
    DAEAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_du0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving a DAE. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false.
* `alias_du0::Union{Bool, Nothing}`: alias the du0 array for DAEs. Defaults to false.
* `alias_tstops::Union{Bool, Nothing}`: alias the tstops array
* `alias::Union{Bool, Nothing}`: sets all fields of the `DAEAliasSpecifier` to `alias`

"""
struct DAEAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_du0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}

    function DAEAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_du0, alias_tstops)
        end
    end
end

module SciMLBaseMonteCarloMeasurementsExt

using SciMLBase
using SciMLBase: value
using MonteCarloMeasurements

function SciMLBase.promote_u0(
        u0::AbstractArray{
            <:MonteCarloMeasurements.AbstractParticles,
        },
        p::AbstractArray{<:MonteCarloMeasurements.AbstractParticles},
        t0
    )
    return u0
end
function SciMLBase.promote_u0(
        u0,
        p::AbstractArray{<:MonteCarloMeasurements.AbstractParticles},
        t0
    )
    return eltype(p).(u0)
end

function SciMLBase.promote_u0(
        ::Nothing,
        p::AbstractArray{<:MonteCarloMeasurements.AbstractParticles},
        t0
    )
    return nothing
end

SciMLBase.value(x::Type{MonteCarloMeasurements.AbstractParticles{T, N}}) where {T, N} = T
SciMLBase.value(x::MonteCarloMeasurements.AbstractParticles) = mean(x.particles)
function SciMLBase.unitfulvalue(
        x::Type{
            MonteCarloMeasurements.AbstractParticles{
                T, N,
            },
        }
    ) where {T, N}
    return T
end
SciMLBase.unitfulvalue(x::MonteCarloMeasurements.AbstractParticles) = mean(x.particles)

end

"""
The SciMLBaseMLStyleExt module provides backwards compatibility for those using MLStyle
to pattern match the Clocks algebraic data type (ADT).

Before this ADT was made using Expronomicon, which directly supported MLStyle.
Now that the ADT is made using Moshi, we need to define MLStyle custom patterns.
Using Moshi pattern matching is recommended over relying on this package extension.
"""
module SciMLBaseMLStyleExt

using SciMLBase: TimeDomain, ContinuousClock, SolverStepClock, PeriodicClock
using MLStyle: MLStyle
using MLStyle.AbstractPatterns: literal, wildcard, PComp, BasicPatterns, decons
using Moshi.Data: isa_variant

# This makes Singletons also work without parentheses in matches
MLStyle.is_enum(::Type{ContinuousClock}) = true
MLStyle.is_enum(::Type{SolverStepClock}) = true
function MLStyle.pattern_uncall(::Type{ContinuousClock}, self::Function, _, _, _)
    return literal(ContinuousClock())
end
MLStyle.pattern_uncall(T::TimeDomain, self::Function, _, _, _) = literal(T())

function MLStyle.pattern_uncall(::Type{SolverStepClock}, self::Function, _, _, _)
    return literal(SolverStepClock())
end

function periodic_clock_pattern(c)
    return if c isa TimeDomain && isa_variant(c, PeriodicClock)
        (c.dt, c.phase)
    else
        # These values are used in match results, but they shouldn't.
        # This means that any wildcard pattern will be `nothing`, see broken test.
        (nothing, nothing)
    end
end

function MLStyle.pattern_uncall(
        ::Type{PeriodicClock}, self::Function, type_params, type_args, args
    )
    @assert isempty(type_params)
    @assert isempty(type_args)
    n_args = length(args)

    trans(expr) = Expr(:call, periodic_clock_pattern, expr)
    type_infer(_...) = Any

    extract = if n_args <= 1
        (expr::Any, i::Int, ::Any, ::Any) -> expr
    else
        (expr::Any, i::Int, ::Any, ::Any) -> Core._expr(:ref, expr, i)
    end

    comp = PComp(
        "PeriodicClock(c)", type_infer; view = BasicPatterns.SimpleCachablePre(trans)
    )

    ps = if n_args === 0
        []
    elseif n_args === 1
        [self(Expr(:call, Some, args[1]))]
    elseif n_args === 2
        if args[2] == :(_...)
            [self(args[1]), wildcard]
        else
            [self(args[1]), self(args[2])]
        end
    else
        error("too many arguments")
    end

    return decons(comp, extract, ps)
end

end

"""
$(TYPEDEF)
"""
struct EnsembleTestSolution{T, N, S} <: AbstractEnsembleSolution{T, N, S}
    u::S
    errors::Dict{Symbol, Vector{T}}
    weak_errors::Dict{Symbol, T}
    error_means::Dict{Symbol, T}
    error_medians::Dict{Symbol, T}
    elapsedTime::Float64
    converged::Bool
end
function EnsembleTestSolution(
        sim::AbstractEnsembleSolution{T, N}, errors, weak_errors,
        error_means, error_medians, elapsedTime,
        converged
    ) where {T, N}
    return EnsembleTestSolution{T, N, typeof(sim.u)}(
        sim.u, errors, weak_errors, error_means,
        error_medians, sim.elapsedTime, sim.converged
    )
end
function EnsembleTestSolution(
        u, errors, weak_errors, error_means, error_medians,
        elapsedTime, converged
    )
    return EnsembleTestSolution(
        EnsembleSolution(u, elapsedTime, converged), errors, weak_errors,
        error_means, error_medians, elapsedTime, converged
    )
end

"""
$(TYPEDEF)
"""
struct EnsembleSolution{T, N, S} <: AbstractEnsembleSolution{T, N, S}
    u::S
    elapsedTime::Float64
    converged::Bool
    stats::Any
end
function EnsembleSolution(sim, dims::NTuple{N}, elapsedTime, converged, stats) where {N}
    return EnsembleSolution{eltype(eltype(sim)), N, typeof(sim)}(
        sim, elapsedTime, converged, stats
    )
end
function EnsembleSolution(sim, elapsedTime, converged, stats = nothing)
    return EnsembleSolution(sim, (length(sim),), elapsedTime, converged, stats)
end # Vector of some type which is not an array
function EnsembleSolution(
        sim::T, elapsedTime,
        converged, stats = nothing
    ) where {
        T <:
        AbstractVector{T2},
    } where {
        T2 <:
        Union{AbstractArray, RecursiveArrayTools.AbstractVectorOfArray},
    }
    return EnsembleSolution{
        eltype(eltype(sim)), ndims(sim[1]) + 1,
        typeof(sim),
    }(
        sim,
        elapsedTime,
        converged,
        stats
    )
end

struct WeightedEnsembleSolution{T1 <: AbstractEnsembleSolution, T2 <: Number}
    ensol::T1
    weights::Vector{T2}
    function WeightedEnsembleSolution(ensol, weights)
        @assert length(weights) == length(ensol)
        return new{typeof(ensol), eltype(weights)}(ensol, weights)
    end
end

function Base.reverse(sim::EnsembleSolution)
    return EnsembleSolution(reverse(sim.u), sim.elapsedTime, sim.converged, sim.stats)
end

"""
$(TYPEDEF)

The `EnsembleSummary` type is included to help with analyzing the general summary
statistics. Two constructors are provided:

```julia
EnsembleSummary(sim; quantiles = [0.05, 0.95])
EnsembleSummary(sim, ts; quantiles = [0.05, 0.95])
```

The first produces a `(mean,var)` summary at each time step. As with the summary
statistics, this assumes that the time steps are all the same. The second produces
a `(mean,var)` summary at each time point `t` in `ts`. This requires the ability
to interpolate the solution. Quantile is used to determine the `qlow` and `qhigh`
quantiles at each timepoint. It defaults to the 5% and 95% quantiles.

## Plot Recipe

The `EnsembleSummary` comes with a plot recipe for visualizing the summary
statistics. The extra keyword arguments are:

  - `idxs`: the solution components to plot. Defaults to plotting all components.
  - `error_style`: The style for plotting the error. Defaults to `ribbon`. Other
    choices are `:bars` for error bars and `:none` for no error bars.
  - `ci_type` : Defaults to `:quantile` which has `(qlow,qhigh)` quantiles
    whose limits were determined when constructing the `EnsembleSummary`.
    Gaussian CI `1.96*(standard error of the mean)` can be set using `ci_type=:SEM`.

One useful argument is `fillalpha` which controls the transparency of the ribbon
around the mean.
"""
struct EnsembleSummary{T, N, Tt, S, S2, S3, S4, S5} <: AbstractEnsembleSolution{T, N, S}
    t::Tt
    u::S
    v::S2
    med::S3
    qlow::S4
    qhigh::S5
    num_monte::Int
    elapsedTime::Float64
    converged::Bool
end

function calculate_ensemble_errors(sim::AbstractEnsembleSolution; kwargs...)
    calculate_ensemble_errors(
        sim.u; elapsedTime = sim.elapsedTime,
        converged = sim.converged, kwargs...
    )
end

function calculate_ensemble_errors(
        u; elapsedTime = 0.0, converged = false,
        weak_timeseries_errors = false,
        weak_dense_errors = false
    )
    errors = Dict{Symbol, Vector{eltype(u[1].u[1])}}() #Should add type information
    error_means = Dict{Symbol, eltype(u[1].u[1])}()
    error_medians = Dict{Symbol, eltype(u[1].u[1])}()

    analyticvoa = u[1].u_analytic isa AbstractVectorOfArray ? true : false

    for k in keys(u[1].errors)
        errors[k] = [sol.errors[k] for sol in u]
        error_means[k] = mean(errors[k])
        error_medians[k] = median(errors[k])
    end
    # Now Calculate Weak Errors
    weak_errors = Dict{Symbol, eltype(u[1].u[1])}()
    # Final
    m_final = mean([s.u[end] for s in u])

    if analyticvoa
        m_final_analytic = mean([s.u_analytic.u[end] for s in u])
    else
        m_final_analytic = mean([s.u_analytic[end] for s in u])
    end

    res = norm(m_final - m_final_analytic)
    weak_errors[:weak_final] = res
    if weak_timeseries_errors
        if analyticvoa
            ts_weak_errors = [
                mean([u[j].u[i] - u[j].u_analytic.u[i] for j in 1:length(u)])
                    for i in 1:length(u[1])
            ]
        else
            ts_weak_errors = [
                mean([u[j].u[i] - u[j].u_analytic[i] for j in 1:length(u)])
                    for i in 1:length(u[1])
            ]
        end
        ts_l2_errors = [sqrt.(sum(abs2, err) / length(err)) for err in ts_weak_errors]
        l2_tmp = sqrt(sum(abs2, ts_l2_errors) / length(ts_l2_errors))
        max_tmp = maximum([maximum(abs.(err)) for err in ts_weak_errors])
        weak_errors[:weak_l2] = l2_tmp
        weak_errors[:weak_l∞] = max_tmp
    end
    if weak_dense_errors
        densetimes = collect(range(u[1].t[1], stop = u[1].t[end], length = 100))
        u_analytic = [
            [
                    sol.prob.f.analytic(
                        sol.prob.u0, sol.prob.p, densetimes[i],
                        sol.W(densetimes[i])[1]
                    )
                    for i in eachindex(densetimes)
                ] for sol in u
        ]

        udense = [u[j](densetimes) for j in 1:length(u)]
        dense_weak_errors = [
            mean([udense[j].u[i] - u_analytic[j][i] for j in 1:length(u)])
                for i in eachindex(densetimes)
        ]
        dense_L2_errors = [sqrt.(sum(abs2, err) / length(err)) for err in dense_weak_errors]
        L2_tmp = sqrt(sum(abs2, dense_L2_errors) / length(dense_L2_errors))
        max_tmp = maximum([maximum(abs.(err)) for err in dense_weak_errors])
        weak_errors[:weak_L2] = L2_tmp
        weak_errors[:weak_L∞] = max_tmp
    end
    return EnsembleTestSolution(
        u, errors, weak_errors, error_means, error_medians,
        elapsedTime, converged
    )
end

### Displays

function Base.summary(io::IO, A::AbstractEnsembleSolution)
    return print(
        io, "EnsembleSolution Solution of length ", length(A.u), " with uType:\n",
        eltype(A.u)
    )
end
function Base.show(io::IO, m::MIME"text/plain", A::AbstractEnsembleSolution)
    return summary(io, A)
end

### Plot Recipes

@recipe function f(
        sim::AbstractEnsembleSolution;
        zcolors = sim.u isa AbstractArray ? fill(nothing, length(sim.u)) :
            nothing,
        trajectories = eachindex(sim)
    )
    for i in trajectories
        size(sim.u[i].u, 1) == 0 && continue
        @series begin
            legend := false
            xlims --> (-Inf, Inf)
            ylims --> (-Inf, Inf)
            zlims --> (-Inf, Inf)
            marker_z --> zcolors[i]
            sim.u[i]
        end
    end
end

@recipe function f(
        sim::EnsembleSummary;
        idxs = sim.u.u[1] isa AbstractArray ? eachindex(sim.u.u[1]) :
            1,
        error_style = :ribbon, ci_type = :quantile
    )
    if ci_type == :SEM
        if sim.u.u[1] isa AbstractArray
            u = vecarr_to_vectors(sim.u)
        else
            u = [sim.u.u]
        end
        if sim.u.u[1] isa AbstractArray
            ci_low = vecarr_to_vectors(
                VectorOfArray(
                    [
                        sqrt.(sim.v.u[i] / sim.num_monte) .*
                            1.96 for i in 1:length(sim.v)
                    ]
                )
            )
            ci_high = ci_low
        else
            ci_low = [
                [
                    sqrt(sim.v.u[i] / length(sim.num_monte)) .* 1.96
                        for i in 1:length(sim.v)
                ],
            ]
            ci_high = ci_low
        end
    elseif ci_type == :quantile
        if sim.med.u[1] isa AbstractArray
            u = vecarr_to_vectors(sim.med)
        else
            u = [sim.med.u]
        end
        if sim.u.u[1] isa AbstractArray
            ci_low = u - vecarr_to_vectors(sim.qlow)
            ci_high = vecarr_to_vectors(sim.qhigh) - u
        else
            ci_low = [u[1] - sim.qlow.u]
            ci_high = [sim.qhigh.u - u[1]]
        end
    else
        error("ci_type choice not valid. Must be `:SEM` or `:quantile`")
    end
    for i in idxs
        @series begin
            legend --> false
            linewidth --> 3
            fillalpha --> 0.2
            if error_style == :ribbon
                ribbon --> (ci_low[i], ci_high[i])
            elseif error_style == :bars
                yerror --> (ci_low[i], ci_high[i])
            elseif error_style == :none
                nothing
            else
                error("error_style not recognized")
            end
            sim.t, u[i]
        end
    end
end

function (sol::AbstractEnsembleSolution)(args...; kwargs...)
    return [s(args...; kwargs...) for s in sol]
end

Base.@propagate_inbounds function Base.getindex(sol::WeightedEnsembleSolution, S)
    return [sum(stack(sol.weights .* sol.ensol[:, S]), dims = 2)]
end

"""
$(TYPEDEF)
"""
struct StandardBVProblem end

"""
$(TYPEDEF)
"""
struct TwoPointBVProblem{iip} end # The iip is needed to make type stable construction easier

@doc doc"""

Defines an BVP problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/bvp_types/>

## Mathematical Specification of a BVP Problem

To define a BVP Problem, you simply need to give the function ``f`` and the initial
condition ``u_0`` which define an ODE:

```math
\frac{du}{dt} = f(u,p,t)
```

along with an implicit function `bc` which defines the residual equation, where

```math
bc(u,p,t) = 0
```

is the manifold on which the solution must live. A common form for this is the
two-point `BVProblem` where the manifold defines the solution at two points:

```math
\begin{align*}
u(t_0) &= a, \\
u(t_f) &= b
\end{align*}
```

## Problem Type

### Constructors

```julia
TwoPointBVProblem{isinplace}(f, bc, u0, tspan, p=NullParameters(); kwargs...)
BVProblem{isinplace}(f, bc, u0, tspan, p=NullParameters(); kwargs...)
```

or if we have an initial guess function `initialGuess(p, t)` for the given BVP,
we can pass the initial guess to the problem constructors:

```julia
TwoPointBVProblem{isinplace}(f, bc, initialGuess, tspan, p=NullParameters(); kwargs...)
BVProblem{isinplace}(f, bc, initialGuess, tspan, p=NullParameters(); kwargs...)
```

For any BVP problem type, `bc` must be inplace if `f` is inplace. Otherwise it must be
out-of-place.

If the bvp is a StandardBVProblem (also known as a Multi-Point BV Problem) it must define
either of the following functions

```julia
bc!(residual, u, p, t)
residual = bc(u, p, t)
```

where `residual` computed from the current `u`. `u` is an array of solution values
where `u[i]` is at time `t[i]`, while `p` are the parameters. For a `TwoPointBVProblem`,
`t = tspan`. For the more general `BVProblem`, `u` can be all of the internal
time points, and for shooting type methods `u=sol` the ODE solution.
Note that all features of the `ODESolution` are present in this form.
In both cases, the size of the residual matches the size of the initial condition.

If the bvp is a TwoPointBVProblem then `bc` must be a Tuple `(bca, bcb)` and each of them
must define either of the following sets of functions:

```julia
bca!(resid_a, u_a, p)
bcb!(resid_b, u_b, p)
```

or

```julia
resid_a = bca(u_a, p)
resid_b = bcb(u_b, p)
```

where `resid_a` and `resid_b` are the residuals at the two endpoints, `u_a` and `u_b` are
the solution values at the two endpoints, and `p` are the parameters.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

### Fields

* `f`: The function for the ODE.
* `bc`: The boundary condition function.
* `u0`: The initial condition. Either the initial condition for the ODE as an
  initial value problem, or a `Vector` of values for ``u(t_i)`` for collocation
  methods.
* `tspan`: The timespan for the problem.
* `p`: The parameters for the problem. Defaults to `NullParameters`.
* `lb`: The lower bounds for the solution variables. Defaults to `nothing`.
* `ub`: The upper bounds for the solution variables. Defaults to `nothing`.
* `lcons`: The lower bounds for the constraint residuals. Defaults to `nothing`.
* `ucons`: The upper bounds for the constraint residuals. Defaults to `nothing`.
* `problem_type`: The type of the problem, either `StandardBVProblem` or
  `TwoPointBVProblem`.
* `singular_term`: The singular term of the problem. Defaults to `nothing`.
* `kwargs`: The keyword arguments passed onto the solves.

### Special Keyword Arguments

- `nlls`: Specify that the BVP is a nonlinear least squares problem. Use `Val(true)` or
  `Val(false)` for type stability. By default this is automatically inferred based on the
  size of the input and outputs, however this is type unstable for any array type that
  doesn't store array size as part of type information. If we can't reliably infer this,
  we set it to `Nothing`. Downstreams solvers must be setup to deal with this case.
"""
struct BVProblem{uType, tType, isinplace, nlls, P, F, LB, UB, LC, UC, PT, S, K} <:
    AbstractBVProblem{uType, tType, isinplace, nlls}
    f::F
    u0::uType
    tspan::tType
    p::P
    lb::LB
    ub::UB
    lcons::LC
    ucons::UC
    problem_type::PT
    singular_term::S
    kwargs::K

    @add_kwonly function BVProblem{iip}(
            f::AbstractBVPFunction{iip, TP}, u0, tspan,
            p = NullParameters(); lb = nothing, ub = nothing, lcons = nothing,
            ucons = nothing, problem_type = nothing, singular_term = nothing, nlls = nothing,
            kwargs...
        ) where {iip, TP}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        prob_type = TP ? TwoPointBVProblem{iip}() : StandardBVProblem()
        @assert singular_term === nothing || isa(singular_term, AbstractMatrix) "Singular term must be a singular matrix or nothing."

        # Needed to ensure that `problem_type` doesn't get passed in kwargs
        if problem_type === nothing
            problem_type = prob_type
        else
            @assert prob_type === problem_type "This indicates incorrect problem type specification! Users should never pass in `problem_type` kwarg, this exists exclusively for internal use."
        end

        if nlls === nothing
            if !hasmethod(length, Tuple{typeof(_u0)})
                # If _u0 is a function for initial guess we won't be able to infer
                __u0 = _u0 isa Function ?
                    (
                        hasmethod(_u0, Tuple{typeof(p), typeof(first(_tspan))}) ?
                        _u0(p, first(_tspan)) : _u0(first(_tspan))
                    ) : nothing
            else
                __u0 = _u0
            end
            # Try to infer it
            if __u0 isa Nothing
                _nlls = Nothing
            elseif problem_type isa TwoPointBVProblem
                if f.bcresid_prototype !== nothing
                    l1, l2 = length(f.bcresid_prototype[1]), length(f.bcresid_prototype[2])
                    _nlls = l1 + l2 != length(__u0)
                else
                    # iip without bcresid_prototype is not possible
                    if !iip
                        l1 = length(f.bc[1](u0, p))
                        l2 = length(f.bc[2](u0, p))
                        _nlls = l1 + l2 != length(__u0)
                    end
                end
            else
                if f.bcresid_prototype !== nothing
                    _nlls = length(f.bcresid_prototype) != length(__u0)
                else
                    # For StandardBVProblem without bcresid_prototype, the solver
                    # creates a residual matching u0 size, so it is not NLLS.
                    _nlls = false
                end
            end
        else
            _nlls = _unwrap_val(nlls)
        end

        return new{
            typeof(_u0), typeof(_tspan), iip, _nlls, typeof(p),
            typeof(f), typeof(lb), typeof(ub), typeof(lcons), typeof(ucons),
            typeof(problem_type), typeof(singular_term), typeof(kwargs),
        }(
            f, _u0, _tspan, p, lb, ub, lcons, ucons, problem_type, singular_term, kwargs
        )
    end

    function BVProblem{iip}(f, bc, u0, tspan, p = NullParameters(); kwargs...) where {iip}
        return BVProblem(BVPFunction{iip}(f, bc), u0, tspan, p; kwargs...)
    end
end

function BVProblem(f, bc, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 4)
    return BVProblem{iip}(BVPFunction{iip}(f, bc), u0, tspan, p; kwargs...)
end

function BVProblem(f::AbstractBVPFunction, u0, tspan, p = NullParameters(); kwargs...)
    return BVProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end

# This is mostly a fake struct and isn't used anywhere
# But we need it for function calls like TwoPointBVProblem{iip}(...) = ...
struct TwoPointBVPFunction{iip} end

@inline function TwoPointBVPFunction(args...; kwargs...)
    return BVPFunction(args...; kwargs..., twopoint = Val(true))
end
@inline function TwoPointBVPFunction{iip}(args...; kwargs...) where {iip}
    return BVPFunction{iip}(args...; kwargs..., twopoint = Val(true))
end

function TwoPointBVProblem{iip}(
        f, bc, u0, tspan, p = NullParameters();
        bcresid_prototype = nothing, kwargs...
    ) where {iip}
    return TwoPointBVProblem(
        TwoPointBVPFunction{iip}(f, bc; bcresid_prototype), u0, tspan,
        p; kwargs...
    )
end
function TwoPointBVProblem(
        f, bc, u0, tspan, p = NullParameters();
        bcresid_prototype = nothing, kwargs...
    )
    return TwoPointBVProblem(
        TwoPointBVPFunction(f, bc; bcresid_prototype), u0, tspan, p;
        kwargs...
    )
end
function TwoPointBVProblem{iip}(
        f::AbstractBVPFunction{iip, twopoint}, u0, tspan,
        p = NullParameters(); kwargs...
    ) where {iip, twopoint}
    @assert twopoint "`TwoPointBVProblem` can only be used with a `TwoPointBVPFunction`. Instead of using `BVPFunction`, use `TwoPointBVPFunction` or pass a kwarg `twopoint=Val(true)` during the construction of the `BVPFunction`."
    return BVProblem{iip}(f, u0, tspan, p; kwargs...)
end
function TwoPointBVProblem(
        f::AbstractBVPFunction{iip, twopoint}, u0, tspan,
        p = NullParameters(); kwargs...
    ) where {iip, twopoint}
    @assert twopoint "`TwoPointBVProblem` can only be used with a `TwoPointBVPFunction`. Instead of using `BVPFunction`, use `TwoPointBVPFunction` or pass a kwarg `twopoint=Val(true)` during the construction of the `BVPFunction`."
    return BVProblem{iip}(f, u0, tspan, p; kwargs...)
end

# Allow previous timeseries solution
function TwoPointBVProblem(
        f::AbstractODEFunction, bc, sol::T, tspan::Tuple,
        p = NullParameters(); kwargs...
    ) where {T <: AbstractTimeseriesSolution}
    return TwoPointBVProblem(f, bc, sol.u, tspan, p; kwargs...)
end
# Allow initial guess function for the initial guess
function TwoPointBVProblem(
        f::AbstractODEFunction, bc, initialGuess, tspan::AbstractVector,
        p = NullParameters(); kwargs...
    )
    u0 = [initialGuess(i) for i in tspan]
    return TwoPointBVProblem(f, bc, u0, (tspan[1], tspan[end]), p; kwargs...)
end

######################## SecondOrderBVProblem ########################

"""
$(TYPEDEF)
"""
struct StandardSecondOrderBVProblem end

"""
$(TYPEDEF)
"""
struct TwoPointSecondOrderBVProblem{iip} end # The iip is needed to make type stable construction easier

@doc doc"""

Defines a second order BVP problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/bvp_types/>

## Mathematical Specification of a second order BVP Problem

To define a second order BVP Problem, you simply need to give the function ``f`` and the initial
condition ``u_0`` which define an ODE:

```math
u'' = \frac{d^2 u}{dt^2} = f(u', u, p, t)
```

along with an implicit function `bc` which defines the residual equation, where

```math
bc(u', u, p, t) = 0
```

is the manifold on which the solution must live. A common form for this is the
two-point `SecondOrderBVProblem` where the manifold defines the solution at two points:

```math
\begin{align*}
g(u(t_0), u'(t_0)) &= 0 \\
g(u(t_f), u'(t_f)) &= 0
\end{align*}
```

## Problem Type

### Constructors

```julia
TwoPointSecondOrderBVProblem{isinplace}(f, bc, u0, tspan, p=NullParameters(); kwargs...)
SecondOrderBVProblem{isinplace}(f, bc, u0, tspan, p=NullParameters(); kwargs...)
```

or if we have an initial guess function `initialGuess(p, t)` for the given BVP,
we can pass the initial guess to the problem constructors:

```julia
TwoPointSecondOrderBVProblem{isinplace}(f, bc, initialGuess, tspan, p=NullParameters(); kwargs...)
SecondOrderBVProblem{isinplace}(f, bc, initialGuess, tspan, p=NullParameters(); kwargs...)
```

For any BVP problem type, `bc` must be inplace if `f` is inplace. Otherwise it must be
out-of-place.

If the bvp is a StandardSecondOrderBVProblem (also known as a Multi-Point BV Problem) it must define
either of the following functions

```julia
bc!(residual, du, u, p, t)
residual = bc(du, u, p, t)
```

where `residual` computed from the current `u`. `u` is an array of solution values
where `u[i]` is at time `t[i]`, while `p` are the parameters. For a `TwoPointBVProblem`,
`t = tspan`. For the more general `BVProblem`, `u` can be all of the internal
time points, and for shooting type methods `u=sol` the ODE solution.
Note that all features of the `ODESolution` are present in this form.
In both cases, the size of the residual matches the size of the initial condition.

If the bvp is a `TwoPointSecondOrderBVProblem` then `bc` must be a Tuple `(bca, bcb)` and each of them
must define either of the following sets of functions:

```julia
bca!(resid_a, du_a, u_a, p)
bcb!(resid_b, du_b, u_b, p)
```

or

```julia
resid_a = bca(du_a, u_a, p)
resid_b = bcb(du_b, u_b, p)
```

where `resid_a` and `resid_b` are the residuals at the two endpoints, `u_a` and `u_b` are
the solution values at the two endpoints, `du_a` and `du_b` are the derivative of solution values at the two endpoints, and `p` are the parameters.


Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

### Fields

* `f`: The function for the ODE.
* `bc`: The boundary condition function.
* `u0`: The initial condition. Either the initial condition for the ODE as an
  initial value problem, or a `Vector` of values for ``u(t_i)`` for collocation
  methods.
* `tspan`: The timespan for the problem.
* `p`: The parameters for the problem. Defaults to `NullParameters`.
* `lb`: The lower bounds for the solution variables. Defaults to `nothing`.
* `ub`: The upper bounds for the solution variables. Defaults to `nothing`.
* `lcons`: The lower bounds for the constraint residuals. Defaults to `nothing`.
* `ucons`: The upper bounds for the constraint residuals. Defaults to `nothing`.
* `problem_type`: The type of the problem, either `StandardSecondOrderBVProblem` or
  `TwoPointSecondOrderBVProblem`.
* `kwargs`: The keyword arguments passed onto the solves.
"""
struct SecondOrderBVProblem{uType, tType, isinplace, nlls, P, F, LB, UB, LC, UC, PT, K} <:
    AbstractBVProblem{uType, tType, isinplace, nlls}
    f::F
    u0::uType
    tspan::tType
    p::P
    lb::LB
    ub::UB
    lcons::LC
    ucons::UC
    problem_type::PT
    kwargs::K

    @add_kwonly function SecondOrderBVProblem{iip}(
            f::DynamicalBVPFunction{iip, specialize, TP}, u0, tspan,
            p = NullParameters(); lb = nothing, ub = nothing, lcons = nothing,
            ucons = nothing, problem_type = nothing, nlls = nothing,
            kwargs...
        ) where {iip, specialize, TP}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        prob_type = TP ? TwoPointSecondOrderBVProblem{iip}() :
            StandardSecondOrderBVProblem()

        # Needed to ensure that `problem_type` doesn't get passed in kwargs
        if problem_type === nothing
            problem_type = prob_type
        else
            @assert prob_type === problem_type "This indicates incorrect problem type specification! Users should never pass in `problem_type` kwarg, this exists exclusively for internal use."
        end

        return new{
            typeof(_u0), typeof(_tspan), iip, typeof(nlls), typeof(p), typeof(f),
            typeof(lb), typeof(ub), typeof(lcons), typeof(ucons),
            typeof(problem_type), typeof(kwargs),
        }(
            f, _u0, _tspan, p, lb, ub, lcons, ucons, problem_type, kwargs
        )
    end

    function SecondOrderBVProblem{iip}(
            f, bc, u0, tspan, p = NullParameters(); kwargs...
        ) where {iip}
        return SecondOrderBVProblem(DynamicalBVPFunction{iip}(f, bc), u0, tspan, p; kwargs...)
    end
end

function SecondOrderBVProblem(f, bc, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 5)
    return SecondOrderBVProblem{iip}(
        DynamicalBVPFunction{iip}(f, bc), u0, tspan, p; kwargs...
    )
end

function SecondOrderBVProblem(
        f::DynamicalBVPFunction, u0, tspan, p = NullParameters(); kwargs...
    )
    return SecondOrderBVProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end

# This is mostly a fake struct and isn't used anywhere
# But we need it for function calls like TwoPointBVProblem{iip}(...) = ...
struct TwoPointDynamicalBVPFunction{iip} end

@inline function TwoPointDynamicalBVPFunction(args...; kwargs...)
    return DynamicalBVPFunction(args...; kwargs..., twopoint = Val(true))
end
@inline function TwoPointDynamicalBVPFunction{iip}(args...; kwargs...) where {iip}
    return DynamicalBVPFunction{iip}(args...; kwargs..., twopoint = Val(true))
end

function TwoPointSecondOrderBVProblem{iip}(
        f, bc, u0, tspan, p = NullParameters();
        bcresid_prototype = nothing, kwargs...
    ) where {iip}
    return TwoPointSecondOrderBVProblem(
        TwoPointDynamicalBVPFunction{iip}(f, bc; bcresid_prototype), u0, tspan,
        p; kwargs...
    )
end
function TwoPointSecondOrderBVProblem(
        f, bc, u0, tspan, p = NullParameters();
        bcresid_prototype = nothing, kwargs...
    )
    return TwoPointSecondOrderBVProblem(
        TwoPointDynamicalBVPFunction(f, bc; bcresid_prototype), u0, tspan, p;
        kwargs...
    )
end
function TwoPointSecondOrderBVProblem{iip}(
        f::AbstractBVPFunction{iip, twopoint}, u0, tspan,
        p = NullParameters(); kwargs...
    ) where {iip, twopoint}
    @assert twopoint "`TwoPointSecondOrderBVProblem` can only be used with a `TwoPointDynamicalBVPFunction`. Instead of using `DynamicalBVPFunction`, use `TwoPointDynamicalBVPFunction` or pass a kwarg `twopoint=Val(true)` during the construction of the `DynamicalBVPFunction`."
    return SecondOrderBVProblem{iip}(f, u0, tspan, p; kwargs...)
end
function TwoPointSecondOrderBVProblem(
        f::AbstractBVPFunction{iip, twopoint}, u0, tspan,
        p = NullParameters(); kwargs...
    ) where {iip, twopoint}
    @assert twopoint "`TwoPointSecondOrderBVProblem` can only be used with a `TwoPointDynamicalBVPFunction`. Instead of using `DynamicalBVPFunction`, use `TwoPointDynamicalBVPFunction` or pass a kwarg `twopoint=Val(true)` during the construction of the `DynamicalBVPFunction`."
    return SecondOrderBVProblem{iip}(f, u0, tspan, p; kwargs...)
end

# Allow previous timeseries solution
function TwoPointSecondOrderBVProblem(
        f::AbstractODEFunction, bc, sol::T, tspan::Tuple,
        p = NullParameters(); kwargs...
    ) where {T <: AbstractTimeseriesSolution}
    return TwoPointSecondOrderBVProblem(f, bc, sol.u, tspan, p; kwargs...)
end
# Allow initial guess function for the initial guess
function TwoPointSecondOrderBVProblem(
        f::AbstractODEFunction, bc, initialGuess, tspan::AbstractVector,
        p = NullParameters(); kwargs...
    )
    u0 = [initialGuess(i) for i in tspan]
    return TwoPointSecondOrderBVProblem(f, bc, u0, (tspan[1], tspan[end]), p; kwargs...)
end

@doc doc"""
    BVPAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_du0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving an BVP. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false .
* `alias_du0::Union{Bool, Nothing}`: alias the du0 array for DAEs. Defaults to false.
* `alias_tstops::Union{Bool, Nothing}`: alias the tstops array
* `alias::Union{Bool, Nothing}`: sets all fields of the `BVPAliasSpecifier` to `alias`

"""
struct BVPAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_du0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}

    function BVPAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_du0, alias_tstops)
        end
    end
end

using OrdinaryDiffEq, Test, Statistics

# test for https://github.com/SciML/SciMLBase.jl/issues/190
prob = ODEProblem((u, p, t) -> 1.01u, 0.5, (0.0, 1.0))
prob_func(prob, i, repeat) = remake(prob, u0 = rand() * prob.u0)
output_func(sol, i) = (last(sol), false)
reduction(u, batch, I) = (append!(u, mean(batch)), false)
# make sure first batch is timed (test using 1 batch but reduction)
ensemble_prob = EnsembleProblem(
    prob, prob_func = prob_func, output_func = output_func,
    reduction = reduction
)
sim = solve(
    ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 1000,
    batch_size = 1000
)

@test sim.elapsedTime > 1000 * @elapsed for i in 2:1
end

using ModelingToolkit, OrdinaryDiffEq, Test
using ModelingToolkit: t_nounits as t, D_nounits as D
using SymbolicIndexingInterface

@parameters σ ρ β
@variables x(t) y(t) z(t)

eqs = [
    D(D(x)) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
]

@mtkcompile sys = System(eqs, t)

u0 = [
    D(x) => 2.0,
    x => 1.0,
    y => 0.0,
    z => 0.0,
]

p = [
    σ => 28.0,
    ρ => 10.0,
    β => 8 / 3,
]

tspan = (0.0, 100.0)

# ODEProblem.
oprob = ODEProblem(sys, [u0; p], tspan, jac = true)

@test_throws Exception oprob[σ]
@test_throws Exception oprob[sys.σ]
@test_throws Exception oprob[:σ]
getσ1 = getp(sys, σ)
getσ2 = getp(sys, sys.σ)
getσ3 = getp(sys, :σ)
@test getσ1(oprob) == getσ2(oprob) == getσ3(oprob) == oprob.ps[σ] == oprob.ps[sys.σ] ==
    oprob.ps[:σ] == 28.0
getρ1 = getp(sys, ρ)
getρ2 = getp(sys, sys.ρ)
getρ3 = getp(sys, :ρ)
@test getρ1(oprob) == getρ2(oprob) == getρ3(oprob) == oprob.ps[ρ] == oprob.ps[sys.ρ] ==
    oprob.ps[:ρ] == 10.0
getβ1 = getp(sys, β)
getβ2 = getp(sys, sys.β)
getβ3 = getp(sys, :β)
@test getβ1(oprob) == getβ2(oprob) == getβ3(oprob) == oprob.ps[β] == oprob.ps[sys.β] ==
    oprob.ps[:β] == 8 / 3

@test oprob[x] == oprob[sys.x] == oprob[:x] == 1.0
@test oprob[y] == oprob[sys.y] == oprob[:y] == 0.0
@test oprob[z] == oprob[sys.z] == oprob[:z] == 0.0
@test oprob[solvedvariables] == oprob[variable_symbols(sys)]
@test oprob[allvariables] == oprob[all_variable_symbols(sys)]

setσ = setp(sys, σ)
setσ(oprob, 10.0)
@test getσ1(oprob) == getσ2(oprob) == getσ3(oprob) == oprob.ps[σ] == oprob.ps[sys.σ] ==
    oprob.ps[:σ] == 10.0
setρ = setp(sys, sys.ρ)
setρ(oprob, 20.0)
@test getρ1(oprob) == getρ2(oprob) == getρ3(oprob) == oprob.ps[ρ] == oprob.ps[sys.ρ] ==
    oprob.ps[:ρ] == 20.0
setβ = setp(sys, :β)
setβ(oprob, 30.0)
@test getβ1(oprob) == getβ2(oprob) == getβ3(oprob) == oprob.ps[β] == oprob.ps[sys.β] ==
    oprob.ps[:β] == 30.0

oprob.ps[σ] = 11.0
@test getσ1(oprob) == getσ2(oprob) == getσ3(oprob) == oprob.ps[σ] == oprob.ps[sys.σ] ==
    oprob.ps[:σ] == 11.0
oprob.ps[sys.ρ] = 21.0
@test getρ1(oprob) == getρ2(oprob) == getρ3(oprob) == oprob.ps[ρ] == oprob.ps[sys.ρ] ==
    oprob.ps[:ρ] == 21.0
oprob.ps[:β] = 31.0
@test getβ1(oprob) == getβ2(oprob) == getβ3(oprob) == oprob.ps[β] == oprob.ps[sys.β] ==
    oprob.ps[:β] == 31.0

oprob[x] = 10.0
@test oprob[x] == oprob[sys.x] == oprob[:x] == 10.0
oprob[sys.y] = 10.0
@test oprob[sys.y] == oprob[sys.y] == oprob[:y] == 10.0
oprob[:z] = 1.0
@test oprob[z] == oprob[sys.z] == oprob[:z] == 1.0

getx = getsym(oprob, x)
gety = getsym(oprob, :y)
get_arr = getsym(oprob, [x, y])
get_tuple = getsym(oprob, (y, z))
get_obs = getsym(oprob, sys.x + sys.z + t + σ)
@test getx(oprob) == 10.0
@test gety(oprob) == 10.0
@test get_arr(oprob) == [10.0, 10.0]
@test get_tuple(oprob) == (10.0, 1.0)
@test get_obs(oprob) == 22.0

setx! = setsym(oprob, x)
sety! = setsym(oprob, :y)
set_arr! = setsym(oprob, [x, y])
set_tuple! = setsym(oprob, (y, z))

setx!(oprob, 11.0)
@test getx(oprob) == 11.0
sety!(oprob, 12.0)
@test gety(oprob) == 12.0
set_arr!(oprob, [11.0, 12.0])
@test get_arr(oprob) == [11.0, 12.0]
set_tuple!(oprob, [10.0, 10.0])
@test get_tuple(oprob) == (10.0, 10.0)

# SDEProblem.
noiseeqs = [
    0.1 * D(x),
    0.1 * x,
    0.1 * y,
    0.1 * z,
]
@named noise_sys = SDESystem(sys, noiseeqs)
noise_sys = complete(noise_sys)
sprob = SDEProblem(noise_sys, [u0; p], (0.0, 100.0))
u0

getσ1 = getp(noise_sys, σ)
getσ2 = getp(noise_sys, sys.σ)
getσ3 = getp(noise_sys, :σ)
@test getσ1(sprob) == getσ2(sprob) == getσ3(sprob) == sprob.ps[σ] == sprob.ps[sys.σ] ==
    sprob.ps[:σ] == 28.0
getρ1 = getp(noise_sys, ρ)
getρ2 = getp(noise_sys, sys.ρ)
getρ3 = getp(noise_sys, :ρ)
@test getρ1(sprob) == getρ2(sprob) == getρ3(sprob) == sprob.ps[ρ] == sprob.ps[sys.ρ] ==
    sprob.ps[:ρ] == 10.0
getβ1 = getp(noise_sys, β)
getβ2 = getp(noise_sys, sys.β)
getβ3 = getp(noise_sys, :β)
@test getβ1(sprob) == getβ2(sprob) == getβ3(sprob) == sprob.ps[β] == sprob.ps[sys.β] ==
    sprob.ps[:β] == 8 / 3

@test sprob[x] == sprob[noise_sys.x] == sprob[:x] == 1.0
@test sprob[y] == sprob[noise_sys.y] == sprob[:y] == 0.0
@test sprob[z] == sprob[noise_sys.z] == sprob[:z] == 0.0

setσ = setp(noise_sys, σ)
setσ(sprob, 10.0)
@test getσ1(sprob) == getσ2(sprob) == getσ3(sprob) == sprob.ps[σ] == sprob.ps[sys.σ] ==
    sprob.ps[:σ] == 10.0
setρ = setp(noise_sys, sys.ρ)
setρ(sprob, 20.0)
@test getρ1(sprob) == getρ2(sprob) == getρ3(sprob) == sprob.ps[ρ] == sprob.ps[sys.ρ] ==
    sprob.ps[:ρ] == 20.0
setp(noise_sys, noise_sys.ρ)(sprob, 25.0)
@test getρ1(sprob) == getρ2(sprob) == getρ3(sprob) == sprob.ps[ρ] == sprob.ps[sys.ρ] ==
    sprob.ps[:ρ] == 25.0
setβ = setp(noise_sys, :β)
setβ(sprob, 30.0)
@test getβ1(sprob) == getβ2(sprob) == getβ3(sprob) == sprob.ps[β] == sprob.ps[sys.β] ==
    sprob.ps[:β] == 30.0
sprob.ps[σ] = 11.0
@test getσ1(sprob) == getσ2(sprob) == getσ3(sprob) == sprob.ps[σ] == sprob.ps[sys.σ] ==
    sprob.ps[:σ] == 11.0
sprob.ps[sys.ρ] = 21.0
@test getρ1(sprob) == getρ2(sprob) == getρ3(sprob) == sprob.ps[ρ] == sprob.ps[sys.ρ] ==
    sprob.ps[:ρ] == 21.0
sprob.ps[:β] = 31.0
@test getβ1(sprob) == getβ2(sprob) == getβ3(sprob) == sprob.ps[β] == sprob.ps[sys.β] ==
    sprob.ps[:β] == 31.0

sprob[x] = 10.0
@test sprob[x] == sprob[noise_sys.x] == sprob[:x] == 10.0
sprob[noise_sys.y] = 10.0
@test sprob[y] == sprob[noise_sys.y] == sprob[:y] == 10.0
sprob[:z] = 1.0
@test sprob[z] == sprob[noise_sys.z] == sprob[:z] == 1.0

getx = getsym(sprob, x)
gety = getsym(sprob, :y)
get_arr = getsym(sprob, [x, y])
get_tuple = getsym(sprob, (y, z))
get_obs = getsym(sprob, sys.x + sys.z + t + σ)
@test getx(sprob) == 10.0
@test gety(sprob) == 10.0
@test get_arr(sprob) == [10.0, 10.0]
@test get_tuple(sprob) == (10.0, 1.0)
@test get_obs(sprob) == 22.0

setx! = setsym(sprob, x)
sety! = setsym(sprob, :y)
set_arr! = setsym(sprob, [x, y])
set_tuple! = setsym(sprob, (y, z))

setx!(sprob, 11.0)
@test getx(sprob) == 11.0
sety!(sprob, 12.0)
@test gety(sprob) == 12.0
set_arr!(sprob, [11.0, 12.0])
@test get_arr(sprob) == [11.0, 12.0]
set_tuple!(sprob, [10.0, 10.0])
@test get_tuple(sprob) == (10.0, 10.0)

using LinearAlgebra
sts = @variables x(t)[1:3] = [1, 2, 3.0] y(t) = 1.0
ps = @parameters p[1:3] = [1, 2, 3]
eqs = [
    collect(D.(x) .~ x)
    D(y) ~ norm(x) * y - x[1]
]
@mtkcompile sys = System(eqs, t, [sts...;], [ps...;])
prob = ODEProblem(sys, [], (0, 1.0))
@test getp(sys, p)(prob) == prob.ps[p] == [1, 2, 3]
setp(sys, p)(prob, [4, 5, 6])
@test getp(sys, p)(prob) == prob.ps[p] == [4, 5, 6]
prob.ps[p] = [7, 8, 9]
@test getp(sys, p)(prob) == prob.ps[p] == [7, 8, 9]

# EnsembleProblem indexing
# Issue#661
@parameters p d
@variables X(t) X2(t)
eqs = [
    D(X) ~ p - d * X,
    X2 ~ 2 * X,
]
@mtkcompile osys = System(eqs, t)

u0 = [X => 0.1]
tspan = (0.0, 10.0)
ps = [p => 1.0, d => 0.2]
oprob = ODEProblem(osys, [u0; ps], tspan)
eprob = EnsembleProblem(oprob)

@test eprob[X] == 0.1
@test eprob[:X] == 0.1
@test eprob[osys.X] == 0.1
@test eprob.ps[p] == 1.0
@test eprob.ps[:p] == 1.0
@test eprob.ps[osys.p] == 1.0
@test getsym(eprob, X)(eprob) == 0.1
@test getsym(eprob, :X)(eprob) == 0.1
@test getsym(eprob, osys.X)(eprob) == 0.1
@test getp(eprob, p)(eprob) == 1.0
@test getp(eprob, :p)(eprob) == 1.0
@test getp(eprob, osys.p)(eprob) == 1.0

@test_nowarn eprob[X] = 0.0
@test eprob[X] == 0.0
@test_nowarn eprob[:X] = 0.1
@test eprob[:X] == 0.1
@test_nowarn eprob[osys.X] = 0.0
@test eprob[osys.X] == 0.0
@test_nowarn eprob.ps[p] = 0.0
@test eprob.ps[p] == 0.0
@test_nowarn eprob.ps[:p] = 0.1
@test eprob.ps[:p] == 0.1
@test_nowarn eprob.ps[osys.p] = 0.0
@test eprob.ps[osys.p] == 0.0
@test_nowarn setsym(eprob, X)(eprob, 0.1)
@test eprob[X] == 0.1
@test_nowarn setsym(eprob, :X)(eprob, 0.0)
@test eprob[:X] == 0.0
@test_nowarn setsym(eprob, osys.X)(eprob, 0.1)
@test eprob[osys.X] == 0.1
@test_nowarn setp(eprob, p)(eprob, 0.1)
@test eprob.ps[p] == 0.1
@test_nowarn setp(eprob, :p)(eprob, 0.0)
@test eprob.ps[:p] == 0.0
@test_nowarn setp(eprob, osys.p)(eprob, 0.1)
@test eprob.ps[osys.p] == 0.1

@test state_values(remake(eprob; u0 = [X => 0.1])) == [0.1]
@test state_values(remake(eprob; u0 = [:X => 0.2])) == [0.2]
@test state_values(remake(eprob; u0 = [osys.X => 0.3])) == [0.3]

@test remake(eprob; p = [d => 0.4]).ps[d] == 0.4
@test remake(eprob; p = [:d => 0.5]).ps[d] == 0.5
@test remake(eprob; p = [osys.d => 0.6]).ps[d] == 0.6

# SteadyStateProblem Indexing
# Issue#660
@parameters p d
@variables X(t) X2(t)
eqs = [
    D(X) ~ p - d * X,
    X2 ~ 2 * X,
]
@mtkbuild osys = System(eqs, t)

u0 = [X => 0.1]
ps = [p => 1.0, d => 0.2]
prob = SteadyStateProblem(osys, [u0; ps])

@test prob[X] == prob[osys.X] == prob[:X] == 0.1
@test prob[X2] == prob[osys.X2] == prob[:X2] == 0.2
@test prob[[X, X2]] == prob[[osys.X, osys.X2]] == prob[[:X, :X2]] == [0.1, 0.2]
@test getsym(prob, X)(prob) == getsym(prob, osys.X)(prob) == getsym(prob, :X)(prob) == 0.1
@test getsym(prob, X2)(prob) == getsym(prob, osys.X2)(prob) == getsym(prob, :X2)(prob) ==
    0.2
@test getsym(prob, [X, X2])(prob) == getsym(prob, [osys.X, osys.X2])(prob) ==
    getsym(prob, [:X, :X2])(prob) == [0.1, 0.2]
@test getsym(prob, (X, X2))(prob) == getsym(prob, (osys.X, osys.X2))(prob) ==
    getsym(prob, (:X, :X2))(prob) == (0.1, 0.2)

@testset "SCCNonlinearProblem" begin
    function fullf!(du, u, p)
        du[1] = cos(u[2]) - u[1]
        du[2] = sin(u[1] + u[2]) + u[2]
        du[3] = 2u[4] + u[3] + p[1]
        du[4] = u[5]^2 + u[4]
        du[5] = u[3]^2 + u[5]
        du[6] = u[1] + u[2] + u[3] + u[4] + u[5] + 2.0u[6] + 2.5u[7] + 1.5u[8]
        du[7] = u[1] + u[2] + u[3] + 2.0u[4] + u[5] + 4.0u[6] - 1.5u[7] + 1.5u[8]
        du[8] = u[1] + 2.0u[2] + 3.0u[3] + 5.0u[4] + 6.0u[5] + u[6] - u[7] - u[8]
    end
    @variables u[1:8] = zeros(8) [irreducible = true]
    u2 = collect(u)
    @parameters p = 1.0
    eqs = Any[0 for _ in 1:8]
    fullf!(eqs, u, [p])
    @mtkcompile model = System(0 .~ eqs, [u...], [p])

    prob = NonlinearProblem(model, [])
    sccprob = SCCNonlinearProblem(model, [])
    @test sccprob isa SCCNonlinearProblem
end

@testset "LinearProblem" begin
    # TODO update when MTK codegen exists
    sys = SymbolCache([:x, :y, :z], [:p, :q, :r])
    update_A! = function (A, p)
        A[1, 1] = p[1]
        A[2, 2] = p[2]
        A[3, 3] = p[3]
    end
    update_b! = function (b, p)
        b[1] = p[3]
        b[2] = -8p[2] - p[1]
    end
    f = SciMLBase.SymbolicLinearInterface(update_A!, update_b!, sys, nothing, nothing)
    A = Float64[1 1 1; 6 -4 5; 5 2 2]
    b = Float64[2, 31, 13]
    p = Float64[1, -4, 2]
    u0 = Float64[1, 2, 3]
    prob = LinearProblem(A, b, p; u0, f)
    @test prob[:x] ≈ 1.0
    @test prob[:y] ≈ 2.0
    @test prob[:z] ≈ 3.0
    @test prob.ps[:p] ≈ 1.0
    @test prob.ps[:q] ≈ -4.0
    @test prob.ps[:r] ≈ 2.0
    prob.ps[:p] = 2.0
    @test prob.ps[:p] ≈ 2.0
    @test prob.A[1, 1] ≈ 2.0
    @test prob.b[2] ≈ 30.0

    prob2 = remake(prob; u0 = 2u0)
    @test prob2.u0 ≈ 2u0
    prob2 = remake(prob; p = 2p)
    @test prob2.p ≈ 2p
    prob2 = remake(prob; u0 = [:x => 3.0], p = [:q => 1.5])
    @test prob2.u0[1] ≈ 3.0
    @test prob2.p[2] ≈ 1.5

    # no u0
    prob = LinearProblem(A, b, p; f)
    prob2 = remake(prob; p = 2p)
    @test prob2.p ≈ 2p
    prob2 = remake(prob; p = [:q => 1.5])
    @test prob2.p[2] ≈ 1.5
end

using SciMLBase, Test

@testset "DomainError hint only in SciML context" begin
    # DomainError outside any SciML context should NOT show the SciML hint
    @testset "standalone log(-1) does not trigger hint" begin
        output = try
            log(-1.0)
        catch e
            sprint(showerror, e)
        end
        @test occursin("DomainError", output)
        @test !occursin("DomainError detected in the user", output)
    end

    @testset "standalone sqrt(-1) does not trigger hint" begin
        output = try
            sqrt(-1.0)
        catch e
            sprint(showerror, e)
        end
        @test occursin("DomainError", output)
        @test !occursin("DomainError detected in the user", output)
    end

    # DomainError through an ODEFunction (SciMLBase wrapper) SHOULD show the hint
    @testset "DomainError through ODEFunction triggers hint" begin
        f_oop(u, p, t) = log(u)
        odefun = ODEFunction(f_oop)
        output = try
            odefun(-1.0, nothing, 0.0)
        catch e
            sprint(showerror, e)
        end
        @test occursin("DomainError", output)
        @test occursin("DomainError detected in the user", output)
    end

    @testset "DomainError through in-place ODEFunction triggers hint" begin
        f_iip(du, u, p, t) = (du .= log.(u))
        odefun = ODEFunction(f_iip)
        du = [0.0]
        output = try
            odefun(du, [-1.0], nothing, 0.0)
        catch e
            sprint(showerror, e)
        end
        @test occursin("DomainError", output)
        @test occursin("DomainError detected in the user", output)
    end

    # Non-complex DomainError should never show the hint regardless of context
    @testset "unrelated DomainError does not trigger hint" begin
        output = try
            throw(DomainError(-1, "some other message"))
        catch e
            sprint(showerror, e)
        end
        @test occursin("DomainError", output)
        @test !occursin("DomainError detected in the user", output)
    end
end

@testset "NullParameters MethodError hint" begin
    @testset "arithmetic on NullParameters triggers hint" begin
        output = try
            SciMLBase.NullParameters() + 1
        catch e
            sprint(showerror, e)
        end
        @test occursin("NullParameters", output)
    end
end

const PERFORMANCE_WARNINGS = Preferences.@load_preference("PerformanceWarnings", true)

should_warn_paramtype(p::AbstractArray) = !isconcretetype(eltype(p))
should_warn_paramtype(::Dict{K, V}) where {K, V} = !isconcretetype(V)
should_warn_paramtype(p::AbstractArray{<:AbstractArray}) = any(should_warn_paramtype, p)
should_warn_paramtype(p::Tuple) = any(should_warn_paramtype, p)
should_warn_paramtype(p::NamedTuple) = any(should_warn_paramtype, p)
should_warn_paramtype(p) = false

const WARN_PARAMTYPE_MESSAGE = """
Using arrays or dicts to store parameters of different types can hurt performance.
Consider using tuples instead.
"""

"""
    warn_paramtype(p, warn_performance=PERFORMANCE_WARNINGS)

Inspect the type of `p` and emit a warning if it could hurt
performance when used to hold problem parameters.

The warning can be turned off by setting `warn_performance` to `false`.
To turn it off globally within the active project you can execute the following code, or put it in your `startup.jl`.

```julia
using Preferences, UUIDs
set_preferences!(
    UUID("1dea7af3-3e70-54e6-95c3-0bf5283fa5ed"), "PerformanceWarnings" => false)
```
"""
function warn_paramtype(p, warn_performance = PERFORMANCE_WARNINGS)
    return if warn_performance && should_warn_paramtype(p)
        @warn WARN_PARAMTYPE_MESSAGE maxlog = 1
    end
end

"""
$(TYPEDEF)

Representation of the solution to an linear system `Ax=b` defined by a `LinearProblem`

## Fields

  - `u`: the representation of the linear solve's solution.
  - `resid`: the residual of the solver, if the method is an iterative method. Returns a mutable
    type, thus if scalar it is wrapped in a `Ref`.
  - `alg`: the algorithm type used by the solver.
  - `iters`: the number of iterations used to solve the equation, if the method is an iterative
    method.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully or whether it exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
  - `cache`: the `LinearCache` object containing the solver's internal cached variables. This
    is given to allow continuation of solver usage, for example, solving `Ax=b` with the same
    `A` and a new `b` without refactorizing `A`. See the caching interface tutorial for details
    on how to use the `cache` effectively: <https://docs.sciml.ai/LinearSolve/stable/tutorials/caching_interface>
  - `stats`: statistics of the solver, such as the number of function evaluations required.
"""
struct LinearSolution{T, N, uType, R, A, C, S} <: AbstractLinearSolution{T, N}
    u::uType
    resid::R
    alg::A
    retcode::ReturnCode.T
    iters::Int
    cache::C
    stats::S
end

function build_linear_solution(
        alg, u, resid, cache;
        retcode = ReturnCode.Default,
        iters = 0, stats = nothing
    )
    T = eltype(eltype(u))
    N = length((size(u)...,))
    return LinearSolution{
        T, N, typeof(u), typeof(resid), typeof(alg), typeof(cache),
        typeof(stats),
    }(
        u,
        resid,
        alg,
        retcode,
        iters,
        cache,
        stats
    )
end

"""
$(TYPEDEF)

Representation of the solution to an quadrature integral_lb^ub f(x) dx defined by a `IntegralProblem`

## Fields

  - `u`: the representation of the optimization's solution.
  - `resid`: the residual of the solver.
  - `alg`: the algorithm type used by the solver.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully or whether it exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
  - `chi`: the variance estimate of the estimator from Monte Carlo quadrature methods.
  - `stats`: statistics of the solver, such as the number of function evaluations required.
"""
struct IntegralSolution{T, N, uType, R, P, A, C, S} <: AbstractIntegralSolution{T, N}
    u::uType
    resid::R
    prob::P
    alg::A
    retcode::ReturnCode.T
    chi::C
    stats::S
end

struct QuadratureSolution end
@deprecate QuadratureSolution(args...; kwargs...) IntegralSolution(args...; kwargs...)

function build_solution(
        prob::AbstractIntegralProblem,
        alg, u, resid; chi = nothing,
        retcode = ReturnCode.Default, stats = nothing, kwargs...
    )
    T = eltype(eltype(u))
    N = length((size(u)...,))

    return IntegralSolution{
        T, N, typeof(u), typeof(resid), typeof(prob), typeof(alg), typeof(chi),
        typeof(stats),
    }(
        u,
        resid,
        prob,
        alg,
        retcode,
        chi,
        stats
    )
end

function wrap_sol(sol)
    return if hasproperty(sol, :prob) && hasproperty(sol.prob, :problem_type)
        wrap_sol(sol, sol.prob.problem_type)
    else
        sol
    end
end

# Define a default `wrap_sol` that does nothing
wrap_sol(sol, _) = sol

module SciMLBaseMooncakeExt

using SciMLBase, Mooncake
using SciMLBase: ADOriginator, ChainRulesOriginator, MooncakeOriginator,
    AbstractTimeseriesSolution, AbstractNonlinearSolution, getobserved
using SymbolicIndexingInterface: symbolic_type, NotSymbolic, variable_index,
    parameter_values
import SymbolicIndexingInterface as SII
import Mooncake: rrule!!, CoDual, zero_fcodual, @is_primitive,
    @from_rrule, @zero_adjoint, @mooncake_overlay, MinimalCtx,
    NoPullback, NoFData, NoRData, NoTangent, fdata, zero_tangent,
    primal, tangent, build_rrule, prepare_pullback_cache, value_and_pullback!!

# OverrideInitData and ODENLStepData are solver/initialization infrastructure
# embedded in ODEFunction type parameters. They are not differentiable, but their
# deeply nested type parameters (NonlinearProblem, RuntimeGeneratedFunction,
# InitializationMetadata, etc.) cause Mooncake's abstract interpretation to hang
# during type inference. Marking them NoTangent avoids generating tangent code
# for these fields entirely.
Mooncake.tangent_type(::Type{<:SciMLBase.OverrideInitData}) = Mooncake.NoTangent
Mooncake.tangent_type(::Type{<:SciMLBase.ODENLStepData}) = Mooncake.NoTangent

# Non-differentiable helpers — these use runtime reflection (`methods`) or
# only validate/dispatch and have no numerical gradient contribution.
@zero_adjoint MinimalCtx Tuple{typeof(SciMLBase.numargs), Any}
@zero_adjoint MinimalCtx Tuple{typeof(SciMLBase.checkkwargs), Any}
@zero_adjoint MinimalCtx Tuple{typeof(SciMLBase.isinplace), Any, Any}
@zero_adjoint MinimalCtx Tuple{typeof(SciMLBase.isinplace), Any, Any, Any}
@zero_adjoint MinimalCtx Tuple{typeof(SciMLBase.isinplace), Any, Any, Any, Any}

@is_primitive MinimalCtx Tuple{
    typeof(SciMLBase.set_mooncakeoriginator_if_mooncake), SciMLBase.ChainRulesOriginator,
}

@mooncake_overlay SciMLBase.set_mooncakeoriginator_if_mooncake(x::SciMLBase.ADOriginator) = SciMLBase.MooncakeOriginator()

function rrule!!(
        f::CoDual{typeof(SciMLBase.set_mooncakeoriginator_if_mooncake)},
        X::CoDual{SciMLBase.ChainRulesOriginator}
    )
    return zero_fcodual(SciMLBase.MooncakeOriginator()), NoPullback(f, X)
end

# ============================================================================
# tmap and responsible_map rules for Ensemble AD
# These enable Mooncake to differentiate through ensemble solves by providing
# proper AD nesting for the mapped function.
# See: https://github.com/SciML/DiffEqBase.jl/issues/1256
# ============================================================================

# Mark tmap and responsible_map as primitives
@is_primitive MinimalCtx Tuple{typeof(SciMLBase.tmap), Any, Vararg}
@is_primitive MinimalCtx Tuple{typeof(SciMLBase.responsible_map), Any, Vararg}

# Helper to accumulate tangents
function _accum_tangents(a::NoTangent, b::NoTangent)
    return NoTangent()
end
function _accum_tangents(a::NoTangent, b)
    return b
end
function _accum_tangents(a, b::NoTangent)
    return a
end
function _accum_tangents(a::T, b::T) where {T <: Number}
    return a + b
end
function _accum_tangents(a::Tuple, b::Tuple)
    return map(_accum_tangents, a, b)
end
function _accum_tangents(a::NamedTuple{N}, b::NamedTuple{N}) where {N}
    return NamedTuple{N}(map(_accum_tangents, values(a), values(b)))
end
function _accum_tangents(a, b)
    # Fallback: try addition
    return a + b
end

"""
    rrule!! for SciMLBase.tmap

Implements reverse-mode AD for tmap by:
1. Forward pass: Compute primals and prepare pullback caches for each element
2. Reverse pass: Read gradients from output fdata, compute input gradients via caches

Note: For vectors, Mooncake uses fdata (tangent field of CoDual) for gradients,
not rdata. The pullback receives NoRData() and must read the gradient from
the output's fdata which was modified by the downstream operation.
"""
function rrule!!(
        ::CoDual{typeof(SciMLBase.tmap)},
        f_dual::CoDual{F},
        args_dual::CoDual...
    ) where {F}
    # Extract primals and tangents (fdata)
    f = primal(f_dual)
    args = map(primal, args_dual)
    args_tangents = map(tangent, args_dual)

    n = length(args[1])

    # Compute first element to determine output type
    if n == 0
        # Empty case - infer type from function signature if possible
        T = Core.Compiler.return_type(f, Tuple{map(eltype, args)...})
        ys = Vector{T}(undef, 0)
        return zero_fcodual(ys), NoPullback(zero_fcodual(SciMLBase.tmap), f_dual, args_dual...)
    end

    # Forward pass: compute values and prepare caches
    caches = Vector{Any}(undef, n)

    # Compute first element to get the type
    arg_1 = ntuple(j -> args[j][1], length(args))
    caches[1] = prepare_pullback_cache(f, arg_1...)
    y1 = f(arg_1...)

    # Create properly typed output vector and its tangent (fdata)
    ys = Vector{typeof(y1)}(undef, n)
    ys[1] = y1
    ys_tangent = zeros(typeof(y1), n)

    # Compute remaining elements
    for i in 2:n
        arg_i = ntuple(j -> args[j][i], length(args))
        # Prepare cache for this call
        caches[i] = prepare_pullback_cache(f, arg_i...)
        # Compute primal value
        ys[i] = f(arg_i...)
    end

    # Create output CoDual - the tangent will be modified by downstream pullbacks
    ys_codual = CoDual(ys, ys_tangent)

    function tmap_pullback!!(::NoRData)
        # For vectors, gradient comes from fdata (ys_tangent), not rdata
        # The downstream operation (e.g., sum) will have modified ys_tangent

        # Compute gradients for each element and accumulate into input tangents
        Δf = NoTangent()

        for i in 1:n
            arg_i = ntuple(j -> args[j][i], length(args))
            # Get cotangent for this element from output fdata
            δ_i = ys_tangent[i]

            # Use cache to compute pullback
            _, tangents_i = value_and_pullback!!(caches[i], δ_i, f, arg_i...)
            # tangents_i is (df, darg1, darg2, ...)

            Δf = _accum_tangents(Δf, tangents_i[1])

            # Accumulate into input tangents (fdata)
            for j in 1:length(args)
                args_tangents[j][i] += tangents_i[j + 1]
            end
        end

        # Return NoRData for all args since gradients are in fdata
        Δargs = ntuple(_ -> NoRData(), length(args))
        return NoTangent(), Δf, Δargs...
    end

    return ys_codual, tmap_pullback!!
end

"""
    rrule!! for SciMLBase.responsible_map

Implements reverse-mode AD for responsible_map by:
1. Forward pass: Compute primals and prepare pullback caches for each element
2. Reverse pass: Read gradients from output fdata, compute input gradients in reverse order (for stateful f)

Note: For vectors, Mooncake uses fdata (tangent field of CoDual) for gradients,
not rdata. The pullback receives NoRData() and must read the gradient from
the output's fdata which was modified by the downstream operation.
"""
function rrule!!(
        ::CoDual{typeof(SciMLBase.responsible_map)},
        f_dual::CoDual{F},
        args_dual::CoDual...
    ) where {F}
    # Extract primals and tangents (fdata)
    f = primal(f_dual)
    args = map(primal, args_dual)
    args_tangents = map(tangent, args_dual)

    n = length(args[1])

    # Compute first element to determine output type
    if n == 0
        # Empty case - infer type from function signature if possible
        T = Core.Compiler.return_type(f, Tuple{map(eltype, args)...})
        ys = Vector{T}(undef, 0)
        return zero_fcodual(ys), NoPullback(zero_fcodual(SciMLBase.responsible_map), f_dual, args_dual...)
    end

    # Forward pass: compute values and prepare caches
    caches = Vector{Any}(undef, n)

    # Compute first element to get the type
    arg_1 = ntuple(j -> args[j][1], length(args))
    caches[1] = prepare_pullback_cache(f, arg_1...)
    y1 = f(arg_1...)

    # Create properly typed output vector and its tangent (fdata)
    ys = Vector{typeof(y1)}(undef, n)
    ys[1] = y1
    ys_tangent = zeros(typeof(y1), n)

    # Compute remaining elements
    for i in 2:n
        arg_i = ntuple(j -> args[j][i], length(args))
        # Prepare cache for this call
        caches[i] = prepare_pullback_cache(f, arg_i...)
        # Compute primal value
        ys[i] = f(arg_i...)
    end

    # Create output CoDual - the tangent will be modified by downstream pullbacks
    ys_codual = CoDual(ys, ys_tangent)

    function responsible_map_pullback!!(::NoRData)
        # For vectors, gradient comes from fdata (ys_tangent), not rdata
        # The downstream operation (e.g., sum) will have modified ys_tangent

        # Compute gradients for each element and accumulate into input tangents
        # Apply pullbacks in reverse order for correctness with stateful f
        Δf = NoTangent()

        for i in n:-1:1
            arg_i = ntuple(j -> args[j][i], length(args))
            # Get cotangent for this element from output fdata
            δ_i = ys_tangent[i]

            # Use cache to compute pullback
            _, tangents_i = value_and_pullback!!(caches[i], δ_i, f, arg_i...)
            # tangents_i is (df, darg1, darg2, ...)

            Δf = _accum_tangents(Δf, tangents_i[1])

            # Accumulate into input tangents (fdata)
            for j in 1:length(args)
                args_tangents[j][i] += tangents_i[j + 1]
            end
        end

        # Return NoRData for all args since gradients are in fdata
        Δargs = ntuple(_ -> NoRData(), length(args))
        return NoTangent(), Δf, Δargs...
    end

    return ys_codual, responsible_map_pullback!!
end

# =============================================================================
# Symbolic indexing of solutions: getindex(sol, sym)
# =============================================================================
#
# Mooncake cannot differentiate through `sol[sym]` for symbolic `sym` because
# the SymbolicIndexingInterface dispatch chain uses hash-consed symbols,
# task-local values, IdDicts, and atomic pointers — none of which are
# differentiable infrastructure. Make `getindex(::AbstractTimeseriesSolution,
# sym)` a primitive that bypasses the dispatch and:
#
# - For state variables: scatter the gradient directly into `sol.u[k][i]`
# - For observables: build a Mooncake derived rule for the observed function
#   and apply it (analogous to how `SciMLBaseChainRulesCoreExt` uses
#   `rrule_via_ad` to recurse into Zygote for the observed function).

@is_primitive MinimalCtx Tuple{typeof(getindex), AbstractTimeseriesSolution, Any}
@is_primitive MinimalCtx Tuple{
    typeof(getindex), AbstractTimeseriesSolution, Any, Integer,
}
@is_primitive MinimalCtx Tuple{
    typeof(getindex), AbstractTimeseriesSolution, AbstractVector,
}
# `sol[i::Integer]` returns the state vector at time step `i` (a different
# operation from `sol[sym]`). A dedicated, more-specific primitive routes
# integer time-step indexing to the correct scatter so the generic symbolic
# rrule above does not mistake `i` for a state-variable index (#1325).
@is_primitive MinimalCtx Tuple{typeof(getindex), AbstractTimeseriesSolution, Integer}

# Differentiate the observed function `getter(sym, u, p, t)` once with
# Mooncake. The pullback `pb(dy)` mutates the fdata captured in the input
# CoDuals so the gradients land in the locations we control: `u_fd` for the
# state and `p_fd` for the parameters. This is the Mooncake equivalent of
# how SciMLBaseChainRulesCoreExt uses `rrule_via_ad` to recurse into Zygote.
function _run_observable_pullback(getter, s, u_jp, p, t_jp, dy)
    sig = Tuple{typeof(getter), typeof(s), typeof(u_jp), typeof(p), typeof(t_jp)}
    rule = build_rrule(sig)

    # Allocate fresh fdata for u and p so the gradient lands in known
    # buffers rather than the (possibly aliased) original tangents.
    u_fd = zero(u_jp)
    p_fd = fdata(zero_tangent(p))
    getter_cd = CoDual(getter, fdata(zero_tangent(getter)))
    sym_cd = CoDual(s, fdata(zero_tangent(s)))
    u_cd = CoDual(u_jp, u_fd)
    p_cd = CoDual(p, p_fd)
    t_cd = CoDual(t_jp, fdata(zero_tangent(t_jp)))

    _, pb = rule(getter_cd, sym_cd, u_cd, p_cd, t_cd)
    pb(dy)
    return u_fd, p_fd
end

# Accumulate parameter gradient `p_fd` (an FData) into `dest_p_tangent`
# (which may be a Tangent for immutable structs or an FData/MutableTangent
# for other layouts). We can't use Mooncake.increment!! because of type
# mismatches between Tangent and FData. Instead, walk the NamedTuple
# structure and accumulate Vector-typed leaves in place.
function _accumulate_p_fdata!(dest, src)
    (dest isa NoFData || dest isa NoTangent || src isa NoFData || src isa NoTangent) &&
        return nothing
    if dest isa Vector{<:Real} && src isa Vector{<:Real}
        @. dest += src
        return nothing
    end
    # Tangent / MutableTangent use .fields; FData uses .data.
    dest_fields = if dest isa Mooncake.FData
        dest.data
    elseif dest isa Mooncake.Tangent || dest isa Mooncake.MutableTangent
        dest.fields
    else
        return nothing
    end
    src_fields = if src isa Mooncake.FData
        src.data
    elseif src isa Mooncake.Tangent || src isa Mooncake.MutableTangent
        src.fields
    else
        return nothing
    end
    for name in propertynames(dest_fields)
        hasproperty(src_fields, name) || continue
        _accumulate_p_fdata!(getfield(dest_fields, name), getfield(src_fields, name))
    end
    return nothing
end

function _observable_pullback_at!(sol_fdata, VA, s, dy, jp)
    getter = getobserved(VA)
    u_jp = VA.u[jp]
    p = parameter_values(VA.prob)
    t_jp = VA.t[jp]

    u_fd, p_fd = _run_observable_pullback(getter, s, u_jp, p, t_jp, dy)

    # Scatter u-grad into sol_fdata.u at index jp
    u_dest = sol_fdata.data.u[jp]
    @. u_dest += u_fd

    # Propagate p-grad into sol_fdata.prob.p (if accessible).
    prob_fd = sol_fdata.data.prob
    if prob_fd isa Mooncake.MutableTangent && hasfield(typeof(prob_fd.fields), :p)
        _accumulate_p_fdata!(prob_fd.fields.p, p_fd)
    end
    return nothing
end

# Scatter the accumulated gradient `dy_per_timestep` (one scalar per saved
# time point) for a single symbol `s` back into `sol_fdata`. Shared between
# the scalar-symbol and vector-of-symbols `getindex` rrules.
function _scatter_symbol_timeseries!(sol_fdata, VA, s, dy_per_timestep)
    i = symbolic_type(s) != NotSymbolic() ? variable_index(VA, s) : s
    if i !== nothing
        # State variable: scatter dy_per_timestep[k] into sol_fdata.u[k][i].
        u_fd = sol_fdata.data.u
        for k in eachindex(VA.u)
            u_fd[k][i] += dy_per_timestep[k]
        end
    else
        # Observable: differentiate the observed function via a Mooncake
        # derived rule, once per saved time point.
        for k in eachindex(VA.u)
            _observable_pullback_at!(sol_fdata, VA, s, dy_per_timestep[k], k)
        end
    end
    return nothing
end

function rrule!!(
        ::CoDual{typeof(getindex)},
        sol::CoDual{<:AbstractTimeseriesSolution},
        sym::CoDual,
    )
    VA = sol.x
    s = sym.x
    y = VA[s]
    # Allocate a zero-initialized fdata for the output. Downstream rrules
    # (e.g. `sum`) mutate this in-place to accumulate the output gradient.
    y_fdata = zero(y)
    sol_fdata = sol.dx

    function _scatter_pullback(::NoRData)
        _scatter_symbol_timeseries!(sol_fdata, VA, s, y_fdata)
        return (NoRData(), NoRData(), NoRData())
    end

    return CoDual(y, y_fdata), _scatter_pullback
end

# Integer time-step indexing: `sol[i::Integer]` returns the state vector at
# time step `i`. The output cotangent is accumulated into `sol_fdata.u[i]`
# in-place. More specific than the `sym::CoDual` rrule above, so Julia
# dispatches here for integer arguments (#1325).
function rrule!!(
        ::CoDual{typeof(getindex)},
        sol::CoDual{<:AbstractTimeseriesSolution},
        i::CoDual{<:Integer},
    )
    VA = sol.x
    ip = i.x
    y = VA[ip]
    y_fdata = zero(y)
    sol_fdata = sol.dx

    function _time_step_pullback(::NoRData)
        u_dest = sol_fdata.data.u[ip]
        @. u_dest += y_fdata
        return (NoRData(), NoRData(), NoRData())
    end

    return CoDual(y, y_fdata), _time_step_pullback
end

# Vector of symbols: `sol[[sym1, sym2, ...]]` returns a `Vector{Vector{T}}`
# where entry `k` is `[sol[sym1][k], sol[sym2][k], ...]`. We allocate a
# matching zero-initialized fdata vector and, in the pullback, transpose the
# per-timestep gradient back into per-symbol gradients before scattering via
# `_scatter_symbol_timeseries!`. Each element of `syms` is dispatched through
# the same state-vs-observable logic as the scalar rrule.
function rrule!!(
        ::CoDual{typeof(getindex)},
        sol::CoDual{<:AbstractTimeseriesSolution},
        syms::CoDual{<:AbstractVector},
    )
    VA = sol.x
    ss = syms.x
    y = VA[ss]
    # Preallocate per-element zero fdata matching the primal shape.
    y_fdata = [zero(yi) for yi in y]
    sol_fdata = sol.dx

    function _scatter_pullback_vec(::NoRData)
        nsyms = length(ss)
        nt = length(VA.u)
        # Transpose: per-symbol vector of length nt, where entry k is
        # y_fdata[k][j] for symbol j.
        for (j, s) in enumerate(ss)
            dy_j = [y_fdata[k][j] for k in 1:nt]
            _scatter_symbol_timeseries!(sol_fdata, VA, s, dy_j)
        end
        return (NoRData(), NoRData(), NoRData())
    end

    return CoDual(y, y_fdata), _scatter_pullback_vec
end

function rrule!!(
        ::CoDual{typeof(getindex)},
        sol::CoDual{<:AbstractTimeseriesSolution},
        sym::CoDual,
        j::CoDual{<:Integer},
    )
    VA = sol.x
    s = sym.x
    jp = j.x
    y = VA[s, jp]
    sol_fdata = sol.dx

    # Scalar output: gradient comes via dy (rdata).
    function _scatter_pullback_indexed(dy)
        i = symbolic_type(s) != NotSymbolic() ? variable_index(VA, s) : s
        if i !== nothing
            sol_fdata.data.u[jp][i] += dy
        else
            _observable_pullback_at!(sol_fdata, VA, s, dy, jp)
        end
        return (NoRData(), NoRData(), NoRData(), NoRData())
    end

    return zero_fcodual(y), _scatter_pullback_indexed
end

# =============================================================================
# Symbolic indexing of nonlinear (no-time) solutions: getindex(NS, sym)
# =============================================================================
#
# `AbstractNonlinearSolution` is also used by MTK as the result of DAE
# initialization (`prob.f.initialization_data.initializeprob` solved). Indexing
# such a solution with a symbolic name (`isol[w]`) goes through the same
# symbolic dispatch as the timeseries case and is not differentiable by
# Mooncake without help.
#
# Unlike the timeseries case, the observed function for a nonlinear solution
# takes only `(u, p)` (no time argument). More importantly, calling
# `getter(sym, u, p)` directly inside Mooncake's tracing is brittle: the
# `ObservedFunctionCache` does `get!(dict, value(obsvar)) do ... end`, and
# Mooncake's abstract interpretation of that get! together with the symbolic
# `obsvar` causes either:
#   - `__verify_const(::Num, ...)` errors when `sym` is a non-const global,
#   - extremely slow `build_rrule` (>15 minutes) for the cache-lookup chain,
#   - or `isequal_bsimpl` typeasserts inside `SymbolicUtils/hashconsing.jl`.
#
# The fix is to extract the inner observed function *outside* Mooncake's
# tracing — ObservedFunctionCache called with no extra arguments
# (`getter(sym)`) returns the cached generated function which takes plain
# numeric `(u, p)` arrays. We then ask Mooncake to differentiate only that
# inner numeric function, which it handles in seconds.

@is_primitive MinimalCtx Tuple{typeof(getindex), AbstractNonlinearSolution, Any}

function _run_observable_pullback_no_t(getter, s, u, p, dy)
    # Resolve the inner observed function from the cache outside Mooncake's
    # tracing. Calling `ObservedFunctionCache(sym)` with no extra args returns
    # the cached `inner(u, p)` (a `GeneratedFunctionWrapper`), avoiding the
    # symbolic dispatch chain that breaks Mooncake.
    inner = getter(s)

    sig = Tuple{typeof(inner), typeof(u), typeof(p)}
    rule = build_rrule(sig)

    u_fd = zero(u)
    p_fd = fdata(zero_tangent(p))
    inner_cd = CoDual(inner, fdata(zero_tangent(inner)))
    u_cd = CoDual(u, u_fd)
    p_cd = CoDual(p, p_fd)

    _, pb = rule(inner_cd, u_cd, p_cd)
    pb(dy)
    return u_fd, p_fd
end

function _observable_pullback_no_t!(sol_fdata, NS, s, dy)
    getter = getobserved(NS)
    u = NS.u
    p = parameter_values(NS.prob)

    u_fd, p_fd = _run_observable_pullback_no_t(getter, s, u, p, dy)

    # Scatter u-grad into sol_fdata.u (a single Vector for nonlinear sols).
    u_dest = sol_fdata.data.u
    if u_dest isa Vector{<:Real} && u_fd isa Vector{<:Real}
        @. u_dest += u_fd
    end

    # Propagate p-grad into sol_fdata.prob.p (if accessible).
    prob_fd = sol_fdata.data.prob
    if prob_fd isa Mooncake.MutableTangent && hasfield(typeof(prob_fd.fields), :p)
        _accumulate_p_fdata!(prob_fd.fields.p, p_fd)
    end
    return nothing
end

function rrule!!(
        ::CoDual{typeof(getindex)},
        sol::CoDual{<:AbstractNonlinearSolution},
        sym::CoDual,
    )
    NS = sol.x
    s = sym.x
    y = NS[s]
    sol_fdata = sol.dx

    # Scalar nonlinear solutions return a scalar `y` for a scalar symbol;
    # the gradient comes back via rdata (`dy`) since scalars use rdata.
    function _scatter_pullback_ns(dy)
        i = if symbolic_type(s) != NotSymbolic()
            SII.is_variable(NS, s) ? variable_index(NS, s) : nothing
        else
            s
        end
        if i !== nothing
            # State unknown of the nonlinear problem.
            u_dest = sol_fdata.data.u
            if u_dest isa Vector{<:Real}
                u_dest[i] += dy
            end
        else
            # Observable: differentiate via the inner observed function.
            _observable_pullback_no_t!(sol_fdata, NS, s, dy)
        end
        return (NoRData(), NoRData(), NoRData())
    end

    return zero_fcodual(y), _scatter_pullback_ns
end

# NOTE: The ChainRules extension also defines rrules for constructors
# (SDEProblem, ODESolution, RODESolution, IntervalNonlinearProblem,
# EnsembleSolution) and for `getproperty(::NonlinearProblem, ::Symbol)`.
# These are Zygote-specific workarounds for how Zygote handles mutable
# struct field accumulation and constructor tracing. Mooncake's MutableTangent
# handles struct construction and field access with proper cache reset
# semantics natively, so those rrules are not needed on the Mooncake path.

end

# Necessary to have initialize set u_modified to false if all don't do anything
# otherwise unnecessary save
INITIALIZE_DEFAULT(cb, u, t, integrator) = u_modified!(integrator, false)
FINALIZE_DEFAULT(cb, u, t, integrator) = nothing

@enum RootfindOpt::Int8 begin
    NoRootFind = 0
    LeftRootFind = 1
    RightRootFind = 2
end

function Base.convert(::Type{RootfindOpt}, b::Bool)
    return b ? LeftRootFind : NoRootFind
end

"""
```julia
ContinuousCallback(condition, affect!, affect_neg!;
    initialize = INITIALIZE_DEFAULT,
    finalize = FINALIZE_DEFAULT,
    idxs = nothing,
    rootfind = LeftRootFind,
    save_positions = (true, true),
    interp_points = 10,
    abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
    initializealg = nothing)
```

```julia
ContinuousCallback(condition, affect!;
    initialize = INITIALIZE_DEFAULT,
    finalize = FINALIZE_DEFAULT,
    idxs = nothing,
    rootfind = LeftRootFind,
    save_positions = (true, true),
    affect_neg! = affect!,
    interp_points = 10,
    abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
    initializealg = nothing)
```

Contains a single callback whose `condition` is a continuous function. The callback is triggered when this function evaluates to 0.

# Arguments

  - `condition`: This is a function `condition(u,t,integrator)` for declaring when
    the callback should be used. A callback is initiated if the condition hits
    `0` within the time interval. See the [Integrator Interface](@ref integrator) documentation for information about `integrator`.
  - `affect!`: This is the function `affect!(integrator)` where one is allowed to
    modify the current state of the integrator. If you do not pass an `affect_neg!`
    function, it is called when `condition` is found to be `0` (at a root) and
    the cross is either an upcrossing (from negative to positive) or a downcrossing
    (from positive to negative). You need to explicitly pass `nothing` as the
    `affect_neg!` argument if it should only be called at upcrossings, e.g.
    `ContinuousCallback(condition, affect!, nothing)`. For more information on what can
    be done, see the [Integrator Interface](@ref integrator) manual page. Modifications to
    `u` are safe in this function.
  - `affect_neg!=affect!`: This is the function `affect_neg!(integrator)` where one is allowed to
    modify the current state of the integrator. This is called when `condition` is
    found to be `0` (at a root) and the cross is a downcrossing (from positive to
    negative). For more information on what can
    be done, see the [Integrator Interface](@ref integrator) manual page. Modifications to
    `u` are safe in this function.
  - `rootfind=LeftRootFind`: This is a flag to specify the type of rootfinding to do for finding
    event location. If this is set to `LeftRootfind`, the solution will be backtracked to the point where
    `condition==0` and if the solution isn't exact, the left limit of root is used. If set to
    `RightRootFind`, the solution would be set to the right limit of the root. Otherwise, the systems and
    the `affect!` will occur at `t+dt`. Note that these enums are not exported, and thus one needs to
    reference them as `SciMLBase.LeftRootFind`, `SciMLBase.RightRootFind`, or `SciMLBase.NoRootFind`.
  - `interp_points=10`: The number of interpolated points to check the condition. The
    condition is found by checking whether any interpolation point / endpoint has
    a different sign. If `interp_points=0`, then conditions will only be noticed if
    the sign of `condition` is different at `t` than at `t+dt`. This behavior is not
    robust when the solution is oscillatory, and thus it's recommended that one use
    some interpolation points (they're cheap to compute!).
    `0` within the time interval.
  - `save_positions=(true,true)`: Boolean tuple for whether to save before and after the `affect!`.
    This saving will occur just before and after the event, only at event times, and
    does not depend on options like `saveat`, `save_everystep`, etc. (i.e. if
    `saveat=[1.0,2.0,3.0]`, this can still add a save point at `2.1` if true).
    For discontinuous changes like a modification to `u` to be
    handled correctly (without error), one should set `save_positions=(true,true)`.
  - `idxs=nothing`: The components which will be interpolated into the condition. Defaults
    to `nothing` which means `u` will be all components.
  - `initialize`: This is a function `(c,u,t,integrator)` which can be used to initialize
    the state of the callback `c`. It should modify the argument `c` and the return is
    ignored.
  - `finalize`: This is a function `(c,u,t,integrator)` which can be used to finalize
    the state of the callback `c`. It can modify the argument `c` and the return is ignored.
  - `abstol=10eps()`: Tolerance for repeted event prevention. If the callback was just triggered
    and the new starting condition is less than the tolerance from its value at the root,
    then the next testing point will be nudged to avoid repeats. If the callback does not
    mutate the integrator in a way that affect the condition, this can be safely set to `0.0`.
    `reltol` is deprecated.
  - `repeat_nudge = 1//100`: This is used to set the next testing point after a
    previously found zero. Defaults to `1//100`, which means after a callback, the next
    sign check will take place at `t + dt*1//100` instead of at `t` to avoid repeats.
  - `initializealg = nothing`: In the context of a DAE, this is the algorithm that is used
    to run initialization after the effect. The default of `nothing` defers to the initialization
    algorithm provided in the `solve`.

!!! warning

    The effect of using a callback with a DAE needs to be done with care because the solution
    `u` needs to satisfy the algebraic constraints before taking the next step. For this reason,
    a consistent initialization calculation must be run after running the callback. If the
    chosen initialization alg is `BrownFullBasicInit()` (the default for `solve`), then the initialization
    will change the algebraic variables to satisfy the conditions. Thus if `x` is an algebraic
    variable and the callback performs `x+=1`, the initialization may "revert" the change to
    satisfy the constraints. This behavior can be removed by setting `initializealg = CheckInit()`,
    which simply checks that the state `u` is consistent, but requires that the result of the
    `affect!` satisfies the constraints (or else errors). It is not recommended that `NoInit()` is
    used as that will lead to an unstable step following initialization. This warning can be
    ignored for non-DAE ODEs.

# Extended help

- `saved_clock_partitions`: An iterable of clock partition indices to save after the callback triggers. MTK-only
  API
"""
struct ContinuousCallback{F1, F2, F3, F4, F5, T, T2, T3, T4, I, R, SCP} <:
    AbstractContinuousCallback
    condition::F1
    affect!::F2
    affect_neg!::F3
    initialize::F4
    finalize::F5
    idxs::I
    rootfind::RootfindOpt
    interp_points::Int
    save_positions::BitArray{1}
    dtrelax::R
    abstol::T
    reltol::T2
    repeat_nudge::T3
    initializealg::T4
    saved_clock_partitions::SCP
    initialize_save_discretes::Bool
    function ContinuousCallback(
            condition::F1, affect!::F2, affect_neg!::F3,
            initialize::F4, finalize::F5, idxs::I, rootfind,
            interp_points, save_positions, dtrelax::R, abstol::T,
            reltol::T2, repeat_nudge::T3, initializealg::T4 = nothing,
            saved_clock_partitions::SCP = (), initialize_save_discretes::Bool = true
        ) where {
            F1, F2, F3, F4, F5, T, T2, T3, T4, I, R, SCP,
        }
        _condition = prepare_function(condition)
        return new{typeof(_condition), F2, F3, F4, F5, T, T2, T3, T4, I, R, SCP}(
            _condition,
            affect!, affect_neg!,
            initialize, finalize, idxs, rootfind,
            interp_points,
            BitArray(collect(save_positions)),
            dtrelax, abstol, reltol, repeat_nudge, initializealg, saved_clock_partitions,
            initialize_save_discretes
        )
    end
end

function ContinuousCallback(
        condition, affect!, affect_neg!;
        initialize = INITIALIZE_DEFAULT,
        finalize = FINALIZE_DEFAULT,
        idxs = nothing,
        rootfind = LeftRootFind,
        save_positions = (true, true),
        interp_points = 10,
        dtrelax = 1,
        abstol = 10eps(), reltol = 0,
        repeat_nudge = 1 // 100,
        initializealg = nothing,
        saved_clock_partitions = (),
        initialize_save_discretes = true,
    )
    return ContinuousCallback(
        condition, affect!, affect_neg!, initialize, finalize,
        idxs,
        rootfind, interp_points,
        save_positions,
        dtrelax, abstol, reltol, repeat_nudge, initializealg, saved_clock_partitions,
        initialize_save_discretes
    )
end

function ContinuousCallback(
        condition, affect!;
        initialize = INITIALIZE_DEFAULT,
        finalize = FINALIZE_DEFAULT,
        idxs = nothing,
        rootfind = LeftRootFind,
        save_positions = (true, true),
        affect_neg! = affect!,
        interp_points = 10,
        dtrelax = 1,
        abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
        initializealg = nothing, saved_clock_partitions = (),
        initialize_save_discretes = true,
    )
    return ContinuousCallback(
        condition, affect!, affect_neg!, initialize, finalize, idxs,
        rootfind, interp_points,
        collect(save_positions),
        dtrelax, abstol, reltol, repeat_nudge, initializealg, saved_clock_partitions,
        initialize_save_discretes
    )
end

"""
```julia
VectorContinuousCallback(condition, affect!, affect_neg!, len;
    initialize = INITIALIZE_DEFAULT,
    finalize = FINALIZE_DEFAULT,
    idxs = nothing,
    rootfind = LeftRootFind,
    save_positions = (true, true),
    interp_points = 10,
    abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
    initializealg = nothing)
```

```julia
VectorContinuousCallback(condition, affect!, len;
    initialize = INITIALIZE_DEFAULT,
    finalize = FINALIZE_DEFAULT,
    idxs = nothing,
    rootfind = LeftRootFind,
    save_positions = (true, true),
    affect_neg! = affect!,
    interp_points = 10,
    abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
    initializealg = nothing)
```

This is also a subtype of `AbstractContinuousCallback`. `CallbackSet` is not feasible when you have many callbacks,
as it doesn't scale well. For this reason, we have `VectorContinuousCallback` - it allows you to have a single callback for
multiple events.

# Arguments

  - `condition`: This is a function `condition(out, u, t, integrator)` which should save the condition value in the array `out`
    at the right index. Maximum index of `out` should be specified in the `len` property of callback. So, this way you can have
    a chain of `len` events, which would cause the `i`th event to trigger when `out[i] = 0`.
  - `affect!`: This is a function `affect!(integrator, event_index)` which lets you modify `integrator` and it tells you about
    which event occurred using `event_idx` i.e. gives you index `i` for which `out[i]` came out to be zero.
  - `len`: Number of callbacks chained. This is compulsory to be specified.

Rest of the arguments have the same meaning as in [`ContinuousCallback`](@ref).

# Extended help

- `saved_clock_partitions`: An iterable of `len` elements, where the `i`th element is an iterable of clock partition indices to save when the `i`th event triggers. MTK-only API.
"""
struct VectorContinuousCallback{F1, F2, F3, F4, F5, T, T2, T3, T4, I, R, SCP} <:
    AbstractContinuousCallback
    condition::F1
    affect!::F2
    affect_neg!::F3
    len::Int
    initialize::F4
    finalize::F5
    idxs::I
    rootfind::RootfindOpt
    interp_points::Int
    save_positions::BitArray{1}
    dtrelax::R
    abstol::T
    reltol::T2
    repeat_nudge::T3
    initializealg::T4
    saved_clock_partitions::SCP
    initialize_save_discretes::Bool
    function VectorContinuousCallback(
            condition::F1, affect!::F2, affect_neg!::F3, len::Int,
            initialize::F4, finalize::F5, idxs::I, rootfind,
            interp_points, save_positions, dtrelax::R,
            abstol::T, reltol::T2, repeat_nudge::T3,
            initializealg::T4 = nothing,
            saved_clock_partitions::SCP = (), initialize_save_discretes = true
        ) where {
            F1, F2, F3, F4, F5, T, T2,
            T3, T4, I, R, SCP,
        }
        _condition = prepare_function(condition)
        return new{typeof(_condition), F2, F3, F4, F5, T, T2, T3, T4, I, R, SCP}(
            _condition,
            affect!, affect_neg!, len,
            initialize, finalize, idxs, rootfind,
            interp_points,
            BitArray(collect(save_positions)),
            dtrelax, abstol, reltol, repeat_nudge, initializealg,
            saved_clock_partitions, initialize_save_discretes
        )
    end
end

function VectorContinuousCallback(
        condition, affect!, affect_neg!, len;
        initialize = INITIALIZE_DEFAULT,
        finalize = FINALIZE_DEFAULT,
        idxs = nothing,
        rootfind = LeftRootFind,
        save_positions = (true, true),
        interp_points = 10,
        dtrelax = 1,
        abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
        initializealg = nothing, saved_clock_partitions = (),
        initialize_save_discretes = true
    )
    return VectorContinuousCallback(
        condition, affect!, affect_neg!, len,
        initialize, finalize,
        idxs,
        rootfind, interp_points,
        save_positions, dtrelax,
        abstol, reltol, repeat_nudge, initializealg, saved_clock_partitions,
        initialize_save_discretes
    )
end

function VectorContinuousCallback(
        condition, affect!, len;
        initialize = INITIALIZE_DEFAULT,
        finalize = FINALIZE_DEFAULT,
        idxs = nothing,
        rootfind = LeftRootFind,
        save_positions = (true, true),
        affect_neg! = affect!,
        interp_points = 10,
        dtrelax = 1,
        abstol = 10eps(), reltol = 0, repeat_nudge = 1 // 100,
        initializealg = nothing, saved_clock_partitions = (),
        initialize_save_discretes = true
    )
    return VectorContinuousCallback(
        condition, affect!, affect_neg!, len, initialize, finalize,
        idxs,
        rootfind, interp_points,
        collect(save_positions),
        dtrelax, abstol, reltol, repeat_nudge, initializealg, saved_clock_partitions,
        initialize_save_discretes
    )
end

"""
```julia
DiscreteCallback(condition, affect!;
    initialize = INITIALIZE_DEFAULT,
    finalize = FINALIZE_DEFAULT,
    save_positions = (true, true),
    initializealg = nothing)
```

# Arguments

  - `condition`: This is a function `condition(u,t,integrator)` for declaring when
    the callback should be used. A callback is initiated if the condition evaluates
    to `true`. See the [Integrator Interface](@ref integrator) documentation for information about `integrator`.
  - `affect!`: This is the function `affect!(integrator)` where one is allowed to
    modify the current state of the integrator. For more information on what can
    be done, see the [Integrator Interface](@ref integrator) manual page.
  - `save_positions`: Boolean tuple for whether to save before and after the `affect!`.
    This saving will occur just before and after the event, only at event times, and
    does not depend on options like `saveat`, `save_everystep`, etc. (i.e. if
    `saveat=[1.0,2.0,3.0]`, this can still add a save point at `2.1` if true).
    For discontinuous changes like a modification to `u` to be
    handled correctly (without error), one should set `save_positions=(true,true)`.
  - `initialize`: This is a function `(c,u,t,integrator)` which can be used to initialize
    the state of the callback `c`. It should modify the argument `c` and the return is
    ignored.
  - `finalize`: This is a function `(c,u,t,integrator)` which can be used to finalize
    the state of the callback `c`. It should can the argument `c` and the return is
    ignored.
  - `initializealg = nothing`: In the context of a DAE, this is the algorithm that is used
    to run initialization after the effect. The default of `nothing` defers to the initialization
    algorithm provided in the `solve`.

!!! warning

    The effect of using a callback with a DAE needs to be done with care because the solution
    `u` needs to satisfy the algebraic constraints before taking the next step. For this reason,
    a consistent initialization calculation must be run after running the callback. If the
    chosen initialization alg is `BrownFullBasicInit()` (the default for `solve`), then the initialization
    will change the algebraic variables to satisfy the conditions. Thus if `x` is an algebraic
    variable and the callback performs `x+=1`, the initialization may "revert" the change to
    satisfy the constraints. This behavior can be removed by setting `initializealg = CheckInit()`,
    which simply checks that the state `u` is consistent, but requires that the result of the
    `affect!` satisfies the constraints (or else errors). It is not recommended that `NoInit()` is
    used as that will lead to an unstable step following initialization. This warning can be
    ignored for non-DAE ODEs.

# Extended help

- `saved_clock_partitions`: An iterable of clock partition indices to save after the callback
  triggers. MTK-only API
"""
struct DiscreteCallback{F1, F2, F3, F4, F5, SCP} <: AbstractDiscreteCallback
    condition::F1
    affect!::F2
    initialize::F3
    finalize::F4
    save_positions::BitArray{1}
    initializealg::F5
    saved_clock_partitions::SCP
    initialize_save_discretes::Bool
    function DiscreteCallback(
            condition::F1, affect!::F2,
            initialize::F3, finalize::F4,
            save_positions,
            initializealg::F5 = nothing,
            saved_clock_partitions::SCP = (),
            initialize_save_discretes = true
        ) where {F1, F2, F3, F4, F5, SCP}
        _condition = prepare_function(condition)
        return new{typeof(_condition), F2, F3, F4, F5, SCP}(
            _condition,
            affect!, initialize, finalize,
            BitArray(collect(save_positions)),
            initializealg, saved_clock_partitions,
            initialize_save_discretes
        )
    end
end
function DiscreteCallback(
        condition, affect!;
        initialize = INITIALIZE_DEFAULT, finalize = FINALIZE_DEFAULT,
        save_positions = (true, true),
        initializealg = nothing, saved_clock_partitions = (),
        initialize_save_discretes = true,
    )
    return DiscreteCallback(
        condition, affect!, initialize, finalize, save_positions, initializealg,
        saved_clock_partitions, initialize_save_discretes
    )
end

"""
$(TYPEDEF)

Multiple callbacks can be chained together to form a `CallbackSet`. A `CallbackSet`
is constructed by passing the constructor `ContinuousCallback`, `DiscreteCallback`,
`VectorContinuousCallback` or other `CallbackSet` instances:

    CallbackSet(cb1,cb2,cb3)

You can pass as many callbacks as you like. When the solvers encounter multiple
callbacks, the following rules apply:

  - `ContinuousCallback`s and `VectorContinuousCallback`s are applied before `DiscreteCallback`s. (This is because
    they often implement event-finding that will backtrack the timestep to smaller
    than `dt`).
  - For `ContinuousCallback`s and `VectorContinuousCallback`s, the event times are found by rootfinding and only
    the first `ContinuousCallback` or `VectorContinuousCallback` affect is applied.
  - The `DiscreteCallback`s are then applied in order. Note that the ordering only
    matters for the conditions: if a previous callback modifies `u` in such a way
    that the next callback no longer evaluates condition to `true`, its `affect`
    will not be applied.
"""
struct CallbackSet{T1 <: Tuple, T2 <: Tuple} <: DECallback
    continuous_callbacks::T1
    discrete_callbacks::T2
end

CallbackSet(callback::AbstractDiscreteCallback) = CallbackSet((), (callback,))
CallbackSet(callback::AbstractContinuousCallback) = CallbackSet((callback,), ())
CallbackSet() = CallbackSet((), ())
CallbackSet(cb::Nothing) = CallbackSet()

# For Varargs, use recursion to make it type-stable
function CallbackSet(callbacks::Union{DECallback, Nothing}...)
    return CallbackSet(split_callbacks((), (), callbacks...)...)
end

"""
    split_callbacks(cs, ds, args...)

Split comma separated callbacks into sets of continuous and discrete callbacks.
"""
@inline split_callbacks(cs, ds) = cs, ds
@inline split_callbacks(cs, ds, c::Nothing, args...) = split_callbacks(cs, ds, args...)
@inline function split_callbacks(cs, ds, c::AbstractContinuousCallback, args...)
    return split_callbacks((cs..., c), ds, args...)
end
@inline function split_callbacks(cs, ds, d::AbstractDiscreteCallback, args...)
    return split_callbacks(cs, (ds..., d), args...)
end
@inline function split_callbacks(cs, ds, d::CallbackSet, args...)
    return split_callbacks(
        (cs..., d.continuous_callbacks...), (ds..., d.discrete_callbacks...),
        args...
    )
end

"""
    $TYPEDSIGNATURES

Save the discrete variables associated with callback `cb` in `integrator`.

# Keyword arguments

- `skip_duplicates`: Skip saving variables that have already been saved at the current time.
"""
function save_discretes!(integrator::DEIntegrator, cb::Union{ContinuousCallback, DiscreteCallback}; skip_duplicates = false)
    isempty(cb.saved_clock_partitions) && return
    for idx in cb.saved_clock_partitions
        save_discretes!(integrator, idx; skip_duplicates)
    end
    return
end

function save_discretes!(integrator::DEIntegrator, cb::VectorContinuousCallback; kw...)
    isempty(cb.saved_clock_partitions) && return
    for idx in eachindex(cb.saved_clock_partitions)
        save_discretes!(integrator, cb, idx; skip_duplicates = true)
    end
    return
end

function save_discretes!(integrator::DEIntegrator, cb::VectorContinuousCallback, i; skip_duplicates = false)
    isempty(cb.saved_clock_partitions) && return
    for idx in cb.saved_clock_partitions[i]
        save_discretes!(integrator, idx; skip_duplicates)
    end
    return
end

function _save_all_discretes!(integrator::DEIntegrator, cb::DECallback, cbs::DECallback...)
    save_discretes!(integrator, cb; skip_duplicates = true)
    return _save_all_discretes!(integrator, cbs...)
end

_save_all_discretes!(::DEIntegrator) = nothing

function save_discretes!(integrator::DEIntegrator, cb::CallbackSet; kw...)
    return _save_all_discretes!(integrator, cb.continuous_callbacks..., cb.discrete_callbacks...)
end

"""
    $TYPEDSIGNATURES

Save the discrete variables associated with callback `cb` in `integrator` if the finalizer
exists and `save_positions[2]` is `true`. Used to save the necessary values at the final
time of the simulation, after the finalizer has run.
"""
function save_final_discretes!(integrator::DEIntegrator, cb::Union{ContinuousCallback, VectorContinuousCallback, DiscreteCallback})
    cb.finalize === FINALIZE_DEFAULT && return
    cb.save_positions[2] || return
    return save_discretes!(integrator, cb; skip_duplicates = true)
end

function _save_all_final_discretes!(integrator::DEIntegrator, cb::DECallback, cbs::DECallback...)
    save_final_discretes!(integrator, cb)
    return _save_all_final_discretes!(integrator, cbs...)
end

_save_all_final_discretes!(::DEIntegrator) = nothing

function save_final_discretes!(integrator::DEIntegrator, cb::CallbackSet; kw...)
    return _save_all_final_discretes!(integrator, cb.continuous_callbacks..., cb.discrete_callbacks...)
end

"""
    $TYPEDSIGNATURES

Save the discrete variables associated with callback `cb` in `integrator` if
`save_positions[2] && initialize_save_discretes` is `true`.

# Keyword arguments

- `skip_duplicates`: Skip saving variables that have already been saved at the current time.
"""
function save_discretes_if_enabled!(integrator::DEIntegrator, cb::Union{ContinuousCallback, VectorContinuousCallback, DiscreteCallback}; skip_duplicates = false)
    cb.save_positions[2] && cb.initialize_save_discretes || return
    return save_discretes!(integrator, cb; skip_duplicates)
end

function _save_discretes_if_enabled!(integrator::DEIntegrator, cb::DECallback, cbs::DECallback...; kw...)
    save_discretes_if_enabled!(integrator, cb; kw...)
    return _save_discretes_if_enabled!(integrator, cbs...; kw...)
end

_save_discretes_if_enabled!(::DEIntegrator; kw...) = nothing

function save_discretes_if_enabled!(integrator::DEIntegrator, cb::CallbackSet; kw...)
    return _save_discretes_if_enabled!(integrator, cb.continuous_callbacks..., cb.discrete_callbacks...; kw...)
end

#
# Deprecated Quadrature things
const AbstractQuadratureProblem = AbstractIntegralProblem
const AbstractQuadratureAlgorithm = AbstractIntegralAlgorithm
const AbstractQuadratureSolution = AbstractIntegralSolution

# Deprecated High Level things
# All downstream uses need to be removed before removing

const DEAlgorithm = AbstractDEAlgorithm
const SciMLAlgorithm = AbstractSciMLAlgorithm
const DEProblem = AbstractDEProblem
const DEAlgorithm = AbstractDEAlgorithm
const DESolution = AbstractSciMLSolution
const SciMLSolution = AbstractSciMLSolution

# Deprecated `destats`
@deprecate has_destats(x) has_stats(x) false

using Test
using SciMLBase
using SciMLBase: Clock, PeriodicClock, Continuous, ContinuousClock, SolverStepClock,
    first_clock_tick_time, IndexedClock, canonicalize_indexed_clock
using MLStyle: @match

@testset "Clock" begin
    @test PeriodicClock(nothing, 0.2) isa TimeDomain
    @test SolverStepClock() isa TimeDomain
    @test ContinuousClock() isa TimeDomain
    @test Continuous() isa TimeDomain
    @test Continuous === ContinuousClock()

    @test Clock(1) isa TimeDomain
    @test Clock(24.0; phase = 0.1) == PeriodicClock(24.0, 0.1)
    @test Clock(1 // 24) == PeriodicClock(1 // 24, 0.0)
    @test Clock(; phase = 0.2) == PeriodicClock(nothing, 0.2)

    @test isclock(PeriodicClock(; dt = 1.0))
    @test !isclock(Continuous())
    @test !isclock(SolverStepClock())
    @test !isclock(nothing)

    @test !issolverstepclock(PeriodicClock(; dt = 1.0))
    @test !issolverstepclock(Continuous())
    @test issolverstepclock(SolverStepClock())
    @test !issolverstepclock(nothing)

    @test !iscontinuous(PeriodicClock(; dt = 1.0))
    @test iscontinuous(Continuous())
    @test !iscontinuous(SolverStepClock())
    @test !iscontinuous(nothing)

    @test is_discrete_time_domain(PeriodicClock(; dt = 1.0))
    @test !is_discrete_time_domain(Continuous())
    @test is_discrete_time_domain(SolverStepClock())
    @test !is_discrete_time_domain(nothing)

    @test first_clock_tick_time(PeriodicClock(; dt = 2.0), 5.0) === 6.0
    @test_throws ErrorException first_clock_tick_time(Continuous(), 5.0)
    @test first_clock_tick_time(SolverStepClock(), 5.0) === 5.0

    ic = Clock(1)[5]
    @test ic === IndexedClock(Clock(1), 5)
end

@testset "MLStyle" begin
    sampletime(c) = @match c begin
        PeriodicClock(dt, _...) => dt
        _ => nothing
    end

    @test sampletime(PeriodicClock(1 // 2, 3.14)) === 1 // 2
    @test sampletime(ContinuousClock()) === nothing
    @test sampletime(missing) === nothing

    function clocktype(c)
        @match c begin
            Continuous() => "continuous"
            SolverStepClock() => "solver_step_clock"
            PeriodicClock(dt, phase) => (dt, phase)
            _ => "other"
        end
    end

    @test clocktype(Continuous()) === "continuous"
    @test clocktype(ContinuousClock()) === "continuous"
    @test clocktype(Continuous) === "continuous"
    @test clocktype(SolverStepClock()) === "solver_step_clock"
    @test clocktype(PeriodicClock(1 // 2, 3.14)) === (1 // 2, 3.14)
    @test clocktype(pi) === "other" broken = true
end

@testset "SciMLBase precompiles without deprecation warnings" begin
    # Moshi's bare singleton variant syntax (`ContinuousClock` rather than
    # `ContinuousClock()`) only warns while the `@data` block is macroexpanded, so a
    # forced recompile is the only way to observe it from a test.
    script = """Base.compilecache(Base.identify_package("SciMLBase"))"""
    cmd = `$(Base.julia_cmd()) --startup-file=no --project=$(Base.active_project()) -e $script`
    buf = IOBuffer()
    run(pipeline(ignorestatus(cmd), stdout = buf, stderr = buf))
    output = String(take!(buf))
    occursin("deprecated", output) &&
        @info "SciMLBase precompilation output" output
    @test !occursin("deprecated", output)
end

using ModelingToolkit, OrdinaryDiffEq, Test
using SymbolicIndexingInterface
using ModelingToolkit: t_nounits as t, D_nounits as D
@variables x(t), y(t)

@mtkcompile sys1 = System(
    [
        D(x) ~ x,
        D(y) ~ -y,
    ], t
)
@mtkcompile sys2 = System(
    [
        D(x) ~ 2x,
        D(y) ~ -2y,
    ], t
)
@mtkcompile sys3 = System(
    [
        D(x) ~ 3x,
        D(y) ~ -3y,
    ], t
)

prob1 = ODEProblem(sys1, [x => 1.0, y => 1.0], (0.0, 1.0))
prob2 = ODEProblem(sys2, [x => 2.0, y => 2.0], (0.0, 1.0))
prob3 = ODEProblem(sys3, [x => 3.0, y => 3.0], (0.0, 1.0))

# test that when passing a vector of problems, trajectories and the prob_func are chosen appropriately
ensemble_prob = EnsembleProblem([prob1, prob2, prob3])
sol = solve(ensemble_prob, Tsit5(), EnsembleThreads())
xidx = variable_index(sys1, x)
yidx = variable_index(sys1, y)
for i in 1:3
    @test sol[xidx, :, i] == sol.u[i][x]
    @test sol[yidx, :, i] == sol.u[i][y]
end
# Ensemble is a recursive array
@test only.(sol(0.0, idxs = [x])) == sol[xidx, 1, :]
@test only.(sol(1.0, idxs = [x])) ≈ [sol[i][xidx, end] for i in 1:3]

using Test
using SciMLBase
using Aqua
using Pkg

# yes this is horrible, we'll fix it when Pkg or Base provides a decent API
manifest = Pkg.Types.EnvCache().manifest
# these are good sentinels to test whether someone has added a heavy SciML package to the test deps
if haskey(manifest.deps, "NonlinearSolveBase") || haskey(manifest.deps, "DiffEqBase")
    error("Don't put Downstream Packages in non Downstream CI")
end

# https://github.com/JuliaArrays/FillArrays.jl/pull/163
@test isempty(detect_ambiguities(SciMLBase))

@testset "Aqua tests (performance)" begin
    # This tests that we don't accidentally run into
    # https://github.com/JuliaLang/julia/issues/29393
    Aqua.test_unbound_args(SciMLBase)

    # See: https://github.com/SciML/OrdinaryDiffEq.jl/issues/1750
    # Test that we're not introducing method ambiguities across deps
    ambs = Aqua.detect_ambiguities(SciMLBase; recursive = true)
    pkg_match(pkgname, pkdir::Nothing) = false
    pkg_match(pkgname, pkdir::AbstractString) = occursin(pkgname, pkdir)
    filter!(x -> pkg_match("SciMLBase", pkgdir(last(x).module)), ambs)

    # Uncomment for debugging:
    # for method_ambiguity in ambs
    #     @show method_ambiguity
    # end
    !isempty(ambs) && @warn "Number of method ambiguities: $(length(ambs))"
    @test length(ambs) ≤ 8
end

@testset "Aqua tests (additional)" begin
    Aqua.test_undefined_exports(SciMLBase)
    Aqua.test_stale_deps(SciMLBase)
    Aqua.test_deps_compat(SciMLBase, check_extras = false)
    Aqua.test_project_extras(SciMLBase)
    # Aqua.test_project_toml_formatting(SciMLBase) # failing
    # Aqua.test_piracy(SciMLBase) # failing
end

nothing

#=
(Symbolic) save_idxs interface:

Allows symbolically indexing solutions where a subset of the variables are saved.

To implement this interface, the solution must store a `SavedSubsystem` if it contains a
subset of all timeseries variables. The `get_saved_subsystem` function must be implemented
to return the `SavedSubsystem` if present and `nothing` otherwise.

The solution must forward `is_timeseries_parameter`, `timeseries_parameter_index`,
`with_updated_parameter_timeseries_values` and `get_saveable_values` to
`SavedSubsystemWithFallback(sol.saved_subsystem, symbolic_container(sol))`.

Additionally, it must implement `state_values` to always return the full state vector, using
the `SciMLProblem`'s `u0` as a reference, and updating the saved values in it.

See the implementation for `ODESolution` as a reference.
=#

get_saved_subsystem(_) = nothing

struct VectorTemplate
    type::DataType
    size::Int
end

struct TupleOfArraysWrapper{T}
    x::T
end

function TupleOfArraysWrapper(vt::Vector{VectorTemplate})
    return TupleOfArraysWrapper(Tuple(map(t -> Vector{t.type}(undef, t.size), vt)))
end

function Base.getindex(t::TupleOfArraysWrapper, i::Tuple{Int, Int})
    return t.x[i[1]][i[2]]
end

function Base.setindex!(t::TupleOfArraysWrapper, val, i::Tuple{Int, Int})
    return t.x[i[1]][i[2]] = val
end

function as_diffeq_array(vt::Vector{VectorTemplate}, t)
    return DiffEqArray(typeof(TupleOfArraysWrapper(vt))[], t, (1, 1))
end

function get_root_indp(prob::AbstractSciMLProblem)
    return get_root_indp(prob.f)
end

function get_root_indp(f::T) where {T <: AbstractSciMLFunction}
    if hasfield(T, :sys)
        return f.sys
    elseif hasfield(T, :f) && f.f isa AbstractSciMLFunction
        return get_root_indp(f.f)
    else
        return nothing
    end
end

function get_root_indp(prob::LinearProblem)
    return get_root_indp(prob.f)
end

get_root_indp(prob::AbstractJumpProblem) = get_root_indp(prob.prob)

get_root_indp(x) = x

function get_root_indp(f::SymbolicLinearInterface)
    return get_root_indp(f.sys)
end

# Everything from this point on is public API

"""
    $(TYPEDSIGNATURES)

A representation of the subsystem of a given system which is saved in a solution. Created
by providing an index provider and the indexes of saved variables in the system. The indexes
can also be symbolic variables. All indexes must refer to state variables, or timeseries
parameters.

The arguments to the constructor are an index provider, the parameter object and the indexes
of variables to save.

This object is stored in the solution object and used for symbolic indexing of the subsetted
solution.

In case the provided `saved_idxs` is `nothing` or `isempty`, or if the provided
`saved_idxs` includes all of the variables and timeseries parameters, returns `nothing`.
"""
struct SavedSubsystem{V, T, M, I, P, Q, C}
    """
    `Dict` mapping indexes of saved variables in the parent system to corresponding
    indexes in the saved continuous timeseries.
    """
    state_map::V
    """
    `Dict` mapping indexes of saved timeseries parameters in the parent system to
    corresponding `ParameterTimeseriesIndex`es in the save parameter timeseries.
    """
    timeseries_params_map::T
    """
    `Dict` mapping `ParameterTimeseriesIndex`es to indexes of parameters in the
    system. (`timeseries_parameter_index => parameter_index`)
    """
    timeseries_idx_to_param_idx::M
    """
    `Set` of all timeseries_idxs that are saved as-is.
    """
    identity_partitions::I
    """
    `Dict` mapping timeseries indexes to a vector of `VectorTemplate`s to use for storing
    that subsetted timeseries partition
    """
    timeseries_partition_templates::P
    """
    `Dict` mapping timeseries indexes to a vector of `ParameterTimeseriesIndex` in that
    partition. Only for saved partitions not in `identity_partitions`.
    """
    indexes_in_partition::Q
    """
    Map of timeseries indexes to the number of saved timeseries parameters in that
    partition.
    """
    partition_count::C
end

SavedSubsystem(indp, pobj, ::Nothing) = nothing

function SavedSubsystem(indp, pobj, idx::Int)
    _indp = get_root_indp(indp)
    if _indp === EMPTY_SYMBOLCACHE || _indp === nothing
        return nothing
    end
    state_map = Dict(1 => idx)
    return SavedSubsystem(state_map, nothing, nothing, nothing, nothing, nothing, nothing)
end

function SavedSubsystem(indp, pobj, saved_idxs::Union{AbstractArray, Tuple})
    _indp = get_root_indp(indp)
    if _indp === EMPTY_SYMBOLCACHE || _indp === nothing
        return nothing
    end
    if eltype(saved_idxs) == Int
        state_map = Dict{Int, Int}(v => k for (k, v) in enumerate(saved_idxs))
        return SavedSubsystem(
            state_map, nothing, nothing, nothing, nothing, nothing, nothing
        )
    end

    # array state symbolics must be scalarized
    saved_idxs = collect(
        Iterators.flatten(
            map(saved_idxs) do sym
                if symbolic_type(sym) == NotSymbolic()
                    (sym,)
                elseif sym isa AbstractArray && is_variable(indp, sym)
                    collect(sym)
                else
                    (sym,)
                end
            end
        )
    )

    saved_state_idxs = Int[]
    ts_idx_to_type_to_param_idx = Dict()
    ts_idx_to_count = Dict()
    num_ts_params = 0
    TParammapKeys = Union{}
    TParamIdx = Union{}
    timeseries_idx_to_param_idx = Dict()
    for var in saved_idxs
        if (idx = variable_index(indp, var)) !== nothing
            push!(saved_state_idxs, idx)
        elseif (idx = timeseries_parameter_index(indp, var)) !== nothing
            TParammapKeys = Base.promote_typejoin(TParammapKeys, typeof(idx))
            # increment total number of ts params
            num_ts_params += 1
            # get dict mapping type to idxs for this timeseries_idx
            buf = get!(() -> Dict(), ts_idx_to_type_to_param_idx, idx.timeseries_idx)
            # get type of parameter
            pidx = parameter_index(indp, var)
            timeseries_idx_to_param_idx[idx] = pidx
            TParamIdx = Base.promote_typejoin(TParamIdx, typeof(pidx))
            val = parameter_values(pobj, pidx)
            T = typeof(val)
            # get vector of idxs for this type
            buf = get!(() -> [], buf, T)
            # push to it
            push!(buf, idx)
            # update count of variables in this partition
            cnt = get(ts_idx_to_count, idx.timeseries_idx, 0)
            ts_idx_to_count[idx.timeseries_idx] = cnt + 1
        else
            throw(ArgumentError("Can only save variables and timeseries parameters. Got $var."))
        end
    end

    # type of timeseries_idxs
    Ttsidx = Union{}
    for k in keys(ts_idx_to_type_to_param_idx)
        Ttsidx = Base.promote_typejoin(Ttsidx, typeof(k))
    end

    # timeseries_idx to timeseries_parameter_index for all params
    all_ts_params = Dict()
    num_all_ts_params = 0
    for var in parameter_symbols(indp)
        if (idx = timeseries_parameter_index(indp, var)) !== nothing
            num_all_ts_params += 1
            buf = get!(() -> [], all_ts_params, idx.timeseries_idx)
            push!(buf, idx)
        end
    end

    save_all_states = length(saved_state_idxs) == length(variable_symbols(indp))
    save_all_tsparams = num_ts_params == num_all_ts_params
    if save_all_states && save_all_tsparams
        # if we're saving everything
        return nothing
    end
    if save_all_states
        sort!(saved_state_idxs)
        state_map = saved_state_idxs
    else
        state_map = Dict(saved_state_idxs .=> collect(eachindex(saved_state_idxs)))
    end

    if save_all_tsparams
        if isempty(ts_idx_to_type_to_param_idx)
            identity_partitions = ()
        else
            identity_partitions = Set{Ttsidx}(keys(ts_idx_to_type_to_param_idx))
        end
        return SavedSubsystem(
            state_map, nothing, nothing, identity_partitions, nothing, nothing, nothing
        )
    end

    if num_ts_params == 0
        return SavedSubsystem(state_map, nothing, nothing, (), nothing, nothing, nothing)
    end

    identitypartitions = Set{Ttsidx}()
    parammap = Dict()
    timeseries_partition_templates = Dict()
    TsavedParamIdx = ParameterTimeseriesIndex{Ttsidx, NTuple{2, Int}}
    indexes_in_partition = Dict{Ttsidx, Vector{TParammapKeys}}()
    for (tsidx, type_to_idxs) in ts_idx_to_type_to_param_idx
        if ts_idx_to_count[tsidx] == length(all_ts_params[tsidx])
            push!(identitypartitions, tsidx)
            continue
        end
        templates = VectorTemplate[]
        for (type, idxs) in type_to_idxs
            template = VectorTemplate(type, length(idxs))
            push!(templates, template)
            for (i, idx) in enumerate(idxs)
                pti = ParameterTimeseriesIndex(tsidx, (length(templates), i))
                parammap[idx] = pti

                buf = get!(() -> TsavedParamIdx[], indexes_in_partition, tsidx)
                push!(buf, idx)
            end
        end
        timeseries_partition_templates[tsidx] = templates
    end
    parammap = Dict{TParammapKeys, TsavedParamIdx}(parammap)
    timeseries_partition_templates = Dict{Ttsidx, Vector{VectorTemplate}}(timeseries_partition_templates)
    ts_idx_to_count = Dict{Ttsidx, Int}(ts_idx_to_count)
    timeseries_idx_to_param_idx = Dict{TParammapKeys, TParamIdx}(timeseries_idx_to_param_idx)
    return SavedSubsystem(
        state_map, parammap, timeseries_idx_to_param_idx, identitypartitions,
        timeseries_partition_templates, indexes_in_partition, ts_idx_to_count
    )
end

"""
    $(TYPEDSIGNATURES)

Given a `SavedSubsystem`, return the subset of state indexes of the original system that are
saved, in the order they are saved.
"""
function get_saved_state_idxs(ss::SavedSubsystem)
    idxs = Vector{valtype(ss.state_map)}(undef, length(ss.state_map))
    for (k, v) in ss.state_map
        idxs[v] = k
    end
    return idxs
end

"""
    $(TYPEDEF)

A combination of a `SavedSubsystem` and a fallback index provider. The provided fallback
is used as the `symbolic_container` for the `SavedSubsystemWithFallback`. Manually
implements `is_timeseries_parameter` and `timeseries_parameter_index` using the
`SavedSubsystem` to return the appropriate indexes for the subset of saved variables,
and `nothing`/`false` otherwise.

Also implements `create_parameter_timeseries_collection`, `get_saveable_values` and
`with_updated_parameter_timeseries_values` to appropriately handled subsetted timeseries
parameters.
"""
struct SavedSubsystemWithFallback{S <: SavedSubsystem, T}
    saved_subsystem::S
    fallback::T
end

function SymbolicIndexingInterface.symbolic_container(sswf::SavedSubsystemWithFallback)
    return sswf.fallback
end

function SymbolicIndexingInterface.is_timeseries_parameter(
        sswf::SavedSubsystemWithFallback, sym
    )
    return timeseries_parameter_index(sswf, sym) !== nothing
end

function SymbolicIndexingInterface.timeseries_parameter_index(
        sswf::SavedSubsystemWithFallback, sym
    )
    ss = sswf.saved_subsystem
    ss.timeseries_params_map === nothing && return nothing
    if symbolic_type(sym) == NotSymbolic()
        sym isa ParameterTimeseriesIndex || return nothing
        sym.timeseries_idx in ss.identity_partitions && return sym
        return get(ss.timeseries_params_map, sym, nothing)
    end
    v = timeseries_parameter_index(sswf.fallback, sym)
    return timeseries_parameter_index(sswf, v)
end

function create_parameter_timeseries_collection(sswf::SavedSubsystemWithFallback, ps, tspan)
    original = create_parameter_timeseries_collection(sswf.fallback, ps, tspan)
    ss = sswf.saved_subsystem
    if original === nothing
        return nothing
    end
    newcollection = map(enumerate(original)) do (i, buffer)
        i in ss.identity_partitions && return buffer
        ss.partition_count === nothing && return buffer
        cnt = get(ss.partition_count, i, 0)
        cnt == 0 && return buffer

        return as_diffeq_array(ss.timeseries_partition_templates[i], buffer.t)
    end

    return ParameterTimeseriesCollection(newcollection, parameter_values(original))
end

function get_saveable_values(sswf::SavedSubsystemWithFallback, ps, tsidx)
    ss = sswf.saved_subsystem
    original = get_saveable_values(sswf.fallback, ps, tsidx)
    tsidx in ss.identity_partitions && return original
    ss.partition_count === nothing && return nothing
    cnt = get(ss.partition_count, tsidx, 0)
    cnt == 0 && return nothing

    toaw = TupleOfArraysWrapper(ss.timeseries_partition_templates[tsidx])
    for idx in ss.indexes_in_partition[tsidx]
        toaw[ss.timeseries_params_map[idx].parameter_idx] = original[idx.parameter_idx]
    end
    return toaw
end

function SymbolicIndexingInterface.with_updated_parameter_timeseries_values(
        sswf::SavedSubsystemWithFallback, ps, args...
    )
    ss = sswf.saved_subsystem
    for (tsidx, val) in args
        if tsidx in ss.identity_partitions
            ps = with_updated_parameter_timeseries_values(sswf.fallback, ps, tsidx => val)
            continue
        end
        ss.partition_count === nothing && continue
        cnt = get(ss.partition_count, tsidx, 0)
        cnt == 0 && continue

        # now we know val isa TupleOfArraysWrapper
        for idx in ss.indexes_in_partition[tsidx]
            set_parameter!(
                ps, val[ss.timeseries_params_map[idx].parameter_idx],
                ss.timeseries_idx_to_param_idx[idx]
            )
        end
    end

    return ps
end

"""
    $(TYPEDSIGNATURES)

Given a SciMLProblem `prob` and (possibly symbolic) `save_idxs`, return the `save_idxs`
corresponding to the state variables and a `SavedSubsystem` to pass to `build_solution`.

The second return value (corresponding to the `SavedSubsystem`) may be `nothing` in case
one is not required. `save_idxs` may be a scalar or `nothing`.
"""
get_save_idxs_and_saved_subsystem(prob, ::Nothing) = nothing, nothing
function get_save_idxs_and_saved_subsystem(prob, save_idxs::Vector{Int})
    return save_idxs, SavedSubsystem(prob, parameter_values(prob), save_idxs)
end
function get_save_idxs_and_saved_subsystem(prob, save_idx::Int)
    return save_idx, SavedSubsystem(prob, parameter_values(prob), save_idx)
end
function get_save_idxs_and_saved_subsystem(prob, save_idxs)
    if !(save_idxs isa AbstractArray) || symbolic_type(save_idxs) != NotSymbolic()
        _save_idxs = (save_idxs,)
    else
        _save_idxs = save_idxs
    end
    saved_subsystem = SavedSubsystem(prob, parameter_values(prob), _save_idxs)
    if saved_subsystem !== nothing
        _save_idxs = get_saved_state_idxs(saved_subsystem)
        if isempty(_save_idxs)
            # no states to save
            save_idxs = Int[]
        elseif !(save_idxs isa AbstractArray) ||
                symbolic_type(save_idxs) != NotSymbolic()
            # only a single state to save, and save it as a scalar timeseries instead of
            # single-element array
            save_idxs = only(_save_idxs)
        else
            save_idxs = _save_idxs
        end
    end

    return save_idxs, saved_subsystem
end

using SciMLBase

struct DummySolution
    retcode::SciMLBase.ReturnCode.T
end

SciMLBase.solution_new_retcode(::DummySolution, code) = DummySolution(code)

mutable struct DummyIntegrator{Alg, IIP, U, T} <: SciMLBase.DEIntegrator{Alg, IIP, U, T}
    uprev::U
    tprev::T
    u::U
    t::T
    dt::T
    tdir::Any
    tstops::Any
    sol::DummySolution

    function DummyIntegrator()
        return new{Bool, Bool, Vector{Float64}, Float64}(
            [0.0], 0, [0.0], 0, 1, 1, [],
            DummySolution(ReturnCode.Default)
        )
    end
end

function SciMLBase.add_tstop!(integrator::DummyIntegrator, t)
    integrator.tdir * (t - integrator.t) < 0 &&
        error("Tried to add a tstop that is behind the current time. This is strictly forbidden")
    return push!(integrator.tstops, t)
end

function SciMLBase.step!(integrator::DummyIntegrator)
    t_next = integrator.t + integrator.dt
    if !isempty(integrator.tstops) && integrator.tstops[1] < t_next
        t_next = integrator.tstops[1]
    end
    integrator.uprev .= integrator.u
    integrator.u[1] += 2 * (t_next - integrator.t)
    integrator.tprev = integrator.t
    return integrator.t = t_next
end

function step_dt!(integrator, args...)
    t = integrator.t
    step!(integrator, args...)
    return integrator.t - t
end

function SciMLBase.done(integrator::DummyIntegrator)
    return integrator.t > 10
end

SciMLBase.check_error(::DummyIntegrator) = ReturnCode.Success
SciMLBase.postamble!(::DummyIntegrator) = nothing

integrator = DummyIntegrator()
@test step_dt!(integrator, 1.5) == 2
@test step_dt!(integrator, 1.5, true) == 1.5
@test_throws ErrorException step!(integrator, -1)

for (u, t) in tuples(DummyIntegrator())
    @test u[1] == 2 * t
end
@test eltype(collect(tuples(DummyIntegrator()))) == Tuple{Vector{Float64}, Float64}

for (uprev, tprev, u, t) in intervals(DummyIntegrator())
    @test u[1] - uprev[1] == 2
    @test t - tprev == 1
end
@test eltype(collect(intervals(DummyIntegrator()))) ==
    Tuple{Vector{Float64}, Float64, Vector{Float64}, Float64}

@test integrator.sol.retcode == ReturnCode.Default
@test check_error(integrator) == ReturnCode.Success
@test integrator.sol.retcode == ReturnCode.Default
@test SciMLBase.check_error!(integrator) == ReturnCode.Success
@test integrator.sol.retcode == ReturnCode.Success

let
    integrator = DummyIntegrator()
    @test 0 == @allocated SciMLBase.check_error!(integrator)
end

@enum ObjSense MinSense MaxSense

@doc doc"""

Defines an optimization problem.
Documentation Page: <https://docs.sciml.ai/Optimization/stable/API/optimization_problem/>

## Mathematical Specification of an Optimization Problem

To define an optimization problem, you need the objective function ``f``
which is minimized over the domain of ``u``, the collection of optimization variables:

```math
\min_u f(u,p)
```

``u₀`` is an initial guess for the minimizer. `f` should be specified as `f(u,p)`
and `u₀` should be an `AbstractArray` whose geometry matches the
desired geometry of `u`. Note that we are not limited to vectors
for `u₀`; one is allowed to provide `u₀` as arbitrary matrices /
higher-dimension tensors as well.

## Problem Type

### Constructors

```julia
OptimizationProblem{isinplace}(f, u0, p = SciMLBase.NullParameters(),;
                        lb = nothing,
                        ub = nothing,
                        lcons = nothing,
                        ucons = nothing,
                        sense = nothing,
                        kwargs...)
```

`isinplace` optionally sets whether the function is in-place or not.
This is determined automatically, but not inferred. Note that for OptimizationProblem,
in-place refers to the objective's derivative functions, the constraint function
and its derivatives. `OptimizationProblem` currently only supports in-place.

Parameters `p` are optional, and if not given, then a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters.

`lb` and `ub` are the upper and lower bounds for box constraints on the
optimization variables. They should be an `AbstractArray` matching the geometry of `u`,
where `(lb[i],ub[i])` is the box constraint (lower and upper bounds) for `u[i]`.

`lcons` and `ucons` are the upper and lower bounds in case of inequality constraints on the
optimization and if they are set to be equal then it represents an equality constraint.
They should be an `AbstractArray`, where `(lcons[i],ucons[i])`
are the lower and upper bounds for `cons[i]`.

The `f` in the `OptimizationProblem` should typically be an instance of [`OptimizationFunction`](https://docs.sciml.ai/Optimization/stable/API/optimization_function/#optfunction)
to specify the objective function and its derivatives either by passing
predefined functions for them or automatically generated using the [ADType](https://github.com/SciML/ADTypes.jl).

If `f` is a standard Julia function, it is automatically transformed into an
`OptimizationFunction` with `NoAD()`, meaning the derivative functions are not
automatically generated.

Any extra keyword arguments are captured to be sent to the optimizers.

### Fields

* `f`: the function in the problem.
* `u0`: the initial guess for the optimization variables.
* `p`: Either the constant parameters or fixed data (full batch) used in the objective or a [MLUtils](https://github.com/JuliaML/MLUtils.jl) [`DataLoader`](https://juliaml.github.io/MLUtils.jl/stable/api/#MLUtils.DataLoader) for minibatching with stochastic optimization solvers. Defaults to `NullParameters`.
* `lb`: the lower bounds for the optimization variables `u`.
* `ub`: the upper bounds for the optimization variables `u`.
* `int`: integrality indicator for `u`. If `int[i] == true`, then `u[i]` is an integer variable.
    Defaults to `nothing`, implying no integrality constraints.
* `lcons`: the vector of lower bounds for the constraints passed to [OptimizationFunction](https://docs.sciml.ai/Optimization/stable/API/optimization_function/#optfunction).
    Defaults to `nothing`, implying no lower bounds for the constraints (i.e. the constraint bound is `-Inf`)
* `ucons`: the vector of upper bounds for the constraints passed to [`OptimizationFunction`](https://docs.sciml.ai/Optimization/stable/API/optimization_function/#optfunction).
    Defaults to `nothing`, implying no upper bounds for the constraints (i.e. the constraint bound is `Inf`)
* `sense`: the objective sense, can take `MaxSense` or `MinSense` from Optimization.jl.
* `kwargs`: the keyword arguments passed on to the solvers.

## Inequality and Equality Constraints

Both inequality and equality constraints are defined by the `f.cons` function in the [`OptimizationFunction`](https://docs.sciml.ai/Optimization/stable/API/optimization_function/#optfunction)
description of the problem structure. This `f.cons` is given as a function `f.cons(u,p)` which computes
the value of the constraints at `u`. For example, take `f.cons(u,p) = u[1] - u[2]`.
With these definitions, `lcons` and `ucons` define the bounds on the constraint that the solvers try to satisfy.
If `lcons` and `ucons` are `nothing`, then there are no constraints bounds, meaning that the constraint is satisfied when `-Inf < f.cons < Inf` (which of course is always!). If `lcons[i] = ucons[i] = 0`, then the constraint is satisfied when `f.cons(u,p)[i] = 0`, and so this implies the equality constraint `u[1] = u[2]`. If `lcons[i] = ucons[i] = a`, then ``u[1] - u[2] = a`` is the equality constraint.

Inequality constraints are then given by making `lcons[i] != ucons[i]`. For example, `lcons[i] = -Inf` and `ucons[i] = 0` would imply the inequality constraint `u[1] <= u[2]` since any `f.cons[i] <= 0` satisfies the constraint. Similarly, `lcons[i] = -1` and `ucons[i] = 1` would imply that `-1 <= f.cons[i] <= 1` is required or `-1 <= u[1] - u[2] <= 1`.

Note that these vectors must be sized to match the number of constraints, with one set of conditions for each constraint.

## Data handling

As described above the second argument of the objective definition can take a full batch or a [`DataLoader`](https://juliaml.github.io/MLUtils.jl/stable/api/#MLUtils.DataLoader) object for mini-batching which is useful for stochastic optimization solvers. Thus the data either as an Array or a `DataLoader` object should be passed as the third argument of the `OptimizationProblem` constructor.
For an example of how to use this data handling, see the `Sophia` example in the [Optimization.jl documentation](https://docs.sciml.ai/Optimization/dev/optimization_packages/optimization) or the [mini-batching tutorial](https://docs.sciml.ai/Optimization/dev/tutorials/minibatch/).
"""
struct OptimizationProblem{iip, F, uType, P, LB, UB, I, LC, UC, S, K} <:
    AbstractOptimizationProblem{iip}
    f::F
    u0::uType
    p::P
    lb::LB
    ub::UB
    int::I
    lcons::LC
    ucons::UC
    sense::S
    kwargs::K
    @add_kwonly function OptimizationProblem{iip}(
            f::Union{OptimizationFunction{iip}, MultiObjectiveOptimizationFunction{iip}},
            u0,
            p = NullParameters();
            lb = nothing, ub = nothing, int = nothing,
            lcons = nothing, ucons = nothing,
            sense = nothing, kwargs...
        ) where {iip}
        if xor(lb === nothing, ub === nothing)
            error("If any of `lb` or `ub` is provided, both must be provided.")
        end
        warn_paramtype(p)
        new{
            iip, typeof(f), typeof(u0), typeof(p),
            typeof(lb), typeof(ub), typeof(int), typeof(lcons), typeof(ucons),
            typeof(sense), typeof(kwargs),
        }(
            f, u0, p, lb, ub, int, lcons, ucons, sense,
            kwargs
        )
    end
end

function OptimizationProblem(
        f::Union{OptimizationFunction, MultiObjectiveOptimizationFunction},
        args...; kwargs...
    )
    return OptimizationProblem{isinplace(f)}(f, args...; kwargs...)
end
function OptimizationProblem(f, args...; kwargs...)
    return OptimizationProblem(OptimizationFunction(f), args...; kwargs...)
end

function OptimizationFunction(
        f::NonlinearFunction, adtype::AbstractADType = NoAD(); kwargs...
    )
    if isinplace(f)
        throw(ArgumentError("Converting NonlinearFunction to OptimizationFunction is not supported with in-place functions yet."))
    end
    return OptimizationFunction((u, p) -> sum(abs2, f(u, p)), adtype; kwargs...)
end

function OptimizationProblem(
        prob::NonlinearLeastSquaresProblem, adtype::AbstractADType = NoAD(); kwargs...
    )
    if isinplace(prob)
        throw(ArgumentError("Converting NonlinearLeastSquaresProblem to OptimizationProblem is not supported with in-place functions yet."))
    end
    optf = OptimizationFunction(prob.f, adtype; kwargs...)
    return OptimizationProblem(optf, prob.u0, prob.p; prob.kwargs..., kwargs...)
end

isinplace(f::OptimizationFunction{iip}) where {iip} = iip
isinplace(f::OptimizationProblem{iip}) where {iip} = iip

@doc doc"""
    OptimizationAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = false, alias = nothing)

Holds information on what variables to alias
when solving an OptimizationProblem. Conforms to the AbstractAliasSpecifier interface. 

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false .
* `alias::Union{Bool, Nothing}`: sets all fields of the `OptimizationAliasSpecifier` to `alias`

"""
struct OptimizationAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}

    function OptimizationAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true)
        elseif alias == false
            new(false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0)
        end
    end
end

DOMAINERROR_COMPLEX_MSG = """

DomainError detected in the user `f` function. This occurs when the domain of a function is violated.
For example, `log(-1.0)` is undefined because `log` of a real number is defined to only output real
numbers, but `log` of a negative number is complex valued and therefore Julia throws a DomainError
by default. Cases to be aware of include:

* `log(x)`, `sqrt(x)`, `cbrt(x)`, etc. where `x<0`
* `x^y` for `x<0` floating point `y` (example: `(-1.0)^(1/2) == im`)

Within the context of SciML, this error can occur within the solver process even if the domain constraint
would not be violated in the solution due to adaptivity. For example, an ODE solver or optimization
routine may check a step at `new_u` which violates the domain constraint, and if violated reject the
step and use a smaller `dt`. However, the throwing of this error will have halted the solving process.

Thus the recommended fix is to replace this function with the equivalent ones from NaNMath.jl
(https://github.com/JuliaMath/NaNMath.jl) which returns a NaN instead of an error. The solver will then
effectively use the NaN within the error control routines to reject the out of bounds step. Additionally,
one could perform a domain transformation on the variables so that such an issue does not occur in the
definition of `f`.

For more information, check out the following FAQ page:
<https://docs.sciml.ai/Optimization/stable/API/FAQ/#The-Solver-Seems-to-Violate-Constraints-During-the-Optimization,-Causing-DomainErrors,-What-Can-I-Do-About-That?>"""

FUNCTIONWRAPPERSWRAPPERS_MSG = """
No appropriate function wrapper found. This means that the auto-despecialization code used for the reduction
of compile times has failed. This is most likely due to an issue internal to the function `prob.f` that is
found upon evaluation of the model. To work around this issue, use `SciMLBase.FullSpecialize`, like:

```julia
ODEProblem{iip,SciMLBase.FullSpecialize}(f,u0,tspan,p)
```

where `iip` is either true or false depending on the in-placeness of the definition of `f` (i.e. for ODEs
if `f` has 3 arguments `(u,p,t)` then it's false, otherwise `f(du,u,p,t)` is true).

For more information on the control of specialization options, please see the documentation at:

<https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Choices>

If one wants way more detail than necessary on why the function wrappers exist and what they are doing, see:

<https://sciml.ai/news/2022/09/21/compile_time>"""

const NO_PARAMETERS_ARITHMETIC_ERROR_MESSAGE = """

An arithmetic operation was performed on a NullParameters object. This means no parameters were passed
into the AbstractSciMLProblem (e.x.: ODEProblem) but the parameters object `p` was used in an arithmetic
expression. Two common reasons for this issue are:

1. Forgetting to pass parameters into the problem constructor. For example, `ODEProblem(f,u0,tspan)` should
   be `ODEProblem(f,u0,tspan,p)` in order to use parameters.

2. Using the wrong function signature. For example, with `ODEProblem`s the function signature is always
   `f(du,u,p,t)` for the in-place form or `f(u,p,t)` for the out-of-place form. Note that the `p` argument
   will always be in the function signature regardless of if the problem is defined with parameters!
"""

"""
    _has_sciml_in_stacktrace()

Check whether any frame in the current exception's stacktrace originates from SciMLBase
(e.g. from `SciMLFunction` wrappers in `scimlfunctions.jl`). This is used to avoid showing
SciML-specific error hints when the error occurs outside of a SciML solver context.
"""
function _has_sciml_in_stacktrace()
    bt = catch_backtrace()
    frames = stacktrace(bt)
    scimlbase_src = let d = pkgdir(@__MODULE__)
        d === nothing ? nothing : joinpath(d, "src")
    end
    scimlbase_src === nothing && return false
    for frame in frames
        fpath = string(frame.file)
        if startswith(fpath, scimlbase_src)
            return true
        end
    end
    return false
end

function __init__()
    Base.Experimental.register_error_hint(DomainError) do io, e
        if e isa DomainError &&
                occursin("will only return a complex result if called with a complex argument. Try ", e.msg) &&
                _has_sciml_in_stacktrace()
            println(io, DOMAINERROR_COMPLEX_MSG)
        end
    end

    Base.Experimental.register_error_hint(MethodError) do io, e, args, kwargs
        if e isa MethodError && NullParameters in args
            println(io, NO_PARAMETERS_ARITHMETIC_ERROR_MESSAGE)
        end
    end

    return Base.Experimental.register_error_hint(FunctionWrappersWrappers.NoFunctionWrapperFoundError) do io,
            e
        println(io, FUNCTIONWRAPPERSWRAPPERS_MSG)
    end
end

"""
$(TYPEDEF)

Representation of the solution to an differential-algebraic equation defined by an DAEProblem.

## DESolution Interface

For more information on interacting with `DESolution` types, check out the Solution Handling
page of the DifferentialEquations.jl documentation.

<https://docs.sciml.ai/DiffEqDocs/stable/basics/solution/>

## Fields

  - `u`: the representation of the DAE solution. Given as an array of solutions, where `u[i]`
    corresponds to the solution at time `t[i]`. It is recommended in most cases one does not
    access `sol.u` directly and instead use the array interface described in the Solution
    Handling page of the DifferentialEquations.jl documentation.
  - `du`: the representation of the derivatives of the DAE solution.
  - `t`: the time points corresponding to the saved values of the DAE solution.
  - `prob`: the original DAEProblem that was solved.
  - `alg`: the algorithm type used by the solver.
  - `stats`: statistics of the solver, such as the number of function evaluations required,
    number of Jacobians computed, and more.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully, whether it terminated early due to a user-defined callback, or whether it
    exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
"""
struct DAESolution{T, N, uType, duType, uType2, DType, tType, P, A, ID, S, rateType, V} <:
    AbstractDAESolution{T, N, uType}
    u::uType
    du::duType
    u_analytic::uType2
    errors::DType
    t::tType
    k::rateType
    prob::P
    alg::A
    interp::ID
    dense::Bool
    tslocation::Int
    stats::S
    retcode::ReturnCode.T
    saved_subsystem::V
end

function DAESolution{T, N}(
        u, du, u_analytic, errors, t, k, prob, alg, interp, dense,
        tslocation, stats, retcode, saved_subsystem
    ) where {T, N}
    return DAESolution{
        T, N, typeof(u), typeof(du), typeof(u_analytic), typeof(errors),
        typeof(t), typeof(prob), typeof(alg), typeof(interp), typeof(stats), typeof(k),
        typeof(saved_subsystem),
    }(
        u, du, u_analytic, errors, t, k, prob, alg, interp, dense, tslocation, stats,
        retcode, saved_subsystem
    )
end

function ConstructionBase.constructorof(::Type{O}) where {T, N, O <: DAESolution{T, N}}
    return DAESolution{T, N}
end

function ConstructionBase.setproperties(sol::DAESolution, patch::NamedTuple)
    u = get(patch, :u, sol.u)
    N = u === nothing ? 2 : ndims(eltype(u)) + 1
    T = eltype(eltype(u))
    patch = merge(getproperties(sol), patch)
    return DAESolution{T, N}(
        patch.u, patch.du, patch.u_analytic, patch.errors, patch.t,
        patch.k, patch.prob, patch.alg, patch.interp, patch.dense, patch.tslocation,
        patch.stats, patch.retcode, patch.saved_subsystem
    )
end

Base.@propagate_inbounds function Base.getproperty(x::AbstractDAESolution, s::Symbol)
    if s === :destats
        Base.depwarn("`sol.destats` is deprecated. Use `sol.stats` instead.", "sol.destats")
        return getfield(x, :stats)
    elseif s === :ps
        return ParameterIndexingProxy(x)
    end
    return getfield(x, s)
end

function build_solution(
        prob::AbstractDAEProblem, alg, t, u, du = nothing;
        timeseries_errors = length(u) > 2,
        dense = false,
        dense_errors = dense,
        calculate_error = true,
        k = nothing,
        interp = du === nothing ? LinearInterpolation(t, u) :
            HermiteInterpolation(t, u, du),
        retcode = ReturnCode.Default,
        destats = missing,
        stats = nothing,
        saved_subsystem = nothing,
        kwargs...
    )
    T = eltype(eltype(u))

    if prob.u0 === nothing
        N = 2
    else
        N = ndims(eltype(u)) + 1
    end

    if !ismissing(destats)
        msg = "`destats` kwarg has been deprecated in favor of `stats`"
        if stats !== nothing
            msg *= " `stats` kwarg is also provided, ignoring `destats` kwarg."
        else
            stats = destats
        end
        Base.depwarn(msg, :build_solution)
    end
    return if has_analytic(prob.f)
        u_analytic = Vector{typeof(prob.u0)}()
        errors = Dict{Symbol, real(eltype(prob.u0))}()

        sol = DAESolution{
            T, N, typeof(u), typeof(du), typeof(u_analytic), typeof(errors),
            typeof(t), typeof(prob), typeof(alg), typeof(interp), typeof(stats), typeof(k),
            typeof(saved_subsystem),
        }(
            u,
            du,
            u_analytic,
            errors,
            t,
            k,
            prob,
            alg,
            interp,
            dense,
            0,
            stats,
            retcode,
            saved_subsystem
        )

        if calculate_error
            calculate_solution_errors!(
                sol; timeseries_errors = timeseries_errors,
                dense_errors = dense_errors
            )
        end
        sol
    else
        DAESolution{
            T, N, typeof(u), typeof(du), Nothing, Nothing, typeof(t),
            typeof(prob), typeof(alg), typeof(interp), typeof(stats), typeof(k),
            typeof(saved_subsystem),
        }(
            u, du,
            nothing,
            nothing, t, k,
            prob, alg,
            interp,
            dense, 0,
            stats,
            retcode,
            saved_subsystem
        )
    end
end

function calculate_solution_errors!(
        sol::AbstractDAESolution;
        fill_uanalytic = true, timeseries_errors = true,
        dense_errors = true
    )
    prob = sol.prob
    f = prob.f

    if fill_uanalytic
        for i in 1:size(sol.u, 1)
            push!(sol.u_analytic, f.analytic(prob.du0, prob.u0, prob.p, sol.t[i]))
        end
    end

    save_everystep = length(sol.u) > 2
    if !isempty(sol.u_analytic)
        sol.errors[:final] = norm(recursive_mean(abs.(sol.u[end] - sol.u_analytic[end])))

        if save_everystep && timeseries_errors
            sol.errors[:l∞] = norm(
                maximum(
                    vecvecapply(
                        x -> abs.(x),
                        sol.u - sol.u_analytic
                    )
                )
            )
            sol.errors[:l2] = norm(
                sqrt(
                    recursive_mean(
                        vecvecapply(
                            x -> float.(x) .^ 2,
                            sol.u - sol.u_analytic
                        )
                    )
                )
            )
            if sol.dense && dense_errors
                densetimes = collect(range(sol.t[1]; stop = sol.t[end], length = 100))
                interp_u = sol(densetimes)
                interp_analytic = VectorOfArray(
                    [
                        f.analytic(prob.du0, prob.u0, prob.p, t)
                            for t in densetimes
                    ]
                )
                sol.errors[:L∞] = norm(
                    maximum(
                        vecvecapply(
                            x -> abs.(x),
                            interp_u - interp_analytic
                        )
                    )
                )
                sol.errors[:L2] = norm(
                    sqrt(
                        recursive_mean(
                            vecvecapply(
                                x -> float.(x) .^ 2,
                                interp_u .-
                                    interp_analytic
                            )
                        )
                    )
                )
            end
        end
    end

    return nothing
end

function build_solution(sol::AbstractDAESolution{T, N}, u_analytic, errors) where {T, N}
    @reset sol.u_analytic = u_analytic
    return @set sol.errors = errors
end

function solution_new_retcode(sol::AbstractDAESolution{T, N}, retcode) where {T, N}
    return @set sol.retcode = retcode
end

function solution_new_tslocation(sol::AbstractDAESolution{T, N}, tslocation) where {T, N}
    return @set sol.tslocation = tslocation
end

function solution_slice(sol::AbstractDAESolution{T, N}, I) where {T, N}
    @reset sol.u = sol.u[I]
    @reset sol.du = sol.du[I]
    @reset sol.u_analytic = sol.u_analytic === nothing ? nothing : sol.u_analytic[I]
    @reset sol.t = sol.t[I]
    @reset sol.k = sol.dense ? sol.k[I] : sol.k
    return @set sol.dense = false
end

"""
$(TYPEDEF)
"""
struct StandardODEProblem end

@doc doc"""

Defines an ordinary differential equation (ODE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/ode_types/>

## Mathematical Specification of an ODE Problem

To define an ODE Problem, you simply need to give the function ``f`` and the initial
condition ``u_0`` which define an ODE:

```math
M \frac{du}{dt} = f(u,p,t)
```

There are two different ways of specifying `f`:
- `f(du,u,p,t)`: in-place. Memory-efficient when avoiding allocations. Best option for most cases unless mutation is not allowed.
- `f(u,p,t)`: returning `du`. Less memory-efficient way, particularly suitable when mutation is not allowed (e.g. with certain automatic differentiation packages such as Zygote).

`u₀` should be an AbstractArray (or number) whose geometry matches the desired geometry of `u`.
Note that we are not limited to numbers or vectors for `u₀`; one is allowed to
provide `u₀` as arbitrary matrices / higher dimension tensors as well.

For the mass matrix ``M``, see the documentation of `ODEFunction`.

## Problem Type

### Constructors

`ODEProblem` can be constructed by first building an `ODEFunction` or
by simply passing the ODE right-hand side to the constructor. The constructors
are:

- `ODEProblem(f::ODEFunction,u0,tspan,p=NullParameters();kwargs...)`
- `ODEProblem{isinplace,specialize}(f,u0,tspan,p=NullParameters();kwargs...)` :
  Defines the ODE with the specified functions. `isinplace` optionally sets whether
  the function is inplace or not. This is determined automatically, but not inferred.
  `specialize` optionally controls the specialization level. See the
  [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
  for more details. The default is `AutoSpecialize`.

For more details on the in-place and specialization controls, see the ODEFunction
documentation.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the `ODEFunction` documentation.

### Fields

- `f`: The function in the ODE.
- `u0`: The initial condition.
- `tspan`: The timespan for the problem.
- `p`: The parameters.
- `kwargs`: The keyword arguments passed onto the solves.

## Example Problem

```julia
using SciMLBase
function lorenz!(du,u,p,t)
  du[1] = 10.0(u[2]-u[1])
  du[2] = u[1]*(28.0-u[3]) - u[2]
  du[3] = u[1]*u[2] - (8/3)*u[3]
end
u0 = [1.0;0.0;0.0]
tspan = (0.0,100.0)
prob = ODEProblem(lorenz!,u0,tspan)

# Test that it worked
using OrdinaryDiffEq
sol = solve(prob,Tsit5())
using Plots; plot(sol,vars=(1,2,3))
```

## More Example Problems

Example problems can be found in [DiffEqProblemLibrary.jl](https://github.com/SciML/DiffEqProblemLibrary.jl).

To use a sample problem, such as `prob_ode_linear`, you can do something like:

```julia
#] add ODEProblemLibrary
using ODEProblemLibrary
prob = ODEProblemLibrary.prob_ode_linear
sol = solve(prob)
```
"""
mutable struct ODEProblem{uType, tType, isinplace, P, F, K, PT} <:
    AbstractODEProblem{uType, tType, isinplace}
    """The ODE is `du = f(u,p,t)` for out-of-place and f(du,u,p,t) for in-place."""
    f::F
    """The initial condition is `u(tspan[1]) = u0`."""
    u0::uType
    """The solution `u(t)` will be computed for `tspan[1] ≤ t ≤ tspan[2]`."""
    tspan::tType
    """Constant parameters to be supplied as the second argument of `f`."""
    p::P
    """A callback to be applied to every solver which uses the problem."""
    kwargs::K
    """An internal argument for storing traits about the solving process."""
    problem_type::PT
    @add_kwonly function ODEProblem{iip}(
            f::AbstractODEFunction{iip},
            u0, tspan, p = NullParameters(),
            problem_type = StandardODEProblem();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan),
            isinplace(f), typeof(p), typeof(f),
            typeof(kwargs),
            typeof(problem_type),
        }(
            f,
            _u0,
            _tspan,
            p,
            kwargs,
            problem_type
        )
    end

    """
        ODEProblem{isinplace}(f,u0,tspan,p=NullParameters(),callback=CallbackSet())

    Define an ODE problem with the specified function.
    `isinplace` optionally sets whether the function is inplace or not.
    This is determined automatically, but not inferred.
    """
    function ODEProblem{iip}(f, u0, tspan, p = NullParameters(); kwargs...) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        _f = ODEFunction{iip, DEFAULT_SPECIALIZATION}(f)
        return ODEProblem(_f, _u0, _tspan, p; kwargs...)
    end

    @add_kwonly function ODEProblem{iip, recompile}(
            f, u0, tspan, p = NullParameters();
            kwargs...
        ) where {iip, recompile}
        ODEProblem{iip}(ODEFunction{iip, recompile}(f), u0, tspan, p; kwargs...)
    end

    function ODEProblem{iip, FunctionWrapperSpecialize}(
            f, u0, tspan, p = NullParameters();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        if !(f isa FunctionWrappersWrappers.FunctionWrappersWrapper)
            if iip
                ff = ODEFunction{iip, FunctionWrapperSpecialize}(
                    wrapfun_iip(
                        f,
                        (
                            _u0, _u0, p,
                            _tspan[1],
                        )
                    )
                )
            else
                ff = ODEFunction{iip, FunctionWrapperSpecialize}(
                    wrapfun_oop(
                        f,
                        (
                            _u0, p,
                            _tspan[1],
                        )
                    )
                )
            end
        end
        return ODEProblem{iip}(ff, _u0, _tspan, p; kwargs...)
    end
end

function Base.setproperty!(prob::ODEProblem, s::Symbol, v)
    @warn "Mutation of ODEProblem detected. SciMLBase v2.0 has made ODEProblem temporarily mutable in order to allow for interfacing with EnzymeRules due to a current limitation in the rule system. This change is only intended to be temporary and ODEProblem will return to being a struct in a later non-breaking release. Do not rely on this behavior, use with caution."
    return Base.setfield!(prob, s, v)
end

function Base.setproperty!(prob::ODEProblem, s::Symbol, v, order::Symbol)
    @warn "Mutation of ODEProblem detected. SciMLBase v2.0 has made ODEProblem temporarily mutable in order to allow for interfacing with EnzymeRules due to a current limitation in the rule system. This change is only intended to be temporary and ODEProblem will return to being a struct in a later non-breaking release. Do not rely on this behavior, use with caution."
    return Base.setfield!(prob, s, v, order)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: ODEProblem}
    return function ctor(f, u0, tspan, p, kw, pt)
        if f isa AbstractODEFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 4)
        end
        return ODEProblem{iip}(f, u0, tspan, p, pt; kw...)
    end
end

"""
    ODEProblem(f::ODEFunction,u0,tspan,p=NullParameters(),callback=CallbackSet())

Define an ODE problem from an [`ODEFunction`](@ref).
"""
function ODEProblem(f::AbstractODEFunction, u0, tspan, args...; kwargs...)
    return ODEProblem{isinplace(f)}(f, u0, tspan, args...; kwargs...)
end

function ODEProblem(f, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 4)
    _u0 = prepare_initial_state(u0)
    _tspan = promote_tspan(tspan)
    _f = ODEFunction{iip, DEFAULT_SPECIALIZATION}(f)
    return ODEProblem(_f, _u0, _tspan, p; kwargs...)
end

"""
$(TYPEDEF)
"""
abstract type AbstractDynamicalODEProblem end

@doc doc"""

Defines a dynamical ordinary differential equation (ODE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/dynamical_types/>

Dynamical ordinary differential equations, such as those arising from the definition
of a Hamiltonian system or a second order ODE, have a special structure that can be
utilized in the solution of the differential equation. On this page, we describe
how to define second order differential equations for their efficient numerical solution.

## Mathematical Specification of a Dynamical ODE Problem

These algorithms require a Partitioned ODE of the form:

```math
\begin{align*}
\frac{dv}{dt} &= f_1(u,t) \\
\frac{du}{dt} &= f_2(v) \\
\end{align*}
```
This is a Partitioned ODE partitioned into two groups, so the functions should be
specified as `f1(dv,v,u,p,t)` and `f2(du,v,u,p,t)` (in the inplace form), where `f1`
is independent of `v` (unless specified by the solver), and `f2` is independent
of `u` and `t`. This includes discretizations arising from
`SecondOrderODEProblem`s where the velocity is not used in the acceleration function,
and Hamiltonians where the potential is (or can be) time-dependent, but the kinetic
energy is only dependent on `v`.

Note that some methods assume that the integral of `f2` is a quadratic form. That
means that `f2=v'*M*v`, i.e. ``\int f_2 = \frac{1}{2} m v^2``, giving `du = v`.
This is equivalent to saying that the kinetic energy is related to ``v^2``. The
methods which require this assumption will lose accuracy if this assumption is
violated. Methods listed make note of this requirement with "Requires
quadratic kinetic energy".

### Constructor

```julia
DynamicalODEProblem(f::DynamicalODEFunction,v0,u0,tspan,p=NullParameters();kwargs...)
DynamicalODEProblem{isinplace}(f1,f2,v0,u0,tspan,p=NullParameters();kwargs...)
```

Defines the ODE with the specified functions. `isinplace` optionally sets whether
the function is inplace or not. This is determined automatically, but not inferred.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

### Fields

* `f1` and `f2`: The functions in the ODE.
* `v0` and `u0`: The initial conditions.
* `tspan`: The timespan for the problem.
* `p`: The parameters for the problem. Defaults to `NullParameters`
* `kwargs`: The keyword arguments passed onto the solves.
"""
struct DynamicalODEProblem{iip} <: AbstractDynamicalODEProblem end

"""
    DynamicalODEProblem(f::DynamicalODEFunction,v0,u0,tspan,p=NullParameters(),callback=CallbackSet())

Define a dynamical ODE function from a [`DynamicalODEFunction`](@ref).
"""
function DynamicalODEProblem(
        f::DynamicalODEFunction, du0, u0, tspan, p = NullParameters();
        kwargs...
    )
    return ODEProblem(f, ArrayPartition(du0, u0), tspan, p; kwargs...)
end
function DynamicalODEProblem(f1, f2, du0, u0, tspan, p = NullParameters(); kwargs...)
    return ODEProblem(DynamicalODEFunction(f1, f2), ArrayPartition(du0, u0), tspan, p; kwargs...)
end

function DynamicalODEProblem{iip}(
        f1, f2, du0, u0, tspan, p = NullParameters();
        kwargs...
    ) where {iip}
    return ODEProblem(
        DynamicalODEFunction{iip}(f1, f2), ArrayPartition(du0, u0), tspan, p,
        DynamicalODEProblem{iip}(); kwargs...
    )
end

@doc doc"""

Defines a second order ordinary differential equation (ODE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/dynamical_types/>

## Mathematical Specification of a 2nd Order ODE Problem

To define a 2nd Order ODE Problem, you simply need to give the function ``f``
and the initial condition ``u_0`` which define an ODE:

```math
u'' = f(u',u,p,t)
```

`f` should be specified as `f(du,u,p,t)` (or in-place as `f(ddu,du,u,p,t)`), and `u₀`
should be an AbstractArray (or number) whose geometry matches the desired
geometry of `u`. Note that we are not limited to numbers or vectors for `u₀`;
one is allowed to provide `u₀` as arbitrary matrices / higher dimension tensors
as well.

From this form, a dynamical ODE:

```math
\begin{align*}
v' &= f(v,u,p,t) \\
u' &= v
\end{align*}
```

is generated.

### Constructors

```julia
SecondOrderODEProblem{isinplace}(f,du0,u0,tspan,callback=CallbackSet())
```

Defines the ODE with the specified functions.

### Fields

* `f`: The function for the second derivative.
* `du0`: The initial derivative.
* `u0`: The initial condition.
* `tspan`: The timespan for the problem.
* `callback`: A callback to be applied to every solver which uses the problem.
  Defaults to nothing.
"""
struct SecondOrderODEProblem{iip} <: AbstractDynamicalODEProblem end
function SecondOrderODEProblem(f, du0, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 5)
    return SecondOrderODEProblem{iip}(f, du0, u0, tspan, p; kwargs...)
end

function SecondOrderODEProblem{iip}(
        f, du0, u0, tspan, p = NullParameters();
        kwargs...
    ) where {iip}
    if iip
        f2 = function (du, v, u, p, t)
            return du .= v
        end
    else
        f2 = function (v, u, p, t)
            return v
        end
    end
    _u0 = ArrayPartition((du0, u0))
    return ODEProblem(
        DynamicalODEFunction{iip}(f, f2), _u0, tspan, p,
        SecondOrderODEProblem{iip}(); kwargs...
    )
end
function SecondOrderODEProblem(
        f::DynamicalODEFunction, du0, u0, tspan,
        p = NullParameters(); kwargs...
    )
    iip = isinplace(f.f1, 5)
    _u0 = ArrayPartition((du0, u0))
    if f.f2.f === nothing
        if iip
            f2 = function (du, v, u, p, t)
                return du .= v
            end
        else
            f2 = function (v, u, p, t)
                return v
            end
        end
        return ODEProblem(
            DynamicalODEFunction{iip}(
                f.f1, f2; mass_matrix = f.mass_matrix,
                analytic = f.analytic
            ),
            _u0,
            tspan,
            p,
            SecondOrderODEProblem{iip}(); kwargs...
        )
    else
        return ODEProblem(
            DynamicalODEFunction{iip}(
                f.f1, f.f2; mass_matrix = f.mass_matrix,
                analytic = f.analytic
            ),
            _u0,
            tspan,
            p,
            SecondOrderODEProblem{iip}(); kwargs...
        )
    end
end

"""
$(TYPEDEF)
"""
abstract type AbstractSplitODEProblem end

@doc doc"""

Defines a split ordinary differential equation (ODE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/split_ode_types/>

## Mathematical Specification of a Split ODE Problem

To define a `SplitODEProblem`, you simply need to give two functions
``f_1`` and ``f_2`` along with an initial condition ``u_0`` which
define an ODE:

```math
\frac{du}{dt} =  f_1(u,p,t) + f_2(u,p,t)
```

`f` should be specified as `f(u,p,t)` (or in-place as `f(du,u,p,t)`), and `u₀` should
be an AbstractArray (or number) whose geometry matches the desired geometry of `u`.
Note that we are not limited to numbers or vectors for `u₀`; one is allowed to
provide `u₀` as arbitrary matrices / higher dimension tensors as well.

Many splits are at least partially linear. That is the equation:

```math
\frac{du}{dt} =  Au + f_2(u,p,t)
```

For how to define a linear function `A`, see the documentation for the [AbstractSciMLOperator](https://docs.sciml.ai/SciMLOperators/stable/interface/).

### Constructors

```julia
SplitODEProblem(f::SplitFunction,u0,tspan,p=NullParameters();kwargs...)
SplitODEProblem{isinplace}(f1,f2,u0,tspan,p=NullParameters();kwargs...)
```

The `isinplace` parameter can be omitted and will be determined using the signature of `f2`.
Note that both `f1` and `f2` should support the in-place style if `isinplace` is `true` or they
should both support the out-of-place style if `isinplace` is `false`. You cannot mix up the two styles.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

Under the hood, a `SplitODEProblem` is just a regular `ODEProblem` whose `f` is a `SplitFunction`.
Therefore, you can solve a `SplitODEProblem` using the same solvers for `ODEProblem`. For solvers
dedicated to split problems, see [Split ODE Solvers](@ref split_ode_solve).

For specifying Jacobians and mass matrices, see the
[DiffEqFunctions](@ref performance_overloads)
page.

### Fields

* `f1`, `f2`: The functions in the ODE.
* `u0`: The initial condition.
* `tspan`: The timespan for the problem.
* `p`: The parameters for the problem. Defaults to `NullParameters`
* `kwargs`: The keyword arguments passed onto the solves.
"""
struct SplitODEProblem{iip} <: AbstractSplitODEProblem end

function SplitODEProblem(f1, f2, u0, tspan, p = NullParameters(); kwargs...)
    f = SplitFunction(f1, f2)
    return SplitODEProblem(f, u0, tspan, p; kwargs...)
end

function SplitODEProblem{iip}(
        f1, f2, u0, tspan, p = NullParameters();
        kwargs...
    ) where {iip}
    f = SplitFunction{iip}(f1, f2)
    return SplitODEProblem(f, u0, tspan, p; kwargs...)
end

"""
$(SIGNATURES)

Define a split ODE problem from a [`SplitFunction`](@ref).
"""
function SplitODEProblem(f::SplitFunction, u0, tspan, p = NullParameters(); kwargs...)
    return SplitODEProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end
function SplitODEProblem{iip}(
        f::SplitFunction, u0, tspan, p = NullParameters();
        kwargs...
    ) where {iip}
    if f._func_cache === nothing && iip
        _func_cache = typeof(u0) <: AbstractArray{<:Number} ? DiffCache(u0) : u0
        f = remake(f; _func_cache)
    end
    return ODEProblem(f, u0, tspan, p, SplitODEProblem{iip}(); kwargs...)
end

abstract type AbstractIncrementingODEProblem end

"""
$(SIGNATURES)

Experimental
"""
struct IncrementingODEProblem{iip} <: AbstractIncrementingODEProblem end

function IncrementingODEProblem(f, u0, tspan, p = NullParameters(); kwargs...)
    f = IncrementingODEFunction(f)
    return IncrementingODEProblem(f, u0, tspan, p; kwargs...)
end

function IncrementingODEProblem{iip}(
        f, u0, tspan, p = NullParameters();
        kwargs...
    ) where {iip}
    f = IncrementingODEFunction{iip}(f)
    return IncrementingODEProblem(f, u0, tspan, p; kwargs...)
end

function IncrementingODEProblem(
        f::IncrementingODEFunction, u0, tspan, p = NullParameters();
        kwargs...
    )
    return IncrementingODEProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end

function IncrementingODEProblem{iip}(
        f::IncrementingODEFunction, u0, tspan,
        p = NullParameters(); kwargs...
    ) where {iip}
    return ODEProblem(f, u0, tspan, p, IncrementingODEProblem{iip}(); kwargs...)
end

@doc doc"""
    ODEAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = false, alias_du0 = false, alias_tstops = false, alias = nothing)

Holds information on what variables to alias
when solving an ODE. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false .
* `alias_du0::Union{Bool, Nothing}`: alias the du0 array for DAEs. Defaults to false.
* `alias_tstops::Union{Bool, Nothing}`: alias the tstops array
* `alias::Union{Bool, Nothing}`: sets all fields of the `ODEAliasSpecifier` to `alias`

"""
struct ODEAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_du0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}

    function ODEAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_du0, alias_tstops)
        end
    end
end

struct ImmutableODEProblem{uType, tType, isinplace, P, F, K, PT} <:
    AbstractODEProblem{uType, tType, isinplace}
    """The ODE is `du = f(u,p,t)` for out-of-place and f(du,u,p,t) for in-place."""
    f::F
    """The initial condition is `u(tspan[1]) = u0`."""
    u0::uType
    """The solution `u(t)` will be computed for `tspan[1] ≤ t ≤ tspan[2]`."""
    tspan::tType
    """Constant parameters to be supplied as the second argument of `f`."""
    p::P
    """A callback to be applied to every solver which uses the problem."""
    kwargs::K
    """An internal argument for storing traits about the solving process."""
    problem_type::PT
    @add_kwonly function ImmutableODEProblem{iip}(
            f::AbstractODEFunction{iip},
            u0, tspan, p = NullParameters(),
            problem_type = StandardODEProblem();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan),
            isinplace(f), typeof(p), typeof(f),
            typeof(kwargs),
            typeof(problem_type),
        }(
            f,
            _u0,
            _tspan,
            p,
            kwargs,
            problem_type
        )
    end

    """
        ImmutableODEProblem{isinplace}(f,u0,tspan,p=NullParameters(),callback=CallbackSet())

    Define an ODE problem with the specified function.
    `isinplace` optionally sets whether the function is inplace or not.
    This is determined automatically, but not inferred.
    """
    function ImmutableODEProblem{iip}(
            f,
            u0,
            tspan,
            p = NullParameters();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        _f = ODEFunction{iip, DEFAULT_SPECIALIZATION}(f)
        return ImmutableODEProblem(_f, _u0, _tspan, p; kwargs...)
    end

    @add_kwonly function ImmutableODEProblem{iip, recompile}(
            f, u0, tspan,
            p = NullParameters();
            kwargs...
        ) where {iip, recompile}
        ImmutableODEProblem{iip}(ODEFunction{iip, recompile}(f), u0, tspan, p; kwargs...)
    end
end

"""
    ImmutableODEProblem(f::ODEFunction,u0,tspan,p=NullParameters(),callback=CallbackSet())

Define an ODE problem from an [`ODEFunction`](@ref).
"""
function ImmutableODEProblem(f::AbstractODEFunction, u0, tspan, args...; kwargs...)
    return ImmutableODEProblem{isinplace(f)}(f, u0, tspan, args...; kwargs...)
end

function ImmutableODEProblem(f, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 4)
    _u0 = prepare_initial_state(u0)
    _tspan = promote_tspan(tspan)
    _f = ODEFunction{iip, DEFAULT_SPECIALIZATION}(f)
    return ImmutableODEProblem(_f, _u0, _tspan, p; kwargs...)
end

staticarray_itize(x) = x
staticarray_itize(x::Vector) = StaticArraysCore.SVector{length(x)}(x)
staticarray_itize(x::StaticArraysCore.SizedVector) = StaticArraysCore.SVector{length(x)}(x)
staticarray_itize(x::Matrix) = StaticArraysCore.SMatrix{size(x)...}(x)
staticarray_itize(x::StaticArraysCore.SizedMatrix) = StaticArraysCore.SMatrix{size(x)...}(x)

function Base.convert(::Type{ImmutableODEProblem}, prob::T) where {T <: ODEProblem}
    return ImmutableODEProblem(
        prob.f,
        staticarray_itize(prob.u0),
        prob.tspan,
        staticarray_itize(prob.p),
        prob.problem_type;
        prob.kwargs...
    )
end

module SciMLBaseDifferentiationInterfaceExt

using SciMLBase, DifferentiationInterface

import SciMLBase: anyeltypedual

# Opt out since these are using for preallocation, not differentiation
function anyeltypedual(
        x::DifferentiationInterface.Prep,
        ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return Any
end
function anyeltypedual(
        x::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        DifferentiationInterface.Prep,
    }
    return Any
end

end

"""
    $(TYPEDEF)

A collection of all the data required for custom ODE Nonlinear problem solving
"""
struct ODENLStepData{NLProb, SetU0, SetGammaC, SetOuterTmp, SetInnerTmp, NLProbMap}
    """
    The `AbstractNonlinearProblem` to define custom nonlinear problems to be used for
    implicit time discretizations. This allows to use extra structure of the ODE function (e.g.
    multi-level structure). The nonlinear function must match that form of the function implicit
    ODE integration algorithms need do solve the a nonlinear problems,
    specifically of the form `M*z = outer_tmp + γ₁⋅f(γ₂⋅z+inner_tmp,p,t_c)`.
    Here `z` is the stage solution vector, `p` is the parameter of the ODE problem, `t_c` is
    the time of evaluation (`t_c = t + c*dt`), `γ₁` and `γ₂` are some scaling factors determined
    by the solver algorithm and the temporary variables are some compatible vectors set by the specific solver.
    The inner nonlinear function of the nonlinear problem is in general of the form `g(z,p') = 0` such that
    `g(z,p') = γ₁⋅f(γ₂⋅z+inner_tmp,p,t_c) + outer_tmp - M*z = 0`.
    """
    nlprob::NLProb
    u0perm::SetU0
    set_γ_c::SetGammaC
    set_outer_tmp::SetOuterTmp
    set_inner_tmp::SetInnerTmp
    """
    A function which takes the solution of `nlprob` and returns
    the state vector of the original problem.
    """
    nlprobmap::NLProbMap
end

module SciMLBaseTrackerExt

using SciMLBase
import Tracker

SciMLBase.value(x::Type{Tracker.TrackedReal{T}}) where {T} = T
SciMLBase.value(x::Type{Tracker.TrackedArray{T, N, A}}) where {T, N, A} = Array{T, N}
SciMLBase.value(x::Tracker.TrackedReal) = x.data
SciMLBase.value(x::Tracker.TrackedArray) = x.data

SciMLBase.unitfulvalue(x::Type{Tracker.TrackedReal{T}}) where {T} = T
function SciMLBase.unitfulvalue(x::Type{Tracker.TrackedArray{T, N, A}}) where {T, N, A}
    return Array{T, N}
end
SciMLBase.unitfulvalue(x::Tracker.TrackedReal) = x.data
SciMLBase.unitfulvalue(x::Tracker.TrackedArray) = x.data

SciMLBase.promote_u0(u0::Tracker.TrackedArray, p::Tracker.TrackedArray, t0) = u0
function SciMLBase.promote_u0(
        u0::AbstractArray{<:Tracker.TrackedReal},
        p::Tracker.TrackedArray, t0
    )
    return u0
end
function SciMLBase.promote_u0(
        u0::Tracker.TrackedArray,
        p::AbstractArray{<:Tracker.TrackedReal}, t0
    )
    return u0
end
function SciMLBase.promote_u0(
        u0::AbstractArray{<:Tracker.TrackedReal},
        p::AbstractArray{<:Tracker.TrackedReal}, t0
    )
    return u0
end
SciMLBase.promote_u0(u0, p::Tracker.TrackedArray, t0) = Tracker.track(u0)
SciMLBase.promote_u0(u0, p::AbstractArray{<:Tracker.TrackedReal}, t0) = eltype(p).(u0)

@inline Base.any(f::Function, x::Tracker.TrackedArray) = any(f, Tracker.data(x))


end

"""
$(TYPEDEF)
"""
struct AnalyticalProblem{uType, tType, isinplace, P, F, K} <:
    AbstractAnalyticalProblem{uType, tType, isinplace}
    f::F
    u0::uType
    tspan::tType
    p::P
    kwargs::K
    @add_kwonly function AnalyticalProblem{iip}(
            f, u0, tspan, p = NullParameters();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan), iip, typeof(p),
            typeof(f), typeof(kwargs),
        }(
            f,
            _u0,
            _tspan,
            p,
            kwargs
        )
    end
end

function AnalyticalProblem(f, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 4)
    return AnalyticalProblem{iip}(f, u0, tspan, p; kwargs...)
end

export AnalyticalProblem, AbstractAnalyticalProblem

@doc doc"""
    AnalyticalAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_du0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving an AnalyticalProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.
    
### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the `u0` array.
* `alias_du0::Union{Bool, Nothing}`: alias the `du0` array for DAEs. Defaults to `false`.
* `alias_tstops::Union{Bool, Nothing}`: alias the `tstops` array
* `alias::Union{Bool, Nothing}`: sets all fields of the `AnalyticalAliasSpecifier` to `alias`

"""
struct AnalyticalAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_du0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}

    function AnalyticalAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_du0, alias_tstops)
        end
    end
end

### Concrete Types

"""
$(TYPEDEF)

Representation of the solution to an stochastic differential equation defined by an SDEProblem,
or of a random ordinary differential equation defined by an RODEProblem.

## DESolution Interface

For more information on interacting with `DESolution` types, check out the Solution Handling
page of the DifferentialEquations.jl documentation.

<https://docs.sciml.ai/DiffEqDocs/stable/basics/solution>

## Fields

  - `u`: the representation of the SDE or RODE solution. Given as an array of solutions, where `u[i]`
    corresponds to the solution at time `t[i]`. It is recommended in most cases one does not
    access `sol.u` directly and instead use the array interface described in the Solution
    Handling page of the DifferentialEquations.jl documentation.
  - `t`: the time points corresponding to the saved values of the ODE solution.
  - `W`: the representation of the saved noise process from the solution. See [the Noise Processes
    page of the DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/features/noise_process/).
    Note that this noise is only saved in full if `save_noise=true` in the solver.
  - `prob`: the original SDEProblem/RODEProblem that was solved.
  - `alg`: the algorithm type used by the solver.
  - `stats`: statistics of the solver, such as the number of function evaluations required,
    number of Jacobians computed, and more.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully, whether it terminated early due to a user-defined callback, or whether it
    exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
"""
struct RODESolution{
        T, N, uType, uType2, DType, tType, randType, discType, P, A, IType, S,
        AC <: Union{Nothing, Vector{Int}}, V,
    } <:
    AbstractRODESolution{T, N, uType}
    u::uType
    u_analytic::uType2
    errors::DType
    t::tType
    W::randType
    discretes::discType
    prob::P
    alg::A
    interp::IType
    dense::Bool
    tslocation::Int
    stats::S
    alg_choice::AC
    retcode::ReturnCode.T
    seed::UInt64
    saved_subsystem::V
end

function ConstructionBase.constructorof(::Type{O}) where {T, N, O <: RODESolution{T, N}}
    return RODESolution{T, N}
end

function ConstructionBase.setproperties(sol::RODESolution, patch::NamedTuple)
    u = get(patch, :u, sol.u)
    N = u === nothing ? 2 : ndims(eltype(u)) + 1
    T = eltype(eltype(u))
    patch = merge(getproperties(sol), patch)
    return RODESolution{
        T, N, typeof(patch.u), typeof(patch.u_analytic), typeof(patch.errors),
        typeof(patch.t), typeof(patch.W), typeof(patch.discretes),
        typeof(patch.prob), typeof(patch.alg), typeof(patch.interp),
        typeof(patch.stats), typeof(patch.alg_choice), typeof(patch.saved_subsystem),
    }(
        patch.u, patch.u_analytic, patch.errors, patch.t, patch.W, patch.discretes,
        patch.prob, patch.alg, patch.interp, patch.dense, patch.tslocation, patch.stats,
        patch.alg_choice, patch.retcode, patch.seed, patch.saved_subsystem
    )
end

Base.@propagate_inbounds function Base.getproperty(x::AbstractRODESolution, s::Symbol)
    if s === :destats
        Base.depwarn("`sol.destats` is deprecated. Use `sol.stats` instead.", "sol.destats")
        return getfield(x, :stats)
    elseif s === :ps
        return ParameterIndexingProxy(x)
    end
    return getfield(x, s)
end

function (sol::RODESolution)(
        t, ::Type{deriv} = Val{0}; idxs = nothing,
        continuity = :left
    ) where {deriv}
    return sol(t, deriv, idxs, continuity)
end
function (sol::RODESolution)(
        v, t, ::Type{deriv} = Val{0}; idxs = nothing,
        continuity = :left
    ) where {deriv}
    return sol.interp(v, t, idxs, deriv, sol.prob.p, continuity)
end

function build_solution(
        prob::Union{AbstractRODEProblem, AbstractSDDEProblem},
        alg, t, u; W = nothing, timeseries_errors = length(u) > 2,
        dense = false, dense_errors = dense, calculate_error = true,
        interp = LinearInterpolation(t, u),
        retcode = ReturnCode.Default,
        alg_choice = nothing,
        seed = UInt64(0), destats = missing, stats = nothing,
        saved_subsystem = nothing, kwargs...
    )
    T = eltype(eltype(u))
    if prob.u0 === nothing
        N = 2
    else
        N = ndims(eltype(u)) + 1
    end

    if prob.f isa Tuple
        f = prob.f[1]
    else
        f = prob.f
    end

    if !ismissing(destats)
        msg = "`destats` kwarg has been deprecated in favor of `stats`"
        if stats !== nothing
            msg *= " `stats` kwarg is also provided, ignoring `destats` kwarg."
        else
            stats = destats
        end
        Base.depwarn(msg, :build_solution)
    end

    ps = parameter_values(prob)
    if has_sys(prob.f)
        sswf = if saved_subsystem === nothing
            prob.f.sys
        else
            SavedSubsystemWithFallback(saved_subsystem, prob.f.sys)
        end
        discretes = create_parameter_timeseries_collection(sswf, ps, prob.tspan)
    else
        discretes = nothing
    end
    if has_analytic(f)
        u_analytic = Vector{typeof(prob.u0)}()
        errors = Dict{Symbol, real(eltype(prob.u0))}()
        sol = RODESolution{
            T, N, typeof(u), typeof(u_analytic), typeof(errors), typeof(t),
            typeof(W), typeof(discretes),
            typeof(prob), typeof(alg), typeof(interp), typeof(stats),
            typeof(alg_choice), typeof(saved_subsystem),
        }(
            u,
            u_analytic,
            errors,
            t, W,
            discretes,
            prob,
            alg,
            interp,
            dense,
            0,
            stats,
            alg_choice,
            retcode,
            seed,
            saved_subsystem
        )

        if calculate_error
            calculate_solution_errors!(
                sol; timeseries_errors = timeseries_errors,
                dense_errors = dense_errors
            )
        end

        return sol
    else
        return RODESolution{
            T, N, typeof(u), Nothing, Nothing, typeof(t),
            typeof(W), typeof(discretes), typeof(prob), typeof(alg), typeof(interp),
            typeof(stats), typeof(alg_choice), typeof(saved_subsystem),
        }(
            u, nothing, nothing, t, W, discretes,
            prob, alg, interp,
            dense, 0, stats,
            alg_choice, retcode, seed, saved_subsystem
        )
    end
end

function save_discretes!(sol::AbstractRODESolution, t, vals, timeseries_idx)
    RecursiveArrayTools.has_discretes(sol) || return
    disc = RecursiveArrayTools.get_discretes(sol)
    return _save_discretes_internal!(disc[timeseries_idx], t, vals)
end

function get_interpolated_discretes(sol::AbstractRODESolution, t, deriv, continuity)
    is_parameter_timeseries(sol) == Timeseries() || return nothing

    discs::ParameterTimeseriesCollection = RecursiveArrayTools.get_discretes(sol)
    interp_discs = map(discs) do partition
        hold_discrete(partition.u, partition.t, t)
    end
    return ParameterTimeseriesCollection(interp_discs, parameter_values(discs))
end

function SymbolicIndexingInterface.is_parameter_timeseries(::Type{S}) where {
        T1, T2, T3, T4, T5, T6, T7,
        S <: RODESolution{T1, T2, T3, T4, T5, T6, T7, <:ParameterTimeseriesCollection},
    }
    return Timeseries()
end

function calculate_solution_errors!(
        sol::AbstractRODESolution; fill_uanalytic = true,
        timeseries_errors = true, dense_errors = true
    )
    if sol.prob.f isa Tuple
        f = sol.prob.f[1]
    else
        f = sol.prob.f
    end

    if fill_uanalytic
        empty!(sol.u_analytic)
        if f isa RODEFunction && f.analytic_full == true
            f.analytic(sol)
        elseif sol.W isa AbstractDiffEqArray{T, N, nothing} where {T, N}
            for i in 1:length(sol)
                push!(
                    sol.u_analytic,
                    f.analytic(sol.prob.u0, sol.prob.p, sol.t[i], first(sol.W(sol.t[i])))
                )
            end
        else
            for i in 1:length(sol)
                push!(
                    sol.u_analytic,
                    f.analytic(sol.prob.u0, sol.prob.p, sol.t[i], sol.W[:, i])
                )
            end
        end
    end

    return if !isempty(sol.u_analytic)
        sol.errors[:final] = norm(recursive_mean(abs.(sol.u[end] - sol.u_analytic[end])))
        if timeseries_errors
            sol.errors[:l∞] = norm(
                maximum(
                    vecvecapply(
                        (x) -> abs.(x),
                        sol.u - sol.u_analytic
                    )
                )
            )
            sol.errors[:l2] = norm(
                sqrt(
                    recursive_mean(
                        vecvecapply(
                            (x) -> float.(x) .^ 2,
                            sol.u - sol.u_analytic
                        )
                    )
                )
            )
        end
        if dense_errors
            densetimes = collect(range(sol.t[1], stop = sol.t[end], length = 100))
            interp_u = sol(densetimes)
            interp_analytic = [
                f.analytic(sol.u[1], sol.prob.p, t, sol.W(t)[1])
                    for t in densetimes
            ]
            sol.errors[:L∞] = norm(
                maximum(
                    vecvecapply(
                        (x) -> abs.(x),
                        interp_u - interp_analytic
                    )
                )
            )
            sol.errors[:L2] = norm(
                sqrt(
                    recursive_mean(
                        vecvecapply(
                            (x) -> float.(x) .^ 2,
                            interp_u -
                                interp_analytic
                        )
                    )
                )
            )
        end
    end
end

function build_solution(sol::AbstractRODESolution, u_analytic, errors)
    @reset sol.u_analytic = u_analytic
    return @set sol.errors = errors
end

function solution_new_retcode(sol::AbstractRODESolution, retcode)
    return @set sol.retcode = retcode
end

function solution_new_tslocation(sol::AbstractRODESolution, tslocation)
    return @set sol.tslocation = tslocation
end

function solution_slice(sol::AbstractRODESolution{T, N}, I) where {T, N}
    @reset sol.u = sol.u[I]
    @reset sol.u_analytic = sol.u_analytic === nothing ? nothing : sol.u_analytic[I]
    @reset sol.t = sol.t[I]
    return @set sol.dense = false
end

function sensitivity_solution(sol::AbstractRODESolution, u, t)
    T = eltype(eltype(u))

    # handle save_idxs
    u0 = first(u)
    if u0 isa Number
        N = 1
    else
        N = length((size(u0)..., length(u)))
    end

    interp = enable_interpolation_sensitivitymode(sol.interp)
    @reset sol.u = u
    @reset sol.t = t isa Vector ? t : collect(t)
    return @set sol.interp = interp
end

using NonlinearSolve, Optimization, OptimizationNLopt, ForwardDiff

true_function(x, θ) = @. θ[1] * exp(θ[2] * x) * cos(θ[3] * x + θ[4])

θ_true = [1.0, 0.1, 2.0, 0.5]

x = [-1.0, -0.5, 0.0, 0.5, 1.0]

y_target = true_function(x, θ_true)

function loss_function(θ, p)
    ŷ = true_function(p, θ)
    return ŷ .- y_target
end

θ_init = θ_true .+ randn!(similar(θ_true)) * 0.1
prob_oop = NonlinearLeastSquaresProblem{false}(loss_function, θ_init, x)

solver = LevenbergMarquardt()

@time sol = solve(prob, solver; maxiters = 10000, abstol = 1.0e-8)

optf = OptimizationFunction(prob_oop.f, AutoForwardDiff())
optprob = OptimizationProblem(optf, prob_oop.u0, prob_oop.p)
@time sol = solve(optprob, NLopt.LD_LBFGS(); maxiters = 10000, abstol = 1.0e-8)

optprob = OptimizationProblem(prob_oop, AutoForwardDiff())
@time sol = solve(optprob, NLopt.LD_LBFGS(); maxiters = 10000, abstol = 1.0e-8)

@doc doc"""

Defines a stochastic delay differential equation (SDDE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/sdde_types/>

## Mathematical Specification of a Stochastic Delay Differential Equation (SDDE) Problem

To define a SDDE Problem, you simply need to give the drift function ``f``,
the diffusion function `g`, the initial condition ``u_0`` at time point ``t_0``,
and the history function ``h`` which together define a SDDE:

```math
\begin{align*}
du(t)  &= f(u,h,p,t) \, dt + g(u,h,p,t) \, dW_t & (t \geq t_0) \\
u(t_0) &= u_0, \\
u(t)   &= h(t) & (t < t_0).
\end{align*}
```

``f`` should be specified as `f(u, h, p, t)` (or in-place as `f(du, u, h, p, t)`)
(and ``g`` should match). ``u_0`` should be an AbstractArray (or number) whose
geometry matches the desired geometry of `u`, and ``h`` should be specified as
described below. The history function `h` is accessed for all delayed values.
Note that we are not limited to numbers or vectors for ``u_0``; one is allowed
to provide ``u_0`` as arbitrary matrices / higher dimension tensors as well.

Note that this functionality should be considered experimental.

## Functional Forms of the History Function

The history function `h` can be called in the following ways:

- `h(p, t)`: out-of-place calculation
- `h(out, p, t)`: in-place calculation
- `h(p, t, deriv::Type{Val{i}})`: out-of-place calculation of the `i`th derivative
- `h(out, p, t, deriv::Type{Val{i}})`: in-place calculation of the `i`th derivative
- `h(args...; idxs)`: calculation of `h(args...)` for indices `idxs`

Note that a dispatch for the supplied history function of matching form is required
for whichever function forms are used in the user derivative function `f`.

## Declaring Lags

Lags are declared separately from their use. One can use any lag by simply using
the interpolant of `h` at that point. However, one should use caution in order
to achieve the best accuracy. When lags are declared, the solvers can more
efficiently be more accurate and thus this is recommended.

## Neutral, Retarded, and Algebraic Stochastic Delay Differential Equations

Note that the history function specification can be used to specify general
retarded arguments, i.e. `h(p,α(u,t))`. Neutral delay differential equations
can be specified by using the `deriv` value in the history interpolation.
For example, `h(p,t-τ, Val{1})` returns the first derivative of the history
values at time `t-τ`.

Note that algebraic equations can be specified by using a singular mass matrix.

## Problem Type

### Constructors

```julia
SDDEProblem(f,g[, u0], h, tspan[, p]; <keyword arguments>)
SDDEProblem{isinplace,specialize}(f,g[, u0], h, tspan[, p]; <keyword arguments>)
```

`isinplace` optionally sets whether the function is inplace or not. This is
determined automatically, but not inferred. `specialize` optionally controls
the specialization level. See the [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
for more details. The default is `AutoSpecialize`.

For more details on the in-place and specialization controls, see the ODEFunction documentation.


Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the [DiffEqFunctions](@ref performance_overloads) page.

### Arguments

* `f`: The drift function in the SDDE.
* `g`: The diffusion function in the SDDE.
* `u0`: The initial condition. Defaults to the value `h(p, first(tspan))` of the history function evaluated at the initial time point.
* `h`: The history function for the DDE before `t0`.
* `tspan`: The timespan for the problem.
* `p`: The parameters with which function `f` is called. Defaults to `NullParameters`.
* `constant_lags`: A collection of constant lags used by the history function `h`. Defaults to `()`.
* `dependent_lags` A tuple of functions `(u, p, t) -> lag` for the state-dependent lags
  used by the history function `h`. Defaults to `()`.
* `neutral`: If the DDE is neutral, i.e., if delays appear in derivative terms.
* `order_discontinuity_t0`: The order of the discontinuity at the initial time
  point. Defaults to `0` if an initial condition `u0` is provided. Otherwise,
  it is forced to be greater or equal than `1`.
* `kwargs`: The keyword arguments passed onto the solves.
"""
struct SDDEProblem{uType, tType, lType, lType2, isinplace, P, NP, F, G, H, K, ND} <:
    AbstractSDDEProblem{uType, tType, lType, isinplace, ND}
    f::F
    g::G
    u0::uType
    h::H
    tspan::tType
    p::P
    noise::NP
    constant_lags::lType
    dependent_lags::lType2
    kwargs::K
    noise_rate_prototype::ND
    seed::UInt64
    neutral::Bool
    order_discontinuity_t0::Rational{Int}

    @add_kwonly function SDDEProblem{iip}(
            f::AbstractSDDEFunction{iip}, g, u0, h, tspan,
            p = NullParameters();
            noise_rate_prototype = nothing, noise = nothing,
            seed = UInt64(0),
            constant_lags = (), dependent_lags = (),
            neutral = f.mass_matrix !== I &&
                det(f.mass_matrix) != 1,
            order_discontinuity_t0 = 0 // 1,
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan), typeof(constant_lags), typeof(dependent_lags),
            isinplace(f),
            typeof(p), typeof(noise), typeof(f), typeof(g), typeof(h), typeof(kwargs),
            typeof(noise_rate_prototype),
        }(
            f, g, _u0, h, _tspan, p, noise, constant_lags,
            dependent_lags, kwargs, noise_rate_prototype,
            seed, neutral, order_discontinuity_t0
        )
    end

    function SDDEProblem{iip}(
            f::AbstractSDDEFunction{iip}, g, h, tspan::Tuple,
            p = NullParameters();
            order_discontinuity_t0 = 1 // 1, kwargs...
        ) where {iip}
        return SDDEProblem{iip}(
            f, g, h(p, first(tspan)), h, tspan, p;
            order_discontinuity_t0 = max(1 // 1, order_discontinuity_t0),
            kwargs...
        )
    end

    function SDDEProblem{iip}(f, g, args...; kwargs...) where {iip}
        return SDDEProblem{iip}(SDDEFunction{iip}(f, g), g, args...; kwargs...)
    end
end

function SDDEProblem(f, g, args...; kwargs...)
    return SDDEProblem(SDDEFunction(f, g), g, args...; kwargs...)
end

function SDDEProblem(f::AbstractSDDEFunction, args...; kwargs...)
    return SDDEProblem{isinplace(f)}(f, args...; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: SDDEProblem}
    return function ctor(
            f, g, u0, h, tspan, p, noise, constant_lags, dependent_lags, kw,
            noise_rate_prototype, seed, neutral, order_discontinuity_t0
        )
        if f isa AbstractSDDEFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 5)
        end
        return SDDEProblem{iip}(
            f, g, u0, h, tspan, p; kw..., noise, constant_lags, dependent_lags,
            noise_rate_prototype, seed, neutral, order_discontinuity_t0
        )
    end
end

SymbolicIndexingInterface.get_history_function(prob::AbstractSDDEProblem) = prob.h

@doc doc"""
    SDDEAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_du0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving an SDDEProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the `u0` array. Defaults to `false`.
* `alias_tstops::Union{Bool, Nothing}`: alias the `tstops` array
* `alias_jumps::Union{Bool, Nothing}`: alias jump process if wrapped in a `JumpProcess`
* `alias::Union{Bool, Nothing}`: sets all fields of the `SDDEAliasSpecifier` to `alias`

"""
struct SDDEAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}
    alias_jumps::Union{Bool, Nothing}

    function SDDEAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias_jumps = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_tstops, alias_jumps)
        end
    end
end

"""
$(TYPEDEF)
"""
abstract type BasicEnsembleAlgorithm <: EnsembleAlgorithm end

"""
$(TYPEDEF)

Basic ensemble solver which uses no parallelism and runs
the problems in serial
"""
struct EnsembleSerial <: BasicEnsembleAlgorithm end

"""
$(TYPEDEF)

The default. This uses multithreading. It's local (single computer, shared memory)
parallelism only. Lowest parallelism overhead for small problems.
"""
struct EnsembleThreads <: BasicEnsembleAlgorithm end

"""
$(TYPEDEF)

Uses `pmap` internally. It will use as many processors as you
have Julia processes. To add more processes, use `addprocs(n)`. These processes
can be placed onto multiple different machines in order to paralleize across
an entire cluster via passwordless SSH. See Julia's
documentation for more details.

Recommended for the case when each trajectory calculation isn't “too quick” (at least about
a millisecond each?), where the calculations of a given problem allocate memory, or when
you have a very large ensemble. This can be true even on a single shared memory system
because distributed process use separate garbage collectors and thus can be even faster
than EnsembleThreads if the computation is complex enough.
"""
struct EnsembleDistributed <: BasicEnsembleAlgorithm end

"""
$(TYPEDEF)

A mixture of distributed computing with threading. The optimal version of this is to have
a process on each node of a computer and then multithread on each system. However, this
ensembler will simply use the node setup provided by the Julia Distributed processes, and
thus it is recommended that you setup the processes in this fashion before using this
ensembler. See Julia's Distributed documentation for more information
"""
struct EnsembleSplitThreads <: BasicEnsembleAlgorithm end

function merge_stats(us)
    st = Iterators.filter(
        !isnothing, (hasproperty(x, :stats) ? x.stats : nothing for x in us)
    )
    isempty(st) && return nothing
    return reduce(merge, st)
end

mutable struct AggregateLogger{T <: Logging.AbstractLogger} <: Logging.AbstractLogger
    progress::Dict{Symbol, Float64}
    done_counter::Int
    total::Float64
    print_time::Float64
    lock::ReentrantLock
    logger::T
end
function AggregateLogger(logger::Logging.AbstractLogger)
    return AggregateLogger(Dict{Symbol, Float64}(), 0, 0.0, 0.0, ReentrantLock(), logger)
end

function Logging.handle_message(
        l::AggregateLogger, level, message, _module, group, id, file, line; kwargs...
    )
    if convert(Logging.LogLevel, level) == Logging.LogLevel(-1) && haskey(kwargs, :progress)
        pr = kwargs[:progress]
        if trylock(l.lock) || (pr == "done" && lock(l.lock) === nothing)
            try
                if pr == "done"
                    pr = 1.0
                    l.done_counter += 1
                end
                len = length(l.progress)
                if haskey(l.progress, id)
                    l.total += (pr - l.progress[id]) / len
                else
                    l.total = l.total * (len / (len + 1)) + pr / (len + 1)
                    len += 1
                end
                l.progress[id] = pr
                # validation check (slow)
                # tot = sum(values(l.progress))/length(l.progress)
                # @show tot l.total l.total ≈ tot
                curr_time = time()
                if l.done_counter >= len
                    tot = "done"
                    empty!(l.progress)
                    l.done_counter = 0
                    l.print_time = 0.0
                elseif curr_time - l.print_time > 0.1
                    tot = l.total
                    l.print_time = curr_time
                else
                    return
                end
                id = :total
                message = "Total"
                kwargs = merge(values(kwargs), (progress = tot,))
            finally
                unlock(l.lock)
            end
        else
            return
        end
    end
    return Logging.handle_message(
        l.logger, level, message, _module, group, id, file, line; kwargs...
    )
end
Logging.shouldlog(l::AggregateLogger, args...) = Logging.shouldlog(l.logger, args...)
Logging.min_enabled_level(l::AggregateLogger) = Logging.min_enabled_level(l.logger)
Logging.catch_exceptions(l::AggregateLogger) = Logging.catch_exceptions(l.logger)

function __solve(
        prob::AbstractEnsembleProblem,
        alg::Union{AbstractDEAlgorithm, Nothing};
        kwargs...
    )
    if alg isa EnsembleAlgorithm
        # Assume DifferentialEquations.jl is being used, so default alg
        ensemblealg = alg
        alg = nothing
    else
        ensemblealg = EnsembleThreads()
    end
    return __solve(prob, alg, ensemblealg; kwargs...)
end

@noinline function rerun_warn()
    return @warn("output_func should return (out,rerun). See docs for updated details")
end
tighten_container_eltype(u::Vector{Any}) = map(identity, u)
tighten_container_eltype(u) = u

function __solve(
        prob::EnsembleProblem{<:AbstractVector{<:AbstractSciMLProblem}},
        alg::Union{AbstractDEAlgorithm, Nothing},
        ensemblealg::BasicEnsembleAlgorithm; kwargs...
    )
    Base.depwarn(
        "This dispatch is deprecated for the standard ensemble syntax. See the Parallel
Ensembles Simulations Interface page for more details",
        :EnsembleProblemSolve
    )
    return invoke(
        __solve, Tuple{AbstractEnsembleProblem, typeof(alg), typeof(ensemblealg)},
        prob, alg, ensemblealg; trajectories = length(prob.prob), kwargs...
    )
end

"""
    sim = solve(enprob, alg, ensemblealg = EnsembleThreads(), kwargs...)

Solves the ensemble problem `enprob` with the algorithm `alg` using the ensembler
`ensemblealg`.

The keyword arguments take in the arguments for the common solver interface and will
pass them to the solver. The `ensemblealg` is optional, and will
default to `EnsembleThreads()`. The special keyword arguments to note are:

  - `trajectories`: The number of simulations to run. This argument is required.
  - `batch_size` : The size of the batches on which the reductions are applies. Defaults to `trajectories`.
  - `pmap_batch_size`: The size of the `pmap` batches. Default is
    `batch_size÷100 > 0 ? batch_size÷100 : 1`
"""
function __solve(
        prob::AbstractEnsembleProblem,
        alg::A,
        ensemblealg::BasicEnsembleAlgorithm;
        trajectories, batch_size = trajectories, progress_aggregate = true,
        pmap_batch_size = batch_size ÷ 100 > 0 ? batch_size ÷ 100 : 1, kwargs...
    ) where {A}
    logger = progress_aggregate ? AggregateLogger(Logging.current_logger()) :
        Logging.current_logger()

    return Logging.with_logger(logger) do
        num_batches = trajectories ÷ batch_size
        num_batches < 1 &&
            error("trajectories ÷ batch_size cannot be less than 1, got $num_batches")
        num_batches * batch_size != trajectories && (num_batches += 1)

        if get(kwargs, :progress, false)
            name = get(kwargs, :progress_name, "Ensemble")
            for i in 1:trajectories
                msg = "$name #$i"
                Logging.@logmsg(
                    Logging.LogLevel(-1), msg, _id = Symbol("SciMLBase_$i"),
                    progress = 0
                )
            end
        end

        if num_batches == 1 && prob.reduction === DEFAULT_REDUCTION
            elapsed_time = @elapsed u = solve_batch(
                prob, alg, ensemblealg, 1:trajectories,
                pmap_batch_size; kwargs...
            )
            _u = tighten_container_eltype(u)
            stats = merge_stats(_u)
            return EnsembleSolution(_u, elapsed_time, true, stats)
        end

        converged::Bool = false
        elapsed_time = @elapsed begin
            i = 1
            II = (batch_size * (i - 1) + 1):(batch_size * i)

            batch_data = solve_batch(prob, alg, ensemblealg, II, pmap_batch_size; kwargs...)

            u = prob.u_init === nothing ? similar(batch_data, 0) : prob.u_init
            u, converged = prob.reduction(u, batch_data, II)
            for i in 2:num_batches
                converged && break
                if i == num_batches
                    II = (batch_size * (i - 1) + 1):trajectories
                else
                    II = (batch_size * (i - 1) + 1):(batch_size * i)
                end
                batch_data = solve_batch(
                    prob, alg, ensemblealg, II, pmap_batch_size; kwargs...
                )
                u, converged = prob.reduction(u, batch_data, II)
            end
        end
        _u = tighten_container_eltype(u)
        stats = merge_stats(_u)
        return EnsembleSolution(_u, elapsed_time, converged, stats)
    end
end

function batch_func(i, prob, alg; kwargs...)
    iter = 1
    _prob = prob.safetycopy ? deepcopy(prob.prob) : prob.prob
    new_prob = prob.prob_func(_prob, i, iter)
    rerun = true

    progress = get(kwargs, :progress, false)
    if progress
        name = get(kwargs, :progress_name, "Ensemble")
        progress_name = "$name #$i"
        progress_id = Symbol("SciMLBase_$i")
        kwargs = (kwargs..., progress_name = progress_name, progress_id = progress_id)
    end
    x = prob.output_func(solve(new_prob, alg; kwargs...), i)
    if !(x isa Tuple)
        rerun_warn()
        _x = (x, false)
    else
        _x = x
    end
    rerun = _x[2]
    while rerun
        iter += 1
        _prob = prob.safetycopy ? deepcopy(prob.prob) : prob.prob
        new_prob = prob.prob_func(_prob, i, iter)
        x = prob.output_func(solve(new_prob, alg; kwargs...), i)
        if !(x isa Tuple)
            rerun_warn()
            _x = (x, false)
        else
            _x = x
        end
        rerun = _x[2]
    end
    return _x[1]
end

function solve_batch(
        prob, alg, ensemblealg::EnsembleDistributed, II, pmap_batch_size;
        kwargs...
    )
    wp = CachingPool(workers())

    # Fix the return type of pmap
    #=
    function f()
      batch_func(1,prob,alg;kwargs...)
    end
    T = Core.Compiler.return_type(f,Tuple{})
    =#

    batch_data = pmap(wp, II, batch_size = pmap_batch_size) do i
        batch_func(i, prob, alg; kwargs...)
    end

    return tighten_container_eltype(batch_data)
end

__getindex(x, i) = x[i]
__getindex(x::AbstractVectorOfArray, i) = x.u[i]

function responsible_map(f, II...)
    batch_data = Vector{
        Core.Compiler.return_type(
            f, Tuple{ntuple(i -> typeof(__getindex(II[i], 1)), Val(length(II)))...}
        ),
    }(
        undef,
        length(II[1])
    )
    for i in 1:length(II[1])
        batch_data[i] = f(ntuple(ii -> __getindex(II[ii], i), Val(length(II)))...)
    end
    return batch_data
end

function SciMLBase.solve_batch(prob, alg, ::EnsembleSerial, II, pmap_batch_size; kwargs...)
    batch_data = responsible_map(II) do i
        SciMLBase.batch_func(i, prob, alg; kwargs...)
    end
    return SciMLBase.tighten_container_eltype(batch_data)
end

function solve_batch(
        prob, alg, ensemblealg::EnsembleThreads, II, pmap_batch_size;
        kwargs...
    )
    nthreads = min(Threads.nthreads(), length(II))
    if length(II) == 1 || nthreads == 1
        return solve_batch(prob, alg, EnsembleSerial(), II, pmap_batch_size; kwargs...)
    end

    if prob.prob isa AbstractJumpProblem && length(II) != 1
        probs = [deepcopy(prob.prob) for i in 1:nthreads]
    else
        probs = prob.prob
    end

    batch_data = tmap(II) do i
        batch_func(i, prob, alg; kwargs...)
    end
    return tighten_container_eltype(batch_data)
end

function tmap(f, args...)
    batch_data = Vector{
        Core.Compiler.return_type(f, Tuple{typeof.(getindex.(args, 1))...}),
    }(
        undef,
        length(args[1])
    )
    Threads.@threads for i in 1:length(args[1])
        batch_data[i] = f(getindex.(args, i)...)
    end
    return batch_data
end

function solve_batch(prob, alg, ::EnsembleSplitThreads, II, pmap_batch_size; kwargs...)
    wp = CachingPool(workers())
    N = nworkers()
    batch_size = length(II) ÷ N

    # Fix the return type of pmap
    #=
    function f()
      i = 1
      I_local = II[(batch_size*(i-1)+1):end]
      solve_batch(prob,alg,EnsembleThreads(),I_local,pmap_batch_size;kwargs...)
    end
    T = Core.Compiler.return_type(f,Tuple{})
    =#

    batch_data = let
        pmap(wp, 1:N, batch_size = pmap_batch_size) do i
            if i == N
                I_local = II[(batch_size * (i - 1) + 1):end]
            else
                I_local = II[(batch_size * (i - 1) + 1):(batch_size * i)]
            end
            solve_batch(prob, alg, EnsembleThreads(), I_local, pmap_batch_size; kwargs...)
        end
    end
    return reduce(vcat, batch_data)
end

function solve(prob::EnsembleProblem, args...; kwargs...)
    if haskey(kwargs, :ensemblealg)
        throw(
            ArgumentError(
                "ensemblealg must be passed as a positional argument, not a keyword argument. " *
                    "Correct usage: solve(prob, alg, ensemblealg; kwargs...)"
            )
        )
    end

    alg = extract_alg(args, kwargs, kwargs)
    return if length(args) > 1
        __solve(prob, alg, Base.tail(args)...; kwargs...)
    else
        __solve(prob, alg; kwargs...)
    end
end

function solve(prob::SciMLBase.WeightedEnsembleProblem, args...; kwargs...)
    return WeightedEnsembleSolution(solve(prob.ensembleprob), prob.weights)
end

using SciMLBase, Test
using SciMLBase: should_warn_paramtype, warn_paramtype, WARN_PARAMTYPE_MESSAGE

@test should_warn_paramtype([]) == true
@test should_warn_paramtype(Float64[]) == false
@test should_warn_paramtype([1, "2"]) == true
@test should_warn_paramtype([1, 2.0]) == false
@test should_warn_paramtype(SciMLBase.NullParameters()) == false
@test should_warn_paramtype(nothing) == false
@test should_warn_paramtype(()) == false
@test should_warn_paramtype((1, "2")) == false
@test should_warn_paramtype(Dict(:a => 1, :b => "2")) == true
@test should_warn_paramtype(((1, 2.0), (3, "4"))) == false
@test should_warn_paramtype(([1, 2.0], [3, "4"])) == true
@test should_warn_paramtype([(1, 2.0), (3, "4")]) == true # uh oh
@test should_warn_paramtype([[1, 2.0], [3, "4"]]) == true

@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) warn_paramtype([1, "2"])
@test_logs warn_paramtype((1, "2"))
@test_logs warn_paramtype([1, 2])
@test_logs warn_paramtype([1, "2"], false)
@test_logs warn_paramtype((1, "2"), false)

# mock functions
f_2(a, b) = nothing
f_3(a, b, c) = nothing
f_4(a, b, c, d) = nothing

x = [0.0]
tspan = (0.0, 1.0)
p = [1, "2"]
# Test all Basic Problem types
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) AnalyticalProblem(f_4, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) LinearProblem(f_4, x, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) IntervalNonlinearProblem(f_2, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) NonlinearProblem(f_3, x, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) IntegralProblem(f_3, (x, x), p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) OptimizationProblem(f_2, x, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) BVProblem(f_4, f_4, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) DAEProblem(f_4, x, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) DDEProblem(f_4, f_4, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) DiscreteProblem(f_4, x, tspan, p)
#@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) ImplicitDiscreteProblem(f_3, x, tspan, p) # Base constructor is apparently broken?
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) ODEProblem(f_4, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) RODEProblem(f_4, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) SDDEProblem(f_4, f_4, x, f_2, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) SDEProblem(f_4, f_4, x, tspan, p)
@test_logs (:warn, WARN_PARAMTYPE_MESSAGE) SteadyStateProblem(f_4, x, p)

"""
$(TYPEDEF)

## Constructor

```julia
EnsembleProblem(prob::AbstractSciMLProblem;
    output_func = (sol, i) -> (sol, false),
    prob_func = (prob, i, repeat) -> (prob),
    reduction = (u, data, I) -> (append!(u, data), false),
    u_init = [], safetycopy = prob_func !== DEFAULT_PROB_FUNC)
```

## Positional Arguments

  - `prob`: The canonical problem of the ensemble problem. This is the prob that is seeded
    into each `prob_func` call to be used as the one that is manipulated/changed for each
    run of the ensemble.

## Keyword Arguments

  - `output_func`: The function determines what is saved from the solution to the
    output array. Defaults to saving the solution itself. The output is
    `(out,rerun)` where `out` is the output and `rerun` is a boolean which
    designates whether to rerun.
  - `prob_func`: The function by which the problem is to be modified. `prob`
    is the problem, `i` is the unique id `1:trajectories` for the problem, and
    `repeat` is the iteration of the repeat. At first, it is `1`, but if
    `rerun` was true this will be `2`, `3`, etc. counting the number of times
    problem `i` has been repeated.

  - `reduction`: This function is used to aggregate the results in each simulation batch. 
    By default, it appends the `data` from the batch to `u`, which is initialized via `u_data`. 
    The `I` is a range of indices corresponding to the trajectories for the current batch.
    ### Arguments:
        - `u`: The solution from the current ensemble run. This is the accumulated data that gets 
          updated in each batch.
        - `data`: The results from the current batch of simulations. This is typically some data 
          (e.g., variable values, time steps) that is merged with `u`.
        - `I`: A range of indices corresponding to the simulations in the current batch. This provides 
          the trajectory indices for the batch.

    ### Returns:
        - `(new_data, has_converged)`: A tuple where:
        - `new_data`: The updated accumulated data, typically the result of appending `data` to `u`.
        - `has_converged`: A boolean indicating whether the simulation has converged and should terminate early. 
          If `true`, the simulation will stop early. If `false`, the simulation will continue. By default, this is 
          `false`, meaning the simulation will not stop early.

  - `u_init`: The initial form of the object that gets updated in-place inside the
    `reduction` function.
  - `safetycopy`: Determines whether a safety `deepcopy` is called on the `prob`
    before the `prob_func`. By default, this is true for any user-given `prob_func`,
    as without this, modifying the arguments of something in the `prob_func`, such
    as parameters or caches stored within the user function, are not necessarily
    thread-safe. If you know that your function is thread-safe, then setting this
    to `false` can improve performance when used with threads. For nested problems,
    e.g., SDE problems with custom noise processes, `deepcopy` might be
    insufficient. In such cases, use a custom `prob_func`.

## `prob_func` Specification

One can specify a function `prob_func` which changes the problem. For example:

```julia
function prob_func(prob, i, repeat)
    @. prob.u0 = randn() * prob.u0
    prob
end
```

modifies the initial condition for all of the problems by a standard normal
random number (a different random number per simulation). Notice that since
problem types are immutable, it uses `.=`. Otherwise, one can just create
a new problem type:

```julia
function prob_func(prob, i, repeat)
    @. prob.u0 = u0_arr[i]
    prob
end
```

## `output_func` Specification

The `output_func` is a reduction function. Its arguments are the generated solution and the
unique index for the run. For example, if we wish to only save the 2nd coordinate
at the end of each solution, we can do:

```julia
output_func(sol, i) = (sol[end, 2], false)
```

Thus, the ensemble simulation would return as its data an array which is the
end value of the 2nd dependent variable for each of the runs.
"""

"""
$(TYPEDEF)

Defines a structure to manage an ensemble (batch) of problems.
Each field controls how the ensemble behaves during simulation.

## Arguments

  - `prob`: The original base problem to replicate or modify.
  - `prob_func`: A function that defines how to generate each subproblem.
  - `output_func`: A function to post-process each individual simulation result.
  - `reduction`: A function to combine results from all simulations.
  - `u_init`: The initial container used to accumulate the results.
  - `safetycopy`: Whether to copy the problem when creating subproblems (to avoid unintended modifications).
"""
struct EnsembleProblem{T, T2, T3, T4, T5} <: AbstractEnsembleProblem
    prob::T
    prob_func::T2
    output_func::T3
    reduction::T4
    u_init::T5
    safetycopy::Bool
end

"""
Returns the same problem without modification.
"""
DEFAULT_PROB_FUNC(prob, i, repeat) = prob

"""
Returns the solution as-is, along with `false` indicating no rerun.
"""
DEFAULT_OUTPUT_FUNC(sol, i) = (sol, false)

"""
Appends new data to the accumulated data and returns `false` to indicate no early termination.
"""
DEFAULT_REDUCTION(u, data, I) = append!(u, data), false

"""
Selects the i-th problem from a vector of problems.
"""
DEFAULT_VECTOR_PROB_FUNC(prob, i, repeat) = prob[i]

"""
$(TYPEDEF)

Constructor for deprecated usage where a vector of problems is passed directly.

!!! warning

    This constructor is deprecated. Use the standard ensemble syntax with `prob_func` instead.
"""
function EnsembleProblem(prob::AbstractVector{<:AbstractSciMLProblem}; kwargs...)
    Base.depwarn(
        "This dispatch is deprecated for the standard ensemble syntax. See the Parallel \
Ensembles Simulations Interface page for more details",
        :EnsembleProblem
    )
    return invoke(
        EnsembleProblem,
        Tuple{Any},
        prob;
        prob_func = DEFAULT_VECTOR_PROB_FUNC,
        kwargs...
    )
end

"""
$(TYPEDEF)

Main constructor for `EnsembleProblem`.

## Keyword Arguments

  - `prob`: The base problem.
  - `prob_func`: Function to modify the base problem per trajectory.
  - `output_func`: Function to extract output from a solution.
  - `reduction`: Function to aggregate results.
  - `u_init`: Initial value for aggregation.
  - `safetycopy`: Whether to deepcopy the problem before modifying.
"""
function EnsembleProblem(
        prob;
        prob_func = DEFAULT_PROB_FUNC,
        output_func = DEFAULT_OUTPUT_FUNC,
        reduction = DEFAULT_REDUCTION,
        u_init = nothing,
        safetycopy = prob_func !== DEFAULT_PROB_FUNC
    )
    _prob_func = prepare_function(prob_func)
    _output_func = prepare_function(output_func)
    _reduction = prepare_function(reduction)
    _u_init = prepare_initial_state(u_init)
    return EnsembleProblem(prob, _prob_func, _output_func, _reduction, _u_init, safetycopy)
end

"""
$(TYPEDEF)

Alternate constructor that uses only keyword arguments.
"""
function EnsembleProblem(;
        prob,
        prob_func = DEFAULT_PROB_FUNC,
        output_func = DEFAULT_OUTPUT_FUNC,
        reduction = DEFAULT_REDUCTION,
        u_init = nothing, p = nothing,
        safetycopy = prob_func !== DEFAULT_PROB_FUNC
    )
    return EnsembleProblem(prob; prob_func, output_func, reduction, u_init, safetycopy)
end

"""
$(TYPEDEF)

Constructor that is used for NOnlinearProblem.

!!! warning

    This dispatch is deprecated. See the Parallel Ensembles Simulations Interface page.
"""
function SciMLBase.EnsembleProblem(
        prob::AbstractSciMLProblem, u0s::Vector{Vector{T}}; kwargs...
    ) where {T}
    Base.depwarn(
        "This dispatch is deprecated for the standard ensemble syntax. See the Parallel \
Ensembles Simulations Interface page for more details",
        :EnsembleProblem
    )
    prob_func = (prob, i, repeat = nothing) -> remake(prob, u0 = u0s[i])
    return SciMLBase.EnsembleProblem(prob; prob_func, kwargs...)
end

"""
$(TYPEDEF)

Defines a weighted version of an `EnsembleProblem`, where different simulations contribute unequally.

## Arguments

  - `ensembleprob`: The base ensemble problem.
  - `weights`: A vector of weights corresponding to each simulation.
"""
struct WeightedEnsembleProblem{T1 <: AbstractEnsembleProblem, T2 <: AbstractVector} <:
    AbstractEnsembleProblem
    ensembleprob::T1
    weights::T2
end

"""
Returns a list of all accessible properties, including those from the inner ensemble and `:weights`.
"""
function Base.propertynames(e::WeightedEnsembleProblem)
    return (Base.propertynames(getfield(e, :ensembleprob))..., :weights)
end

"""
Accesses properties of a `WeightedEnsembleProblem`.

Returns `weights` or delegates to the underlying ensemble.
"""
function Base.getproperty(e::WeightedEnsembleProblem, f::Symbol)
    f === :weights && return getfield(e, :weights)
    f === :ensembleprob && return getfield(e, :ensembleprob)
    return getproperty(getfield(e, :ensembleprob), f)
end

"""
$(TYPEDEF)

Constructor for `WeightedEnsembleProblem`. Ensures weights sum to 1 and matches problem count.
"""
function WeightedEnsembleProblem(args...; weights, kwargs...)
    # TODO: allow skipping checks?
    @assert sum(weights) ≈ 1
    ep = EnsembleProblem(args...; kwargs...)
    @assert length(ep.prob) == length(weights)
    return WeightedEnsembleProblem(ep, weights)
end

@doc doc"""

Defines a discrete dynamical system problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/discrete_types/>

## Mathematical Specification of a ImplicitDiscrete Problem

To define an ImplicitDiscrete Problem, you simply need to give the function ``f`` and the initial
condition ``u_0`` which define a function map:

```math
f(u_{n+1}, u_n, p, t_{n+1}, \text{integ}) = 0
```

`f` should be specified as `f(un,p,t)` (or in-place as `f(unp1,un,p,t)`), and
`u_0` should be an AbstractArray (or number) whose geometry matches the desired
geometry of `u`.  Note that we are not limited to numbers or vectors for `u₀`;
one is allowed to provide `u₀` as arbitrary matrices / higher dimension tensors
as well. ``u_{n+1}`` only depends on the previous iteration ``u_{n}`` and
``t_{n+1}``. The default ``t_{n+1}`` is chosen adaptively, and when ``dt`` is
specified, we have ``t_n = t_0 + n*dt``. `integ` contains the fields:
```julia
dt: the time step
```

## Problem Type

### Constructors

- `ImplicitDiscreteProblem(f::ImplicitDiscreteFunction,u0,tspan,p=NullParameters();kwargs...)` :
  Defines the discrete problem with the specified functions.
- `ImplicitDiscreteProblem{isinplace,specialize}(f,u0,tspan,p=NullParameters();kwargs...)` :
  Defines the discrete problem with the specified functions.
- `ImplicitDiscreteProblem{isinplace,specialize}(u0,tspan,p=NullParameters();kwargs...)` :
  Defines the discrete problem with the identity map.

`isinplace` optionally sets whether the function is inplace or not. This is
determined automatically, but not inferred. `specialize` optionally controls
the specialization level. See the [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
for more details. The default is `AutoSpecialize`.

For more details on the in-place and specialization controls, see the ODEFunction
documentation.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the
[DiffEqFunctions](@ref performance_overloads)
page.

### Fields

* `f`: The function in the map.
* `u0`: The initial condition.
* `tspan`: The timespan for the problem.
* `p`: The parameters for the problem. Defaults to `NullParameters`
* `kwargs`: The keyword arguments passed onto the solves.

#### Note About Timing

Note that if no `dt` and not `tstops` is given, it's assumed that `dt=1` and thus
`tspan=(0,n)` will solve for `n` iterations. If in the solver `dt` is given, then
the number of iterations will change. And if `tstops` is not empty, the solver will
revert to the standard behavior of fixed timestep methods, which is "step to each
tstop".
"""
struct ImplicitDiscreteProblem{uType, tType, isinplace, P, F, K} <:
    AbstractDiscreteProblem{uType, tType, isinplace}
    """The function in the map."""
    f::F
    """The initial condition."""
    u0::uType
    """The timespan for the problem."""
    tspan::tType
    """The parameter values of the function."""
    p::P
    """A callback to be applied to every solver which uses the problem."""
    kwargs::K
    @add_kwonly function ImplicitDiscreteProblem{iip}(
            f::ImplicitDiscreteFunction{
                iip,
            },
            u0, tspan::Tuple,
            p = NullParameters();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan), isinplace(f, 5),
            typeof(p),
            typeof(f), typeof(kwargs),
        }(
            f,
            _u0,
            _tspan,
            p,
            kwargs
        )
    end

    function ImplicitDiscreteProblem{iip}(
            f, u0, tspan, p = NullParameters();
            kwargs...
        ) where {iip}
        return ImplicitDiscreteProblem(ImplicitDiscreteFunction{iip}(f), u0, tspan, p; kwargs...)
    end
end

"""
    ImplicitDiscreteProblem{isinplace}(f,u0,tspan,p=NullParameters(),callback=nothing)

Defines a discrete problem with the specified functions.
"""
function ImplicitDiscreteProblem(
        f::ImplicitDiscreteFunction, u0, tspan::Tuple,
        p = NullParameters(); kwargs...
    )
    return ImplicitDiscreteProblem{isinplace(f, 5)}(f, u0, tspan, p; kwargs...)
end

function ImplicitDiscreteProblem(
        f, u0, tspan, p = NullParameters();
        kwargs...
    )
    iip = isinplace(f, 5)
    return ImplicitDiscreteProblem(ImplicitDiscreteFunction{iip}(f), u0, tspan, p; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: ImplicitDiscreteProblem}
    return function ctor(f, u0, tspan, p, kw)
        if f isa AbstractDiscreteFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 5)
        end
        return ImplicitDiscreteProblem{iip}(f, u0, tspan, p; kw...)
    end
end

@doc doc"""
    ImplicitDiscreteAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias = nothing)

Holds information on what variables to alias
when solving an ODE. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false .
* `alias::Union{Bool, Nothing}`: sets all fields of the `ImplicitDiscreteAliasSpecifier` to `alias`

"""
struct ImplicitDiscreteAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}

    function ImplicitDiscreteAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true)
        elseif alias == false
            new(false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0)
        end
    end
end

using ModelingToolkit, OrdinaryDiffEq, Tables, Test
using ModelingToolkit: t_nounits as t, D_nounits as D

@variables x(t) y(t)
@parameters p q
@mtkcompile sys = System(
    [D(x) ~ p * x + q * y, 0 ~ y^2 - 2x * y - 4], t, guesses = [y => 1.0]
)
prob = ODEProblem(sys, [x => 1.0, p => 1.0, q => 2.0], (0.0, 5.0))
sol = solve(prob, Rodas5P())

@test sort(collect(Tables.columnnames(Tables.columns(sol)))) ==
    [:timestamp, Symbol("x(t)"), Symbol("y(t)")]

module EnsembleAnalysis

using SciMLBase, Statistics, RecursiveArrayTools, StaticArraysCore
using DocStringExtensions

# Getters
"""
$(SIGNATURES)

Returns an iterator of each simulation at time step i
"""
get_timestep(sim, i) = (sol.u[i] for sol in sim)

"""
$(SIGNATURES)

Returns an iterator of each simulation at time point t
"""
get_timepoint(sim, t) = (sol(t) for sol in sim)

"""
$(SIGNATURES)

Returns a vector of each simulation at time step i
"""
function componentwise_vectors_timestep(sim, i)
    arr = [get_timestep(sim, i)...]
    if arr[1] isa AbstractArray
        return vecarr_to_vectors(VectorOfArray(arr))
    else
        return arr
    end
end

"""
$(SIGNATURES)

Returns a vector of each simulation at time point t
"""
function componentwise_vectors_timepoint(sim, t)
    arr = [get_timepoint(sim, t)...]
    if arr[1] isa AbstractArray
        return vecarr_to_vectors(VectorOfArray(arr))
    else
        return arr
    end
end

# Timestep statistics
"""
$(SIGNATURES)

Computes the mean of each component at time step i
"""
timestep_mean(sim, i) = componentwise_mean(get_timestep(sim, i))
timestep_mean(sim, ::Colon) = timeseries_steps_mean(sim)

"""
$(SIGNATURES)

Computes the median of each component at time step i
"""
function timestep_median(sim, i)
    arr = componentwise_vectors_timestep(sim, i)
    if typeof(first(arr)) <: AbstractArray
        return reshape([median(x) for x in arr], size(sim.u[1].u[i])...)
    else
        return median(arr)
    end
end
timestep_median(sim, ::Colon) = timeseries_steps_median(sim)

"""
$(SIGNATURES)

Computes the quantile q of each component at time step i
"""
function timestep_quantile(sim, q, i)
    arr = componentwise_vectors_timestep(sim, i)
    if typeof(first(arr)) <: AbstractArray
        return reshape([quantile(x, q) for x in arr], size(sim.u[1].u[i])...)
    else
        return quantile(arr, q)
    end
end
timestep_quantile(sim, q, ::Colon) = timeseries_steps_quantile(sim, q)

"""
$(SIGNATURES)

Computes the mean and variance of each component at time step i
"""
timestep_meanvar(sim, i) = componentwise_meanvar(get_timestep(sim, i))
timestep_meanvar(sim, ::Colon) = timeseries_steps_meanvar(sim)

"""
$(SIGNATURES)

Computes the mean at i and j, and the covariance, for each component
"""
function timestep_meancov(sim, i, j)
    return componentwise_meancov(get_timestep(sim, i), get_timestep(sim, j))
end
timestep_meancov(sim, ::Colon, ::Colon) = timeseries_steps_meancov(sim)

"""
$(SIGNATURES)

Computes the mean at i and j, and the correlation, for each component
"""
function timestep_meancor(sim, i, j)
    return componentwise_meancor(get_timestep(sim, i), get_timestep(sim, j))
end
timestep_meancor(sim, ::Colon, ::Colon) = timeseries_steps_meancor(sim)

"""
$(SIGNATURES)

Computes the mean at i and j, and the weighted covariance W, for each component
"""
function timestep_weighted_meancov(sim, W, i, j)
    return componentwise_weighted_meancov(get_timestep(sim, i), get_timestep(sim, j), W)
end
function timestep_weighted_meancov(sim, W, ::Colon, ::Colon)
    return timeseries_steps_weighted_meancov(sim, W)
end

"""
$(SIGNATURES)

Computes the mean at each time step
"""
function timeseries_steps_mean(sim)
    return DiffEqArray([timestep_mean(sim, i) for i in 1:length(sim.u[1])], sim.u[1].t)
end

"""
$(SIGNATURES)

Computes the median at each time step
"""
function timeseries_steps_median(sim)
    return DiffEqArray([timestep_median(sim, i) for i in 1:length(sim.u[1])], sim.u[1].t)
end

"""
$(SIGNATURES)

Computes the quantile q at each time step
"""
function timeseries_steps_quantile(sim, q)
    return DiffEqArray([timestep_quantile(sim, q, i) for i in 1:length(sim.u[1])], sim.u[1].t)
end

"""
$(SIGNATURES)

Computes the mean and variance at each time step
"""
function timeseries_steps_meanvar(sim)
    m, v = timestep_meanvar(sim, 1)
    means = [m]
    vars = [v]
    for i in 2:length(sim.u[1])
        m, v = timestep_meanvar(sim, i)
        push!(means, m)
        push!(vars, v)
    end
    return DiffEqArray(means, sim.u[1].t), DiffEqArray(vars, sim.u[1].t)
end

"""
$(SIGNATURES)

Computes the covariance matrix and means at each time step
"""
function timeseries_steps_meancov(sim)
    return reshape(
        [
            timestep_meancov(sim, i, j) for i in 1:length(sim.u[1])
                for j in 1:length(sim.u[1])
        ],
        length(sim.u[1]),
        length(sim.u[1])
    )
end

"""
$(SIGNATURES)

Computes the correlation matrix and means at each time step
"""
function timeseries_steps_meancor(sim)
    return reshape(
        [
            timestep_meancor(sim, i, j) for i in 1:length(sim.u[1])
                for j in 1:length(sim.u[1])
        ],
        length(sim.u[1]),
        length(sim.u[1])
    )
end

"""
$(SIGNATURES)

Computes the weighted covariance matrix and means at each time step
"""
function timeseries_steps_weighted_meancov(sim, W)
    return reshape(
        [
            timestep_meancov(sim, W, i, j) for i in 1:length(sim.u[1])
                for j in 1:length(sim.u[1])
        ],
        length(sim.u[1]),
        length(sim.u[1])
    )
end

"""
$(SIGNATURES)

Computes the mean of each component at time t
"""
timepoint_mean(sim, t) = componentwise_mean(get_timepoint(sim, t))

"""
$(SIGNATURES)

Computes the median of each component at time t
"""
function timepoint_median(sim, t)
    arr = componentwise_vectors_timepoint(sim, t)
    if typeof(first(arr)) <: AbstractArray
        return reshape([median(x) for x in arr], size(sim.u[1].u[1])...)
    else
        return median(arr)
    end
end

"""
$(SIGNATURES)

Computes the quantile q of each component at time t
"""
function timepoint_quantile(sim, q, t)
    arr = componentwise_vectors_timepoint(sim, t)
    if typeof(first(arr)) <: AbstractArray
        return reshape([quantile(x, q) for x in arr], size(sim.u[1].u[1])...)
    else
        return quantile(arr, q)
    end
end

"""
$(SIGNATURES)

Computes the mean and variance of each component at time t
"""
timepoint_meanvar(sim, t) = componentwise_meanvar(get_timepoint(sim, t))

"""
$(SIGNATURES)

Computes the mean at t1 and t2, the covariance, for each component
"""
function timepoint_meancov(sim, t1, t2)
    return componentwise_meancov(get_timepoint(sim, t1), get_timepoint(sim, t2))
end

"""
$(SIGNATURES)

Computes the mean at t1 and t2, the correlation, for each component
"""
function timepoint_meancor(sim, t1, t2)
    return componentwise_meancor(get_timepoint(sim, t1), get_timepoint(sim, t2))
end

"""
$(SIGNATURES)

Computes the mean at t1 and t2, the weighted covariance W, for each component
"""
function timepoint_weighted_meancov(sim, W, t1, t2)
    return componentwise_weighted_meancov(get_timepoint(sim, t1), get_timepoint(sim, t2), W)
end

function SciMLBase.EnsembleSummary(
        sim::SciMLBase.AbstractEnsembleSolution{T, N},
        t = sim.u[1].t; quantiles = [0.05, 0.95]
    ) where {T, N}
    if sim.u[1] isa SciMLSolution
        m, v = timeseries_point_meanvar(sim, t)
        med = timeseries_point_median(sim, t)
        qlow = timeseries_point_quantile(sim, quantiles[1], t)
        qhigh = timeseries_point_quantile(sim, quantiles[2], t)
    else
        m, v = timeseries_steps_meanvar(sim)
        med = timeseries_steps_median(sim)
        qlow = timeseries_steps_quantile(sim, quantiles[1])
        qhigh = timeseries_steps_quantile(sim, quantiles[2])
    end

    trajectories = length(sim)
    return EnsembleSummary{
        T, N, typeof(t), typeof(m), typeof(v), typeof(med), typeof(qlow),
        typeof(qhigh),
    }(
        t, m, v, med, qlow, qhigh, trajectories, sim.elapsedTime,
        sim.converged
    )
end

"""
$(SIGNATURES)

Computes the mean at each time point in ts
"""
function timeseries_point_mean(sim, ts)
    return DiffEqArray([timepoint_mean(sim, t) for t in ts], ts)
end

"""
$(SIGNATURES)

Computes the median at each time point in ts
"""
function timeseries_point_median(sim, ts)
    return DiffEqArray([timepoint_median(sim, t) for t in ts], ts)
end

"""
$(SIGNATURES)

Computes the quantile q at each time point in ts
"""
function timeseries_point_quantile(sim, q, ts)
    return DiffEqArray([timepoint_quantile(sim, q, t) for t in ts], ts)
end

"""
$(SIGNATURES)

Computes the mean and variance at each time point in ts
"""
function timeseries_point_meanvar(sim, ts)
    m, v = timepoint_meanvar(sim, first(ts))
    means = [m]
    vars = [v]
    for t in Iterators.drop(ts, 1)
        m, v = timepoint_meanvar(sim, t)
        push!(means, m)
        push!(vars, v)
    end
    return DiffEqArray(means, ts), DiffEqArray(vars, ts)
end

"""
$(SIGNATURES)

Computes the covariance matrix and means at each time point in ts
"""
function timeseries_point_meancov(sim, ts)
    return timeseries_point_meancov(sim, ts[1:(end - 1)], ts[2:end])
end

"""
$(SIGNATURES)
"""
function timeseries_point_meancov(sim, ts1, ts2)
    return reshape(
        [timepoint_meancov(sim, t1, t2) for t1 in ts1 for t2 in ts2], length(ts1),
        length(ts2)
    )
end

"""
$(SIGNATURES)

Computes the correlation matrix and means at each time point in ts
"""
function timeseries_point_meancor(sim, ts)
    return timeseries_point_meancor(sim, ts[1:(end - 1)], ts[2:end])
end

"""
$(SIGNATURES)
"""
function timeseries_point_meancor(sim, ts1, ts2)
    return reshape(
        [timepoint_meancor(sim, t1, t2) for t1 in ts1 for t2 in ts2], length(ts1),
        length(ts2)
    )
end

"""
$(SIGNATURES)

Computes the weighted covariance matrix and means at each time point in ts
"""
function timeseries_point_weighted_meancov(sim, W, ts)
    return timeseries_point_weighted_meancov(sim, W, ts[1:(end - 1)], ts[2:end])
end

"""
$(SIGNATURES)
"""
function timeseries_point_weighted_meancov(sim, W, ts1, ts2)
    return reshape(
        [timepoint_meancov(sim, W, t1, t2) for t1 in ts1 for t2 in ts2], length(ts1),
        length(ts2)
    )
end

function componentwise_mean(A)
    x0 = first(A)
    n = 0
    mean = zero(x0) ./ 1
    for x in A
        n += 1
        if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
            mean .+= x
        else
            mean += x
        end
    end
    if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
        mean ./= n
    else
        mean /= n
    end
    return mean
end

# Welford algorithm
# https://en.wikipedia.org/wiki/Algorithms_for_calculating_variance
function componentwise_meanvar(A; bessel = true)
    x0 = first(A)
    n = 0
    mean = zero(x0) ./ 1
    M2 = zero(x0) ./ 1
    delta = zero(x0) ./ 1
    delta2 = zero(x0) ./ 1
    for x in A
        n += 1
        if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
            delta .= x .- mean
            mean .+= delta ./ n
            delta2 .= x .- mean
            M2 .+= delta .* delta2
        else
            delta = x .- mean
            mean += delta ./ n
            delta2 = x .- mean
            M2 += delta .* delta2
        end
    end
    if n < 2
        return NaN
    else
        if bessel
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                M2 .= M2 ./ (n .- 1)
            else
                M2 = M2 ./ (n .- 1)
            end
        else
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                M2 .= M2 ./ n
            else
                M2 = M2 ./ n
            end
        end
        return mean, M2
    end
end

function componentwise_meancov(A, B; bessel = true)
    x0 = first(A)
    y0 = first(B)
    n = 0
    meanx = zero(x0) ./ 1
    meany = zero(y0) ./ 1
    C = zero(x0) ./ 1
    dx = zero(x0) ./ 1
    for (x, y) in zip(A, B)
        n += 1
        if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
            dx .= x .- meanx
            meanx .+= dx ./ n
            meany .+= (y .- meany) ./ n
            C .+= dx .* (y .- meany)
        else
            dx = x .- meanx
            meanx += dx ./ n
            meany += (y .- meany) ./ n
            C += dx .* (y .- meany)
        end
    end
    if n < 2
        return NaN
    else
        if bessel
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                C .= C ./ (n .- 1)
            else
                C = C ./ (n .- 1)
            end
        else
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                C .= C ./ n
            else
                C = C ./ n
            end
        end
        return meanx, meany, C
    end
end

function componentwise_meancor(A, B; bessel = true)
    mx, my, cov = componentwise_meancov(A, B; bessel = bessel)
    mx, vx = componentwise_meanvar(A; bessel = bessel)
    my, vy = componentwise_meanvar(B; bessel = bessel)
    if vx isa AbstractArray
        vx .= sqrt.(vx)
        vy .= sqrt.(vy)
    else
        vx = sqrt.(vx)
        vy = sqrt.(vy)
    end
    return mx, my, cov ./ (vx .* vy)
end

function componentwise_weighted_meancov(A, B, W; weight_type = :reliability)
    x0 = first(A)
    y0 = first(B)
    w0 = first(W)
    n = 0
    meanx = zero(x0) ./ 1
    meany = zero(y0) ./ 1
    wsum = zero(w0)
    wsum2 = zero(w0)
    C = zero(x0) ./ 1
    dx = zero(x0) ./ 1
    for (x, y, w) in zip(A, B, W)
        n += 1
        if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
            wsum .+= w
            wsum2 .+= w .* w
            dx .= x .- meanx
            meanx .+= (w ./ wsum) .* dx
            meany .+= (w ./ wsum) .* (y .- meany)
            C .+= w .* dx .* (y .- meany)
        else
            wsum += w
            wsum2 += w .* w
            dx = x .- meanx
            meanx += (w ./ wsum) .* dx
            meany += (w ./ wsum) .* (y .- meany)
            C += w .* dx .* (y .- meany)
        end
    end
    if n < 2
        return NaN
    else
        if weight_type == :population
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                C .= C ./ wsum
            else
                C = C ./ wsum
            end
        elseif weight_type == :reliability
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                C .= C ./ (wsum .- wsum2 ./ wsum)
            else
                C = C ./ (wsum .- wsum2 ./ wsum)
            end
        elseif weight_type == :frequency
            if x0 isa AbstractArray && !(x0 isa StaticArraysCore.SArray)
                C .= C ./ (wsum .- 1)
            else
                C = C ./ (wsum .- 1)
            end
        else
            error("The weight_type which was chosen is not allowed.")
        end
        return meanx, meany, C
    end
end

export get_timestep,
    get_timepoint,
    componentwise_vectors_timestep, componentwise_vectors_timepoint

export componentwise_mean, componentwise_meanvar

export timestep_mean, timestep_median, timestep_quantile, timestep_meanvar,
    timestep_meancov, timestep_meancor, timestep_weighted_meancov

export timeseries_steps_mean, timeseries_steps_median, timeseries_steps_quantile,
    timeseries_steps_meanvar, timeseries_steps_meancov,
    timeseries_steps_meancor, timeseries_steps_weighted_meancov

export timepoint_mean, timepoint_median, timepoint_quantile,
    timepoint_meanvar, timepoint_meancov,
    timepoint_meancor, timepoint_weighted_meancov

export timeseries_point_mean, timeseries_point_median, timeseries_point_quantile,
    timeseries_point_meanvar, timeseries_point_meancov,
    timeseries_point_meancor, timeseries_point_weighted_meancov

end

using SciMLBase, Tables, Test
using OrdinaryDiffEq, DataFrames, SymbolicIndexingInterface

# https://github.com/SciML/SciMLBase.jl/pull/813#issuecomment-2401803039
@test !Tables.isrowtable(ODESolution)
@test !Tables.isrowtable(RODESolution)
@test !Tables.isrowtable(DAESolution)
@test !Tables.isrowtable(SciMLBase.NonlinearSolution)
@test !Tables.isrowtable(SciMLBase.LinearSolution)
@test !Tables.isrowtable(SciMLBase.QuadratureSolution)
@test !Tables.isrowtable(SciMLBase.OptimizationSolution)

function rhs(u, p, t)
    return -u
end
sys = SymbolCache([:x], Symbol[], :t)
prob = ODEProblem(ODEFunction(rhs; sys), [1.0], (0.0, 1.0))
sol = solve(prob, Tsit5())
df = DataFrame(sol)
@test size(df) == (length(sol.u), 2)
@test df.timestamp == sol.t
@test df.x == sol[:x]

using Test, SciMLBase

@testset "getindex" begin
    u = rand(1)
    @test SciMLBase.build_linear_solution(nothing, u, zeros(1), nothing)[] == u[]
end

@testset "plot ODE solution" begin
    f = ODEFunction((u, p, t) -> -u, analytic = (u0, p, t) -> u0 * exp(-t))
    ode = ODEProblem(f, 1.0, (0.0, 1.0))
    sol = SciMLBase.build_solution(ode, :NoAlgorithm, [ode.tspan[begin]], [ode.u0])
    for t in Iterators.drop(range(ode.tspan..., length = 5), 1)
        push!(sol.t, t)
        push!(sol.u, ode.u0)
    end

    int_vars = SciMLBase.interpret_vars(nothing, sol) # nothing = idxs
    plot_vecs,
        labels = SciMLBase.diffeq_to_arrays(
        sol,
        true, # plot_analytic
        true, # denseplot
        10, # plotdensity
        ode.tspan,
        int_vars,
        :identity,
        nothing
    ) # tscale
    @test plot_vecs[2][:, 2] ≈ @. exp(-plot_vecs[1][:, 2])
end

@testset "interpolate empty ODE solution" begin
    f = (u, p, t) -> -u
    ode = ODEProblem(f, 1.0, (0.0, 1.0))
    sol = SciMLBase.build_solution(ode, :NoAlgorithm, [ode.tspan[begin]], [ode.u0])
    @test sol(0.0) == 1.0
    @test sol([0.0, 0.0]) == [1.0, 1.0]
    # test that indexing out of bounds doesn't segfault
    @test_throws ErrorException sol(1)
    @test_throws ErrorException sol(-0.5)
    @test_throws ErrorException sol([0, -0.5, 0])
end

@testset "interpolate with empty idxs" begin
    f = (u, p, t) -> u
    sol1 = SciMLBase.build_solution(
        ODEProblem(f, 1.0, (0.0, 1.0)), :NoAlgorithm, 0.0:0.1:1.0, exp.(0.0:0.1:1.0)
    )
    sol2 = SciMLBase.build_solution(
        ODEProblem(f, [1.0, 2.0], (0.0, 1.0)), :NoAlgorithm,
        0.0:0.1:1.0, vcat.(exp.(0.0:0.1:1.0), 2exp.(0.0:0.1:1.0))
    )
    for sol in [sol1, sol2]
        @test sol(0.15; idxs = []) == Float64[]
        @test sol(0.15; idxs = Int[]) == Float64[]
        @test sol([0.15, 0.25]; idxs = []) == [Float64[], Float64[]]
        @test sol([0.15, 0.25]; idxs = Int[]) == [Float64[], Float64[]]
    end
end

const allowedkeywords = (
    :dense,
    :saveat,
    :save_idxs,
    :save_discretes,
    :tstops,
    :tspan,
    :d_discontinuities,
    :save_everystep,
    :save_on,
    :save_start,
    :save_end,
    :initialize_save,
    :adaptive,
    :abstol,
    :reltol,
    :dt,
    :dtmax,
    :dtmin,
    :force_dtmin,
    :internalnorm,
    :controller,
    :gamma,
    :beta1,
    :beta2,
    :qmax,
    :qmin,
    :qsteady_min,
    :qsteady_max,
    :qoldinit,
    :failfactor,
    :calck,
    :alias_u0,
    :maxiters,
    :maxtime,
    :callback,
    :isoutofdomain,
    :unstable_check,
    :verbose,
    :merge_callbacks,
    :progress,
    :progress_steps,
    :progress_name,
    :progress_message,
    :progress_id,
    :timeseries_errors,
    :dense_errors,
    :weak_timeseries_errors,
    :weak_dense_errors,
    :wrap,
    :calculate_error,
    :initializealg,
    :alg,
    :save_noise,
    :delta,
    :seed,
    :rng,
    :alg_hints,
    :kwargshandle,
    :trajectories,
    :batch_size,
    :sensealg,
    :advance_to_tstop,
    :stop_at_next_tstop,
    :u0,
    :p,
    # These two are from the default algorithm handling
    :default_set,
    :second_time,
    # This is for DiffEqDevTools
    :prob_choice,
    # Jump problems
    :alias_jump,
    # This is for copying/deepcopying noise in StochasticDiffEq
    :alias_noise,
    # This is for SimpleNonlinearSolve handling for batched Nonlinear Solves
    :batch,
    # Shooting method in BVP needs to differentiate between these two categories
    :nlsolve_kwargs,
    :odesolve_kwargs,
    # If Solvers which internally use linsolve
    :linsolve_kwargs,
    # Solvers internally using EnsembleProblem
    :ensemblealg,
    # Fine Grained Control of Tracing (Storing and Logging) during Solve
    :show_trace,
    :trace_level,
    :store_trace,
    # Termination condition for solvers
    :termination_condition,
    # For AbstractAliasSpecifier
    :alias,
    # Parameter estimation with BVP
    :tune_parameters,
)


const KWARGWARN_MESSAGE = """
Unrecognized keyword arguments found.
The only allowed keyword arguments to `solve` are:
$allowedkeywords

See <https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts> for more details.

Set kwargshandle=KeywordArgError for an error message.
Set kwargshandle=KeywordArgSilent to ignore this message.
"""

const KWARGERROR_MESSAGE = """
Unrecognized keyword arguments found.
The only allowed keyword arguments to `solve` are:
$allowedkeywords

See <https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts> for more details.
"""

struct CommonKwargError <: Exception
    kwargs::Any
end

function Base.showerror(io::IO, e::CommonKwargError)
    println(io, KWARGERROR_MESSAGE)
    notin = collect(map(x -> x ∉ allowedkeywords, keys(e.kwargs)))
    unrecognized = collect(keys(e.kwargs))[notin]
    print(io, "Unrecognized keyword arguments: ")
    return printstyled(io, unrecognized; bold = true, color = :red)
end

@enum KeywordArgError KeywordArgWarn KeywordArgSilent

const INCOMPATIBLE_U0_MESSAGE = """
Initial condition incompatible with functional form.
Detected an in-place function with an initial condition of type Number or SArray.
This is incompatible because Numbers cannot be mutated, i.e.
`x = 2.0; y = 2.0; x .= y` will error.

If using a immutable initial condition type, please use the out-of-place form.
I.e. define the function `du=f(u,p,t)` instead of attempting to "mutate" the immutable `du`.

If your differential equation function was defined with multiple dispatches and one is
in-place, then the automatic detection will choose in-place. In this case, override the
choice in the problem constructor, i.e. `ODEProblem{false}(f,u0,tspan,p,kwargs...)`.

For a longer discussion on mutability vs immutability and in-place vs out-of-place, see:
<https://docs.sciml.ai/DiffEqDocs/stable/tutorials/faster_ode_example#Example-Accelerating-a-Non-Stiff-Equation:-The-Lorenz-Equation>
"""

struct IncompatibleInitialConditionError <: Exception end

function Base.showerror(io::IO, e::IncompatibleInitialConditionError)
    return print(io, INCOMPATIBLE_U0_MESSAGE)
end

const NO_DEFAULT_ALGORITHM_MESSAGE = """
Default algorithm choices require DifferentialEquations.jl.
Please specify an algorithm (e.g., `solve(prob, Tsit5())` or
`init(prob, Tsit5())` for an ODE) or import DifferentialEquations
directly.

You can find the list of available solvers at <https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve>
and its associated pages.
"""

struct NoDefaultAlgorithmError <: Exception end

function Base.showerror(io::IO, e::NoDefaultAlgorithmError)
    return print(io, NO_DEFAULT_ALGORITHM_MESSAGE)
end

const NO_TSPAN_MESSAGE = """
No tspan is set in the problem or chosen in the init/solve call
"""

struct NoTspanError <: Exception end

function Base.showerror(io::IO, e::NoTspanError)
    return print(io, NO_TSPAN_MESSAGE)
end

const NAN_TSPAN_MESSAGE = """
NaN tspan is set in the problem or chosen in the init/solve call.
Note that -Inf and Inf values are allowed in the timespan for solves
which are terminated via callbacks, however NaN values are not allowed
since the direction of time is undetermined.
"""

struct NaNTspanError <: Exception end

function Base.showerror(io::IO, e::NaNTspanError)
    return print(io, NAN_TSPAN_MESSAGE)
end

const NON_SOLVER_MESSAGE = """
The arguments to solve are incorrect.
The second argument must be a solver choice, `solve(prob,alg)`
where `alg` is a `<: AbstractDEAlgorithm`, e.g. `Tsit5()`.

Please double check the arguments being sent to the solver.

You can find the list of available solvers at <https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve>
and its associated pages.
"""

struct NonSolverError <: Exception end

function Base.showerror(io::IO, e::NonSolverError)
    return print(io, NON_SOLVER_MESSAGE)
end

const NOISE_SIZE_MESSAGE = """
Noise sizes are incompatible. The expected number of noise terms in the defined
`noise_rate_prototype` does not match the number of noise terms in the defined
`AbstractNoiseProcess`. Please ensure that
`size(prob.noise_rate_prototype,2) == length(prob.noise.W[1])`.

Note: Noise process definitions require that users specify `u0`, and this value is
directly used in the definition. For example, if `noise = WienerProcess(0.0,0.0)`,
then the noise process is a scalar with `u0=0.0`. If `noise = WienerProcess(0.0,[0.0])`,
then the noise process is a vector with `u0=0.0`. If `noise_rate_prototype = zeros(2,4)`,
then the noise process must be a 4-dimensional process, for example
`noise = WienerProcess(0.0,zeros(4))`. This error is a sign that the user definition
of `noise_rate_prototype` and `noise` are not aligned in this manner and the definitions should
be double checked.
"""

struct NoiseSizeIncompatibilityError <: Exception
    prototypesize::Int
    noisesize::Int
end

function Base.showerror(io::IO, e::NoiseSizeIncompatibilityError)
    println(io, NOISE_SIZE_MESSAGE)
    println(io, "size(prob.noise_rate_prototype,2) = $(e.prototypesize)")
    return println(io, "length(prob.noise.W[1]) = $(e.noisesize)")
end

const PROBSOLVER_PAIRING_MESSAGE = """
Incompatible problem+solver pairing.
For example, this can occur if an ODE solver is passed with an SDEProblem.
Solvers are only capable of handling specific problem types. Please double
check that the chosen pairing is capable for handling the given problems.
"""

struct ProblemSolverPairingError <: Exception
    prob::Any
    alg::Any
end

function Base.showerror(io::IO, e::ProblemSolverPairingError)
    println(io, PROBSOLVER_PAIRING_MESSAGE)
    println(io, "Problem type: $(SciMLBase.__parameterless_type(typeof(e.prob)))")
    println(io, "Solver type: $(SciMLBase.__parameterless_type(typeof(e.alg)))")
    return println(
        io,
        "Problem types compatible with the chosen solver: $(compatible_problem_types(e.prob, e.alg))"
    )
end

function compatible_problem_types(prob, alg)
    return if alg isa AbstractODEAlgorithm
        ODEProblem
    elseif alg isa AbstractSDEAlgorithm
        (SDEProblem, SDDEProblem)
    elseif alg isa AbstractDDEAlgorithm # StochasticDelayDiffEq.jl just uses the SDE alg
        DDEProblem
    elseif alg isa AbstractDAEAlgorithm
        DAEProblem
    elseif alg isa AbstractSteadyStateAlgorithm
        SteadyStateProblem
    end
end

const DIRECT_AUTODIFF_INCOMPATIBILITY_MESSAGE = """
Incompatible solver + automatic differentiation pairing.
The chosen automatic differentiation algorithm requires the ability
for compiler transforms on the code which is only possible on pure-Julia
solvers such as those from OrdinaryDiffEq.jl. Direct differentiation methods
which require this ability include:

- Direct use of ForwardDiff.jl on the solver
- `ForwardDiffSensitivity`, `ReverseDiffAdjoint`, `TrackerAdjoint`, and `ZygoteAdjoint`
  sensealg choices for adjoint differentiation.

Either switch the choice of solver to a pure Julia method, or change the automatic
differentiation method to one that does not require such transformations.

For more details on automatic differentiation, adjoint, and sensitivity analysis
of differential equations, see the documentation page:

<https://docs.sciml.ai/SciMLSensitivity/>
"""

struct DirectAutodiffError <: Exception end

function Base.showerror(io::IO, e::DirectAutodiffError)
    return println(io, DIRECT_AUTODIFF_INCOMPATIBILITY_MESSAGE)
end

const NONNUMBER_ELTYPE_MESSAGE = """
Non-Number element type inside of an `Array` detected.
Arrays with non-number element types, such as
`Array{Array{Float64}}`, are not supported by the
solvers.

If you are trying to use an array of arrays structure,
look at the tools in RecursiveArrayTools.jl. For example:

If this was a mistake, promote the element types to be
all the same. If this was intentional, for example,
using Unitful.jl with different unit values, then use
an array type which has fast broadcast support for
heterogeneous values such as the ArrayPartition
from RecursiveArrayTools.jl. For example:

```julia
using RecursiveArrayTools
u0 = ArrayPartition([1.0,2.0],[3.0,4.0])
u0 = VectorOfArray([1.0,2.0],[3.0,4.0])
```

are both initial conditions which would be compatible with
the solvers. Or use ComponentArrays.jl for more complex
nested structures.

Element type:
"""

struct NonNumberEltypeError <: Exception
    eltype::Any
end

function Base.showerror(io::IO, e::NonNumberEltypeError)
    print(io, NONNUMBER_ELTYPE_MESSAGE)
    return print(io, e.eltype)
end

const GENERIC_NUMBER_TYPE_ERROR_MESSAGE = """
Non-standard number type (i.e. not Float32, Float64,
ComplexF32, or ComplexF64) detected as the element type
for the initial condition or time span. These generic
number types are only compatible with the pure Julia
solvers which support generic programming, such as
OrdinaryDiffEq.jl. The chosen solver does not support
this functionality. Please double check that the initial
condition and time span types are correct, and check that
the chosen solver was correct.
"""

struct GenericNumberTypeError <: Exception
    alg::Any
    uType::Any
    tType::Any
end

function Base.showerror(io::IO, e::GenericNumberTypeError)
    println(io, GENERIC_NUMBER_TYPE_ERROR_MESSAGE)
    println(io, "Solver: $(e.alg)")
    println(io, "u0 type: $(e.uType)")
    return print(io, "Timespan type: $(e.tType)")
end

const COMPLEX_SUPPORT_ERROR_MESSAGE = """
Complex number type (i.e. ComplexF32, or ComplexF64)
detected as the element type for the initial condition
with an algorithm that does not support complex numbers.
Please check that the initial condition type is correct.
If complex number support is needed, try different solvers
such as those from OrdinaryDiffEq.jl.
"""

struct ComplexSupportError <: Exception
    alg::Any
end

function Base.showerror(io::IO, e::ComplexSupportError)
    println(io, COMPLEX_SUPPORT_ERROR_MESSAGE)
    return println(io, "Solver: $(e.alg)")
end

const COMPLEX_TSPAN_ERROR_MESSAGE = """
Complex number type (i.e. ComplexF32, or ComplexF64)
detected as the element type for the independent variable
(i.e. time span). Please check that the tspan type is correct.
No solvers support complex time spans. If this is required,
please open an issue.
"""

struct ComplexTspanError <: Exception end

function Base.showerror(io::IO, e::ComplexTspanError)
    return println(io, COMPLEX_TSPAN_ERROR_MESSAGE)
end

const TUPLE_STATE_ERROR_MESSAGE = """
Tuple type used as a state. Since a tuple does not have vector
properties, it will not work as a state type in equation solvers.
Instead, change your equation from using tuple constructors `()`
to static array constructors `SA[]`. For example, change:

```julia
function ftup((a,b),p,t)
  return b,-a
end
u0 = (1.0,2.0)
tspan = (0.0,1.0)
ODEProblem(ftup,u0,tspan)
```

to:

```julia
using StaticArrays
function fsa(u,p,t)
    SA[u[2],u[1]]
end
u0 = SA[1.0,2.0]
tspan = (0.0,1.0)
ODEProblem(ftup,u0,tspan)
```

This will be safer and fast for small ODEs. For more information, see:
<https://docs.sciml.ai/DiffEqDocs/stable/tutorials/faster_ode_example/#Further-Optimizations-of-Small-Non-Stiff-ODEs-with-StaticArrays>
"""

struct TupleStateError <: Exception end

function Base.showerror(io::IO, e::TupleStateError)
    return println(io, TUPLE_STATE_ERROR_MESSAGE)
end

const MASS_MATRIX_ERROR_MESSAGE = """
Mass matrix size is incompatible with initial condition
sizing. The mass matrix must represent the `vec`
form of the initial condition `u0`, i.e.
`size(mm,1) == size(mm,2) == length(u)`
"""

struct IncompatibleMassMatrixError <: Exception
    sz::Int
    len::Int
end

function Base.showerror(io::IO, e::IncompatibleMassMatrixError)
    println(io, MASS_MATRIX_ERROR_MESSAGE)
    print(io, "size(prob.f.mass_matrix,1): ")
    println(io, e.sz)
    print(io, "length(u0): ")
    return println(e.len)
end

const LATE_BINDING_TSTOPS_ERROR_MESSAGE = """
This solver does not support providing `tstops` as a function.
Consider using a different solver or providing `tstops` as an array
of times.
"""

struct LateBindingTstopsNotSupportedError <: Exception end

function Base.showerror(io::IO, e::LateBindingTstopsNotSupportedError)
    return println(io, LATE_BINDING_TSTOPS_ERROR_MESSAGE)
end

"""
$(TYPEDEF)
Statistics from the nonlinear equation solver about the solution process.

## Fields

  - `nf`: Number of function evaluations.
  - `njacs`: Number of Jacobians created during the solve.
  - `nfactors`: Number of factorzations of the jacobian required for the solve.
  - `nsolve`: Number of linear solves `W\\b` required for the solve.
  - `nsteps`: Total number of iterations for the nonlinear solver.
"""
mutable struct NLStats
    nf::Int
    njacs::Int
    nfactors::Int
    nsolve::Int
    nsteps::Int
end

function Base.show(io::IO, ::MIME"text/plain", s::NLStats)
    println(io, summary(s))
    @printf io "%-50s %-d\n" "Number of function evaluations:" s.nf
    @printf io "%-50s %-d\n" "Number of Jacobians created:" s.njacs
    @printf io "%-50s %-d\n" "Number of factorizations:" s.nfactors
    @printf io "%-50s %-d\n" "Number of linear solves:" s.nsolve
    return @printf io "%-50s %-d" "Number of nonlinear solver iterations:" s.nsteps
end

function Base.merge(s1::NLStats, s2::NLStats)
    return NLStats(
        s1.nf + s2.nf, s1.njacs + s2.njacs, s1.nfactors + s2.nfactors,
        s1.nsolve + s2.nsolve, s1.nsteps + s2.nsteps
    )
end

"""
$(TYPEDEF)

Representation of the solution to a nonlinear equation defined by a NonlinearProblem,
or the steady state solution to a differential equation defined by a SteadyStateProblem.

## Fields

  - `u`: the representation of the nonlinear equation's solution.
  - `resid`: the residual of the solution.
  - `prob`: the original NonlinearProblem/SteadyStateProblem that was solved.
  - `alg`: the algorithm type used by the solver.
  - `original`: if the solver is wrapped from an alternative solver ecosystem, such as
    NLsolve.jl, then this is the original return from said solver library.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully or whether it exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
  - `left`: if the solver is bracketing method, this is the final left bracket value.
  - `right`: if the solver is bracketing method, this is the final right bracket value.
  - `stats`: statistics of the solver, such as the number of function evaluations required.
"""
struct NonlinearSolution{T, N, uType, R, P, A, O, uType2, S, Tr} <:
    AbstractNonlinearSolution{T, N}
    u::uType
    resid::R
    prob::P
    alg::A
    retcode::ReturnCode.T
    original::O
    left::uType2
    right::uType2
    stats::S
    trace::Tr
end

function NonlinearSolution(u, resid, prob, alg, retcode, original, left, right, stats, trace)
    T = eltype(eltype(u))
    N = ndims(u)

    return NonlinearSolution{
        T, N, typeof(u), typeof(resid), typeof(prob), typeof(alg),
        typeof(original), typeof(left), typeof(stats), typeof(trace),
    }(
        u, resid, prob, alg,
        retcode, original, left, right, stats, trace
    )
end

const SteadyStateSolution = NonlinearSolution

get_p(p::AbstractNonlinearSolution) = p.prob.p

function build_solution(
        prob::Union{AbstractNonlinearProblem, SCCNonlinearProblem},
        alg, u, resid; calculate_error = true,
        retcode = ReturnCode.Default,
        original = nothing,
        left = nothing,
        right = nothing,
        stats = nothing,
        trace = nothing,
        kwargs...
    )
    return NonlinearSolution(
        u, resid, prob, alg, retcode,
        original, left, right, stats, trace
    )
end

function strip_solution(sol::NonlinearSolution)
    @reset sol.prob = (; p = nothing)
    @reset sol.alg = nothing
    @reset sol.original = nothing
    return sol
end

function sensitivity_solution(sol::AbstractNonlinearSolution, u)
    # Some of the subtypes might not have a trace field
    trace = hasfield(typeof(sol), :trace) ? sol.trace : nothing

    return NonlinearSolution(
        u, sol.resid, sol.prob, sol.alg, sol.retcode,
        sol.original, sol.left, sol.right, sol.stats, trace
    )
end

"""
$(TYPEDEF)
"""
struct StandardDDEProblem end

@doc doc"""

Defines a delay differential equation (DDE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/dde_types/>

## Mathematical Specification of a DDE Problem

To define a DDE Problem, you simply need to give the function ``f``, the initial
condition ``u_0`` at time point ``t_0``, and the history function ``h``
which together define a DDE:

```math
\begin{align*}
\frac{du}{dt} &= f(u,h,p,t) & (t \geq t_0) \\
u(t_0) &= u_0, \\
u(t)   &= h(t) & (t < t_0).
\end{align*}
```

``f`` should be specified as `f(u, h, p, t)` (or in-place as `f(du, u, h, p, t)`),
``u_0`` should be an AbstractArray (or number) whose geometry matches the
desired geometry of `u`, and ``h`` should be specified as described below. The
history function `h` is accessed for all delayed values. Note that we are not
limited to numbers or vectors for ``u_0``; one is allowed to provide ``u_0``
as arbitrary matrices / higher dimension tensors as well.

## Functional Forms of the History Function

The history function `h` can be called in the following ways:

- `h(p, t)`: out-of-place calculation
- `h(out, p, t)`: in-place calculation
- `h(p, t, deriv::Type{Val{i}})`: out-of-place calculation of the `i`th derivative
- `h(out, p, t, deriv::Type{Val{i}})`: in-place calculation of the `i`th derivative
- `h(args...; idxs)`: calculation of `h(args...)` for indices `idxs`

Note that a dispatch for the supplied history function of matching form is required
for whichever function forms are used in the user derivative function `f`.

## Declaring Lags

Lags are declared separately from their use. One can use any lag by simply using
the interpolant of `h` at that point. However, one should use caution in order
to achieve the best accuracy. When lags are declared, the solvers can be more
efficient and accurate, and this is thus recommended.

## Neutral and Retarded Delay Differential Equations

Note that the history function specification can be used to specify general
retarded arguments, i.e. `h(p,α(u,t))`. Neutral delay differential equations
can be specified by using the `deriv` value in the history interpolation.
For example, `h(p,t-τ, Val{1})` returns the first derivative of the history
values at time `t-τ`.

Note that algebraic equations can be specified by using a singular mass matrix.

## Problem Type

### Constructors

```julia
DDEProblem(f[, u0], h, tspan[, p]; <keyword arguments>)
DDEProblem{isinplace,specialize}(f[, u0], h, tspan[, p]; <keyword arguments>)
```

`isinplace` optionally sets whether the function is inplace or not. This is
determined automatically, but not inferred. `specialize` optionally controls
the specialization level. See the [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
for more details. The default is `AutoSpecialize`.

For more details on the in-place and specialization controls, see the ODEFunction
documentation.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the [DiffEqFunctions](@ref performance_overloads) page.

### Arguments

* `f`: The function in the DDE.
* `u0`: The initial condition. Defaults to the value `h(p, first(tspan))` of the history function evaluated at the initial time point.
* `h`: The history function for the DDE before `t0`.
* `tspan`: The timespan for the problem.
* `p`: The parameters with which function `f` is called. Defaults to `NullParameters`.
* `constant_lags`: A collection of constant lags used by the history function `h`. Defaults to `()`.
* `dependent_lags` A tuple of functions `(u, p, t) -> lag` for the state-dependent lags
  used by the history function `h`. Defaults to `()`.
* `neutral`: If the DDE is neutral, i.e., if delays appear in derivative terms.
* `order_discontinuity_t0`: The order of the discontinuity at the initial time point. Defaults to `0` if an initial condition `u0` is provided. Otherwise, it is forced to be greater or equal than `1`.
* `kwargs`: The keyword arguments passed onto the solves.

## Dynamical Delay Differential Equations

Much like [Dynamical ODEs](@ref dynamical_prob), a Dynamical DDE is a Partitioned DDE
of the form:

```math
\begin{align*}
\frac{dv}{dt} &= f_1(u,t,h) \\
\frac{du}{dt} &= f_2(v,h) \\
\end{align*}
```

### Constructors

```julia
DynamicalDDEProblem(f1, f2[, v0, u0], h, tspan[, p]; <keyword arguments>)
DynamicalDDEProblem{isinplace}(f1, f2[, v0, u0], h, tspan[, p]; <keyword arguments>)
```
Parameter `isinplace` optionally sets whether the function is inplace or not.
This is determined automatically, but not inferred.

### Arguments

* `f`: The function in the DDE.
* `v0` and `u0`: The initial condition. Defaults to the values `h(p, first(tspan))...` of the history function evaluated at the initial time point.
* `h`: The history function for the DDE before `t0`. Must return an object with the indices 1 and 2, with the values of `v` and `u` respectively.
* `tspan`: The timespan for the problem.
* `p`: The parameters with which function `f` is called. Defaults to `NullParameters`.
* `constant_lags`: A collection of constant lags used by the history function `h`. Defaults to `()`.
* `dependent_lags` A tuple of functions `(v, u, p, t) -> lag` for the state-dependent lags
  used by the history function `h`. Defaults to `()`.
* `neutral`: If the DDE is neutral, i.e., if delays appear in derivative terms.
* `order_discontinuity_t0`: The order of the discontinuity at the initial time point. Defaults to `0` if an initial condition `u0` is provided. Otherwise, it is forced to be greater or equal than `1`.
* `kwargs`: The keyword arguments passed onto the solves.

For dynamical and second order DDEs, the history function will return an object with
the indices 1 and 2 defined, where `h(p, t_prev)[1]` is the value of ``f_2(v, u, h, p,
t_{\mathrm{prev}})`` and `h(p, t_prev)[2]` is the value of ``f_1(v, u, h, p, t_{\mathrm{prev}})``
(this is for consistency with the ordering of the initial conditions in the constructor).
The supplied history function must also return such a 2-index object, which can be accomplished
with a tuple `(v,u)` or vector `[v,u]`.

## 2nd Order Delay Differential Equations

To define a 2nd Order DDE Problem, you simply need to give the function ``f``
and the initial condition ``u_0`` which define an DDE:

```math
u'' = f(u',u,h,p,t)
```

`f` should be specified as `f(du,u,p,t)` (or in-place as `f(ddu,du,u,p,t)`), and `u₀`
should be an AbstractArray (or number) whose geometry matches the desired
geometry of `u`. Note that we are not limited to numbers or vectors for `u₀`;
one is allowed to provide `u₀` as arbitrary matrices / higher dimension tensors
as well.

From this form, a dynamical ODE:

```math
\begin{align*}
v' &= f(v,u,h,p,t) \\
u' &= v
\end{align*}
```

### Constructors

```julia
SecondOrderDDEProblem(f[, du0, u0], h, tspan[, p]; <keyword arguments>)
SecondOrderDDEProblem{isinplace}(f, [, du0, u0], h, tspan[, p]; <keyword arguments>)
```

Parameter `isinplace` optionally sets whether the function is inplace or not.
This is determined automatically, but not inferred.

### Arguments

* `f`: The function in the DDE.
* `du0` and `u0`: The initial condition. Defaults to the values `h(p, first(tspan))...` of the history function evaluated at the initial time point.
* `h`: The history function for the DDE before `t0`. Must return an object with the indices 1 and 2, with the values of `v` and `u` respectively.
* `tspan`: The timespan for the problem.
* `p`: The parameters with which function `f` is called. Defaults to `NullParameters`.
* `constant_lags`: A collection of constant lags used by the history function `h`. Defaults to `()`.
* `dependent_lags` A tuple of functions `(v, u, p, t) -> lag` for the state-dependent lags
  used by the history function `h`. Defaults to `()`.
* `neutral`: If the DDE is neutral, i.e., if delays appear in derivative terms.
* `order_discontinuity_t0`: The order of the discontinuity at the initial time point. Defaults to `0` if an initial condition `u0` is provided. Otherwise, it is forced to be greater or equal than `1`.
* `kwargs`: The keyword arguments passed onto the solves.

As above, the history function will return an object with indices 1 and 2, with the values of `du` and `u` respectively. The supplied history function must also match this return type, e.g. by returning a 2-element tuple or vector.

## Example Problems

Example problems can be found in [DiffEqProblemLibrary.jl](https://github.com/SciML/DiffEqProblemLibrary.jl).

To use a sample problem, such as `prob_dde_constant_1delay_ip`, you can do something like:

```julia
#] add DDEProblemLibrary
using DDEProblemLibrary
prob = DDEProblemLibrary.prob_dde_constant_1delay_ip
sol = solve(prob)
```
"""
struct DDEProblem{uType, tType, lType, lType2, isinplace, P, F, H, K, PT} <:
    AbstractDDEProblem{uType, tType, lType, isinplace}
    f::F
    u0::uType
    h::H
    tspan::tType
    p::P
    constant_lags::lType
    dependent_lags::lType2
    kwargs::K
    neutral::Bool
    order_discontinuity_t0::Int
    problem_type::PT

    @add_kwonly function DDEProblem{iip}(
            f::AbstractDDEFunction{iip}, u0, h, tspan,
            p = NullParameters();
            constant_lags = (),
            dependent_lags = (),
            neutral = f.mass_matrix !== I &&
                det(f.mass_matrix) != 1,
            order_discontinuity_t0 = 0,
            problem_type = StandardDDEProblem(),
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan), typeof(constant_lags), typeof(dependent_lags),
            isinplace(f),
            typeof(p), typeof(f), typeof(h), typeof(kwargs), typeof(problem_type),
        }(
            f, _u0,
            h,
            _tspan,
            p,
            constant_lags,
            dependent_lags,
            kwargs,
            neutral,
            order_discontinuity_t0,
            problem_type
        )
    end

    function DDEProblem{iip}(
            f::AbstractDDEFunction{iip}, h, tspan::Tuple,
            p = NullParameters();
            order_discontinuity_t0 = 1, kwargs...
        ) where {iip}
        return DDEProblem{iip}(
            f, h(p, first(tspan)), h, tspan, p;
            order_discontinuity_t0 = max(1, order_discontinuity_t0), kwargs...
        )
    end

    function DDEProblem{iip}(f, args...; kwargs...) where {iip}
        return DDEProblem{iip}(DDEFunction{iip}(f), args...; kwargs...)
    end
end

function ConstructionBase.constructorof(::Type{P}) where {P <: DDEProblem}
    return function ctor(
            f, u0, h, tspan, p, constant_lags, dependent_lags,
            kw, neutral, order_discontinuity_t0, problem_type
        )
        if f isa AbstractDDEFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 5)
        end
        return DDEProblem{iip}(
            f, u0, h, tspan, p; kw..., constant_lags, dependent_lags,
            neutral, order_discontinuity_t0, problem_type
        )
    end
end

DDEProblem(f, args...; kwargs...) = DDEProblem(DDEFunction(f), args...; kwargs...)

function DDEProblem(f::AbstractDDEFunction, args...; kwargs...)
    return DDEProblem{isinplace(f)}(f, args...; kwargs...)
end

SymbolicIndexingInterface.get_history_function(prob::AbstractDDEProblem) = prob.h

"""
$(TYPEDEF)
"""
abstract type AbstractDynamicalDDEProblem end

"""
$(TYPEDEF)
"""
struct DynamicalDDEProblem{iip} <: AbstractDynamicalDDEProblem end

# u' = f1(v,h)
# v' = f2(t,u,h)
"""
    DynamicalDDEProblem(f::DynamicalDDEFunction,v0,u0,tspan,p=NullParameters(),callback=CallbackSet())

Define a dynamical DDE problem from a [`DynamicalDDEFunction`](@ref).
"""
function DynamicalDDEProblem(
        f::DynamicalDDEFunction, v0, u0, h, tspan,
        p = NullParameters(); dependent_lags = (), kwargs...
    )
    return DDEProblem(
        f, ArrayPartition(v0, u0), h, tspan, p;
        problem_type = DynamicalDDEProblem{isinplace(f)}(),
        dependent_lags = ntuple(
            i -> (u, p, t) -> dependent_lags[i](u[1], u[2], p, t),
            length(dependent_lags)
        ),
        kwargs...
    )
end
function DynamicalDDEProblem(
        f::DynamicalDDEFunction, h, tspan, p = NullParameters();
        kwargs...
    )
    return DynamicalDDEProblem(f, h(p, first(tspan))..., h, tspan, p; kwargs...)
end
function DynamicalDDEProblem(f1, f2, args...; kwargs...)
    return DynamicalDDEProblem(DynamicalDDEFunction(f1, f2), args...; kwargs...)
end

"""
    DynamicalDDEProblem{isinplace}(f1,f2,v0,u0,h,tspan,p=NullParameters(),callback=CallbackSet())

Define a dynamical DDE problem from the two functions `f1` and `f2`.

# Arguments

  - `f1` and `f2`: The functions in the DDE.
  - `v0` and `u0`: The initial conditions.
  - `h`: The initial history function.
  - `tspan`: The timespan for the problem.
  - `p`: Parameter values for `f1` and `f2`.
  - `callback`: A callback to be applied to every solver which uses the problem. Defaults to nothing.

`isinplace` optionally sets whether the function is inplace or not.
This is determined automatically, but not inferred.
"""
function DynamicalDDEProblem{iip}(f1, f2, args...; kwargs...) where {iip}
    return DynamicalDDEProblem(DynamicalDDEFunction{iip}(f1, f2), args...; kwargs...)
end

# u'' = f(du,u,h,p,t)
"""
$(TYPEDEF)
"""
struct SecondOrderDDEProblem{iip} <: AbstractDynamicalDDEProblem end
function SecondOrderDDEProblem(f, args...; kwargs...)
    iip = isinplace(f, 6)
    return SecondOrderDDEProblem{iip}(f, args...; kwargs...)
end

"""
    SecondOrderDDEProblem{isinplace}(f,du0,u0,h,tspan,p=NullParameters(),callback=CallbackSet())

Define a second order DDE problem with the specified function.

# Arguments

  - `f`: The function for the second derivative.
  - `du0`: The initial derivative.
  - `u0`: The initial condition.
  - `h`: The initial history function.
  - `tspan`: The timespan for the problem.
  - `p`: Parameter values for `f`.
  - `callback`: A callback to be applied to every solver which uses the problem. Defaults to nothing.

`isinplace` optionally sets whether the function is inplace or not.
This is determined automatically, but not inferred.
"""
function SecondOrderDDEProblem{iip}(f, args...; kwargs...) where {iip}
    if iip
        f2 = function (du, v, u, h, p, t)
            return du .= v
        end
    else
        f2 = function (v, u, h, p, t)
            return v
        end
    end
    return DynamicalDDEProblem{iip}(
        f, f2, args...; problem_type = SecondOrderDDEProblem{iip}(),
        kwargs...
    )
end
function SecondOrderDDEProblem(f::DynamicalDDEFunction, args...; kwargs...)
    iip = isinplace(f.f1, 6)
    if f.f2.f === nothing
        if iip
            f2 = function (du, v, u, h, p, t)
                return du .= v
            end
        else
            f2 = function (v, u, h, p, t)
                return v
            end
        end
        return DynamicalDDEProblem(
            DynamicalDDEFunction{iip}(
                f.f1, f2;
                mass_matrix = f.mass_matrix,
                analytic = f.analytic
            ),
            args...; problem_type = SecondOrderDDEProblem{iip}(),
            kwargs...
        )
    else
        return DynamicalDDEProblem(
            DynamicalDDEFunction{iip}(
                f.f1, f.f2;
                mass_matrix = f.mass_matrix,
                analytic = f.analytic
            ),
            args...; problem_type = SecondOrderDDEProblem{iip}(),
            kwargs...
        )
    end
end

@doc doc"""
    DDEAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_du0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving a DDE. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the u0 array. Defaults to false .
* `alias_du0::Union{Bool, Nothing}`: alias the du0 array for DAEs. Defaults to false.
* `alias_tstops::Union{Bool, Nothing}`: alias the tstops array
* `alias::Union{Bool, Nothing}`: sets all fields of the `DDEAliasSpecifier` to `alias`

"""
struct DDEAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}

    function DDEAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true)
        elseif alias == false
            new(false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_tstops)
        end
    end
end

module SciMLBaseForwardDiffExt

using SciMLBase, ForwardDiff
using ArrayInterface

import SciMLBase:
    wrapfun_oop, wrapfun_iip, isdualtype, value, DualEltypeChecker,
    AbstractTimeseriesSolution, NonlinearProblem, NonlinearLeastSquaresProblem,
    ODEProblem, SDEProblem, RODEProblem, DDEProblem, PDEProblem, DAEProblem,
    RecursiveArrayTools, totallength, sse, anyeltypedual, reduce_tup,
    unitfulvalue

eltypedual(x) = eltype(x) <: ForwardDiff.Dual
isdualtype(::Type{<:ForwardDiff.Dual}) = true

promote_dual(::Type{T}, ::Type{T2}) where {T <: ForwardDiff.Dual, T2} = T
function promote_dual(
        ::Type{T},
        ::Type{T2}
    ) where {T <: ForwardDiff.Dual, T2 <: ForwardDiff.Dual}
    return T
end
promote_dual(::Type{T}, ::Type{T2}) where {T, T2 <: ForwardDiff.Dual} = T2

function promote_dual(
        ::Type{T},
        ::Type{T2}
    ) where {
        T3, T4, V, V2 <: ForwardDiff.Dual, N, N2,
        T <: ForwardDiff.Dual{T3, V, N},
        T2 <: ForwardDiff.Dual{T4, V2, N2},
    }
    return T2
end
function promote_dual(
        ::Type{T},
        ::Type{T2}
    ) where {
        T3, T4, V <: ForwardDiff.Dual, V2, N, N2,
        T <: ForwardDiff.Dual{T3, V, N},
        T2 <: ForwardDiff.Dual{T4, V2, N2},
    }
    return T
end
function promote_dual(
        ::Type{T},
        ::Type{T2}
    ) where {
        T3, V <: ForwardDiff.Dual, V2 <: ForwardDiff.Dual,
        N,
        T <: ForwardDiff.Dual{T3, V, N},
        T2 <: ForwardDiff.Dual{T3, V2, N},
    }
    return ForwardDiff.Dual{T3, promote_dual(V, V2), N}
end

"""
    promote_dual(::Type{T},::Type{T2})

Is like the number promotion system, but always prefers a dual number type above
anything else. For higher order differentiation, it returns the most dualiest of
them all. This is then used to promote `u0` into the suspected highest differentiation
space for solving the equation.
"""
promote_dual(::Type{T}, ::Type{T2}) where {T, T2} = T

# `reduce` and `map` are specialized on tuples to be unrolled (via recursion)
# Therefore, they can be type stable even with heterogeneous input types.
# We also don't care about allocating any temporaries with them, as it should
# all be unrolled and optimized away.
# Being unrolled also means const prop can work for things like
# `mapreduce(f, op, propertynames(x))`
# where `f` may call `getproperty` and thus have return type dependent
# on the particular symbol.
# `mapreduce` hasn't received any such specialization.
@inline diffeqmapreduce(f::F, op::OP, x::Tuple) where {F, OP} = reduce_tup(op, map(f, x))
@inline function diffeqmapreduce(f::F, op::OP, x::NamedTuple) where {F, OP}
    return reduce_tup(op, map(f, x))
end
# For other container types, we probably just want to call `mapreduce`
@inline diffeqmapreduce(f::F, op::OP, x) where {F, OP} = mapreduce(f, op, x, init = Any)

getval(::Val{I}) where {I} = I
getval(::Type{Val{I}}) where {I} = I
getval(I::Int) = I

const DUALCHECK_RECURSION_MAX = 10

function (dec::DualEltypeChecker)(::Val{Y}) where {Y}
    isdefined(dec.x, Y) || return Any
    getval(dec.counter) >= DUALCHECK_RECURSION_MAX && return Any
    return anyeltypedual(getfield(dec.x, Y), Val{getval(dec.counter)})
end

# Untyped dispatch: catch composite types, check all of their fields
"""
    anyeltypedual(x)

Searches through a type to see if any of its values are parameters. This is used to
then promote other values to match the dual type. For example, if a user passes a parameter

which is a `Dual` and a `u0` which is a `Float64`, after the first time step, `f(u,p,t) = p*u`
will change `u0` from `Float64` to `Dual`. Thus the state variable always needs to be converted
to a dual number before the solve. Worse still, this needs to be done in the case of
`f(du,u,p,t) = du[1] = p*u[1]`, and thus running `f` and taking the return value is not a valid
way to calculate the required state type.

But given the properties of automatic differentiation requiring that differentiation of parameters
implies differentiation of state, we assume any dual parameters implies differentiation of state
and then attempt to upconvert `u0` to match that dual-ness. Because this changes types, this needs
to be specified at compiled time and thus cannot have a Bool-based opt out, so in the future this
may be extended to use a preference system to opt-out with a `UPCONVERT_DUALS`. In the case where
upconversion is not done automatically, the user is required to upconvert all initial conditions
themselves, for an example of how this can be confusing to a user see
<https://discourse.julialang.org/t/typeerror-in-julia-turing-when-sampling-for-a-forced-differential-equation/82937>
"""
@generated function anyeltypedual(x, ::Type{Val{counter}}) where {counter}
    x = x.name === Core.Compiler.typename(Type) ? x.parameters[1] : x
    return if isdualtype(x)
        :($x)
    elseif fieldnames(x) === ()
        :(Any)
    elseif counter < DUALCHECK_RECURSION_MAX
        T = diffeqmapreduce(
            x -> anyeltypedual(x, Val{counter + 1}), promote_dual,
            x.parameters
        )
        if T === Any || isconcretetype(T)
            :($T)
        else
            :(
                diffeqmapreduce(
                    DualEltypeChecker($x, $counter + 1), promote_dual,
                    map(Val, fieldnames($(typeof(x))))
                )
            )
        end
    else
        :(Any)
    end
end

const FORWARDDIFF_AUTODETECTION_FAILURE_MESSAGE = """
Failed to automatically detect ForwardDiff compatibility of
the parameter object. In order for ForwardDiff.jl automatic
differentiation to work on a solution object, the state of
the differential equation or nonlinear solve (`u0`) needs to
be converted to a Dual type which matches the values being
differentiated. For example, for a loss function loss(p)
where `p`` is a `Vector{Float64}`, this conversion is
equivalent to:

```julia
# Convert u0 to match the new Dual element type of `p`
_prob = remake(prob, u0 = eltype(p).(prob.u0))
```

In most cases, SciML tools are able to do this conversion
automatically. However, it seems you have provided a
parameter type for which this automatic conversion has failed.

To fix this, you can do the conversion yourself. For example,
if you have a parameter vector being optimized `p` which is
then put into an odd struct, you can manually convert `u0`
to match `p`:

```julia
function loss(p)
    _prob = remake(prob, u0 = eltype(p).(prob.u0), p = MyStruct(p))
    sol = solve(_prob, ...)
    # do stuff on sol
end
```

Or you can define a dispatch on `SciMLBase.anyeltypedual`
which tells the system what fields to interpret as the
differentiable parts. For example, to support ODESolutions
as parameters we tell it the data is `sol.u` and `sol.t` via:

```julia
function SciMLBase.anyeltypedual(sol::ODESolution, counter = 0)
    SciMLBase.anyeltypedual((sol.u, sol.t))
end
```

To opt a type out of the dual checking, define an overload
that returns Any. For example:

```julia
function SciMLBase.anyeltypedual(::YourType, ::Type{Val{counter}}) where {counter}
    Any
end
```

If you have defined this on a common type which should
be more generally supported, please open a pull request
adding this dispatch. If you need help defining this dispatch,
feel free to open an issue.
"""

struct ForwardDiffAutomaticDetectionFailure <: Exception end

function Base.showerror(io::IO, e::ForwardDiffAutomaticDetectionFailure)
    return print(io, FORWARDDIFF_AUTODETECTION_FAILURE_MESSAGE)
end

function anyeltypedual(::Type{Union{}})
    throw(ForwardDiffAutomaticDetectionFailure())
end

function anyeltypedual(
        ::Type{<:AbstractTimeseriesSolution{T, N}},
        ::Type{Val{counter}} = Val{0}
    ) where {T, N, counter}
    return anyeltypedual(T)
end

function anyeltypedual(
        ::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        NonlinearProblem{
            uType, iip, pType,
        },
    } where {uType, iip, pType}
    return anyeltypedual((uType, pType), Val{counter})
end

function anyeltypedual(
        ::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        NonlinearLeastSquaresProblem{
            uType, iip, pType,
        },
    } where {uType, iip, pType}
    return anyeltypedual((uType, pType), Val{counter})
end

function anyeltypedual(
        x::SciMLBase.RecipesBase.AbstractPlot,
        ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return Any
end
function anyeltypedual(x::Returns, ::Type{Val{counter}} = Val{0}) where {counter}
    return anyeltypedual(x.value, Val{counter})
end

Base.@assume_effects :foldable function __anyeltypedual(::Type{T}) where {T}
    return if T isa Union
        promote_dual(anyeltypedual(T.a), anyeltypedual(T.b))
    elseif hasproperty(T, :parameters)
        mapreduce(anyeltypedual, promote_dual, T.parameters; init = Any)
    else
        T
    end
end
function anyeltypedual(::Type{T}, ::Type{Val{counter}} = Val{0}) where {counter} where {T}
    return __anyeltypedual(T)
end

function anyeltypedual(
        ::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        Union{AbstractArray, Set},
    }
    return anyeltypedual(eltype(T))
end
Base.@pure function __anyeltypedual_ntuple(::Type{T}) where {T <: NTuple}
    if isconcretetype(eltype(T))
        return eltype(T)
    end
    if isempty(T.parameters)
        Any
    else
        mapreduce(anyeltypedual, promote_dual, T.parameters; init = Any)
    end
end
function anyeltypedual(
        ::Type{T}, ::Type{Val{counter}} = Val{0}
    ) where {counter} where {T <: NTuple}
    return __anyeltypedual_ntuple(T)
end

# Any in this context just means not Dual
function anyeltypedual(
        x::SciMLBase.NullParameters, ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return Any
end

function anyeltypedual(sol::RecursiveArrayTools.AbstractDiffEqArray, counter = 0)
    return diffeqmapreduce(anyeltypedual, promote_dual, (sol.u, sol.t))
end
function anyeltypedual(sol::RecursiveArrayTools.AbstractDiffEqArray, ::Type{Val{counter}}) where {counter}
    return diffeqmapreduce(anyeltypedual, promote_dual, (sol.u, sol.t))
end


function anyeltypedual(
        prob::Union{ODEProblem, SDEProblem, RODEProblem, DDEProblem},
        ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return anyeltypedual((prob.u0, prob.p, prob.tspan))
end

function anyeltypedual(
        prob::Union{NonlinearProblem, NonlinearLeastSquaresProblem, OptimizationProblem},
        ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return anyeltypedual((prob.u0, prob.p))
end

function anyeltypedual(x::Number, ::Type{Val{counter}} = Val{0}) where {counter}
    return anyeltypedual(typeof(x))
end
function anyeltypedual(
        x::Union{String, Symbol}, ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return typeof(x)
end
function anyeltypedual(
        x::Union{AbstractArray{T}, Set{T}},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        Union{
            Number,
            Symbol,
            String,
        },
    }
    return anyeltypedual(T)
end
function anyeltypedual(
        x::Union{AbstractArray{T}, Set{T}},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <: Union{
            AbstractArray{
                <:Number,
            },
            Set{
                <:Number,
            },
        },
    }
    return anyeltypedual(eltype(x))
end
function anyeltypedual(
        x::Union{AbstractArray{T}, Set{T}},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {N, T <: NTuple{N, <:Number}}
    return anyeltypedual(eltype(x))
end

# Try to avoid this dispatch because it can lead to type inference issues when !isconcrete(eltype(x))
function anyeltypedual(x::AbstractArray, ::Type{Val{counter}} = Val{0}) where {counter}
    return if isconcretetype(eltype(x))
        anyeltypedual(eltype(x))
    elseif !isempty(x) && all(i -> isassigned(x, i), 1:length(x)) &&
            counter < DUALCHECK_RECURSION_MAX
        _counter = Val{counter + 1}
        mapreduce(y -> anyeltypedual(y, _counter), promote_dual, x)
    else
        # This fallback to Any is required since otherwise we cannot handle `undef` in all cases
        #  misses cases of
        Any
    end
end

function anyeltypedual(x::Set, ::Type{Val{counter}} = Val{0}) where {counter}
    return if isconcretetype(eltype(x))
        anyeltypedual(eltype(x))
    else
        # This fallback to Any is required since otherwise we cannot handle `undef` in all cases
        Any
    end
end

function anyeltypedual(x::Tuple, ::Type{Val{counter}} = Val{0}) where {counter}
    # Handle the empty tuple case separately for inference and to avoid mapreduce error
    return if x === ()
        Any
    else
        diffeqmapreduce(anyeltypedual, promote_dual, x)
    end
end
function anyeltypedual(x::AbstractDict, ::Type{Val{counter}} = Val{0}) where {counter}
    return isempty(x) ? eltype(values(x)) : mapreduce(anyeltypedual, promote_dual, values(x))
end
function anyeltypedual(x::NamedTuple, ::Type{Val{counter}} = Val{0}) where {counter}
    return anyeltypedual(values(x))
end

function anyeltypedual(
        f::SciMLBase.AbstractSciMLFunction, ::Type{Val{counter}}
    ) where {counter}
    return Any
end

anyeltypedual(::@Kwargs{}, ::Type{Val{counter}} = Val{0}) where {counter} = Any
anyeltypedual(::Type{@Kwargs{}}, ::Type{Val{counter}} = Val{0}) where {counter} = Any

# Opt out since these are using for preallocation, not differentiation
function anyeltypedual(
        x::Union{ForwardDiff.AbstractConfig, Module},
        ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return Any
end
function anyeltypedual(
        x::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        ForwardDiff.AbstractConfig,
    }
    return Any
end

function anyeltypedual(
        x::ForwardDiff.DiffResults.DiffResult,
        ::Type{Val{counter}} = Val{0}
    ) where {counter}
    return Any
end
function anyeltypedual(
        x::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {
        T <:
        ForwardDiff.DiffResults.DiffResult,
    }
    return Any
end

function anyeltypedual(
        ::Type{T},
        ::Type{Val{counter}} = Val{0}
    ) where {counter} where {T <: ForwardDiff.Dual}
    return T
end

value(x::Type{ForwardDiff.Dual{T, V, N}}) where {T, V, N} = V
value(x::ForwardDiff.Dual) = value(ForwardDiff.value(x))

unitfulvalue(x::Type{ForwardDiff.Dual{T, V, N}}) where {T, V, N} = V
unitfulvalue(x::ForwardDiff.Dual) = unitfulvalue(ForwardDiff.value(x))

sse(x::ForwardDiff.Dual) = sse(ForwardDiff.value(x)) + sum(sse, ForwardDiff.partials(x))

function SciMLBase.totallength(x::ForwardDiff.Dual)
    return SciMLBase.totallength(ForwardDiff.value(x)) +
        sum(SciMLBase.totallength, ForwardDiff.partials(x))
end

end

### Abstract Interface
const AllObserved = RecursiveArrayTools.AllObserved

# No Time Solution : Forward to `A.u`
Base.getindex(A::AbstractNoTimeSolution) = A.u[]
Base.getindex(A::AbstractNoTimeSolution, i::Int) = A.u[i]
Base.getindex(A::AbstractNoTimeSolution, I::Vararg{Int, N}) where {N} = A.u[I...]
Base.getindex(A::AbstractNoTimeSolution, I::AbstractArray{Int}) = A.u[I]
Base.getindex(A::AbstractNoTimeSolution, I::CartesianIndex) = A.u[I]
Base.getindex(A::AbstractNoTimeSolution, I::Colon) = A.u[I]
Base.getindex(A::AbstractTimeseriesSolution, I::AbstractArray{Int}) = solution_slice(A, I)
Base.setindex!(A::AbstractNoTimeSolution, v, i::Int) = (A.u[i] = v)
Base.setindex!(A::AbstractNoTimeSolution, v, I::Vararg{Int, N}) where {N} = (A.u[I] = v)
Base.size(A::AbstractNoTimeSolution) = size(A.u)

function Base.show(io::IO, m::MIME"text/plain", A::AbstractNoTimeSolution)
    if hasfield(typeof(A), :retcode)
        println(io, string("retcode: ", A.retcode))
    end
    print(io, "u: ")
    return show(io, m, A.u)
end

# For augmenting system information to enable symbol based indexing of interpolated solutions
function augment(
        A::DiffEqArray{T, N, Q, B}, sol::AbstractODESolution;
        discretes = nothing
    ) where {T, N, Q, B}
    p = hasproperty(sol.prob, :p) ? sol.prob.p : nothing
    return DiffEqArray(A.u, A.t, p, sol; discretes)
end

# SymbolicIndexingInterface.jl
const AbstractSolution = Union{AbstractTimeseriesSolution, AbstractNoTimeSolution}

Base.@propagate_inbounds function Base.getproperty(A::AbstractSolution, sym::Symbol)
    if sym === :ps
        return ParameterIndexingProxy(A)
    else
        return getfield(A, sym)
    end
end

SymbolicIndexingInterface.symbolic_container(A::AbstractSolution) = A.prob
SymbolicIndexingInterface.parameter_values(A::AbstractSolution) = parameter_values(A.prob)
function SymbolicIndexingInterface.parameter_values(A::AbstractSolution, i)
    return parameter_values(parameter_values(A), i)
end

SymbolicIndexingInterface.symbolic_container(A::AbstractPDESolution) = A.disc_data.pdesys

SymbolicIndexingInterface.is_independent_variable(::AbstractNoTimeSolution, sym) = false

SymbolicIndexingInterface.independent_variable_symbols(::AbstractNoTimeSolution) = []

SymbolicIndexingInterface.is_time_dependent(::AbstractTimeseriesSolution) = true

SymbolicIndexingInterface.is_time_dependent(::AbstractNoTimeSolution) = false

# TODO make this nontrivial once dynamic state selection works
SymbolicIndexingInterface.constant_structure(::AbstractSolution) = true
SymbolicIndexingInterface.state_values(A::AbstractNoTimeSolution) = A.u

function get_saved_subsystem(sol::T) where {T <: AbstractTimeseriesSolution}
    return hasfield(T, :saved_subsystem) ? sol.saved_subsystem : nothing
end

for fn in [
        is_timeseries_parameter, timeseries_parameter_index,
        with_updated_parameter_timeseries_values, get_saveable_values,
    ]
    fname = nameof(fn)
    mod = parentmodule(fn)

    @eval function $(mod).$(fname)(sol::AbstractTimeseriesSolution, args...)
        ss = get_saved_subsystem(sol)
        return if ss === nothing
            $(fn)(symbolic_container(sol), args...)
        else
            $(fn)(SavedSubsystemWithFallback(ss, symbolic_container(sol)), args...)
        end
    end
end

function SymbolicIndexingInterface.state_values(sol::AbstractTimeseriesSolution, i)
    ss = get_saved_subsystem(sol)
    ss === nothing && return sol.u[i]

    original = state_values(sol.prob)
    saved = sol.u[i]
    if !(saved isa AbstractArray)
        saved = [saved]
    end
    idxs = similar(saved, eltype(keys(ss.state_map)))
    for (k, v) in ss.state_map
        idxs[v] = k
    end
    replaced = remake_buffer(sol, original, idxs, saved)
    return replaced
end

function SymbolicIndexingInterface.state_values(sol::AbstractTimeseriesSolution)
    ss = get_saved_subsystem(sol)
    ss === nothing && return sol.u
    return map(Base.Fix1(state_values, sol), eachindex(sol.u))
end

# Ambiguity resolution
function SymbolicIndexingInterface.state_values(sol::AbstractTimeseriesSolution, ::Colon)
    return state_values(sol)
end

Base.@propagate_inbounds function Base.getindex(A::AbstractTimeseriesSolution, ::Colon)
    return A.u[:]
end

Base.@propagate_inbounds function Base.getindex(A::AbstractNoTimeSolution, sym)
    if is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `sol.ps[$sym]` for parameter indexing.")
    end
    return getsym(A, sym)(A)
end

Base.@propagate_inbounds function Base.getindex(
        A::AbstractNoTimeSolution, sym::Union{AbstractArray, Tuple}
    )
    if symbolic_type(sym) == NotSymbolic() && any(x -> is_parameter(A, x), sym) ||
            is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `sol.ps[$sym]` for parameter indexing.")
    end
    return getsym(A, sym)(A)
end

Base.@propagate_inbounds function Base.getindex(
        A::AbstractNoTimeSolution, ::SymbolicIndexingInterface.SolvedVariables
    )
    return getindex(A, variable_symbols(A))
end

Base.@propagate_inbounds function Base.getindex(
        A::AbstractNoTimeSolution, ::SymbolicIndexingInterface.AllVariables
    )
    return getindex(A, all_variable_symbols(A))
end

function observed(A::AbstractTimeseriesSolution, sym, i::Int)
    return getobserved(A)(sym, A[i], parameter_values(A), A.t[i])
end

function observed(A::AbstractTimeseriesSolution, sym, i::AbstractArray{Int})
    return getobserved(A).((sym,), A.u[i], (parameter_values(A),), A.t[i])
end

function observed(A::AbstractTimeseriesSolution, sym, i::Colon)
    return getobserved(A).((sym,), A.u, (parameter_values(A),), A.t)
end

function observed(A::AbstractNoTimeSolution, sym)
    return getobserved(A)(sym, A.u, parameter_values(A))
end

## AbstractTimeseriesSolution Interface

function Base.summary(io::IO, A::AbstractTimeseriesSolution)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(A)),
        no_color, " with uType ",
        type_color, eltype(A.u),
        no_color, " and tType ",
        type_color, eltype(A.t), no_color
    )
end

function Base.show(io::IO, m::MIME"text/plain", A::AbstractTimeseriesSolution)
    println(io, string("retcode: ", A.retcode))
    println(io, string("Interpolation: "), interp_summary(A.interp))
    print(io, "t: ")
    show(io, m, A.t)
    println(io)
    print(io, "u: ")
    return show(io, m, A.u)
end

RecursiveArrayTools.tuples(sol::AbstractTimeseriesSolution) = tuple.(sol.u, sol.t)

function Base.iterate(sol::AbstractTimeseriesSolution, state = 0)
    state >= length(sol) && return nothing
    state += 1
    return (solution_new_tslocation(sol, state), state)
end

function Base.show(io::IO, m::MIME"text/plain", A::AbstractPDESolution)
    println(io, string("retcode: ", A.retcode))
    print(io, "t: ")
    show(io, m, A.t)
    println(io)
    print(io, "u: ")
    return show(io, m, A.u)
end

DEFAULT_PLOT_FUNC(x, y) = (x, y)
DEFAULT_PLOT_FUNC(x, y, z) = (x, y, z) # For v0.5.2 bug

function isdenseplot(sol)
    return (sol.dense || sol.prob isa AbstractDiscreteProblem) &&
        !(sol isa AbstractRODESolution) &&
        !(
        hasfield(typeof(sol), :interp) &&
            sol.interp isa SensitivityInterpolation
    )
end

"""
    $(TYPEDSIGNATURES)

Given the first element in a timeseries solution, return an `AbstractArray` of
indices that can be plotted as continuous variables. This is useful for systems
that store auxiliary variables in the state vector which are not meant to be
used for plotting.
"""
plottable_indices(x::AbstractArray) = 1:length(x)
plottable_indices(x::Number) = 1

@recipe function f(
        sol::AbstractTimeseriesSolution;
        plot_analytic = false,
        denseplot = isdenseplot(sol),
        plotdensity = min(
            Int(1.0e5),
            sol.tslocation == 0 ?
                (
                    sol.prob isa AbstractDiscreteProblem ?
                    max(1000, 100 * length(sol)) :
                    max(1000, 10 * length(sol))
                ) :
                1000 * sol.tslocation
        ), plotat = nothing,
        tspan = nothing,
        vars = nothing, idxs = nothing
    )
    if vars !== nothing
        Base.depwarn(
            "To maintain consistency with solution indexing, keyword argument vars will be removed in a future version. Please use keyword argument idxs instead.",
            :f; force = true
        )
        (idxs !== nothing) &&
            error("Simultaneously using keywords vars and idxs is not supported. Please only use idxs.")
        idxs = vars
    end

    if plot_analytic && (sol.u_analytic === nothing)
        throw(ArgumentError("No analytic solution was found but `plot_analytic` was set to `true`."))
    end

    idxs = idxs === nothing ? plottable_indices(sol.u[1]) : idxs
    if !(idxs isa Union{Tuple, AbstractArray})
        vars = interpret_vars([idxs], sol)
    else
        vars = interpret_vars(idxs, sol)
    end
    disc_vars = Tuple[]
    cont_vars = Tuple[]
    for var in vars
        tsidxs = union(
            var[2] === 0 ? () : get_all_timeseries_indexes(sol, var[2]),
            get_all_timeseries_indexes(sol, var[3])
        )
        if ContinuousTimeseries() in tsidxs || isempty(tsidxs)
            push!(cont_vars, var)
        else
            push!(disc_vars, (var..., only(tsidxs)))
        end
    end
    idxs = identity.(cont_vars)
    vars = identity.(cont_vars)
    tdir = sign(sol.t[end] - sol.t[1])
    xflip --> tdir < 0
    seriestype --> :path

    @series begin
        if idxs isa Union{AbstractArray, Tuple} && isempty(idxs)
            label --> nothing
            ([], [])
        else
            tscale = get(plotattributes, :xscale, :identity)
            plot_vecs,
                labels = diffeq_to_arrays(
                sol, plot_analytic, denseplot,
                plotdensity, tspan, vars, tscale, plotat
            )

            # Special case labels when idxs = (:x,:y,:z) or (:x) or [:x,:y] ...
            if idxs isa Tuple && vars[1][1] === DEFAULT_PLOT_FUNC
                val = hasname(vars[1][2]) ? String(getname(vars[1][2])) : vars[1][2]
                if val isa Integer
                    if val == 0
                        val = "t"
                    else
                        val = "u[$val]"
                    end
                end
                xguide --> val
                val = hasname(vars[1][3]) ? String(getname(vars[1][3])) : vars[1][3]
                if val isa Integer
                    if val == 0
                        val = "t"
                    else
                        val = "u[$val]"
                    end
                end
                yguide --> val
                if length(idxs) > 2
                    val = hasname(vars[1][4]) ? String(getname(vars[1][4])) : vars[1][4]
                    if val isa Integer
                        if val == 0
                            val = "t"
                        else
                            val = "u[$val]"
                        end
                    end
                    zguide --> val
                end
            end

            if (
                    !any(!isequal(NotSymbolic()), symbolic_type.(getindex.(vars, 1))) &&
                        getindex.(vars, 1) == zeros(length(vars))
                ) ||
                    (
                    !any(!isequal(NotSymbolic()), symbolic_type.(getindex.(vars, 2))) &&
                        getindex.(vars, 2) == zeros(length(vars))
                ) ||
                    all(t -> Symbol(t) == getindepsym_defaultt(sol), getindex.(vars, 1)) ||
                    all(t -> Symbol(t) == getindepsym_defaultt(sol), getindex.(vars, 2))
                xguide --> "$(getindepsym_defaultt(sol))"
            end
            if length(vars[1]) >= 3 &&
                    (
                    (
                        !any(!isequal(NotSymbolic()), symbolic_type.(getindex.(vars, 3))) &&
                            getindex.(vars, 3) == zeros(length(vars))
                    ) ||
                        all(t -> Symbol(t) == getindepsym_defaultt(sol), getindex.(vars, 3))
                )
                yguide --> "$(getindepsym_defaultt(sol))"
            end
            if length(vars[1]) >= 4 &&
                    (
                    (
                        !any(!isequal(NotSymbolic()), symbolic_type.(getindex.(vars, 4))) &&
                            getindex.(vars, 4) == zeros(length(vars))
                    ) ||
                        all(t -> Symbol(t) == getindepsym_defaultt(sol), getindex.(vars, 4))
                )
                zguide --> "$(getindepsym_defaultt(sol))"
            end

            if (
                    !any(!isequal(NotSymbolic()), symbolic_type.(getindex.(vars, 2))) &&
                        getindex.(vars, 2) == zeros(length(vars))
                ) ||
                    all(t -> Symbol(t) == getindepsym_defaultt(sol), getindex.(vars, 2))
                if tspan === nothing
                    if tdir > 0
                        xlims --> (sol.t[1], sol.t[end])
                    else
                        xlims --> (sol.t[end], sol.t[1])
                    end
                else
                    xlims --> (tspan[1], tspan[end])
                end
            end

            label --> reshape(labels, 1, length(labels))
            (plot_vecs...,)
        end
    end
    for (func, xvar, yvar, tsidx) in disc_vars
        partition = sol.discretes[tsidx]
        ts = current_time(partition)
        if tspan !== nothing
            tstart = searchsortedfirst(ts, tspan[1])
            tend = searchsortedlast(ts, tspan[2])
            if tstart == lastindex(ts) + 1 || tend == firstindex(ts) - 1
                continue
            end
        else
            tstart = firstindex(ts)
            tend = lastindex(ts)
        end
        ts = ts[tstart:tend]

        if symbolic_type(xvar) == NotSymbolic() && xvar == 0
            xvar = only(independent_variable_symbols(sol))
        end
        xvals = sol(ts; idxs = xvar).u
        # xvals = getsym(sol, xvar)(sol, tstart:tend)
        yvals = getp(sol, yvar)(sol, tstart:tend)
        tmpvals = map(func, xvals, yvals)
        xvals = getindex.(tmpvals, 1)
        yvals = getindex.(tmpvals, 2)
        # Scatterplot of points
        @series begin
            seriestype := :line
            linestyle --> :dash
            markershape --> :o
            markersize --> repeat([2, 0], length(ts) - 1)
            markeralpha --> repeat([1, 0], length(ts) - 1)
            label --> string(hasname(yvar) ? getname(yvar) : yvar)

            x = vec([xvals[1:(end - 1)]'; xvals[2:end]'])
            y = repeat(yvals, inner = 2)[1:(end - 1)]
            x, y
        end
    end
end

function diffeq_to_arrays(
        sol, plot_analytic, denseplot, plotdensity, tspan,
        vars, tscale, plotat
    )
    if tspan === nothing
        if sol.tslocation == 0
            end_idx = length(sol)
        else
            end_idx = sol.tslocation
        end
        start_idx = 1
    else
        start_idx = searchsortedfirst(sol.t, tspan[1])
        end_idx = searchsortedlast(sol.t, tspan[end])
    end

    # determine type of spacing for plot
    densetspacer = if tscale in [:ln, :log10, :log2]
        (start, stop, n) -> exp10.(range(log10(start), stop = log10(stop), length = n))
    else
        (start, stop, n) -> range(start; stop = stop, length = n)
    end

    if plotat !== nothing
        plott = plotat
        plot_analytic_timeseries = nothing
    elseif denseplot
        # Generate the points from the plot from dense function
        if sol isa AbstractAnalyticalSolution
            tspan = sol.prob.tspan
            plott = collect(densetspacer(tspan[1], tspan[end], plotdensity))
        elseif tspan === nothing
            plott = collect(densetspacer(sol.t[start_idx], sol.t[end_idx], plotdensity))
        else
            plott = collect(densetspacer(tspan[1], tspan[end], plotdensity))
        end
        if plot_analytic
            if sol.prob.f isa Tuple
                plot_analytic_timeseries = [
                    sol.prob.f[1].analytic(
                            sol.prob.u0, sol.prob.p,
                            t
                        ) for t in plott
                ]
            else
                plot_analytic_timeseries = [
                    sol.prob.f.analytic(sol.prob.u0, sol.prob.p, t)
                        for t in plott
                ]
            end
        else
            plot_analytic_timeseries = nothing
        end
    else
        # Plot for sparse output: use the timeseries itself
        if sol.tslocation == 0
            plott = sol.t
            plot_timeseries = DiffEqArray(sol.u, sol.t)
            if plot_analytic
                plot_analytic_timeseries = sol.u_analytic
            else
                plot_analytic_timeseries = nothing
            end
        else
            if tspan === nothing
                plott = sol.t[start_idx:end_idx]
            else
                plott = collect(densetspacer(tspan[1], tspan[2], plotdensity))
            end

            if plot_analytic
                plot_analytic_timeseries = sol.u_analytic[start_idx:end_idx]
            else
                plot_analytic_timeseries = nothing
            end
        end
    end

    dims = length(vars[1]) - 1
    for var in vars
        @assert length(var) - 1 == dims
    end
    # Should check that all have the same dims!
    return plot_vecs,
        labels = solplot_vecs_and_labels(
        dims, vars, plott, sol,
        plot_analytic, plot_analytic_timeseries
    )
end

function interpret_vars(vars, sol)
    if vars === nothing
        # Default: plot all timeseries
        if sol[:, 1] isa Union{Tuple, AbstractArray}
            vars = collect((DEFAULT_PLOT_FUNC, 0, i) for i in plot_indices(sol[:, 1]))
        else
            vars = [(DEFAULT_PLOT_FUNC, 0, 1)]
        end
    end

    if vars isa Base.Integer
        vars = [(DEFAULT_PLOT_FUNC, 0, vars)]
    end

    if vars isa AbstractArray
        # If list given, its elements should be tuples, or we assume x = time
        tmp = Tuple[]
        for x in vars
            if x isa Tuple
                if x[1] isa Int
                    push!(tmp, tuple(DEFAULT_PLOT_FUNC, x...))
                else
                    push!(tmp, x)
                end
            else
                push!(tmp, (DEFAULT_PLOT_FUNC, 0, x))
            end
        end
        vars = tmp
    end

    if vars isa Tuple
        # If tuple given...
        if vars[end - 1] isa AbstractArray
            if vars[end] isa AbstractArray
                # If both axes are lists we zip (will fail if different lengths)
                vars = collect(
                    zip(
                        [DEFAULT_PLOT_FUNC for i in eachindex(vars[end - 1])],
                        vars[end - 1], vars[end]
                    )
                )
            else
                # Just the x axis is a list
                vars = [(DEFAULT_PLOT_FUNC, x, vars[end]) for x in vars[end - 1]]
            end
        else
            if vars[2] isa AbstractArray
                # Just the y axis is a list
                vars = [(DEFAULT_PLOT_FUNC, vars[end - 1], y) for y in vars[end]]
            else
                # Both axes are numbers
                if vars[1] isa Int || symbolic_type(vars[1]) != NotSymbolic()
                    vars = [tuple(DEFAULT_PLOT_FUNC, vars...)]
                else
                    vars = [vars]
                end
            end
        end
    end

    # Here `vars` should be a list of tuples (x, y).
    @assert(typeof(vars) <: AbstractArray)
    @assert(eltype(vars) <: Tuple)
    return vars
end

function add_labels!(labels, x, dims, sol, strs)
    if ((x[2] isa Integer && x[2] == 0) || isequal(x[2], getindepsym_defaultt(sol))) &&
            dims == 2
        push!(labels, strs[end])
    elseif x[1] !== DEFAULT_PLOT_FUNC
        push!(labels, "f($(join(strs, ',')))")
    else
        push!(labels, "($(join(strs, ',')))")
    end
    return labels
end

function add_analytic_labels!(labels, x, dims, sol, strs)
    if ((x[2] isa Integer && x[2] == 0) || isequal(x[2], getindepsym_defaultt(sol))) &&
            dims == 2
        push!(labels, "True $(strs[end])")
    elseif x[1] !== DEFAULT_PLOT_FUNC
        push!(labels, "True f($(join(strs, ',')))")
    else
        push!(labels, "True ($(join(strs, ',')))")
    end
    return labels
end

function solplot_vecs_and_labels(
        dims, vars, plott, sol, plot_analytic,
        plot_analytic_timeseries
    )
    plot_vecs = []
    labels = String[]
    varsyms = variable_symbols(sol)
    batch_symbolic_vars = []
    for x in vars
        for j in 2:length(x)
            if (x[j] isa Integer && x[j] == 0) || isequal(x[j], getindepsym_defaultt(sol))
            else
                push!(batch_symbolic_vars, x[j])
            end
        end
    end
    batch_symbolic_vars = identity.(batch_symbolic_vars)
    indexed_solution = sol(plott; idxs = batch_symbolic_vars)
    idxx = 0
    for x in vars
        tmp = []
        strs = String[]
        for j in 2:length(x)
            if (x[j] isa Integer && x[j] == 0) || isequal(x[j], getindepsym_defaultt(sol))
                push!(tmp, plott)
                push!(strs, "t")
            else
                idxx += 1
                push!(tmp, indexed_solution[idxx, :])
                if !isempty(varsyms) && x[j] isa Integer
                    push!(strs, String(getname(varsyms[x[j]])))
                elseif hasname(x[j])
                    push!(strs, String(getname(x[j])))
                else
                    push!(strs, "u[$(x[j])]")
                end
            end
        end

        f = x[1]

        tmp = map(f, tmp...)

        tmp = tuple((getindex.(tmp, i) for i in eachindex(tmp[1]))...)
        for i in eachindex(tmp)
            if length(plot_vecs) < i
                push!(plot_vecs, [])
            end
            push!(plot_vecs[i], tmp[i])
        end
        add_labels!(labels, x, dims, sol, strs)
    end

    if plot_analytic
        for x in vars
            tmp = []
            strs = String[]
            for j in 2:length(x)
                if (x[j] isa Integer && x[j] == 0)
                    push!(tmp, plott)
                    push!(strs, "t")
                elseif isequal(x[j], getindepsym_defaultt(sol))
                    push!(tmp, plott)
                    push!(strs, String(getname(x[j])))
                elseif x[j] == 1 && !(sol[:, 1] isa Union{AbstractArray, ArrayPartition})
                    push!(tmp, plot_analytic_timeseries)
                    if !isempty(varsyms) && x[j] isa Integer
                        push!(strs, String(getname(varsyms[x[j]])))
                    elseif hasname(x[j])
                        push!(strs, String(getname(x[j])))
                    else
                        push!(strs, "u[$(x[j])]")
                    end
                else
                    _tmp = Vector{eltype(sol.u[1])}(undef, length(plot_analytic_timeseries))
                    for n in 1:length(plot_analytic_timeseries)
                        _tmp[n] = plot_analytic_timeseries[n][x[j]]
                    end
                    push!(tmp, _tmp)
                    if !isempty(varsyms) && x[j] isa Integer
                        push!(strs, String(getname(varsyms[x[j]])))
                    elseif hasname(x[j])
                        push!(strs, String(getname(x[j])))
                    else
                        push!(strs, "u[$(x[j])]")
                    end
                end
            end
            f = x[1]
            tmp = map(f, tmp...)
            tmp = tuple((getindex.(tmp, i) for i in eachindex(tmp[1]))...)
            for i in eachindex(tmp)
                push!(plot_vecs[i], tmp[i])
            end
            add_analytic_labels!(labels, x, dims, sol, strs)
        end
    end
    plot_vecs = [hcat(x...) for x in plot_vecs]
    return plot_vecs, labels
end

plot_indices(A::AbstractArray) = eachindex(A)
plot_indices(A::ArrayPartition) = eachindex(A)

using Adapt, SciMLBase, Test

f(u, p) = u .* u .- p
u0 = [1.0f0, 1.0f0]

for iip in (true, false)
    prob = SciMLBase.ImmutableNonlinearProblem{iip}(f, u0, 2.0f0)
    adapted = Adapt.adapt(nothing, prob)
    @test typeof(prob) === typeof(adapted)
    @test SciMLBase.isinplace(adapted) === iip
end

using Test, SciMLBase

function showtest(x, with_color = true)
    return sprint() do io
        Base.show(IOContext(io, :color => with_color), MIME"text/plain"(), x)
    end
end

@testset "Respect :color setting in IOContext" begin
    local prob = ODEProblem((u, p, t) -> u, 1.0, (0.0, 1.0), ones(1, 1))

    # This test might be too specific
    # @test showtest(prob, true) == "\e[36mODEProblem\e[0m with uType \e[36mFloat64\e[0m and tType \e[36mFloat64\e[0m. In-place: \e[36mfalse\e[0m\ntimespan: (0.0, 1.0)\nu0: 1.0"

    # Only test whether the colorizers are printed:
    @test occursin(SciMLBase.TYPE_COLOR, showtest(prob, true))
    @test occursin(SciMLBase.NO_COLOR, showtest(prob, true))

    @test !occursin(SciMLBase.TYPE_COLOR, showtest(prob, false))
    @test !occursin(SciMLBase.NO_COLOR, showtest(prob, false))
end

using OrdinaryDiffEq, ModelingToolkit, SciMLSensitivity
using SymbolicIndexingInterface
using ModelingToolkit: t_nounits as t, D_nounits as D
using Test

# DifferentiationInterface with version-dependent backends
using DifferentiationInterface
using ADTypes
using ForwardDiff: ForwardDiff
using Mooncake: Mooncake
if VERSION < v"1.12"
    using Zygote: Zygote
    using Enzyme: Enzyme
end

function backend_name(backend::ADTypes.AbstractADType)
    return string(typeof(backend).name.name)
end

@variables x(t) o(t)
function lotka_volterra(; name = name)
    unknowns = @variables x(t) = 1.0 y(t) = 1.0 o(t)
    params = @parameters p1 = 1.5 p2 = 1.0 p3 = 3.0 p4 = 1.0
    eqs = [
        D(x) ~ p1 * x - p2 * x * y,
        D(y) ~ -p3 * y + p4 * x * y,
        o ~ x * y,
    ]
    return System(eqs, t, unknowns, params; name = name)
end

@named lotka_volterra_sys = lotka_volterra()

function make_sum_of_solution_u0(prob)
    return function (u0)
        # If `p` is passed to `remake`, MTK won't copy `u0` to initials
        # and it will be reset to the previous value
        _prob = remake(prob, u0 = u0)
        return sum(
            solve(
                _prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6, saveat = 0.1,
                sensealg = BacksolveAdjoint(autojacvec = ZygoteVJP())
            )
        )
    end
end

function make_sum_of_solution_p(prob, u0_fixed)
    return function (p)
        _prob = remake(prob, u0 = u0_fixed, p = p)
        return sum(
            solve(
                _prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6, saveat = 0.1,
                sensealg = BacksolveAdjoint(autojacvec = ZygoteVJP())
            )
        )
    end
end

function make_symbolic_indexing_u0(prob)
    return function (u0)
        _prob = remake(prob, u0 = u0)
        soln = solve(
            _prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6, saveat = 0.1,
            sensealg = BacksolveAdjoint(autojacvec = ZygoteVJP())
        )
        return sum(soln[x])
    end
end

function make_symbolic_indexing_p(prob, u0_fixed)
    return function (p)
        _prob = remake(prob, u0 = u0_fixed, p = p)
        soln = solve(
            _prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6, saveat = 0.1,
            sensealg = BacksolveAdjoint(autojacvec = ZygoteVJP())
        )
        return sum(soln[x])
    end
end

function make_symbolic_indexing_observed_u0(prob)
    return function (u0)
        _prob = remake(prob, u0 = u0)
        soln = solve(
            _prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6, saveat = 0.1,
            sensealg = BacksolveAdjoint(autojacvec = ZygoteVJP())
        )
        return sum(soln[o, i] for i in 1:length(soln))
    end
end

function make_symbolic_indexing_observed_p(prob, u0_fixed)
    return function (p)
        _prob = remake(prob, u0 = u0_fixed, p = p)
        soln = solve(
            _prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6, saveat = 0.1,
            sensealg = BacksolveAdjoint(autojacvec = ZygoteVJP())
        )
        return sum(soln[o, i] for i in 1:length(soln))
    end
end

if VERSION < v"1.12"
    backend = AutoZygote()
    derivatives = []
    @testset "`split = $split`" for split in (false, true)
        cur_ders = Dict()
        push!(derivatives, cur_ders)

        # `split = true` runs into https://github.com/JuliaDiff/ChainRules.jl/issues/830
        # for Zygote. It can be re-enabled for other backends if they are tested here.
        if split
            continue
            @test_broken false
        end
        sys = mtkcompile(lotka_volterra_sys; split)
        prob = ODEProblem(sys, [], (0.0, 10.0))
        sol = solve(prob, Tsit5(), reltol = 1.0e-6, abstol = 1.0e-6)
        setter = setsym_oop(prob, [unknowns(sys); parameters(sys)])
        u0, p = setter(prob, [1.0, 1.0, 1.5, 1.0, 1.0, 1.0])

        du01 = DifferentiationInterface.gradient(
            make_sum_of_solution_u0(prob), backend, u0
        )
        @test du01 !== nothing
        cur_ders["sum_of_solution_u0"] = du01
        dp1 = DifferentiationInterface.gradient(
            make_sum_of_solution_p(prob, u0), backend, p
        )
        @test dp1 !== nothing
        cur_ders["sum_of_solution_p"] = dp1

        du01 = DifferentiationInterface.gradient(
            make_symbolic_indexing_u0(prob), backend, u0
        )
        @test du01 !== nothing
        cur_ders["symbolic_indexing_u0"] = du01
        dp1 = DifferentiationInterface.gradient(
            make_symbolic_indexing_p(prob, u0), backend, p
        )
        @test dp1 !== nothing
        cur_ders["symbolic_indexing_p"] = dp1

        du01 = DifferentiationInterface.gradient(
            make_symbolic_indexing_observed_u0(prob), backend, u0
        )
        @test du01 !== nothing
        cur_ders["symbolic_indexing_observed_u0"] = du01
        dp1 = DifferentiationInterface.gradient(
            make_symbolic_indexing_observed_p(prob, u0), backend, p
        )
        @test dp1 !== nothing
        cur_ders["symbolic_indexing_observed_p"] = dp1
    end

    @testset "Consistent gradients" begin
        nosplit_ders, split_ders = derivatives
        ks = intersect(keys(nosplit_ders), keys(split_ders))
        @test length(ks) == 6 broken = true
        @testset "$k" for k in ks
            @test nosplit_ders[k] ≈ split_ders[k]
        end
    end
end

using SciMLBase
using SymbolicIndexingInterface
using StaticArrays
using DifferentiationInterface
using ADTypes
using ForwardDiff: ForwardDiff
using RecursiveArrayTools

probs = []
containerTypes = [Vector, Tuple, SVector{3}, MVector{3}, SizedVector{3}]
# ODE
function lorenz!(du, u, p, t)
    du[1] = p[1] * (u[2] - u[1])
    du[2] = u[1] * (p[2] - u[3]) - u[2]
    return du[3] = u[1] * u[2] - p[3] * u[3]
end
u0 = [1.0; 2.0; 3.0]
tspan = (0.0, 100.0)
p = [10.0, 20.0, 30.0]
sys = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)
indep_sys = SymbolCache([:x, :y, :z], [:a, :b, :c])
fn = ODEFunction(lorenz!; sys)
for T in containerTypes
    push!(probs, ODEProblem(fn, u0, tspan, T(p)))
end
for T in containerTypes
    push!(probs, SteadyStateProblem(fn, u0, T(p)))
end

function ddelorenz!(du, u, h, p, t)
    du[1] = p[1] * (u[2] - u[1])
    du[2] = u[1] * (p[2] - u[3]) - u[2]
    return du[3] = u[1] * u[2] - p[3] * u[3]
end

function history(p, t)
    return u0 .- t
end

fn = DDEFunction(ddelorenz!; sys)
for T in containerTypes
    push!(probs, DDEProblem(fn, u0, history, tspan, T(p)))
end

function residual!(resid, u, p, t)
    resid[1] = u[1] - 0.5
    resid[2] = u[2] - 0.5
    return resid[3] = u[3] - 0.5
end
fn = BVPFunction(lorenz!, residual!; sys)
for T in containerTypes
    push!(probs, BVProblem(fn, u0, tspan, T(p)))
end

function noise!(du, u, p, t)
    return du .= 0.1u
end
fn = SDEFunction(lorenz!, noise!; sys)
for T in containerTypes
    push!(probs, SDEProblem(fn, u0, tspan, T(p)))
end

fn = SDDEFunction(ddelorenz!, noise!; sys)
for T in containerTypes
    push!(probs, SDDEProblem(fn, noise!, u0, history, tspan, T(p)))
end

function loss(x, p)
    du = similar(x)
    lorenz!(du, u, p, 0.0)
    return sum(du)
end

fn = OptimizationFunction(loss; sys = indep_sys)

@testset "`remake(::OptimizationFunction)` works" begin
    expr = :(A + B)
    _fn = remake(fn; expr)
    @test _fn.expr == expr
end

for T in containerTypes
    push!(probs, OptimizationProblem(fn, u0, T(p)))
end

function nllorenz!(du, u, p)
    return lorenz!(du, u, p, 0.0)
end

fn = NonlinearFunction(nllorenz!; sys = indep_sys)
for T in containerTypes
    push!(probs, NonlinearProblem(fn, u0, T(p)))
end

for T in containerTypes
    push!(probs, NonlinearLeastSquaresProblem(fn, u0, T(p)))
end

update_A! = function (A, p)
    A[1, 1] = p[1]
    A[2, 2] = p[2]
    return A[3, 3] = p[3]
end
update_b! = function (b, p)
    b[1] = p[3]
    return b[2] = -8p[2] - p[1]
end
f = SciMLBase.SymbolicLinearInterface(update_A!, update_b!, indep_sys, nothing, nothing)
for T in containerTypes
    push!(probs, LinearProblem(rand(3, 3), rand(3), T(p); u0, f))
end

# temporary definition to test this functionality
function SciMLBase.late_binding_update_u0_p(
        prob, u0, p::SciMLBase.NullParameters, t0, newu0, newp
    )
    return newu0, ones(3)
end

@testset "$(SciMLBase.parameterless_type(prob)) - $(typeof(prob.p))" for prob in
    deepcopy(probs)
    prob2 = @inferred remake(prob)
    @test prob2.u0 == u0
    @test prob2.p == typeof(prob.p)(p)
    baseType = Base.typename(typeof(prob)).wrapper
    for T in containerTypes
        if T !== Tuple
            local u0 = T([2.0, 3.0, 4.0])
            prob2 = @inferred baseType remake(prob; u0 = deepcopy(u0))
            @test prob2.u0 == u0
            @test prob2.u0 isa T
        end
        local p = T([11.0, 12.0, 13.0])
        prob2 = @inferred baseType remake(prob; p = deepcopy(p))
        @test prob2.p == p
        @test prob2.p isa T
    end

    for T in [Float32, Float64]
        local u0 = [:x => T(2.0), :z => T(4.0), :y => T(3.0)]
        prob2 = @inferred baseType remake(prob; u0)
        @test all(prob2.u0 .≈ T[2.0, 3.0, 4.0])
        @test eltype(prob2.u0) == T

        local u0 = [:x => T(2.0)]
        prob2 = @inferred baseType remake(prob; u0)
        @test all(prob2.u0 .≈ [2.0, 2.0, 3.0])
        @test eltype(prob2.u0) == Float64 # partial update promotes, since fallback is Float64

        local p = [:a => T(11.0), :b => T(12.0), :c => T(13.0)]
        prob2 = @inferred baseType remake(prob; p)
        @test all(prob2.p .≈ T[11.0, 12.0, 13.0])
        @test eltype(prob2.p) == T

        local p = [:a => T(11.0)]
        prob2 = @inferred baseType remake(prob; p)
        @test all(prob2.p .≈ [11.0, 20.0, 30.0])
        if prob.p isa Tuple
            @test prob2.p isa Tuple{T, Float64, Float64}
        else
            @test eltype(prob2.p) == Float64
        end
    end

    # constant defaults
    begin
        prob.f.sys.defaults[:a] = 0.1
        prob.f.sys.defaults[:x] = 0.1
        # remake with no updates should use existing values
        prob2 = @inferred baseType remake(prob)
        @test prob2.u0 == u0
        @test prob2.p == typeof(prob.p)(p)

        # not passing use_defaults ignores defaults
        prob2 = @inferred baseType remake(prob; u0 = [:y => 0.2])
        @test prob2.u0 == [1.0, 0.2, 3.0]
        @test prob2.p == typeof(prob.p)(p)

        # respect defaults (:x), fallback to existing value (:z)
        prob2 = @inferred baseType remake(prob; u0 = [:y => 0.2], use_defaults = true)
        @test prob2.u0 ≈ [0.1, 0.2, 3.0]
        @test prob2.p == typeof(prob.p)(p) # params unaffected

        # override defaults
        prob2 = @inferred baseType remake(prob; u0 = [:x => 0.2], use_defaults = true)
        @test prob2.u0 ≈ [0.2, 2.0, 3.0]
        @test prob2.p == typeof(prob.p)(p)

        prob2 = @inferred baseType remake(prob; p = [:b => 0.2], use_defaults = true)
        @test prob2.u0 == u0
        @test all(prob2.p .≈ [0.1, 0.2, 30.0])

        prob2 = @inferred baseType remake(prob; p = [:a => 0.2], use_defaults = true)
        @test prob2.u0 == u0
        @test all(prob2.p .≈ [0.2, 20.0, 30.0])

        empty!(prob.f.sys.defaults)
    end

    # dependent defaults
    begin
        prob.f.sys.defaults[:b] = :(3a)
        prob.f.sys.defaults[:y] = :(3x)
        prob.f.sys.defaults[:z] = 9.0
        prob.f.sys.defaults[:c] = 0.9
        # remake with no updates should use existing values
        prob2 = @inferred baseType remake(prob)
        @test prob2.u0 == u0
        @test prob2.p == typeof(prob.p)(p)

        prob2 = @inferred baseType remake(prob; u0 = [:x => 0.2])
        @test prob2.u0 ≈ [0.2, 0.6, 3.0]
        @test prob2.p == typeof(prob.p)(p)

        # respect numeric defaults (:z)
        prob2 = @inferred baseType remake(prob; u0 = [:x => 0.2], use_defaults = true)
        @test prob2.u0 ≈ [0.2, 0.6, 9.0]
        @test prob2.p == typeof(prob.p)(p) # params unaffected

        # override defaults
        prob2 = @inferred baseType remake(prob; u0 = [:y => 0.2])
        @test prob2.u0 ≈ [1.0, 0.2, 3.0]
        @test prob2.p == typeof(prob.p)(p)
        prob2 = @inferred baseType remake(prob; u0 = [:y => 0.2], use_defaults = true)
        @test prob2.u0 ≈ [1.0, 0.2, 9.0]
        @test prob2.p == typeof(prob.p)(p)

        prob2 = @inferred baseType remake(prob; p = [:a => 0.2])
        @test prob2.u0 == u0
        @test all(prob2.p .≈ [0.2, 0.6, 30.0])

        prob2 = @inferred baseType remake(prob; p = [:a => 0.2], use_defaults = true)
        @test prob2.u0 == u0
        @test all(prob2.p .≈ [0.2, 0.6, 0.9])

        prob2 = @inferred baseType remake(prob; p = [:b => 0.2])
        @test prob2.u0 == u0
        @test all(prob2.p .≈ [10.0, 0.2, 30.0])
        prob2 = @inferred baseType remake(prob; p = [:b => 0.2], use_defaults = true)
        @test prob2.u0 == u0
        @test all(prob2.p .≈ [10.0, 0.2, 0.9])

        empty!(prob.f.sys.defaults)
    end

    # defaults dependent on each other (params <-> states)
    begin
        prob.f.sys.defaults[:b] = :(3x)
        prob.f.sys.defaults[:y] = :(3a)
        prob.f.sys.defaults[:x] = 0.1
        prob.f.sys.defaults[:a] = 1.0
        # remake with no updates should use existing values
        prob2 = @inferred baseType remake(prob)
        @test prob2.u0 == u0
        @test prob2.p == typeof(prob.p)(p)

        # Dependency ignored since `p` was not changed
        prob2 = @inferred baseType remake(prob; u0 = [:x => 0.2])
        @test prob2.u0 ≈ [0.2, 30.0, 3.0]
        @test prob2.p == typeof(prob.p)(p)

        # need to pass empty `Dict()` to prevent defaulting to existing values
        prob2 = @inferred baseType remake(
            prob; u0 = [:x => 0.2], p = Dict()
        )
        @test prob2.u0 ≈ [0.2, 30.0, 3.0]
        @test all(prob2.p .≈ [10.0, 0.6, 30.0])

        prob2 = @inferred baseType remake(
            prob; u0 = [:x => 0.2], p = Dict(), use_defaults = true
        )
        @test prob2.u0 ≈ [0.2, 3.0, 3.0]
        @test all(prob2.p .≈ [1.0, 0.6, 30.0])

        # override defaults
        prob2 = @inferred baseType remake(
            prob; u0 = [:y => 0.2], p = Dict()
        )
        @test prob2.u0 ≈ [1.0, 0.2, 3.0]
        @test all(prob2.p .≈ [10.0, 3.0, 30.0])
        prob2 = @inferred baseType remake(
            prob; u0 = [:y => 0.2], p = Dict(), use_defaults = true
        )
        @test prob2.u0 ≈ [0.1, 0.2, 3.0]
        @test all(prob2.p .≈ [1.0, 0.3, 30.0])

        prob2 = @inferred baseType remake(
            prob; p = [:a => 0.2], u0 = Dict()
        )
        @test prob2.u0 ≈ [1.0, 0.6, 3.0]
        @test all(prob2.p .≈ [0.2, 3.0, 30.0])
        prob2 = @inferred baseType remake(
            prob; p = [:a => 0.2], u0 = Dict(), use_defaults = true
        )
        @test prob2.u0 ≈ [0.1, 0.6, 3.0]
        @test all(prob2.p .≈ [0.2, 0.3, 30.0])

        prob2 = @inferred baseType remake(
            prob; p = [:b => 0.2], u0 = Dict()
        )
        @test prob2.u0 ≈ [1.0, 30.0, 3.0]
        @test all(prob2.p .≈ [10.0, 0.2, 30.0])
        prob2 = @inferred baseType remake(
            prob; p = [:b => 0.2], u0 = Dict(), use_defaults = true
        )
        @test prob2.u0 ≈ [0.1, 3.0, 3.0]
        @test all(prob2.p .≈ [1.0, 0.2, 30.0])

        empty!(prob.f.sys.defaults)
    end

    if !isa(prob.p, Tuple)
        function fakeloss!(p)
            prob2 = @inferred baseType remake(prob; p = [:a => p])
            @test eltype(prob2.p) <: ForwardDiff.Dual
            return prob2.ps[:a]
        end
        DifferentiationInterface.derivative(fakeloss!, AutoForwardDiff(), 1.0)
    end

    # test late_binding_update_u0_p
    prob2 = remake(prob; p = SciMLBase.NullParameters())
    @test prob2.p ≈ ones(3)
end

# delete the method defined here to prevent breaking other tests
Base.delete_method(only(methods(SciMLBase.late_binding_update_u0_p, @__MODULE__)))

# eltype(()) <: Pair, so ensure that this doesn't error
function lorenz!(du, u, _, t)
    du[1] = 1 * (u[2] - u[1])
    du[2] = u[1] * (2 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - 3 * u[3]
end
u0 = [1.0; 2.0; 3.0]
tspan = (0.0, 100.0)
prob = ODEProblem(lorenz!, u0, tspan, nothing)
@test_nowarn remake(prob, p = (), interpret_symbolicmap = true)

# IntervalNonlinearProblem doesn't have a u0
# Issue#726
interval_f(u, p) = u * u - 2.0 + p[1]
uspan = (1.0, 2.0)
interval_prob = IntervalNonlinearProblem(interval_f, uspan)
new_prob = @inferred IntervalNonlinearProblem remake(interval_prob; p = [0])
@test new_prob.p == [0]

# SDEProblem specific
function noise2!(du, u, p, t)
    return du .= 0.2u
end
fn = SDEFunction(lorenz!, noise!; sys)
sdeprob = SDEProblem(fn, u0, tspan, Tuple(p))
newprob = remake(sdeprob; g = noise2!)
@test newprob.f isa SDEFunction
tmp = newprob.g([0.0, 0.0, 0.0], [1.0, 2.0, 3.0], nothing, 0.0)
@test tmp ≈ [0.2, 0.4, 0.6] atol = 1.0e-6

struct Remake_Test1
    p::Any
    args::Any
    kwargs::Any
end
Remake_Test1(args...; p, kwargs...) = Remake_Test1(p, args, kwargs)
a = Remake_Test1(p = 1)
@test @inferred remake(a, p = 2) == Remake_Test1(p = 2)
@test @inferred remake(a, args = 1) == Remake_Test1(1, p = 1)
@test @inferred remake(a, kwargs = (; a = 1)) == Remake_Test1(p = 1, a = 1)

@testset "fill_u0 and fill_p ignore identical variables with different names" begin
    struct SCWrapper{S}
        sc::S
    end
    SymbolicIndexingInterface.symbolic_container(s::SCWrapper) = s.sc
    function SymbolicIndexingInterface.is_variable(s::SCWrapper, i::Symbol)
        if i == :x2
            return is_variable(s.sc, :x)
        end
        is_variable(s.sc, i)
    end
    function SymbolicIndexingInterface.variable_index(s::SCWrapper, i::Symbol)
        if i == :x2
            return variable_index(s.sc, :x)
        end
        variable_index(s.sc, i)
    end
    function SymbolicIndexingInterface.is_parameter(s::SCWrapper, i::Symbol)
        if i == :a2
            return is_parameter(s.sc, :a)
        end
        is_parameter(s.sc, i)
    end
    function SymbolicIndexingInterface.parameter_index(s::SCWrapper, i::Symbol)
        if i == :a2
            return parameter_index(s.sc, :a)
        end
        parameter_index(s.sc, i)
    end
    sys = SCWrapper(
        SymbolCache(
            Dict(:x => 1, :y => 2), Dict(:a => 1, :b => 2),
            :t; defaults = Dict(:x => 1, :y => 2, :a => 3, :b => 4)
        )
    )
    function foo(du, u, p, t)
        du .= u .* p
    end
    prob = ODEProblem(ODEFunction(foo; sys), [1.5, 2.5], (0.0, 1.0), [3.5, 4.5])
    u0 = Dict(:x2 => 2)
    newu0 = SciMLBase.fill_u0(prob, u0; defs = default_values(sys))
    @test length(newu0) == 2
    @test get(newu0, :x, 0) == 2
    @test get(newu0, :y, 0) == 2.5
    p = Dict(:a2 => 3)
    newp = SciMLBase.fill_p(prob, p; defs = default_values(sys))
    @test length(newp) == 2
    @test get(newp, :a, 0) == 3
    @test get(newp, :b, 0) == 4.5
end

@testset "value of `nothing` is ignored" begin
    sys = SymbolCache(
        Dict(:x => 1, :y => 2), Dict(:a => 1, :b => 2),
        :t; defaults = Dict(:x => 1, :y => 2, :a => 3, :b => 4)
    )
    function foo(du, u, p, t)
        du .= u .* p
    end
    prob = ODEProblem(ODEFunction(foo; sys), [1.5, 2.5], (0.0, 1.0), [3.5, 4.5])
    @test_nowarn remake(prob; u0 = [:x => nothing], p = [:a => nothing])
end

@testset "retain properties of `SciMLFunction` passed to `remake`" begin
    u0 = [1.0; 2.0; 3.0]
    p = [10.0, 20.0, 30.0]
    sys = SymbolCache([:x, :y, :z], [:a, :b, :c], :t)
    fn = NonlinearFunction(nllorenz!; sys, resid_prototype = zeros(Float64, 3))
    prob = NonlinearProblem(fn, u0, p)
    fn2 = NonlinearFunction(nllorenz!; resid_prototype = zeros(Float32, 3))
    prob2 = remake(prob; f = fn2)
    @test prob2.f.resid_prototype isa Vector{Float32}
end

@testset "`remake(::HomotopyNonlinearFunction)`" begin
    f! = function (du, u, p)
        du[1] = u[1] * u[1] - p[1] * u[2] + u[2]^3 + 1
        du[2] = u[2]^3 + 2 * p[2] * u[1] * u[2] + u[2]
    end

    fjac! = function (j, u, p)
        j[1, 1] = 2u[1]
        j[1, 2] = -p[1] + 3 * u[2]^2
        j[2, 1] = 2 * p[2] * u[2]
        j[2, 2] = 3 * u[2]^2 + 2 * p[2] * u[1] + 1
    end
    fn = NonlinearFunction(f!; jac = fjac!)
    fn = HomotopyNonlinearFunction(fn)
    prob = NonlinearProblem(fn, ones(2), ones(2))
    @test prob.f.f.jac == fjac!
    prob2 = remake(prob; u0 = zeros(2))
    @test prob2.f.f.jac == fjac!
end

@testset "Issue#925: `remake` retains specialization of explicit `f`" begin
    f = ODEFunction{false, SciMLBase.FullSpecialize}((u, p, t) -> u)
    prob = ODEProblem(f, nothing, nothing)
    @test SciMLBase.specialization(prob.f) == SciMLBase.FullSpecialize
    prob2 = remake(ODEProblem((u, p, t) -> 2 .* u, nothing, nothing); f = f)
    @test SciMLBase.specialization(prob2.f) == SciMLBase.FullSpecialize
end

@testset "`remake(::LinearProblem)` without a system" begin
    prob = LinearProblem{true}(rand(3, 3), rand(3))
    @inferred remake(prob)
    base_allocs = @allocations remake(prob)
    A = ones(3, 3)
    b = ones(3)
    u0 = ones(3)
    p = "P"
    @inferred remake(prob; A, b, u0, p)
    @test (@allocations remake(prob; A, b, u0, p)) <= base_allocs

    prob2 = remake(prob; u0)
    @test prob2.u0 === u0
    prob2 = remake(prob; A = SMatrix{3, 3}(A))
    @test prob2.A isa SMatrix{3, 3}
end

@testset "Issue#1267: `anyeltypedual` ambiguity" begin
    ts = 0.0:0.1:10.0
    f1(t) = t - 1
    f2(t) = t^2
    vals = [[f1(t), f2(t)] for t in ts]
    sol = DiffEqArray(vals, ts)
    @test SciMLBase.anyeltypedual(sol, Val{0}) == Any
end

using ModelingToolkit, SymbolicIndexingInterface
using JumpProcesses
using ModelingToolkit: t_nounits as t, D_nounits as D
using OrdinaryDiffEq
using DiffEqNoiseProcess
using Optimization
using OptimizationOptimJL
using ForwardDiff
using SciMLStructures
using Test

probs = []
syss = []

@parameters σ ρ β q
@variables x(t) y(t) z(t)

eqs = [
    D(x) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
]

@named sys = System(eqs, t, [x, y, z], [σ, ρ, β, q]; bindings = [q => 3β])
sys = complete(sys)
u0 = [
    x => 1.0,
    y => 0.0,
    z => 0.0,
]

p = [
    σ => 28.0,
    ρ => 10.0,
    β => 8 / 3,
]

tspan = (0.0, 100.0)

push!(syss, sys)
push!(probs, ODEProblem(sys, [u0; p], tspan, jac = true))

push!(syss, sys)
push!(probs, SteadyStateProblem(ODEProblem(sys, [u0; p], tspan, jac = true)))

noise_eqs = [0.1x, 0.1y, 0.1z]
@named sdesys = SDESystem(sys, noise_eqs)
sdesys = complete(sdesys)

push!(syss, sdesys)
push!(probs, SDEProblem(sdesys, [u0; p], tspan, jac = true))

@named nsys = System([0 ~ eq.rhs for eq in eqs], [x, y, z], [σ, β, ρ])
nsys = complete(nsys)

push!(syss, nsys)
push!(probs, NonlinearProblem(nsys, [u0; p], jac = true))

rate₁ = β * x * y
affect₁ = [x ~ Pre(x) - σ, y ~ Pre(y) + σ]
rate₂ = ρ * y
affect₂ = [y ~ Pre(y) - 1, z ~ Pre(z) + 1]
j₁ = ConstantRateJump(rate₁, affect₁)
j₂ = ConstantRateJump(rate₂, affect₂)
j₃ = MassActionJump(2 * β + ρ, [z => 1], [x => 1, z => -1]; scale_rates = false)
@named js = JumpSystem([j₁, j₂, j₃], t, [x, y, z], [σ, β, ρ])
js = complete(js)

push!(syss, js)
push!(probs, JumpProblem(js, [u0; p], tspan; aggregator = Direct()))

@named optsys = OptimizationSystem(sum(eq.lhs for eq in eqs), [x, y, z], [σ, ρ, β])
optsys = complete(optsys)
push!(syss, optsys)
push!(probs, OptimizationProblem(optsys, [u0; p]))

@mtkcompile sys = System(
    [0 ~ x^3 * β + y^3 * ρ - σ, 0 ~ x^2 + 2x * y + y^2, 0 ~ z^2 - 4z + 4],
    [x, y, z], [σ, β, ρ]
)
sccprob = SCCNonlinearProblem(sys, [u0; p])
@test_nowarn SciMLBase.initialization_status(sccprob)
push!(syss, sys)
push!(probs, sccprob)

for (sys, prob) in zip(syss, probs)
    @test parameter_values(prob) isa ModelingToolkit.MTKParameters

    @inferred typeof(prob) remake(prob)

    baseType = Base.typename(typeof(prob)).wrapper
    ugetter = getsym(prob, [x, y, z])
    prob2 = @inferred baseType remake(prob; u0 = [x => 2.0, y => 3.0, z => 4.0])
    @test ugetter(prob2) == [2.0, 3.0, 4.0]
    prob2 = @inferred baseType remake(prob; u0 = [sys.x => 2.0, sys.y => 3.0, sys.z => 4.0])
    @test ugetter(prob2) == [2.0, 3.0, 4.0]
    prob2 = @inferred baseType remake(prob; u0 = [:x => 2.0, :y => 3.0, :z => 4.0])
    @test ugetter(prob2) == [2.0, 3.0, 4.0]
    prob2 = @inferred baseType remake(prob; u0 = [x => 2.0, sys.y => 3.0, :z => 4.0])
    @test ugetter(prob2) == [2.0, 3.0, 4.0]

    prob2 = @inferred baseType remake(prob; u0 = [x => 12.0])
    @test ugetter(prob2) == [12.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [sys.x => 12.0])
    @test ugetter(prob2) == [12.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [:x => 12.0])
    @test ugetter(prob2) == [12.0, 0.0, 0.0]

    pgetter = getp(prob, [σ, β, ρ])
    prob2 = @inferred baseType remake(prob; p = [σ => 0.1, β => 0.2, ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end
    prob2 = @inferred baseType remake(prob; p = [sys.σ => 0.1, sys.β => 0.2, sys.ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end
    prob2 = @inferred baseType remake(prob; p = [:σ => 0.1, :β => 0.2, :ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end
    prob2 = @inferred baseType remake(prob; p = [σ => 0.1, sys.β => 0.2, :ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end

    prob2 = @inferred baseType remake(prob; p = [σ => 0.5])
    @test pgetter(prob2) == [0.5, 8 / 3, 10.0]
    prob2 = @inferred baseType remake(prob; p = [sys.σ => 0.5])
    @test pgetter(prob2) == [0.5, 8 / 3, 10.0]
    prob2 = @inferred baseType remake(prob; p = [:σ => 0.5])
    @test pgetter(prob2) == [0.5, 8 / 3, 10.0]

    # Test p dependent on u0
    prob2 = @inferred baseType remake(prob; p = [σ => 0.5x + 1])
    @test pgetter(prob2) ≈ [1.5, 8 / 3, 10.0]
    prob2 = @inferred baseType remake(prob; p = [sys.σ => 0.5x + 1])
    @test pgetter(prob2) ≈ [1.5, 8 / 3, 10.0]
    prob2 = @inferred baseType remake(prob; p = [:σ => 0.5x + 1])
    @test pgetter(prob2) ≈ [1.5, 8 / 3, 10.0]

    # Test u0 dependent on p
    prob2 = @inferred baseType remake(prob; u0 = [x => 0.5σ + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [sys.x => 0.5σ + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [:x => 0.5σ + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]

    # Test u0 dependent on p and p dependent on u0
    prob2 = @inferred baseType remake(prob; u0 = [x => 0.5σ + 1], p = [β => 0.5x + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    @test pgetter(prob2) ≈ [28.0, 8.5, 10.0]
    prob2 = @inferred baseType remake(
        prob; u0 = [sys.x => 0.5σ + 1], p = [sys.β => 0.5x + 1]
    )
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    @test pgetter(prob2) ≈ [28.0, 8.5, 10.0]
    # Not testing `Symbol => expr` since nested substitution doesn't work with that
end

@testset "DiscreteProblem" begin
    k = ShiftIndex(t)
    @mtkcompile discsys = System(
        [
            x ~ x(k - 1) * ρ + y(k - 2), y ~ y(k - 1) * σ - z(k - 2), z ~
                z(k - 1) * β +
                x(k - 2),
        ],
        t; initial_conditions = [
            x => 1.0, y => 1.0, z => 1.0, x(k - 1) => 0.0, y(k - 1) => 0.0, z(k - 1) => 0.0,
        ]
    )
    prob = DiscreteProblem(discsys, p, (0, 10))
    prob[x(k - 1)] = 1.0
    prob[y(k - 1)] = prob[z(k - 1)] = 0.0

    @test parameter_values(prob) isa ModelingToolkit.MTKParameters
    @inferred typeof(prob) remake(prob)

    baseType = Base.typename(typeof(prob)).wrapper
    ugetter = getsym(prob, [x(k - 1), y(k - 1), z(k - 1)])
    prob2 = @inferred baseType remake(
        prob; u0 = [
            x(k - 1) => 2.0, y(k - 1) => 3.0, z(k - 1) => 4.0,
        ]
    )
    @test ugetter(prob2) == [2.0, 3.0, 4.0]
    prob2 = @inferred baseType remake(
        prob; u0 = [
            sys.x(k - 1) => 2.0, sys.y(k - 1) => 3.0, sys.z(k - 1) => 4.0,
        ]
    )
    @test ugetter(prob2) == [2.0, 3.0, 4.0]
    prob2 = @inferred baseType remake(prob; u0 = [:xₜ₋₁ => 2.0, :yₜ₋₁ => 3.0, :zₜ₋₁ => 4.0])
    @test ugetter(prob2) == [2.0, 3.0, 4.0]
    prob2 = @inferred baseType remake(
        prob; u0 = [
            x(k - 1) => 2.0, sys.y(k - 1) => 3.0, :zₜ₋₁ => 4.0,
        ]
    )
    @test ugetter(prob2) == [2.0, 3.0, 4.0]

    prob2 = @inferred baseType remake(prob; u0 = [x(k - 1) => 12.0])
    @test ugetter(prob2) == [12.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [sys.x(k - 1) => 12.0])
    @test ugetter(prob2) == [12.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [:xₜ₋₁ => 12.0])
    @test ugetter(prob2) == [12.0, 0.0, 0.0]

    pgetter = getp(prob, [σ, β, ρ])
    prob2 = @inferred baseType remake(prob; p = [σ => 0.1, β => 0.2, ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end
    prob2 = @inferred baseType remake(prob; p = [sys.σ => 0.1, sys.β => 0.2, sys.ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end
    prob2 = @inferred baseType remake(prob; p = [:σ => 0.1, :β => 0.2, :ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end
    prob2 = @inferred baseType remake(prob; p = [σ => 0.1, sys.β => 0.2, :ρ => 0.3])
    @test pgetter(prob2) == [0.1, 0.2, 0.3]
    if prob isa ODEProblem
        @test prob2.ps[q] ≈ 0.6
    end

    prob2 = @inferred baseType remake(prob; p = [σ => 0.5])
    @test pgetter(prob2) == [0.5, 8 / 3, 10.0]
    prob2 = @inferred baseType remake(prob; p = [sys.σ => 0.5])
    @test pgetter(prob2) == [0.5, 8 / 3, 10.0]
    prob2 = @inferred baseType remake(prob; p = [:σ => 0.5])
    @test pgetter(prob2) == [0.5, 8 / 3, 10.0]

    # Test p dependent on u0
    @test_broken begin
        prob2 = @inferred baseType remake(prob; p = [σ => 0.5x(k - 1) + 1])
        @test pgetter(prob2) ≈ [1.5, 8 / 3, 10.0]
        prob2 = @inferred baseType remake(prob; p = [sys.σ => 0.5x(k - 1) + 1])
        @test pgetter(prob2) ≈ [1.5, 8 / 3, 10.0]
        prob2 = @inferred baseType remake(prob; p = [:σ => 0.5x(k - 1) + 1])
        @test pgetter(prob2) ≈ [1.5, 8 / 3, 10.0]
    end

    # Test u0 dependent on p
    prob2 = @inferred baseType remake(prob; u0 = [x(k - 1) => 0.5σ + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [sys.x(k - 1) => 0.5σ + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    prob2 = @inferred baseType remake(prob; u0 = [:xₜ₋₁ => 0.5σ + 1])
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]

    # Test u0 dependent on p and p dependent on u0
    prob2 = @inferred baseType remake(
        prob; u0 = [x(k - 1) => 0.5σ + 1], p = [
            β => 0.5x(k - 1) +
                1,
        ]
    )
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    @test_broken pgetter(prob2) ≈ [28.0, 8.5, 10.0]
    prob2 = @inferred baseType remake(
        prob; u0 = [sys.x(k - 1) => 0.5σ + 1], p = [sys.β => 0.5x(k - 1) + 1]
    )
    @test ugetter(prob2) ≈ [15.0, 0.0, 0.0]
    @test_broken pgetter(prob2) ≈ [28.0, 8.5, 10.0]
    # Not testing `Symbol => expr` since nested substitution doesn't work with that
end

# Optimization
@parameters p
@mtkcompile sys = System([D(x) ~ -p * x], t)
odeprob = ODEProblem(sys, [x => 1.0, p => 0.5], (0.0, 10.0))

ts = 0.0:0.5:10.0
data = exp.(-2.5 .* ts)

function loss(x, p)
    prob = p[1]

    prob = @inferred ODEProblem remake(
        prob; p = [prob.f.sys.p => x[1]], u0 = typeof(x)(prob.u0)
    )
    sol = solve(prob, Tsit5())
    vals = sol(ts; idxs = prob.f.sys.x).u
    return sum((data .- vals) .^ 2) / length(ts)
end

f = OptimizationFunction(loss, Optimization.AutoForwardDiff())
prob = OptimizationProblem(f, [0.5], [odeprob])
sol = solve(prob, BFGS())
@test sol.u[1] ≈ 2.5 rtol = 1.0e-4

# Issue ModelingToolkit.jl#2637
@testset "remake with defaults containing expressions" begin
    @variables x(t)
    @parameters P

    for sign in [+1.0, -1.0]
        @named sys = System([D(x) ~ P], t, [x], [P]; initial_conditions = [P => sign * x]) # set P from initial condition of x
        sys = complete(sys)

        prob1 = ODEProblem(sys, [x => 1.0], (0.0, 1.0))
        @test prob1.ps[P] == sign * 1.0

        prob2 = remake(prob1; u0 = [x => 2.0], p = Dict(), use_defaults = true) # use defaults to update parameters
        @test prob2.ps[P] == sign * 2.0
    end
end

@testset "remake with Vector{Int} as index of array variable/parameter" begin
    @parameters k[1:4]
    @variables (V(t))[1:2]
    function rhs!(du, u, p, t)
        du[1] = p[1] - p[2] * u[1]
        du[2] = p[3] - p[4] * u[2]
        nothing
    end
    sys = SymbolCache(
        Dict(V => 1:2, V[1] => 1, V[2] => 2),
        Dict(k => 1:4, k[1] => 1, k[2] => 2, k[3] => 3, k[4] => 4), t
    )
    struct SCWrapper{S}
        sys::S
    end
    SymbolicIndexingInterface.symbolic_container(s::SCWrapper) = s.sys
    SymbolicIndexingInterface.variable_symbols(s::SCWrapper) = filter(
        x -> symbolic_type(x) != ArraySymbolic(), variable_symbols(s.sys)
    )
    SymbolicIndexingInterface.parameter_symbols(s::SCWrapper) = filter(
        x -> symbolic_type(x) != ArraySymbolic(), parameter_symbols(s.sys)
    )
    sys = SCWrapper(sys)
    fn = ODEFunction(rhs!; sys)
    oprob_scal_scal = ODEProblem(fn, [10.0, 20.0], (0.0, 1.0), [1.0, 2.0, 3.0, 4.0])
    ps_vec = [k => [2.0, 3.0, 4.0, 5.0]]
    u0_vec = [V => [1.5, 2.5]]
    newoprob = remake(oprob_scal_scal; u0 = u0_vec, p = ps_vec)
    @test newoprob.ps[k] == [2.0, 3.0, 4.0, 5.0]
    @test newoprob[V] == [1.5, 2.5]
end

@testset "remake with parameter dependent on observed" begin
    @variables x(t) y(t)
    @parameters p = missing
    @mtkcompile sys = System([D(x) ~ x, p ~ x + y], t)
    prob = ODEProblem(sys, [x => 1.0, y => 2.0], (0.0, 1.0))
    @test prob.ps[p] ≈ 3.0
    prob2 = remake(prob; u0 = [y => 3.0], p = Dict())
    @test prob2.ps[p] ≈ 4.0
end

@testset "u0 dependent on parameter given as Symbol" begin
    @variables x(t)
    @parameters p
    @mtkcompile sys = System([D(x) ~ x * p], t)
    prob = ODEProblem(sys, [x => 1.0, p => 1.0], (0.0, 1.0))
    @test prob.ps[p] ≈ 1.0
    prob2 = remake(prob; u0 = [x => p], p = [:p => 2.0])
    @test prob2[x] ≈ 2.0
end

@testset "remake dependent on indepvar" begin
    @variables x(t)
    @parameters p
    @mtkcompile sys = System([D(x) ~ x * p], t)
    prob = ODEProblem(sys, [x => 1.0, p => 1.0], (0.0, 1.0))
    prob2 = remake(prob; u0 = [x => t + 3.0])
    @test prob2[x] ≈ 3.0
end

@static if length(methods(SciMLBase.detect_cycles)) == 1
    function SciMLBase.detect_cycles(
            ::ModelingToolkit.AbstractSystem, varmap::Dict{Any, Any}, vars
        )
        for sym in vars
            newval = ModelingToolkit.fixpoint_sub(sym, varmap; maxiters = 10)
            vs = ModelingToolkit.vars(newval)
            if !isempty(vars) && any(in(Set(vars)), vs)
                NotSymbolic()
                return true
            end
        end
        return false
    end
end

@testset "Cycle detection" begin
    @variables x(t) y(t)
    @parameters p q
    @mtkcompile sys = System([D(x) ~ x * p, D(y) ~ y * q], t)

    prob = ODEProblem(sys, [x => 1.0, y => 1.0, p => 1.0, q => 1.0], (0.0, 1.0))
    @test_throws SciMLBase.CyclicDependencyError remake(
        prob; u0 = [x => 2y + 3, y => 2x + 1]
    )
    @test_throws SciMLBase.CyclicDependencyError remake(prob; p = [p => 2q + 1, q => p + 3])
    @test_throws SciMLBase.CyclicDependencyError remake(
        prob; u0 = [x => 2y + p, y => q + 3], p = [p => x + y, q => p + 3]
    )
end

@testset "SCCNonlinearProblem" begin
    @mtkbuild fullsys = System(
        [0 ~ x^3 * β + y^3 * ρ - σ, 0 ~ x^2 + 2x * y + y^2, 0 ~ z^2 - 4z + 4],
        [x, y, z], [σ, β, ρ]
    )

    u0 = [
        x => 1.0,
        y => 0.0,
        z => 0.0,
    ]

    p = [
        σ => 28.0,
        ρ => 10.0,
        β => 8 / 3,
    ]

    sccprob = SCCNonlinearProblem(fullsys, [u0; p])

    sccprob2 = remake(sccprob; u0 = 2ones(3))
    @test state_values(sccprob2) ≈ 2ones(3)
    prob1, prob2 = if length(state_values(sccprob2.probs[1])) == 1
        sccprob2.probs[2], sccprob2.probs[1]
    else
        sccprob2.probs[1], sccprob2.probs[2]
    end
    @test prob1.u0 ≈ 2ones(2)
    @test prob2.u0 ≈ 2ones(1)
    @test sccprob2.explicitfuns! !== missing
    @test sccprob2.f.sys !== missing

    sccprob3 = remake(sccprob; p = [σ => 2.0])
    @test sccprob3.p === sccprob3.probs[1].p
    @test sccprob3.p === sccprob3.probs[2].p

    @test_throws ["parameters_alias", "SCCNonlinearProblem"] remake(
        sccprob; parameters_alias = false, p = [σ => 2.0]
    )

    newp = remake_buffer(sccprob.f.sys, sccprob.p, [σ], [3.0])
    sccprob4 = remake(
        sccprob; parameters_alias = false, p = newp,
        probs = [remake(sccprob.probs[1]; p = deepcopy(newp)), sccprob.probs[2]]
    )
    @test sccprob4.parameters_alias === Val(false)
    @test sccprob4.p !== sccprob4.probs[1].p
    @test sccprob4.p !== sccprob4.probs[2].p
end

# TODO: Rewrite this test when MTK build initialization for everything
@testset "Lazy initialization" begin
    @variables _x(..) [guess = 1.0] y(t) [guess = 1.0]
    @parameters p = 1.0 [guess = 1.0]
    @brownians a
    x = _x(t)

    initprob = NonlinearProblem(nothing) do args...
        return 0.0
    end
    iprobmap = (_...) -> [1.0, 1.0]
    iprobpmap = function (orig, sol)
        ps = parameter_values(orig)
        setp(orig, p)(ps, 3.0)
        return ps
    end
    initdata = SciMLBase.OverrideInitData(initprob, nothing, iprobmap, iprobpmap)
    @test SciMLBase.is_trivial_initialization(initdata)

    @testset "$Problem" for (rhss, Problem, Func) in [
            (0.0, ODEProblem, ODEFunction),
            (a, SDEProblem, SDEFunction),
            (_x(t - 0.1), DDEProblem, DDEFunction),
            (_x(t - 0.1) + a, SDDEProblem, SDDEFunction),
            (y + 2, NonlinearProblem, NonlinearFunction),
            (y + 2, NonlinearLeastSquaresProblem, NonlinearFunction),
        ]
        is_nlsolve = Func == NonlinearFunction
        D = is_nlsolve ? (v) -> v^3 : Differential(t)
        sys_args = is_nlsolve ? () : (t,)
        prob_args = is_nlsolve ? () : ((0.0, 1.0),)

        @mtkcompile sys = System([D(x) ~ x + rhss, x + y ~ p], sys_args...)
        prob = Problem(sys, [x => 1.0, y => 1.0], prob_args...)
        func_args = isdefined(prob.f, :g) ? (prob.f.g,) : ()
        func = Func{true, SciMLBase.FullSpecialize}(
            prob.f.f, func_args...; initialization_data = initdata, sys = prob.f.sys
        )
        prob2 = remake(prob; f = func)
        @test SciMLBase.is_trivial_initialization(prob2)
        @test prob2.ps[p] ≈ 3.0
    end
end

# https://github.com/SciML/ModelingToolkit.jl/issues/3326
@testset "Remake with non-substitute-able values" begin
    @variables x1(t) x2(t) y(t)
    @parameters k2 p Gamma y0 d k1
    @mtkcompile sys = System(
        [D(y) ~ p - d * y, D(x1) ~ -k1 * x1 + k2 * (Gamma - x1), x2 ~ Gamma - x1],
        t, [x1, x2, y], [k2, p, Gamma, y0, d, k1]; initial_conditions = Dict(y => y0, Gamma => x1 + x2)
    )
    u0 = [x1 => 1.0, x2 => 2.0]
    p0 = [p => 10.0, d => 5.0, y0 => 3.0, k1 => 1.0, k2 => 2.0]
    prob = ODEProblem(sys, [u0; p0], (0.0, 1.0))
    u0_new = [x1 => 0.1]
    ps_new = [y0 => 0.3, p => 100.0]
    prob2 = remake(prob; u0 = u0_new, p = ps_new)
    @test prob2[x1] ≈ 0.1
    @test prob2[y] ≈ 0.3
    # old value retained
    @test prob2.ps[Gamma] ≈ 3.0
end

@testset "`nothing` value for variable specified as `Symbol`" begin
    @variables x(t) [guess = 1.0] y(t) [guess = 1.0]
    @parameters p [guess = 1.0] q [guess = 1.0]
    @mtkcompile sys = System(
        [D(x) ~ p * x + q * y, y ~ 2x], t; bindings = [q => 2p]
    )
    prob = ODEProblem(sys, [:x => 1.0, p => 1.0], (0.0, 1.0))
    @test_nowarn remake(prob; u0 = [:y => 1.0, :x => nothing])
end

@testset "`initialization_data` u0 and p are promoted with explicit `f`" begin
    @variables x(t) [guess = 1.0] y(t) [guess = 1.0]
    @parameters p q
    @mtkcompile sys = System([D(x) ~ x, (x - p)^2 + (y - q)^3 ~ 0], t)
    prob = ODEProblem(sys, [x => 1.0, p => 1.0, q => 2.0], (0.0, 1.0))
    @test prob.f.initialization_data !== nothing
    buf, repack, _ = SciMLStructures.canonicalize(SciMLStructures.Tunable(), prob.p)
    newps = repack(ForwardDiff.Dual.(buf))
    prob2 = @test_nowarn remake(
        prob; f = prob.f, u0 = ForwardDiff.Dual.(prob.u0), p = newps
    )
    @test prob2.f.initialization_data !== nothing
    initprob = prob2.f.initialization_data.initializeprob
    @test eltype(initprob.u0) <: ForwardDiff.Dual
    @test eltype(SciMLStructures.canonicalize(SciMLStructures.Tunable(), initprob.p)[1]) <:
    ForwardDiff.Dual
end

@testset "Array unknown specified as Symbol" begin
    @variables x(t)[1:2]
    @parameters k
    @mtkcompile sys = System([D(x[1]) ~ k * x[1], D(x[2]) ~ -x[2]], t)
    prob = ODEProblem(sys, [x => ones(2), k => 2.0], (0.0, 1.0))
    prob2 = remake(prob; u0 = [:x => 2ones(2)])
end

"""
    promote_tspan(tspan)

Convert the `tspan` field of a `AbstractDEProblem` to a `(tmin, tmax)` tuple, where both
elements are of the same type. If `tspan` is a function, returns it as-is.
"""
promote_tspan((t1, t2)::Tuple{T, S}) where {T, S} = promote(t1, t2)
promote_tspan(tspan::Number) = (zero(tspan), tspan)
promote_tspan(tspan::Nothing) = (nothing, nothing)
promote_tspan(tspan::Function) = tspan
function promote_tspan(tspan::AbstractArray)
    return length(tspan) == 2 ? promote_tspan((first(tspan), last(tspan))) :
        throw(error("The length of tspan must be two (and preferably, tspan should be a tuple, i.e. (0.0,1.0)). If you are trying to include other values for saving reasons, see the [common solver arguments page](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/) for information on the saving command saveat."))
end

### Displays

function Base.summary(io::IO, prob::AbstractDEProblem)
    type_color, no_color = get_colorizers(io)
    print(
        io,
        type_color, nameof(typeof(prob)),
        no_color, " with uType ",
        type_color, typeof(prob.u0),
        no_color, " and tType ",
        type_color,
        prob.tspan isa Function ?
            "Unknown" : (
                prob.tspan === nothing ?
                "Nothing" : typeof(prob.tspan[1])
            ),
        no_color,
        ". In-place: ", type_color, isinplace(prob), no_color
    )
    init = initialization_status(prob)
    !isnothing(init) && begin
        println(io)
        print(
            io, "Initialization status: ", type_color,
            initialization_status(prob), no_color
        )
    end

    return hasproperty(prob.f, :mass_matrix) && begin
        println(io)
        print(
            io, "Non-trivial mass matrix: ", type_color,
            !(prob.f.mass_matrix isa LinearAlgebra.UniformScaling{Bool}), no_color
        )
    end
end

function Base.summary(io::IO, prob::AbstractLinearProblem)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(prob)),
        no_color, ". In-place: ",
        type_color, isinplace(prob),
        no_color
    )
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractLinearProblem)
    summary(io, A)
    println(io)
    print(io, "b: ")
    return show(io, mime, A.b)
end

function Base.summary(io::IO, prob::AbstractNonlinearProblem{uType, iip}) where {uType, iip}
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(prob)),
        no_color, " with uType ",
        type_color, uType,
        no_color, ". In-place: ",
        type_color, isinplace(prob),
        no_color
    )
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractNonlinearProblem)
    summary(io, A)
    println(io)
    print(io, "u0: ")
    return show(io, mime, state_values(A))
end

function Base.show(io::IO, mime::MIME"text/plain", A::IntervalNonlinearProblem)
    summary(io, A)
    println(io)
    print(io, "Interval: ")
    return show(io, mime, A.tspan)
end

function Base.summary(io::IO, prob::AbstractOptimizationProblem)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(prob)),
        no_color, ". In-place: ",
        type_color, isinplace(prob),
        no_color
    )
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractOptimizationProblem)
    summary(io, A)
    println(io)
    print(io, "u0: ")
    return show(io, mime, A.u0)
end

function Base.summary(io::IO, prob::AbstractIntegralProblem)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(prob)),
        no_color, ". In-place: ",
        type_color, isinplace(prob),
        no_color
    )
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractIntegralProblem)
    summary(io, A)
    return println(io)
end

function Base.summary(io::IO, prob::AbstractNoiseProblem)
    return print(
        io,
        nameof(typeof(prob)), " with WType ", typeof(prob.noise.curW), " and tType ",
        typeof(prob.tspan[1]), ". In-place: ", isinplace(prob)
    )
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractDEProblem)
    summary(io, A)
    println(io)
    print(io, "timespan: ")
    show(io, mime, A.tspan)
    println(io)
    print(io, "u0: ")
    return show(io, mime, A.u0)
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractNoiseProblem)
    summary(io, A)
    println(io)
    print(io, "timespan: ")
    show(io, mime, A.tspan)
    return println(io)
end
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractDAEProblem)
    summary(io, A)
    println(io)
    print(io, "timespan: ")
    show(io, mime, A.tspan)
    println(io)
    print(io, "u0: ")
    show(io, mime, A.u0)
    println(io)
    print(io, "du0: ")
    return show(io, mime, A.du0)
end

function Base.summary(io::IO, prob::AbstractEnsembleProblem)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        nameof(typeof(prob)),
        " with problem ",
        nameof(typeof(prob.prob))
    )
end
Base.show(io::IO, mime::MIME"text/plain", A::AbstractEnsembleProblem) = summary(io, A)

struct NullParameters end

const NO_PARAMETERS_INDEX_ERROR_MESSAGE = """
An indexing operation was performed on a NullParameters object. This means no parameters were passed
into the AbstractSciMLProblem (e.x.: ODEProblem) but the parameters object `p` was used in an indexing
expression (e.x. `p[i]`, or `x .+ p`). Two common reasons for this issue are:

1. Forgetting to pass parameters into the problem constructor. For example, `ODEProblem(f,u0,tspan)` should
   be `ODEProblem(f,u0,tspan,p)` in order to use parameters.

2. Using the wrong function signature. For example, with `ODEProblem`s the function signature is always
   `f(du,u,p,t)` for the in-place form or `f(u,p,t)` for the out-of-place form. Note that the `p` argument
   will always be in the function signature regardless of if the problem is defined with parameters!
"""

struct NullParameterIndexError <: Exception end

function Base.showerror(io::IO, e::NullParameterIndexError)
    return println(io, NO_PARAMETERS_INDEX_ERROR_MESSAGE)
end

function Base.getindex(::NullParameters, i...)
    throw(NullParameterIndexError())
end
function Base.iterate(::NullParameters)
    throw(NullParameterIndexError())
end

function Base.show(io::IO, mime::MIME"text/plain", A::AbstractPDEProblem)
    summary(io, A.prob)
    return println(io)
end
function Base.summary(io::IO, prob::AbstractPDEProblem)
    return print(
        io,
        type_color, nameof(typeof(prob)),
        no_color
    )
end

Base.copy(p::SciMLBase.NullParameters) = p

SymbolicIndexingInterface.is_time_dependent(::AbstractDEProblem) = true
SymbolicIndexingInterface.is_time_dependent(::AbstractNonlinearProblem) = false

"""
    step!(integ::DEIntegrator [, dt [, stop_at_tdt]])

Perform one (successful) step on the integrator.

Alternative, if a `dt` is given, then `step!` the integrator until
there is a temporal difference `≥ dt` in `integ.t`.  When `true` is
passed to the optional third argument, the integrator advances exactly
`dt`.
"""
function step!(d::DEIntegrator)
    error("Integrator stepping is not implemented")
end

"""
    resize!(integrator::DEIntegrator,k::Int)

Resizes the DE to a size `k`. This chops off the end of the array, or adds blank values at the end, depending on whether
`k > length(integrator.u)`.
"""
function Base.resize!(i::DEIntegrator, ii::Int)
    error("resize!: method has not been implemented for the integrator")
end

"""
    deleteat!(integrator::DEIntegrator,idxs)

Shrinks the ODE by deleting the `idxs` components.
"""
function Base.deleteat!(i::DEIntegrator, ii)
    error("deleteat!: method has not been implemented for the integrator")
end

"""
    addat!(integrator::DEIntegrator,idxs,val)

Grows the ODE by adding the `idxs` components. Must be contiguous indices.
"""
function addat!(i::DEIntegrator, idxs, val = zeros(length(idxs)))
    error("addat!: method has not been implemented for the integrator")
end

"""
    get_tmp_cache(i::DEIntegrator)

Returns a tuple of internal cache vectors which are safe to use as temporary arrays. This should be used
for integrator interface and callbacks which need arrays to write into in order to be non-allocating.
The length of the tuple is dependent on the method.
"""
function get_tmp_cache(i::DEIntegrator)
    error("get_tmp_cache!: method has not been implemented for the integrator")
end
"""
    user_cache(integrator::DEIntegrator)

Returns user-accessible cache components from the integrator. These are cache arrays that users
can safely access and modify without breaking the internal integrator state.
"""
function user_cache(i::DEIntegrator)
    error("user_cache: method has not been implemented for the integrator")
end

"""
    u_cache(integrator::DEIntegrator)

Returns the state variable cache arrays used by the integrator. These contain intermediate
state values during the integration process.
"""
function u_cache(i::DEIntegrator)
    error("u_cache: method has not been implemented for the integrator")
end

"""
    du_cache(integrator::DEIntegrator)

Returns the derivative cache arrays used by the integrator. These contain intermediate
derivative values during the integration process.
"""
function du_cache(i::DEIntegrator)
    error("du_cache: method has not been implemented for the integrator")
end

"""
    ratenoise_cache(integrator::DEIntegrator)

Returns cache arrays for rate noise in stochastic differential equations.
Returns an empty tuple by default for deterministic problems.
"""
ratenoise_cache(i::DEIntegrator) = ()

"""
    rand_cache(integrator::DEIntegrator)

Returns cache arrays for random number generation in stochastic differential equations.
Returns an empty tuple by default for deterministic problems.
"""
rand_cache(i::DEIntegrator) = ()

"""
    full_cache(i::DEIntegrator)

Returns an iterator over the cache arrays of the method. This can be used to change internal values as needed.
"""
function full_cache(i::DEIntegrator)
    error("full_cache: method has not been implemented for the integrator")
end

"""
    resize_non_user_cache!(integrator::DEIntegrator,k::Int)

Resizes the non-user facing caches to be compatible with a DE of size `k`. This includes resizing Jacobian caches.

!!! note

    In many cases, [`resize!`](@ref) simply resizes [`full_cache`](@ref) variables and then
    calls this function. This finer control is required for some `AbstractArray`
    operations.
"""
function resize_non_user_cache!(i::DEIntegrator, ii::Int)
    error("resize_non_user_cache!: method has not been implemented for the integrator")
end

"""
    deleteat_non_user_cache!(integrator::DEIntegrator,idxs)

[`deleteat!`](@ref)s the non-user facing caches at indices `idxs`. This includes resizing Jacobian caches.

!!! note

    In many cases, `deleteat!` simply `deleteat!`s [`full_cache`](@ref) variables and then
    calls this function. This finer control is required for some `AbstractArray`
    operations.
"""
function deleteat_non_user_cache!(i::DEIntegrator, idxs)
    error("deleteat_non_user_cache!: method has not been implemented for the integrator")
end

"""
    addat_non_user_cache!(i::DEIntegrator,idxs)

[`addat!`](@ref)s the non-user facing caches at indices `idxs`. This includes resizing Jacobian caches.

!!! note

    In many cases, `addat!` simply `addat!`s [`full_cache`](@ref) variables and then
    calls this function. This finer control is required for some `AbstractArray`
    operations.
"""
function addat_non_user_cache!(i::DEIntegrator, idxs)
    error("addat_non_user_cache!: method has not been implemented for the integrator")
end

"""
    terminate!(i::DEIntegrator[, retcode = :Terminated])

Terminates the integrator by emptying `tstops`. This can be used in events and callbacks to immediately
end the solution process.  Optionally, `retcode` may be specified (see: [Return Codes (RetCodes)](@ref retcodes)).
"""
function terminate!(i::DEIntegrator)
    error("terminate!: method has not been implemented for the integrator")
end

"""
    get_du(i::DEIntegrator)

Returns the derivative at `t`.
"""
function get_du(i::DEIntegrator)
    error("get_du: method has not been implemented for the integrator")
end

"""
    get_du!(out,i::DEIntegrator)

Write the current derivative at `t` into `out`.
"""
function get_du!(out, i::DEIntegrator)
    error("get_du: method has not been implemented for the integrator")
end
function get_dt(i::DEIntegrator)
    error("get_dt: method has not been implemented for the integrator")
end

"""
    get_proposed_dt(i::DEIntegrator)

Gets the proposed `dt` for the next timestep.
"""
function get_proposed_dt(i::DEIntegrator)
    error("get_proposed_dt: method has not been implemented for the integrator")
end

"""
    set_proposed_dt!(i::DEIntegrator,dt)
    set_proposed_dt!(i::DEIntegrator,i2::DEIntegrator)

Sets the proposed `dt` for the next timestep. If the second argument isa `DEIntegrator`, then it sets the timestepping of
the first argument to match that of the second one. Note that due to PI control and step acceleration, this is more than matching
the factors in most cases.
"""
function set_proposed_dt!(i::DEIntegrator, dt)
    error("set_proposed_dt!: method has not been implemented for the integrator")
end

"""
    savevalues!(integrator::DEIntegrator,
      force_save=false) -> Tuple{Bool, Bool}

Try to save the state and time variables at the current time point, or the
`saveat` point by using interpolation when appropriate. It returns a tuple that
is `(saved, savedexactly)`. If `savevalues!` saved value, then `saved` is true,
and if `savevalues!` saved at the current time point, then `savedexactly` is
true.

The saving priority/order is as follows:

  - `save_on`

      + `saveat`
      + `force_save`
      + `save_everystep`
"""
function savevalues!(i::DEIntegrator)
    error("savevalues!: method has not been implemented for the integrator")
end

"""
    u_modified!(i::DEIntegrator,bool)

Sets `bool` which states whether a change to `u` occurred, allowing the solver to handle the discontinuity. By default,
this is assumed to be true if a callback is used. This will result in the re-calculation of the derivative at
`t+dt`, which is not necessary if the algorithm is FSAL and `u` does not experience a discontinuous change at the
end of the interval. Thus, if `u` is unmodified in a callback, a single call to the derivative calculation can be
eliminated by `u_modified!(integrator,false)`.
"""
function u_modified!(i::DEIntegrator, bool)
    error("u_modified!: method has not been implemented for the integrator")
end

"""
    add_tstop!(i::DEIntegrator,t)

Adds a `tstop` at time `t`.
"""
function add_tstop!(i::DEIntegrator, t)
    error("add_tstop!: method has not been implemented for the integrator")
end

"""
    has_tstop(i::DEIntegrator)

Checks if integrator has any stopping times defined.
"""
function has_tstop(i::DEIntegrator)
    error("has_tstop: method has not been implemented for the integrator")
end

"""
    first_tstop(i::DEIntegrator)

Gets the first stopping time of the integrator.
"""
function first_tstop(i::DEIntegrator)
    error("first_tstop: method has not been implemented for the integrator")
end

"""
    pop_tstop!(i::DEIntegrator)

Pops the last stopping time from the integrator.
"""
function pop_tstop!(i::DEIntegrator)
    error("pop_tstop!: method has not been implemented for the integrator")
end

"""
    add_saveat!(i::DEIntegrator,t)

Adds a `saveat` time point at `t`.
"""
function add_saveat!(i::DEIntegrator, t)
    error("add_saveat!: method has not been implemented for the integrator")
end

function set_abstol!(i::DEIntegrator, t)
    error("set_abstol!: method has not been implemented for the integrator")
end
function set_reltol!(i::DEIntegrator, t)
    error("set_reltol!: method has not been implemented for the integrator")
end

"""
    has_rng(integrator::DEIntegrator) -> Bool

Returns `true` if the integrator type supports the RNG interface
(`get_rng` / `set_rng!`). This is a type-level trait — integrators
that return `true` always carry a valid `AbstractRNG`, defaulting to
`Random.default_rng()` when none is provided by the caller.
Default: `false` for all `DEIntegrator` subtypes.
"""
has_rng(::DEIntegrator) = false

"""
    get_rng(integrator::DEIntegrator) -> AbstractRNG

Returns the integrator's random number generator.
Throws an informative error if the integrator does not support RNG.
"""
function get_rng(integrator::DEIntegrator)
    error(
        "Integrator of type $(typeof(integrator)) does not carry an RNG. " *
            "Ensure the solver package version supports the SciMLBase RNG interface " *
            "(has_rng / get_rng / set_rng!)."
    )
end

"""
    set_rng!(integrator::DEIntegrator, rng) -> nothing

Replaces the integrator's random number generator. The new RNG must be the
same concrete type as the existing one (the type is baked into the integrator's
type parameters).

This is needed for RNG types that don't support `Random.seed!`, such as
counter-based RNGs (Random123.jl's Philox, Threefry) which are configured via
`(key, counter)` pairs rather than a single seed. For these types, reseeding
requires constructing a new instance and swapping it in.

For standard RNGs (Xoshiro, MersenneTwister, StableRNG), `Random.seed!` works
and `set_rng!` is not needed — but it is available for consistency.
"""
function set_rng!(integrator::DEIntegrator, rng)
    error("Integrator of type $(typeof(integrator)) does not support set_rng!.")
end

"""
    reinit!(integrator::DEIntegrator,args...; kwargs...)

The reinit function lets you restart the integration at a new value.

# Arguments

  - `u0`: Value of `u` to start at. Default value is `integrator.sol.prob.u0`

# Keyword Arguments

  - `t0`: Starting timepoint. Default value is `integrator.sol.prob.tspan[1]`
  - `tf`: Ending timepoint. Default value is `integrator.sol.prob.tspan[2]`
  - `erase_sol=true`: Whether to start with no other values in the solution, or keep the previous solution.
  - `tstops`, `d_discontinuities`, & `saveat`: Cache where these are stored. Default is the original cache.
  - `reset_dt`: Set whether to reset the current value of `dt` using the automatic `dt` determination algorithm. Default is
    `(integrator.dtcache == zero(integrator.dt)) && integrator.opts.adaptive`
  - `reinit_callbacks`: Set whether to run the callback initializations again (and `initialize_save` is for that). Default is `true`.
  - `reinit_cache`: Set whether to re-run the cache initialization function (i.e. resetting FSAL, not allocating vectors)
    which should usually be true for correctness. Default is `true`.

Additionally, once can access [`auto_dt_reset!`](@ref) which will run the auto `dt` initialization algorithm.
"""
function reinit!(integrator::DEIntegrator, args...; kwargs...)
    error("reinit!: method has not been implemented for the integrator")
end

"""
    initialize_dae!(integrator::DEIntegrator,initializealg = integrator.initializealg)

Runs the DAE initialization to find a consistent state vector. The optional
argument `initializealg` can be used to specify a different initialization
algorithm to use.
"""
function initialize_dae!(integrator::DEIntegrator)
    error("initialize_dae!: method has not been implemented for the integrator")
end
function initialize_dae!(integrator::DEIntegrator, initializealg)
    return if !(initializealg isa NoInit)
        error("initialize_dae!: $(typeof(initializealg)) method has not been implemented for the integrator")
    end
end

"""
    auto_dt_reset!(integrator::DEIntegrator)

Run the auto `dt` initialization algorithm.
"""
function auto_dt_reset!(integrator::DEIntegrator)
    error("auto_dt_reset!: method has not been implemented for the integrator")
end

"""
    change_t_via_interpolation!(integrator::DEIntegrator,t,modify_save_endpoint=Val{false},reinitialize_alg=nothing)

Modifies the current `t` and changes all of the corresponding values using the local interpolation. If the current solution
has already been saved, one can provide the optional value `modify_save_endpoint` to also modify the endpoint of `sol` in the
same manner.
"""
function change_t_via_interpolation!(i::DEIntegrator, args...)
    error("change_t_via_interpolation!: method has not been implemented for the integrator")
end

addsteps!(i::DEIntegrator, args...) = nothing

"""
    reeval_internals_due_to_modification!(integrator::DEIntegrator, continuous_modification::Bool=true;
                                          callback_initializealg = nothing)

Update DE integrator after changes by callbacks.
For DAEs (either implicit or semi-explicit), this requires re-solving alebraic variables.
If continuous_modification is true (or unspecified), this should also recalculate interpolation data.
Otherwise the integrator is allowed to skip recalculating the interpolation.

# Arguments

  - `continuous_modification`: determines whether the modification is due to a continuous change (continuous callback)
    or a discrete callback. For a continuous change, this can include a change to time which requires a re-evaluation
    of the interpolations.
  - `callback_initializealg`: the initialization algorithm provided by the callback. For DAEs, this is the choice for the
    initialization that is done post callback. The default value of `nothing` means that the initialization choice
    used for the DAE should be performed post-callback.
"""
function reeval_internals_due_to_modification!(
        integrator::DEIntegrator, continuous_modification;
        callback_initializealg = nothing
    )
    return reeval_internals_due_to_modification!(integrator::DEIntegrator)
end
function reeval_internals_due_to_modification!(
        integrator::DEIntegrator; callback_initializealg = nothing
    )
    return nothing
end

"""
    set_t!(integrator::DEIntegrator, t)

Set current time point of the `integrator` to `t`.
"""
function set_t!(integrator::DEIntegrator, t)
    error("set_t!: method has not been implemented for the integrator")
end

"""
    set_u!(integrator::DEIntegrator, u)
    set_u!(integrator::DEIntegrator, sym, val)

Set current state of the `integrator` to `u`. Alternatively, set the state of variable
`sym` to value `val`.
"""
function set_u! end

function set_u!(integrator::DEIntegrator, u)
    error("set_u!: method has not been implemented for the integrator")
end

function set_u!(integrator::DEIntegrator, sym, val)
    # So any error checking happens to ensure we actually _can_ set state
    set_u!(integrator, integrator.u)

    if symbolic_type(sym) == NotSymbolic()
        error("sym must be a symbol")
    end
    i = variable_index(integrator, sym)

    if isnothing(i)
        error("$sym is not a state variable")
    end

    integrator.u[i] = val
    return u_modified!(integrator, true)
end

"""
    set_ut!(integrator::DEIntegrator, u, t)

Set current state of the `integrator` to `u` and `t`
"""
function set_ut!(integrator::DEIntegrator, u, t)
    set_u!(integrator, u)
    return set_t!(integrator, t)
end

"""
    get_sol(integrator::DEIntegrator)

Get the solution object contained in the integrator.
"""
function get_sol(integrator::DEIntegrator)
    return integrator.sol
end

### Addat isn't a real thing. Let's make it a real thing Gretchen

function addat!(a::AbstractArray, idxs, val = nothing)
    return if val === nothing
        resize!(a, length(a) + length(idxs))
    else
        error("real addat! on arrays isn't supported yet")
        #=
        flip_range = last(idxs):-1:idxs.start
        @show idxs,flip_range
        splice!(a,flip_range,val)
        =#
    end
end

### Indexing
function getsyms(integrator::DEIntegrator)
    syms = variable_symbols(integrator)
    if isempty(syms)
        syms = keys(integrator.u)
    end
    return syms
end

function getindepsym(integrator::DEIntegrator)
    syms = independent_variable_symbols(integrator)
    if isempty(syms)
        return nothing
    end
    return syms
end

function getparamsyms(integrator::DEIntegrator)
    psyms = parameter_symbols(integrator)
    if isempty(psyms)
        return nothing
    end
    return psyms
end

function getobserved(integrator::DEIntegrator)
    if has_observed(integrator.f)
        return integrator.f.observed
    else
        return DEFAULT_OBSERVED
    end
end

function sym_to_index(sym, integrator::DEIntegrator)
    idx = variable_index(integrator, sym)
    if idx === nothing
        idx = findfirst(isequal(sym), keys(integrator.u))
    end
    return idx
end

# SymbolicIndexingInterface
SymbolicIndexingInterface.symbolic_container(A::DEIntegrator) = A.f
SymbolicIndexingInterface.parameter_values(A::DEIntegrator) = A.p
SymbolicIndexingInterface.state_values(A::DEIntegrator) = A.u
SymbolicIndexingInterface.current_time(A::DEIntegrator) = A.t
function SymbolicIndexingInterface.set_state!(A::DEIntegrator, val, idx)
    A.u[idx] = val
    return u_modified!(A, true)
end

SymbolicIndexingInterface.is_time_dependent(::DEIntegrator) = true

# TODO make this nontrivial once dynamic state selection works
SymbolicIndexingInterface.constant_structure(::DEIntegrator) = true

function Base.getproperty(A::DEIntegrator, sym::Symbol)
    if sym === :destats && hasfield(typeof(A), :stats)
        @warn "destats has been deprecated for stats"
        getfield(A, :stats)
    elseif sym === :ps
        return ParameterIndexingProxy(A)
    else
        return getfield(A, sym)
    end
end

Base.@propagate_inbounds function Base.getindex(A::DEIntegrator, sym)
    if is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `integrator.ps[$sym]` for parameter indexing.")
    end
    return getsym(A, sym)(A)
end

Base.@propagate_inbounds function Base.getindex(
        A::DEIntegrator, sym::Union{AbstractArray, Tuple}
    )
    if symbolic_type(sym) == NotSymbolic() && any(x -> is_parameter(A, x), sym) ||
            is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `integrator.ps[$sym]` for parameter indexing.")
    end
    return getsym(A, sym)(A)
end

Base.@propagate_inbounds function Base.getindex(
        A::DEIntegrator, ::SymbolicIndexingInterface.SolvedVariables
    )
    return getindex(A, variable_symbols(A))
end

Base.@propagate_inbounds function Base.getindex(
        A::DEIntegrator, ::SymbolicIndexingInterface.AllVariables
    )
    return getindex(A, all_variable_symbols(A))
end

function observed(A::DEIntegrator, sym)
    return getobserved(A)(sym, A.u, A.p, A.t)
end

function Base.setindex!(A::DEIntegrator, val, sym)
    if is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `integrator.ps[$sym] = $val` for parameter indexing.")
    end
    return setsym(A, sym)(A, val)
end

function Base.setindex!(A::DEIntegrator, val, sym::Union{AbstractArray, Tuple})
    if symbolic_type(sym) == NotSymbolic() && any(x -> is_parameter(A, x), sym) ||
            is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `integrator.ps[$sym] = $val` for parameter indexing.")
    end
    return setsym(A, sym)(A, val)
end

### Integrator traits

has_reinit(i::DEIntegrator) = false

### Display

function Base.summary(io::IO, I::DEIntegrator)
    type_color, no_color = get_colorizers(io)
    return print(
        io,
        type_color, nameof(typeof(I)),
        no_color, " with uType ",
        type_color, typeof(I.u),
        no_color, " and tType ",
        type_color, typeof(I.t),
        no_color
    )
end
function Base.show(io::IO, A::DEIntegrator)
    println(io, string("t: ", A.t))
    print(io, "u: ")
    return show(io, A.u)
end
function Base.show(io::IO, m::MIME"text/plain", A::DEIntegrator)
    println(io, string("t: ", A.t))
    print(io, "u: ")
    return show(io, m, A.u)
end

### Error check (retcode)

last_step_failed(integrator::DEIntegrator) = false

"""
    check_error(integrator)

Check state of `integrator` and return one of the
[Return Codes](https://docs.sciml.ai/DiffEqDocs/stable/basics/solution/#retcodes)
"""
function check_error(integrator::DEIntegrator)
    if integrator.sol.retcode ∉ (ReturnCode.Success, ReturnCode.Default)
        return integrator.sol.retcode
    end
    opts = integrator.opts
    verbose = opts.verbose
    # This implementation is intended to be used for ODEIntegrator and
    # SDEIntegrator.

    if isnan(integrator.dt)
        if verbose isa Bool
            @warn "NaN dt detected. Likely a NaN value in the state, parameters, or derivative value caused this outcome."
        else
            @SciMLMessage("NaN dt detected. Likely a NaN value in the state, parameters, or derivative value caused this outcome.", verbose, :dt_NaN)
        end
        return ReturnCode.DtNaN
    end
    if integrator.iter > opts.maxiters
        if verbose isa Bool
            @warn "Interrupted. Larger maxiters is needed. If you are using an integrator for non-stiff ODEs or an automatic switching algorithm (the default), you may want to consider using a method for stiff equations. See the solver pages for more details (e.g. https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/#Stiff-Problems)."
        else
            @SciMLMessage(
                "Interrupted. Larger maxiters is needed. If you are using an integrator for non-stiff ODEs or an automatic switching algorithm (the default), you may want to consider using a method for stiff equations. See the solver pages for more details (e.g. https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/#Stiff-Problems).",
                verbose,
                :max_iters
            )
        end
        return ReturnCode.MaxIters
    end

    # The last part:
    # Bail out if we take a step with dt less than the minimum value (which may be time dependent)
    # except if we are successfully taking such a small timestep is to hit a tstop exactly
    # We also exit if the ODE is unstable according to a user chosen callback
    # but only if we accepted the step to prevent from bailing out as unstable
    # when we just took way too big a step)
    step_accepted = !hasproperty(integrator, :accept_step) || integrator.accept_step
    if !opts.force_dtmin && opts.adaptive
        if abs(integrator.dt) <= abs(opts.dtmin) &&
                (
                !step_accepted || (
                    hasproperty(opts, :tstops) ?
                        integrator.t + integrator.dt < integrator.tdir * first(opts.tstops) :
                        true
                )
            )
            if verbose isa Bool
                if isdefined(integrator, :EEst)
                    EEst = lazy", and step error estimate = $(integrator.EEst)"
                else
                    EEst = ""
                end
                @warn lazy"dt($(integrator.dt)) <= dtmin($(opts.dtmin)) at t=$(integrator.t)$EEst. Aborting. There is either an error in your model specification or the true solution is unstable."
            else
                EEst = if isdefined(integrator, :EEst)
                    lazy", and step error estimate = $(integrator.EEst)"
                else
                    ""
                end
                @SciMLMessage(lazy"dt($(integrator.dt) <= dtmin($(opts.dtmin)), at t=$(integrator.t)$EEst. Aborting. There is either an error in your model specification or the true solution is unstable.", verbose, :dt_min_unstable)
            end
            return ReturnCode.DtLessThanMin
        elseif !step_accepted && integrator.t isa AbstractFloat &&
                abs(integrator.dt) <= abs(eps(integrator.t))
            if verbose isa Bool
                if isdefined(integrator, :EEst)
                    EEst = lazy", and step error estimate = $(integrator.EEst)"
                else
                    EEst = ""
                end
                @warn lazy"At t=$(integrator.t), dt was forced below floating point epsilon $(integrator.dt)$EEst. Aborting. There is either an error in your model specification or the true solution is unstable (or the true solution can not be represented in the precision of $(eltype(integrator.u)))."
            else
                EEst = if isdefined(integrator, :EEst)
                    lazy", and step error estimate = $(integrator.EEst)"
                else
                    ""
                end
                @SciMLMessage(lazy"At t= $(integrator.t), dt was forced below floating point epsilon $(integrator.dt)$EEst. Aborting. There is either an error in your model specification or the true solution is unstable (or the true solution can not be represented in the precision of $(eltype(integrator.u)).", verbose, :dt_epsilon)
            end
            return ReturnCode.Unstable
        end
    end
    if step_accepted &&
            opts.unstable_check(integrator.dt, integrator.u, integrator.p, integrator.t)
        if verbose isa Bool
            @warn "Instability detected. Aborting"
        else
            @SciMLMessage("Instability detected. Aborting", verbose, :instability)
        end
        return ReturnCode.Unstable
    end
    if last_step_failed(integrator)
        if verbose isa Bool
            @warn "Newton steps could not converge and algorithm is not adaptive. Use a lower dt."
        else
            @SciMLMessage("Newton steps could not converge and algorithm is not adaptive. Use a lower dt.", verbose, :newton_convergence)
        end
        return ReturnCode.ConvergenceFailure
    end
    return ReturnCode.Success
end

function postamble! end

"""
    check_error!(integrator)

Same as `check_error` but also set solution's return code
(`integrator.sol.retcode`) and run `postamble!`.
"""
function check_error!(integrator::DEIntegrator)
    code = check_error(integrator)
    integrator.sol = solution_new_retcode(integrator.sol, code)
    if code != ReturnCode.Success
        postamble!(integrator)
    end
    return code
end

### Default Iterator Interface
function done(integrator::DEIntegrator)
    if !(integrator.sol.retcode in (ReturnCode.Default, ReturnCode.Success))
        return true
    elseif isempty(integrator.opts.tstops)
        postamble!(integrator)
        return true
    elseif integrator.just_hit_tstop
        integrator.just_hit_tstop = false
        if integrator.opts.stop_at_next_tstop
            postamble!(integrator)
            return true
        end
    end
    return false
end
function Base.iterate(integrator::DEIntegrator, state = 0)
    done(integrator) && return nothing
    state += 1
    step!(integrator) # Iter updated in the step! header
    # Next is callbacks -> iterator  -> top
    return integrator, state
end

Base.eltype(::Type{T}) where {T <: DEIntegrator} = T
Base.IteratorSize(::Type{<:DEIntegrator}) = Base.SizeUnknown()

### Other Iterators

struct IntegratorTuples{I}
    integrator::I
end

function Base.iterate(tup::IntegratorTuples, state = 0)
    done(tup.integrator) && return nothing
    step!(tup.integrator) # Iter updated in the step! header
    state += 1
    # Next is callbacks -> iterator  -> top
    return (tup.integrator.u, tup.integrator.t), state
end

function Base.eltype(
        ::Type{
            IntegratorTuples{I},
        }
    ) where {
        U, T,
        I <:
        DEIntegrator{<:Any, <:Any, U, T},
    }
    return Tuple{U, T}
end
Base.IteratorSize(::Type{<:IntegratorTuples}) = Base.SizeUnknown()

RecursiveArrayTools.tuples(integrator::DEIntegrator) = IntegratorTuples(integrator)

"""
$(TYPEDEF)
"""
struct IntegratorIntervals{I}
    integrator::I
end

function Base.iterate(tup::IntegratorIntervals, state = 0)
    done(tup.integrator) && return nothing
    state += 1
    step!(tup.integrator) # Iter updated in the step! header
    # Next is callbacks -> iterator  -> top
    return (tup.integrator.uprev, tup.integrator.tprev, tup.integrator.u, tup.integrator.t),
        state
end

function Base.eltype(
        ::Type{
            IntegratorIntervals{I},
        }
    ) where {
        U, T,
        I <:
        DEIntegrator{
            <:Any, <:Any, U, T,
        },
    }
    return Tuple{U, T, U, T}
end
Base.IteratorSize(::Type{<:IntegratorIntervals}) = Base.SizeUnknown()

intervals(integrator::DEIntegrator) = IntegratorIntervals(integrator)

struct TimeChoiceIterator{T, T2}
    integrator::T
    ts::T2
end

function Base.iterate(iter::TimeChoiceIterator, state = 1)
    state > length(iter.ts) && return nothing
    t = iter.ts[state]
    integrator = iter.integrator
    if isinplace(integrator.sol.prob)
        tmp = first(get_tmp_cache(integrator))
        if t == integrator.t
            tmp .= integrator.u
        elseif t < integrator.t
            integrator(tmp, t)
        else
            step!(integrator, t - integrator.t)
            integrator(tmp, t)
        end
        return (tmp, t), state + 1
    else
        if t == integrator.t
            tmp = integrator.u
        elseif t < integrator.t
            tmp = integrator(t)
        else
            step!(integrator, t - integrator.t)
            tmp = integrator(t)
        end
        return (tmp, t), state + 1
    end
end

Base.length(iter::TimeChoiceIterator) = length(iter.ts)

@recipe function f(
        integrator::DEIntegrator;
        denseplot = (
            integrator.opts.calck ||
                integrator isa AbstractSDEIntegrator
        ) &&
            integrator.iter > 0,
        plotdensity = 10,
        plot_analytic = false, vars = nothing, idxs = nothing
    )
    if vars !== nothing
        Base.depwarn(
            "To maintain consistency with solution indexing, keyword argument vars will be removed in a future version. Please use keyword argument idxs instead.",
            :f; force = true
        )
        (idxs !== nothing) &&
            error("Simultaneously using keywords vars and idxs is not supported. Please only use idxs.")
        idxs = vars
    end

    int_vars = interpret_vars(idxs, integrator.sol)

    if denseplot
        # Generate the points from the plot from dense function
        plott = collect(range(integrator.tprev, integrator.t; length = plotdensity))
        if plot_analytic
            plot_analytic_timeseries = [
                integrator.sol.prob.f.analytic(
                        integrator.sol.prob.u0,
                        integrator.sol.prob.p,
                        t
                    ) for t in plott
            ]
        end
    else
        plott = nothing
    end

    dims = length(int_vars[1])
    for var in int_vars
        @assert length(var) == dims
    end
    # Should check that all have the same dims!

    plot_vecs = []
    for i in 2:dims
        push!(plot_vecs, [])
    end

    labels = String[] # Array{String, 2}(1, length(int_vars)*(1+plot_analytic))
    strs = String[]
    varsyms = variable_symbols(integrator)
    @show plott

    for x in int_vars
        for j in 2:dims
            if denseplot
                if (x[j] isa Integer && x[j] == 0) ||
                        isequal(x[j], getindepsym_defaultt(integrator))
                    push!(plot_vecs[j - 1], plott)
                else
                    push!(plot_vecs[j - 1], Vector(integrator(plott; idxs = x[j])))
                end
            else # just get values
                if x[j] == 0
                    push!(plot_vecs[j - 1], integrator.t)
                elseif x[j] == 1 && !(integrator.u isa AbstractArray)
                    push!(plot_vecs[j - 1], integrator.u)
                else
                    push!(plot_vecs[j - 1], integrator.u[x[j]])
                end
            end

            if !isempty(varsyms) && x[j] isa Integer
                push!(strs, String(getname(varsyms[x[j]])))
            elseif hasname(x[j])
                push!(strs, String(getname(x[j])))
            else
                push!(strs, "u[$(x[j])]")
            end
        end
        add_labels!(labels, x, dims, integrator.sol, strs)
    end

    if plot_analytic
        for x in int_vars
            for j in 1:dims
                if denseplot
                    push!(
                        plot_vecs[j],
                        u_n(plot_timeseries, x[j], sol, plott, plot_timeseries)
                    )
                else # Just get values
                    if x[j] == 0
                        push!(plot_vecs[j], integrator.t)
                    elseif x[j] == 1 && !(integrator.u isa AbstractArray)
                        push!(
                            plot_vecs[j],
                            integrator.sol.prob.f(
                                Val{:analytic}, integrator.t,
                                integrator.sol[1]
                            )
                        )
                    else
                        push!(
                            plot_vecs[j],
                            integrator.sol.prob.f(
                                Val{:analytic}, integrator.t,
                                integrator.sol[1]
                            )[x[j]]
                        )
                    end
                end
            end
            add_labels!(labels, x, dims, integrator.sol, strs)
        end
    end

    xflip --> integrator.tdir < 0

    if denseplot
        seriestype --> :path
    else
        seriestype --> :scatter
    end

    # Special case labels when idxs = (:x,:y,:z) or (:x) or [:x,:y] ...
    if idxs isa Tuple && (typeof(idxs[1]) == Symbol && typeof(idxs[2]) == Symbol)
        xlabel --> idxs[1]
        ylabel --> idxs[2]
        if length(idxs) > 2
            zlabel --> idxs[3]
        end
    end
    if getindex.(int_vars, 1) == zeros(length(int_vars)) ||
            getindex.(int_vars, 2) == zeros(length(int_vars))
        xlabel --> "t"
    end

    linewidth --> 3
    #xtickfont --> font(11)
    #ytickfont --> font(11)
    #legendfont --> font(11)
    #guidefont  --> font(11)
    label --> reshape(labels, 1, length(labels))
    (plot_vecs...,)
end

function step!(integ::DEIntegrator, dt, stop_at_tdt = false)
    (dt * integ.tdir) < 0 * oneunit(dt) && error("Cannot step backward.")
    t = integ.t
    next_t = t + dt
    stop_at_tdt && add_tstop!(integ, next_t)
    while integ.t * integ.tdir < next_t * integ.tdir
        step!(integ)
        integ.sol.retcode in (ReturnCode.Default, ReturnCode.Success) || break
    end
    return
end

has_stats(i::DEIntegrator) = false

"""
    isadaptive(i::DEIntegrator)

Checks if the integrator is adaptive
"""
function isadaptive(integrator::DEIntegrator)
    return isdefined(integrator.opts, :adaptive) ? integrator.opts.adaptive : false
end

function SymbolicIndexingInterface.get_history_function(
        integ::Union{
            AbstractDDEIntegrator, AbstractSDDEIntegrator,
        }
    )
    return DDESolutionHistoryWrapper(get_sol(integ))
end

"""
$(TYPEDEF)
"""
struct NoiseProblem{N <: AbstractNoiseProcess, T, K} <: AbstractNoiseProblem
    noise::N
    tspan::T
    seed::UInt64
    kwargs::K
end

@add_kwonly function NoiseProblem(noise, tspan; seed = UInt64(0), kwargs...)
    _tspan = promote_tspan(tspan)
    NoiseProblem{typeof(noise), typeof(_tspan), typeof(kwargs)}(noise, _tspan, seed, kwargs)
end

Base.@propagate_inbounds function Base.getproperty(prob::AbstractSciMLProblem, sym::Symbol)
    if sym === :ps
        return ParameterIndexingProxy(prob)
    end
    return getfield(prob, sym)
end

SymbolicIndexingInterface.symbolic_container(prob::AbstractSciMLProblem) = prob.f
SymbolicIndexingInterface.symbolic_container(prob::AbstractJumpProblem) = prob.prob
SymbolicIndexingInterface.symbolic_container(prob::AbstractEnsembleProblem) = prob.prob

SymbolicIndexingInterface.parameter_values(prob::AbstractSciMLProblem) = prob.p
function SymbolicIndexingInterface.parameter_values(prob::AbstractJumpProblem)
    return parameter_values(prob.prob)
end
function SymbolicIndexingInterface.parameter_values(prob::AbstractEnsembleProblem)
    return parameter_values(prob.prob)
end
SymbolicIndexingInterface.state_values(prob::AbstractSciMLProblem) = prob.u0
SymbolicIndexingInterface.state_values(prob::AbstractJumpProblem) = state_values(prob.prob)
function SymbolicIndexingInterface.state_values(prob::AbstractEnsembleProblem)
    return state_values(prob.prob)
end
SymbolicIndexingInterface.current_time(prob::AbstractSciMLProblem) = prob.tspan[1]
SymbolicIndexingInterface.current_time(prob::AbstractJumpProblem) = current_time(prob.prob)
function SymbolicIndexingInterface.current_time(prob::AbstractEnsembleProblem)
    return current_time(prob.prob)
end
SymbolicIndexingInterface.current_time(::AbstractSteadyStateProblem) = Inf

Base.@propagate_inbounds function Base.getindex(
        prob::AbstractSciMLProblem, ::SymbolicIndexingInterface.SolvedVariables
    )
    return getindex(prob, variable_symbols(prob))
end

Base.@propagate_inbounds function Base.getindex(
        prob::AbstractSciMLProblem, ::SymbolicIndexingInterface.AllVariables
    )
    return getindex(prob, all_variable_symbols(prob))
end

Base.@propagate_inbounds function Base.getindex(A::AbstractSciMLProblem, sym)
    if is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `prob.ps[$sym]` for parameter indexing.")
    end
    return getsym(A, sym)(A)
end

Base.@propagate_inbounds function Base.getindex(
        A::AbstractSciMLProblem, sym::Union{AbstractArray, Tuple}
    )
    if symbolic_type(sym) == NotSymbolic() && any(x -> is_parameter(A, x), sym) ||
            is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `prob.ps[$sym]` for parameter indexing.")
    end
    return getsym(A, sym)(A)
end

function Base.setindex!(prob::AbstractSciMLProblem, args...; kwargs...)
    return ___internal_setindex!(prob::AbstractSciMLProblem, args...; kwargs...)
end

function ___internal_setindex!(A::AbstractSciMLProblem, val, sym)
    if is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `prob.ps[$sym] = $val` for parameter indexing.")
    end
    return setsym(A, sym)(A, val)
end

function ___internal_setindex!(
        A::AbstractSciMLProblem, val, sym::Union{AbstractArray, Tuple}
    )
    if symbolic_type(sym) == NotSymbolic() && any(x -> is_parameter(A, x), sym) ||
            is_parameter(A, sym)
        error("Indexing with parameters is deprecated. Use `prob.ps[$sym] = $val` for parameter indexing.")
    end
    return setsym(A, sym)(A, val)
end

"""
    $(TYPEDEF)

A utility struct stored inside `LinearProblem` to enable a symbolic interface. Intended for
use by ModelingToolkit.jl.

# Fields

$(TYPEDFIELDS)
"""
struct SymbolicLinearInterface{F1, F2, S, O, M}
    # the docstrings cannot start with a newline because otherwise the docs
    # builder fragments the list of fields into single-item lists (in TYPEDFIELDS)
    """A function which takes `A` and the parameter object `p` and updates `A` in-place."""
    update_A!::F1
    """A function which takes `b` and the parameter object `p` and updates `b` in-place."""
    update_b!::F2
    """The symbolic backend for the `LinearProblem`."""
    sys::S
    """A function which when given a symbolic expression returns a function `(u, p)`
    that computes the expression."""
    observed::O
    """Arbitrary metadata useful for the symbolic backend."""
    metadata::M
end

__has_sys(::SymbolicLinearInterface) = true
has_sys(::SymbolicLinearInterface) = true

SymbolicIndexingInterface.symbolic_container(sli::SymbolicLinearInterface) = sli.sys

function SymbolicIndexingInterface.observed(fn::SymbolicLinearInterface, sym)
    return if fn.observed !== nothing
        fn.observed(sym)
    elseif fn.sys !== nothing
        SymbolicIndexingInterface.observed(fn.sys, sym)
    else
        error("This `LinearProblem` does not support computing observed quantities.")
    end
end

@doc doc"""

Defines a linear system problem.
Documentation Page: <https://docs.sciml.ai/LinearSolve/stable/basics/LinearProblem/>

## Mathematical Specification of a Linear Problem

### Concrete `LinearProblem`

To define a `LinearProblem`, you simply need to give the `AbstractMatrix` ``A``
and an `AbstractVector` ``b`` which defines the linear system:

```math
Au = b
```

### Matrix-Free LinearProblem

For matrix-free versions, the specification of the problem is given by an
operator `A(u,p,t)` which computes `A*u`, or in-place as `A(du,u,p,t)`. These
are specified via the `AbstractSciMLOperator` interface. For more details, see
the [SciMLBase Documentation](https://docs.sciml.ai/SciMLBase/stable/).

Note that matrix-free versions of LinearProblem definitions are not compatible
with all solvers. To check a solver for compatibility, use the function `needs_concrete_A(alg::AbstractLinearAlgorithm)`.

## Problem Type

### Constructors

Optionally, an initial guess ``u₀`` can be supplied which is used for iterative
methods.

```julia
LinearProblem{isinplace}(A,b,p=NullParameters();u0=nothing,kwargs...)
LinearProblem(f::AbstractSciMLOperator,b,p=NullParameters();u0=nothing,kwargs...)
```

`isinplace` optionally sets whether the function is in-place or not, i.e. whether
the solvers are allowed to mutate. By default this is true for `AbstractMatrix`,
and for `AbstractSciMLOperator`s it matches the choice of the operator definition.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers.

### Fields

* `A`: The representation of the linear operator.
* `b`: The right-hand side of the linear system.
* `p`: The parameters for the problem. Defaults to `NullParameters`. Currently unused.
* `u0`: The initial condition used by iterative solvers.
* `symbolic_interface`: An instance of `SymbolicLinearInterface` if the problem was
  generated by a symbolic backend.
* `kwargs`: The keyword arguments passed on to the solvers.
"""
struct LinearProblem{
        uType, isinplace, F, bType, P, I <: Union{SymbolicLinearInterface, Nothing}, K,
    } <:
    AbstractLinearProblem{bType, isinplace}
    A::F
    b::bType
    u0::uType
    p::P
    f::I
    kwargs::K
    @add_kwonly function LinearProblem{iip}(
            A, b, p = NullParameters(); u0 = nothing,
            f = nothing, kwargs...
        ) where {iip}
        warn_paramtype(p)
        new{typeof(u0), iip, typeof(A), typeof(b), typeof(p), typeof(f), typeof(kwargs)}(
            A, b, u0, p,
            f, kwargs
        )
    end
end

function LinearProblem(A, b, args...; kwargs...)
    return if A isa AbstractArray
        LinearProblem{true}(A, b, args...; kwargs...)
    elseif A isa Number
        LinearProblem{false}(A, b, args...; kwargs...)
    else
        LinearProblem{isinplace(A, 4)}(A, b, args...; kwargs...)
    end
end

SymbolicIndexingInterface.symbolic_container(prob::LinearProblem) = prob.f
SymbolicIndexingInterface.state_values(prob::LinearProblem) = prob.u0
SymbolicIndexingInterface.parameter_values(prob::LinearProblem) = prob.p
SymbolicIndexingInterface.is_time_dependent(::LinearProblem) = false
function SymbolicIndexingInterface.set_parameter!(
        valp::LinearProblem{A, B, C, D, E, <:SymbolicLinearInterface},
        val, idx
    ) where {A, B, C, D, E}
    set_parameter!(parameter_values(valp), val, idx)
    valp.f.update_A!(valp.A, valp.p)
    return valp.f.update_b!(valp.b, valp.p)
end

@doc doc"""
    LinearAliasSpecifier(; alias_A = nothing, alias_b = nothing, alias = nothing)

Holds information on what variables to alias
when solving a LinearProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords

* `alias_A::Union{Bool, Nothing}`: alias the `A` array.
* `alias_b::Union{Bool, Nothing}`: alias the `b` array. 
* `alias::Union{Bool, Nothing}`: sets all fields of the `LinearAliasSpecifier` to `alias`. 

Creates a `LinearAliasSpecifier` where `alias_A` and `alias_b` default to `nothing`.
When `alias_A` or `alias_b` is nothing, the default value of the solver is used.
"""
struct LinearAliasSpecifier <: AbstractAliasSpecifier
    alias_A::Union{Bool, Nothing}
    alias_b::Union{Bool, Nothing}

    function LinearAliasSpecifier(; alias_A = nothing, alias_b = nothing, alias = nothing)
        return if alias == true
            new(true, true)
        elseif alias == false
            new(false, false)
        elseif isnothing(alias)
            new(alias_A, alias_b)
        end
    end
end

using SciMLBase
using Serialization
using Test

for clock in [
        SciMLBase.Clock(0.5),
        SciMLBase.Clock(0.5; phase = 0.1),
        SciMLBase.SolverStepClock,
        SciMLBase.Continuous,
    ]
    serialize("_tmp.jls", clock)
    newclock = deserialize("_tmp.jls")
    @test newclock == clock
end

if isfile("_tmp.jls")
    rm("_tmp.jls")
end

using OrdinaryDiffEq, SciMLBase

function lorenz!(du, u, p, t)
    du[1] = 10.0 * (u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    return du[3] = u[1] * u[2] - (8 / 3) * u[3]
end

u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 1.0)
prob = ODEProblem(lorenz!, u0, tspan)
# implicit solver so we can test cache stripping worked
sol = solve(prob, Rosenbrock23())

stripped_sol = SciMLBase.strip_solution(sol)

@test isnothing(SciMLBase.strip_solution(sol, strip_alg = true).alg)

@test isnothing(stripped_sol.interp.f)

@test isnothing(stripped_sol.interp.cache.jac_config)

@test isnothing(stripped_sol.interp.cache.grad_config)

@testset "`nothing` alg with empty ODE" begin
    prob = ODEProblem(Returns(nothing), nothing, (0.0, 1.0), nothing)
    sol = solve(prob, Tsit5())
    @test sol.alg === nothing
    stripped_sol = SciMLBase.strip_solution(sol)
    @test stripped_sol.alg === nothing
    @test stripped_sol.prob == (; p = nothing)
end

using OrdinaryDiffEq, Test

# https://github.com/SciML/OrdinaryDiffEq.jl/issues/2719

# set up functions
function f1!(du, u, p, t)
    du .= -u .^ 2
    return nothing
end

function f2!(du, u, p, t)
    du .= 2u
    return nothing
end

function f!(du, u, p, t)
    du .= -u .^ 2 .+ 2u
    return nothing
end

#create problems
u0 = ones(2)
tspan = (0.0, 1.0)
prob = ODEProblem(f!, u0, tspan)
f_split! = SplitFunction(f1!, f2!)
prob_split = SplitODEProblem(f_split!, u0, tspan)

#solve
sol = solve(prob, Rodas5P())
sol_split = solve(prob_split, Rodas5P())

#tests
@test sol_split == sol

"""
$(SIGNATURES)

Returns the number of arguments of `f` for each method.
"""
function numargs(f)
    if hasfield(typeof(f), :r) && typeof(f.r).name.name == :RObject ||
            typeof(f).name.name == :RFunction
        # Uses the RCall form to grab the parameter length
        return [length(unsafe_load(f.r.p).formals)]
    else
        return [num_types_in_tuple(m.sig) - 1 for m in methods(f)] #-1 since f is the first parameter
    end
end

function numargs(
        f::RuntimeGeneratedFunctions.RuntimeGeneratedFunction{
            T,
            V,
            W,
            I,
        }
    ) where {
        T,
        V,
        W,
        I,
    }
    return (length(T),)
end

numargs(f::ComposedFunction) = numargs(f.inner)

"""
$(SIGNATURES)

Get the number of parameters of a Tuple type, i.e. the number of fields.
"""
function num_types_in_tuple(sig)
    return length(sig.parameters)
end

function num_types_in_tuple(sig::UnionAll)
    return length(Base.unwrap_unionall(sig).parameters)
end

const NO_METHODS_ERROR_MESSAGE = """
No methods were found for the model function passed to the equation solver.
The function `f` needs to have dispatches, for example, for an ODEProblem
`f` must define either `f(u,p,t)` or `f(du,u,p,t)`. For more information
on how the model function `f` should be defined, consult the docstring for
the appropriate `AbstractSciMLFunction`.
"""

struct NoMethodsError <: Exception
    fname::String
end

function Base.showerror(io::IO, e::NoMethodsError)
    println(io, NO_METHODS_ERROR_MESSAGE)
    print(io, "Offending function: ")
    return printstyled(io, e.fname; bold = true, color = :red)
end

const TOO_MANY_ARGUMENTS_ERROR_MESSAGE = """
All methods for the model function `f` had too many arguments. For example,
an ODEProblem `f` must define either `f(u,p,t)` or `f(du,u,p,t)`. This error
can be thrown if you define an ODE model for example as `f(du,u,p1,p2,t)`.
For more information on the required number of arguments for the function
you were defining, consult the documentation for the `SciMLProblem` or
`SciMLFunction` type that was being constructed.

A common reason for this occurrence is due to following the MATLAB or SciPy
convention for parameter passing, i.e. to add each parameter as an argument.
In the SciML convention, if you wish to pass multiple parameters, use a
struct or other collection to hold the parameters. For example, here is the
parameterized Lorenz equation:

```julia
function lorenz(du,u,p,t)
  du[1] = p[1]*(u[2]-u[1])
  du[2] = u[1]*(p[2]-u[3]) - u[2]
  du[3] = u[1]*u[2] - p[3]*u[3]
end
u0 = [1.0;0.0;0.0]
p = [10.0,28.0,8/3]
tspan = (0.0,100.0)
prob = ODEProblem(lorenz,u0,tspan,p)
```

Notice that `f` is defined with a single `p`, an array which matches the definition
of the `p` in the `ODEProblem`. Note that `p` can be any Julia struct.
"""

struct TooManyArgumentsError <: Exception
    fname::String
    f::Any
end

function Base.showerror(io::IO, e::TooManyArgumentsError)
    println(io, TOO_MANY_ARGUMENTS_ERROR_MESSAGE)
    print(io, "Offending function: ")
    printstyled(io, e.fname; bold = true, color = :red)
    println(io, "\nMethods:")
    return println(io, methods(e.f))
end

const TOO_FEW_ARGUMENTS_ERROR_MESSAGE_OPTIMIZATION = """
All methods for the model function `f` had too few arguments. For example,
an OptimizationProblem `f` must define `f(u,p)` where `u` is the optimization
state and `p` are the parameters of the optimization (commonly, the hyperparameters
of the simulation).

A common reason for this error is from defining a single-input loss function
`f(u)`. While parameters are not required, a loss function which takes parameters
is required, i.e. `f(u,p)`. If you have a function `f(u)`, ignored parameters
can be easily added using a closure, i.e. `OptimizationProblem((u,_)->f(u),...)`.

For example, here is a parameterized optimization problem:

```julia
using Optimization, OptimizationOptimJL
rosenbrock(u,p) =  (p[1] - u[1])^2 + p[2] * (u[2] - u[1]^2)^2
u0 = zeros(2)
p  = [1.0,100.0]

prob = OptimizationProblem(rosenbrock,u0,p)
sol = solve(prob,NelderMead())
```

and a parameter-less example:

```julia
using Optimization, OptimizationOptimJL
rosenbrock(u,p) =  (1 - u[1])^2 + (u[2] - u[1]^2)^2
u0 = zeros(2)

prob = OptimizationProblem(rosenbrock,u0)
sol = solve(prob,NelderMead())
```
"""

const TOO_FEW_ARGUMENTS_ERROR_MESSAGE = """
All methods for the model function `f` had too few arguments. For example,
an ODEProblem `f` must define either `f(u,p,t)` or `f(du,u,p,t)`. This error
can be thrown if you define an ODE model for example as `f(u,t)`. The parameters
`p` are not optional in the definition of `f`! For more information on the required
number of arguments for the function you were defining, consult the documentation
for the `SciMLProblem` or `SciMLFunction` type that was being constructed.

For example, here is the no parameter Lorenz equation. The two valid versions
are out of place:

```julia
function lorenz(u,p,t)
  du1 = 10.0*(u[2]-u[1])
  du2 = u[1]*(28.0-u[3]) - u[2]
  du3 = u[1]*u[2] - 8/3*u[3]
  [du1,du2,du3]
end
u0 = [1.0;0.0;0.0]
tspan = (0.0,100.0)
prob = ODEProblem(lorenz,u0,tspan)
```

and in-place:

```julia
function lorenz!(du,u,p,t)
  du[1] = 10.0*(u[2]-u[1])
  du[2] = u[1]*(28.0-u[3]) - u[2]
  du[3] = u[1]*u[2] - 8/3*u[3]
end
u0 = [1.0;0.0;0.0]
tspan = (0.0,100.0)
prob = ODEProblem(lorenz!,u0,tspan)
```
"""

struct TooFewArgumentsError <: Exception
    fname::String
    f::Any
    isoptimization::Bool
end

function Base.showerror(io::IO, e::TooFewArgumentsError)
    if e.isoptimization
        println(io, TOO_FEW_ARGUMENTS_ERROR_MESSAGE_OPTIMIZATION)
    else
        println(io, TOO_FEW_ARGUMENTS_ERROR_MESSAGE)
    end
    print(io, "Offending function: ")
    printstyled(io, e.fname; bold = true, color = :red)
    println(io, "\nMethods:")
    return println(io, methods(e.f))
end

const ARGUMENTS_ERROR_MESSAGE = """
Methods dispatches for the model function `f` do not match the required number.
For example, an ODEProblem `f` must define either `f(u,p,t)` or `f(du,u,p,t)`.
This error can be thrown if you define an ODE model for example as `f(u,t)`
and `f(u,p,t,x,y)` as both of those are not valid dispatches! For more information
on the required dispatches for the given model function, consult the documentation
for the appropriate `SciMLProblem` or `AbstractSciMLFunction`.
"""

struct FunctionArgumentsError <: Exception
    fname::String
    f::Any
end

function Base.showerror(io::IO, e::FunctionArgumentsError)
    println(io, ARGUMENTS_ERROR_MESSAGE)
    print(io, "Offending function: ")
    printstyled(io, e.fname; bold = true, color = :red)
    println(io, "\nMethods:")
    return println(io, methods(e.f))
end

"""
    isinplace(f, inplace_param_number, fname = "f", iip_preferred = true;
              has_two_dispatches = true,
              outofplace_param_number = inplace_param_number - 1)
    isinplace(f::AbstractSciMLFunction[, inplace_param_number])

Check whether a function operates in place by comparing its number of arguments
to the expected number. If `f` is an `AbstractSciMLFunction`, then the type
parameter is assumed to be correct and is used. Otherwise `inplace_param_number`
is checked against the methods table, where `inplace_param_number` is the number
of arguments for the in-place dispatch. The out-of-place dispatch is assumed
to have `outofplace_param_number` parameters (one less than the inplace version
by default). If neither of these dispatches exist, an error is thrown.
If the error is thrown, `fname` is used to tell the user which function has the
incorrect dispatches.

`iip_preferred` means that if `inplace_param_number=4` and methods of both 3 and
for 4 args exist, then it will be chosen as in-place. `iip_dispatch` flips this
decision.

If `has_two_dispatches = false`, then it is assumed that there is only one correct
dispatch, i.e. `f(u,p)` for OptimizationFunction, and thus the check for the oop
form is disabled and the 2-argument signature is ensured to be matched.

# See also

  - [`numargs`](@ref numargs)
"""
function isinplace(
        f, inplace_param_number, fname = "f", iip_preferred = true;
        has_two_dispatches = true, isoptimization = false,
        outofplace_param_number = inplace_param_number - 1
    )
    nargs = numargs(f)
    iip_dispatch = any(x -> x == inplace_param_number, nargs)
    oop_dispatch = any(x -> x == outofplace_param_number, nargs)

    if length(nargs) == 0
        throw(NoMethodsError(fname))
    end

    return if !iip_dispatch && !oop_dispatch && !isoptimization
        if all(>(inplace_param_number), nargs)
            throw(TooManyArgumentsError(fname, f))
        elseif all(<(outofplace_param_number), nargs) && has_two_dispatches
            # Possible extra safety?
            # Find if there's a `f(args...)` dispatch
            # If so, no error
            _parameters = if methods(f).ms[1].sig isa UnionAll
                Base.unwrap_unionall(methods(f).ms[1].sig).parameters
            else
                methods(f).ms[1].sig.parameters
            end

            for i in 1:length(nargs)
                if nargs[i] < inplace_param_number &&
                        any(isequal(Vararg{Any}), _parameters)
                    # If varargs, assume iip
                    return iip_preferred
                end
            end

            # No varargs detected, error that there are dispatches but not the right ones

            throw(TooFewArgumentsError(fname, f, isoptimization))
        else
            throw(FunctionArgumentsError(fname, f))
        end
    elseif oop_dispatch && !iip_dispatch && !has_two_dispatches

        # Possible extra safety?
        # Find if there's a `f(args...)` dispatch
        # If so, no error
        for i in 1:length(nargs)
            if nargs[i] < inplace_param_number &&
                    any(isequal(Vararg{Any}), methods(f).ms[1].sig.parameters)
                # If varargs, assume iip
                return iip_preferred
            end
        end

        throw(TooFewArgumentsError(fname, f, isoptimization))
    else
        if iip_preferred
            # Equivalent to, if iip_dispatch exists, treat as iip
            # Otherwise, it's oop
            iip_dispatch
        else
            # Equivalent to, if oop_dispatch exists, treat as oop
            # Otherwise, it's iip
            !oop_dispatch
        end
    end
end

isinplace(f::AbstractSciMLFunction{iip}) where {iip} = iip
function isinplace(
        f::AbstractSciMLFunction{iip}, inplace_param_number,
        fname = nothing
    ) where {iip}
    return iip
end

# Determine in-place status for FunctionWrappersWrapper by inspecting the return types
# of the wrapped FunctionWrapper variants. An IIP wrapper has all variants returning
# Nothing (the mutating convention), while OOP wrappers return non-Nothing types.
function isinplace(
        f::FunctionWrappersWrappers.FunctionWrappersWrapper{FW}, inplace_param_number,
        fname = "f", iip_preferred = true;
        has_two_dispatches = false, isoptimization = false,
        outofplace_param_number = inplace_param_number - 1
    ) where {FW}
    # Extract return types from FunctionWrapper{R,A} type parameters in the tuple
    return all(T -> T.parameters[1] === Nothing, FW.parameters)
end

"""
    @CSI_str cmd

Create an ANSI escape sequence string for the CSI command `cmd`.
"""
macro CSI_str(str)
    return :(string("\x1b[", $(esc(str)), "m"))
end

const TYPE_COLOR = CSI"38;2;86;182;194"  # Cyan
const NO_COLOR = CSI"0"

get_colorizers(io::IO) = get(io, :color, false) ? (TYPE_COLOR, NO_COLOR) : ("", "")

"""
    @def name definition
"""
macro def(name, definition)
    return quote
        macro $(esc(name))()
            return esc($(Expr(:quote, definition)))
        end
    end
end

using Base: typename

Base.@pure __parameterless_type(T) = typename(T).wrapper
parameterless_type(x) = __parameterless_type(typeof(x))
parameterless_type(::Type{T}) where {T} = __parameterless_type(T)

# support functions
export check_keywords, warn_compat
function check_keywords(alg, kwargs, warnlist)
    flg = false
    for (kw, val) in kwargs
        if kw in warnlist
            if val !== nothing
                flg = true
                @warn(string("The ", kw, " argument is ignored by ", alg, "."))
            end
        end
    end
    return flg
end

"""
$(SIGNATURES)

Emit a warning with a link to the solver compatibility chart in the documentation.
"""
warn_compat() = @warn("https://docs.sciml.ai/DiffEqDocs/stable/basics/compatibility_chart/")

"""
    @add_kwonly function_definition

Define keyword-only version of the `function_definition`.

    @add_kwonly function f(x; y=1)
        ...
    end

expands to:

    function f(x; y=1)
        ...
    end
    function f(; x = error("No argument x"), y=1)
        ...
    end
"""
macro add_kwonly(ex)
    return esc(add_kwonly(ex))
end

add_kwonly(ex::Expr) = add_kwonly(Val{ex.head}, ex)

function add_kwonly(::Type{<:Val}, ex)
    error("add_only does not work with expression $(ex.head)")
end

function add_kwonly(
        ::Union{
            Type{Val{:function}},
            Type{Val{:(=)}},
        }, ex::Expr
    )
    body = ex.args[2:end]  # function body
    default_call = ex.args[1]  # e.g., :(f(a, b=2; c=3))
    kwonly_call = add_kwonly(default_call)
    if kwonly_call === nothing
        return ex
    end

    return quote
        begin
            $ex
            $(Expr(ex.head, kwonly_call, body...))
        end
    end
end

function add_kwonly(::Type{Val{:where}}, ex::Expr)
    default_call = ex.args[1]
    rest = ex.args[2:end]
    kwonly_call = add_kwonly(default_call)
    if kwonly_call === nothing
        return nothing
    end
    return Expr(:where, kwonly_call, rest...)
end

function add_kwonly(::Type{Val{:call}}, default_call::Expr)
    # default_call is, e.g., :(f(a, b=2; c=3))
    funcname = default_call.args[1]  # e.g., :f
    required = []  # required positional arguments; e.g., [:a]
    optional = []  # optional positional arguments; e.g., [:(b=2)]
    default_kwargs = []
    for arg in default_call.args[2:end]
        if isa(arg, Symbol)
            push!(required, arg)
        elseif arg.head == :(::)
            push!(required, arg)
        elseif arg.head == :kw
            push!(optional, arg)
        elseif arg.head == :parameters
            @assert default_kwargs == []  # can I have :parameters twice?
            default_kwargs = arg.args
        else
            error("Not expecting to see: $arg")
        end
    end
    if isempty(required) && isempty(optional)
        # If the function is already keyword-only, do nothing:
        return nothing
    end
    if isempty(required)
        # It's not clear what should be done.  Let's not support it at
        # the moment:
        error("At least one positional mandatory argument is required.")
    end

    kwonly_kwargs = Expr(
        :parameters,
        [
            Expr(:kw, pa, :(error($("No argument $pa"))))
                for pa in required
        ]..., optional..., default_kwargs...
    )
    kwonly_call = Expr(:call, funcname, kwonly_kwargs)
    # e.g., :(f(; a=error(...), b=error(...), c=1, d=2))

    return kwonly_call
end

"""
$(SIGNATURES)

List symbols `export`'ed but not actually defined.
"""
function undefined_exports(mod)
    undefined = []
    for name in names(mod)
        if !isdefined(mod, name)
            push!(undefined, name)
        end
    end
    return undefined
end

# Overloaded in other repositories
function unwrap_cache end

struct Void{F}
    f::F
end
function (f::Void)(args...)
    f.f(args...)
    return nothing
end

"""
To be overloaded in ModelingToolkit
"""
function handle_varmap end

function mergedefaults(defaults, varmap, vars)
    return defs = if varmap isa Dict
        merge(defaults, varmap)
    elseif eltype(varmap) <: Pair
        merge(defaults, Dict(varmap))
    elseif eltype(varmap) <: Number
        merge(defaults, Dict(zip(vars, varmap)))
    else
        defaults
    end
end

_unwrap_val(::Val{B}) where {B} = B
_unwrap_val(B) = B

"""
    prepare_initial_state(u0) = u0

Whenever an initial state is passed to the SciML ecosystem, is passed to
`prepare_initial_state` and the result is used instead. If you define a
type which cannot be used as a state but can be converted to something that
can be, then you may define `prepare_initial_state(x::YourType) = ...`.

!!! warning

    This function is experimental and may be removed in the future.

See also: `prepare_function`.
"""
prepare_initial_state(u0) = u0

"""
    prepare_function(f) = f

Whenever a function is passed to the SciML ecosystem, is passed to
`prepare_function` and the result is used instead. If you define a type which
cannot be used as a function in the SciML ecosystem but can be converted to
something that can be, then you may define `prepare_function(x::YourType) = ...`.

`prepare_function` may be called before or after
the arity of a function is computed with `numargs`

!!! warning

    This function is experimental and may be removed in the future.

See also: `prepare_initial_state`.
"""
prepare_function(f) = f

"""
    strip_solution(sol)

Strips a SciMLSolution object and its interpolation of their functions to better accommodate serialization.
"""
function strip_solution(sol::AbstractSciMLSolution)
    return sol
end

using ModelingToolkit, OrdinaryDiffEq, RecursiveArrayTools, StochasticDiffEq,
    SymbolicIndexingInterface, Test
using ModelingToolkit: t_nounits as t, D_nounits as D
using SciMLStructures: canonicalize, Tunable
### Tests on non-layered model (everything should work). ###

@parameters a b c d
@variables s1(t) s2(t)

eqs = [
    D(s1) ~ a * s1 / (1 + s1 + s2) - b * s1,
    D(s2) ~ +c * s2 / (1 + s1 + s2) - d * s2,
]

@named pop_model = System(eqs, t)
population_model = complete(pop_model)
# Tests on ODEProblem.
u0 = [s1 => 2.0, s2 => 1.0]
p = [a => 2.0, b => 1.0, c => 1.0, d => 1.0]
tspan = (0.0, 1000000.0)
oprob = ODEProblem(population_model, [u0; p], tspan)
integrator = init(oprob, Rodas4())

@test_throws Exception integrator[a]
@test_throws Exception integrator[population_model.a]
@test_throws Exception integrator[:a]
@test getp(oprob, a)(integrator) == getp(oprob, population_model.a)(integrator) ==
    getp(oprob, :a)(integrator) == 2.0
@test integrator.ps[a] == integrator.ps[population_model.a] == integrator.ps[:a] == 2.0
@test getp(oprob, b)(integrator) == getp(oprob, population_model.b)(integrator) ==
    getp(oprob, :b)(integrator) == 1.0
@test integrator.ps[b] == integrator.ps[population_model.b] == integrator.ps[:b] == 1.0
@test getp(oprob, c)(integrator) == getp(oprob, population_model.c)(integrator) ==
    getp(oprob, :c)(integrator) == 1.0
@test integrator.ps[d] == integrator.ps[population_model.d] == integrator.ps[:d] == 1.0
@test getp(oprob, d)(integrator) == getp(oprob, population_model.d)(integrator) ==
    getp(oprob, :d)(integrator) == 1.0
@test integrator.ps[d] == integrator.ps[population_model.d] == integrator.ps[:d] == 1.0

@test integrator[s1] == integrator[population_model.s1] == integrator[:s1] == 2.0
@test integrator[s2] == integrator[population_model.s2] == integrator[:s2] == 1.0
@test integrator[solvedvariables] == integrator.u
@test integrator[allvariables] == integrator.u
step!(integrator, 100.0, true)

@test getp(population_model, a)(integrator) ==
    getp(population_model, population_model.a)(integrator) ==
    getp(population_model, :a)(integrator) == 2.0
@test getp(population_model, b)(integrator) ==
    getp(population_model, population_model.b)(integrator) ==
    getp(population_model, :b)(integrator) == 1.0
@test getp(population_model, c)(integrator) ==
    getp(population_model, population_model.c)(integrator) ==
    getp(population_model, :c)(integrator) == 1.0
@test getp(population_model, d)(integrator) ==
    getp(population_model, population_model.d)(integrator) ==
    getp(population_model, :d)(integrator) == 1.0

@test integrator[s1] == integrator[population_model.s1] == integrator[:s1] != 2.0
@test integrator[s2] == integrator[population_model.s2] == integrator[:s2] != 1.0

setp(oprob, a)(integrator, 10.0)
@test getp(integrator, a)(integrator) == getp(integrator, population_model.a)(integrator) ==
    getp(integrator, :a)(integrator) == 10.0
@test integrator.ps[a] == integrator.ps[population_model.a] == integrator.ps[:a] == 10.0
setp(population_model, population_model.b)(integrator, 20.0)
@test getp(integrator, b)(integrator) == getp(integrator, population_model.b)(integrator) ==
    getp(integrator, :b)(integrator) == 20.0
@test integrator.ps[b] == integrator.ps[population_model.b] == integrator.ps[:b] == 20.0
setp(integrator, c)(integrator, 30.0)
@test getp(integrator, c)(integrator) == getp(integrator, population_model.c)(integrator) ==
    getp(integrator, :c)(integrator) == 30.0
@test integrator.ps[c] == integrator.ps[population_model.c] == integrator.ps[:c] == 30.0
integrator.ps[d] = 40.0
@test integrator.ps[d] == integrator.ps[population_model.d] == integrator.ps[:d] == 40.0

integrator[s1] = 10.0
@test integrator[s1] == integrator[population_model.s1] == integrator[:s1] == 10.0
integrator[population_model.s2] = 10.0
@test integrator[s2] == integrator[population_model.s2] == integrator[:s2] == 10.0
integrator[:s1] = 1.0
@test integrator[s1] == integrator[population_model.s1] == integrator[:s1] == 1.0

# Tests on SDEProblem
noiseeqs = [
    0.1 * s1,
    0.1 * s2,
]
@named noisy_population_model = SDESystem(pop_model, noiseeqs)
noisy_population_model = complete(noisy_population_model)
sprob = SDEProblem(noisy_population_model, [u0; p], (0.0, 100.0))
integrator = init(sprob, ImplicitEM())

step!(integrator, 100.0, true)

@test getp(sprob, a)(integrator) == getp(sprob, noisy_population_model.a)(integrator) ==
    getp(sprob, :a)(integrator) == 2.0
@test getp(sprob, b)(integrator) == getp(sprob, noisy_population_model.b)(integrator) ==
    getp(sprob, :b)(integrator) == 1.0
@test getp(sprob, c)(integrator) == getp(sprob, noisy_population_model.c)(integrator) ==
    getp(sprob, :c)(integrator) == 1.0
@test getp(sprob, d)(integrator) == getp(sprob, noisy_population_model.d)(integrator) ==
    getp(sprob, :d)(integrator) == 1.0
@test integrator[s1] == integrator[noisy_population_model.s1] == integrator[:s1] != 2.0
@test integrator[s2] == integrator[noisy_population_model.s2] == integrator[:s2] != 1.0

setp(integrator, a)(integrator, 10.0)
@test getp(noisy_population_model, a)(integrator) ==
    getp(noisy_population_model, noisy_population_model.a)(integrator) ==
    getp(noisy_population_model, :a)(integrator) == 10.0
setp(sprob, noisy_population_model.b)(integrator, 20.0)
@test getp(noisy_population_model, b)(integrator) ==
    getp(noisy_population_model, noisy_population_model.b)(integrator) ==
    getp(noisy_population_model, :b)(integrator) == 20.0
setp(noisy_population_model, c)(integrator, 30.0)
@test getp(noisy_population_model, c)(integrator) ==
    getp(noisy_population_model, noisy_population_model.c)(integrator) ==
    getp(noisy_population_model, :c)(integrator) == 30.0

integrator[s1] = 10.0
@test integrator[s1] == integrator[noisy_population_model.s1] == integrator[:s1] == 10.0
integrator[noisy_population_model.s2] = 10.0
@test integrator[s2] == integrator[noisy_population_model.s2] == integrator[:s2] == 10.0
integrator[:s1] = 1.0
@test integrator[s1] == integrator[noisy_population_model.s1] == integrator[:s1] == 1.0

@parameters σ ρ β
@variables x(t) y(t) z(t)

eqs = [
    D(x) ~ σ * (y - x),
    D(y) ~ x * (ρ - z) - y,
    D(z) ~ x * y - β * z,
]

@named lorenz1 = System(eqs, t)
@named lorenz2 = System(eqs, t)

@parameters γ
@variables a(t) α(t)
connections = [
    0 ~ lorenz1.x + lorenz2.y + a * γ,
    α ~ 2lorenz1.x + a * γ,
]
@mtkbuild sys = System(
    connections, t, [a, α], [γ], systems = [lorenz1, lorenz2]
)

u0 = [
    lorenz1.x => 1.0,
    lorenz1.y => 0.0,
    lorenz1.z => 0.0,
    lorenz2.x => 0.0,
    lorenz2.y => 1.0,
    lorenz2.z => 0.0,
    a => 2.0,
]

p = [
    lorenz1.σ => 10.0,
    lorenz1.ρ => 28.0,
    lorenz1.β => 8 / 3,
    lorenz2.σ => 10.0,
    lorenz2.ρ => 28.0,
    lorenz2.β => 8 / 3,
    γ => 2.0,
]

tspan = (0.0, 100.0)
prob = ODEProblem(sys, [u0; p], tspan)
integrator = init(prob, Rodas4())
sol = solve(prob, Rodas4())
step!(integrator, 100.0, true)

@test_throws Any integrator[b]
@test_throws Any integrator['a']

@test integrator[a] isa Real
@test_throws Any integrator[a, 1]
@test_throws Any integrator[a, 1:5]
@test_throws Any integrator[a, [1, 2, 3]]

@test integrator[1] isa Real
@test integrator[1:2] isa AbstractArray
@test integrator[[1, 2]] isa AbstractArray

@test integrator[lorenz1.x] isa Real
@test integrator[t] isa Real
@test integrator[α] isa Real
@test getp(prob, γ)(integrator) isa Real
@test getp(prob, γ)(integrator) == 2.0
@test getp(prob, (lorenz1.σ, lorenz1.ρ))(integrator) isa Tuple

@test length(integrator[[lorenz1.x, lorenz2.x]]) == 2
@test getp(integrator, [γ, lorenz1.σ])(integrator) isa Vector{Float64}
@test length(getp(integrator, [γ, lorenz1.σ])(integrator)) == 2

@variables q(t)[1:2] = [1.0, 2.0]
eqs = [
    D(q[1]) ~ 2q[1]
    D(q[2]) ~ 2.0
]
@named sys2 = System(eqs, t, [q...], [])
sys2_simplified = mtkcompile(sys2)
prob2 = ODEProblem(sys2_simplified, [], (0.0, 5.0))
integrator2 = init(prob2, Tsit5())

@test integrator2[q] isa Vector{Float64}
@test length(integrator2[q]) == length(q)
@test integrator2[collect(q)] == integrator2[q]
@test integrator2[(q...,)] isa NTuple{length(q), Float64}

@testset "Symbolic set_u!" begin
    @variables u(t)
    eqs = [D(u) ~ u]

    @mtkcompile sys2 = System(eqs, t)

    tspan = (0.0, 5.0)

    prob1 = ODEProblem(sys2, [u => 1.0], tspan)
    prob2 = ODEProblem(sys2, [u => 2.0], tspan)

    integrator1 = init(prob1, Tsit5(); save_everystep = false)
    integrator2 = init(prob2, Tsit5(); save_everystep = false)

    set_u!(integrator1, u, 2.0)

    @test integrator1.u ≈ integrator2.u
end

# Tests various interface methods:
@test_throws Any getp(sys, σ)(integrator)
tunable, _, _ = canonicalize(Tunable(), integrator.p)
@test in(getp(sys, lorenz1.σ)(integrator), tunable)
@test in(getp(sys, lorenz2.σ)(integrator), tunable)
@test_throws Any getp(sol, :σ)(sol)

@test_throws Any integrator[x]
@test in(integrator[lorenz1.x], integrator.u)
@test in(integrator[lorenz2.x], integrator.u)
@test_throws Any getp(sol, :x)(sol)

@test_throws Any setp(integrator, σ)(integrator, 2.0)
setp(integrator, lorenz1.σ)(integrator, 2.0)
@test getp(integrator, lorenz1.σ)(integrator) == 2.0
@test getp(integrator, lorenz2.σ)(integrator) != 2.0
setp(integrator, lorenz2.σ)(integrator, 2.0)
@test getp(integrator, lorenz2.σ)(integrator) == 2.0
@test_throws Any getp(sol, :σ)(sol)

@test_throws Any integrator[x] = 2.0
integrator[lorenz1.x] = 2.0
@test integrator[lorenz1.x] == 2.0
@test integrator[lorenz2.x] != 2.0
integrator[lorenz2.x] = 2.0
@test integrator[lorenz2.x] == 2.0
@test_throws Any sol[:x]

# Check if indexing using variable names from interpolated integrator works
# It doesn't because this returns a Vector{Vector{T}} and not a DiffEqArray
# interpolated_integrator = integrator(0.0:1.0:10.0)
# @test interpolated_integrator[α] isa Vector
# @test interpolated_integrator[α, :] isa Vector
# @test interpolated_integrator[α, 2] isa Float64
# @test length(interpolated_integrator[α, 1:5]) == 5
# @test interpolated_integrator[α] ≈
#       2interpolated_integrator[lorenz1.x] .+ interpolated_integrator[a] .* 2.0
# @test collect(interpolated_integrator[t]) isa Vector
# @test collect(interpolated_integrator[t, :]) isa Vector
# @test interpolated_integrator[t, 2] isa Float64
# @test length(interpolated_integrator[t, 1:5]) == 5

# integrator1 = integrator(0.0:1.0:10.0)
# @test integrator1.u isa Vector
# @test first(integrator1.u) isa Vector
# @test length(integrator1.u) == 11
# @test length(integrator1.t) == 11

# integrator2 = integrator(0.1)
# @test integrator2 isa Vector
# @test length(integrator2) == length(unknowns(sys_simplified))
# @test first(integrator2) isa Real

# integrator3 = integrator(0.0:1.0:10.0, idxs = [lorenz1.x, lorenz2.x])
# @test integrator3.u isa Vector
# @test first(integrator3.u) isa Vector
# @test length(integrator3.u) == 11
# @test length(integrator3.t) == 11
# @test collect(integrator3[t]) ≈ integrator3.t
# @test collect(integrator3[t, 1:5]) ≈ integrator3.t[1:5]
# @test integrator(0.0:1.0:10.0, idxs = [lorenz1.x, 1]) isa RecursiveArrayTools.DiffEqArray

# integrator4 = integrator(0.1, idxs = [lorenz1.x, lorenz2.x])
# @test integrator4 isa Vector
# @test length(integrator4) == 2
# @test first(integrator4) isa Real
# @test integrator(0.1, idxs = [lorenz1.x, 1]) isa Vector{Real}

# integrator5 = integrator(0.0:1.0:10.0, idxs = lorenz1.x)
# @test integrator5.u isa Vector
# @test first(integrator5.u) isa Real
# @test length(integrator5.u) == 11
# @test length(integrator5.t) == 11
# @test collect(integrator5[t]) ≈ integrator3.t
# @test collect(integrator5[t, 1:5]) ≈ integrator3.t[1:5]
# @test_throws Any integrator(0.0:1.0:10.0, idxs = 1.2)

# integrator6 = integrator(0.1, idxs = lorenz1.x)
# @test integrator6 isa Real
# @test_throws Any integrator(0.1, idxs = 1.2)

# integrator7 = integrator(0.0:1.0:10.0, idxs = [2, 1])
# @test integrator7.u isa Vector
# @test first(integrator7.u) isa Vector
# @test length(integrator7.u) == 11
# @test length(integrator7.t) == 11
# @test collect(integrator7[t]) ≈ integrator3.t
# @test collect(integrator7[t, 1:5]) ≈ integrator3.t[1:5]

# integrator8 = integrator(0.1, idxs = [2, 1])
# @test integrator8 isa Vector
# @test length(integrator8) == 2
# @test first(integrator8) isa Real

# integrator9 = integrator(0.0:1.0:10.0, idxs = 2)
# @test integrator9.u isa Vector
# @test first(integrator9.u) isa Real
# @test length(integrator9.u) == 11
# @test length(integrator9.t) == 11
# @test collect(integrator9[t]) ≈ integrator3.t
# @test collect(integrator9[t, 1:5]) ≈ integrator3.t[1:5]

# integrator10 = integrator(0.1, idxs = 2)
# @test integrator10 isa Real

using LinearAlgebra
sts = @variables x(t)[1:3] = [1, 2, 3.0] y(t) = 1.0
ps = @parameters p[1:3] = [1, 2, 3]
eqs = [
    collect(D.(x) .~ x)
    D(y) ~ norm(x) * y - x[1]
]
@mtkcompile sys = System(eqs, t, [sts...;], [ps...;])
prob = ODEProblem(sys, [], (0, 1.0))
integrator = init(prob, Tsit5(), save_everystep = false)
@test integrator[x] isa Vector{Float64}
@test integrator[@nonamespace sys.x] isa Vector{Float64}

getx = getsym(integrator, x)
gety = getsym(integrator, :y)
get_arr = getsym(integrator, [x, y])
get_tuple = getsym(integrator, (x, y))
get_obs = getsym(integrator, x[1] / p[1])
@test getx(integrator) == [1.0, 2.0, 3.0]
@test gety(integrator) == 1.0
@test get_arr(integrator) == [[1.0, 2.0, 3.0], 1.0]
@test get_tuple(integrator) == ([1.0, 2.0, 3.0], 1.0)
@test get_obs(integrator) == 1.0

setx! = setsym(integrator, x)
sety! = setsym(integrator, :y)
set_arr! = setsym(integrator, [x, y])
set_tuple! = setsym(integrator, (x, y))

setx!(integrator, [4.0, 5.0, 6.0])
@test getx(integrator) == [4.0, 5.0, 6.0]
sety!(integrator, 3.0)
@test gety(integrator) == 3.0
set_arr!(integrator, [[1.0, 2.0, 3.0], 1.0])
@test get_arr(integrator) == [[1.0, 2.0, 3.0], 1.0]
set_tuple!(integrator, ([2.0, 4.0, 6.0], 2.0))
@test get_tuple(integrator) == ([2.0, 4.0, 6.0], 2.0)
@test getp(sys, p)(integrator) == integrator.ps[p] == [1, 2, 3]
setp(sys, p)(integrator, [4, 5, 6])
@test getp(sys, p)(integrator) == integrator.ps[p] == [4, 5, 6]
integrator.ps[p] = [7, 8, 9]
@test getp(sys, p)(integrator) == integrator.ps[p] == [7, 8, 9]

# Issue#653
@parameters p
@variables X(t)

eq = D(X) ~ p - X
@mtkcompile osys = System([eq], t)
oprob = ODEProblem(osys, [X => 0.1, p => 1.0], (0.0, 1.0))

"""
    AbstractWrappedFunction{iip}

Abstract base type for function wrappers used in automatic differentiation and sensitivity analysis.
These wrappers provide specialized interfaces for computing derivatives with respect to different variables.

# Type Parameter
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
"""
abstract type AbstractWrappedFunction{iip} end
isinplace(f::AbstractWrappedFunction{iip}) where {iip} = iip

"""
    TimeGradientWrapper{iip, fType, uType, P} <: AbstractWrappedFunction{iip}

Wraps functions to compute gradients with respect to time. This wrapper is particularly useful for 
sensitivity analysis and optimization problems where the time dependence of the solution is critical.

# Fields
- `f`: The function to wrap
- `uprev`: Previous state value
- `p`: Parameters

# Type Parameters
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
- `fType`: Type of the wrapped function
- `uType`: Type of the state variables
- `P`: Type of the parameters

This wrapper enables automatic differentiation with respect to time by providing a consistent
interface for computing `∂f/∂t` across different AD systems.
"""
mutable struct TimeGradientWrapper{iip, fType, uType, P} <: AbstractWrappedFunction{iip}
    f::fType
    uprev::uType
    p::P
end

function TimeGradientWrapper{iip}(f::F, uprev, p) where {F, iip}
    return TimeGradientWrapper{iip, F, typeof(uprev), typeof(p)}(f, uprev, p)
end
function TimeGradientWrapper(f::F, uprev, p) where {F}
    return TimeGradientWrapper{isinplace(f, 4)}(f, uprev, p)
end

function (ff::TimeGradientWrapper{true})(t)
    (du2 = similar(ff.uprev); ff.f(du2, ff.uprev, ff.p, t); du2)
end
(ff::TimeGradientWrapper{true})(du2, t) = ff.f(du2, ff.uprev, ff.p, t)

(ff::TimeGradientWrapper{false})(t) = ff.f(ff.uprev, ff.p, t)

"""
    UJacobianWrapper{iip, fType, tType, P} <: AbstractWrappedFunction{iip}

Wraps functions to compute Jacobians with respect to state variables `u`. This is one of the most 
commonly used wrappers in the SciML ecosystem for computing the derivative of the right-hand side 
function with respect to the state variables.

# Fields
- `f`: The function to wrap
- `t`: Time value
- `p`: Parameters

# Type Parameters
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
- `fType`: Type of the wrapped function
- `tType`: Type of the time variable
- `P`: Type of the parameters

This wrapper enables efficient computation of `∂f/∂u` for Jacobian calculations in numerical solvers
and automatic differentiation systems.
"""
mutable struct UJacobianWrapper{iip, fType, tType, P} <: AbstractWrappedFunction{iip}
    f::fType
    t::tType
    p::P
end

function UJacobianWrapper{iip}(f::F, t, p) where {F, iip}
    return UJacobianWrapper{iip, F, typeof(t), typeof(p)}(f, t, p)
end
UJacobianWrapper(f::F, t, p) where {F} = UJacobianWrapper{isinplace(f, 4)}(f, t, p)

(ff::UJacobianWrapper{true})(du1, uprev) = ff.f(du1, uprev, ff.p, ff.t)
function (ff::UJacobianWrapper{true})(uprev)
    (du1 = similar(uprev); ff.f(du1, uprev, ff.p, ff.t); du1)
end
(ff::UJacobianWrapper{true})(du1, uprev, p, t) = ff.f(du1, uprev, p, t)
function (ff::UJacobianWrapper{true})(uprev, p, t)
    (du1 = similar(uprev); ff.f(du1, uprev, p, t); du1)
end

(ff::UJacobianWrapper{false})(uprev) = ff.f(uprev, ff.p, ff.t)
(ff::UJacobianWrapper{false})(uprev, p, t) = ff.f(uprev, p, t)

"""
    TimeDerivativeWrapper{iip, F, uType, P} <: AbstractWrappedFunction{iip}

Wraps functions to compute derivatives with respect to time. This wrapper is used when you need to 
compute `∂f/∂t` for sensitivity analysis or when the function has explicit time dependence.

# Fields
- `f`: The function to wrap
- `u`: State variables
- `p`: Parameters

# Type Parameters
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
- `F`: Type of the wrapped function
- `uType`: Type of the state variables
- `P`: Type of the parameters

This wrapper provides a consistent interface for time derivative computations across different
automatic differentiation backends.
"""
mutable struct TimeDerivativeWrapper{iip, F, uType, P} <: AbstractWrappedFunction{iip}
    f::F
    u::uType
    p::P
end

function TimeDerivativeWrapper{iip}(f::F, u, p) where {F, iip}
    return TimeDerivativeWrapper{iip, F, typeof(u), typeof(p)}(f, u, p)
end
function TimeDerivativeWrapper(f::F, u, p) where {F}
    return TimeDerivativeWrapper{isinplace(f, 4)}(f, u, p)
end

(ff::TimeDerivativeWrapper{false})(t) = ff.f(ff.u, ff.p, t)
(ff::TimeDerivativeWrapper{true})(du1, t) = ff.f(du1, ff.u, ff.p, t)
(ff::TimeDerivativeWrapper{true})(t) = (du1 = similar(ff.u); ff.f(du1, ff.u, ff.p, t); du1)

"""
    UDerivativeWrapper{iip, F, tType, P} <: AbstractWrappedFunction{iip}

Wraps functions to compute derivatives with respect to state variables. This wrapper is used for 
computing `∂f/∂u` and is fundamental for Jacobian computations in numerical solvers.

# Fields
- `f`: The function to wrap
- `t`: Time value
- `p`: Parameters

# Type Parameters
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
- `F`: Type of the wrapped function
- `tType`: Type of the time variable
- `P`: Type of the parameters

This wrapper enables efficient state derivative computations for use in automatic differentiation
and numerical analysis algorithms.
"""
mutable struct UDerivativeWrapper{iip, F, tType, P} <: AbstractWrappedFunction{iip}
    f::F
    t::tType
    p::P
end

function UDerivativeWrapper{iip}(f::F, t, p) where {F, iip}
    return UDerivativeWrapper{iip, F, typeof(t), typeof(p)}(f, t, p)
end
UDerivativeWrapper(f::F, t, p) where {F} = UDerivativeWrapper{isinplace(f, 4)}(f, t, p)

(ff::UDerivativeWrapper{false})(u) = ff.f(u, ff.p, ff.t)
(ff::UDerivativeWrapper{true})(du1, u) = ff.f(du1, u, ff.p, ff.t)
(ff::UDerivativeWrapper{true})(u) = (du1 = similar(u); ff.f(du1, u, ff.p, ff.t); du1)

"""
    ParamJacobianWrapper{iip, fType, tType, uType} <: AbstractWrappedFunction{iip}

Wraps functions to compute Jacobians with respect to parameters `p`. This wrapper is essential for 
parameter estimation, inverse problems, and sensitivity analysis with respect to model parameters.

# Fields
- `f`: The function to wrap
- `t`: Time value
- `u`: State variables

# Type Parameters
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
- `fType`: Type of the wrapped function
- `tType`: Type of the time variable
- `uType`: Type of the state variables

This wrapper enables efficient computation of `∂f/∂p` for parameter sensitivity analysis and
optimization algorithms.
"""
mutable struct ParamJacobianWrapper{iip, fType, tType, uType} <: AbstractWrappedFunction{iip}
    f::fType
    t::tType
    u::uType
end

function ParamJacobianWrapper{iip}(f::F, t, u) where {F, iip}
    return ParamJacobianWrapper{iip, F, typeof(t), typeof(u)}(f, t, u)
end
ParamJacobianWrapper(f::F, t, u) where {F} = ParamJacobianWrapper{isinplace(f, 4)}(f, t, u)

(ff::ParamJacobianWrapper{true})(du1, p) = ff.f(du1, ff.u, p, ff.t)
function (ff::ParamJacobianWrapper{true})(p)
    du1 = similar(p, size(ff.u))
    ff.f(du1, ff.u, p, ff.t)
    return du1
end
(ff::ParamJacobianWrapper{false})(p) = ff.f(ff.u, p, ff.t)
function (ff::ParamJacobianWrapper{false})(du1, p)
    return du1 .= ff.f(ff.u, p, ff.t)
end

"""
    JacobianWrapper{iip, fType, pType} <: AbstractWrappedFunction{iip}

A general-purpose Jacobian wrapper that can be configured for different types of Jacobian computations. 
This wrapper provides a unified interface for various Jacobian calculations across the SciML ecosystem.

# Fields
- `f`: The function to wrap
- `p`: Parameters

# Type Parameters
- `iip`: Boolean indicating if the function is in-place (`true`) or out-of-place (`false`)
- `fType`: Type of the wrapped function
- `pType`: Type of the parameters

This wrapper provides a flexible interface for Jacobian computations that can adapt to different
automatic differentiation backends and numerical methods.
"""
mutable struct JacobianWrapper{iip, fType, pType} <: AbstractWrappedFunction{iip}
    f::fType
    p::pType
end

JacobianWrapper{iip}(f::F, p) where {F, iip} = JacobianWrapper{iip, F, typeof(p)}(f, p)
JacobianWrapper(f::F, p) where {F} = JacobianWrapper{isinplace(f, 3)}(f, p)

(uf::JacobianWrapper{false})(u) = uf.f(u, uf.p)
(uf::JacobianWrapper{false})(res, u) = (vec(res) .= vec(uf.f(u, uf.p)))
(uf::JacobianWrapper{true})(res, u) = uf.f(res, u, uf.p)

using OrdinaryDiffEq, Test, LinearAlgebra
prob = ODEProblem((u, p, t) -> 1.01u, 0.5, (0.0, 1.0), save_start = false, save_end = false)
function prob_func(prob, i, repeat)
    return remake(prob, u0 = rand() * prob.u0)
end
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim = solve(
    ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 10,
    save_everystep = false
)
@test ndims(sim) == 2
@test length(sim.u) == 10
@test eltype(sim.u) <: ODESolution
ts = 0.0:0.1:1.0

using SciMLBase.EnsembleAnalysis
sim = solve(ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 10, saveat = 0.1)
timeseries_point_meancov(sim, ts)
timeseries_point_median(sim, ts)

function prob_sol(_p)
    prob = ODEProblem(
        (u, p, t) -> p .* u, _p, (0.0, 1.0), _p, save_start = false,
        save_end = false
    )
    return sim = solve(prob, Tsit5())
end
mapres = SciMLBase.responsible_map(prob_sol, [0.5, diagm([1.0, 1.0])])
@test length(mapres) == 2

"""
$(TYPEDEF)
"""
struct StandardNonlinearProblem end

@doc doc"""

Defines an interval nonlinear system problem.
Documentation Page: <https://docs.sciml.ai/NonlinearSolve/stable/basics/nonlinear_problem/>

## Mathematical Specification of an Interval Nonlinear Problem

To define a Nonlinear Problem, you simply need to give the function ``f``
which defines the nonlinear system:

```math
f(t,p) = u = 0
```

along with an interval `tspan`, ``t \in [t_0,t_f]``, within which the root should be found.
`f` should be specified as `f(t,p)` (or in-place as `f(u,t,p)`), and `tspan` should be a
`Tuple{T,T} where T <: Number`.

!!! note

    The output value `u` is not required to be a scalar. When `u` is an `AbstractArray`, the
    problem is a simultaneous interval nonlinear problem where the solvers are made to give
    the first `t` for which any of the `u` hit zero. Currently, none of the solvers support
    this mode.

## Problem Type

### Constructors

```julia
IntervalNonlinearProblem(f::NonlinearFunction, tspan, p = NullParameters(); kwargs...)
IntervalNonlinearProblem{isinplace}(f, tspan, p = NullParameters(); kwargs...)
```

`isinplace` optionally sets whether the function is in-place or not. This is
determined automatically, but not inferred.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

### Fields

* `f`: The function in the problem.
* `tspan`: The interval in which the root is to be found.
* `p`: The parameters for the problem. Defaults to `NullParameters`.
* `kwargs`: The keyword arguments passed on to the solvers.
"""
struct IntervalNonlinearProblem{isinplace, tType, P, F, K, PT} <:
    AbstractIntervalNonlinearProblem{nothing, isinplace}
    f::F
    tspan::tType
    p::P
    problem_type::PT
    kwargs::K
    @add_kwonly function IntervalNonlinearProblem{iip}(
            f::AbstractIntervalNonlinearFunction{
                iip,
            },
            tspan,
            p = NullParameters(),
            problem_type = StandardNonlinearProblem();
            kwargs...
        ) where {iip}
        warn_paramtype(p)
        new{
            iip, typeof(tspan), typeof(p), typeof(f),
            typeof(kwargs), typeof(problem_type),
        }(
            f,
            tspan,
            p,
            problem_type,
            kwargs
        )
    end

    """
    $(SIGNATURES)

    Define a steady state problem using the given function.
    `isinplace` optionally sets whether the function is inplace or not.
    This is determined automatically, but not inferred.
    """
    function IntervalNonlinearProblem{iip}(f, tspan, p = NullParameters()) where {iip}
        return IntervalNonlinearProblem{iip}(IntervalNonlinearFunction{iip}(f), tspan, p)
    end
end

"""
$(SIGNATURES)

Define a nonlinear problem using an instance of
[`IntervalNonlinearFunction`](@ref IntervalNonlinearFunction).
"""
function IntervalNonlinearProblem(
        f::AbstractIntervalNonlinearFunction, tspan,
        p = NullParameters(); kwargs...
    )
    return IntervalNonlinearProblem{isinplace(f)}(f, tspan, p; kwargs...)
end

function IntervalNonlinearProblem(f, tspan, p = NullParameters(); kwargs...)
    return IntervalNonlinearProblem(IntervalNonlinearFunction(f), tspan, p; kwargs...)
end

@doc doc"""

Defines a nonlinear system problem.
Documentation Page: <https://docs.sciml.ai/NonlinearSolve/stable/basics/nonlinear_problem/>

## Mathematical Specification of a Nonlinear Problem

To define a Nonlinear Problem, you simply need to give the function ``f``
which defines the nonlinear system:

```math
f(u,p) = 0
```

and an initial guess ``u₀`` of where `f(u, p) = 0`. `f` should be specified as `f(u, p)`
(or in-place as `f(du, u, p)`), and `u₀` should be an AbstractArray (or number)
whose geometry matches the desired geometry of `u`. Note that we are not limited
to numbers or vectors for `u₀`; one is allowed to provide `u₀` as arbitrary
matrices / higher-dimension tensors as well.

## Problem Type

### Constructors

```julia
NonlinearProblem(f::NonlinearFunction, u0, p = NullParameters(); kwargs...)
NonlinearProblem{isinplace}(f, u0, p = NullParameters(); kwargs...)
```

`isinplace` optionally sets whether the function is in-place or not. This is
determined automatically, but not inferred.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the
[NonlinearFunctions](@ref nonlinearfunctions) page.

### Fields

* `f`: The function in the problem.
* `u0`: The initial guess for the root.
* `p`: The parameters for the problem. Defaults to `NullParameters`.
* `lb`: Lower bounds for the solution. Defaults to `nothing`.
* `ub`: Upper bounds for the solution. Defaults to `nothing`.
* `kwargs`: The keyword arguments passed on to the solvers.
"""
mutable struct NonlinearProblem{uType, isinplace, P, F, K, PT, LB, UB} <:
    AbstractNonlinearProblem{uType, isinplace}
    f::F
    u0::uType
    p::P
    problem_type::PT
    lb::LB
    ub::UB
    kwargs::K
    @add_kwonly function NonlinearProblem{iip}(
            f::AbstractNonlinearFunction{iip}, u0,
            p = NullParameters(),
            problem_type = StandardNonlinearProblem();
            lb = nothing,
            ub = nothing,
            kwargs...
        ) where {iip}
        if haskey(kwargs, :p)
            error("`p` specified as a keyword argument `p = $(kwargs[:p])` to `NonlinearProblem`. This is not supported.")
        end
        warn_paramtype(p)
        new{
            typeof(u0), iip, typeof(p), typeof(f),
            typeof(kwargs), typeof(problem_type), typeof(lb), typeof(ub),
        }(
            f,
            u0,
            p,
            problem_type,
            lb,
            ub,
            kwargs
        )
    end

    """
    $(SIGNATURES)

    Define a steady state problem using the given function.
    `isinplace` optionally sets whether the function is inplace or not.
    This is determined automatically, but not inferred.
    """
    function NonlinearProblem{iip}(f, u0, p = NullParameters(); kwargs...) where {iip}
        return NonlinearProblem{iip}(NonlinearFunction{iip}(f), u0, p; kwargs...)
    end
end

"""
$(SIGNATURES)

Define a nonlinear problem using an instance of
[`AbstractNonlinearFunction`](@ref AbstractNonlinearFunction).
"""
function NonlinearProblem(f::AbstractNonlinearFunction, u0, p = NullParameters(); kwargs...)
    return NonlinearProblem{isinplace(f)}(f, u0, p; kwargs...)
end

function NonlinearProblem(f, u0, p = NullParameters(); kwargs...)
    return NonlinearProblem(NonlinearFunction(f), u0, p; kwargs...)
end

"""
$(SIGNATURES)

Define a `NonlinearProblem` problem from `SteadyStateProblem`
"""
function NonlinearProblem(prob::AbstractNonlinearProblem)
    return NonlinearProblem{isinplace(prob)}(prob.f, prob.u0, prob.p)
end

"""
$(SIGNATURES)

Define a nonlinear problem using an instance of
[`AbstractODEFunction`](@ref AbstractODEFunction). Note that
this is interpreted in the form of the steady state problem, i.e.
find the ODE's solution at time ``t = \\infty``.
"""
function NonlinearProblem(f::AbstractODEFunction, u0, p = NullParameters(); kwargs...)
    return NonlinearProblem{isinplace(f)}(f, u0, p; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: NonlinearProblem}
    return function ctor(f, u0, p, pt, lb, ub, kw)
        if f isa AbstractNonlinearFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 4)
        end
        return NonlinearProblem{iip}(f, u0, p, pt; lb, ub, kw...)
    end
end

"""
$(SIGNATURES)

Define a nonlinear problem from a standard ODE problem. Note that
this is interpreted in the form of the steady state problem, i.e.
find the ODE's solution at time ``t = ∞``
"""
function NonlinearProblem(prob::AbstractODEProblem)
    return NonlinearProblem{isinplace(prob)}(prob.f, prob.u0, prob.p; prob.kwargs...)
end

function Base.setproperty!(prob::NonlinearProblem, s::Symbol, v)
    @warn "Mutation of NonlinearProblem detected. SciMLBase v2.0 has made NonlinearProblem temporarily mutable in order to allow for interfacing with EnzymeRules due to a current limitation in the rule system. This change is only intended to be temporary and NonlinearProblem will return to being a struct in a later non-breaking release. Do not rely on this behavior, use with caution."
    return Base.setfield!(prob, s, v)
end

function Base.setproperty!(prob::NonlinearProblem, s::Symbol, v, order::Symbol)
    @warn "Mutation of NonlinearProblem detected. SciMLBase v2.0 has made NonlinearProblem temporarily mutable in order to allow for interfacing with EnzymeRules due to a current limitation in the rule system. This change is only intended to be temporary and NonlinearProblem will return to being a struct in a later non-breaking release. Do not rely on this behavior, use with caution."
    return Base.setfield!(prob, s, v, order)
end

@doc doc"""
Defines a nonlinear least squares problem.

## Mathematical Specification of a Nonlinear Least Squares Problem

To define a Nonlinear Problem, you simply need to give the function ``f`` which defines the
nonlinear system:

```math
\min_x \| f(x, p) \|
```

and an initial guess ``u_0`` for the minimization problem. ``f`` should be specified as
``f(u, p)`` (or in-place as ``f(du, u, p)``), and ``u_0`` should be an AbstractArray (or
number) whose geometry matches the desired geometry of ``u``. Note that we are not limited
to numbers or vectors for ``u_0``; one is allowed to provide ``u_0`` as arbitrary
matrices / higher-dimension tensors as well.

## Problem Type

### Constructors

```julia
NonlinearLeastSquaresProblem(f::NonlinearFunction, u0, p = NullParameters(); kwargs...)
NonlinearLeastSquaresProblem{isinplace}(f, u0, p = NullParameters(); kwargs...)
```

`isinplace` optionally sets whether the function is in-place or not. This is
determined automatically, but not inferred.

Parameters are optional, and if not given, then a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters.

For specifying Jacobians and mass matrices, see the
[NonlinearFunctions](@ref nonlinearfunctions) page.

### Fields

* `f`: The function in the problem.
* `u0`: The initial guess for the solution.
* `p`: The parameters for the problem. Defaults to `NullParameters`.
* `lb`: Lower bounds for the solution. Defaults to `nothing`.
* `ub`: Upper bounds for the solution. Defaults to `nothing`.
* `kwargs`: The keyword arguments passed on to the solvers.
"""
struct NonlinearLeastSquaresProblem{uType, isinplace, P, F, K, LB, UB} <:
    AbstractNonlinearProblem{uType, isinplace}
    f::F
    u0::uType
    p::P
    lb::LB
    ub::UB
    kwargs::K

    @add_kwonly function NonlinearLeastSquaresProblem{iip}(
            f::AbstractNonlinearFunction{
                iip,
            }, u0,
            p = NullParameters();
            lb = nothing,
            ub = nothing,
            kwargs...
        ) where {iip}
        warn_paramtype(p)
        return new{
            typeof(u0), iip, typeof(p), typeof(f), typeof(kwargs),
            typeof(lb), typeof(ub),
        }(f, u0, p, lb, ub, kwargs)
    end

    function NonlinearLeastSquaresProblem{iip}(f, u0, p = NullParameters()) where {iip}
        return NonlinearLeastSquaresProblem{iip}(NonlinearFunction{iip}(f), u0, p)
    end
end

"""
$(SIGNATURES)

Define a nonlinear least squares problem using an instance of
[`AbstractNonlinearFunction`](@ref AbstractNonlinearFunction).
"""
function NonlinearLeastSquaresProblem(
        f::AbstractNonlinearFunction, u0,
        p = NullParameters(); kwargs...
    )
    return NonlinearLeastSquaresProblem{isinplace(f)}(f, u0, p; kwargs...)
end

function NonlinearLeastSquaresProblem(f, u0, p = NullParameters(); kwargs...)
    return NonlinearLeastSquaresProblem(NonlinearFunction(f), u0, p; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: NonlinearLeastSquaresProblem}
    return function ctor(f, u0, p, lb, ub, kw)
        if f isa AbstractNonlinearFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 4)
        end
        return NonlinearLeastSquaresProblem{iip}(f, u0, p; lb, ub, kw...)
    end
end

@doc doc"""
    SCCNonlinearProblem(probs, explicitfuns!)

Defines an SCC-split nonlinear system to be solved iteratively.

## Mathematical Specification of an SCC-Split Nonlinear Problem

An SCC-Split Nonlinear Problem is a system of nonlinear equations

```math
f(u,p) = 0
```

with the special property that its Jacobian is in block-lower-triangular
form. In this form, the nonlinear problem can be decomposed into a system
of nonlinear systems. 

```math
\begin{align*}
f_1(u_1,p) &= 0 \\
f_2(u_2,u_1,p) &= 0 \\
f_3(u_3,u_2,u_1,p) &= 0 \\
& \vdots \\
f_n(u_n,\ldots,u_3,u_2,u_1,p) &= 0
\end{align*}
```

Splitting the system in this form can have multiple advantages, including:

* Improved numerical stability and robustness of the solving process
* Improved performance due to using smaller Jacobians

The SCC-Split Nonlinear Problem is the ordered collection of nonlinear systems 
to solve in order solve the system in the optimized split form.

## Representation

The representation of the `SCCNonlinearProblem` is via an ordered collection
of `NonlinearProblem`s, `probs`, with an attached explicit function for pre-processing
a cache. This can be interpreted as follows:

```math
\begin{align*}
p_1 &= g_1(u,p) & f_1(u_1,p_1)         &= 0 \\
p_2 &= g_2(u,p) & f_2(u_2,u_1,p_2)     &= 0 \\
p_3 &= g_3(u,p) & f_3(u_3,u_2,u_1,p_3) &= 0 \\
& \vdots \\
p_n &= g_n(u,p) & f_n(u_n,\ldots,u_3,u_2,u_1,p_n) &= 0 \\
\end{align*}
```

where ``g_i`` is `explicitfuns![i]`. In a computational sense, `explictfuns!`
is instead a mutating function `explictfuns![i](prob.probs[i],sols)` which
updates the values of prob.probs[i] using the previous solutions `sols[i-1]`
and below.

!!! warning
    For the purposes of differentiation, it's assumed that `explictfuns!` does
    not modify tunable parameters!

!!! warning
    While `explictfuns![i]` could in theory use `sols[i+1]` in its computation,
    these values will not be updated. It is thus the contract of the interface
    to not use those values except for as caches to be overridden.

!!! note
    prob.probs[i].p can be aliased with each other as a performance / memory
    optimization. If they are aliased before the construction of the `probs`
    the runtime guarantees the aliasing behavior is kept.

## Example

For the following nonlinear problem:

```julia
function f(du,u,p)
    du[1] = cos(u[2]) - u[1]
    du[2] = sin(u[1] + u[2]) + u[2]
    du[3] = 2u[4] + u[3] + 1.0
    du[4] = u[5]^2 + u[4]
    du[5] = u[3]^2 + u[5]
    du[6] = u[1] + u[2] + u[3] + u[4] + u[5]    + 2.0u[6] + 2.5u[7] + 1.5u[8]
    du[7] = u[1] + u[2] + u[3] + 2.0u[4] + u[5] + 4.0u[6] - 1.5u[7] + 1.5u[8]
    du[8] = u[1] + 2.0u[2] + 3.0u[3] + 5.0u[4] + 6.0u[5] + u[6] - u[7] - u[8]
end
prob = NonlinearProblem(f, zeros(8))
sol = solve(prob)
```

The split SCC form is:

```julia
cache = zeros(3)

function f1(du,u,cache)
    du[1] = cos(u[2]) - u[1]
    du[2] = sin(u[1] + u[2]) + u[2]
end
explicitfun1(cache,sols) = nothing
prob1 = NonlinearProblem(NonlinearFunction{true, SciMLBase.NoSpecialize}(f1), zeros(2), cache)
sol1 = solve(prob1, NewtonRaphson())

function f2(du,u,cache)
    du[1] = 2u[2] + u[1] + 1.0
    du[2] = u[3]^2 + u[2]
    du[3] = u[1]^2 + u[3]
end
explicitfun2(cache,sols) = nothing
prob2 = NonlinearProblem(NonlinearFunction{true, SciMLBase.NoSpecialize}(f2), zeros(3), cache)
sol2 = solve(prob2, NewtonRaphson())

function f3(du,u,cache)
    du[1] = cache[1] + 2.0u[1] + 2.5u[2] + 1.5u[3]
    du[2] = cache[2] + 4.0u[1] - 1.5u[2] + 1.5u[3]
    du[3] = cache[3] + + u[1] - u[2] - u[3]
end
prob3 = NonlinearProblem(NonlinearFunction{true, SciMLBase.NoSpecialize}(f3), zeros(3), cache)
function explicitfun3(cache,sols)
    cache[1] = sols[1][1] + sols[1][2] + sols[2][1] + sols[2][2] + sols[2][3]
    cache[2] = sols[1][1] + sols[1][2] + sols[2][1] + 2.0sols[2][2] + sols[2][3]
    cache[3] = sols[1][1] + 2.0sols[1][2] + 3.0sols[2][1] + 5.0sols[2][2] + 6.0sols[2][3]
end
explicitfun3(cache,[sol1,sol2])
sol3 = solve(prob3, NewtonRaphson())
manualscc = [sol1; sol2; sol3]

sccprob = SciMLBase.SCCNonlinearProblem(
    [prob1,prob2,prob3],
    SciMLBase.Void{Any}.([explicitfun1,explicitfun2,explicitfun3]))
```

Note that this example aliases the parameters together for a memory-reduced representation.

## Problem Type

### Constructors

### Fields

* `probs`: the collection of problems to solve
* `explictfuns!`: the explicit functions for mutating the parameter set
"""
mutable struct SCCNonlinearProblem{
        uType, iip, P, E, F <: NonlinearFunction{iip},
        Par, Palias <: Union{Val{true}, Val{false}},
    } <:
    AbstractNonlinearProblem{uType, iip}
    probs::P
    explicitfuns!::E
    # NonlinearFunction with `f = Returns(nothing)`
    f::F
    p::Par
    parameters_alias::Palias

    function SCCNonlinearProblem{P, E, F, Par}(
            probs::P, funs::E, f::F, pobj::Par,
            alias::Palias
        ) where {P, E, F <: NonlinearFunction, Par, Palias}
        init = state_values(first(probs))
        has_no_u0 = init === nothing
        if has_no_u0
            # In this case, all of `probs` are `LinearProblem`
            @assert first(probs) isa LinearProblem
            init = first(probs).A
        end
        if ArrayInterface.ismutable(init)
            init = similar(init, 0)
        else
            init = StaticArraysCore.similar_type(init, StaticArraysCore.Size(0))()
        end
        if has_no_u0
            uType = Nothing
        else
            u0 = mapreduce(
                state_values, vcat, probs; init = init
            )
            uType = typeof(u0)
        end
        return new{uType, false, P, E, F, Par, Palias}(probs, funs, f, pobj, alias)
    end
end

function SCCNonlinearProblem(
        probs, explicitfuns!, parameter_object = nothing,
        parameters_alias::Union{Bool, Val{true}, Val{false}} = Val(false); kwargs...
    )
    f = NonlinearFunction{false}(Returns(nothing); kwargs...)
    if parameters_alias isa Bool
        parameters_alias = Val(parameters_alias)
    end
    return SCCNonlinearProblem{
        typeof(probs), typeof(explicitfuns!),
        typeof(f), typeof(parameter_object),
    }(
        probs, explicitfuns!, f, parameter_object, parameters_alias
    )
end

function Base.getproperty(prob::SCCNonlinearProblem, name::Symbol)
    if name == :explictfuns!
        return getfield(prob, :explicitfuns!)
    elseif name == :ps
        return ParameterIndexingProxy(prob)
    end
    return getfield(prob, name)
end

function SymbolicIndexingInterface.symbolic_container(prob::SCCNonlinearProblem)
    return prob.f
end
function SymbolicIndexingInterface.parameter_values(prob::SCCNonlinearProblem)
    return prob.p
end
function SymbolicIndexingInterface.state_values(prob::SCCNonlinearProblem{Nothing})
    return nothing
end
function SymbolicIndexingInterface.state_values(prob::SCCNonlinearProblem)
    init = state_values(first(prob.probs))
    if ArrayInterface.ismutable(init)
        init = similar(init, 0)
    else
        init = StaticArraysCore.similar_type(init, StaticArraysCore.Size(0))()
    end
    return mapreduce(state_values, vcat, prob.probs; init)
end

function SymbolicIndexingInterface.set_state!(prob::SCCNonlinearProblem, val, idx)
    for scc in prob.probs
        svals = state_values(scc)
        checkbounds(Bool, svals, idx) && return set_state!(scc, val, idx)
        idx -= length(svals)
    end
    throw(BoundsError(state_values(prob), idx))
end

function SymbolicIndexingInterface.set_parameter!(prob::SCCNonlinearProblem, val, idx)
    if prob.p !== nothing
        set_parameter!(prob.p, val, idx)
        prob.parameters_alias === Val(true) && return
    end
    for scc in prob.probs
        is_parameter(scc, idx) || continue
        set_parameter!(scc, val, idx)
    end
    return
end

@doc doc"""
    NonlinearAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias = nothing)

Holds information on what variables to alias when solving a `NonlinearProblem`. 
Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords

* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the `u0` array.
* `alias::Union{Bool, Nothing}`: sets all fields of the `NonlinearAliasSpecifier` to `alias`. 
"""
struct NonlinearAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}

    function NonlinearAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias = nothing
        )
        return if isnothing(alias)
            new(alias_p, alias_f, alias_u0)
        elseif alias
            new(true, true, true)
        elseif !alias
            new(false, false, false)
        end
    end
end

struct ImmutableNonlinearProblem{uType, iip, P, F, K, PT} <:
    AbstractNonlinearProblem{uType, iip}
    f::F
    u0::uType
    p::P
    problem_type::PT
    kwargs::K

    SciMLBase.@add_kwonly function ImmutableNonlinearProblem{iip}(
            f::AbstractNonlinearFunction{iip}, u0, p = NullParameters(),
            problem_type = StandardNonlinearProblem(); kwargs...
        ) where {iip}
        if haskey(kwargs, :p)
            error("`p` specified as a keyword argument `p = $(kwargs[:p])` to \
                   `NonlinearProblem`. This is not supported.")
        end
        SciMLBase.warn_paramtype(p)
        return new{
            typeof(u0), iip, typeof(p), typeof(f), typeof(kwargs), typeof(problem_type),
        }(
            f, u0, p, problem_type, kwargs
        )
    end

    """
    Define a steady state problem using the given function.
    `isinplace` optionally sets whether the function is inplace or not.
    This is determined automatically, but not inferred.
    """
    function ImmutableNonlinearProblem{iip}(
            f, u0, p = NullParameters(); kwargs...
        ) where {iip}
        return ImmutableNonlinearProblem{iip}(NonlinearFunction{iip}(f), u0, p; kwargs...)
    end
end

"""
Define a nonlinear problem using an instance of [`AbstractNonlinearFunction`](@ref).
"""
function ImmutableNonlinearProblem(
        f::AbstractNonlinearFunction, u0, p = NullParameters(); kwargs...
    )
    return ImmutableNonlinearProblem{SciMLBase.isinplace(f)}(f, u0, p; kwargs...)
end

function ImmutableNonlinearProblem(f, u0, p = NullParameters(); kwargs...)
    return ImmutableNonlinearProblem(NonlinearFunction(f), u0, p; kwargs...)
end

"""
Define a `ImmutableNonlinearProblem` problem from `SteadyStateProblem`.
"""
function ImmutableNonlinearProblem(prob::AbstractNonlinearProblem)
    return ImmutableNonlinearProblem{SciMLBase.isinplace(prob)}(prob.f, prob.u0, prob.p)
end

function Base.convert(
        ::Type{ImmutableNonlinearProblem}, prob::T
    ) where {T <: NonlinearProblem}
    return ImmutableNonlinearProblem{SciMLBase.isinplace(prob)}(
        prob.f, prob.u0, prob.p, prob.problem_type; prob.kwargs...
    )
end

@doc doc"""

Defines a steady state ODE problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/steady_state_types/>

## Mathematical Specification of a Steady State Problem

To define a Steady State Problem, you simply need to give the function ``f``
which defines the ODE:

```math
\frac{du}{dt} = f(u, p, t)
```

and an initial guess ``u_0`` of where `f(u, p, t) = 0`. `f` should be specified as
`f(u, p, t)` (or in-place as `f(du, u, p, t)`), and `u₀` should be an AbstractArray
(or number) whose geometry matches the desired geometry of `u`. Note that we are not limited
to numbers or vectors for `u₀`; one is allowed to provide `u₀` as arbitrary
matrices / higher dimension tensors as well.

Note that for the steady-state to be defined, we must have that `f` is autonomous,
that is `f` is independent of `t`. But the form which matches the standard ODE
solver should still be used. The steady state solvers interpret the `f` by
fixing ``t = ∞``.

## Problem Type

### Constructors

```julia
SteadyStateProblem(f::ODEFunction, u0, p = NullParameters(); kwargs...)
SteadyStateProblem{isinplace, specialize}(f, u0, p = NullParameters(); kwargs...)
```

`isinplace` optionally sets whether the function is inplace or not. This is
determined automatically, but not inferred. `specialize` optionally controls
the specialization level. See the [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
for more details. The default is `AutoSpecialize`.

Parameters are optional, and if not given, a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

Additionally, the constructor from `ODEProblem`s is provided:

```julia
SteadyStateProblem(prob::ODEProblem)
```

Parameters are optional, and if not given, a `NullParameters()` singleton
will be used, which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the DiffEqFunctions page.

### Fields

* `f`: The function in the ODE.
* `u0`: The initial guess for the steady state.
* `p`: The parameters for the problem. Defaults to `NullParameters`
* `kwargs`: The keyword arguments passed onto the solves.

## Special Solution Fields

The `SteadyStateSolution` type is different from the other DiffEq solutions because
it does not have temporal information.
"""
struct SteadyStateProblem{uType, isinplace, P, F, K} <:
    AbstractSteadyStateProblem{uType, isinplace}
    """f: The function in the ODE."""
    f::F
    """The initial guess for the steady state."""
    u0::uType
    """Parameter values for the ODE function."""
    p::P
    kwargs::K
    @add_kwonly function SteadyStateProblem{iip}(
            f::AbstractODEFunction{iip},
            u0, p = NullParameters();
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        warn_paramtype(p)
        new{typeof(_u0), isinplace(f), typeof(p), typeof(f), typeof(kwargs)}(
            f, _u0, p,
            kwargs
        )
    end

    """
    $(SIGNATURES)

    Define a steady state problem using the given function.
    `isinplace` optionally sets whether the function is inplace or not.
    This is determined automatically, but not inferred.
    """
    function SteadyStateProblem{iip}(f, u0, p = NullParameters()) where {iip}
        return SteadyStateProblem(ODEFunction{iip}(f), u0, p)
    end
end

"""
$(SIGNATURES)

Define a steady state problem using an instance of
[`AbstractODEFunction`](@ref AbstractODEFunction).
"""
function SteadyStateProblem(f::AbstractODEFunction, u0, p = NullParameters(); kwargs...)
    return SteadyStateProblem{isinplace(f)}(f, u0, p; kwargs...)
end

function SteadyStateProblem(f, u0, p = NullParameters(); kwargs...)
    return SteadyStateProblem(ODEFunction(f), u0, p; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: SteadyStateProblem}
    return function ctor(f, u0, p, kw)
        if f isa AbstractODEFunction
            iip = isinplace(f)
        else
            iip = isinplace(f, 4)
        end
        return SteadyStateProblem{iip}(f, u0, p; kw...)
    end
end

"""
$(SIGNATURES)

Define a steady state problem from a standard ODE problem.
"""
function SteadyStateProblem(prob::AbstractODEProblem)
    return SteadyStateProblem{isinplace(prob)}(prob.f, prob.u0, prob.p; prob.kwargs...)
end

SymbolicIndexingInterface.is_time_dependent(::SteadyStateProblem) = true

@doc doc"""
    SteadyStateAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_du0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving a SteadyStateProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the `u0` array. Defaults to `false`.
* `alias_du0::Union{Bool, Nothing}`: alias the `du0` array for DAEs. Defaults to `false`.
* `alias_tstops::Union{Bool, Nothing}`: alias the `tstops` array
* `alias::Union{Bool, Nothing}`: sets all fields of the `SteadStateAliasSpecifier` to `alias`

"""
struct SteadyStateAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_du0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}

    function SteadyStateAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_du0, alias_tstops)
        end
    end
end

module SciMLBase
if isdefined(Base, :Experimental) &&
        isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@max_methods 1
end
using ConstructionBase
using RecipesBase, RecursiveArrayTools
using SciMLStructures
using SymbolicIndexingInterface
using DocStringExtensions
using LinearAlgebra
using Statistics
using Distributed
using Markdown
using Printf
import Preferences
using PreallocationTools: get_tmp, DiffCache, FixedSizeDiffCache

import Logging, ArrayInterface
import IteratorInterfaceExtensions
import CommonSolve: solve, init, step!, solve!
import FunctionWrappersWrappers
import RuntimeGeneratedFunctions
import EnumX
import ADTypes: ADTypes, AbstractADType
import Accessors: @set, @reset, @delete, @insert
using Moshi.Data: @data
using Moshi.Match: @match
import Moshi.Derive: @derive
import StaticArraysCore: StaticArraysCore, SArray
import Adapt: adapt_structure, adapt

using Reexport
using SciMLOperators
using SciMLOperators:
    AbstractSciMLOperator,
    IdentityOperator, NullOperator,
    ScaledOperator, AddedOperator, ComposedOperator,
    InvertedOperator, InvertibleOperator, AbstractSciMLScalarOperator

import SciMLOperators:
    DEFAULT_UPDATE_FUNC, update_coefficients, update_coefficients!,
    getops, isconstant, iscached, islinear, issquare,
    has_adjoint, has_expmv, has_expmv!, has_exp,
    has_mul, has_mul!, has_ldiv, has_ldiv!

@reexport using SciMLOperators

using SciMLPublic: @public

using SciMLLogging: @SciMLMessage

function __solve end
function __init end

"""
$(TYPEDEF)
"""
abstract type AbstractSciMLProblem end

# Problems
"""
$(TYPEDEF)

Base type for all DifferentialEquations.jl problems. Concrete subtypes of
`AbstractDEProblem` contain the necessary information to fully define a differential
equation of the corresponding type.
"""
abstract type AbstractDEProblem <: AbstractSciMLProblem end

"""
$(TYPEDEF)
"""
abstract type DEElement end

"""
$(TYPEDEF)
"""
abstract type DESensitivity end

"""
$(TYPEDEF)

Base for types which define linear systems.
"""
abstract type AbstractLinearProblem{bType, isinplace} <: AbstractSciMLProblem end

"""
$(TYPEDEF)

Base for types which define integrals suitable for quadrature.
"""
abstract type AbstractIntegralProblem{isinplace} <: AbstractSciMLProblem end

"""
$(TYPEDEF)

Base for types which define equations for optimization.
"""
abstract type AbstractOptimizationProblem{isinplace} <: AbstractSciMLProblem end

"""
$(TYPEDEF)

Base for types which define caches for optimization problems. Must at least hold the optimization
function `f <: OptimizationFunction` and the parameters `p`.
"""
abstract type AbstractOptimizationCache end

"""
$(TYPEDEF)

Base for types which define nonlinear solve problems (`f(u)=0`).
"""
abstract type AbstractNonlinearProblem{uType, isinplace} <: AbstractSciMLProblem end
abstract type AbstractIntervalNonlinearProblem{uType, isinplace} <:
AbstractNonlinearProblem{
    uType,
    isinplace,
} end
const AbstractSteadyStateProblem{
    uType, isinplace,
} = AbstractNonlinearProblem{
    uType,
    isinplace,
}

"""
$(TYPEDEF)
"""
abstract type AbstractNoiseProblem <: AbstractDEProblem end

"""
$(TYPEDEF)

Base for types which define ODE problems.
"""
abstract type AbstractODEProblem{uType, tType, isinplace} <: AbstractDEProblem end

"""
$(TYPEDEF)

Base for types which define dynamical optimization problems.
"""
abstract type AbstractDynamicOptProblem{uType, tType, isinplace} <:
AbstractODEProblem{uType, tType, isinplace} end

"""
$(TYPEDEF)

Base for types which define discrete problems.
"""
abstract type AbstractDiscreteProblem{uType, tType, isinplace} <:
AbstractODEProblem{uType, tType, isinplace} end

"""
$(TYPEDEF)
"""
abstract type AbstractAnalyticalProblem{uType, tType, isinplace} <:
AbstractODEProblem{uType, tType, isinplace} end

"""
$(TYPEDEF)

Base for types which define RODE problems.
"""
abstract type AbstractRODEProblem{uType, tType, isinplace, ND} <: AbstractDEProblem end

"""
$(TYPEDEF)

Base for types which define SDE problems.
"""
abstract type AbstractSDEProblem{uType, tType, isinplace, ND} <:
AbstractRODEProblem{uType, tType, isinplace, ND} end

"""
$(TYPEDEF)

Base for types which define DAE problems.
"""
abstract type AbstractDAEProblem{uType, duType, tType, isinplace} <: AbstractDEProblem end

"""
$(TYPEDEF)

Base for types which define DDE problems.
"""
abstract type AbstractDDEProblem{uType, tType, lType, isinplace} <: AbstractDEProblem end

"""
$(TYPEDEF)
"""
abstract type AbstractConstantLagDDEProblem{uType, tType, lType, isinplace} <:
AbstractDDEProblem{uType, tType, lType, isinplace} end

"""
$(TYPEDEF)
"""
abstract type AbstractSecondOrderODEProblem{uType, tType, isinplace} <:
AbstractODEProblem{uType, tType, isinplace} end

"""
$(TYPEDEF)

Base for types which define BVP problems.
"""
abstract type AbstractBVProblem{uType, tType, isinplace, nlls} <:
AbstractODEProblem{uType, tType, isinplace} end

"""
$(TYPEDEF)

Base for types which define jump problems.
"""
abstract type AbstractJumpProblem{P, J} <: AbstractDEProblem end

"""
$(TYPEDEF)

Base for types which define SDDE problems.
"""
abstract type AbstractSDDEProblem{uType, tType, lType, isinplace, ND} <: AbstractDEProblem end

"""
$(TYPEDEF)
"""
abstract type AbstractConstantLagSDDEProblem{uType, tType, lType, isinplace, ND} <:
AbstractSDDEProblem{uType, tType, lType, isinplace, ND} end

"""
$(TYPEDEF)

Base for types which define PDE problems.
"""
abstract type AbstractPDEProblem <: AbstractDEProblem end

# Algorithms
"""
$(TYPEDEF)
"""
abstract type AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractDEAlgorithm <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractLinearAlgorithm <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractNonlinearAlgorithm <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractIntervalNonlinearAlgorithm <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractIntegralAlgorithm <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractOptimizationAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractSteadyStateAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractBVPAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractODEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractSecondOrderODEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractRODEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractSDEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractDAEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractDDEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractSDDEAlgorithm <: AbstractDEAlgorithm end

"""
$(TYPEDEF)
"""
abstract type EnsembleAlgorithm <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractSensitivityAlgorithm{CS, AD, FDT} <: AbstractSciMLAlgorithm end

"""
$(TYPEDEF)
"""
abstract type AbstractOverloadingSensitivityAlgorithm{CS, AD, FDT} <:
AbstractSensitivityAlgorithm{CS, AD, FDT} end

"""
$(TYPEDEF)
"""
abstract type AbstractForwardSensitivityAlgorithm{CS, AD, FDT} <:
AbstractOverloadingSensitivityAlgorithm{CS, AD, FDT} end

"""
$(TYPEDEF)
"""
abstract type AbstractAdjointSensitivityAlgorithm{CS, AD, FDT} <:
AbstractOverloadingSensitivityAlgorithm{CS, AD, FDT} end

"""
$(TYPEDEF)
"""
abstract type AbstractSecondOrderSensitivityAlgorithm{CS, AD, FDT} <:
AbstractOverloadingSensitivityAlgorithm{CS, AD, FDT} end

"""
$(TYPEDEF)
"""
abstract type AbstractShadowingSensitivityAlgorithm{CS, AD, FDT} <:
AbstractOverloadingSensitivityAlgorithm{CS, AD, FDT} end

"""
$(TYPEDEF)
"""
abstract type DAEInitializationAlgorithm <: AbstractSciMLAlgorithm end

"""
    struct NoInit <: DAEInitializationAlgorithm

An initialization algorithm that completely skips the initialization phase. The solver
will use the provided initial conditions directly without any consistency checks or
modifications.

!!! warning
    Using `NoInit()` with inconsistent initial conditions will likely cause
    solver failures or incorrect results. Only use this when you are absolutely certain
    your initial conditions satisfy all DAE constraints.

This is useful when:
- You know your initial conditions are already perfectly consistent
- You want to avoid the computational cost of initialization
- You are debugging solver issues and want to isolate initialization from integration

## Example
```julia
prob = DAEProblem(f, du0_consistent, u0_consistent, tspan)
sol = solve(prob, IDA(), initializealg = NoInit())
```
"""
struct NoInit <: DAEInitializationAlgorithm end

"""
    struct CheckInit <: DAEInitializationAlgorithm

An initialization algorithm that only checks if the initial conditions are consistent
with the DAE constraints, without attempting to modify them. If the conditions are not
consistent within the solver's tolerance, an error will be thrown.

This is useful when:
- You have already computed consistent initial conditions
- You want to verify the consistency of your initial guess
- You want to ensure no automatic modifications are made to your initial conditions

## Example
```julia
prob = DAEProblem(f, du0, u0, tspan)
sol = solve(prob, IDA(), initializealg = CheckInit())
```
"""
struct CheckInit <: DAEInitializationAlgorithm end

"""
    struct OverrideInit <: DAEInitializationAlgorithm

An initialization algorithm that uses a separate initialization problem to find
consistent initial conditions. This is typically used with ModelingToolkit.jl
which can generate specialized initialization problems based on the model structure.

When using `OverrideInit`, the problem must have `initialization_data` that contains
an `initializeprob` field with the initialization problem to solve.

This algorithm is particularly useful for:
- High-index DAEs that have been index-reduced
- Systems with complex initialization requirements
- ModelingToolkit models with custom initialization equations

## Fields
- `abstol`: Absolute tolerance for the initialization solver
- `reltol`: Relative tolerance for the initialization solver
- `nlsolve`: Nonlinear solver to use for initialization

## Example
```julia
# Typically used automatically with ModelingToolkit
@named sys = ODESystem(eqs, t, vars, params)
sys = structural_simplify(sys)
prob = DAEProblem(sys, [], (0.0, 1.0), [])
# Will automatically use OverrideInit if initialization_data exists
sol = solve(prob, IDA())
```
"""
struct OverrideInit{T1, T2, F} <: DAEInitializationAlgorithm
    abstol::T1
    reltol::T2
    nlsolve::F
end

function OverrideInit(; abstol = nothing, reltol = nothing, nlsolve = nothing)
    return OverrideInit(abstol, reltol, nlsolve)
end
OverrideInit(abstol) = OverrideInit(; abstol = abstol, nlsolve = nothing)

# PDE Discretizations

"""
$(TYPEDEF)
"""
abstract type AbstractDiscretization <: AbstractSciMLAlgorithm end

# Discretization metadata
"""
$(TYPEDEF)
"""
abstract type AbstractDiscretizationMetadata{hasTime} end

# Monte Carlo Simulations
"""
$(TYPEDEF)
"""
abstract type AbstractEnsembleProblem <: AbstractSciMLProblem end

"""
$(TYPEDEF)
"""
abstract type AbstractEnsembleEstimator <: AbstractSciMLAlgorithm end

export EnsembleProblem
export EnsembleSolution, EnsembleTestSolution, EnsembleSummary

"""
$(TYPEDEF)
"""
abstract type AbstractDiffEqInterpolation end

"""
$(TYPEDEF)
"""
abstract type AbstractDEOptions end

"""
$(TYPEDEF)
"""
abstract type DECache end

"""
$(TYPEDEF)
"""
abstract type DECallback end

"""
$(TYPEDEF)
"""
abstract type AbstractContinuousCallback <: DECallback end

"""
$(TYPEDEF)
"""
abstract type AbstractDiscreteCallback <: DECallback end

# Integrators
"""
$(TYPEDEF)
"""
abstract type DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractSteadyStateIntegrator{Alg, IIP, U} <:
DEIntegrator{Alg, IIP, U, Nothing} end

"""
$(TYPEDEF)
"""
abstract type AbstractODEIntegrator{Alg, IIP, U, T} <: DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractSecondOrderODEIntegrator{Alg, IIP, U, T} <:
DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractRODEIntegrator{Alg, IIP, U, T} <: DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractSDEIntegrator{Alg, IIP, U, T} <: DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractDDEIntegrator{Alg, IIP, U, T} <: DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractDAEIntegrator{Alg, IIP, U, T} <: DEIntegrator{Alg, IIP, U, T} end

"""
$(TYPEDEF)
"""
abstract type AbstractSDDEIntegrator{Alg, IIP, U, T} <: DEIntegrator{Alg, IIP, U, T} end

# Solutions
"""
$(TYPEDEF)
"""
abstract type AbstractNoTimeSolution{T, N} <: AbstractArray{T, N} end

"""
$(TYPEDEF)
"""
abstract type AbstractTimeseriesSolution{T, N, A} <: AbstractDiffEqArray{T, N, A} end

"""
$(TYPEDEF)
"""
abstract type AbstractEnsembleSolution{T, N, A} <: AbstractVectorOfArray{T, N, A} end

"""
$(TYPEDEF)
"""
abstract type AbstractNoiseProcess{T, N, A, isinplace} <: AbstractDiffEqArray{T, N, A} end

"""
Union of all base solution types.

Uses a Union so that solution types can be `<: AbstractArray`
"""
const AbstractSciMLSolution = Union{
    AbstractTimeseriesSolution,
    AbstractNoTimeSolution,
    AbstractEnsembleSolution,
    AbstractNoiseProcess,
}

"""
$(TYPEDEF)
"""
abstract type AbstractLinearSolution{T, N} <: AbstractNoTimeSolution{T, N} end

"""
$(TYPEDEF)
"""
abstract type AbstractNonlinearSolution{T, N} <: AbstractNoTimeSolution{T, N} end

"""
$(TYPEDEF)
"""
abstract type AbstractIntegralSolution{T, N} <: AbstractNoTimeSolution{T, N} end

"""
$(TYPEDEF)
"""
abstract type AbstractOptimizationSolution{T, N} <: AbstractNoTimeSolution{T, N} end

"""
$(TYPEDEF)
"""
const AbstractSteadyStateSolution{T, N} = AbstractNonlinearSolution{T, N}

"""
$(TYPEDEF)
"""
abstract type AbstractAnalyticalSolution{T, N, S} <: AbstractTimeseriesSolution{T, N, S} end

"""
$(TYPEDEF)
"""
abstract type AbstractODESolution{T, N, S} <: AbstractTimeseriesSolution{T, N, S} end

# Needed for plot recipes
"""
$(TYPEDEF)
"""
abstract type AbstractDDESolution{T, N, S} <: AbstractODESolution{T, N, S} end

"""
$(TYPEDEF)
"""
abstract type AbstractRODESolution{T, N, S} <: AbstractODESolution{T, N, S} end

"""
$(TYPEDEF)
"""
abstract type AbstractDAESolution{T, N, S} <: AbstractODESolution{T, N, S} end

"""
$(TYPEDEF)
"""
abstract type AbstractPDETimeSeriesSolution{T, N, S, D} <:
AbstractTimeseriesSolution{T, N, S} end

"""
$(TYPEDEF)
"""
abstract type AbstractPDENoTimeSolution{T, N, S, D} <:
AbstractNoTimeSolution{T, N} end

"""
$(TYPEDEF)
"""
const AbstractPDESolution{
    T,
    N,
    S,
    D,
} = Union{
    AbstractPDETimeSeriesSolution{T, N, S, D},
    AbstractPDENoTimeSolution{T, N, S, D},
}

"""
$(TYPEDEF)
"""
abstract type AbstractSensitivitySolution{T, N, S} <: AbstractTimeseriesSolution{T, N, S} end

# Misc

"""
$(TYPEDEF)

Base for types defining SciML functions.
"""
abstract type AbstractSciMLFunction{iip} end

"""
$(TYPEDEF)

Base for types defining differential equation functions.
"""
abstract type AbstractDiffEqFunction{iip} <:
AbstractSciMLFunction{iip} end

"""
$(TYPEDEF)

Base for types defining integrand functions.
"""
abstract type AbstractIntegralFunction{iip} <:
AbstractSciMLFunction{iip} end

"""
$(TYPEDEF)

Base for types defining optimization functions.
"""
abstract type AbstractOptimizationFunction{iip} <: AbstractSciMLFunction{iip} end

"""
$(TYPEDEF)

Base for types which define the history of a delay differential equation.
"""
abstract type AbstractHistoryFunction end

"""
$(TYPEDEF)
"""
abstract type AbstractReactionNetwork end

"""
$(TYPEDEF)

Internal. Used for signifying which AD context a derivative calculation is in.
"""
abstract type ADOriginator end

"""
$(TYPEDEF)

Used to specify which variables can be aliased in a solve.
Every concrete AbstractAliasSpecifier should have at least the fields `alias_p` and `alias_f`.
"""
abstract type AbstractAliasSpecifier end

"""
$(TYPEDEF)

Internal. Used for signifying the AD context comes from a ChainRules.jl definition.
"""
struct ChainRulesOriginator <: ADOriginator end

"""
$(TYPEDEF)

Internal. Used for signifying the AD context comes from an Enzyme.jl definition.
"""
struct EnzymeOriginator <: ADOriginator end

"""
$(TYPEDEF)

Internal. Used for signifying the AD context comes from a ReverseDiff.jl context.
"""
struct ReverseDiffOriginator <: ADOriginator end

"""
$(TYPEDEF)

Internal. Used for signifying the AD context comes from a Tracker.jl context.
"""
struct TrackerOriginator <: ADOriginator end

"""
$(TYPEDEF)

Internal. Used for signifying the AD context comes from a Mooncake.jl context.
"""
struct MooncakeOriginator <: ADOriginator end

include("initialization.jl")
include("odenlstep.jl")
include("utils.jl")
include("function_wrappers.jl")
include("scimlfunctions.jl")
include("alg_traits.jl")
include("debug.jl")

unwrapped_f(f) = f
unwrapped_f(f::Void) = unwrapped_f(f.f)
function unwrapped_f(f::FunctionWrappersWrappers.FunctionWrappersWrapper)
    return unwrapped_f(f.fw[1].obj[])
end

function specialization(
        ::Union{
            ODEFunction{iip, specialize},
            SDEFunction{iip, specialize}, DDEFunction{iip, specialize},
            SDDEFunction{iip, specialize},
            DAEFunction{iip, specialize},
            DynamicalODEFunction{iip, specialize},
            SplitFunction{iip, specialize},
            DynamicalSDEFunction{iip, specialize},
            SplitSDEFunction{iip, specialize},
            DynamicalDDEFunction{iip, specialize},
            DiscreteFunction{iip, specialize},
            ImplicitDiscreteFunction{iip, specialize},
            RODEFunction{iip, specialize},
            NonlinearFunction{iip, specialize},
            OptimizationFunction{iip, specialize},
            BVPFunction{iip, specialize},
            DynamicalBVPFunction{iip, specialize},
            IntegralFunction{iip, specialize},
            BatchIntegralFunction{iip, specialize},
        }
    ) where {
        iip,
        specialize,
    }
    return specialize
end

specialization(f::AbstractSciMLFunction) = FullSpecialize

"""
$(TYPEDEF)
"""
abstract type AbstractParameterizedFunction{iip} <: AbstractODEFunction{iip} end

include("retcodes.jl")
include("errors.jl")
include("symbolic_utils.jl")
include("performance_warnings.jl")

include("problems/discrete_problems.jl")
include("problems/implicit_discrete_problems.jl")
include("problems/steady_state_problems.jl")
include("problems/analytical_problems.jl")
include("problems/linear_problems.jl")
include("problems/nonlinear_problems.jl")
include("problems/integral_problems.jl")
include("problems/ode_problems.jl")
include("problems/rode_problems.jl")
include("problems/sde_problems.jl")
include("problems/noise_problems.jl")
include("problems/bvp_problems.jl")
include("problems/dae_problems.jl")
include("problems/dde_problems.jl")
include("problems/sdde_problems.jl")
include("problems/pde_problems.jl")
include("problems/problem_utils.jl")
include("problems/problem_traits.jl")
include("problems/problem_interface.jl")
include("problems/optimization_problems.jl")

include("clock.jl")
include("solutions/save_idxs.jl")
include("solutions/basic_solutions.jl")
include("solutions/nonlinear_solutions.jl")
include("solutions/ode_solutions.jl")
include("solutions/rode_solutions.jl")
include("solutions/optimization_solutions.jl")
include("solutions/dae_solutions.jl")
include("solutions/pde_solutions.jl")
include("solutions/solution_interface.jl")

include("ensemble/ensemble_solutions.jl")
include("ensemble/ensemble_problems.jl")
include("ensemble/basic_ensemble_solve.jl")
include("ensemble/ensemble_analysis.jl")

include("solve.jl")
include("interpolation.jl")
include("integrator_interface.jl")
include("remake.jl")
include("callbacks.jl")

include("adapt.jl")

include("deprecated.jl")

import PrecompileTools

PrecompileTools.@compile_workload begin
    # ODE test functions
    function lorenz(du, u, p, t)
        du[1] = 10.0(u[2] - u[1])
        du[2] = u[1] * (28.0 - u[3]) - u[2]
        du[3] = u[1] * u[2] - (8 / 3) * u[3]
    end

    function lorenz_oop(u, p, t)
        [10.0(u[2] - u[1]), u[1] * (28.0 - u[3]) - u[2], u[1] * u[2] - (8 / 3) * u[3]]
    end

    u0 = [1.0, 0.0, 0.0]
    tspan = (0.0, 1.0)

    # ODEProblem (IIP and OOP)
    prob_ode_iip = ODEProblem(lorenz, u0, tspan)
    ODEProblem(lorenz, u0, tspan, Float64[])
    prob_ode_oop = ODEProblem(lorenz_oop, u0, tspan)
    ODEProblem(lorenz_oop, u0, tspan, Float64[])

    # NonlinearProblem (IIP and OOP)
    nl_iip(res, u, p) = (res[1] = u[1]^2 - 2.0; nothing)
    nl_oop(u, p) = [u[1]^2 - 2.0]
    prob_nl_iip = NonlinearProblem(nl_iip, [1.0], nothing)
    prob_nl_oop = NonlinearProblem(nl_oop, [1.0], nothing)
    NonlinearProblem(nl_iip, [1.0])
    NonlinearProblem(nl_oop, [1.0])

    # OptimizationProblem
    opt_f = OptimizationFunction((x, p) -> sum(abs2, x))
    prob_opt = OptimizationProblem(opt_f, [1.0, 2.0], nothing)
    OptimizationProblem((x, p) -> sum(abs2, x), [1.0, 2.0])

    # IntegralProblem
    int_f = (x, p) -> x^2
    prob_int = IntegralProblem(int_f, (0.0, 1.0), nothing)
    IntegralProblem(int_f, (0.0, 1.0))

    # LinearProblem
    A = [1.0 2.0; 3.0 4.0]
    b = [1.0, 2.0]
    prob_lin = LinearProblem(A, b)
    LinearProblem(A, b, nothing)

    # SDEProblem
    g_iip(du, u, p, t) = (du .= 0.1; nothing)
    g_oop(u, p, t) = fill(0.1, length(u))
    prob_sde = SDEProblem(lorenz, g_iip, u0, tspan)
    SDEProblem(lorenz_oop, g_oop, u0, tspan)

    # DAEProblem
    dae_f(res, du, u, p, t) = (res[1] = du[1] - u[1]; nothing)
    DAEProblem(dae_f, [0.0], [1.0], (0.0, 1.0))

    # DDEProblem
    dde_f(du, u, h, p, t) = (du[1] = h(p, t - 0.1)[1]; nothing)
    h_func(p, t) = [1.0]
    DDEProblem(dde_f, [1.0], h_func, (0.0, 1.0))

    # SteadyStateProblem
    SteadyStateProblem(prob_ode_iip)
    SteadyStateProblem(prob_ode_oop)

    # DiscreteProblem
    discrete_f(du, u, p, t) = (du[1] = u[1] * 2; nothing)
    DiscreteProblem(discrete_f, [1.0], (0, 10))

    # remake for common problem types
    remake(prob_ode_iip, u0 = [2.0, 0.0, 0.0])
    remake(prob_ode_oop, u0 = [2.0, 0.0, 0.0])
    remake(prob_nl_iip, u0 = [2.0])
    remake(prob_nl_oop, u0 = [2.0])
    remake(prob_opt, u0 = [2.0, 3.0])
    remake(prob_lin, b = [2.0, 3.0])
    remake(prob_sde, u0 = [2.0, 0.0, 0.0])

    # RODEProblem
    rode_f(du, u, p, t, W) = (du .= u .* W; nothing)
    RODEProblem(rode_f, u0, tspan)

    # BVProblem
    bvp_f(du, u, p, t) = (du[1] = u[2]; du[2] = -u[1]; nothing)
    bvp_bc(res, u, p, t) = (res[1] = u[1][1] - 1.0; res[2] = u[2][1]; nothing)
    BVProblem(bvp_f, bvp_bc, [1.0, 0.0], (0.0, 1.0))

    # SecondOrderODEProblem
    so_f(ddu, du, u, p, t) = (ddu .= -u; nothing)
    SecondOrderODEProblem(so_f, [0.0], [1.0], (0.0, 1.0))

    # SplitODEProblem
    split_f1(du, u, p, t) = (du .= u; nothing)
    split_f2(du, u, p, t) = (du .= -u; nothing)
    SplitODEProblem(SplitFunction(split_f1, split_f2), [1.0], (0.0, 1.0))

    # ImplicitDiscreteProblem
    impl_f(res, u_next, u, p, t) = (res .= u_next .- 2 .* u; nothing)
    ImplicitDiscreteProblem(impl_f, [1.0], (0, 10))

    # NonlinearLeastSquaresProblem
    nllsq_f(u, p) = [u[1]^2 - 1.0]
    NonlinearLeastSquaresProblem(nllsq_f, [1.5])

    # IntervalNonlinearProblem
    interval_f(u, p) = u^2 - 2
    IntervalNonlinearProblem(interval_f, (0.0, 2.0))

    # Callbacks
    cb_condition(u, t, integrator) = true
    cb_affect!(integrator) = nothing
    DiscreteCallback(cb_condition, cb_affect!)

    ccb_condition(u, t, integrator) = t - 0.5
    ccb_affect!(integrator) = nothing
    ContinuousCallback(ccb_condition, ccb_affect!)

    cb = DiscreteCallback(cb_condition, cb_affect!)
    ccb = ContinuousCallback(ccb_condition, ccb_affect!)
    CallbackSet(cb, ccb)
end

function discretize end
function symbolic_discretize end

isfunctionwrapper(x) = false
function wrapfun_oop end
function wrapfun_iip end
function unwrap_fw end

export ReturnCode

export DEAlgorithm, SciMLAlgorithm, DEProblem, DEAlgorithm, DESolution, SciMLSolution

# Exports
export AllObserved

export isinplace

export solve, solve!, init, discretize, symbolic_discretize

export LinearProblem, IntervalNonlinearProblem,
    IntegralProblem, SampledIntegralProblem, OptimizationProblem

export NonlinearProblem, SCCNonlinearProblem, NonlinearLeastSquaresProblem

export DiscreteProblem, ImplicitDiscreteProblem
export SteadyStateProblem, SteadyStateSolution
export NoiseProblem
export ODEProblem, ODESolution
export DynamicalODEFunction,
    DynamicalODEProblem,
    SecondOrderODEProblem, SplitFunction, SplitODEProblem
export SplitSDEProblem
export DynamicalSDEFunction, DynamicalSDEProblem
export RODEProblem, RODESolution, SDEProblem
export DAEProblem, DAESolution
export DDEProblem
export DynamicalDDEFunction, DynamicalDDEProblem,
    SecondOrderDDEProblem
export SDDEProblem
export PDEProblem
export IncrementingODEProblem

export BVProblem, TwoPointBVProblem, SecondOrderBVProblem, TwoPointSecondOrderBVProblem

export remake

export ODEFunction, DiscreteFunction, ImplicitDiscreteFunction, SplitFunction, DAEFunction,
    DDEFunction, SDEFunction, SplitSDEFunction, RODEFunction, SDDEFunction,
    IncrementingODEFunction, NonlinearFunction, HomotopyNonlinearFunction,
    IntervalNonlinearFunction, BVPFunction,
    TwoPointBVPFunction, TwoPointDynamicalBVPFunction,
    DynamicalBVPFunction, IntegralFunction, BatchIntegralFunction, ODEInputFunction

export OptimizationFunction, MultiObjectiveOptimizationFunction

export CheckInit

export EnsembleThreads, EnsembleDistributed, EnsembleSplitThreads, EnsembleSerial

export EnsembleAnalysis, EnsembleSummary

export tuples, intervals, TimeChoiceIterator

export step!, deleteat!, addat!, get_tmp_cache,
    full_cache, user_cache, u_cache, du_cache,
    rand_cache, ratenoise_cache,
    resize_non_user_cache!, deleteat_non_user_cache!, addat_non_user_cache!,
    terminate!,
    add_tstop!, has_tstop, first_tstop, pop_tstop!,
    add_saveat!, set_abstol!,
    set_reltol!, get_du, get_du!, get_dt, get_proposed_dt, set_proposed_dt!,
    u_modified!, savevalues!, reinit!, auto_dt_reset!, set_t!,
    set_u!, check_error, change_t_via_interpolation!, addsteps!,
    isdiscrete, reeval_internals_due_to_modification!,
    has_rng, get_rng, set_rng!, supports_solve_rng

export ContinuousCallback, DiscreteCallback, CallbackSet, VectorContinuousCallback

export Clocks, TimeDomain, is_discrete_time_domain, isclock, issolverstepclock, iscontinuous

export ODEAliasSpecifier, LinearAliasSpecifier

# Public traits

@public has_init, has_step, successful_retcode

end

using Test, SciMLBase
using SciMLBase: __has_jac, __has_tgrad, __has_Wfact, __has_Wfact_t,
    __has_paramjac, __has_analytic, __has_colorvec, has_jac,
    has_tgrad,
    has_Wfact, has_Wfact_t, has_paramjac, has_analytic, has_colorvec,
    AbstractDiffEqFunction

struct Foo <: AbstractDiffEqFunction{false}
    jac::Any
    tgrad::Any
    Wfact::Any
    Wfact_t::Any
    paramjac::Any
    analytic::Any
    colorvec::Any
end

f = Foo(1, 1, 1, 1, 1, 1, 1)

@test __has_jac(f)
@test __has_tgrad(f)
@test __has_Wfact(f)
@test __has_Wfact_t(f)
@test __has_paramjac(f)
@test __has_analytic(f)
@test __has_colorvec(f)

@test has_jac(f)
@test has_tgrad(f)
@test has_Wfact(f)
@test has_Wfact_t(f)
@test has_paramjac(f)
@test has_analytic(f)
@test has_colorvec(f)

struct Foo2 <: AbstractDiffEqFunction{false}
    jac::Any
    tgrad::Any
    Wfact::Any
    Wfact_t::Any
end

f2 = Foo2(1, 1, nothing, nothing)

@test __has_jac(f2)
@test __has_tgrad(f2)
@test __has_Wfact(f2)
@test __has_Wfact_t(f2)
@test !__has_paramjac(f2)
@test !__has_analytic(f2)
@test !__has_colorvec(f2)

@test has_jac(f2)
@test has_tgrad(f2)
@test !has_Wfact(f2)
@test !has_Wfact_t(f2)
@test !has_paramjac(f2)
@test !has_analytic(f2)
@test !has_colorvec(f2)

using Test, SciMLBase

@testset "Convert NonlinearFunction to ODEFunction" begin
    f! = NonlinearFunction((du, u, p) -> du[1] = u[1] - p[1] + p[2])
    f = NonlinearFunction((u, p) -> u .- p[1] .+ p[2])

    _f! = ODEFunction(f!)
    _f = ODEFunction(f)

    @test _f! isa ODEFunction && isinplace(_f!)
    @test _f isa ODEFunction && !isinplace(_f)
end

@testset "Convert ODEFunction to NonlinearFunction" begin
    f! = ODEFunction((du, u, p, t) -> du[1] = u[1] - p[1] + p[2])
    f = ODEFunction((u, p, t) -> u .- p[1] .+ p[2])

    _f! = NonlinearFunction(f!)
    _f = NonlinearFunction(f)

    @test _f! isa NonlinearFunction && isinplace(_f!)
    @test _f isa NonlinearFunction && !isinplace(_f)
end

@testset "Convert ODEProblem to NonlinearProblem" begin
    function lorenz!(du, u, p, t)
        du[1] = 10.0(u[2] - u[1])
        du[2] = u[1] * (28.0 - u[3]) - u[2]
        du[3] = u[1] * u[2] - (8 / 3) * u[3]
    end
    u0 = [1.0; 0.0; 0.0]
    tspan = (0.0, 100.0)
    prob = ODEProblem(lorenz!, u0, tspan)
    nlprob = NonlinearProblem(prob)
end

@testset "Convert ODEProblem with kwargs to NonlinearProblem" begin
    function lorenz!(du, u, p, t)
        du[1] = p[1] * (u[2] - u[1])
        du[2] = u[1] * (p[2] - u[3]) - u[2]
        du[3] = u[1] * u[2] - p[3] * u[3]
    end
    u0 = [1.0; 0.0; 0.0]
    tspan = (0.0, 100.0)
    p = [10.0, 28.0, 8 / 3]
    prob = ODEProblem(lorenz!, u0, tspan, p; a = 1.0, b = 2.0)
    nlprob = NonlinearProblem(prob)
    @test nlprob.kwargs[:a] == prob.kwargs[:a]
    @test nlprob.kwargs[:b] == prob.kwargs[:b]
end

@testset "unwrapped_f preserves non-nothing fields for AutoSpecialize" begin
    analytic_fn = (u0, p, t) -> u0 .* exp(-t)
    jvp_fn = (Jv, u, p, t, v) -> nothing

    # AutoSpecialize with analytic + jvp should not error
    f = ODEFunction{true, SciMLBase.AutoSpecialize}(
        (du, u, p, t) -> (du .= -u);
        analytic = analytic_fn,
        jvp = jvp_fn
    )
    uf = SciMLBase.unwrapped_f(f)
    @test uf.analytic === analytic_fn
    @test uf.jvp === jvp_fn

    # AutoSpecialize with only analytic
    f2 = ODEFunction{true, SciMLBase.AutoSpecialize}(
        (du, u, p, t) -> (du .= -u);
        analytic = analytic_fn
    )
    uf2 = SciMLBase.unwrapped_f(f2)
    @test uf2.analytic === analytic_fn
    @test uf2.jvp === nothing

    # AutoSpecialize with no extra fields
    f3 = ODEFunction{true, SciMLBase.AutoSpecialize}(
        (du, u, p, t) -> (du .= -u)
    )
    uf3 = SciMLBase.unwrapped_f(f3)
    @test uf3.analytic === nothing
    @test uf3.jvp === nothing
end

@testset "Convert ODEProblem with kwargs to SteadyStateProblem" begin
    function lorenz!(du, u, p, t)
        du[1] = p[1] * (u[2] - u[1])
        du[2] = u[1] * (p[2] - u[3]) - u[2]
        du[3] = u[1] * u[2] - p[3] * u[3]
    end
    u0 = [1.0; 0.0; 0.0]
    tspan = (0.0, 100.0)
    p = [10.0, 28.0, 8 / 3]
    prob = ODEProblem(lorenz!, u0, tspan, p; a = 1.0, b = 2.0)
    sprob = SteadyStateProblem(prob)
    @test sprob.kwargs[:a] == prob.kwargs[:a]
    @test sprob.kwargs[:b] == prob.kwargs[:b]
end

module SciMLBaseRCallExt

using RCall: RFunction
using SciMLBase

# Always assume a function from R is not in-place because copy-on-write disallows it!
function SciMLBase.isinplace(f::RFunction, args...; kwargs...)
    return false
end

end

module SciMLBasePythonCallExt

using PythonCall: Py, PyList, pyimport, hasproperty, pyconvert, pyisinstance, pybuiltins
using SciMLBase: SciMLBase

# SciML uses a function's arity (number of arguments) to determine if it operates in place.
# PythonCall does not preserve arity, so we inspect Python functions to find their arity.
function SciMLBase.numargs(f::Py)
    inspect = pyimport("inspect")
    f2 = hasproperty(f, :py_func) ? f.py_func : f
    # if `f` is a bound method (i.e., `self.f`), `getfullargspec` includes
    # `self` in the `args` list. So, we subtract 1 in that case:
    return pyconvert(Int, length(first(inspect.getfullargspec(f2))) - inspect.ismethod(f2))
end

function _pyconvert(x::Py)
    return pyisinstance(x, pybuiltins.list) ? _promoting_collect(_pyconvert(x) for x in x) :
        pyconvert(Any, x)
end
_pyconvert(x::PyList) = _promoting_collect(_pyconvert(x) for x in x)
_pyconvert(x) = x

# _promoting_collect might copy its input
_promoting_collect(x) = _promoting_collect(collect(x))
function _promoting_collect(x::AbstractArray)
    isconcretetype(eltype(x)) && return x
    T = mapreduce(typeof, promote_type, x)
    return T == eltype(x) ? x : T.(x)
end

SciMLBase.prepare_initial_state(u0::Union{Py, PyList}) = _pyconvert(u0)
SciMLBase.prepare_function(f::Py) = _pyconvert ∘ f

end

function adapt_structure(
        to,
        prob::Union{
            NonlinearProblem{<:Any, iip},
            ImmutableNonlinearProblem{<:Any, iip},
        }
    ) where {iip}
    return ImmutableNonlinearProblem{iip}(
        NonlinearFunction{iip}(adapt(to, prob.f.f)),
        adapt(to, prob.u0),
        adapt(to, prob.p);
        adapt(to, prob.kwargs)...
    )
end

function adapt_structure(
        to,
        prob::Union{ODEProblem{<:Any, <:Any, iip}, ImmutableODEProblem{<:Any, <:Any, iip}}
    ) where {iip}
    return ImmutableODEProblem{iip, FullSpecialize}(
        adapt(to, prob.f),
        adapt(to, prob.u0),
        adapt(to, prob.tspan),
        adapt(to, prob.p);
        adapt(to, prob.kwargs)...
    )
end

# Allow DAE adaptation for GPU kernels
function adapt_structure(to, f::ODEFunction{iip}) where {iip}
    # For GPU kernels, we now support DAEs with mass matrices and initialization
    return ODEFunction{iip, FullSpecialize}(
        adapt(to, f.f),
        jac = adapt(to, f.jac),
        mass_matrix = adapt(to, f.mass_matrix),
        initialization_data = adapt(to, f.initialization_data)
    )
end

# Adapt OverrideInitData for GPU compatibility
function adapt_structure(to, f::OverrideInitData)
    return OverrideInitData(
        adapt(to, f.initializeprob),  # Also adapt initializeprob
        f.update_initializeprob!,
        f.initializeprobmap,
        f.initializeprobpmap,
        nothing,  # Set metadata to nothing for GPU compatibility
        f.is_update_oop
    )
end

abstract type AbstractClock end

@data Clocks <: AbstractClock begin
    ContinuousClock()
    struct PeriodicClock
        dt::Union{Nothing, Float64, Rational{Int}}
        phase::Float64 = 0.0
    end
    SolverStepClock()
    struct EventClock
        id::Symbol
    end
end

@derive Clocks[Show, Hash, Eq]

# for backwards compatibility
const TimeDomain = AbstractClock
using .Clocks: ContinuousClock, PeriodicClock, SolverStepClock, EventClock
const Continuous = ContinuousClock()
(clock::TimeDomain)() = clock

Base.Broadcast.broadcastable(d::TimeDomain) = Ref(d)

"""
    Clock(dt)
    Clock()

The default periodic clock with tick interval `dt`. If `dt` is left unspecified, it will
be inferred (if possible).
"""
Clock(dt::Union{<:Rational, Float64}; phase = 0.0) = PeriodicClock(dt, phase)
Clock(dt; phase = 0.0) = PeriodicClock(convert(Float64, dt), phase)
Clock(; phase = 0.0) = PeriodicClock(nothing, phase)

@doc """
    SolverStepClock

A clock that ticks at each solver step (sometimes referred to as "continuous sample time").
This clock **does generally not have equidistant tick intervals**, instead, the tick
interval depends on the adaptive step-size selection of the continuous solver, as well as
any continuous event handling. If adaptivity of the solver is turned off and there are no
continuous events, the tick interval will be given by the fixed solver time step `dt`.

Due to possibly non-equidistant tick intervals, this clock should typically not be used with
discrete-time systems that assume a fixed sample time, such as PID controllers and digital
filters.
""" SolverStepClock

"""
    isclock(clock)

Returns `true` if the object is a valid clock type (specifically a `PeriodicClock`).
This function is used for type checking in clock-dependent logic.
"""
isclock(c::Clocks.Type) = @match c begin
    PeriodicClock() => true
    _ => false
end
isclock(::TimeDomain) = false

"""
    issolverstepclock(clock)

Returns `true` if the clock is a `SolverStepClock` that triggers at every solver step.
This is useful for monitoring solver progress or implementing step-dependent logic.
"""
issolverstepclock(c::Clocks.Type) = @match c begin
    SolverStepClock() => true
    _ => false
end
issolverstepclock(::TimeDomain) = false

"""
    iscontinuous(clock)

Returns `true` if the clock operates in continuous time (i.e., is a `ContinuousClock`).
Continuous clocks allow events to occur at any real-valued time instant.
"""
iscontinuous(c::Clocks.Type) = @match c begin
    ContinuousClock() => true
    _ => false
end
iscontinuous(::TimeDomain) = false

"""
    iseventclock(clock)

Returns `true` if the clock is an `EventClock` that triggers based on specific events.
Event clocks are used for condition-based triggering in hybrid systems.
"""
iseventclock(c::Clocks.Type) = @match c begin
    EventClock() => true
    _ => false
end
iseventclock(::TimeDomain) = false

"""
    is_discrete_time_domain(clock)

Returns `true` if the clock operates in discrete time (i.e., is not a continuous clock).
Discrete time domains have specific sampling intervals or event-based triggering.
"""
is_discrete_time_domain(c::TimeDomain) = !iscontinuous(c)

# workaround for https://github.com/Roger-luo/Moshi.jl/issues/43
isclock(::Any) = false
issolverstepclock(::Any) = false
iscontinuous(::Any) = false
iseventclock(::Any) = false
is_discrete_time_domain(::Any) = false

# public
function first_clock_tick_time(c::Clocks.Type, t0)
    return @match c begin
        PeriodicClock(dt) => ceil(t0 / dt) * dt
        SolverStepClock() => t0
        ContinuousClock() => error("ContinuousClock() is not a discrete clock")
        EventClock() => error("Event clocks do not have a defined first tick time.")
        _ => error("Unimplemented for clock $c")
    end
end

function first_clock_tick_time(c::TimeDomain, _)
    error("Unimplemented for clock $c")
end

# public
"""
    $(TYPEDEF)

A struct representing the operation of indexing a clock to obtain a subset of the time
points at which it ticked. The actual list of time points depends on the tick instances 
on which the clock was ticking, and can be obtained via `canonicalize_indexed_clock`
by providing a timeseries solution object.

For example, `IndexedClock(PeriodicClock(0.1), 3)` refers to the third time that
`PeriodicClock(0.1)` ticked. If the simulation started at `t = 0`, then this would be
`t = 0.2`. Similarly, `IndexedClock(PeriodicClock(0.1), [1, 5])` refers to `t = 0.0`
and `t = 0.4` in this context.

# Fields

$(TYPEDFIELDS)
"""
struct IndexedClock{C <: AbstractClock, I}
    """
    The clock being indexed. A subtype of `SciMLBase.AbstractClock`
    """
    clock::C
    """
    The subset of indexes being referred to. This can be an integer, an array of integers,
    a range or `Colon()` to refer to all the points that the clock ticked.
    """
    idx::I
end

# public
"""
    $(TYPEDSIGNATURES)

Return a `SciMLBase.IndexedClock` representing the subset of the time points that the clock
ticked indicated by `idx`.
"""
Base.getindex(c::AbstractClock, idx) = IndexedClock(c, idx)

# public
"""
    $(TYPEDSIGNATURES)

Return the time points in the interval
"""
function canonicalize_indexed_clock(ic::IndexedClock, sol::AbstractTimeseriesSolution)
    c = ic.clock

    return @match c begin
        PeriodicClock(dt) => ceil(sol.prob.tspan[1] / dt) * dt .+ (ic.idx .- 1) .* dt
        SolverStepClock() => begin
            ssc_idx = findfirst(eachindex(sol.discretes)) do i
                !isa(sol.discretes[i].t, AbstractRange)
            end
            sol.discretes[ssc_idx].t[ic.idx]
        end
        ContinuousClock() => sol.t[ic.idx]
    end
end

using ModelingToolkit, OrdinaryDiffEq, RecursiveArrayTools, StochasticDiffEq, Test
using StochasticDiffEq
using SymbolicIndexingInterface
using ModelingToolkit: t_nounits as t, D_nounits as D
using Plots: Plots, plot

### Tests on non-layered model (everything should work). ###

@testset "Basic indexing" begin
    @parameters a b c d
    @variables s1(t) s2(t)

    eqs = [
        D(s1) ~ a * s1 / (1 + s1 + s2) - b * s1,
        D(s2) ~ +c * s2 / (1 + s1 + s2) - d * s2,
    ]

    @mtkcompile population_model = System(eqs, t)

    # Tests on ODEProblem.
    u0 = [s1 => 2.0, s2 => 1.0]
    p = [a => 2.0, b => 1.0, c => 1.0, d => 1.0]
    tspan = (0.0, 1000000.0)
    oprob = ODEProblem(population_model, [u0; p], tspan)
    sol = solve(oprob, Rodas4())

    @test sol[s1] == sol[population_model.s1] == sol[:s1]
    @test sol[s2] == sol[population_model.s2] == sol[:s2]
    @test sol[s1][end] ≈ 1.0
    @test_throws Exception sol[a]
    @test_throws Exception sol[population_model.a]
    @test_throws Exception sol[:a]

    Plots.unicodeplots()
    f = ODEFunction((u, p, t) -> -u, analytic = (u0, p, t) -> u0 * exp(-t))

    # scalar
    ode = ODEProblem(f, 1.0, (0.0, 1.0))
    sol = solve(ode, Tsit5())
    @test_nowarn plot(sol)
    @test_nowarn plot(sol; plot_analytic = true)

    # vector
    ode = ODEProblem(f, [1.0, 2.0], (0.0, 1.0))
    sol = solve(ode, Tsit5())
    @test_nowarn plot(sol)
    @test_nowarn plot(sol; plot_analytic = true)

    # matrix
    ode = ODEProblem(f, [1.0 2.0; 3.0 4.0], (0.0, 1.0))
    sol = solve(ode, Tsit5())
    @test_nowarn plot(sol)
    @test_nowarn plot(sol; plot_analytic = true)

    # Tests on SDEProblem
    noiseeqs = [
        0.1 * s1,
        0.1 * s2,
    ]
    @named noisy_population_model = SDESystem(population_model, noiseeqs)
    noisy_population_model = complete(noisy_population_model)
    sprob = SDEProblem(noisy_population_model, [u0; p], (0.0, 100.0))
    sol = solve(sprob, ImplicitEM())

    @test sol[s1] == sol[noisy_population_model.s1] == sol[:s1]
    @test sol[s2] == sol[noisy_population_model.s2] == sol[:s2]
    @test_throws Exception sol[a]
    @test_throws Exception sol[noisy_population_model.a]
    @test_throws Exception sol[:a]
    @test_nowarn sol(0.5, idxs = noisy_population_model.s1)
    ### Tests on layered model (some things should not work). ###

    @parameters σ ρ β
    @variables x(t) y(t) z(t)

    eqs = [
        D(x) ~ σ * (y - x),
        D(y) ~ x * (ρ - z) - y,
        D(z) ~ x * y - β * z,
    ]

    @named lorenz1 = System(eqs, t)
    @named lorenz2 = System(eqs, t)

    @parameters γ
    @variables a(t) α(t)
    connections = [
        0 ~ lorenz1.x + lorenz2.y + a * γ,
        α ~ 2lorenz1.x + a * γ,
    ]
    @mtkcompile sys = System(connections, t, [a, α], [γ], systems = [lorenz1, lorenz2])

    u0 = [
        lorenz1.x => 1.0,
        lorenz1.y => 0.0,
        lorenz1.z => 0.0,
        lorenz2.x => 0.0,
        lorenz2.y => 1.0,
        lorenz2.z => 0.0,
    ]

    p = [
        lorenz1.σ => 10.0,
        lorenz1.ρ => 28.0,
        lorenz1.β => 8 / 3,
        lorenz2.σ => 10.0,
        lorenz2.ρ => 28.0,
        lorenz2.β => 8 / 3,
        γ => 2.0,
    ]

    tspan = (0.0, 100.0)
    prob = ODEProblem(sys, [u0; p], tspan)
    sol = solve(prob, Rodas4())

    @test_throws ArgumentError sol[x]
    @test in(
        sol[lorenz1.x], [
            getindex.(sol.u, i)
                for i in 1:length(unknowns(sol.prob.f.sys))
        ]
    )
    @test_throws KeyError sol[:x]

    ### Non-symbolic indexing tests
    @test sol[:, 1] isa AbstractVector
    @test sol[:, 1:2] isa AbstractDiffEqArray
    @test sol[:, [1, 2]] isa AbstractDiffEqArray

    sol1 = sol(0.0:1.0:10.0)
    @test sol1.u isa Vector
    @test first(sol1.u) isa Vector
    @test length(sol1.u) == 11
    @test length(sol1.t) == 11

    sol2 = sol(0.1)
    @test sol2 isa Vector
    @test length(sol2) == length(unknowns(sys))
    @test first(sol2) isa Real

    sol3 = sol(0.0:1.0:10.0, idxs = [lorenz1.x, lorenz2.x])

    sol7 = sol(0.0:1.0:10.0, idxs = [2, 1])
    @test sol7.u isa Vector
    @test first(sol7.u) isa Vector
    @test length(sol7.u) == 11
    @test length(sol7.t) == 11
    @test collect(sol7[t]) ≈ sol3.t
    @test collect(sol7[t, 1:5]) ≈ sol3.t[1:5]

    sol8 = sol(0.1, idxs = [2, 1])
    @test sol8 isa Vector
    @test length(sol8) == 2
    @test first(sol8) isa Real

    sol9 = sol(0.0:1.0:10.0, idxs = 2)
    @test sol9.u isa Vector
    @test first(sol9.u) isa Real
    @test length(sol9.u) == 11
    @test length(sol9.t) == 11
    @test collect(sol9[t]) ≈ sol3.t
    @test collect(sol9[t, 1:5]) ≈ sol3.t[1:5]

    sol10 = sol(0.1, idxs = 2)
    @test sol10 isa Real
end

@testset "Plot idxs" begin
    @variables x(t) y(t)
    @parameters p
    @mtkcompile sys = System([D(x) ~ x * t, D(y) ~ y - p * x], t)
    prob = ODEProblem(sys, [x => 1.0, y => 2.0, p => 1.0], (0.0, 1.0))
    sol = solve(prob, Tsit5())

    plotfn(t, u) = (t, 2u)
    all_idxs = [
        x, x + p * y, t, (plotfn, 0, 1), (plotfn, t, 1), (plotfn, 0, x),
        (plotfn, t, x), (plotfn, t, p * y),
    ]
    sym_idxs = [
        :x, :t, (plotfn, :t, 1), (plotfn, 0, :x),
        (plotfn, :t, :x),
    ]
    for idx in Iterators.flatten((all_idxs, sym_idxs))
        @test_nowarn plot(sol; idxs = idx)
        @test_nowarn plot(sol; idxs = [idx])
    end
    for idx in Iterators.flatten(
            (
                Iterators.product(all_idxs, all_idxs), Iterators.product(sym_idxs, sym_idxs),
            )
        )
        @test_nowarn plot(sol; idxs = collect(idx))
        if !(idx[1] isa Tuple || idx[2] isa Tuple)
            @test_nowarn plot(sol; idxs = idx)
        end
    end
end

@testset "Saved subsystem" begin
    @testset "Purely continuous ODE/DAE/SDE-solutions" begin
        @variables x(t) y(t)
        @parameters p
        @mtkcompile sys = System([D(x) ~ x + p * y, D(y) ~ 2p + x^2], t)
        @test length(unknowns(sys)) == 2
        xidx = variable_index(sys, x)
        prob = ODEProblem(sys, [x => 1.0, y => 1.0, p => 0.5], (0.0, 5.0))

        @test SciMLBase.SavedSubsystem(sys, prob.p, nothing) === nothing
        @test SciMLBase.SavedSubsystem(sys, prob.p, [x, y]) === nothing
        @test begin
            ss1 = SciMLBase.SavedSubsystem(sys, prob.p, [x])
            ss2 = SciMLBase.SavedSubsystem(sys, prob.p, [xidx])
            ss1.state_map == ss2.state_map
        end

        ode_sol = solve(prob, Tsit5(); save_idxs = [x])

        @mtkcompile sys = System([D(x) ~ x + p * y, 1 ~ sin(y) + cos(x)], t)
        xidx = variable_index(sys, x)
        prob = DAEProblem(
            sys,
            [
                D(x) => x + p * y, D(y) => 1 / sqrt(1 - (1 - cos(x))^2),
                x => 1.0, y => asin(1 - cos(x)), p => 2.0,
            ],
            (0.0, 1.0); build_initializeprob = false
        )
        dae_sol = solve(prob, DFBDF(); save_idxs = [x])

        @brownians a b
        @mtkcompile sys = System([D(x) ~ x + p * y + x * a, D(y) ~ 2p + x^2 + y * b], t)
        xidx = variable_index(sys, x)
        prob = SDEProblem(sys, [x => 1.0, y => 2.0, p => 2.0], (0.0, 1.0))
        sde_sol = solve(prob, SOSRI(); save_idxs = [x])

        for sol in [ode_sol, dae_sol, sde_sol]
            prob = sol.prob
            subsys = sol.saved_subsystem
            xvals = sol[x]
            xidx = variable_index(prob, x)
            @test sol[x] == xvals
            @test is_parameter(sol, p)
            @test parameter_index(sol, p) == parameter_index(sys, p)
            @test any(isequal(p), parameter_symbols(sol))
            @test is_independent_variable(sol, t)

            tmp = copy(prob.u0)
            tmp[xidx] = xvals[2]
            @test state_values(sol, 2) == tmp
            @test state_values(sol) == [state_values(sol, i) for i in 1:length(sol)]
        end
    end

    @testset "ODE with callbacks" begin
        @variables x(t) y(t)
        @parameters p
        @discretes q(t) r(t) s(t) u(t)
        evs = [
            ModelingToolkit.SymbolicDiscreteCallback(
                0.1, [q ~ Pre(q) + 1, s ~ Pre(s) - 1];
                discrete_parameters = [q, s], iv = t
            )
            ModelingToolkit.SymbolicDiscreteCallback(
                0.1, [r ~ 2Pre(r), u ~ Pre(u) / 2];
                discrete_parameters = [r, u], iv = t
            )
        ]
        @mtkcompile sys = System(
            [D(x) ~ x + p * y, D(y) ~ 2p + x], t, [x, y, q, r, s, u],
            [p], discrete_events = evs
        )
        @test length(unknowns(sys)) == 2
        @test length(parameters(sys)) == 5
        @test is_timeseries_parameter(sys, q)
        @test is_timeseries_parameter(sys, r)
        xidx = variable_index(sys, x)
        qidx = parameter_index(sys, q)
        qpidx = timeseries_parameter_index(sys, q)
        ridx = parameter_index(sys, r)
        rpidx = timeseries_parameter_index(sys, r)
        sidx = parameter_index(sys, s)
        uidx = parameter_index(sys, u)

        prob = ODEProblem(
            sys, [x => 1.0, y => 1.0, p => 0.5, q => 0.0, r => 1.0, s => 10.0, u => 4096.0],
            (0.0, 5.0)
        )

        @test SciMLBase.SavedSubsystem(sys, prob.p, [x, y, q, r, s, u]) === nothing

        sol = solve(prob; save_idxs = [x, q, r])
        xvals = sol[x]
        @test SciMLBase.get_saved_state_idxs(sol.saved_subsystem) == [xidx]
        qvals = sol.ps[q]
        rvals = sol.ps[r]
        @test sol[x] == xvals

        @test all(Base.Fix1(is_parameter, sol), [p, q, r, s, u])
        @test all(Base.Fix1(is_timeseries_parameter, sol), [q, r])
        @test all(!Base.Fix1(is_timeseries_parameter, sol), [s, u])
        @test timeseries_parameter_index(sol, q) ==
            ParameterTimeseriesIndex(qpidx.timeseries_idx, (1, 1))
        @test timeseries_parameter_index(sol, r) ==
            ParameterTimeseriesIndex(rpidx.timeseries_idx, (1, 1))
        @test sol[q] == qvals
        @test sol[r] == rvals
    end

    @testset "SavedSubsystemWithFallback" begin
        @variables x(t) y(t)
        @parameters p
        @discretes q(t) r(t) s(t) u(t)
        evs = [
            ModelingToolkit.SymbolicDiscreteCallback(
                0.1, [q ~ Pre(q) + 1, s ~ Pre(s) - 1];
                discrete_parameters = [q, s], iv = t
            )
            ModelingToolkit.SymbolicDiscreteCallback(
                0.1, [r ~ 2Pre(r), u ~ Pre(u) / 2];
                discrete_parameters = [r, u], iv = t
            )
        ]
        @mtkcompile sys = System(
            [D(x) ~ x + p * y, D(y) ~ 2p + x^2], t, [x, y, q, r, s, u],
            [p], discrete_events = evs
        )
        prob = ODEProblem(
            sys, [x => 1.0, y => 1.0, p => 0.5, q => 0.0, r => 1.0, s => 10.0, u => 4096.0],
            (0.0, 5.0)
        )
        ss = SciMLBase.SavedSubsystem(sys, prob.p, [x, q, s, r])
        @test SciMLBase.get_saved_state_idxs(ss) == [variable_index(sys, x)]
        sswf = SciMLBase.SavedSubsystemWithFallback(ss, sys)
        xidx = variable_index(sys, x)
        qidx = parameter_index(sys, q)
        qpidx = timeseries_parameter_index(sys, q)
        ridx = parameter_index(sys, r)
        rpidx = timeseries_parameter_index(sys, r)
        sidx = parameter_index(sys, s)
        uidx = parameter_index(sys, u)
        @test qpidx.timeseries_idx in ss.identity_partitions
        @test !(rpidx.timeseries_idx in ss.identity_partitions)
        @test timeseries_parameter_index(sswf, q) == timeseries_parameter_index(sys, q)
        @test timeseries_parameter_index(sswf, s) == timeseries_parameter_index(sys, s)

        ptc = SciMLBase.create_parameter_timeseries_collection(sswf, prob.p, prob.tspan)
        origptc = SciMLBase.create_parameter_timeseries_collection(sys, prob.p, prob.tspan)

        @test ptc[qpidx.timeseries_idx] == origptc[qpidx.timeseries_idx]
        @test eltype(ptc[rpidx.timeseries_idx].u) <: SciMLBase.TupleOfArraysWrapper
        vals = SciMLBase.get_saveable_values(sswf, prob.p, qpidx.timeseries_idx)
        origvals = SciMLBase.get_saveable_values(sys, prob.p, qpidx.timeseries_idx)
        @test typeof(vals) == typeof(origvals)
        @test !(vals isa SciMLBase.TupleOfArraysWrapper)

        vals = SciMLBase.get_saveable_values(sswf, prob.p, rpidx.timeseries_idx)
        @test vals isa SciMLBase.TupleOfArraysWrapper
        @test vals.x isa Tuple{Vector{Float64}}
        @test vals.x[1][1] == prob.ps[r]

        vals[(1, 1)] = 2prob.ps[r]
        newp = with_updated_parameter_timeseries_values(
            sswf,
            parameter_values(ptc), rpidx.timeseries_idx => vals
        )
        @test newp[ridx] == 2prob.ps[r]
    end

    @testset "get_save_idxs_and_saved_subsystem" begin
        @variables x(t) y(t)
        @parameters p
        @discretes q(t) r(t) s(t) u(t)
        evs = [
            ModelingToolkit.SymbolicDiscreteCallback(
                0.1, [q ~ Pre(q) + 1, s ~ Pre(s) - 1];
                discrete_parameters = [q, s], iv = t
            )
            ModelingToolkit.SymbolicDiscreteCallback(
                0.1, [r ~ 2Pre(r), u ~ Pre(u) / 2];
                discrete_parameters = [r, u], iv = t
            )
        ]
        @mtkcompile sys = System(
            [D(x) ~ x + p * y, D(y) ~ 2p + x^2], t, [x, y, q, r, s, u],
            [p], discrete_events = evs
        )
        prob = ODEProblem(
            sys, [x => 1.0, y => 1.0, p => 0.5, q => 0.0, r => 1.0, s => 10.0, u => 4096.0],
            (0.0, 5.0)
        )

        _idxs, _ss = @inferred SciMLBase.get_save_idxs_and_saved_subsystem(prob, nothing)
        @test _idxs === _ss === nothing
        _idxs, _ss = @inferred SciMLBase.get_save_idxs_and_saved_subsystem(prob, 1)
        @test _idxs == 1
        @test _ss isa SciMLBase.SavedSubsystem
        _idxs, _ss = @inferred SciMLBase.get_save_idxs_and_saved_subsystem(prob, [1])
        @test _idxs == [1]
        @test _ss isa SciMLBase.SavedSubsystem
        _idxs, _ss = SciMLBase.get_save_idxs_and_saved_subsystem(prob, x)
        xidx = variable_index(prob, x)
        @test _idxs == xidx
        @test _ss isa SciMLBase.SavedSubsystem
        _idxs, _ss = SciMLBase.get_save_idxs_and_saved_subsystem(prob, [x])
        @test _idxs == [xidx]
        @test _ss isa SciMLBase.SavedSubsystem
        _idxs, _ss = SciMLBase.get_save_idxs_and_saved_subsystem(prob, [x, q])
        @test _idxs == [xidx]
        @test _ss isa SciMLBase.SavedSubsystem
        _idxs, _ss = SciMLBase.get_save_idxs_and_saved_subsystem(prob, [q])
        @test _idxs == Int[]
        @test _ss isa SciMLBase.SavedSubsystem
    end
end

@testset "Interpolation after final discrete save" begin
    @variables x(t) y(t)
    @parameters start
    @mtkcompile sys = System([D(x) ~ y, y ~ ifelse(t < start, 1.0, 2.0)], t) additional_passes = [ModelingToolkit.IfLifting]
    prob = ODEProblem(sys, [x => 0.0, start => 0.5], (0.0, 1.0))
    sol = solve(prob)
    @test sol(0.6, idxs = y) ≈ 2.0
end

"""
$(TYPEDEF)
"""
struct StandardSDEProblem end

@doc doc"""

Defines an stochastic differential equation (SDE) problem.
Documentation Page: <https://docs.sciml.ai/DiffEqDocs/stable/types/sde_types/>

## Mathematical Specification of a SDE Problem

To define an SDE Problem, you simply need to give the forcing function `f`,
the noise function `g`, and the initial condition `u₀` which define an SDE:

```math
du = f(u,p,t) \, dt + ∑ᵢ gᵢ(u,p,t) \, dWⁱ
```

`f` and `g` should be specified as `f(u,p,t)` and  `g(u,p,t)` respectively, and `u₀`
should be an AbstractArray whose geometry matches the desired geometry of `u`.
Note that we are not limited to numbers or vectors for `u₀`; one is allowed to
provide `u₀` as arbitrary matrices / higher dimension tensors as well. A vector
of `g`s can also be defined to determine an SDE of higher Ito dimension.

## Problem Type

Wraps the data which defines an SDE problem

```math
u = f(u,p,t) \, dt + ∑ᵢ gᵢ(u,p,t) \, dWⁱ
```

with initial condition `u0`.

### Constructors

- `SDEProblem(f::SDEFunction,u0,tspan,p=NullParameters();noise=WHITE_NOISE,noise_rate_prototype=nothing)`
- `SDEProblem{isinplace,specialize}(f,g,u0,tspan,p=NullParameters();noise=WHITE_NOISE,noise_rate_prototype=nothing)` :
  Defines the SDE with the specified functions. The default noise is `WHITE_NOISE`.
  `isinplace` optionally sets whether the function is inplace or not. This is
  determined automatically, but not inferred. `specialize` optionally controls
  the specialization level. See the [specialization levels section of the SciMLBase documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Problems/#Specialization-Levels)
  for more details. The default is `AutoSpecialize`.

Parameters are optional, and if not given then a `NullParameters()` singleton
will be used which will throw nice errors if you try to index non-existent
parameters. Any extra keyword arguments are passed on to the solvers. For example,
if you set a `callback` in the problem, then that `callback` will be added in
every solve call.

For specifying Jacobians and mass matrices, see the
[DiffEqFunctions](@ref performance_overloads)
page.

### Fields

* `f`: The drift function in the SDE.
* `g`: The noise function in the SDE.
* `u0`: The initial condition.
* `tspan`: The timespan for the problem.
* `p`: The optional parameters for the problem. Defaults to `NullParameters`.
* `noise`: The noise process applied to the noise upon generation. Defaults to
  Gaussian white noise. For information on defining different noise processes,
  see [the noise process documentation page](@ref noise_process).
* `noise_rate_prototype`: A prototype type instance for the noise rates, that
  is the output `g`. It can be any type which overloads `A_mul_B!` with itself
  being the middle argument. Commonly, this is a matrix or sparse matrix. If
  this is not given, it defaults to `nothing`, which means the problem should
  be interpreted as having diagonal noise.
* `kwargs`: The keyword arguments passed onto the solves.

## Example Problems

Examples problems can be found in [DiffEqProblemLibrary.jl](https://github.com/SciML/DiffEqProblemLibrary.jl).

To use a sample problem, such as `prob_sde_linear`, you can do something like:

```julia
#] add SDEProblemLibrary
using SDEProblemLibrary
prob = SDEProblemLibrary.prob_sde_linear
sol = solve(prob)
```
"""
struct SDEProblem{uType, tType, isinplace, P, NP, F, G, K, ND} <:
    AbstractSDEProblem{uType, tType, isinplace, ND}
    f::F
    g::G
    u0::uType
    tspan::tType
    p::P
    noise::NP
    kwargs::K
    noise_rate_prototype::ND
    seed::UInt64
    @add_kwonly function SDEProblem{iip}(
            f::AbstractSDEFunction{iip}, u0,
            tspan, p = NullParameters();
            noise_rate_prototype = nothing,
            noise = nothing, seed = UInt64(0),
            kwargs...
        ) where {iip}
        _u0 = prepare_initial_state(u0)
        _tspan = promote_tspan(tspan)
        warn_paramtype(p)
        new{
            typeof(_u0), typeof(_tspan),
            isinplace(f), typeof(p),
            typeof(noise), typeof(f), typeof(f.g),
            typeof(kwargs),
            typeof(noise_rate_prototype),
        }(
            f, f.g, _u0, _tspan, p,
            noise, kwargs,
            noise_rate_prototype, seed
        )
    end

    function SDEProblem{iip}(f, g, u0, tspan, p = NullParameters(); kwargs...) where {iip}
        return SDEProblem(SDEFunction{iip}(f, g), u0, tspan, p; kwargs...)
    end
end

function SDEProblem(f::AbstractSDEFunction, u0, tspan, p = NullParameters(); kwargs...)
    return SDEProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end

function SDEProblem(f, g, u0, tspan, p = NullParameters(); kwargs...)
    iip = isinplace(f, 4)
    return SDEProblem{iip}(SDEFunction{iip}(f, g), u0, tspan, p; kwargs...)
end

function ConstructionBase.constructorof(::Type{P}) where {P <: SDEProblem}
    return function ctor(f, g, u0, tspan, p, noise, kw, noise_rate_prototype, seed)
        if f isa AbstractSDEFunction
            iip = isinplace(f)
            if g !== f.g
                f = remake(f; g)
            end
            return SDEProblem{iip}(
                f, u0, tspan, p; kw..., noise, noise_rate_prototype, seed
            )
        else
            iip = isinplace(f, 4)
            return SDEProblem{iip}(
                f, g, u0, tspan, p; kw..., noise, noise_rate_prototype, seed
            )
        end
    end
end

"""
$(TYPEDEF)
"""
abstract type AbstractSplitSDEProblem end

"""
$(TYPEDEF)
"""
struct SplitSDEProblem{iip} <: AbstractSplitSDEProblem end
# u' = Au + f
#=
function SplitSDEProblem(f1, f2, g, u0, tspan, p = NullParameters(); kwargs...)
    SplitSDEProblem(SplitSDEFunction(f1, f2, g), g, u0, tspan, p; kwargs...)
end
=#
function SplitSDEProblem{iip}(
        f1, f2, g, u0, tspan, p = NullParameters(); kwargs...
    ) where {iip}
    return SplitSDEProblem{iip}(SplitSDEFunction(f1, f2, g), u0, tspan, p; kwargs...)
end

function SplitSDEProblem(f1, f2, g, u0, tspan, p = NullParameters(); kwargs...)
    ff = SplitSDEFunction(f1, f2, g)
    return SplitSDEProblem{isinplace(ff)}(ff, u0, tspan, p; kwargs...)
end

function SplitSDEProblem(f::SplitSDEFunction, u0, tspan, p = NullParameters(); kwargs...)
    return SplitSDEProblem{isinplace(f)}(f, u0, tspan, p; kwargs...)
end

function SplitSDEProblem{iip}(
        f::SplitSDEFunction, u0, tspan, p = NullParameters();
        _func_cache = nothing, kwargs...
    ) where {iip}
    if f._func_cache === nothing && iip
        _func_cache = similar(u0)
        _f = SplitSDEFunction{iip}(
            f.f1, f.f2, f.g; mass_matrix = f.mass_matrix,
            _func_cache = _func_cache, analytic = f.analytic
        )
    else
        _f = f
    end
    return SDEProblem(_f, u0, tspan, p; kwargs...)
end

"""
$(TYPEDEF)
"""
abstract type AbstractDynamicalSDEProblem end

"""
$(TYPEDEF)
"""
struct DynamicalSDEProblem{iip} <: AbstractDynamicalSDEProblem end

function DynamicalSDEProblem(f1, f2, g, v0, u0, tspan, p = NullParameters(); kwargs...)
    ff = DynamicalSDEFunction(f1, f2, g)
    return DynamicalSDEProblem{isinplace(ff)}(ff, v0, u0, tspan, p; kwargs...)
end

function DynamicalSDEProblem{iip}(
        f1, f2, g, v0, u0, tspan, p = NullParameters(); kwargs...
    ) where {iip}
    ff = DynamicalSDEFunction(f1, f2, g)
    return DynamicalSDEProblem{iip}(ff, v0, u0, tspan, p; kwargs...)
end

function DynamicalSDEProblem(
        f::DynamicalSDEFunction, v0, u0, tspan,
        p = NullParameters(); kwargs...
    )
    return DynamicalSDEProblem{isinplace(f)}(f, v0, u0, tspan, p; kwargs...)
end

function DynamicalSDEProblem{iip}(
        f::DynamicalSDEFunction, v0, u0, tspan,
        p = NullParameters();
        _func_cache = nothing, kwargs...
    ) where {iip}
    if f._func_cache === nothing && iip
        _func_cache = similar(u0)
        _f = DynamicalSDEFunction{iip}(
            f.f1, f.f2, f.g; mass_matrix = f.mass_matrix,
            _func_cache = _func_cache, analytic = f.analytic
        )
    else
        _f = f
    end
    return SDEProblem(_f, ArrayPartition(v0, u0), tspan, p; kwargs...)
end

@doc doc"""
    SDEAliasSpecifier(;alias_p = nothing, alias_f = nothing, alias_u0 = nothing, alias_tstops = nothing, alias = nothing)

Holds information on what variables to alias
when solving an SDEProblem. Conforms to the AbstractAliasSpecifier interface. 

When a keyword argument is `nothing`, the default behaviour of the solver is used.

### Keywords 
* `alias_p::Union{Bool, Nothing}`
* `alias_f::Union{Bool, Nothing}`
* `alias_u0::Union{Bool, Nothing}`: alias the `u0` array. Defaults to `false`.
* `alias_tstops::Union{Bool, Nothing}`: alias the `tstops` array
* `alias_jumps::Union{Bool, Nothing}`: alias jump process if wrapped in a `JumpProcess`.
* `alias::Union{Bool, Nothing}`: sets all fields of the `SDEAliasSpecifier` to `alias`

"""
struct SDEAliasSpecifier <: AbstractAliasSpecifier
    alias_p::Union{Bool, Nothing}
    alias_f::Union{Bool, Nothing}
    alias_u0::Union{Bool, Nothing}
    alias_tstops::Union{Bool, Nothing}
    alias_jumps::Union{Bool, Nothing}

    function SDEAliasSpecifier(;
            alias_p = nothing, alias_f = nothing, alias_u0 = nothing,
            alias_du0 = nothing, alias_tstops = nothing, alias_jumps = nothing, alias = nothing
        )
        return if alias == true
            new(true, true, true, true, true)
        elseif alias == false
            new(false, false, false, false, false)
        elseif isnothing(alias)
            new(alias_p, alias_f, alias_u0, alias_tstops, alias_jumps)
        end
    end
end

"""
    $(TYPEDEF)

A collection of all the data required for `OverrideInit`.
"""
struct OverrideInitData{
        IProb, UIProb, IProbMap, IProbPmap, M, OOP <: Union{Val{true}, Val{false}},
    }
    """
    The `AbstractNonlinearProblem` to solve for initialization.
    """
    initializeprob::IProb
    """
    A function which takes `(initializeprob, value_provider)` and updates
    the parameters of the former with their values in the latter.
    If absent (`nothing`) this will not be called, and the parameters
    in `initializeprob` will be used without modification. `value_provider`
    refers to a value provider as defined by SymbolicIndexingInterface.jl.
    Usually this will refer to a problem or integrator.
    """
    update_initializeprob!::UIProb
    """
    A function which takes the solution of `initializeprob` and returns
    the state vector of the original problem. If absent, the existing state vector
    will be used.
    """
    initializeprobmap::IProbMap
    """
    A function which takes `value_provider` and the solution of `initializeprob` and returns
    the parameter object of the original problem. If absent (`nothing`),
    this will not be called and the parameters of the problem being
    initialized will be returned as-is.
    """
    initializeprobpmap::IProbPmap
    """
    Additional metadata required by the creator of the initialization.
    """
    metadata::M
    """
    If this flag is `Val{true}`, `update_initializeprob!` is treated as an out-of-place
    function which returns the updated `initializeprob`.
    """
    is_update_oop::OOP

    function OverrideInitData(
            initprob::I, update_initprob!::J, initprobmap::K,
            initprobpmap::L, metadata::M, is_update_oop::O
        ) where {I, J, K, L, M, O}
        @assert initprob isa
            Union{
            SCCNonlinearProblem, ImmutableNonlinearProblem,
            NonlinearProblem, NonlinearLeastSquaresProblem,
        }
        return new{I, J, K, L, M, O}(
            initprob, update_initprob!, initprobmap, initprobpmap, metadata, is_update_oop
        )
    end
end

function OverrideInitData(
        initprob, update_initprob!, initprobmap, initprobpmap;
        metadata = nothing, is_update_oop = Val(false)
    )
    return OverrideInitData(
        initprob, update_initprob!, initprobmap, initprobpmap, metadata, is_update_oop
    )
end

"""
    get_initial_values(prob, valp, f, alg, isinplace; kwargs...)

Return the initial `u0` and `p` for the given SciMLProblem and initialization algorithm,
and a boolean indicating whether the initialization process was successful. Keyword
arguments to this function are dependent on the initialization algorithm. `prob` is only
required for dispatching. `valp` refers the appropriate data structure from which the
current state and parameter values should be obtained. `valp` is a non-timeseries value
provider as defined by SymbolicIndexingInterface.jl. `f` is the SciMLFunction for the
problem. `alg` is the initialization algorithm to use. `isinplace` is either `Val{true}`
if `valp` and the SciMLFunction are inplace, and `Val{false}` otherwise.
"""
function get_initial_values end

struct CheckInitFailureError <: Exception
    normresid::Any
    abstol::Any
    isdae::Bool
end

function Base.showerror(io::IO, e::CheckInitFailureError)
    print(
        io,
        """
        DAE initialization failed: your u0 did not satisfy the initialization requirements, \
        normresid = $(e.normresid) > abstol = $(e.abstol).
        """
    )

    return if e.isdae
        print(
            io,
            """
            If you wish for the system to automatically change the algebraic variables to \
            satisfy the algebraic constraints, please pass `initializealg = BrownFullBasicInit()` \
            to solve (this option will require `using OrdinaryDiffEqNonlinearSolve`). If you \
            wish to perform an initialization on the complete u0, please pass \
            `initializealg = ShampineCollocationInit()` to `solve`. Note that initialization \
            can be a very difficult process for DAEs and in many cases can be numerically \
            intractable without symbolic manipulation of the system. For an automated \
            system that will generate numerically stable initializations, see \
            ModelingToolkit.jl structural simplification for more details.
            """
        )
    end
end

struct OverrideInitMissingAlgorithm <: Exception end

function Base.showerror(io::IO, e::OverrideInitMissingAlgorithm)
    return print(
        io,
        "OverrideInit specified but no NonlinearSolve.jl algorithm provided. Provide an algorithm via the `nlsolve_alg` keyword argument to `get_initial_values`."
    )
end

struct OverrideInitNoTolerance <: Exception
    tolerance::Symbol
end

function Base.showerror(io::IO, e::OverrideInitNoTolerance)
    return print(
        io,
        "Tolerances were not provided to `OverrideInit`. `$(e.tolerance)` must be provided as a keyword argument to `get_initial_values` or as a keyword argument to the `OverrideInit` constructor."
    )
end

"""
Utility function to evaluate the RHS, using the integrator's `tmp_cache` if
it is in-place or simply calling the function if not.
"""
function _evaluate_f(integrator, f, isinplace::Val{true}, args...)
    tmp = first(get_tmp_cache(integrator))
    f(tmp, args...)
    return tmp
end

function _evaluate_f(integrator, f, isinplace::Val{false}, args...)
    return f(args...)
end

"""
Utility function to evaluate the RHS, adding extra arguments (such as history function for
DDEs) wherever necessary.
"""
function evaluate_f(integrator::DEIntegrator, prob, f, isinplace, u, p, t)
    return _evaluate_f(integrator, f, isinplace, u, p, t)
end

function evaluate_f(
        integrator::DEIntegrator, prob::AbstractDAEProblem, f, isinplace, u, p, t
    )
    return _evaluate_f(integrator, f, isinplace, integrator.du, u, p, t)
end

function evaluate_f(
        integrator::AbstractDDEIntegrator, prob::AbstractDDEProblem, f, isinplace, u, p, t
    )
    return _evaluate_f(integrator, f, isinplace, u, get_history_function(integrator), p, t)
end

function evaluate_f(
        integrator::AbstractSDDEIntegrator,
        prob::AbstractSDDEProblem, f, isinplace, u, p, t
    )
    return _evaluate_f(integrator, f, isinplace, u, get_history_function(integrator), p, t)
end

"""
    $(TYPEDSIGNATURES)

A utility function equivalent to `Base.vec` but also handles `Number` and
`AbstractSciMLScalarOperator`.
"""
_vec(v) = vec(v)
_vec(v::Number) = v
_vec(v::SciMLOperators.AbstractSciMLScalarOperator) = v
_vec(v::AbstractVector) = v

"""
    $(TYPEDSIGNATURES)

Check if the algebraic constraints are satisfied, and error if they aren't. Returns
the `u0` and `p` as-is, and is always successful if it returns. Valid only for
`AbstractDEProblem` and `AbstractDAEProblem`. Requires a `DEIntegrator` as its second argument.

Keyword arguments:

  - `abstol`: The absolute value below which the norm of the residual of algebraic equations
    should lie. The norm function used is `integrator.opts.internalnorm` if present, and
    `LinearAlgebra.norm` if not.
"""
function get_initial_values(
        prob::AbstractDEProblem, integrator::DEIntegrator, f, alg::CheckInit,
        isinplace::Union{Val{true}, Val{false}}; abstol, kwargs...
    )
    u0 = state_values(integrator)
    p = parameter_values(integrator)
    t = current_time(integrator)
    M = f.mass_matrix

    M == I && return u0, p, true
    algebraic_vars = [all(iszero, x) for x in eachcol(M)]
    algebraic_eqs = [all(iszero, x) for x in eachrow(M)]
    (iszero(algebraic_vars) || iszero(algebraic_eqs)) && return u0, p, true
    update_coefficients!(M, u0, p, t)
    tmp = evaluate_f(integrator, prob, f, isinplace, u0, p, t)
    tmp .= ArrayInterface.restructure(tmp, algebraic_eqs .* _vec(tmp))

    normresid = isdefined(integrator.opts, :internalnorm) ?
        integrator.opts.internalnorm(tmp, t) : norm(tmp)
    if normresid > abstol
        throw(CheckInitFailureError(normresid, abstol, true))
    end
    return u0, p, true
end

function get_initial_values(
        prob::AbstractDAEProblem, integrator::DEIntegrator, f, alg::CheckInit,
        isinplace::Union{Val{true}, Val{false}}; abstol, kwargs...
    )
    u0 = state_values(integrator)
    p = parameter_values(integrator)
    t = current_time(integrator)

    resid = evaluate_f(integrator, prob, f, isinplace, u0, p, t)
    normresid = isdefined(integrator.opts, :internalnorm) ?
        integrator.opts.internalnorm(resid, t) : norm(resid)

    if normresid > abstol
        throw(CheckInitFailureError(normresid, abstol, false))
    end
    return u0, p, true
end

"""
    $(TYPEDSIGNATURES)

Solve a `NonlinearProblem`/`NonlinearLeastSquaresProblem` to obtain the initial `u0` and
`p`. Requires that `f` have the field `initialization_data` which is an `OverrideInitData`.
If the field is absent or the value is `nothing`, return `u0` and `p` successfully as-is.

The success value returned depends on the success of the nonlinear solve.

Keyword arguments:

  - `nlsolve_alg`: The NonlinearSolve.jl algorithm to use. If not provided, this function will
    throw an error.
  - `abstol`, `reltol`: The `abstol` (`reltol`) to use for the nonlinear solve. The value
    provided to the `OverrideInit` constructor takes priority over this keyword argument.
    If the former is `nothing`, this keyword argument will be used. If it is also not provided,
    an error will be thrown.

All additional keyword arguments are forwarded to `solve`.

In case the initialization problem is trivial, `nlsolve_alg`, `abstol` and `reltol` are
not required. `solve` is also not called.
"""
function get_initial_values(
        prob, valp, f, alg::OverrideInit,
        iip::Union{Val{true}, Val{false}}; nlsolve_alg = nothing, abstol = nothing, reltol = nothing, kwargs...
    )
    u0 = state_values(valp)
    p = parameter_values(valp)

    if !has_initialization_data(f)
        return u0, p, true
    end

    initdata::OverrideInitData = f.initialization_data
    initprob = initdata.initializeprob

    if initdata.update_initializeprob! !== nothing
        if initdata.is_update_oop === Val(true)
            initprob = initdata.update_initializeprob!(initprob, valp)
        else
            initdata.update_initializeprob!(initprob, valp)
        end
    end

    if is_trivial_initialization(initdata)
        nlsol = initprob
        success = true
    else
        nlsolve_alg = something(nlsolve_alg, alg.nlsolve, Some(nothing))
        if alg.abstol !== nothing
            _abstol = alg.abstol
        elseif abstol !== nothing
            _abstol = abstol
        else
            throw(OverrideInitNoTolerance(:abstol))
        end
        if alg.reltol !== nothing
            _reltol = alg.reltol
        elseif reltol !== nothing
            _reltol = reltol
        else
            throw(OverrideInitNoTolerance(:reltol))
        end
        nlsol = solve(initprob, nlsolve_alg; abstol = _abstol, reltol = _reltol, kwargs...)

        success = if initprob isa NonlinearLeastSquaresProblem
            # Do not accept StalledSuccess as a solution
            # A good local minima is not a success
            resid = nlsol.resid
            normresid = norm(resid)
            SciMLBase.successful_retcode(nlsol) && normresid <= abstol
        else
            SciMLBase.successful_retcode(nlsol)
        end
    end

    if initdata.initializeprobmap !== nothing
        u02 = initdata.initializeprobmap(nlsol)
    end
    if initdata.initializeprobpmap !== nothing
        p2 = initdata.initializeprobpmap(valp, nlsol)
    end

    # specifically needs to be written this way for Zygote
    # See https://github.com/SciML/ModelingToolkit.jl/pull/3585#issuecomment-2883919162
    u03 = isnothing(initdata.initializeprobmap) ? u0 : u02
    p3 = isnothing(initdata.initializeprobpmap) ? p : p2

    return u03, p3, success
end

"""
    $(TYPEDSIGNATURES)

Do not run any initialization routine, and simply return the state and parameter values
stored in `integrator` successfully.
"""
function get_initial_values(prob, integrator, f, ::NoInit, iip; kwargs...)
    return state_values(integrator), parameter_values(integrator), true
end

is_trivial_initialization(::Nothing) = true

function is_trivial_initialization(initdata::OverrideInitData)
    return !(initdata.initializeprob isa Union{NonlinearLeastSquaresProblem, SCCNonlinearProblem{Nothing}}) &&
        state_values(initdata.initializeprob) === nothing
end

function is_trivial_initialization(f::AbstractSciMLFunction)
    return has_initialization_data(f) && is_trivial_initialization(f.initialization_data)
end

function is_trivial_initialization(prob::AbstractSciMLProblem)
    return is_trivial_initialization(prob.f)
end

@enum DETERMINED_STATUS OVERDETERMINED FULLY_DETERMINED UNDERDETERMINED

function initialization_status(prob::AbstractSciMLProblem)
    has_initialization_data(prob.f) || return nothing

    iprob = prob.f.initialization_data.initializeprob
    isnothing(prob) && return nothing

    iu0 = state_values(iprob)
    nunknowns = iu0 === nothing ? 0 : length(iu0)
    neqs = if __has_resid_prototype(iprob.f) && iprob.f.resid_prototype !== nothing
        length(iprob.f.resid_prototype)
    else
        nunknowns
    end

    if neqs > nunknowns
        return OVERDETERMINED
    elseif neqs < nunknowns
        return UNDERDETERMINED
    else
        return FULLY_DETERMINED
    end
end

"""
$(TYPEDEF)

Statistics from the differential equation solver about the solution process.

## Fields

  - `nf`: Number of function evaluations. If the differential equation is a split function,
    such as a `SplitFunction` for implicit-explicit (IMEX) integration, then `nf` is the
    number of function evaluations for the first function (the implicit function)
  - `nf2`: If the differential equation is a split function, such as a `SplitFunction`
    for implicit-explicit (IMEX) integration, then `nf2` is the number of function
    evaluations for the second function, i.e. the function treated explicitly. Otherwise
    it is zero.
  - `nw`: The number of `W=I-gamma*J` (or `W=I/gamma-J`) matrices constructed
    during the solving process.
  - `nsolve`: The number of linear solves `W\\b` required for the integration.
  - `njacs`: Number of Jacobians calculated during the integration.
  - `nnonliniter`: Total number of iterations for the nonlinear solvers.
  - `nnonlinconvfail`: Number of nonlinear solver convergence failures.
  - `ncondition`: Number of calls to the condition function for callbacks.
  - `naccept`: Number of accepted steps.
  - `nreject`: Number of rejected steps.
  - `maxeig`: Maximum eigenvalue over the solution. This is only computed if the
    method is an auto-switching algorithm.
"""
mutable struct DEStats
    nf::Int
    nf2::Int
    nw::Int
    nsolve::Int
    njacs::Int
    nnonliniter::Int
    nnonlinconvfail::Int
    nfpiter::Int
    nfpconvfail::Int
    ncondition::Int
    naccept::Int
    nreject::Int
    maxeig::Float64
end

DEStats(x::Int = -1) = DEStats(x, x, x, x, x, x, x, x, x, x, x, x, 0.0)

function Base.show(io::IO, ::MIME"text/plain", s::DEStats)
    println(io, summary(s))
    @printf io "%-50s %-d\n" "Number of function 1 evaluations:" s.nf
    @printf io "%-50s %-d\n" "Number of function 2 evaluations:" s.nf2
    @printf io "%-50s %-d\n" "Number of W matrix evaluations:" s.nw
    @printf io "%-50s %-d\n" "Number of linear solves:" s.nsolve
    @printf io "%-50s %-d\n" "Number of Jacobians created:" s.njacs
    @printf io "%-50s %-d\n" "Number of nonlinear solver iterations:" s.nnonliniter
    @printf io "%-50s %-d\n" "Number of nonlinear solver convergence failures:" s.nnonlinconvfail
    @printf io "%-50s %-d\n" "Number of fixed-point solver iterations:" s.nfpiter
    @printf io "%-50s %-d\n" "Number of fixed-point solver convergence failures:" s.nfpconvfail
    @printf io "%-50s %-d\n" "Number of rootfind condition calls:" s.ncondition
    @printf io "%-50s %-d\n" "Number of accepted steps:" s.naccept
    @printf io "%-50s %-d" "Number of rejected steps:" s.nreject
    return iszero(s.maxeig) || @printf io "\n%-50s %-e" "Maximum eigenvalue recorded:" s.maxeig
end

function Base.merge(a::DEStats, b::DEStats)
    return DEStats(
        a.nf + b.nf,
        a.nf2 + b.nf2,
        a.nw + b.nw,
        a.nsolve + b.nsolve,
        a.njacs + b.njacs,
        a.nnonliniter + b.nnonliniter,
        a.nnonlinconvfail + b.nnonlinconvfail,
        a.nfpiter + b.nfpiter,
        a.nfpconvfail + b.nfpconvfail,
        a.ncondition + b.ncondition,
        a.naccept + b.naccept,
        a.nreject + b.nreject,
        max(a.maxeig, b.maxeig)
    )
end

"""
$(TYPEDEF)

Representation of the solution to an ordinary differential equation defined by an ODEProblem.

## DESolution Interface

For more information on interacting with `DESolution` types, check out the Solution Handling
page of the DifferentialEquations.jl documentation.

<https://docs.sciml.ai/DiffEqDocs/stable/basics/solution/>

## Fields

  - `u`: the representation of the ODE solution. Given as an array of solutions, where `u[i]`
    corresponds to the solution at time `t[i]`. It is recommended in most cases one does not
    access `sol.u` directly and instead use the array interface described in the Solution
    Handling page of the DifferentialEquations.jl documentation.
  - `t`: the time points corresponding to the saved values of the ODE solution.
  - `prob`: the original ODEProblem that was solved.
  - `alg`: the algorithm type used by the solver.
  - `stats`: statistics of the solver, such as the number of function evaluations required,
    number of Jacobians computed, and more.
  - `retcode`: the return code from the solver. Used to determine whether the solver solved
    successfully, whether it terminated early due to a user-defined callback, or whether it
    exited due to an error. For more details, see
    [the return code documentation](https://docs.sciml.ai/SciMLBase/stable/interfaces/Solutions/#retcodes).
"""
struct ODESolution{
        T, N, uType, uType2, DType, tType, rateType, discType, P, A, IType, S,
        AC <: Union{Nothing, Vector{Int}}, R, O, V,
    } <:
    AbstractODESolution{T, N, uType}
    u::uType
    u_analytic::uType2
    errors::DType
    t::tType
    k::rateType
    discretes::discType
    prob::P
    alg::A
    interp::IType
    dense::Bool
    tslocation::Int
    stats::S
    alg_choice::AC
    retcode::ReturnCode.T
    resid::R
    original::O
    saved_subsystem::V
end

function ConstructionBase.constructorof(::Type{O}) where {T, N, O <: ODESolution{T, N}}
    return ODESolution{T, N}
end

function ConstructionBase.setproperties(sol::ODESolution, patch::NamedTuple)
    u = get(patch, :u, sol.u)
    N = u === nothing ? 2 : ndims(eltype(u)) + 1
    T = eltype(eltype(u))
    patch = merge(getproperties(sol), patch)
    return ODESolution{T, N}(
        patch.u, patch.u_analytic, patch.errors, patch.t, patch.k,
        patch.discretes, patch.prob, patch.alg, patch.interp, patch.dense, patch.tslocation, patch.stats,
        patch.alg_choice, patch.retcode, patch.resid, patch.original, patch.saved_subsystem
    )
end

Base.@propagate_inbounds function Base.getproperty(x::AbstractODESolution, s::Symbol)
    if s === :destats
        Base.depwarn("`sol.destats` is deprecated. Use `sol.stats` instead.", "sol.destats")
        return getfield(x, :stats)
    elseif s === :ps
        return ParameterIndexingProxy(x)
    end
    return getfield(x, s)
end

# FIXME: Remove the defaults for resid and original on a breaking release
function ODESolution{T, N}(
        u, u_analytic, errors, t, k, discretes, prob, alg, interp, dense,
        tslocation, stats, alg_choice, retcode, resid = nothing,
        original = nothing, saved_subsystem = nothing
    ) where {T, N}
    return ODESolution{
        T, N, typeof(u), typeof(u_analytic), typeof(errors), typeof(t),
        typeof(k), typeof(discretes), typeof(prob), typeof(alg), typeof(interp),
        typeof(stats), typeof(alg_choice), typeof(resid), typeof(original),
        typeof(saved_subsystem),
    }(
        u, u_analytic, errors, t, k, discretes, prob, alg, interp,
        dense, tslocation, stats, alg_choice, retcode, resid, original, saved_subsystem
    )
end

error_if_observed_derivative(_, _, ::Type{Val{0}}) = nothing
function error_if_observed_derivative(sys, idx, ::Type)
    return if symbolic_type(idx) != NotSymbolic() && is_observed(sys, idx) ||
            symbolic_type(idx) == NotSymbolic() && any(x -> is_observed(sys, x), idx)
        error(
            """
            Cannot interpolate derivatives of observed variables. A possible solution could be
            interpolating the symbolic expression that evaluates to the derivative of the
            observed variable or using DataInterpolations.jl.
            """
        )
    end
end

function SymbolicIndexingInterface.is_parameter_timeseries(::Type{S}) where {
        T1, T2, T3, T4, T5, T6, T7,
        S <: ODESolution{T1, T2, T3, T4, T5, T6, T7, <:ParameterTimeseriesCollection},
    }
    return Timeseries()
end

function _hold_discrete(disc_u, disc_t, t::Number)
    idx = searchsortedlast(disc_t, t)
    if idx == firstindex(disc_t) - 1
        error("Cannot access discrete variable at time $t before initial save $(first(disc_t))")
    end
    return disc_u[idx]
end

function hold_discrete(disc_u, disc_t, t::Number)
    val = _hold_discrete(disc_u, disc_t, t)
    return DiffEqArray([val], [t])
end

function hold_discrete(disc_u, disc_t, t::AbstractVector{<:Number})
    return DiffEqArray(_hold_discrete.((disc_u,), (disc_t,), t), t)
end

function get_interpolated_discretes(sol::AbstractODESolution, t, deriv, continuity)
    is_parameter_timeseries(sol) == Timeseries() || return nothing

    discs::ParameterTimeseriesCollection = RecursiveArrayTools.get_discretes(sol)
    interp_discs = map(discs) do partition
        hold_discrete(partition.u, partition.t, t)
    end
    return ParameterTimeseriesCollection(interp_discs, parameter_values(discs))
end

function is_discrete_expression(indp, expr)
    ts_idxs = get_all_timeseries_indexes(indp, expr)
    return length(ts_idxs) > 1 || length(ts_idxs) == 1 && only(ts_idxs) != ContinuousTimeseries()
end

function (sol::AbstractODESolution)(
        t, ::Type{deriv} = Val{0}; idxs = nothing,
        continuity = :left
    ) where {deriv}
    if t isa IndexedClock
        t = canonicalize_indexed_clock(t, sol)
    end
    return sol(t, deriv, idxs, continuity)
end
function (sol::AbstractODESolution)(
        v, t, ::Type{deriv} = Val{0}; idxs = nothing,
        continuity = :left
    ) where {deriv}
    if t isa IndexedClock
        t = canonicalize_indexed_clock(t, sol)
    end
    return sol.interp(v, t, idxs, deriv, sol.prob.p, continuity)
end

function (sol::AbstractODESolution)(
        t::Number, ::Type{deriv}, idxs::Nothing,
        continuity
    ) where {deriv}
    return sol.interp(t, idxs, deriv, sol.prob.p, continuity)
end

function (sol::AbstractODESolution)(
        t::AbstractVector{<:Number}, ::Type{deriv},
        idxs::Nothing, continuity
    ) where {deriv}
    discretes = get_interpolated_discretes(sol, t, deriv, continuity)
    return augment(sol.interp(t, idxs, deriv, sol.prob.p, continuity), sol; discretes)
end

function (sol::AbstractODESolution)(
        t::Number, ::Type{deriv}, idxs::Integer,
        continuity
    ) where {deriv}
    return sol.interp(t, idxs, deriv, sol.prob.p, continuity)
end
function (sol::AbstractODESolution)(
        t::Number, ::Type{deriv},
        idxs::AbstractVector{<:Integer},
        continuity
    ) where {deriv}
    if isempty(idxs)
        return eltype(eltype(sol.u))[]
    end
    if eltype(sol.u) <: Number
        idxs = only(idxs)
    end
    return sol.interp(t, idxs, deriv, sol.prob.p, continuity)
end
function (sol::AbstractODESolution)(
        t::AbstractVector{<:Number}, ::Type{deriv},
        idxs::Integer, continuity
    ) where {deriv}
    A = sol.interp(t, idxs, deriv, sol.prob.p, continuity)
    p = hasproperty(sol.prob, :p) ? sol.prob.p : nothing
    return DiffEqArray(A.u, A.t, p, sol)
end
function (sol::AbstractODESolution)(
        t::AbstractVector{<:Number}, ::Type{deriv},
        idxs::AbstractVector{<:Integer},
        continuity
    ) where {deriv}
    if isempty(idxs)
        return map(_ -> eltype(eltype(sol.u))[], t)
    end
    if eltype(sol.u) <: Number
        idxs = only(idxs)
    end
    A = sol.interp(t, idxs, deriv, sol.prob.p, continuity)
    p = hasproperty(sol.prob, :p) ? sol.prob.p : nothing
    return DiffEqArray(A.u, A.t, p, sol)
end

function (sol::AbstractODESolution)(
        t::Number, ::Type{deriv}, idxs,
        continuity
    ) where {deriv}
    symbolic_type(idxs) == NotSymbolic() && error("Incorrect specification of `idxs`")
    error_if_observed_derivative(sol, idxs, deriv)
    ps = parameter_values(sol)
    if is_parameter(sol, idxs) && !is_timeseries_parameter(sol, idxs)
        return getp(sol, idxs)(ps)
    end
    if is_parameter_timeseries(sol) == Timeseries() && is_discrete_expression(sol, idxs)
        discs::ParameterTimeseriesCollection = RecursiveArrayTools.get_discretes(sol)
        ps = parameter_values(discs)
        for ts_idx in eachindex(discs)
            partition = discs[ts_idx]
            interp_val = _hold_discrete(partition.u, partition.t, t)
            ps = with_updated_parameter_timeseries_values(sol, ps, ts_idx => interp_val)
        end
    end
    state = ProblemState(; u = sol.interp(t, nothing, deriv, ps, continuity), p = ps, t)
    return getsym(sol, idxs)(state)
end

function (sol::AbstractODESolution)(
        t::Number, ::Type{deriv}, idxs::AbstractVector,
        continuity
    ) where {deriv}
    if symbolic_type(idxs) == NotSymbolic() &&
            any(isequal(NotSymbolic()), symbolic_type.(idxs))
        error("Incorrect specification of `idxs`")
    end
    if symbolic_type(idxs) == NotSymbolic() && isempty(idxs)
        return eltype(eltype(sol.u))[]
    end
    error_if_observed_derivative(sol, idxs, deriv)
    ps = parameter_values(sol)
    if is_parameter_timeseries(sol) == Timeseries() && is_discrete_expression(sol, idxs)
        discs::ParameterTimeseriesCollection = RecursiveArrayTools.get_discretes(sol)
        ps = parameter_values(discs)
        for ts_idx in eachindex(discs)
            partition = discs[ts_idx]
            interp_val = _hold_discrete(partition.u, partition.t, t)
            ps = with_updated_parameter_timeseries_values(sol, ps, ts_idx => interp_val)
        end
    end
    state = ProblemState(; u = sol.interp(t, nothing, deriv, ps, continuity), p = ps, t)
    return getsym(sol, idxs)(state)
end

function (sol::AbstractODESolution)(
        t::AbstractVector{<:Number}, ::Type{deriv}, idxs,
        continuity
    ) where {deriv}
    symbolic_type(idxs) == NotSymbolic() && error("Incorrect specification of `idxs`")
    error_if_observed_derivative(sol, idxs, deriv)
    p = hasproperty(sol.prob, :p) ? sol.prob.p : nothing
    getter = getsym(sol, idxs)
    if is_parameter_timeseries(sol) == NotTimeseries() || !is_discrete_expression(sol, idxs)
        interp_sol = augment(sol.interp(t, nothing, deriv, p, continuity), sol)
        return DiffEqArray(getter(interp_sol), t, p, sol)
    end
    discretes = get_interpolated_discretes(sol, t, deriv, continuity)
    interp_sol = sol.interp(t, nothing, deriv, p, continuity)
    u = map(eachindex(t)) do ti
        ps = parameter_values(discretes)
        for i in eachindex(discretes)
            ps = with_updated_parameter_timeseries_values(sol, ps, i => discretes[i, ti])
        end
        return getter(ProblemState(; u = interp_sol.u[ti], p = ps, t = t[ti]))
    end
    return DiffEqArray(u, t, p, sol; discretes)
end

function (sol::AbstractODESolution)(
        t::AbstractVector{<:Number}, ::Type{deriv},
        idxs::AbstractVector, continuity
    ) where {deriv}
    if symbolic_type(idxs) == NotSymbolic() && isempty(idxs)
        return map(_ -> eltype(eltype(sol.u))[], t)
    end
    error_if_observed_derivative(sol, idxs, deriv)
    p = hasproperty(sol.prob, :p) ? sol.prob.p : nothing
    getter = getsym(sol, idxs)
    if is_parameter_timeseries(sol) == NotTimeseries() || !is_discrete_expression(sol, idxs)
        interp_sol = augment(sol.interp(t, nothing, deriv, p, continuity), sol)
        return DiffEqArray(getter(interp_sol), t, p, sol)
    end
    discretes = get_interpolated_discretes(sol, t, deriv, continuity)
    interp_sol = sol.interp(t, nothing, deriv, p, continuity)
    u = map(eachindex(t)) do ti
        ps = parameter_values(discretes)
        for i in eachindex(discretes)
            ps = with_updated_parameter_timeseries_values(sol, ps, i => discretes[i, ti])
        end
        return getter(ProblemState(; u = interp_sol.u[ti], p = ps, t = t[ti]))
    end
    return DiffEqArray(u, t, p, sol; discretes)
end

struct DDESolutionHistoryWrapper{T}
    sol::T
end

function (w::DDESolutionHistoryWrapper)(p, t; idxs = nothing)
    return w.sol(t; idxs)
end
function (w::DDESolutionHistoryWrapper)(out, p, t; idxs = nothing)
    return w.sol(out, t; idxs)
end
function (w::DDESolutionHistoryWrapper)(p, t, deriv::Type{Val{i}}; idxs = nothing) where {i}
    return w.sol(t, deriv; idxs)
end
function (w::DDESolutionHistoryWrapper)(
        out, p, t, deriv::Type{Val{i}}; idxs = nothing
    ) where {i}
    return w.sol(out, t, deriv; idxs)
end

function SymbolicIndexingInterface.get_history_function(sol::AbstractODESolution)
    return DDESolutionHistoryWrapper(sol)
end

# public API, used by MTK
"""
    create_parameter_timeseries_collection(sys, ps, tspan)

Create a `SymbolicIndexingInterface.ParameterTimeseriesCollection` for the given system
`sys` and parameter object `ps`. Return `nothing` if there are no timeseries parameters.
Defaults to `nothing`. Falls back on the basis of `symbolic_container`.
"""
function create_parameter_timeseries_collection(sys, ps, tspan)
    if hasmethod(symbolic_container, Tuple{typeof(sys)})
        return create_parameter_timeseries_collection(symbolic_container(sys), ps, tspan)
    else
        return nothing
    end
end

const PeriodicDiffEqArray = DiffEqArray{T, N, A, B} where {T, N, A, B <: AbstractRange}

# public API, used by MTK
"""
    get_saveable_values(sys, ps, timeseries_idx)

Return the values to be saved in parameter object `ps` for timeseries index `timeseries_idx`. Called by
`save_discretes!`. If this returns `nothing`, `save_discretes!` will not save anything.
"""
function get_saveable_values(sys, ps, timeseries_idx)
    return get_saveable_values(symbolic_container(sys), ps, timeseries_idx)
end

"""
    save_discretes!(integ::DEIntegrator, timeseries_idx)

Save the parameter timeseries with index `timeseries_idx`. Calls `get_saveable_values` to
get the values to save. If it returns `nothing`, then the save does not happen.
"""
function save_discretes!(integ::DEIntegrator, timeseries_idx; skip_duplicates = false)
    inner_sol = get_sol(integ)
    vals = get_saveable_values(inner_sol, parameter_values(integ), timeseries_idx)
    vals === nothing && return
    return save_discretes!(integ.sol, current_time(integ), vals, timeseries_idx; skip_duplicates)
end

save_discretes!(args...) = nothing

# public API, used by MTK
function save_discretes!(sol::AbstractODESolution, t, vals, timeseries_idx; skip_duplicates = false)
    RecursiveArrayTools.has_discretes(sol) || return
    disc = RecursiveArrayTools.get_discretes(sol)
    return _save_discretes_internal!(disc[timeseries_idx], t, vals; skip_duplicates)
end

function _save_discretes_internal!(A::AbstractDiffEqArray, t, vals; skip_duplicates = false)
    if skip_duplicates && !isempty(A.t) && isequal(t, A.t[end])
        return
    end
    push!(A.t, t)
    return push!(A.u, vals)
end

function _save_discretes_internal!(A::PeriodicDiffEqArray, t, vals; skip_duplicates = false)
    if skip_duplicates && !isempty(A.u) && isequal(A.t[length(A.u)], t)
        return
    end
    idx = length(A.u) + 1
    if A.t[idx] ≉ t
        error("Tried to save periodic discrete value with timeseries $(A.t) at time $t")
    end
    return push!(A.u, vals)
end

function build_solution(
        prob::Union{AbstractODEProblem, AbstractDDEProblem},
        alg, t, u; timeseries_errors = length(u) > 2,
        dense = false, dense_errors = dense,
        calculate_error = true,
        k = nothing,
        alg_choice = nothing,
        interp = LinearInterpolation(t, u),
        retcode = ReturnCode.Default, destats = missing, stats = nothing,
        resid = nothing, original = nothing,
        saved_subsystem = nothing,
        kwargs...
    )
    T = eltype(eltype(u))

    if prob.u0 === nothing
        N = 2
    elseif prob isa BVProblem && !hasmethod(size, Tuple{typeof(prob.u0)})
        __u0 = hasmethod(prob.u0, Tuple{typeof(prob.p), typeof(first(prob.tspan))}) ?
            prob.u0(prob.p, first(prob.tspan)) : prob.u0(first(prob.tspan))
        N = length((size(__u0)..., length(u)))
    else
        N = ndims(eltype(u)) + 1
    end

    if prob.f isa Tuple
        f = prob.f[1]
    else
        f = prob.f
    end

    if !ismissing(destats)
        msg = "`destats` kwarg has been deprecated in favor of `stats`"
        if stats !== nothing
            msg *= " `stats` kwarg is also provided, ignoring `destats` kwarg."
        else
            stats = destats
        end
        Base.depwarn(msg, :build_solution)
    end

    ps = parameter_values(prob)
    if has_sys(prob.f)
        sswf = if saved_subsystem === nothing
            prob.f.sys
        else
            SavedSubsystemWithFallback(saved_subsystem, prob.f.sys)
        end
        discretes = create_parameter_timeseries_collection(sswf, ps, prob.tspan)
    else
        discretes = nothing
    end
    if has_analytic(f)
        u_analytic = Vector{typeof(prob.u0)}()
        errors = Dict{Symbol, real(eltype(prob.u0))}()
        sol = ODESolution{T, N}(
            u,
            u_analytic,
            errors,
            t, k,
            discretes,
            prob,
            alg,
            interp,
            dense,
            0,
            stats,
            alg_choice,
            retcode,
            resid,
            original,
            saved_subsystem
        )
        if calculate_error
            calculate_solution_errors!(
                sol; timeseries_errors = timeseries_errors,
                dense_errors = dense_errors
            )
        end
        return sol
    else
        return ODESolution{T, N}(
            u,
            nothing,
            nothing,
            t, k,
            discretes,
            prob,
            alg,
            interp,
            dense,
            0,
            stats,
            alg_choice,
            retcode,
            resid,
            original,
            saved_subsystem
        )
    end
end

function calculate_solution_errors!(
        sol::AbstractODESolution; fill_uanalytic = true,
        timeseries_errors = true, dense_errors = true
    )
    f = sol.prob.f

    if fill_uanalytic
        for i in 1:size(sol.u, 1)
            if sol.prob isa AbstractDDEProblem
                push!(
                    sol.u_analytic,
                    f.analytic(sol.prob.u0, sol.prob.h, sol.prob.p, sol.t[i])
                )
            else
                push!(sol.u_analytic, f.analytic(sol.prob.u0, sol.prob.p, sol.t[i]))
            end
        end
    end

    save_everystep = length(sol.u) > 2
    return if !isempty(sol.u_analytic)
        sol.errors[:final] = norm(recursive_mean(abs.(sol.u[end] .- sol.u_analytic[end])))

        if save_everystep && timeseries_errors
            sol.errors[:l∞] = norm(
                maximum(
                    vecvecapply(
                        (x) -> abs.(x),
                        sol.u - sol.u_analytic
                    )
                )
            )
            sol.errors[:l2] = norm(
                sqrt(
                    recursive_mean(
                        vecvecapply(
                            (x) -> float.(x) .^ 2,
                            sol.u - sol.u_analytic
                        )
                    )
                )
            )
            if sol.dense && dense_errors
                densetimes = collect(range(sol.t[1], stop = sol.t[end], length = 100))
                interp_u = sol(densetimes)
                interp_analytic = VectorOfArray(
                    [
                        f.analytic(sol.prob.u0, sol.prob.p, t)
                            for t in densetimes
                    ]
                )
                sol.errors[:L∞] = norm(
                    maximum(
                        vecvecapply(
                            (x) -> abs.(x),
                            interp_u - interp_analytic
                        )
                    )
                )
                sol.errors[:L2] = norm(
                    sqrt(
                        recursive_mean(
                            vecvecapply(
                                (x) -> float.(x) .^ 2,
                                interp_u -
                                    interp_analytic
                            )
                        )
                    )
                )
            end
        end
    end
end

function build_solution(sol::ODESolution{T, N}, u_analytic, errors) where {T, N}
    @reset sol.u_analytic = u_analytic
    return @set sol.errors = errors
end

function solution_new_retcode(sol::ODESolution{T, N}, retcode) where {T, N}
    return @set sol.retcode = retcode
end

function solution_new_tslocation(sol::ODESolution{T, N}, tslocation) where {T, N}
    return @set sol.tslocation = tslocation
end

function solution_new_original_retcode(
        sol::ODESolution{T, N}, original, retcode, resid
    ) where {T, N}
    @reset sol.original = original
    @reset sol.retcode = retcode
    return @set sol.resid = resid
end

function solution_slice(sol::ODESolution{T, N}, I) where {T, N}
    @reset sol.u = sol.u[I]
    @reset sol.u_analytic = sol.u_analytic === nothing ? nothing : sol.u_analytic[I]
    @reset sol.t = sol.t[I]
    @reset sol.k = sol.dense ? sol.k[I] : sol.k
    return @set sol.dense = false
end

mask_discretes(::Nothing, _, _...) = nothing

function mask_discretes(
        discretes::ParameterTimeseriesCollection, new_t, ::Union{Int, CartesianIndex}
    )
    masked_discretes = map(discretes) do disc
        i = searchsortedlast(disc.t, new_t)
        disc[i:i]
    end
    return ParameterTimeseriesCollection(masked_discretes, parameter_values(discretes))
end

function mask_discretes(discretes::ParameterTimeseriesCollection, new_t, ::AbstractRange)
    mint, maxt = extrema(new_t)
    masked_discretes = map(discretes) do disc
        mini = searchsortedfirst(disc.t, mint)
        maxi = searchsortedlast(disc.t, maxt)
        disc[mini:maxi]
    end
    return ParameterTimeseriesCollection(masked_discretes, parameter_values(discretes))
end

function mask_discretes(discretes::ParameterTimeseriesCollection, new_t, _)
    masked_discretes = map(discretes) do disc
        idxs = map(new_t) do t
            searchsortedlast(disc.t, t)
        end
        disc[idxs]
    end
    return ParameterTimeseriesCollection(masked_discretes, parameter_values(discretes))
end

function sensitivity_solution(sol::ODESolution, u, t)
    T = eltype(eltype(u))

    # handle save_idxs
    u0 = first(u)
    if u0 isa Number
        N = 1
    else
        N = length((size(u0)..., length(u)))
    end

    interp = enable_interpolation_sensitivitymode(sol.interp)
    @reset sol.u = u
    @reset sol.t = t isa Vector ? t : collect(t)
    return @set sol.interp = interp
end

struct LazyInterpolationException <: Exception
    var::Symbol
end

function Base.showerror(io::IO, e::LazyInterpolationException)
    return print(
        io, "The algorithm", e.var,
        " uses lazy interpolation, which is incompatible with `strip_solution`."
    )
end

function strip_solution(sol::ODESolution; strip_alg = false)
    if sol.alg !== nothing && has_lazy_interpolation(sol.alg)
        throw(LazyInterpolationException(nameof(typeof(sol.alg))))
    end

    interp = strip_interpolation(sol.interp)

    @reset sol.interp = interp

    @reset sol.prob = (; p = nothing)

    if strip_alg
        @reset sol.alg = nothing
    end

    return sol
end

function enable_interpolation_sensitivitymode end

enable_interpolation_sensitivitymode(interp::Nothing) = nothing

# Pass through should be deprecated in the future, made for backwards compat
enable_interpolation_sensitivitymode(interp::AbstractDiffEqInterpolation) = interp
struct SensitivityInterpolation end

"""
$(TYPEDEF)
"""
struct HermiteInterpolation{T1, T2, T3} <: AbstractDiffEqInterpolation
    t::T1
    u::T2
    du::T3
    sensitivitymode::Bool
end

function HermiteInterpolation(t, u, du; sensitivitymode = false)
    return HermiteInterpolation(t, u, du, sensitivitymode)
end

function enable_interpolation_sensitivitymode(interp::HermiteInterpolation)
    return HermiteInterpolation(interp.t, interp.u, interp.du, true)
end

"""
$(TYPEDEF)
"""
struct LinearInterpolation{T1, T2} <: AbstractDiffEqInterpolation
    t::T1
    u::T2
    sensitivitymode::Bool
end

function LinearInterpolation(t, u; sensitivitymode = false)
    return LinearInterpolation(t, u, sensitivitymode)
end

function enable_interpolation_sensitivitymode(interp::LinearInterpolation)
    return LinearInterpolation(interp.t, interp.u, true)
end

"""
$(TYPEDEF)
"""
struct ConstantInterpolation{T1, T2} <: AbstractDiffEqInterpolation
    t::T1
    u::T2
    sensitivitymode::Bool
end

function ConstantInterpolation(t, u; sensitivitymode = false)
    return ConstantInterpolation(t, u, sensitivitymode)
end

function enable_interpolation_sensitivitymode(interp::ConstantInterpolation)
    return ConstantInterpolation(interp.t, interp.u, true)
end

interp_summary(::AbstractDiffEqInterpolation) = "Unknown"
interp_summary(::HermiteInterpolation) = "3rd order Hermite"
interp_summary(::LinearInterpolation) = "1st order linear"
interp_summary(::ConstantInterpolation) = "Piecewise constant interpolation"
interp_summary(::Nothing) = "No interpolation"
interp_summary(sol::AbstractSciMLSolution) = interp_summary(sol.interp)

const SENSITIVITY_INTERP_MESSAGE = """
Standard interpolation is disabled due to sensitivity analysis being
used for the gradients. Only linear and constant interpolations are
compatible with non-AD sensitivity analysis calculations. Either
utilize tooling like saveat to avoid post-solution interpolation, use
the keyword argument dense=false for linear or constant interpolations,
or use the keyword argument sensealg=SensitivityADPassThrough() to revert
to AD-based derivatives.
"""

function (id::HermiteInterpolation)(tvals, idxs, deriv, p, continuity::Symbol = :left)
    return interpolation(tvals, id, idxs, deriv, p, continuity)
end
function (id::HermiteInterpolation)(val, tvals, idxs, deriv, p, continuity::Symbol = :left)
    return interpolation!(val, tvals, id, idxs, deriv, p, continuity)
end
function (id::LinearInterpolation)(tvals, idxs, deriv, p, continuity::Symbol = :left)
    return interpolation(tvals, id, idxs, deriv, p, continuity)
end
function (id::LinearInterpolation)(val, tvals, idxs, deriv, p, continuity::Symbol = :left)
    return interpolation!(val, tvals, id, idxs, deriv, p, continuity)
end
function (id::ConstantInterpolation)(tvals, idxs, deriv, p, continuity::Symbol = :left)
    return interpolation(tvals, id, idxs, deriv, p, continuity)
end
function (id::ConstantInterpolation)(val, tvals, idxs, deriv, p, continuity::Symbol = :left)
    return interpolation!(val, tvals, id, idxs, deriv, p, continuity)
end

@inline function interpolation(
        tvals, id::I, idxs, deriv::D, p,
        continuity::Symbol = :left
    ) where {I, D}
    t = id.t
    u = id.u
    id isa HermiteInterpolation && (du = id.du)
    tdir = sign(t[end] - t[1])
    idx = sortperm(tvals, rev = tdir < 0)
    i = 2 # Start the search thinking it's between t[1] and t[2]
    t[end] == t[1] && (tvals[idx[1]] != t[1] || tvals[idx[end]] != t[1]) &&
        error("Solution interpolation cannot extrapolate from a single timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tvals[idx[end]] > tdir * t[end] &&
        error("Solution interpolation cannot extrapolate past the final timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tvals[idx[1]] < tdir * t[1] &&
        error("Solution interpolation cannot extrapolate before the first timepoint. Either start solving earlier or use the local extrapolation from the integrator interface.")
    if idxs isa Number
        vals = Vector{eltype(first(u))}(undef, length(tvals))
    elseif idxs isa AbstractVector
        vals = Vector{Vector{eltype(first(u))}}(undef, length(tvals))
    else
        vals = Vector{eltype(u)}(undef, length(tvals))
    end
    for j in idx
        tval = tvals[j]
        i = searchsortedfirst(@view(t[i:end]), tval, rev = tdir < 0) + i - 1 # It's in the interval t[i-1] to t[i]
        avoid_constant_ends = deriv != Val{0} #|| tval isa ForwardDiff.Dual
        avoid_constant_ends && i == 1 && (i += 1)
        if !avoid_constant_ends && t[i - 1] == tval # Can happen if it's the first value!
            if idxs === nothing
                vals[j] = u[i - 1]
            else
                vals[j] = u[i - 1][idxs]
            end
        elseif !avoid_constant_ends && t[i] == tval
            lasti = lastindex(t)
            k = continuity == :right && i + 1 <= lasti && t[i + 1] == tval ? i + 1 : i
            if idxs === nothing
                vals[j] = u[k]
            else
                vals[j] = u[k][idxs]
            end
        else
            id.sensitivitymode && error(SENSITIVITY_INTERP_MESSAGE)
            dt = t[i] - t[i - 1]
            Θ = (tval - t[i - 1]) / dt
            idxs_internal = idxs
            if id isa HermiteInterpolation
                vals[j] = interpolant(
                    Θ, id, dt, u[i - 1], u[i], du[i - 1], du[i],
                    idxs_internal, deriv
                )
            else
                vals[j] = interpolant(Θ, id, dt, u[i - 1], u[i], idxs_internal, deriv)
            end
        end
    end
    return DiffEqArray(vals, tvals)
end

"""
$(SIGNATURES)

Get the value at tvals where the solution is known at the
times t (sorted), with values u and derivatives ks
"""
@inline function interpolation!(
        vals, tvals, id::I, idxs, deriv::D, p,
        continuity::Symbol = :left
    ) where {I, D}
    t = id.t
    u = id.u
    id isa HermiteInterpolation && (du = id.du)
    tdir = sign(t[end] - t[1])
    idx = sortperm(tvals, rev = tdir < 0)
    i = 2 # Start the search thinking it's between t[1] and t[2]
    t[end] == t[1] && (tvals[idx[1]] != t[1] || tvals[idx[end]] != t[1]) &&
        error("Solution interpolation cannot extrapolate from a single timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tvals[idx[end]] > tdir * t[end] &&
        error("Solution interpolation cannot extrapolate past the final timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tvals[idx[1]] < tdir * t[1] &&
        error("Solution interpolation cannot extrapolate before the first timepoint. Either start solving earlier or use the local extrapolation from the integrator interface.")
    for j in idx
        tval = tvals[j]
        i = searchsortedfirst(@view(t[i:end]), tval, rev = tdir < 0) + i - 1 # It's in the interval t[i-1] to t[i]
        avoid_constant_ends = deriv != Val{0} #|| tval isa ForwardDiff.Dual
        avoid_constant_ends && i == 1 && (i += 1)
        if !avoid_constant_ends && t[i - 1] == tval # Can happen if it's the first value!
            if idxs === nothing
                vals[j] = u[i - 1]
            else
                vals[j] = u[i - 1][idxs]
            end
        elseif !avoid_constant_ends && t[i] == tval
            lasti = lastindex(t)
            k = continuity == :right && i + 1 <= lasti && t[i + 1] == tval ? i + 1 : i
            if idxs === nothing
                vals[j] = u[k]
            else
                vals[j] = u[k][idxs]
            end
        else
            id.sensitivitymode && error(SENSITIVITY_INTERP_MESSAGE)
            dt = t[i] - t[i - 1]
            Θ = (tval - t[i - 1]) / dt
            idxs_internal = idxs
            if eltype(u) <: Union{AbstractArray, ArrayPartition}
                if id isa HermiteInterpolation
                    interpolant!(
                        vals[j], Θ, id, dt, u[i - 1], u[i], du[i - 1], du[i],
                        idxs_internal, deriv
                    )
                else
                    interpolant!(vals[j], Θ, id, dt, u[i - 1], u[i], idxs_internal, deriv)
                end
            else
                if id isa HermiteInterpolation
                    vals[j] = interpolant(
                        Θ, id, dt, u[i - 1], u[i], du[i - 1], du[i],
                        idxs_internal, deriv
                    )
                else
                    vals[j] = interpolant(Θ, id, dt, u[i - 1], u[i], idxs_internal, deriv)
                end
            end
        end
    end
    return
end

"""
$(SIGNATURES)

Get the value at tval where the solution is known at the
times t (sorted), with values u and derivatives ks
"""
@inline function interpolation(
        tval::Number, id::I, idxs, deriv::D, p,
        continuity::Symbol = :left
    ) where {I, D}
    t = id.t
    u = id.u
    id isa HermiteInterpolation && (du = id.du)
    tdir = sign(t[end] - t[1])
    t[end] == t[1] && tval != t[end] &&
        error("Solution interpolation cannot extrapolate from a single timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tval > tdir * t[end] &&
        error("Solution interpolation cannot extrapolate past the final timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tval < tdir * t[1] &&
        error("Solution interpolation cannot extrapolate before the first timepoint. Either start solving earlier or use the local extrapolation from the integrator interface.")
    @inbounds i = searchsortedfirst(t, tval, rev = tdir < 0) # It's in the interval t[i-1] to t[i]
    avoid_constant_ends = deriv != Val{0} #|| tval isa ForwardDiff.Dual
    avoid_constant_ends && i == 1 && (i += 1)
    if !avoid_constant_ends && t[i] == tval
        lasti = lastindex(t)
        k = continuity == :right && i + 1 <= lasti && t[i + 1] == tval ? i + 1 : i
        if idxs === nothing
            val = u[k]
        else
            val = u[k][idxs]
        end
    elseif !avoid_constant_ends && t[i - 1] == tval # Can happen if it's the first value!
        if idxs === nothing
            val = u[i - 1]
        else
            val = u[i - 1][idxs]
        end
    else
        id.sensitivitymode && error(SENSITIVITY_INTERP_MESSAGE)
        dt = t[i] - t[i - 1]
        Θ = (tval - t[i - 1]) / dt
        idxs_internal = idxs
        if id isa HermiteInterpolation
            val = interpolant(
                Θ, id, dt, u[i - 1], u[i], du[i - 1], du[i], idxs_internal,
                deriv
            )
        else
            val = interpolant(Θ, id, dt, u[i - 1], u[i], idxs_internal, deriv)
        end
    end
    return val
end

"""
$(SIGNATURES)

Get the value at tval where the solution is known at the
times t (sorted), with values u and derivatives ks
"""
@inline function interpolation!(
        out, tval::Number, id::I, idxs, deriv::D, p,
        continuity::Symbol = :left
    ) where {I, D}
    t = id.t
    u = id.u
    id isa HermiteInterpolation && (du = id.du)
    tdir = sign(t[end] - t[1])
    t[end] == t[1] && tval != t[end] &&
        error("Solution interpolation cannot extrapolate from a single timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tval > tdir * t[end] &&
        error("Solution interpolation cannot extrapolate past the final timepoint. Either solve on a longer timespan or use the local extrapolation from the integrator interface.")
    tdir * tval < tdir * t[1] &&
        error("Solution interpolation cannot extrapolate before the first timepoint. Either start solving earlier or use the local extrapolation from the integrator interface.")
    @inbounds i = searchsortedfirst(t, tval, rev = tdir < 0) # It's in the interval t[i-1] to t[i]
    avoid_constant_ends = deriv != Val{0} #|| tval isa ForwardDiff.Dual
    avoid_constant_ends && i == 1 && (i += 1)
    return if !avoid_constant_ends && t[i] == tval
        lasti = lastindex(t)
        k = continuity == :right && i + 1 <= lasti && t[i + 1] == tval ? i + 1 : i
        if idxs === nothing
            copy!(out, u[k])
        else
            copy!(out, u[k][idxs])
        end
    elseif !avoid_constant_ends && t[i - 1] == tval # Can happen if it's the first value!
        if idxs === nothing
            copy!(out, u[i - 1])
        else
            copy!(out, u[i - 1][idxs])
        end
    else
        id.sensitivitymode && error(SENSITIVITY_INTERP_MESSAGE)
        dt = t[i] - t[i - 1]
        Θ = (tval - t[i - 1]) / dt
        idxs_internal = idxs
        if id isa HermiteInterpolation
            interpolant!(
                out, Θ, id, dt, u[i - 1], u[i], du[i - 1], du[i], idxs_internal,
                deriv
            )
        else
            interpolant!(out, Θ, id, dt, u[i - 1], u[i], idxs_internal, deriv)
        end
    end
end

@inline function interpolant(
        Θ, id::AbstractDiffEqInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        ::Type{Val{D}}
    ) where {D}
    error("$(string(typeof(id))) for $(D)th order not implemented")
end
##################### Hermite Interpolants

"""
Hairer Norsett Wanner Solving Ordinary Differential Equations I - Nonstiff Problems Page 190

Hermite Interpolation
"""
@inline function interpolant(
        Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{0}}
    )
    if idxs === nothing
        out = @. (1 - Θ) * y₀ + Θ * y₁ +
            Θ * (Θ - 1) * ((1 - 2Θ) * (y₁ - y₀) + (Θ - 1) * dt * dy₀ + Θ * dt * dy₁)
    elseif idxs isa Number
        out = (1 - Θ) * y₀[idxs] + Θ * y₁[idxs] +
            Θ * (Θ - 1) *
            (
            (1 - 2Θ) * (y₁[idxs] - y₀[idxs]) +
                (Θ - 1) * dt * dy₀[idxs] + Θ * dt * dy₁[idxs]
        )
    else
        out = similar(y₀, axes(idxs))
        @views @. out = (1 - Θ) * y₀[idxs] + Θ * y₁[idxs] +
            Θ * (Θ - 1) *
            (
            (1 - 2Θ) * (y₁[idxs] - y₀[idxs]) +
                (Θ - 1) * dt * dy₀[idxs] + Θ * dt * dy₁[idxs]
        )
    end
    return out
end

"""
Hermite Interpolation
"""
@inline function interpolant(
        Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{1}}
    )
    if idxs === nothing
        out = @. dy₀ +
            Θ * (
            -4 * dt * dy₀ - 2 * dt * dy₁ - 6 * y₀ +
                Θ * (3 * dt * dy₀ + 3 * dt * dy₁ + 6 * y₀ - 6 * y₁) + 6 * y₁
        ) / dt
    elseif idxs isa Number
        out = dy₀[idxs] +
            Θ * (
            -4 * dt * dy₀[idxs] -
                2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ * (
                3 * dt * dy₀[idxs] + 3 * dt * dy₁[idxs] +
                    6 * y₀[idxs] - 6 * y₁[idxs]
            ) + 6 * y₁[idxs]
        ) / dt
    else
        out = similar(y₀, axes(idxs))
        @views @. out = dy₀[idxs] +
            Θ * (
            -4 * dt * dy₀[idxs] -
                2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ * (
                3 * dt * dy₀[idxs] + 3 * dt * dy₁[idxs] +
                    6 * y₀[idxs] - 6 * y₁[idxs]
            ) + 6 * y₁[idxs]
        ) / dt
    end
    return out
end

"""
Hermite Interpolation
"""
@inline function interpolant(
        Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{2}}
    )
    if idxs === nothing
        out = @. (
            -4 * dt * dy₀ - 2 * dt * dy₁ - 6 * y₀ +
                Θ * (6 * dt * dy₀ + 6 * dt * dy₁ + 12 * y₀ - 12 * y₁) + 6 * y₁
        ) /
            (dt * dt)
    elseif idxs isa Number
        out = (
            -4 * dt * dy₀[idxs] - 2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ * (
                6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] + 12 * y₀[idxs] -
                    12 * y₁[idxs]
            ) + 6 * y₁[idxs]
        ) / (dt * dt)
    else
        out = similar(y₀, axes(idxs))
        @views @. out = (
            -4 * dt * dy₀[idxs] - 2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ * (
                6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] + 12 * y₀[idxs] -
                    12 * y₁[idxs]
            ) + 6 * y₁[idxs]
        ) / (dt * dt)
    end
    return out
end

"""
Hermite Interpolation
"""
@inline function interpolant(
        Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{3}}
    )
    if idxs === nothing
        out = @. (6 * dt * dy₀ + 6 * dt * dy₁ + 12 * y₀ - 12 * y₁) / (dt * dt * dt)
    elseif idxs isa Number
        out = (
            6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] +
                12 * y₀[idxs] - 12 * y₁[idxs]
        ) / (dt * dt * dt)
    else
        out = similar(y₀, axes(idxs))
        @views @. out = (
            6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] +
                12 * y₀[idxs] - 12 * y₁[idxs]
        ) / (dt * dt * dt)
    end
    return out
end

"""
Hairer Norsett Wanner Solving Ordinary Differential Euations I - Nonstiff Problems Page 190

Hermite Interpolation
"""
@inline function interpolant!(
        out, Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{0}}
    )
    if out === nothing
        return (1 - Θ) * y₀[idxs] + Θ * y₁[idxs] +
            Θ * (Θ - 1) *
            (
            (1 - 2Θ) * (y₁[idxs] - y₀[idxs]) + (Θ - 1) * dt * dy₀[idxs] +
                Θ * dt * dy₁[idxs]
        )
    elseif idxs === nothing
        @. out = (1 - Θ) * y₀ + Θ * y₁ +
            Θ * (Θ - 1) * ((1 - 2Θ) * (y₁ - y₀) + (Θ - 1) * dt * dy₀ + Θ * dt * dy₁)
    else
        @views @. out = (1 - Θ) * y₀[idxs] + Θ * y₁[idxs] +
            Θ * (Θ - 1) *
            (
            (1 - 2Θ) * (y₁[idxs] - y₀[idxs]) + (Θ - 1) * dt * dy₀[idxs] +
                Θ * dt * dy₁[idxs]
        )
    end
end

"""
Hermite Interpolation
"""
@inline function interpolant!(
        out, Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{1}}
    )
    if out === nothing
        return dy₀[idxs] +
            Θ * (
            -4 * dt * dy₀[idxs] - 2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ *
                (3 * dt * dy₀[idxs] + 3 * dt * dy₁[idxs] + 6 * y₀[idxs] - 6 * y₁[idxs]) +
                6 * y₁[idxs]
        ) / dt
    elseif idxs === nothing
        @. out = dy₀ +
            Θ * (
            -4 * dt * dy₀ - 2 * dt * dy₁ - 6 * y₀ +
                Θ * (3 * dt * dy₀ + 3 * dt * dy₁ + 6 * y₀ - 6 * y₁) + 6 * y₁
        ) / dt
    else
        @views @. out = dy₀[idxs] +
            Θ * (
            -4 * dt * dy₀[idxs] - 2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ * (
                3 * dt * dy₀[idxs] + 3 * dt * dy₁[idxs] + 6 * y₀[idxs] -
                    6 * y₁[idxs]
            ) + 6 * y₁[idxs]
        ) / dt
    end
end

"""
Hermite Interpolation
"""
@inline function interpolant!(
        out, Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{2}}
    )
    if out === nothing
        return (
            -4 * dt * dy₀[idxs] - 2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ *
                (6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] + 12 * y₀[idxs] - 12 * y₁[idxs]) +
                6 * y₁[idxs]
        ) / (dt * dt)
    elseif idxs === nothing
        @. out = (
            -4 * dt * dy₀ - 2 * dt * dy₁ - 6 * y₀ +
                Θ * (6 * dt * dy₀ + 6 * dt * dy₁ + 12 * y₀ - 12 * y₁) + 6 * y₁
        ) /
            (dt * dt)
    else
        @views @. out = (
            -4 * dt * dy₀[idxs] - 2 * dt * dy₁[idxs] - 6 * y₀[idxs] +
                Θ * (
                6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] + 12 * y₀[idxs] -
                    12 * y₁[idxs]
            ) + 6 * y₁[idxs]
        ) / (dt * dt)
    end
end

"""
Hermite Interpolation
"""
@inline function interpolant!(
        out, Θ, id::HermiteInterpolation, dt, y₀, y₁, dy₀, dy₁, idxs,
        T::Type{Val{3}}
    )
    if out === nothing
        return (6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] + 12 * y₀[idxs] - 12 * y₁[idxs]) /
            (dt * dt * dt)
    elseif idxs === nothing
        @. out = (6 * dt * dy₀ + 6 * dt * dy₁ + 12 * y₀ - 12 * y₁) / (dt * dt * dt)
    else
        @views @. out = (
            6 * dt * dy₀[idxs] + 6 * dt * dy₁[idxs] + 12 * y₀[idxs] -
                12 * y₁[idxs]
        ) / (dt * dt * dt)
    end
end

############################### Linear Interpolants

"""
Linear Interpolation
"""
@inline function interpolant(Θ, id::LinearInterpolation, dt, y₀, y₁, idxs, T::Type{Val{0}})
    Θm1 = (1 - Θ)
    if idxs === nothing
        out = @. Θm1 * y₀ + Θ * y₁
    elseif idxs isa Number
        out = Θm1 * y₀[idxs] + Θ * y₁[idxs]
    else
        out = similar(y₀, axes(idxs))
        @views @. out = Θm1 * y₀[idxs] + Θ * y₁[idxs]
    end
    return out
end

@inline function interpolant(Θ, id::LinearInterpolation, dt, y₀, y₁, idxs, T::Type{Val{1}})
    if idxs === nothing
        out = @. (y₁ - y₀) / dt
    elseif idxs isa Number
        out = (y₁[idxs] - y₀[idxs]) / dt
    else
        out = similar(y₀, axes(idxs))
        @views @. out = (y₁[idxs] - y₀[idxs]) / dt
    end
    return out
end

"""
Linear Interpolation
"""
@inline function interpolant!(
        out, Θ, id::LinearInterpolation, dt, y₀, y₁, idxs,
        T::Type{Val{0}}
    )
    Θm1 = (1 - Θ)
    if out === nothing
        return Θm1 * y₀[idxs] + Θ * y₁[idxs]
    elseif idxs === nothing
        @. out = Θm1 * y₀ + Θ * y₁
    else
        @views @. out = Θm1 * y₀[idxs] + Θ * y₁[idxs]
    end
end

"""
Linear Interpolation
"""
@inline function interpolant!(
        out, Θ, id::LinearInterpolation, dt, y₀, y₁, idxs,
        T::Type{Val{1}}
    )
    if out === nothing
        return (y₁[idxs] - y₀[idxs]) / dt
    elseif idxs === nothing
        @. out = (y₁ - y₀) / dt
    else
        @views @. out = (y₁[idxs] - y₀[idxs]) / dt
    end
end

############################### Linear Interpolants

"""
Constant Interpolation
"""
@inline function interpolant(
        Θ, id::ConstantInterpolation, dt, y₀, y₁, idxs,
        T::Type{Val{0}}
    )
    if idxs === nothing
        out = @. y₀
    elseif idxs isa Number
        out = y₀[idxs]
    else
        out = similar(y₀, axes(idxs))
        @views @. out = y₀[idxs]
    end
    return out
end

@inline function interpolant(
        Θ, id::ConstantInterpolation, dt, y₀, y₁, idxs,
        T::Type{Val{1}}
    )
    if idxs === nothing
        out = zeros(eltype(y₀), length(y₀))
    elseif idxs isa Number
        out = zero(eltype(y₀))
    else
        out = similar(y₀, axes(idxs))
        @views @. out = 0
    end
    return out
end

"""
Constant Interpolation
"""
@inline function interpolant!(
        out, Θ, id::ConstantInterpolation, dt, y₀, y₁, idxs,
        T::Type{Val{0}}
    )
    if out === nothing
        return y₀[idxs]
    elseif idxs === nothing
        @. out = y₀
    else
        @views @. out = y₀[idxs]
    end
end

"""
Constant Interpolation
"""
@inline function interpolant!(
        out, Θ, id::ConstantInterpolation, dt, y₀, y₁, idxs,
        T::Type{Val{1}}
    )
    if out === nothing
        return zeros(eltype(y₀), length(idxs))
    else
        @. out = 0
    end
end

"""
    strip_interpolation(id::AbstractDiffEqInterpolation)

Returns a copy of the interpolation stripped of its function, to accommodate serialization.
If the interpolation object has no function, returns the interpolation object as is.
"""
strip_interpolation(id::AbstractDiffEqInterpolation) = id
strip_interpolation(id::HermiteInterpolation) = id
strip_interpolation(id::LinearInterpolation) = id
strip_interpolation(id::ConstantInterpolation) = id

# Frequently Asked Questions

## What are the code styling rules for SciML?

All SciML libraries are supposed to follow [SciMLStyle](https://docs.sciml.ai/SciMLStyle/stable/).
Any deviation from that style is something to be fixed.

## Where do I find more information on the internals of some packages?

The [SciML Developer Documentation](https://docs.sciml.ai/DiffEqDevDocs/stable/) describes the internals
of some of the larger solver libraries at length.

## What are the community practices that SciML developers should use?

See [ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://docs.sciml.ai/ColPrac/stable/)

## Are there developer programs to help fund parties interested in helping develop SciML?

Yes! See [the SciML Developer Programs](https://sciml.ai/dev/) webpage.

# [SciMLProblems](@id scimlproblems)

The cornerstone of the SciML common interface is the problem type definition.
These definitions are the encoding of mathematical problems into a numerically
computable form.

### Note About Symbolics and ModelingToolkit

The symbolic analog to the problem interface is the ModelingToolkit `AbstractSystem`.
For example, `ODESystem` is the symbolic analog to `ODEProblem`. Each of these system
types have a method for constructing the associated problem and function types.

## Definition of the AbstractSciMLProblem Interface

The following standard principles should be adhered to across all
`AbstractSciMLProblem` instantiations.

### In-place Specification

Each `AbstractSciMLProblem` type can be called with an "is inplace" (iip) choice. For example:

```julia
ODEProblem(f, u0, tspan, p)
ODEProblem{iip}(f, u0, tspan, p)
```

which is a boolean for whether the function is in the inplace form (mutating to
change the first value). This is automatically determined using the methods table
but note that for full type-inferability of the `AbstractSciMLProblem` this iip-ness should
be specified.

Additionally, the functions are fully specialized to reduce the runtimes. If one
would instead like to not specialize on the functions to reduce compile time,
then one can set `recompile` to false.

### Specialization Levels

Specialization levels in problem definitions are used to control the amount of compilation
specialization is performed on the model functions in order to trade off between runtime
performance, simplicity, and compile-time performance. The default choice of specialization
is `AutoSpecialize`, which seeks to allow for using fully precompiled solvers in common
scenarios but falls back to a runtime-optimal approach when further customization is used.

Specialization levels are given as the second type parameter in `AbstractSciMLProblem`
constructors. For example, this is done via:

```julia
ODEProblem{iip, specialization}(f, u0, tspan, p)
```

Note that `iip` choice is required for specialization choices to be made.

#### Specialization Choices

```@docs
SciMLBase.AbstractSpecialization
SciMLBase.AutoSpecialize
SciMLBase.NoSpecialize
SciMLBase.FunctionWrapperSpecialize
SciMLBase.FullSpecialize
```

!!! note
    
    The specialization level must be precompile snooped in the appropriate solver
    package in order to enable the full precompilation and system image generation
    for zero-latency usage. By default, this is only done with `AutoSpecialize` and
    on types `u isa Vector{Float64}`, `eltype(tspan) isa Float64`, and
    `p isa Union{Vector{Float64}, SciMLBase.NullParameters}`. Precompilation snooping
    in the solvers can be done using the Preferences.jl setup on the appropriate
    solver. See the solver library's documentation for more details.

### Default Parameters

By default, `AbstractSciMLProblem` types use the `SciMLBase.NullParameters()` singleton to
define the absence of parameters by default. The reason is because this throws an
informative error if the parameter is used or accessed within the user's function,
for example, `p[1]` will throw an informative error about forgetting to pass
parameters.

### Keyword Argument Splatting

All `AbstractSciMLProblem` types allow for passing keyword arguments that would get forwarded
to the solver. The reason for this is that in many cases, like in `EnsembleProblem`
usage, a `AbstractSciMLProblem` might be associated with some solver configuration, such as a
callback or tolerance. Thus, for flexibility the extra keyword arguments to the
`AbstractSciMLProblem` are carried to the solver.

### `problem_type`

`AbstractSciMLProblem` types include a non-public API definition of `problem_type` which holds
a trait type corresponding to the way the `AbstractSciMLProblem` was constructed. For example,
if a `SecondOrderODEProblem` constructor is used, the returned problem is simply a
`ODEProblem` for interoperability with any `ODEProblem` algorithm. However, in this case
the `problem_type` will be populated with the `SecondOrderODEProblem` type, indicating
the original definition and extra structure.

### Remake

```@docs
remake
```

For problems that are created from a system (e.g. created through ModelingToolkit.jl) or
define a DSL using `SymbolicIndexingInterface.SymbolCache`, `remake` can accept symbolic
maps as `u0` or `p`. A symbolic map is a `Dict` or `Vector{<:Pair}` mapping symbols in
`u0` or `p` to their values. These values can be numeric, or expressions of other symbols.
Symbolic maps can be complete (specifying a value for each symbol in `u0` or `p`) or
partial. For a partial symbolic map, the values of remaining symbols are obtained through
the system's defaults (see `SymbolicIndexingInterface.default_values`) and the existing
values in the problem passed to `remake`.

If the system's defaults contain an expression for the missing symbol, that expression
will be used for the value (it is treated as a dependent initialization). Otherwise,
the existing value of that symbol in the problem passed to `remake` is used.

If `default_values = true` is passed as a keyword argument to `remake`, then the value
contained in the system's defaults is always preferred over the value in the problem.

For example, consider a problem `prob` with parameters `:a`, `:b`, `:c` having values
`1.0`, `2.0`, `3.0` respectively. Let us also assume that the system contains the
defaults `Dict(:a => :(2b), :c => 0.1)`. Then:

  - `remake(prob; p = [:b => 2.0])` will result in the values `4.0`, `2.0`, `3.0` for
    `:a`, `:b` and `:c` respectively. Note how the numeric default for `:c` was not
    respected.
  - `remake(prob; p = [:b => 2.0], use_defaults = true)` will result in the values `4.0`,
    `2.0`, `1.0` for `:a`, `:b` and `:c` respectively.
  - `remake(prob; p = [:b => 2.0, :a => 3.0])` will result in the values `3.0`, `2.0`,
    `3.0` for `:a`, `:b` and `:c` respectively. Note how the explicitly specified value for
    `:a` overrides the dependent default.

### Aliasing Specification

An `AbstractAliasSpecifier` is associated with each SciMLProblem type. Each holds fields specifying which variables to alias
when solving. For example, to tell an ODE solver to alias the `u0` array, you can use an `ODEAliases` object,
and the `alias_u0` keyword argument, e.g. `solve(prob,alias = ODEAliases(alias_u0 = true))`.

```@docs
SciMLBase.AbstractAliasSpecifier
SciMLBase.LinearAliasSpecifier
SciMLBase.NonlinearAliasSpecifier
SciMLBase.ODEAliasSpecifier
SciMLBase.SDEAliasSpecifier
SciMLBase.DDEAliasSpecifier
SciMLBase.SDDEAliasSpecifier
SciMLBase.BVPAliasSpecifier
SciMLBase.OptimizationAliasSpecifier
SciMLBase.IntegralAliasSpecifier
SciMLBase.DiscreteAliasSpecifier
```

## Problem Traits

```@docs
SciMLBase.isinplace(prob::SciMLBase.AbstractDEProblem)
SciMLBase.is_diagonal_noise
```

## AbstractSciMLProblem API

### Defaults and Preferences

`SpecializationLevel` at `SciMLBase` can be used to set the default specialization level. The following
shows how to set the specialization default to `FullSpecialize`:

```julia
using Preferences, UUIDs
set_preferences!(
    UUID("0bca4576-84f4-4d90-8ffe-ffa030f20462"), "SpecializationLevel" => "FullSpecialize")
```

The default is `AutoSpecialize`.

### Abstract SciMLProblems

```@docs
SciMLBase.AbstractSciMLProblem
SciMLBase.AbstractDEProblem
SciMLBase.AbstractLinearProblem
SciMLBase.AbstractNonlinearProblem
SciMLBase.AbstractIntegralProblem
SciMLBase.AbstractOptimizationProblem
SciMLBase.AbstractNoiseProblem
SciMLBase.AbstractODEProblem
SciMLBase.AbstractDiscreteProblem
SciMLBase.AbstractAnalyticalProblem
SciMLBase.AbstractRODEProblem
SciMLBase.AbstractSDEProblem
SciMLBase.AbstractDAEProblem
SciMLBase.AbstractDDEProblem
SciMLBase.AbstractConstantLagDDEProblem
SciMLBase.AbstractSecondOrderODEProblem
SciMLBase.AbstractBVProblem
SciMLBase.AbstractJumpProblem
SciMLBase.AbstractSDDEProblem
SciMLBase.AbstractConstantLagSDDEProblem
SciMLBase.AbstractPDEProblem
```

# The SciML Common Interface for Julia Equation Solvers

The SciML common interface ties together the numerical solvers of the Julia
package ecosystem into a single unified interface. It is designed for maximal
efficiency and parallelism, while incorporating essential features for large-scale
scientific machine learning such as differentiability, composability, and sparsity.

This documentation is made to pool together the docs of the various SciML libraries
to paint the overarching picture, establish development norms, and document the
shared/common functionality.

## Domains of SciML

The SciML common interface covers the following domains:

  - Linear systems (`LinearProblem`)
    
      + Direct methods for dense and sparse
      + Iterative solvers with preconditioning

  - Nonlinear Systems (`NonlinearProblem`)
    
      + Rootfinding for systems of nonlinear equations
  - Interval Nonlinear Systems
    
      + Bracketing rootfinders for nonlinear equations with interval bounds
  - Integrals (quadrature) (`IntegralProblem`)
  - Differential Equations
    
      + Discrete equations (function maps, discrete stochastic (Gillespie/Markov)
        simulations) (`DiscreteProblem`)
      + Ordinary differential equations (ODEs) (`ODEProblem`)
      + Split and Partitioned ODEs (Symplectic integrators, IMEX Methods) (`SplitODEProblem`)
      + Stochastic ordinary differential equations (SODEs or SDEs) (`SDEProblem`)
      + Stochastic differential-algebraic equations (SDAEs) (`SDEProblem` with mass matrices)
      + Random differential equations (RODEs or RDEs) (`RODEProblem`)
      + Differential algebraic equations (DAEs) (`DAEProblem` and `ODEProblem` with mass matrices)
      + Delay differential equations (DDEs) (`DDEProblem`)
      + Neutral, retarded, and algebraic delay differential equations (NDDEs, RDDEs, and DDAEs)
      + Stochastic delay differential equations (SDDEs) (`SDDEProblem`)
      + Experimental support for stochastic neutral, retarded, and algebraic delay differential equations (SNDDEs, SRDDEs, and SDDAEs)
      + Mixed discrete and continuous equations (Hybrid Equations, Jump Diffusions) (`AbstractDEProblem`s with callbacks)
  - Optimization (`OptimizationProblem`)
    
      + Nonlinear (constrained) optimization
  - (Stochastic/Delay/Differential-Algebraic) Partial Differential Equations (`PDESystem`)
    
      + Finite difference and finite volume methods
      + Interfaces to finite element methods
      + Physics-Informed Neural Networks (PINNs)
      + Integro-Differential Equations
      + Fractional Differential Equations

The SciML common interface also includes
[ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/stable/)
for defining such systems symbolically, allowing for optimizations like automated
generation of parallel code, symbolic simplification, and generation of sparsity
patterns.

## Extended SciML Domain

In addition to the purely numerical representations of mathematical objects, there are also
sets of problem types associated with common mathematical algorithms. These are:

  - Data-driven modeling
    
      + Discrete-time data-driven dynamical systems (`DiscreteDataDrivenProblem`)
      + Continuous-time data-driven dynamical systems (`ContinuousDataDrivenProblem`)
      + Symbolic regression (`DirectDataDrivenProblem`)

  - Uncertainty quantification and expected values (`ExpectationProblem`)

## Inverse Problems, Parameter Estimation, and Structural Identification

We note that parameter estimation and inverse problems are solved directly on their
constituent problem types using tools like [DiffEqFlux.jl](https://docs.sciml.ai/DiffEqFlux/stable/).
Thus for example, there is no `ODEInverseProblem`, and instead `ODEProblem` is used to
find the parameters `p` that solve the inverse problem.

## Common Interface High Level

The SciML interface is common as the usage of arguments is standardized across
all of the problem domains. Underlying high level ideas include:

  - All domains use the same interface of defining a `AbstractSciMLProblem` which is then
    solved via `solve(prob,alg;kwargs)`, where `alg` is a `AbstractSciMLAlgorithm`. The
    keyword argument namings are standardized across the organization.
  - `AbstractSciMLProblem`s are generally defined by a `SciMLFunction` which can define
    extra details about a model function, such as its analytical Jacobian, its
    sparsity patterns and so on.
  - There is an organization-wide method for defining linear and nonlinear solvers
    used within other solvers, giving maximum control of performance to the user.
  - Types used within the packages are defined by the input types. For example,
    packages attempt to internally use the type of the initial condition as the
    type for the state within differential equation solvers.
  - `solve` calls should be thread-safe and parallel-safe.
  - `init(prob,alg;kwargs)` returns an iterator which allows for directly iterating
    over the solution process
  - High performance is key. Any performance that is not at the top level is considered
    a bug and should be reported as such.
  - All functions have an in-place and out-of-place form, where the in-place form
    is made to utilize mutation for high performance on large-scale problems and
    the out-of-place form is for compatibility with tooling like static arrays and
    some reverse-mode automatic differentiation systems.

## User-Facing Solver Libraries

  - [DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/)
    
      + Multi-package interface of high performance numerical solvers of
        differential equations

  - [ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/stable/)
    
      + The symbolic modeling package which implements the SciML symbolic common
        interface.
  - [LinearSolve.jl](https://docs.sciml.ai/LinearSolve/stable/)
    
      + Multi-package interface for specifying linear solvers (direct, sparse,
        and iterative), along with tools for caching and preconditioners
        for use in large-scale modeling.
  - [NonlinearSolve.jl](https://docs.sciml.ai/NonlinearSolve/stable/)
    
      + High performance numerical solving of nonlinear systems.
  - [Integrals.jl](https://docs.sciml.ai/Integrals/stable/)
    
      + Multi-package interface for high performance, batched, and parallelized
        numerical quadrature.
  - [Optimization.jl](https://docs.sciml.ai/Optimization/stable/)
    
      + Multi-package interface for numerical solving of optimization problems.
  - [NeuralPDE.jl](https://docs.sciml.ai/NeuralPDE/stable/)
    
      + Physics-Informed Neural Network (PINN) package for transforming partial
        differential equations into optimization problems.
  - [DiffEqOperators.jl](https://docs.sciml.ai/DiffEqOperators/stable/)
    
      + Automated finite difference method (FDM) package for transforming partial
        differential equations into nonlinear problems and ordinary differential
        equations.
  - [DiffEqFlux.jl](https://docs.sciml.ai/DiffEqFlux/stable/)
    
      + High level package for scientific machine learning applications, such as
        neural and universal differential equations, solving of inverse problems,
        parameter estimation, nonlinear optimal control, and more.
  - [DataDrivenDiffEq.jl](https://docs.sciml.ai/DataDrivenDiffEq/stable/)
    
      + Multi-package interface for data-driven modeling, Koopman dynamic mode
        decomposition, symbolic regression/sparsification, and automated model
        discovery.
  - [SciMLExpectations.jl](https://docs.sciml.ai/SciMLExpectations/stable/)
    
      + Extension to the dynamical modeling tools for calculating expectations.

## Interface Implementation Libraries

  - [SciMLBase.jl](https://docs.sciml.ai/SciMLBase/stable/)
    
      + The core package defining the interface which is consumed by the modeling
        and solver packages.

  - [DiffEqBase.jl](https://github.com/SciML/DiffEqBase.jl)
    
      + The core package defining the extended interface which is consumed by the
        differential equation solver packages.
  - [SciMLSensitivity.jl](https://docs.sciml.ai/SciMLSensitivity/stable/)
    
      + A package which pools together the definition of derivative overloads to
        define the common `sensealg` automatic differentiation interface.
  - [DiffEqNoiseProcess.jl](https://docs.sciml.ai/DiffEqNoiseProcess/stable/)
    
      + A package which defines the stochastic `AbstractNoiseProcess` interface
        for the SciML ecosystem.
  - [RecursiveArrayTools.jl](https://docs.sciml.ai/RecursiveArrayTools/stable/)
    
      + A package which defines the underlying `AbstractVectorOfArray` structure
        used as the output for all time series results.
  - [ArrayInterface.jl](https://docs.sciml.ai/ArrayInterface/stable/)
    
      + The package which defines the extended `AbstractArray` interface employed
        throughout the SciML ecosystem.

## Using-Facing Modeling Libraries

There are too many to name here and this will be populated when there is time!

## Flowchart Example for PDE-Constrained Optimal Control

The following example showcases how the pieces of the common interface connect to solve a problem
that mixes inference, symbolics, and numerics.

![](https://user-images.githubusercontent.com/1814174/126318252-1e4152df-e6e2-42a3-8669-f8608f81a095.png)

## External Binding Libraries

  - [diffeqr](https://github.com/SciML/diffeqr)
    
      + Solving differential equations in R using DifferentialEquations.jl with ModelingToolkit for JIT compilation and GPU-acceleration

  - [diffeqpy](https://github.com/SciML/diffeqpy)
    
      + Solving differential equations in Python using DifferentialEquations.jl

## Solver Libraries

There are too many to name here. Check out the
[SciML Organization Github Page](https://github.com/SciML) for details.

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# [SciMLFunctions (Jacobians, Sparsity, Etc.)](@id scimlfunctions)

The SciML ecosystem provides an extensive interface for declaring extra functions
associated with the differential equation's data. In traditional libraries there
is usually only one option: the Jacobian. However, we allow for a large array
of pre-computed functions to speed up the calculations. This is offered via the
`SciMLFunction` types which can be passed to the problems.

## Definition of the AbstractSciMLFunction Interface

The following standard principles should be adhered to across all
`AbstractSciMLFunction` instantiations.

### Common Function Choice Definitions

The full interface available to the solvers is as follows:

  - `jac`: The Jacobian of the differential equation with respect to the state
    variable `u` at a time `t` with parameters `p`.
  - `paramjac`: The Jacobian of the differential equation with respect to `p` at
    state `u` at time `t`.
  - `analytic`: Defines an analytical solution using `u0` at time `t` with `p`
    which will cause the solvers to return errors. Used for testing.
  - `syms`: Allows you to name your variables for automatic names in plots and
    other output.
  - `jac_prototype`: Defines the type to be used for any internal Jacobians
    within the solvers.
  - `sparsity`: Defines the sparsity pattern to be used for the sparse differentiation
    schemes. By default this is equal to `jac_prototype`. See the sparsity handling
    portion of this page for more information.
  - `colorvec`: The coloring pattern used by the sparse differentiator. See the
    sparsity handling portion of this page for more information.
  - `observed`: A function which allows for generating other observables from a
    solution.

Each function type additionally has some specific arguments, refer to their
documentation for details.

### In-place Specification and No-Recompile Mode

Each SciMLFunction type can be called with an "is inplace" (iip) choice.

```julia
ODEFunction(f)
ODEFunction{iip}(f)
```

which is a boolean for whether the function is in the inplace form (mutating to
change the first value). This is automatically determined using the methods table
but note that for full type-inferability of the `AbstractSciMLProblem` this iip-ness should
be specified.

### Specialization Choices

Each `SciMLFunction` type allows for specialization choices

```julia
ODEFunction{iip, specialization}(f)
```

which designates how the compiler should specialize on the model function `f`. For
more details on specialization choices, see the [SciMLProblems](@ref scimlproblems)
page.

### Specifying Jacobian Types

The `jac` field of an inplace style `SciMLFunction` has the signature `jac(J,u,p,t)`,
which updates the Jacobian `J` in-place. The intended type for `J` can sometimes be
inferred (e.g. when it is just a dense `Matrix`), but not in general. To supply the
type information, you can provide a `jac_prototype` in the function's constructor.

The following example creates an inplace `ODEFunction` whose Jacobian is a `Diagonal`:

```julia
using LinearAlgebra
f = (du, u, p, t) -> du .= t .* u
jac = (J, u, p, t) -> (J[1, 1] = t; J[2, 2] = t; J)
jp = Diagonal(zeros(2))
fun = ODEFunction(f; jac = jac, jac_prototype = jp)
```

Note that the integrators will always make a deep copy of `fun.jac_prototype`, so
there's no worry of aliasing.

In general the jacobian prototype can be anything that has `mul!` defined, in
particular sparse matrices or custom lazy types that support `mul!`. A special case
is when the `jac_prototype` is a `AbstractSciMLOperator`, in which case you
do not need to supply `jac` as it is automatically set to `update_coefficients!`.
Refer to the [SciMLOperators](https://docs.sciml.ai/SciMLOperators/stable/premade_operators/) section for more information
on setting up time/parameter dependent operators.

### Sparsity Handling

The solver libraries internally use packages such as [FiniteDiff.jl](https://docs.sciml.ai/FiniteDiff/stable/)
and [SparseDiffTools.jl](https://docs.sciml.ai/SparseDiffTools/stable/) for
high performance calculation of sparse Jacobians and Hessians, along with matrix-free
calculations of Jacobian-Vector products (`J*v`), vector-Jacobian products (`v'*J`),
and Hessian-vector products (`H*v`). The SciML interface gives users the ability
to control these connections in order to allow for top notch performance.

The key arguments in the SciMLFunction is the `prototype`, which is an object
that will be used as the underlying Jacobian/Hessian. Thus if one wants to use
a sparse Jacobian, one should specify `jac_prototype` to be a sparse matrix.
The sparsity pattern used in the differentiation scheme is defined by `sparsity`.
By default, `sparsity=jac_prototype`, meaning that the sparse automatic differentiation
scheme should specialize on the sparsity pattern given by the actual sparsity
pattern. This can be overridden to say perform partial matrix coloring approximations.
Additionally, the color vector for the sparse differentiation directions can
be specified directly via `colorvec`. For more information on how these arguments
control the differentiation process, see the aforementioned differentiation
library documentations.

## Traits

```@docs
SciMLBase.isinplace(f::SciMLBase.AbstractSciMLFunction)
```

## AbstractSciMLFunction API

### Abstract SciML Functions

```@docs
SciMLBase.AbstractDiffEqFunction
SciMLBase.AbstractODEFunction
SciMLBase.AbstractSDEFunction
SciMLBase.AbstractDDEFunction
SciMLBase.AbstractDAEFunction
SciMLBase.AbstractRODEFunction
SciMLBase.AbstractDiscreteFunction
SciMLBase.AbstractSDDEFunction
SciMLBase.AbstractNonlinearFunction
```

# The SciML init and solve Functions

`solve` function has the default definition

```julia
solve(args...; kwargs...) = solve!(init(args...; kwargs...))
```

The interface for the three functions is as follows:

```julia
init(::ProblemType, args...; kwargs...)::IteratorType
solve!(::IteratorType)::SolutionType
```

where `ProblemType`, `IteratorType`, and `SolutionType` are the types defined in
your package.

To avoid method ambiguity, the first argument of `solve`, `solve!`, and `init`
_must_ be dispatched on the type defined in your package.  For example, do
_not_ define a method such as

```julia
init(::AbstractVector, ::AlgorithmType)
```

## `init` and the Iterator Interface

`init`'s return gives an `IteratorType` which is designed to allow the user to
have more direct handling over the internal solving process. Because of this
internal nature, the `IteratorType` has a less unified interface across problem
types than other portions like `ProblemType` and `SolutionType`. For example,
for differential equations this is the
[Integrator Interface](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/)
designed for mutating solutions in a manner for callback implementation, which
is distinctly different from the
[LinearSolve init interface](https://docs.sciml.ai/LinearSolve/stable/tutorials/caching_interface)
which is designed for caching efficiency with reusing factorizations.

## `__solve` and High-Level Handling

While `init` and `solve` are the common entry point for users, solver packages will
mostly define dispatches on `SciMLBase.__init` and `SciMLBase.__solve`. The reason is
because this allows for `SciMLBase.init` and `SciMLBase.solve` to have common
implementations across all solvers for doing things such as checking for common
errors and throwing high level messages. Solvers can opt-out of the high level
error handling by directly defining `SciMLBase.init` and `SciMLBase.solve` instead,
though this is not recommended in order to allow for uniformity of the error messages.

# SciMLSolutions

## Definition of the AbstractSciMLSolution Interface

All `AbstractSciMLSolution` types are a subset of some `AbstractArray`. Types with time series
(like `ODESolution`) are subtypes of `RecursiveArrayTools.AbstractVectorOfArray` and
`RecursiveArrayTools.AbstractDiffEqArray` where appropriate. Types without a time series
(like `OptimizationSolution`) are directly subsets of `AbstractArray`.

### Array Interface

Instead of working on the `Vector{uType}` directly, we can use the provided
array interface.

```julia
sol[j]
```

to access the value at timestep `j` (if the timeseries was saved), and

```julia
sol.t[j]
```

to access the value of `t` at timestep `j`. For multi-dimensional systems, this
will address first by component and lastly by time, and thus

```julia
sol[i, j]
```

will be the `i`th component at timestep `j`. Hence, `sol[j][i] == sol[i, j]`. This is done because Julia is column-major, so the leading dimension should be contiguous in memory. If the independent variables had shape
(for example, was a matrix), then `i` is the linear index. We can also access
solutions with shape:

```julia
sol[i, k, j]
```

gives the `[i,k]` component of the system at timestep `j`. The colon operator is
supported, meaning that

```julia
sol[i, :]
```

gives the timeseries for the `i`th component.

### Common Field Names

  - `u`: the solution values
  - `t`: the independent variable values, matching the length of the solution, if applicable
  - `resid`: the residual of the solution, if applicable
  - `original`: the solution object from the original solver, if it's a wrapper algorithm
  - `retcode`: see the documentation section on return codes
  - `prob`: the problem that was solved
  - `alg`: the algorithm used to solve the problem

## [Return Codes (RetCodes)](@id retcodes)

The solution types have a `retcode` field which returns a `SciMLBase.ReturnCode.T`
(from [EnumX.jl](https://github.com/fredrikekre/EnumX.jl), see that package for the
semantics of handling EnumX types) signifying the error or satisfaction state of
the solution.

```@docs
SciMLBase.ReturnCode
```

### Return Code Traits

```@docs
SciMLBase.successful_retcode
```

### Specific Return Codes

```@docs
SciMLBase.ReturnCode.Default
SciMLBase.ReturnCode.Success
SciMLBase.ReturnCode.Terminated
SciMLBase.ReturnCode.DtNaN
SciMLBase.ReturnCode.MaxIters
SciMLBase.ReturnCode.MaxNumSub
SciMLBase.ReturnCode.MaxTime
SciMLBase.ReturnCode.DtLessThanMin
SciMLBase.ReturnCode.Unstable
SciMLBase.ReturnCode.InitialFailure
SciMLBase.ReturnCode.ConvergenceFailure
SciMLBase.ReturnCode.Failure
SciMLBase.ReturnCode.Infeasible
SciMLBase.ReturnCode.ExactSolutionLeft
SciMLBase.ReturnCode.ExactSolutionRight
SciMLBase.ReturnCode.FloatingPointLimit
SciMLBase.ReturnCode.InternalLineSearchFailed
SciMLBase.ReturnCode.InternalLinearSolveFailed
SciMLBase.ReturnCode.APosterioriSafetyFailure
SciMLBase.ReturnCode.ShrinkThresholdExceeded
SciMLBase.ReturnCode.Stalled
SciMLBase.ReturnCode.StalledSuccess
```

## Solution Traits

## AbstractSciMLSolution API

### Abstract SciML Solutions

```@docs
SciMLBase.AbstractSciMLSolution
SciMLBase.AbstractNoTimeSolution
SciMLBase.AbstractTimeseriesSolution
SciMLBase.AbstractNoiseProcess
SciMLBase.AbstractEnsembleSolution
SciMLBase.AbstractLinearSolution
SciMLBase.AbstractNonlinearSolution
SciMLBase.AbstractIntegralSolution
SciMLBase.AbstractSteadyStateSolution
SciMLBase.AbstractAnalyticalSolution
SciMLBase.AbstractODESolution
SciMLBase.AbstractDDESolution
SciMLBase.AbstractRODESolution
SciMLBase.AbstractDAESolution
```

# [SciML Container (Array) and Number Interfaces](@id arrayandnumber)

We live in a society, and therefore there are rules. In this tutorial we outline
the rules which are required on container and number types which are allowable
in SciML tools.

!!! warning
    
    In general as of 2023, strict adherence to this interface is an early work-in-progress.
    If anything does not conform to the documented interface, please open an issue.

!!! note
    
    There are many types which can work with a specific solver that do satisfy this
    interface. Many times as part of prototyping you may want to side-step the
    high level interface checks in order to simply test whether a new type is working.
    To do this, set `interface_checks = false` as a keyword argument to `init`/`solve`
    to bypass any of the internal interface checks. This means you will no longer get
    a nice high-level error message and instead it will attempt to use the type
    without restrictions. Note that not every problem/solver has implemented this
    new keyword argument as of 2023.

## Note About Wrapped Solvers

Due to limitations of wrapped solvers, any solver that is a wrapped solver from an existing C/Fortran
code is inherently limited to `Float64` and `Vector{Float64}` for its operations. This includes packages
like Sundials.jl, LSODA.jl, DASKR.jl, MINPACK.jl, and many more. This is fundamental to these solvers
and it is not expected that they will allow the full set of SciML types in the future. If more abstract
number/container definitions are required, then these are not the appropriate solvers to use.

## SciML Number Types

The number types are the types used to define the dependent variables (i.e. `u0`) and the
independent variables (`t` or `tspan`). These two types can be different, and can have
different restrictions depending on the type of solver which is employed. The following
rules for a Number type are held in general:

  - Number types can be used in SciML directly or in containers. If a problem defines a value like `u0`
    using a Number type, the out-of-place form must be used for the problem definition.
  - `x::T + y::T = z::T`
  - `x::T * y::T = z::T`
  - `oneunit(x::T)::T`
  - `(one(x::T) * oneunit(x::T))::T`
  - `t::T2 * x::T + y::T = z::T` for `T2` a time type and `T` the dependent variable type (this includes the
    `muladd` equivalent form).

Additionally, the following rules apply to subsets of uses:

### Adaptive Number Types

  - `x::T / y::T = z::T`
  - Default choices of norms can assume `sqrt(x::T)::T` exists. If `internalnorm` is overridden then this
    may not be required (for example, changing the norm to inf-norm).
  - `x::T ^ y::T = z::T`

### Time Types (Independent Variables)

  - If a solver is time adaptive, the time type must be a floating point number. `Rational` is only allowed
    for non-adaptive solves.

## SciML Container (Array) Types

Container types are types which hold number types. They can be used to define objects like the state vector
(`u0`) of a problem. The following operations are required in a container type to be used with SciML
solvers:

  - Broadcast is defined [according to the Julia broadcast interface](https://docs.julialang.org/en/v1/manual/interfaces/#man-interfaces-broadcasting).
  - The container type correctly defines [interface overloads to satisfy the ArrayInterface.jl specification](https://docs.sciml.ai/ArrayInterface/stable/).
  - `ArrayInterface.zeromatrix(x::T)::T2` defines a compatible matrix type (see below)
  - `eltype(x::T)::T2` is a compatible Number type.
  - `x::T .+ y::T = z::T` (i.e. broadcast similar is defined to be type-presurving)
  - Indexing is only required if `ArrayInterface.fast_scalar_indexing(x::T)==true`. If true,
    scalar indexing `x[i]` is assumed to be defined and run through all variables.

!!! note
    
    "`eltype(x::T)::T2` is a compatible Number type" excludes `Array{Array{T}}` types of types. However, recursive
    vectors can conformed to the interface with zero overhead using tools from RecursiveArrayTools.jl such as
    `VectorOfArray(x)`. Since this greatly simplifies the interfaces and the ability to check for correctness,
    doing this wrapping is highly recommended and there are no plans to relax this requirement.

Additionally, the following rules apply to subsets of uses:

### SciML Mutable Array Types

  - `similar(x::T)::T`
  - `zero(x::T)::T`
  - `z::T .= x::T .+ y::T` is defined
  - `z::T .= x::T .* y::T` is defined
  - `z::T .= t::T2 .* x::T` where `T2` is the time type (a Number) and `T` is the container type.
  - (Optional) `Base.resize!(x,i)` is required for `resize!(integrator,i)` to be supported.

### SciML Matrix (Operator) Type

Note that the matrix type may not match the type of the initial container `u0`. An example is `ComponentMatrix`
as the matrix structure corresponding to a `ComponentArray`. However, the following actions are assumed
to hold on the resulting matrix type:

  - `solve(LinearProblem(A::T,b::T2),linsolve)` must be defined for a solver to work on a given SciML matrix
    type `T2`.
  - If the matrix is an operator, i.e. a lazy construct, it should conform to the
    [SciMLOperators](https://docs.sciml.ai/SciMLOperators/stable/) interface.
  - If not a SciMLOperator, `diagind(W::T)` should be defined and `@view(A[idxs])=@view(A[idxs]) + λ::T`

# The PDE Definition Interface

While ODEs ``u' = f(u,p,t)`` can be defined by a user-function `f`, for PDEs the
function form can be different for every PDE. How many functions, and how many
inputs? This can always change. The SciML ecosystem solves this problem by
using [ModelingToolkit.jl](https://docs.sciml.ai/ModelingToolkit/stable/) to define `PDESystem`,
a high-level symbolic description of the PDE to be consumed by other packages.

The vision for the common PDE interface is that a user should only have to specify
their PDE once, mathematically, and have instant access to everything as simple
as a finite difference method with constant grid spacing, to something as complex
as a distributed multi-GPU discontinuous Galerkin method.

The key to the common PDE interface is a separation of the symbolic handling from
the numerical world. All of the discretizers should not "solve" the PDE, but
instead be a conversion of the mathematical specification to a numerical problem.
Preferably, the transformation should be to another ModelingToolkit.jl `AbstractSystem`
via a `symbolic_discretize` dispatch, but in some cases this cannot be done or will
not be performant. Thus in some cases, only a `discretize` definition is given to a
`AbstractSciMLProblem`, with `symbolic_discretize` simply providing diagnostic or lower level
information about the construction process.

These elementary problems, such as solving linear systems `Ax=b`, solving nonlinear
systems `f(x)=0`, ODEs, etc. are all defined by SciMLBase.jl, which then numerical
solvers can all target these common forms. Thus someone who works on linear solvers
doesn't necessarily need to be working on a Discontinuous Galerkin or finite element
library, but instead "linear solvers that are good for matrices A with
properties ..." which are then accessible by every other discretization method
in the common PDE interface.

Similar to the rest of the `AbstractSystem` types, transformation and analyses
functions will allow for simplifying the PDE before solving it, and constructing
block symbolic functions like Jacobians.

## Constructors

```@docs
ModelingToolkit.PDESystem
```

### Domains (WIP)

Domains are specifying by saying `indepvar in domain`, where `indepvar` is a
single or a collection of independent variables, and `domain` is the chosen
domain type. A 2-tuple can be used to indicate an `Interval`.
Thus forms for the `indepvar` can be like:

```julia
t ∈ (0.0, 1.0)
(t, x) ∈ UnitDisk()
[v, w, x, y, z] ∈ VectorUnitBall(5)
```

#### Domain Types (WIP)

  - `Interval(a,b)`: Defines the domain of an interval from `a` to `b` (requires explicit
    import from `DomainSets.jl`, but a 2-tuple can be used instead)

## `discretize` and `symbolic_discretize`

The only functions which act on a PDESystem are the following:

  - `discretize(sys,discretizer)`: produces the outputted `AbstractSystem` or
    `AbstractSciMLProblem`.
  - `symbolic_discretize(sys,discretizer)`: produces a debugging symbolic description
    of the discretized problem.

## Boundary Conditions (WIP)

## Transformations

## Analyses

## Discretizer Ecosystem

### NeuralPDE.jl: PhysicsInformedNN

[NeuralPDE.jl](https://docs.sciml.ai/NeuralPDE/stable/) defines the `PhysicsInformedNN`
discretizer which uses a [DiffEqFlux.jl](https://docs.sciml.ai/DiffEqFlux/stable/)
neural network to solve the differential equation.

### MethodOfLines.jl: MOLFiniteDifference (WIP)

[MethodOfLines.jl](https://docs.sciml.ai/MethodOfLines/stable/) defines the
`MOLFiniteDifference` discretizer which performs a finite difference discretization
using the DiffEqOperators.jl stencils. These stencils make use of NNLib.jl for
fast operations on semi-linear domains.

# Common Keyword Arguments

The following defines the keyword arguments which are meant to be preserved
throughout all of the AbstractSciMLProblem cases (where applicable).

## Default Algorithm Hinting

To help choose the default algorithm, the keyword argument `alg_hints` is
provided to `solve`. `alg_hints` is a `Vector{Symbol}` which describe the
problem at a high level to the solver. The options are:

This functionality is derived via the benchmarks in
[SciMLBenchmarks.jl](https://docs.sciml.ai/SciMLBenchmarksOutput/stable/)

Currently this is only implemented for the differential equation solvers.

## Output Control

These arguments control the output behavior of the solvers. It defaults to maximum
output to give the best interactive user experience, but can be reduced all the
way to only saving the solution at the final timepoint.

The following options are all related to output control. See the "Examples"
section at the end of this page for some example usage.

  - `dense`: Denotes whether to save the extra pieces required for dense (continuous)
    output. Default is `save_everystep && !isempty(saveat)` for algorithms which have
    the ability to produce dense output, i.e. by default it's `true` unless the user
    has turned off saving on steps or has chosen a `saveat` value. If `dense=false`,
    the solution still acts like a function, and `sol(t)` is a linear interpolation
    between the saved time points.
  - `saveat`: Denotes specific times to save the solution at, during the solving
    phase. The solver will save at each of the timepoints in this array in the
    most efficient manner available to the solver. If only `saveat` is given, then
    the arguments `save_everystep` and `dense` are `false` by default.
    If `saveat` is given a number, then it will automatically expand to
    `tspan[1]:saveat:tspan[2]`. For methods where interpolation is not possible,
    `saveat` may be equivalent to `tstops`. The default value is `[]`.
  - `save_idxs`: Denotes the indices for the components of the equation to save.
    Defaults to saving all indices. For example, if you are solving a 3-dimensional ODE,
    and given `save_idxs = [1, 3]`, only the first and third components of the
    solution will be outputted.
    Notice that of course in this case the outputted solution will be two-dimensional.
  - `tstops`: Denotes *extra* times that the timestepping algorithm must step to.
    This should be used to help the solver deal with discontinuities and
    singularities, since stepping exactly at the time of the discontinuity will
    improve accuracy. If a method cannot change timesteps (fixed timestep
    multistep methods), then `tstops` will use an interpolation,
    matching the behavior of `saveat`. If a method cannot change timesteps and
    also cannot interpolate, then `tstops` must be a multiple of `dt` or else an
    error will be thrown. Default is `[]`.
  - `d_discontinuities:` Denotes locations of discontinuities in low order derivatives.
    This will force FSAL algorithms which assume derivative continuity to re-evaluate
    the derivatives at the point of discontinuity. The default is `[]`.
  - `save_everystep`: Saves the result at every step.
    Default is true if `isempty(saveat)`.
  - `save_on`: Denotes whether intermediate solutions are saved. This overrides the
    settings of `dense`, `saveat` and `save_everystep` and is used by some applications
    to manually turn off saving temporarily. Everyday use of the solvers should leave
    this unchanged. Defaults to `true`.
  - `save_start`: Denotes whether the initial condition should be included in
    the solution type as the first timepoint. Defaults to `true`.
  - `save_end`: Denotes whether the final timepoint is forced to be saved,
    regardless of the other saving settings. Defaults to `true`.
  - `initialize_save`: Denotes whether to save after the callback initialization
    phase (when `u_modified=true`). Defaults to `true`.

Note that `dense` requires `save_everystep=true` and `saveat=false`.

## Stepsize Control

These arguments control the timestepping routines.

#### Basic Stepsize Control

  - `adaptive`: Turns on adaptive timestepping for appropriate methods. Default
    is true.
  - `abstol`: Absolute tolerance in adaptive timestepping. This is the tolerance
    on local error estimates, not necessarily the global error (though these quantities
    are related).
  - `reltol`: Relative tolerance in adaptive timestepping.  This is the tolerance
    on local error estimates, not necessarily the global error (though these quantities
    are related).
  - `dt`: Sets the initial stepsize. This is also the stepsize for fixed
    timestep methods. Defaults to an automatic choice if the method is adaptive.
  - `dtmax`: Maximum dt for adaptive timestepping. Defaults are
    package-dependent.
  - `dtmin`: Minimum dt for adaptive timestepping. Defaults are
    package-dependent.

#### Fixed Stepsize Usage

Note that if a method does not have adaptivity, the following rules apply:

  - If `dt` is set, then the algorithm will step with size `dt` each iteration.
  - If `tstops` and `dt` are both set, then the algorithm will step with either a
    size `dt`, or use a smaller step to hit the `tstops` point.
  - If `tstops` is set without `dt`, then the algorithm will step directly to
    each value in `tstops`
  - If neither `dt` nor `tstops` are set, the solver will throw an error.

## Memory Optimizations

  - `alias`: an `AbstractAliasSpecifier` object that holds fields specifying which variables to alias
    when solving. For example, to tell an ODE solver to alias the `u0` array, you can use an `ODEAliases` object,
    and the `alias_u0` keyword argument, e.g. `solve(prob,alias = ODEAliases(alias_u0 = true))`.
    For more information on what can be aliased for each problem type, see the documentation for the `AbstractAliasSpecifier`
    associated with that problem type. Set to `true` to alias every variable possible, or to `false` to disable aliasing.
    Defaults to an `AbstractAliasSpecifier` instance with `nothing` for all fields, which tells the solver to use the default behavior.
  - `cache`: pass a solver cache to decrease the construction time. This is not implemented
    for any of the problem interfaces at this moment.

## Miscellaneous

  - `maxiters`: Maximum number of iterations before stopping.
  - `callback`: Specifies a callback function that is called between iterations.
  - `verbose`: Toggles whether warnings are thrown when the solver exits early.
    Defaults to true.
  - `rng`: Pass an `AbstractRNG` instance to be used by the integrator for any
    stochastic operations (e.g., jump process sampling, noise generation). Can
    also be used in user callbacks. When provided, `rng` takes priority over
    `seed`. Defaults to `Random.default_rng()` when the solver supports it. The
    integrator's RNG can be accessed via `get_rng(integrator)` and replaced via
    `set_rng!(integrator, rng)`. Use `has_rng(integrator)` to check whether an
    integrator supports the RNG interface.

## Progress Monitoring

These arguments control the usage of the progressbar in the logger.

  - `progress`: Turns on/off the Juno progressbar. Default is false.
  - `progress_steps`: Numbers of steps between updates of the progress bar.
    Default is 1000.
  - `progress_name`: Controls the name of the progressbar. Default is the name
    of the problem type.
  - `progress_message`: Controls the message with the progressbar. Defaults to
    showing `dt`, `t`, the maximum of `u`.

The progress bars all use the Julia Logging interface in order to be generic
to the IDE or programming tool that is used. For more information on how this
is all put together, see [this discussion](https://github.com/FedeClaudi/Term.jl/discussions/67).

## Error Calculations

If you are using the test problems (i.e. `SciMLFunction`s where `f.analytic` is
defined), then options control the errors which are calculated. By default,
any cheap error estimates are always calculated. Extra keyword arguments include:

  - `timeseries_errors`
  - `dense_errors`

for specifying more expensive errors.

## Automatic Differentiation Control

See the [Automatic Differentiation page for a full description of `sensealg`](@ref sensealg)

# [Parallel Ensemble Simulations Interface](@id ensemble)

Performing Monte Carlo simulations, solving with a predetermined set of initial conditions, and
GPU-parallelizing a parameter search all fall under the ensemble simulation interface. This
interface allows one to declare a template AbstractSciMLProblem to parallelize, tweak the template
in `trajectories` for many trajectories, solve each in parallel batches, reduce the solutions
down to specific answers, and compute summary statistics on the results.

## Performing an Ensemble Simulation

### Building a Problem

```@docs
EnsembleProblem
```

### Solving the Problem

```@docs
SciMLBase.__solve(prob::SciMLBase.AbstractEnsembleProblem, alg, ensemblealg::SciMLBase.BasicEnsembleAlgorithm)
```

### EnsembleAlgorithms

The choice of ensemble algorithm allows for control over how the multiple trajectories
are handled. Currently, the ensemble algorithm types are:

```@docs
EnsembleSerial
EnsembleThreads
EnsembleDistributed
EnsembleSplitThreads
```

#### DiffEq Only (ODEProblem, SDEProblem)

| GPU Manufacturer | GPU Kernel Language | Julia Support Package                              | Backend Type             |
|:---------------- |:------------------- |:-------------------------------------------------- |:------------------------ |
| NVIDIA           | CUDA                | [CUDA.jl](https://github.com/JuliaGPU/CUDA.jl)     | `CUDA.CUDABackend()`     |
| AMD              | ROCm                | [AMDGPU.jl](https://github.com/JuliaGPU/AMDGPU.jl) | `AMDGPU.ROCBackend()`    |
| Intel            | OneAPI              | [OneAPI.jl](https://github.com/JuliaGPU/oneAPI.jl) | `oneAPI.oneAPIBackend()` |
| Apple (M-Series) | Metal               | [Metal.jl](https://github.com/JuliaGPU/Metal.jl)   | `Metal.MetalBackend()`   |

  - `EnsembleGPUArray()` - Requires installing and `using DiffEqGPU`. This uses a GPU for computing the ensemble
    with hyperparallelism. It will automatically recompile your Julia functions to the GPU. A standard GPU sees
    a 5x performance increase over a 16 core Xeon CPU. However, there are limitations on what functions can
    auto-compile in this fashion, please see [DiffEqGPU for more details](https://docs.sciml.ai/DiffEqGPU/stable/)
  - `EnsembleGPUKernel()` - Requires installing and `using DiffEqGPU`. This uses a GPU for computing the ensemble
    with hyperparallelism by building a custom GPU kernel. This can have drastically less overhead (for example,
    achieving 15x accelerating against Jax and PyTorch, see
    [this paper for more details](https://www.sciencedirect.com/science/article/abs/pii/S0045782523007156)) but
    has limitations on what kinds of problems are compatible. See
    [DiffEqGPU for more details](https://docs.sciml.ai/DiffEqGPU/stable/)

### Choosing an Ensembler

For example, `EnsembleThreads()` is invoked by:

```julia
solve(ensembleprob, alg, EnsembleThreads(); trajectories = 1000)
```

### Solution Type

The resulting type is a `EnsembleSimulation`, which includes the array of
solutions.

### Plot Recipe

There is a plot recipe for a `AbstractEnsembleSimulation` which composes all
of the plot recipes for the component solutions. The keyword arguments are passed
along. A useful argument to use is `linealpha` which will change the transparency
of the plots. An additional argument is `idxs` which allows you to choose which
components of the solution to plot. For example, if the differential equation
is a vector of 9 values, `idxs=1:2:9` will plot only the solutions
of the odd components. Another additional argument is `zcolors` (an alias of `marker_z`) which allows
you to pass a `zcolor` for each series. For details about `zcolor` see the
[Series documentation for Plots.jl](https://docs.juliaplots.org/stable/attributes/).

## Analyzing an Ensemble Experiment

Analysis tools are included for generating summary statistics and summary plots
for a `EnsembleSimulation`.

To use this functionality, import the analysis module via:

```julia
using SciMLBase.EnsembleAnalysis
```

### Time steps vs time points

For the summary statistics, there are two types. You can either summarize by
time steps or by time points. Summarizing by time steps assumes that the time steps
are all the same time point, i.e. the integrator used a fixed `dt` or the values were
saved using `saveat`. Summarizing by time points requires interpolating the solution.

```@docs
SciMLBase.EnsembleAnalysis.get_timestep
SciMLBase.EnsembleAnalysis.get_timepoint
SciMLBase.EnsembleAnalysis.componentwise_vectors_timestep
SciMLBase.EnsembleAnalysis.componentwise_vectors_timepoint
```

### Summary Statistics Functions

#### Single Time Statistics

The available functions for time steps are:

```@docs
SciMLBase.EnsembleAnalysis.timestep_mean
SciMLBase.EnsembleAnalysis.timestep_median
SciMLBase.EnsembleAnalysis.timestep_quantile
SciMLBase.EnsembleAnalysis.timestep_meanvar
SciMLBase.EnsembleAnalysis.timestep_meancov
SciMLBase.EnsembleAnalysis.timestep_meancor
SciMLBase.EnsembleAnalysis.timestep_weighted_meancov
```

The available functions for time points are:

```@docs
SciMLBase.EnsembleAnalysis.timepoint_mean
SciMLBase.EnsembleAnalysis.timepoint_median
SciMLBase.EnsembleAnalysis.timepoint_quantile
SciMLBase.EnsembleAnalysis.timepoint_meanvar
SciMLBase.EnsembleAnalysis.timepoint_meancov
SciMLBase.EnsembleAnalysis.timepoint_meancor
SciMLBase.EnsembleAnalysis.timepoint_weighted_meancov
```

#### Full Timeseries Statistics

Additionally, the following functions are provided for analyzing the full timeseries.
The `mean` and `meanvar` versions return a `DiffEqArray` which can be directly plotted.
The `meancov` and `meancor` return a matrix of tuples, where the tuples are the
`(mean_t1,mean_t2,cov or cor)`.

The available functions for the time steps are:

```@docs
timeseries_steps_mean
timeseries_steps_median
timeseries_steps_quantile
timeseries_steps_meanvar
timeseries_steps_meancov
timeseries_steps_meancor
timeseries_steps_weighted_meancov
```

The available functions for the time points are:

```@docs
SciMLBase.EnsembleAnalysis.timeseries_point_mean
SciMLBase.EnsembleAnalysis.timeseries_point_median
SciMLBase.EnsembleAnalysis.timeseries_point_quantile
SciMLBase.EnsembleAnalysis.timeseries_point_meanvar
SciMLBase.EnsembleAnalysis.timeseries_point_meancov
SciMLBase.EnsembleAnalysis.timeseries_point_meancor
SciMLBase.EnsembleAnalysis.timeseries_point_weighted_meancov
```

### EnsembleSummary

```@docs
EnsembleSummary
```

## Example 1: Solving an ODE With Different Initial Conditions

### Random Initial Conditions

Let's test the sensitivity of the linear ODE to its initial condition. To do this,
we would like to solve the linear ODE 100 times and plot what the trajectories
look like. Let's start by opening up some extra processes so that way the computation
will be parallelized. Here we will choose to use distributed parallelism, which means
that the required functions must be made available to all processes. This can be
achieved with
[`@everywhere` macro](https://docs.julialang.org/en/v1.2/stdlib/Distributed/#Distributed.@everywhere):

```julia
using Distributed
using OrdinaryDiffEq
using Plots

addprocs()
@everywhere using OrdinaryDiffEq
```

Now let's define the linear ODE, which is our base problem:

```julia
# Linear ODE which starts at 0.5 and solves from t=0.0 to t=1.0
prob = ODEProblem((u, p, t) -> 1.01u, 0.5, (0.0, 1.0))
```

For our ensemble simulation, we would like to change the initial condition around.
This is done through the `prob_func`. This function takes in the base problem
and modifies it to create the new problem that the trajectory actually solves.
The `prob_func` has the signature `prob_func(prob, i, repeat)` where:

- `prob` is the base problem to be modified
- `i` is the unique trajectory index (`1` to `trajectories`)  
- `repeat` is the repeat iteration number (starts at `1`, increments if `output_func` returned `rerun=true`)

Here, we will take the base problem, multiply the initial condition by a `rand()`,
and use that for calculating the trajectory:

```julia
@everywhere function prob_func(prob, i, repeat)
    remake(prob, u0 = rand() * prob.u0)
end
```

Now we build and solve the `EnsembleProblem` with this base problem and `prob_func`:

```julia
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim = solve(ensemble_prob, Tsit5(), EnsembleDistributed(), trajectories = 10)
```

We can use the plot recipe to plot what the 10 ODEs look like:

```julia
plot(sim, linealpha = 0.4)
```

We note that if we wanted to find out what the initial condition was for a given
trajectory, we can retrieve it from the solution. `sim[i]` returns the `i`th
solution object. `sim[i].prob` is the problem that specific trajectory solved,
and `sim[i].prob.u0` would then be the initial condition used in the `i`th
trajectory.

Note: If the problem has callbacks, the functions for the `condition` and
`affect!` must be named functions (not anonymous functions).

### Using multithreading

The previous ensemble simulation can also be parallelized using a multithreading
approach, which will make use of the different cores within a single computer.
Because the memory is shared across the different threads, it is not necessary to
use the `@everywhere` macro. Instead, the same problem can be implemented simply as:

```@example ensemble1_2
using OrdinaryDiffEq
prob = ODEProblem((u, p, t) -> 1.01u, 0.5, (0.0, 1.0))
function prob_func(prob, i, repeat)
    remake(prob, u0 = rand() * prob.u0)
end
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim = solve(ensemble_prob, Tsit5(), EnsembleThreads(), trajectories = 10)
using Plots;
plot(sim);
```

The number of threads to be used has to be defined outside of Julia, in
the environmental variable `JULIA_NUM_THREADS` (see Julia's [documentation](https://docs.julialang.org/en/v1.1/manual/environment-variables/#JULIA_NUM_THREADS-1) for details).

### Pre-Determined Initial Conditions

Often, you may already know what initial conditions you want to use. This
can be specified by the `i` argument of the `prob_func`. This `i` is the unique
index of each trajectory. So, if we have `trajectories=100`, then we have `i` as
some index in `1:100`, and it's different for each trajectory.

So, if we wanted to use a grid of evenly spaced initial conditions from `0` to `1`,
we could simply index the `linspace` type:

```@example ensemble1_3
initial_conditions = range(0, stop = 1, length = 100)
function prob_func(prob, i, repeat)
    remake(prob, u0 = initial_conditions[i])
end
```

It's worth noting that if you run this code successfully, there will be no visible output.

## Example 2: Solving an SDE with Different Parameters

Let's solve the same SDE, but with varying parameters. Let's create a Lotka-Volterra
system with multiplicative noise. Our Lotka-Volterra system will have as its
drift component:

```@example ensemble2
function f(du, u, p, t)
    du[1] = p[1] * u[1] - p[2] * u[1] * u[2]
    du[2] = -3 * u[2] + u[1] * u[2]
end
```

For our noise function, we will use multiplicative noise:

```@example ensemble2
function g(du, u, p, t)
    du[1] = p[3] * u[1]
    du[2] = p[4] * u[2]
end
```

Now we build the SDE with these functions:

```@example ensemble2
using StochasticDiffEq
p = [1.5, 1.0, 0.1, 0.1]
prob = SDEProblem(f, g, [1.0, 1.0], (0.0, 10.0), p)
```

This is the base problem for our study. What would like to do with this experiment
is keep the same parameters in the deterministic component each time, but vary
the parameters for the amount of noise using `0.3rand(2)` as our parameters.
Once again, we do this with a `prob_func`, and here we modify the parameters in
`prob.p`:

```@example ensemble2
# `p` is a global variable, referencing it would be type unstable.
# Using a let block defines a small local scope in which we can
# capture that local `p` which isn't redefined anywhere in that local scope.
# This allows it to be type stable.
prob_func = let p = p
    (prob, i, repeat) -> begin
        x = 0.3rand(2)
        remake(prob, p = [p[1], p[2], x[1], x[2]])
    end
end
```

Now we solve the problem 10 times and plot all of the trajectories in phase space:

```@example ensemble2
ensemble_prob = EnsembleProblem(prob, prob_func = prob_func)
sim = solve(ensemble_prob, SRIW1(), trajectories = 10)
using Plots;
plot(sim, linealpha = 0.6, color = :blue, idxs = (0, 1), title = "Phase Space Plot");
plot!(sim, linealpha = 0.6, color = :red, idxs = (0, 2), title = "Phase Space Plot")
```

We can then summarize this information with the mean/variance bounds using a
`EnsembleSummary` plot. We will take the mean/quantile at every `0.1` time
units and directly plot the summary:

```@example ensemble2
summ = EnsembleSummary(sim, 0:0.1:10)
plot(summ, fillalpha = 0.5)
```

Note that here we used the quantile bounds, which default to `[0.05,0.95]` in
the `EnsembleSummary` constructor. We can change to standard error of the mean
bounds using `ci_type=:SEM` in the plot recipe.

## Example 3: Using the Reduction to Halt When Estimator is Within Tolerance

In this problem, we will solve the equation just as many times as needed to get
the standard error of the mean for the final time point below our tolerance
`0.5`. Since we only care about the endpoint, we can tell the `output_func`
to discard the rest of the data.

```@example ensemble3
function output_func(sol, i)
    last(sol), false
end
```

Our `prob_func` will simply randomize the initial condition:

```@example ensemble3
using OrdinaryDiffEq
# Linear ODE which starts at 0.5 and solves from t=0.0 to t=1.0
prob = ODEProblem((u, p, t) -> 1.01u, 0.5, (0.0, 1.0))

function prob_func(prob, i, repeat)
    remake(prob, u0 = rand() * prob.u0)
end
```

Our reduction function will append the data from the current batch to the previous
batch, and declare convergence if the standard error of the mean is calculated
as sufficiently small:

```@example ensemble3
using Statistics
function reduction(u, batch, I)
    u = append!(u, batch)
    finished = (var(u) / sqrt(last(I))) / mean(u) < 0.5
    u, finished
end
```

Then we can define and solve the problem:

```@example ensemble3
prob2 = EnsembleProblem(prob, prob_func = prob_func, output_func = output_func,
    reduction = reduction, u_init = Vector{Float64}())
sim = solve(prob2, Tsit5(), trajectories = 10000, batch_size = 20)
```

Since `batch_size=20`, this means that every 20 simulations, it will take this batch,
append the results to the previous batch, calculate `(var(u)/sqrt(last(I)))/mean(u)`,
and if that's small enough, exit the simulation. In this case, the simulation
exits only after 20 simulations (i.e. after calculating the first batch). This
can save a lot of time!

In addition to saving time by checking convergence, we can save memory by reducing
between batches. For example, say we only care about the mean at the end once
again. Instead of saving the solution at the end for each trajectory, we can instead
save the running summation of the endpoints:

```@example ensemble3
function reduction(u, batch, I)
    u + sum(batch), false
end
prob2 = EnsembleProblem(prob, prob_func = prob_func, output_func = output_func,
    reduction = reduction, u_init = 0.0)
sim2 = solve(prob2, Tsit5(), trajectories = 100, batch_size = 20)
```

this will sum up the endpoints after every 20 solutions, and save the running sum.
The final result will have `sim2.u` as simply a number, and thus `sim2.u/100` would
be the mean.

## Example 4: Using the Analysis Tools

In this example, we will show how to analyze a `EnsembleSolution`. First, let's
generate a 10 solution Monte Carlo experiment. For our problem, we will use a `4x2`
system of linear stochastic differential equations:

```@example ensemble4
function f(du, u, p, t)
    for i in 1:length(u)
        du[i] = 1.01 * u[i]
    end
end
function σ(du, u, p, t)
    for i in 1:length(u)
        du[i] = 0.87 * u[i]
    end
end
using StochasticDiffEq
prob = SDEProblem(f, σ, ones(4, 2) / 2, (0.0, 1.0)) #prob_sde_2Dlinear
```

To solve this 10 times, we use the `EnsembleProblem` constructor and solve
with `trajectories=10`. Since we wish to compare values at the timesteps, we need
to make sure the steps all hit the same times. We thus set `adaptive=false` and
explicitly give a `dt`.

```@example ensemble4
prob2 = EnsembleProblem(prob)
sim = solve(prob2, SRIW1(), dt = 1 // 2^(3), trajectories = 10, adaptive = false)
```

**Note that if you don't do the `timeseries_steps` calculations, this code is
compatible with adaptive timestepping. Using adaptivity is usually more efficient!**

We can compute the mean and the variance at the 3rd timestep using:

```@example ensemble4
using SciMLBase.EnsembleAnalysis
m, v = timestep_meanvar(sim, 3)
```

or we can compute the mean and the variance at the `t=0.5` using:

```@example ensemble4
m, v = timepoint_meanvar(sim, 0.5)
```

We can get a series for the mean and the variance at each time step using:

```@example ensemble4
m_series, v_series = timeseries_steps_meanvar(sim)
```

or at chosen values of `t`:

```@example ensemble4
ts = 0:0.1:1
m_series = timeseries_point_mean(sim, ts)
```

Note that these mean and variance series can be directly plotted. We can
compute covariance matrices similarly:

```@example ensemble4
timeseries_steps_meancov(sim) # Use the time steps, assume fixed dt
timeseries_point_meancov(sim, 0:(1 // 2 ^ (3)):1, 0:(1 // 2 ^ (3)):1) # Use time points, interpolate
```

For general analysis, we can build a `EnsembleSummary` type.

```@example ensemble4
summ = EnsembleSummary(sim)
```

will summarize at each time step, while

```@example ensemble4
summ = EnsembleSummary(sim, 0.0:0.1:1.0)
```

will summarize at the `0.1` time points using the interpolations. To
visualize the results, we can plot it. Since there are 8 components to
the differential equation, this can get messy, so let's only plot the
3rd component:

```@example ensemble4
using Plots;
plot(summ; idxs = 3);
```

We can change to errorbars instead of ribbons and plot two different
indices:

```@example ensemble4
plot(summ; idxs = (3, 5), error_style = :bars)
```

Or we can simply plot the mean of every component over time:

```@example ensemble4
plot(summ; error_style = :none)
```

# SciMLAlgorithms

## Definition of the AbstractSciMLAlgorithm Interface

`SciMLAlgorithms` are defined as types which have dispatches to the function signature:

```julia
CommonSolve.solve(prob::AbstractSciMLProblem, alg::AbstractSciMLAlgorithm; kwargs...)
```

### Algorithm-Specific Arguments

Note that because the keyword arguments of `solve` are designed to be common across the whole
problem type, algorithms should have the algorithm-specific keyword arguments defined as part
of the algorithm constructor. For example, `Rodas5` has a choice of `autodiff::Bool` which is
not common across all ODE solvers, and thus `autodiff` is a algorithm-specific keyword argument
handled via `Rodas5(autodiff=true)`.

### Remake

Note that `remake` is applicable to `AbstractSciMLAlgorithm` types, but this is not used in the public API.
It's used for solvers to swap out components like ForwardDiff chunk sizes.

## Common Algorithm Keyword Arguments

Commonly used algorithm keyword arguments are:

## Traits

```@docs
SciMLBase.isautodifferentiable
SciMLBase.allows_arbitrary_number_types
SciMLBase.allowscomplex
SciMLBase.isadaptive
SciMLBase.isdiscrete
SciMLBase.forwarddiffs_model
SciMLBase.forwarddiffs_model_time
SciMLBase.forwarddiff_chunksize
SciMLBase.has_lazy_interpolation
SciMLBase.allows_late_binding_tstops
SciMLBase.has_init
SciMLBase.has_step
```

### Abstract SciML Algorithms

```@docs
SciMLBase.AbstractSciMLAlgorithm
SciMLBase.AbstractDEAlgorithm
SciMLBase.AbstractLinearAlgorithm
SciMLBase.AbstractNonlinearAlgorithm
SciMLBase.AbstractIntervalNonlinearAlgorithm
SciMLBase.AbstractQuadratureAlgorithm
SciMLBase.AbstractOptimizationAlgorithm
SciMLBase.AbstractSteadyStateAlgorithm
SciMLBase.AbstractODEAlgorithm
SciMLBase.AbstractSecondOrderODEAlgorithm
SciMLBase.AbstractRODEAlgorithm
SciMLBase.AbstractSDEAlgorithm
SciMLBase.AbstractDAEAlgorithm
SciMLBase.AbstractDDEAlgorithm
SciMLBase.AbstractSDDEAlgorithm
```

# [Automatic Differentiation and Sensitivity Algorithms (Adjoints)](@id sensealg)

Automatic differentiation control is done through the `sensealg` keyword argument.
Hooks exist in the high level interfaces for `solve` which shuttle the definitions
of automatic differentiation overloads to dispatches defined in DiffEqSensitivity.jl
(should be renamed SciMLSensitivity.jl as it expands). This is done by first entering
a top-level `solve` definition, for example:

```julia
function solve(prob::AbstractDEProblem, args...; sensealg = nothing,
        u0 = nothing, p = nothing, kwargs...)
    u0 = u0 !== nothing ? u0 : prob.u0
    p = p !== nothing ? p : prob.p
    if sensealg === nothing && haskey(prob.kwargs, :sensealg)
        sensealg = prob.kwargs[:sensealg]
    end
    solve_up(prob, sensealg, u0, p, args...; kwargs...)
end
```

`solve_up` then drops down the differentiable arguments as positional arguments, which
is required for the [ChainRules.jl](https://juliadiff.org/ChainRulesCore.jl/stable/)
interface. Then the `ChainRules` overloads are written on the `solve_up` calls, like:

```julia
function ChainRulesCore.frule(::typeof(solve_up), prob,
        sensealg::Union{Nothing, AbstractSensitivityAlgorithm},
        u0, p, args...;
        kwargs...)
    _solve_forward(prob, sensealg, u0, p, args...; kwargs...)
end

function ChainRulesCore.rrule(::typeof(solve_up), prob::SciMLBase.AbstractDEProblem,
        sensealg::Union{Nothing, AbstractSensitivityAlgorithm},
        u0, p, args...;
        kwargs...)
    _solve_adjoint(prob, sensealg, u0, p, args...; kwargs...)
end
```

Default definitions then exist to throw an informative error if the sensitivity
mechanism is not added:

```julia
function _concrete_solve_adjoint(args...; kwargs...)
    error("No adjoint rules exist. Check that you added `using DiffEqSensitivity`")
end

function _concrete_solve_forward(args...; kwargs...)
    error("No sensitivity rules exist. Check that you added `using DiffEqSensitivity`")
end
```

The sensitivity mechanism is kept in a separate package because of the high dependency
and load time cost introduced by the automatic differentiation libraries. Different
choices of automatic differentiation are then selected by the `sensealg` keyword argument
in `solve`, which is made into a positional argument in the `_solve_adjoint` and other
functions in order to allow dispatch.

## SensitivityADPassThrough

The special sensitivity algorithm `SensitivityADPassThrough` is used to ignore the
internal sensitivity dispatches and instead do automatic differentiation directly
through the solver. Generally this `sensealg` is only used internally.

## Note about ForwardDiff

ForwardDiff does not use ChainRules.jl and thus it completely ignores the special
handling.
